/* SyncWarningDialog.c generated by valac 0.55.1, the Vala compiler
 * generated from SyncWarningDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <granite.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <handy.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_SYNC_WARNING_DIALOG (music_sync_warning_dialog_get_type ())
#define MUSIC_SYNC_WARNING_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_SYNC_WARNING_DIALOG, MusicSyncWarningDialog))
#define MUSIC_SYNC_WARNING_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_SYNC_WARNING_DIALOG, MusicSyncWarningDialogClass))
#define MUSIC_IS_SYNC_WARNING_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_SYNC_WARNING_DIALOG))
#define MUSIC_IS_SYNC_WARNING_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_SYNC_WARNING_DIALOG))
#define MUSIC_SYNC_WARNING_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_SYNC_WARNING_DIALOG, MusicSyncWarningDialogClass))

typedef struct _MusicSyncWarningDialog MusicSyncWarningDialog;
typedef struct _MusicSyncWarningDialogClass MusicSyncWarningDialogClass;
typedef struct _MusicSyncWarningDialogPrivate MusicSyncWarningDialogPrivate;
enum  {
	MUSIC_SYNC_WARNING_DIALOG_0_PROPERTY,
	MUSIC_SYNC_WARNING_DIALOG_DEVICE_PROPERTY,
	MUSIC_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY,
	MUSIC_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY,
	MUSIC_SYNC_WARNING_DIALOG_NUM_PROPERTIES
};
static GParamSpec* music_sync_warning_dialog_properties[MUSIC_SYNC_WARNING_DIALOG_NUM_PROPERTIES];
typedef enum  {
	MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA = 1,
	MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE,
	MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP
} MusicSyncWarningDialogResponseId;

#define MUSIC_SYNC_WARNING_DIALOG_TYPE_RESPONSE_ID (music_sync_warning_dialog_response_id_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicSyncWarningDialog {
	GraniteMessageDialog parent_instance;
	MusicSyncWarningDialogPrivate * priv;
};

struct _MusicSyncWarningDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _MusicSyncWarningDialogPrivate {
	MusicDevice* _device;
	GeeTreeSet* _to_sync;
	GeeTreeSet* _to_remove;
	GtkWidget* import_media_button;
	GtkWidget* continue_button;
};

static gint MusicSyncWarningDialog_private_offset;
static gpointer music_sync_warning_dialog_parent_class = NULL;

VALA_EXTERN GType music_sync_warning_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicSyncWarningDialog, g_object_unref)
VALA_EXTERN GType music_sync_warning_dialog_response_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MusicSyncWarningDialog* music_sync_warning_dialog_new (MusicDevice* d,
                                                       GeeTreeSet* to_sync,
                                                       GeeTreeSet* removed);
VALA_EXTERN MusicSyncWarningDialog* music_sync_warning_dialog_construct (GType object_type,
                                                             MusicDevice* d,
                                                             GeeTreeSet* to_sync,
                                                             GeeTreeSet* removed);
VALA_EXTERN void music_sync_warning_dialog_file_operations_done (MusicSyncWarningDialog* self);
VALA_EXTERN void music_sync_warning_dialog_file_operations_started (MusicSyncWarningDialog* self);
VALA_EXTERN MusicDevice* music_sync_warning_dialog_get_device (MusicSyncWarningDialog* self);
static void music_sync_warning_dialog_set_device (MusicSyncWarningDialog* self,
                                           MusicDevice* value);
VALA_EXTERN GeeTreeSet* music_sync_warning_dialog_get_to_sync (MusicSyncWarningDialog* self);
static void music_sync_warning_dialog_set_to_sync (MusicSyncWarningDialog* self,
                                            GeeTreeSet* value);
VALA_EXTERN GeeTreeSet* music_sync_warning_dialog_get_to_remove (MusicSyncWarningDialog* self);
static void music_sync_warning_dialog_set_to_remove (MusicSyncWarningDialog* self,
                                              GeeTreeSet* value);
static GObject * music_sync_warning_dialog_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN MusicLibraryWindow* music_app_get_main_window (void);
static void music_sync_warning_dialog_finalize (GObject * obj);
static GType music_sync_warning_dialog_get_type_once (void);
static void _vala_music_sync_warning_dialog_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_music_sync_warning_dialog_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
music_sync_warning_dialog_get_instance_private (MusicSyncWarningDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSyncWarningDialog_private_offset);
}

static GType
music_sync_warning_dialog_response_id_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA, "MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA", "import-media"}, {MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE, "MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE", "continue"}, {MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP, "MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP", "stop"}, {0, NULL, NULL}};
	GType music_sync_warning_dialog_response_id_type_id;
	music_sync_warning_dialog_response_id_type_id = g_enum_register_static ("MusicSyncWarningDialogResponseId", values);
	return music_sync_warning_dialog_response_id_type_id;
}

GType
music_sync_warning_dialog_response_id_get_type (void)
{
	static volatile gsize music_sync_warning_dialog_response_id_type_id__once = 0;
	if (g_once_init_enter (&music_sync_warning_dialog_response_id_type_id__once)) {
		GType music_sync_warning_dialog_response_id_type_id;
		music_sync_warning_dialog_response_id_type_id = music_sync_warning_dialog_response_id_get_type_once ();
		g_once_init_leave (&music_sync_warning_dialog_response_id_type_id__once, music_sync_warning_dialog_response_id_type_id);
	}
	return music_sync_warning_dialog_response_id_type_id__once;
}

MusicSyncWarningDialog*
music_sync_warning_dialog_construct (GType object_type,
                                     MusicDevice* d,
                                     GeeTreeSet* to_sync,
                                     GeeTreeSet* removed)
{
	MusicSyncWarningDialog * self = NULL;
	g_return_val_if_fail (d != NULL, NULL);
	g_return_val_if_fail (to_sync != NULL, NULL);
	g_return_val_if_fail (removed != NULL, NULL);
	self = (MusicSyncWarningDialog*) g_object_new (object_type, "device", d, "to-sync", to_sync, "to-remove", removed, NULL);
	return self;
}

MusicSyncWarningDialog*
music_sync_warning_dialog_new (MusicDevice* d,
                               GeeTreeSet* to_sync,
                               GeeTreeSet* removed)
{
	return music_sync_warning_dialog_construct (MUSIC_TYPE_SYNC_WARNING_DIALOG, d, to_sync, removed);
}

void
music_sync_warning_dialog_file_operations_done (MusicSyncWarningDialog* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->import_media_button;
	gtk_widget_set_sensitive (_tmp0_, TRUE);
	_tmp1_ = self->priv->continue_button;
	gtk_widget_set_sensitive (_tmp1_, TRUE);
}

void
music_sync_warning_dialog_file_operations_started (MusicSyncWarningDialog* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->import_media_button;
	gtk_widget_set_sensitive (_tmp0_, FALSE);
	_tmp1_ = self->priv->continue_button;
	gtk_widget_set_sensitive (_tmp1_, FALSE);
}

MusicDevice*
music_sync_warning_dialog_get_device (MusicSyncWarningDialog* self)
{
	MusicDevice* result;
	MusicDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_sync_warning_dialog_set_device (MusicSyncWarningDialog* self,
                                      MusicDevice* value)
{
	MusicDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_sync_warning_dialog_get_device (self);
	if (old_value != value) {
		MusicDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_sync_warning_dialog_properties[MUSIC_SYNC_WARNING_DIALOG_DEVICE_PROPERTY]);
	}
}

GeeTreeSet*
music_sync_warning_dialog_get_to_sync (MusicSyncWarningDialog* self)
{
	GeeTreeSet* result;
	GeeTreeSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_to_sync;
	result = _tmp0_;
	return result;
}

static void
music_sync_warning_dialog_set_to_sync (MusicSyncWarningDialog* self,
                                       GeeTreeSet* value)
{
	GeeTreeSet* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_sync_warning_dialog_get_to_sync (self);
	if (old_value != value) {
		GeeTreeSet* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_to_sync);
		self->priv->_to_sync = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_sync_warning_dialog_properties[MUSIC_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY]);
	}
}

GeeTreeSet*
music_sync_warning_dialog_get_to_remove (MusicSyncWarningDialog* self)
{
	GeeTreeSet* result;
	GeeTreeSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_to_remove;
	result = _tmp0_;
	return result;
}

static void
music_sync_warning_dialog_set_to_remove (MusicSyncWarningDialog* self,
                                         GeeTreeSet* value)
{
	GeeTreeSet* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_sync_warning_dialog_get_to_remove (self);
	if (old_value != value) {
		GeeTreeSet* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_to_remove);
		self->priv->_to_remove = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_sync_warning_dialog_properties[MUSIC_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY]);
	}
}

static GObject *
music_sync_warning_dialog_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicSyncWarningDialog * self;
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	GThemedIcon* _tmp2_;
	GThemedIcon* _tmp3_;
	GeeTreeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GeeTreeSet* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	MusicDevice* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	MusicDevice* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkWidget* _tmp26_;
	GtkWidget* _tmp27_;
	GtkWidget* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkWidget* stop_button = NULL;
	GtkWidget* _tmp30_;
	GtkWidget* _tmp31_;
	GtkWidget* _tmp32_;
	GtkWidget* _tmp33_;
	GtkWidget* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkWidget* _tmp36_;
	MusicLibrariesManager* _tmp37_;
	MusicLibrary* _tmp38_;
	GtkWidget* _tmp39_;
	MusicLibrariesManager* _tmp40_;
	MusicLibrary* _tmp41_;
	parent_class = G_OBJECT_CLASS (music_sync_warning_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SYNC_WARNING_DIALOG, MusicSyncWarningDialog);
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
	gtk_window_set_destroy_with_parent ((GtkWindow*) self, TRUE);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp1_);
	_tmp2_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
	_tmp3_ = _tmp2_;
	granite_message_dialog_set_image_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->_to_remove;
	_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->priv->_to_remove;
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = self->priv->_device;
	_tmp11_ = music_device_get_display_name (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strdup_printf (ngettext ("Sync will remove %i item from %s", "Sync will remove %i items from %s", (gulong) _tmp6_), _tmp9_, _tmp12_);
	_tmp14_ = _tmp13_;
	granite_message_dialog_set_primary_text ((GraniteMessageDialog*) self, _tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	_tmp15_ = self->priv->_device;
	_tmp16_ = music_device_get_display_name (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_markup_escape_text (_tmp17_, (gssize) -1);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strconcat ("<b>", _tmp19_, NULL);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_strconcat (_tmp21_, "</b>", NULL);
	_tmp23_ = _tmp22_;
	_tmp24_ = g_strdup_printf (_ ("If you continue to sync, media will be removed from %s since they are " \
"not on the sync list. Would you like to import them to your library fi" \
"rst?"), _tmp23_);
	_tmp25_ = _tmp24_;
	granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp25_);
	_g_free0 (_tmp25_);
	_g_free0 (_tmp23_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_g_free0 (_tmp17_);
	_tmp26_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Continue Syncing"), (gint) MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE);
	_tmp27_ = _g_object_ref0 (_tmp26_);
	_g_object_unref0 (self->priv->continue_button);
	self->priv->continue_button = _tmp27_;
	_tmp28_ = self->priv->continue_button;
	_tmp29_ = gtk_widget_get_style_context (_tmp28_);
	gtk_style_context_add_class (_tmp29_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
	_tmp30_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP);
	_tmp31_ = _g_object_ref0 (_tmp30_);
	stop_button = _tmp31_;
	_tmp32_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Import"), (gint) MUSIC_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA);
	_tmp33_ = _g_object_ref0 (_tmp32_);
	_g_object_unref0 (self->priv->import_media_button);
	self->priv->import_media_button = _tmp33_;
	_tmp34_ = self->priv->import_media_button;
	_tmp35_ = gtk_widget_get_style_context (_tmp34_);
	gtk_style_context_add_class (_tmp35_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp36_ = self->priv->import_media_button;
	_tmp37_ = music_libraries_manager;
	_tmp38_ = _tmp37_->local_library;
	gtk_widget_set_sensitive (_tmp36_, !music_library_doing_file_operations (_tmp38_));
	_tmp39_ = self->priv->continue_button;
	_tmp40_ = music_libraries_manager;
	_tmp41_ = _tmp40_->local_library;
	gtk_widget_set_sensitive (_tmp39_, !music_library_doing_file_operations (_tmp41_));
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (stop_button);
	return obj;
}

static void
music_sync_warning_dialog_class_init (MusicSyncWarningDialogClass * klass,
                                      gpointer klass_data)
{
	music_sync_warning_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicSyncWarningDialog_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_sync_warning_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_sync_warning_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_sync_warning_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_sync_warning_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SYNC_WARNING_DIALOG_DEVICE_PROPERTY, music_sync_warning_dialog_properties[MUSIC_SYNC_WARNING_DIALOG_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", MUSIC_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY, music_sync_warning_dialog_properties[MUSIC_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY] = g_param_spec_object ("to-sync", "to-sync", "to-sync", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY, music_sync_warning_dialog_properties[MUSIC_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY] = g_param_spec_object ("to-remove", "to-remove", "to-remove", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
music_sync_warning_dialog_instance_init (MusicSyncWarningDialog * self,
                                         gpointer klass)
{
	self->priv = music_sync_warning_dialog_get_instance_private (self);
}

static void
music_sync_warning_dialog_finalize (GObject * obj)
{
	MusicSyncWarningDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SYNC_WARNING_DIALOG, MusicSyncWarningDialog);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->_to_sync);
	_g_object_unref0 (self->priv->_to_remove);
	_g_object_unref0 (self->priv->import_media_button);
	_g_object_unref0 (self->priv->continue_button);
	G_OBJECT_CLASS (music_sync_warning_dialog_parent_class)->finalize (obj);
}

static GType
music_sync_warning_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSyncWarningDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_sync_warning_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSyncWarningDialog), 0, (GInstanceInitFunc) music_sync_warning_dialog_instance_init, NULL };
	GType music_sync_warning_dialog_type_id;
	music_sync_warning_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "MusicSyncWarningDialog", &g_define_type_info, 0);
	MusicSyncWarningDialog_private_offset = g_type_add_instance_private (music_sync_warning_dialog_type_id, sizeof (MusicSyncWarningDialogPrivate));
	return music_sync_warning_dialog_type_id;
}

GType
music_sync_warning_dialog_get_type (void)
{
	static volatile gsize music_sync_warning_dialog_type_id__once = 0;
	if (g_once_init_enter (&music_sync_warning_dialog_type_id__once)) {
		GType music_sync_warning_dialog_type_id;
		music_sync_warning_dialog_type_id = music_sync_warning_dialog_get_type_once ();
		g_once_init_leave (&music_sync_warning_dialog_type_id__once, music_sync_warning_dialog_type_id);
	}
	return music_sync_warning_dialog_type_id__once;
}

static void
_vala_music_sync_warning_dialog_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	MusicSyncWarningDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SYNC_WARNING_DIALOG, MusicSyncWarningDialog);
	switch (property_id) {
		case MUSIC_SYNC_WARNING_DIALOG_DEVICE_PROPERTY:
		g_value_set_object (value, music_sync_warning_dialog_get_device (self));
		break;
		case MUSIC_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY:
		g_value_set_object (value, music_sync_warning_dialog_get_to_sync (self));
		break;
		case MUSIC_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY:
		g_value_set_object (value, music_sync_warning_dialog_get_to_remove (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_sync_warning_dialog_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	MusicSyncWarningDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SYNC_WARNING_DIALOG, MusicSyncWarningDialog);
	switch (property_id) {
		case MUSIC_SYNC_WARNING_DIALOG_DEVICE_PROPERTY:
		music_sync_warning_dialog_set_device (self, g_value_get_object (value));
		break;
		case MUSIC_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY:
		music_sync_warning_dialog_set_to_sync (self, g_value_get_object (value));
		break;
		case MUSIC_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY:
		music_sync_warning_dialog_set_to_remove (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

