/* LocalMedia.c generated by valac 0.55.1, the Vala compiler
 * generated from LocalMedia.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <libgda/libgda.h>

#define MUSIC_DATABASE_MEDIA_TABLE_NAME "media"
#define MUSIC_DATABASE_MEDIA_ROWID "+26"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_LOCAL_MEDIA (music_local_media_get_type ())
#define MUSIC_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMedia))
#define MUSIC_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMediaClass))
#define MUSIC_IS_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_MEDIA))
#define MUSIC_IS_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_MEDIA))
#define MUSIC_LOCAL_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMediaClass))

typedef struct _MusicLocalMedia MusicLocalMedia;
typedef struct _MusicLocalMediaClass MusicLocalMediaClass;
typedef struct _MusicLocalMediaPrivate MusicLocalMediaPrivate;
enum  {
	MUSIC_LOCAL_MEDIA_0_PROPERTY,
	MUSIC_LOCAL_MEDIA_FILE_SIZE_PROPERTY,
	MUSIC_LOCAL_MEDIA_TITLE_PROPERTY,
	MUSIC_LOCAL_MEDIA_TRACK_PROPERTY,
	MUSIC_LOCAL_MEDIA_TRACK_COUNT_PROPERTY,
	MUSIC_LOCAL_MEDIA_COMPOSER_PROPERTY,
	MUSIC_LOCAL_MEDIA_ARTIST_PROPERTY,
	MUSIC_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY,
	MUSIC_LOCAL_MEDIA_ALBUM_PROPERTY,
	MUSIC_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY,
	MUSIC_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY,
	MUSIC_LOCAL_MEDIA_ALBUM_INFO_PROPERTY,
	MUSIC_LOCAL_MEDIA_GROUPING_PROPERTY,
	MUSIC_LOCAL_MEDIA_GENRE_PROPERTY,
	MUSIC_LOCAL_MEDIA_COMMENT_PROPERTY,
	MUSIC_LOCAL_MEDIA_LYRICS_PROPERTY,
	MUSIC_LOCAL_MEDIA_YEAR_PROPERTY,
	MUSIC_LOCAL_MEDIA_BITRATE_PROPERTY,
	MUSIC_LOCAL_MEDIA_SAMPLERATE_PROPERTY,
	MUSIC_LOCAL_MEDIA_LENGTH_PROPERTY,
	MUSIC_LOCAL_MEDIA_RATING_PROPERTY,
	MUSIC_LOCAL_MEDIA_PLAY_COUNT_PROPERTY,
	MUSIC_LOCAL_MEDIA_SKIP_COUNT_PROPERTY,
	MUSIC_LOCAL_MEDIA_DATE_ADDED_PROPERTY,
	MUSIC_LOCAL_MEDIA_LAST_PLAYED_PROPERTY,
	MUSIC_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY,
	MUSIC_LOCAL_MEDIA_SHOW_PROPERTY,
	MUSIC_LOCAL_MEDIA_RESUME_POS_PROPERTY,
	MUSIC_LOCAL_MEDIA_NUM_PROPERTIES
};
static GParamSpec* music_local_media_properties[MUSIC_LOCAL_MEDIA_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicLocalMedia {
	MusicMedia parent_instance;
	MusicLocalMediaPrivate * priv;
	guint* _year;
	guint* _bitrate;
	guint* _samplerate;
	guint* _length;
	guint* _play_count;
	guint* _skip_count;
	guint* _date_added;
	guint* _last_played;
	guint* _last_modified;
};

struct _MusicLocalMediaClass {
	MusicMediaClass parent_class;
};

struct _MusicLocalMediaPrivate {
	guint64* _file_size;
	gchar* _title;
	guint* _track;
	guint* _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint* _album_number;
	guint* _album_count;
	MusicAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	guint* _show;
	gint _resume_pos;
	GdaConnection* connection;
};

static gint MusicLocalMedia_private_offset;
static gpointer music_local_media_parent_class = NULL;

VALA_EXTERN GType music_local_media_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalMedia, g_object_unref)
VALA_EXTERN MusicLocalMedia* music_local_media_new (gint64 rowid,
                                        GdaConnection* connection);
VALA_EXTERN MusicLocalMedia* music_local_media_construct (GType object_type,
                                              gint64 rowid,
                                              GdaConnection* connection);
VALA_EXTERN GValue* music_database_query_field (gint64 rowid,
                                    GdaConnection* connection,
                                    const gchar* table,
                                    const gchar* field);
static void _vala_GValue_free (GValue* self);
VALA_EXTERN MusicLocalMedia* music_local_media_new_from_media (GdaConnection* connection,
                                                   MusicMedia* m,
                                                   GError** error);
VALA_EXTERN MusicLocalMedia* music_local_media_construct_from_media (GType object_type,
                                                         GdaConnection* connection,
                                                         MusicMedia* m,
                                                         GError** error);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static guint64 music_local_media_common_uint64_getter (MusicLocalMedia* self,
                                                const gchar* field,
                                                guint64** temp);
static guint64* _uint64_dup (guint64* self);
static void music_local_media_common_uint64_setter (MusicLocalMedia* self,
                                             const gchar* field,
                                             guint64 value,
                                             guint64** temp);
VALA_EXTERN void music_database_set_field (gint64 rowid,
                               GdaConnection* connection,
                               const gchar* table,
                               const gchar* field,
                               GValue* val);
static guint music_local_media_common_uint_getter (MusicLocalMedia* self,
                                            const gchar* field,
                                            guint** temp);
static guint* _uint_dup (guint* self);
static void music_local_media_common_uint_setter (MusicLocalMedia* self,
                                           const gchar* field,
                                           guint value,
                                           guint** temp);
static gchar* music_local_media_common_string_getter (MusicLocalMedia* self,
                                               const gchar* field,
                                               gchar** temp);
static void music_local_media_common_string_setter (MusicLocalMedia* self,
                                             const gchar* field,
                                             const gchar* value,
                                             gchar** temp);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static void music_local_media_finalize (GObject * obj);
static GType music_local_media_get_type_once (void);
static void _vala_music_local_media_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_music_local_media_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
music_local_media_get_instance_private (MusicLocalMedia* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLocalMedia_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_GValue_free (GValue* self)
{
	g_boxed_free (G_TYPE_VALUE, self);
}

MusicLocalMedia*
music_local_media_construct (GType object_type,
                             gint64 rowid,
                             GdaConnection* connection)
{
	MusicLocalMedia * self = NULL;
	GdaConnection* _tmp0_;
	GValue* query = NULL;
	GValue* _tmp1_;
	GValue* _tmp2_;
	g_return_val_if_fail (connection != NULL, NULL);
	self = (MusicLocalMedia*) g_object_new (object_type, "rowid", rowid, NULL);
	_tmp0_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->connection);
	self->priv->connection = _tmp0_;
	_tmp1_ = music_database_query_field (rowid, connection, MUSIC_DATABASE_MEDIA_TABLE_NAME, "uri");
	query = _tmp1_;
	_tmp2_ = query;
	if (((gpointer) _tmp2_) != NULL) {
		GValue* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = query;
		_tmp4_ = g_value_dup_string (_tmp3_);
		_tmp5_ = _tmp4_;
		music_media_set_uri ((MusicMedia*) self, _tmp5_);
		_g_free0 (_tmp5_);
	}
	__vala_GValue_free0 (query);
	return self;
}

MusicLocalMedia*
music_local_media_new (gint64 rowid,
                       GdaConnection* connection)
{
	return music_local_media_construct (MUSIC_TYPE_LOCAL_MEDIA, rowid, connection);
}

static void
__vala_GValue_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

MusicLocalMedia*
music_local_media_construct_from_media (GType object_type,
                                        GdaConnection* connection,
                                        MusicMedia* m,
                                        GError** error)
{
	MusicLocalMedia * self = NULL;
	GValue* query = NULL;
	gint64 _tmp123_;
	gint64 _tmp124_;
	GValue* _tmp125_;
	GValue* _tmp126_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (connection != NULL, NULL);
	g_return_val_if_fail (m != NULL, NULL);
	{
		GdaSqlBuilder* builder = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GValue* _tmp5_ = NULL;
		GdaSet* last_insert_row = NULL;
		GdaStatement* _tmp6_ = NULL;
		GdaSqlBuilder* _tmp7_;
		GdaStatement* _tmp8_;
		GdaSet* _tmp9_ = NULL;
		gint64 _rowid = 0LL;
		GdaSet* _tmp10_;
		GValue _tmp11_;
		GdaConnection* _tmp12_;
		GSList* col_names = NULL;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		GSList* values = NULL;
		guint64 _tmp39_;
		guint64 _tmp40_;
		GValue* _tmp41_ = NULL;
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		GValue* _tmp44_ = NULL;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
		GValue* _tmp47_ = NULL;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		GValue* _tmp50_ = NULL;
		const gchar* _tmp51_;
		const gchar* _tmp52_;
		GValue* _tmp53_ = NULL;
		const gchar* _tmp54_;
		const gchar* _tmp55_;
		GValue* _tmp56_ = NULL;
		const gchar* _tmp57_;
		const gchar* _tmp58_;
		GValue* _tmp59_ = NULL;
		const gchar* _tmp60_;
		const gchar* _tmp61_;
		GValue* _tmp62_ = NULL;
		const gchar* _tmp63_;
		const gchar* _tmp64_;
		GValue* _tmp65_ = NULL;
		const gchar* _tmp66_;
		const gchar* _tmp67_;
		GValue* _tmp68_ = NULL;
		gboolean _tmp69_;
		gboolean _tmp70_;
		GValue* _tmp71_ = NULL;
		guint _tmp72_;
		guint _tmp73_;
		GValue* _tmp74_ = NULL;
		guint _tmp75_;
		guint _tmp76_;
		GValue* _tmp77_ = NULL;
		guint _tmp78_;
		guint _tmp79_;
		GValue* _tmp80_ = NULL;
		guint _tmp81_;
		guint _tmp82_;
		GValue* _tmp83_ = NULL;
		guint _tmp84_;
		guint _tmp85_;
		GValue* _tmp86_ = NULL;
		guint _tmp87_;
		guint _tmp88_;
		GValue* _tmp89_ = NULL;
		guint _tmp90_;
		guint _tmp91_;
		GValue* _tmp92_ = NULL;
		guint _tmp93_;
		guint _tmp94_;
		GValue* _tmp95_ = NULL;
		guint _tmp96_;
		guint _tmp97_;
		GValue* _tmp98_ = NULL;
		guint _tmp99_;
		guint _tmp100_;
		GValue* _tmp101_ = NULL;
		guint _tmp102_;
		guint _tmp103_;
		GValue* _tmp104_ = NULL;
		guint _tmp105_;
		guint _tmp106_;
		GValue* _tmp107_ = NULL;
		guint _tmp108_;
		guint _tmp109_;
		GValue* _tmp110_ = NULL;
		guint _tmp111_;
		guint _tmp112_;
		GValue* _tmp113_ = NULL;
		gboolean _tmp114_;
		gboolean _tmp115_;
		GValue* _tmp116_ = NULL;
		GdaSet* _tmp117_;
		GSList* _tmp118_;
		GSList* _tmp119_;
		GValue _tmp120_;
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
		builder = _tmp0_;
		_tmp1_ = builder;
		gda_sql_builder_set_table (_tmp1_, MUSIC_DATABASE_MEDIA_TABLE_NAME);
		_tmp2_ = builder;
		_tmp3_ = music_media_get_uri (m);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_new0 (GValue, 1);
		g_value_init (_tmp5_, G_TYPE_STRING);
		g_value_take_string (_tmp5_, _tmp4_);
		gda_sql_builder_add_field_value_as_gvalue (_tmp2_, "uri", _tmp5_);
		__vala_GValue_free0 (_tmp5_);
		_tmp7_ = builder;
		_tmp8_ = gda_sql_builder_get_statement (_tmp7_, &_inner_error0_);
		_tmp6_ = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (last_insert_row);
			_g_object_unref0 (builder);
			goto __catch0_g_error;
		}
		gda_connection_statement_execute_non_select (connection, _tmp6_, NULL, &_tmp9_, &_inner_error0_);
		_g_object_unref0 (last_insert_row);
		last_insert_row = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (last_insert_row);
			_g_object_unref0 (builder);
			goto __catch0_g_error;
		}
		_tmp10_ = last_insert_row;
		_tmp11_ = *gda_set_get_holder_value (_tmp10_, MUSIC_DATABASE_MEDIA_ROWID);
		_rowid = g_value_get_int64 (&_tmp11_);
		self = (MusicLocalMedia*) g_object_new (object_type, "rowid", _rowid, NULL);
		_tmp12_ = _g_object_ref0 (connection);
		_g_object_unref0 (self->priv->connection);
		self->priv->connection = _tmp12_;
		col_names = NULL;
		_tmp13_ = g_strdup ("file_size");
		col_names = g_slist_append (col_names, _tmp13_);
		_tmp14_ = g_strdup ("title");
		col_names = g_slist_append (col_names, _tmp14_);
		_tmp15_ = g_strdup ("artist");
		col_names = g_slist_append (col_names, _tmp15_);
		_tmp16_ = g_strdup ("composer");
		col_names = g_slist_append (col_names, _tmp16_);
		_tmp17_ = g_strdup ("album_artist");
		col_names = g_slist_append (col_names, _tmp17_);
		_tmp18_ = g_strdup ("album");
		col_names = g_slist_append (col_names, _tmp18_);
		_tmp19_ = g_strdup ("grouping");
		col_names = g_slist_append (col_names, _tmp19_);
		_tmp20_ = g_strdup ("genre");
		col_names = g_slist_append (col_names, _tmp20_);
		_tmp21_ = g_strdup ("comment");
		col_names = g_slist_append (col_names, _tmp21_);
		_tmp22_ = g_strdup ("lyrics");
		col_names = g_slist_append (col_names, _tmp22_);
		_tmp23_ = g_strdup ("has_embedded");
		col_names = g_slist_append (col_names, _tmp23_);
		_tmp24_ = g_strdup ("year");
		col_names = g_slist_append (col_names, _tmp24_);
		_tmp25_ = g_strdup ("track");
		col_names = g_slist_append (col_names, _tmp25_);
		_tmp26_ = g_strdup ("track_count");
		col_names = g_slist_append (col_names, _tmp26_);
		_tmp27_ = g_strdup ("album_number");
		col_names = g_slist_append (col_names, _tmp27_);
		_tmp28_ = g_strdup ("album_count");
		col_names = g_slist_append (col_names, _tmp28_);
		_tmp29_ = g_strdup ("bitrate");
		col_names = g_slist_append (col_names, _tmp29_);
		_tmp30_ = g_strdup ("length");
		col_names = g_slist_append (col_names, _tmp30_);
		_tmp31_ = g_strdup ("samplerate");
		col_names = g_slist_append (col_names, _tmp31_);
		_tmp32_ = g_strdup ("rating");
		col_names = g_slist_append (col_names, _tmp32_);
		_tmp33_ = g_strdup ("playcount");
		col_names = g_slist_append (col_names, _tmp33_);
		_tmp34_ = g_strdup ("skipcount");
		col_names = g_slist_append (col_names, _tmp34_);
		_tmp35_ = g_strdup ("dateadded");
		col_names = g_slist_append (col_names, _tmp35_);
		_tmp36_ = g_strdup ("lastplayed");
		col_names = g_slist_append (col_names, _tmp36_);
		_tmp37_ = g_strdup ("lastmodified");
		col_names = g_slist_append (col_names, _tmp37_);
		_tmp38_ = g_strdup ("show");
		col_names = g_slist_append (col_names, _tmp38_);
		values = NULL;
		_tmp39_ = music_media_get_file_size (m);
		_tmp40_ = _tmp39_;
		_tmp41_ = g_new0 (GValue, 1);
		g_value_init (_tmp41_, G_TYPE_UINT64);
		g_value_set_uint64 (_tmp41_, _tmp40_);
		values = g_slist_append (values, _tmp41_);
		_tmp42_ = music_media_get_title (m);
		_tmp43_ = _tmp42_;
		_tmp44_ = g_new0 (GValue, 1);
		g_value_init (_tmp44_, G_TYPE_STRING);
		g_value_set_string (_tmp44_, _tmp43_);
		values = g_slist_append (values, _tmp44_);
		_tmp45_ = music_media_get_artist (m);
		_tmp46_ = _tmp45_;
		_tmp47_ = g_new0 (GValue, 1);
		g_value_init (_tmp47_, G_TYPE_STRING);
		g_value_set_string (_tmp47_, _tmp46_);
		values = g_slist_append (values, _tmp47_);
		_tmp48_ = music_media_get_composer (m);
		_tmp49_ = _tmp48_;
		_tmp50_ = g_new0 (GValue, 1);
		g_value_init (_tmp50_, G_TYPE_STRING);
		g_value_set_string (_tmp50_, _tmp49_);
		values = g_slist_append (values, _tmp50_);
		_tmp51_ = music_media_get_album_artist (m);
		_tmp52_ = _tmp51_;
		_tmp53_ = g_new0 (GValue, 1);
		g_value_init (_tmp53_, G_TYPE_STRING);
		g_value_set_string (_tmp53_, _tmp52_);
		values = g_slist_append (values, _tmp53_);
		_tmp54_ = music_media_get_album (m);
		_tmp55_ = _tmp54_;
		_tmp56_ = g_new0 (GValue, 1);
		g_value_init (_tmp56_, G_TYPE_STRING);
		g_value_set_string (_tmp56_, _tmp55_);
		values = g_slist_append (values, _tmp56_);
		_tmp57_ = music_media_get_grouping (m);
		_tmp58_ = _tmp57_;
		_tmp59_ = g_new0 (GValue, 1);
		g_value_init (_tmp59_, G_TYPE_STRING);
		g_value_set_string (_tmp59_, _tmp58_);
		values = g_slist_append (values, _tmp59_);
		_tmp60_ = music_media_get_genre (m);
		_tmp61_ = _tmp60_;
		_tmp62_ = g_new0 (GValue, 1);
		g_value_init (_tmp62_, G_TYPE_STRING);
		g_value_set_string (_tmp62_, _tmp61_);
		values = g_slist_append (values, _tmp62_);
		_tmp63_ = music_media_get_comment (m);
		_tmp64_ = _tmp63_;
		_tmp65_ = g_new0 (GValue, 1);
		g_value_init (_tmp65_, G_TYPE_STRING);
		g_value_set_string (_tmp65_, _tmp64_);
		values = g_slist_append (values, _tmp65_);
		_tmp66_ = music_media_get_lyrics (m);
		_tmp67_ = _tmp66_;
		_tmp68_ = g_new0 (GValue, 1);
		g_value_init (_tmp68_, G_TYPE_STRING);
		g_value_set_string (_tmp68_, _tmp67_);
		values = g_slist_append (values, _tmp68_);
		_tmp69_ = music_media_get_has_embedded (m);
		_tmp70_ = _tmp69_;
		_tmp71_ = g_new0 (GValue, 1);
		g_value_init (_tmp71_, G_TYPE_BOOLEAN);
		g_value_set_boolean (_tmp71_, _tmp70_);
		values = g_slist_append (values, _tmp71_);
		_tmp72_ = music_media_get_year (m);
		_tmp73_ = _tmp72_;
		_tmp74_ = g_new0 (GValue, 1);
		g_value_init (_tmp74_, G_TYPE_UINT);
		g_value_set_uint (_tmp74_, _tmp73_);
		values = g_slist_append (values, _tmp74_);
		_tmp75_ = music_media_get_track (m);
		_tmp76_ = _tmp75_;
		_tmp77_ = g_new0 (GValue, 1);
		g_value_init (_tmp77_, G_TYPE_UINT);
		g_value_set_uint (_tmp77_, _tmp76_);
		values = g_slist_append (values, _tmp77_);
		_tmp78_ = music_media_get_track_count (m);
		_tmp79_ = _tmp78_;
		_tmp80_ = g_new0 (GValue, 1);
		g_value_init (_tmp80_, G_TYPE_UINT);
		g_value_set_uint (_tmp80_, _tmp79_);
		values = g_slist_append (values, _tmp80_);
		_tmp81_ = music_media_get_album_number (m);
		_tmp82_ = _tmp81_;
		_tmp83_ = g_new0 (GValue, 1);
		g_value_init (_tmp83_, G_TYPE_UINT);
		g_value_set_uint (_tmp83_, _tmp82_);
		values = g_slist_append (values, _tmp83_);
		_tmp84_ = music_media_get_album_count (m);
		_tmp85_ = _tmp84_;
		_tmp86_ = g_new0 (GValue, 1);
		g_value_init (_tmp86_, G_TYPE_UINT);
		g_value_set_uint (_tmp86_, _tmp85_);
		values = g_slist_append (values, _tmp86_);
		_tmp87_ = music_media_get_bitrate (m);
		_tmp88_ = _tmp87_;
		_tmp89_ = g_new0 (GValue, 1);
		g_value_init (_tmp89_, G_TYPE_UINT);
		g_value_set_uint (_tmp89_, _tmp88_);
		values = g_slist_append (values, _tmp89_);
		_tmp90_ = music_media_get_length (m);
		_tmp91_ = _tmp90_;
		_tmp92_ = g_new0 (GValue, 1);
		g_value_init (_tmp92_, G_TYPE_UINT);
		g_value_set_uint (_tmp92_, _tmp91_);
		values = g_slist_append (values, _tmp92_);
		_tmp93_ = music_media_get_samplerate (m);
		_tmp94_ = _tmp93_;
		_tmp95_ = g_new0 (GValue, 1);
		g_value_init (_tmp95_, G_TYPE_UINT);
		g_value_set_uint (_tmp95_, _tmp94_);
		values = g_slist_append (values, _tmp95_);
		_tmp96_ = music_media_get_rating (m);
		_tmp97_ = _tmp96_;
		_tmp98_ = g_new0 (GValue, 1);
		g_value_init (_tmp98_, G_TYPE_UINT);
		g_value_set_uint (_tmp98_, _tmp97_);
		values = g_slist_append (values, _tmp98_);
		_tmp99_ = music_media_get_play_count (m);
		_tmp100_ = _tmp99_;
		_tmp101_ = g_new0 (GValue, 1);
		g_value_init (_tmp101_, G_TYPE_UINT);
		g_value_set_uint (_tmp101_, _tmp100_);
		values = g_slist_append (values, _tmp101_);
		_tmp102_ = music_media_get_skip_count (m);
		_tmp103_ = _tmp102_;
		_tmp104_ = g_new0 (GValue, 1);
		g_value_init (_tmp104_, G_TYPE_UINT);
		g_value_set_uint (_tmp104_, _tmp103_);
		values = g_slist_append (values, _tmp104_);
		_tmp105_ = music_media_get_date_added (m);
		_tmp106_ = _tmp105_;
		_tmp107_ = g_new0 (GValue, 1);
		g_value_init (_tmp107_, G_TYPE_UINT);
		g_value_set_uint (_tmp107_, _tmp106_);
		values = g_slist_append (values, _tmp107_);
		_tmp108_ = music_media_get_last_played (m);
		_tmp109_ = _tmp108_;
		_tmp110_ = g_new0 (GValue, 1);
		g_value_init (_tmp110_, G_TYPE_UINT);
		g_value_set_uint (_tmp110_, _tmp109_);
		values = g_slist_append (values, _tmp110_);
		_tmp111_ = music_media_get_last_modified (m);
		_tmp112_ = _tmp111_;
		_tmp113_ = g_new0 (GValue, 1);
		g_value_init (_tmp113_, G_TYPE_UINT);
		g_value_set_uint (_tmp113_, _tmp112_);
		values = g_slist_append (values, _tmp113_);
		_tmp114_ = music_media_get_show (m);
		_tmp115_ = _tmp114_;
		_tmp116_ = g_new0 (GValue, 1);
		g_value_init (_tmp116_, G_TYPE_BOOLEAN);
		g_value_set_boolean (_tmp116_, _tmp115_);
		values = g_slist_append (values, _tmp116_);
		_tmp117_ = last_insert_row;
		_tmp118_ = col_names;
		_tmp119_ = values;
		_tmp120_ = *gda_set_get_holder_value (_tmp117_, MUSIC_DATABASE_MEDIA_ROWID);
		gda_connection_update_row_in_table_v (connection, MUSIC_DATABASE_MEDIA_TABLE_NAME, "rowid", &_tmp120_, _tmp118_, _tmp119_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (last_insert_row);
			_g_object_unref0 (builder);
			goto __catch0_g_error;
		}
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
		_g_object_unref0 (_tmp6_);
		_g_object_unref0 (last_insert_row);
		_g_object_unref0 (builder);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp121_;
		GError* _tmp122_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp121_ = e;
		_tmp122_ = _g_error_copy0 (_tmp121_);
		_inner_error0_ = _tmp122_;
		_g_error_free0 (e);
		goto __finally0;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp123_ = music_media_get_rowid ((MusicMedia*) self);
	_tmp124_ = _tmp123_;
	_tmp125_ = music_database_query_field (_tmp124_, connection, MUSIC_DATABASE_MEDIA_TABLE_NAME, "uri");
	query = _tmp125_;
	_tmp126_ = query;
	if (((gpointer) _tmp126_) != NULL) {
		GValue* _tmp127_;
		gchar* _tmp128_;
		gchar* _tmp129_;
		_tmp127_ = query;
		_tmp128_ = g_value_dup_string (_tmp127_);
		_tmp129_ = _tmp128_;
		music_media_set_uri ((MusicMedia*) self, _tmp129_);
		_g_free0 (_tmp129_);
	}
	__vala_GValue_free0 (query);
	return self;
}

MusicLocalMedia*
music_local_media_new_from_media (GdaConnection* connection,
                                  MusicMedia* m,
                                  GError** error)
{
	return music_local_media_construct_from_media (MUSIC_TYPE_LOCAL_MEDIA, connection, m, error);
}

static guint64*
_uint64_dup (guint64* self)
{
	guint64* dup;
	dup = g_new0 (guint64, 1);
	memcpy (dup, self, sizeof (guint64));
	return dup;
}

static gpointer
__uint64_dup0 (gpointer self)
{
	return self ? _uint64_dup (self) : NULL;
}

static guint64
music_local_media_common_uint64_getter (MusicLocalMedia* self,
                                        const gchar* field,
                                        guint64** temp)
{
	GValue* query = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	guint64 result;
	g_return_val_if_fail (self != NULL, 0ULL);
	g_return_val_if_fail (field != NULL, 0ULL);
	if ((*temp) != NULL) {
		result = *(*temp);
		return result;
	}
	_tmp0_ = music_media_get_rowid ((MusicMedia*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = music_database_query_field (_tmp1_, _tmp2_, MUSIC_DATABASE_MEDIA_TABLE_NAME, field);
	query = _tmp3_;
	_tmp4_ = query;
	if (((gpointer) _tmp4_) != NULL) {
		GValue* _tmp5_;
		guint64 _tmp6_;
		guint64* _tmp7_;
		_tmp5_ = query;
		_tmp6_ = (guint64) g_value_get_int (_tmp5_);
		_tmp7_ = __uint64_dup0 (&_tmp6_);
		_g_free0 (*temp);
		*temp = _tmp7_;
		result = *(*temp);
		__vala_GValue_free0 (query);
		return result;
	} else {
		result = (guint64) 0;
		__vala_GValue_free0 (query);
		return result;
	}
}

static void
music_local_media_common_uint64_setter (MusicLocalMedia* self,
                                        const gchar* field,
                                        guint64 value,
                                        guint64** temp)
{
	guint64* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = __uint64_dup0 (&value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_UINT64);
	val = _tmp1_;
	g_value_set_uint64 (&val, value);
	_tmp2_ = music_media_get_rowid ((MusicMedia*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = val;
	music_database_set_field (_tmp3_, _tmp4_, MUSIC_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
	dup = g_new0 (guint, 1);
	memcpy (dup, self, sizeof (guint));
	return dup;
}

static gpointer
__uint_dup0 (gpointer self)
{
	return self ? _uint_dup (self) : NULL;
}

static guint
music_local_media_common_uint_getter (MusicLocalMedia* self,
                                      const gchar* field,
                                      guint** temp)
{
	GValue* query = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (field != NULL, 0U);
	if ((*temp) != NULL) {
		result = *(*temp);
		return result;
	}
	_tmp0_ = music_media_get_rowid ((MusicMedia*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->connection;
	_tmp3_ = music_database_query_field (_tmp1_, _tmp2_, MUSIC_DATABASE_MEDIA_TABLE_NAME, field);
	query = _tmp3_;
	_tmp4_ = query;
	if (((gpointer) _tmp4_) != NULL) {
		GValue* _tmp5_;
		guint _tmp6_;
		guint* _tmp7_;
		_tmp5_ = query;
		_tmp6_ = (guint) g_value_get_int (_tmp5_);
		_tmp7_ = __uint_dup0 (&_tmp6_);
		_g_free0 (*temp);
		*temp = _tmp7_;
		result = *(*temp);
		__vala_GValue_free0 (query);
		return result;
	} else {
		result = (guint) 0;
		__vala_GValue_free0 (query);
		return result;
	}
}

static void
music_local_media_common_uint_setter (MusicLocalMedia* self,
                                      const gchar* field,
                                      guint value,
                                      guint** temp)
{
	guint* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = __uint_dup0 (&value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_UINT);
	val = _tmp1_;
	g_value_set_uint (&val, value);
	_tmp2_ = music_media_get_rowid ((MusicMedia*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = val;
	music_database_set_field (_tmp3_, _tmp4_, MUSIC_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static gchar*
music_local_media_common_string_getter (MusicLocalMedia* self,
                                        const gchar* field,
                                        gchar** temp)
{
	GValue* query = NULL;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue* _tmp4_;
	GValue* _tmp5_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	if ((*temp) != NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (*temp);
		result = _tmp0_;
		return result;
	}
	_tmp1_ = music_media_get_rowid ((MusicMedia*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->connection;
	_tmp4_ = music_database_query_field (_tmp2_, _tmp3_, MUSIC_DATABASE_MEDIA_TABLE_NAME, field);
	query = _tmp4_;
	_tmp5_ = query;
	if (((gpointer) _tmp5_) != NULL) {
		GValue* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = query;
		_tmp7_ = g_value_dup_string (_tmp6_);
		_g_free0 (*temp);
		*temp = _tmp7_;
		_tmp8_ = self->priv->_composer;
		_tmp9_ = g_strdup (_tmp8_);
		result = _tmp9_;
		__vala_GValue_free0 (query);
		return result;
	} else {
		const gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp10_ = music_media_UNKNOWN;
		_tmp11_ = g_strdup (_tmp10_);
		result = _tmp11_;
		__vala_GValue_free0 (query);
		return result;
	}
}

static void
music_local_media_common_string_setter (MusicLocalMedia* self,
                                        const gchar* field,
                                        const gchar* value,
                                        gchar** temp)
{
	gchar* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (*temp);
	*temp = _tmp0_;
	g_value_init (&_tmp1_, G_TYPE_STRING);
	val = _tmp1_;
	g_value_set_string (&val, value);
	_tmp2_ = music_media_get_rowid ((MusicMedia*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->connection;
	_tmp5_ = val;
	music_database_set_field (_tmp3_, _tmp4_, MUSIC_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static guint64
music_local_media_real_get_file_size (MusicMedia* base)
{
	guint64 result;
	MusicLocalMedia* self;
	guint64* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint64_getter (self, "file_size", &self->priv->_file_size);
	_tmp0_ = self->priv->_file_size;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_file_size (MusicMedia* base,
                                      guint64 value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint64_setter (self, "file_size", value, &self->priv->_file_size);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_FILE_SIZE_PROPERTY]);
}

static const gchar*
music_local_media_real_get_title (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "title", &self->priv->_title);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_title;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_title (MusicMedia* base,
                                  const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "title", value, &self->priv->_title);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_TITLE_PROPERTY]);
}

static guint
music_local_media_real_get_track (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "track", &self->priv->_track);
	_tmp0_ = self->priv->_track;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_track (MusicMedia* base,
                                  guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "track", value, &self->priv->_track);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_TRACK_PROPERTY]);
}

static guint
music_local_media_real_get_track_count (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "track_count", &self->priv->_track_count);
	_tmp0_ = self->priv->_track_count;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_track_count (MusicMedia* base,
                                        guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "track_count", value, &self->priv->_track_count);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_TRACK_COUNT_PROPERTY]);
}

static const gchar*
music_local_media_real_get_composer (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "composer", &self->priv->_composer);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_composer;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_composer (MusicMedia* base,
                                     const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "composer", value, &self->priv->_composer);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_COMPOSER_PROPERTY]);
}

static const gchar*
music_local_media_real_get_artist (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "artist", &self->priv->_artist);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_artist;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_artist (MusicMedia* base,
                                   const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "artist", value, &self->priv->_artist);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_ARTIST_PROPERTY]);
}

static const gchar*
music_local_media_real_get_album_artist (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "album_artist", &self->priv->_album_artist);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_album_artist;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_album_artist (MusicMedia* base,
                                         const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "album_artist", value, &self->priv->_album_artist);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY]);
}

static const gchar*
music_local_media_real_get_album (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "album", &self->priv->_album);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_album;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_album (MusicMedia* base,
                                  const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "album", value, &self->priv->_album);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_PROPERTY]);
}

static guint
music_local_media_real_get_album_number (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "album_number", &self->priv->_album_number);
	_tmp0_ = self->priv->_album_number;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_album_number (MusicMedia* base,
                                         guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "album_number", value, &self->priv->_album_number);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY]);
}

static guint
music_local_media_real_get_album_count (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "album_count", &self->priv->_album_count);
	_tmp0_ = self->priv->_album_count;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_album_count (MusicMedia* base,
                                        guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "album_count", value, &self->priv->_album_count);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY]);
}

static MusicAlbum*
music_local_media_real_get_album_info (MusicMedia* base)
{
	MusicAlbum* result;
	MusicLocalMedia* self;
	MusicAlbum* _tmp0_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = self->priv->_album_info;
	result = _tmp0_;
	return result;
}

static void
music_local_media_real_set_album_info (MusicMedia* base,
                                       MusicAlbum* value)
{
	MusicLocalMedia* self;
	MusicAlbum* old_value;
	self = (MusicLocalMedia*) base;
	old_value = music_local_media_real_get_album_info (base);
	if (old_value != value) {
		self->priv->_album_info = value;
		g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_INFO_PROPERTY]);
	}
}

static const gchar*
music_local_media_real_get_grouping (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "grouping", &self->priv->_grouping);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_grouping;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_grouping (MusicMedia* base,
                                     const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "grouping", value, &self->priv->_grouping);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_GROUPING_PROPERTY]);
}

static const gchar*
music_local_media_real_get_genre (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "genre", &self->priv->_genre);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_genre;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_genre (MusicMedia* base,
                                  const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "genre", value, &self->priv->_genre);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_GENRE_PROPERTY]);
}

static const gchar*
music_local_media_real_get_comment (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "comment", &self->priv->_comment);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_comment;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_comment (MusicMedia* base,
                                    const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "comment", value, &self->priv->_comment);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_COMMENT_PROPERTY]);
}

static const gchar*
music_local_media_real_get_lyrics (MusicMedia* base)
{
	const gchar* result;
	MusicLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	self = (MusicLocalMedia*) base;
	_tmp0_ = music_local_media_common_string_getter (self, "lyrics", &self->priv->_lyrics);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->_lyrics;
	result = _tmp2_;
	return result;
}

static void
music_local_media_real_set_lyrics (MusicMedia* base,
                                   const gchar* value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_string_setter (self, "lyrics", value, &self->priv->_lyrics);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_LYRICS_PROPERTY]);
}

static guint
music_local_media_real_get_year (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "year", &self->_year);
	_tmp0_ = self->_year;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_year (MusicMedia* base,
                                 guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "year", value, &self->_year);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_YEAR_PROPERTY]);
}

static guint
music_local_media_real_get_bitrate (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "bitrate", &self->_bitrate);
	_tmp0_ = self->_bitrate;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_bitrate (MusicMedia* base,
                                    guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "bitrate", value, &self->_bitrate);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_BITRATE_PROPERTY]);
}

static guint
music_local_media_real_get_samplerate (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "samplerate", &self->_samplerate);
	_tmp0_ = self->_samplerate;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_samplerate (MusicMedia* base,
                                       guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "samplerate", value, &self->_samplerate);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_SAMPLERATE_PROPERTY]);
}

static guint
music_local_media_real_get_length (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "length", &self->_length);
	_tmp0_ = self->_length;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_length (MusicMedia* base,
                                   guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "length", value, &self->_length);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_LENGTH_PROPERTY]);
}

static guint
music_local_media_real_get_rating (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "rating", &((MusicMedia*) self)->_rating);
	result = ((MusicMedia*) self)->_rating;
	return result;
}

static void
music_local_media_real_set_rating (MusicMedia* base,
                                   guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "rating", CLAMP (value, (guint) 0, (guint) 5), &((MusicMedia*) self)->_rating);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_RATING_PROPERTY]);
}

static guint
music_local_media_real_get_play_count (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "playcount", &self->_play_count);
	_tmp0_ = self->_play_count;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_play_count (MusicMedia* base,
                                       guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "playcount", value, &self->_play_count);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_PLAY_COUNT_PROPERTY]);
}

static guint
music_local_media_real_get_skip_count (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "skipcount", &self->_skip_count);
	_tmp0_ = self->_skip_count;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_skip_count (MusicMedia* base,
                                       guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "skipcount", value, &self->_skip_count);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_SKIP_COUNT_PROPERTY]);
}

static guint
music_local_media_real_get_date_added (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "dateadded", &self->_date_added);
	_tmp0_ = self->_date_added;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_date_added (MusicMedia* base,
                                       guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "dateadded", value, &self->_date_added);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_DATE_ADDED_PROPERTY]);
}

static guint
music_local_media_real_get_last_played (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "lastplayed", &self->_last_played);
	_tmp0_ = self->_last_played;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_last_played (MusicMedia* base,
                                        guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "lastplayed", value, &self->_last_played);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_LAST_PLAYED_PROPERTY]);
}

static guint
music_local_media_real_get_last_modified (MusicMedia* base)
{
	guint result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "lastmodified", &self->_last_modified);
	_tmp0_ = self->_last_modified;
	result = *_tmp0_;
	return result;
}

static void
music_local_media_real_set_last_modified (MusicMedia* base,
                                          guint value)
{
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_setter (self, "lastmodified", value, &self->_last_modified);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY]);
}

static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}

static gboolean
music_local_media_real_get_show (MusicMedia* base)
{
	gboolean result;
	MusicLocalMedia* self;
	guint* _tmp0_;
	guint _tmp1_;
	self = (MusicLocalMedia*) base;
	music_local_media_common_uint_getter (self, "show", &self->priv->_show);
	_tmp0_ = self->priv->_show;
	_tmp1_ = (guint) 1;
	result = _uint_equal (_tmp0_, &_tmp1_) == TRUE;
	return result;
}

static void
music_local_media_real_set_show (MusicMedia* base,
                                 gboolean value)
{
	MusicLocalMedia* self;
	gint _tmp0_ = 0;
	self = (MusicLocalMedia*) base;
	if (value) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = 0;
	}
	music_local_media_common_uint_setter (self, "show", (guint) _tmp0_, &self->priv->_show);
	g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_SHOW_PROPERTY]);
}

static gint
music_local_media_real_get_resume_pos (MusicMedia* base)
{
	gint result;
	MusicLocalMedia* self;
	self = (MusicLocalMedia*) base;
	result = self->priv->_resume_pos;
	return result;
}

static void
music_local_media_real_set_resume_pos (MusicMedia* base,
                                       gint value)
{
	MusicLocalMedia* self;
	gint old_value;
	self = (MusicLocalMedia*) base;
	old_value = music_local_media_real_get_resume_pos (base);
	if (old_value != value) {
		self->priv->_resume_pos = value;
		g_object_notify_by_pspec ((GObject *) self, music_local_media_properties[MUSIC_LOCAL_MEDIA_RESUME_POS_PROPERTY]);
	}
}

static void
music_local_media_class_init (MusicLocalMediaClass * klass,
                              gpointer klass_data)
{
	music_local_media_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicLocalMedia_private_offset);
	MUSIC_MEDIA_CLASS (klass)->get_file_size = music_local_media_real_get_file_size;
	MUSIC_MEDIA_CLASS (klass)->set_file_size = music_local_media_real_set_file_size;
	MUSIC_MEDIA_CLASS (klass)->get_title = music_local_media_real_get_title;
	MUSIC_MEDIA_CLASS (klass)->set_title = music_local_media_real_set_title;
	MUSIC_MEDIA_CLASS (klass)->get_track = music_local_media_real_get_track;
	MUSIC_MEDIA_CLASS (klass)->set_track = music_local_media_real_set_track;
	MUSIC_MEDIA_CLASS (klass)->get_track_count = music_local_media_real_get_track_count;
	MUSIC_MEDIA_CLASS (klass)->set_track_count = music_local_media_real_set_track_count;
	MUSIC_MEDIA_CLASS (klass)->get_composer = music_local_media_real_get_composer;
	MUSIC_MEDIA_CLASS (klass)->set_composer = music_local_media_real_set_composer;
	MUSIC_MEDIA_CLASS (klass)->get_artist = music_local_media_real_get_artist;
	MUSIC_MEDIA_CLASS (klass)->set_artist = music_local_media_real_set_artist;
	MUSIC_MEDIA_CLASS (klass)->get_album_artist = music_local_media_real_get_album_artist;
	MUSIC_MEDIA_CLASS (klass)->set_album_artist = music_local_media_real_set_album_artist;
	MUSIC_MEDIA_CLASS (klass)->get_album = music_local_media_real_get_album;
	MUSIC_MEDIA_CLASS (klass)->set_album = music_local_media_real_set_album;
	MUSIC_MEDIA_CLASS (klass)->get_album_number = music_local_media_real_get_album_number;
	MUSIC_MEDIA_CLASS (klass)->set_album_number = music_local_media_real_set_album_number;
	MUSIC_MEDIA_CLASS (klass)->get_album_count = music_local_media_real_get_album_count;
	MUSIC_MEDIA_CLASS (klass)->set_album_count = music_local_media_real_set_album_count;
	MUSIC_MEDIA_CLASS (klass)->get_album_info = music_local_media_real_get_album_info;
	MUSIC_MEDIA_CLASS (klass)->set_album_info = music_local_media_real_set_album_info;
	MUSIC_MEDIA_CLASS (klass)->get_grouping = music_local_media_real_get_grouping;
	MUSIC_MEDIA_CLASS (klass)->set_grouping = music_local_media_real_set_grouping;
	MUSIC_MEDIA_CLASS (klass)->get_genre = music_local_media_real_get_genre;
	MUSIC_MEDIA_CLASS (klass)->set_genre = music_local_media_real_set_genre;
	MUSIC_MEDIA_CLASS (klass)->get_comment = music_local_media_real_get_comment;
	MUSIC_MEDIA_CLASS (klass)->set_comment = music_local_media_real_set_comment;
	MUSIC_MEDIA_CLASS (klass)->get_lyrics = music_local_media_real_get_lyrics;
	MUSIC_MEDIA_CLASS (klass)->set_lyrics = music_local_media_real_set_lyrics;
	MUSIC_MEDIA_CLASS (klass)->get_year = music_local_media_real_get_year;
	MUSIC_MEDIA_CLASS (klass)->set_year = music_local_media_real_set_year;
	MUSIC_MEDIA_CLASS (klass)->get_bitrate = music_local_media_real_get_bitrate;
	MUSIC_MEDIA_CLASS (klass)->set_bitrate = music_local_media_real_set_bitrate;
	MUSIC_MEDIA_CLASS (klass)->get_samplerate = music_local_media_real_get_samplerate;
	MUSIC_MEDIA_CLASS (klass)->set_samplerate = music_local_media_real_set_samplerate;
	MUSIC_MEDIA_CLASS (klass)->get_length = music_local_media_real_get_length;
	MUSIC_MEDIA_CLASS (klass)->set_length = music_local_media_real_set_length;
	MUSIC_MEDIA_CLASS (klass)->get_rating = music_local_media_real_get_rating;
	MUSIC_MEDIA_CLASS (klass)->set_rating = music_local_media_real_set_rating;
	MUSIC_MEDIA_CLASS (klass)->get_play_count = music_local_media_real_get_play_count;
	MUSIC_MEDIA_CLASS (klass)->set_play_count = music_local_media_real_set_play_count;
	MUSIC_MEDIA_CLASS (klass)->get_skip_count = music_local_media_real_get_skip_count;
	MUSIC_MEDIA_CLASS (klass)->set_skip_count = music_local_media_real_set_skip_count;
	MUSIC_MEDIA_CLASS (klass)->get_date_added = music_local_media_real_get_date_added;
	MUSIC_MEDIA_CLASS (klass)->set_date_added = music_local_media_real_set_date_added;
	MUSIC_MEDIA_CLASS (klass)->get_last_played = music_local_media_real_get_last_played;
	MUSIC_MEDIA_CLASS (klass)->set_last_played = music_local_media_real_set_last_played;
	MUSIC_MEDIA_CLASS (klass)->get_last_modified = music_local_media_real_get_last_modified;
	MUSIC_MEDIA_CLASS (klass)->set_last_modified = music_local_media_real_set_last_modified;
	MUSIC_MEDIA_CLASS (klass)->get_show = music_local_media_real_get_show;
	MUSIC_MEDIA_CLASS (klass)->set_show = music_local_media_real_set_show;
	MUSIC_MEDIA_CLASS (klass)->get_resume_pos = music_local_media_real_get_resume_pos;
	MUSIC_MEDIA_CLASS (klass)->set_resume_pos = music_local_media_real_set_resume_pos;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_local_media_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_local_media_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_local_media_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_FILE_SIZE_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_FILE_SIZE_PROPERTY] = g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_TITLE_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_TRACK_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_TRACK_PROPERTY] = g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_TRACK_COUNT_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_TRACK_COUNT_PROPERTY] = g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_COMPOSER_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_COMPOSER_PROPERTY] = g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_ARTIST_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_ALBUM_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY] = g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY] = g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_ALBUM_INFO_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_ALBUM_INFO_PROPERTY] = g_param_spec_object ("album-info", "album-info", "album-info", MUSIC_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_GROUPING_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_GROUPING_PROPERTY] = g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_GENRE_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_COMMENT_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_LYRICS_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_LYRICS_PROPERTY] = g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_YEAR_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_BITRATE_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_BITRATE_PROPERTY] = g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_SAMPLERATE_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_SAMPLERATE_PROPERTY] = g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_LENGTH_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_RATING_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_PLAY_COUNT_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_PLAY_COUNT_PROPERTY] = g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_SKIP_COUNT_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_SKIP_COUNT_PROPERTY] = g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_DATE_ADDED_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_DATE_ADDED_PROPERTY] = g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_LAST_PLAYED_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_LAST_PLAYED_PROPERTY] = g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY] = g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_SHOW_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_SHOW_PROPERTY] = g_param_spec_boolean ("show", "show", "show", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LOCAL_MEDIA_RESUME_POS_PROPERTY, music_local_media_properties[MUSIC_LOCAL_MEDIA_RESUME_POS_PROPERTY] = g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_local_media_instance_init (MusicLocalMedia * self,
                                 gpointer klass)
{
	self->priv = music_local_media_get_instance_private (self);
	self->priv->_file_size = NULL;
	self->priv->_title = NULL;
	self->priv->_track = NULL;
	self->priv->_track_count = NULL;
	self->priv->_composer = NULL;
	self->priv->_artist = NULL;
	self->priv->_album_artist = NULL;
	self->priv->_album = NULL;
	self->priv->_album_number = NULL;
	self->priv->_album_count = NULL;
	self->priv->_album_info = NULL;
	self->priv->_grouping = NULL;
	self->priv->_genre = NULL;
	self->priv->_comment = NULL;
	self->priv->_lyrics = NULL;
	self->_year = NULL;
	self->_bitrate = NULL;
	self->_samplerate = NULL;
	self->_length = NULL;
	self->_play_count = NULL;
	self->_skip_count = NULL;
	self->_date_added = NULL;
	self->_last_played = NULL;
	self->_last_modified = NULL;
	self->priv->_show = NULL;
	self->priv->_resume_pos = 0;
}

static void
music_local_media_finalize (GObject * obj)
{
	MusicLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMedia);
	_g_free0 (self->priv->_file_size);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_track);
	_g_free0 (self->priv->_track_count);
	_g_free0 (self->priv->_composer);
	_g_free0 (self->priv->_artist);
	_g_free0 (self->priv->_album_artist);
	_g_free0 (self->priv->_album);
	_g_free0 (self->priv->_album_number);
	_g_free0 (self->priv->_album_count);
	_g_free0 (self->priv->_grouping);
	_g_free0 (self->priv->_genre);
	_g_free0 (self->priv->_comment);
	_g_free0 (self->priv->_lyrics);
	_g_free0 (self->_year);
	_g_free0 (self->_bitrate);
	_g_free0 (self->_samplerate);
	_g_free0 (self->_length);
	_g_free0 (self->_play_count);
	_g_free0 (self->_skip_count);
	_g_free0 (self->_date_added);
	_g_free0 (self->_last_played);
	_g_free0 (self->_last_modified);
	_g_free0 (self->priv->_show);
	_g_object_unref0 (self->priv->connection);
	G_OBJECT_CLASS (music_local_media_parent_class)->finalize (obj);
}

static GType
music_local_media_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLocalMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_local_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLocalMedia), 0, (GInstanceInitFunc) music_local_media_instance_init, NULL };
	GType music_local_media_type_id;
	music_local_media_type_id = g_type_register_static (MUSIC_TYPE_MEDIA, "MusicLocalMedia", &g_define_type_info, 0);
	MusicLocalMedia_private_offset = g_type_add_instance_private (music_local_media_type_id, sizeof (MusicLocalMediaPrivate));
	return music_local_media_type_id;
}

GType
music_local_media_get_type (void)
{
	static volatile gsize music_local_media_type_id__once = 0;
	if (g_once_init_enter (&music_local_media_type_id__once)) {
		GType music_local_media_type_id;
		music_local_media_type_id = music_local_media_get_type_once ();
		g_once_init_leave (&music_local_media_type_id__once, music_local_media_type_id);
	}
	return music_local_media_type_id__once;
}

static void
_vala_music_local_media_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	MusicLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMedia);
	switch (property_id) {
		case MUSIC_LOCAL_MEDIA_FILE_SIZE_PROPERTY:
		g_value_set_uint64 (value, music_media_get_file_size ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_TITLE_PROPERTY:
		g_value_set_string (value, music_media_get_title ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_TRACK_PROPERTY:
		g_value_set_uint (value, music_media_get_track ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_TRACK_COUNT_PROPERTY:
		g_value_set_uint (value, music_media_get_track_count ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_COMPOSER_PROPERTY:
		g_value_set_string (value, music_media_get_composer ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_ARTIST_PROPERTY:
		g_value_set_string (value, music_media_get_artist ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY:
		g_value_set_string (value, music_media_get_album_artist ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_PROPERTY:
		g_value_set_string (value, music_media_get_album ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY:
		g_value_set_uint (value, music_media_get_album_number ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY:
		g_value_set_uint (value, music_media_get_album_count ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_INFO_PROPERTY:
		g_value_set_object (value, music_media_get_album_info ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_GROUPING_PROPERTY:
		g_value_set_string (value, music_media_get_grouping ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_GENRE_PROPERTY:
		g_value_set_string (value, music_media_get_genre ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_COMMENT_PROPERTY:
		g_value_set_string (value, music_media_get_comment ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_LYRICS_PROPERTY:
		g_value_set_string (value, music_media_get_lyrics ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_YEAR_PROPERTY:
		g_value_set_uint (value, music_media_get_year ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_BITRATE_PROPERTY:
		g_value_set_uint (value, music_media_get_bitrate ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_SAMPLERATE_PROPERTY:
		g_value_set_uint (value, music_media_get_samplerate ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_LENGTH_PROPERTY:
		g_value_set_uint (value, music_media_get_length ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_RATING_PROPERTY:
		g_value_set_uint (value, music_media_get_rating ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_PLAY_COUNT_PROPERTY:
		g_value_set_uint (value, music_media_get_play_count ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_SKIP_COUNT_PROPERTY:
		g_value_set_uint (value, music_media_get_skip_count ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_DATE_ADDED_PROPERTY:
		g_value_set_uint (value, music_media_get_date_added ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_LAST_PLAYED_PROPERTY:
		g_value_set_uint (value, music_media_get_last_played ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY:
		g_value_set_uint (value, music_media_get_last_modified ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_SHOW_PROPERTY:
		g_value_set_boolean (value, music_media_get_show ((MusicMedia*) self));
		break;
		case MUSIC_LOCAL_MEDIA_RESUME_POS_PROPERTY:
		g_value_set_int (value, music_media_get_resume_pos ((MusicMedia*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_local_media_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	MusicLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LOCAL_MEDIA, MusicLocalMedia);
	switch (property_id) {
		case MUSIC_LOCAL_MEDIA_FILE_SIZE_PROPERTY:
		music_media_set_file_size ((MusicMedia*) self, g_value_get_uint64 (value));
		break;
		case MUSIC_LOCAL_MEDIA_TITLE_PROPERTY:
		music_media_set_title ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_TRACK_PROPERTY:
		music_media_set_track ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_TRACK_COUNT_PROPERTY:
		music_media_set_track_count ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_COMPOSER_PROPERTY:
		music_media_set_composer ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_ARTIST_PROPERTY:
		music_media_set_artist ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY:
		music_media_set_album_artist ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_PROPERTY:
		music_media_set_album ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY:
		music_media_set_album_number ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY:
		music_media_set_album_count ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_ALBUM_INFO_PROPERTY:
		music_media_set_album_info ((MusicMedia*) self, g_value_get_object (value));
		break;
		case MUSIC_LOCAL_MEDIA_GROUPING_PROPERTY:
		music_media_set_grouping ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_GENRE_PROPERTY:
		music_media_set_genre ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_COMMENT_PROPERTY:
		music_media_set_comment ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_LYRICS_PROPERTY:
		music_media_set_lyrics ((MusicMedia*) self, g_value_get_string (value));
		break;
		case MUSIC_LOCAL_MEDIA_YEAR_PROPERTY:
		music_media_set_year ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_BITRATE_PROPERTY:
		music_media_set_bitrate ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_SAMPLERATE_PROPERTY:
		music_media_set_samplerate ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_LENGTH_PROPERTY:
		music_media_set_length ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_RATING_PROPERTY:
		music_media_set_rating ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_PLAY_COUNT_PROPERTY:
		music_media_set_play_count ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_SKIP_COUNT_PROPERTY:
		music_media_set_skip_count ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_DATE_ADDED_PROPERTY:
		music_media_set_date_added ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_LAST_PLAYED_PROPERTY:
		music_media_set_last_played ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY:
		music_media_set_last_modified ((MusicMedia*) self, g_value_get_uint (value));
		break;
		case MUSIC_LOCAL_MEDIA_SHOW_PROPERTY:
		music_media_set_show ((MusicMedia*) self, g_value_get_boolean (value));
		break;
		case MUSIC_LOCAL_MEDIA_RESUME_POS_PROPERTY:
		music_media_set_resume_pos ((MusicMedia*) self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

