/* BrowserColumnModel.c generated by valac 0.55.1, the Vala compiler
 * generated from BrowserColumnModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <stdarg.h>
#include "io.elementary.music-core.h"

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_BROWSER_COLUMN_MODEL (music_browser_column_model_get_type ())
#define MUSIC_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModel))
#define MUSIC_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModelClass))
#define MUSIC_IS_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_BROWSER_COLUMN_MODEL))
#define MUSIC_IS_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_BROWSER_COLUMN_MODEL))
#define MUSIC_BROWSER_COLUMN_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModelClass))

typedef struct _MusicBrowserColumnModel MusicBrowserColumnModel;
typedef struct _MusicBrowserColumnModelClass MusicBrowserColumnModelClass;
typedef struct _MusicBrowserColumnModelPrivate MusicBrowserColumnModelPrivate;
typedef enum  {
	MUSIC_BROWSER_COLUMN_CATEGORY_RATING,
	MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING,
	MUSIC_BROWSER_COLUMN_CATEGORY_YEAR,
	MUSIC_BROWSER_COLUMN_CATEGORY_GENRE,
	MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER,
	MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST,
	MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM,
	MUSIC_BROWSER_COLUMN_CATEGORY_N_CATEGORIES
} MusicBrowserColumnCategory;

#define MUSIC_BROWSER_COLUMN_TYPE_CATEGORY (music_browser_column_category_get_type ())
enum  {
	MUSIC_BROWSER_COLUMN_MODEL_0_PROPERTY,
	MUSIC_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY,
	MUSIC_BROWSER_COLUMN_MODEL_NUM_PROPERTIES
};
static GParamSpec* music_browser_column_model_properties[MUSIC_BROWSER_COLUMN_MODEL_NUM_PROPERTIES];
#define _g_sequence_free0(var) ((var == NULL) ? NULL : (var = (g_sequence_free (var), NULL)))
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicBrowserColumnModel {
	GObject parent_instance;
	MusicBrowserColumnModelPrivate * priv;
};

struct _MusicBrowserColumnModelClass {
	GObjectClass parent_class;
};

struct _MusicBrowserColumnModelPrivate {
	gint stamp;
	GSequence* rows;
	GtkTreeIter* first_iter;
	gint sort_column_id;
	GtkSortType sort_direction;
	GtkTreeIterCompareFunc default_sort_func;
	gpointer default_sort_func_target;
	MusicBrowserColumnCategory category;
};

static gint MusicBrowserColumnModel_private_offset;
static gpointer music_browser_column_model_parent_class = NULL;
static GtkTreeModelIface * music_browser_column_model_gtk_tree_model_parent_iface = NULL;
static GtkTreeSortableIface * music_browser_column_model_gtk_tree_sortable_parent_iface = NULL;

VALA_EXTERN GType music_browser_column_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicBrowserColumnModel, g_object_unref)
VALA_EXTERN GType music_browser_column_category_get_type (void) G_GNUC_CONST ;
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
VALA_EXTERN MusicBrowserColumnModel* music_browser_column_model_new (MusicBrowserColumnCategory category);
VALA_EXTERN MusicBrowserColumnModel* music_browser_column_model_construct (GType object_type,
                                                               MusicBrowserColumnCategory category);
static void _g_free0_ (gpointer var);
static GtkTreeModelFlags music_browser_column_model_real_get_flags (GtkTreeModel* base);
static gboolean music_browser_column_model_real_get_iter (GtkTreeModel* base,
                                                   GtkTreeIter* iter,
                                                   GtkTreePath* path);
static gint music_browser_column_model_real_get_n_columns (GtkTreeModel* base);
static GType music_browser_column_model_real_get_column_type (GtkTreeModel* base,
                                                       gint col);
static GtkTreePath* music_browser_column_model_real_get_path (GtkTreeModel* base,
                                                       GtkTreeIter* iter);
static void music_browser_column_model_real_get_value (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                gint column,
                                                GValue* val);
static gboolean music_browser_column_model_real_iter_children (GtkTreeModel* base,
                                                        GtkTreeIter* iter,
                                                        GtkTreeIter* parent);
static gboolean music_browser_column_model_real_iter_has_child (GtkTreeModel* base,
                                                         GtkTreeIter* iter);
static gint music_browser_column_model_real_iter_n_children (GtkTreeModel* base,
                                                      GtkTreeIter* iter);
static gboolean music_browser_column_model_real_iter_next (GtkTreeModel* base,
                                                    GtkTreeIter* iter);
static gboolean music_browser_column_model_real_iter_nth_child (GtkTreeModel* base,
                                                         GtkTreeIter* iter,
                                                         GtkTreeIter* parent,
                                                         gint n);
static gboolean music_browser_column_model_real_iter_parent (GtkTreeModel* base,
                                                      GtkTreeIter* iter,
                                                      GtkTreeIter* child);
static void music_browser_column_model_real_ref_node (GtkTreeModel* base,
                                               GtkTreeIter* iter);
static void music_browser_column_model_real_unref_node (GtkTreeModel* base,
                                                 GtkTreeIter* iter);
VALA_EXTERN void music_browser_column_model_append (MusicBrowserColumnModel* self,
                                        GtkTreeIter* iter);
VALA_EXTERN void music_browser_column_model_append_items (MusicBrowserColumnModel* self,
                                              GeeCollection* strings,
                                              gboolean emit);
static void music_browser_column_model_add_first_element (MusicBrowserColumnModel* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void music_browser_column_model_update_first_item (MusicBrowserColumnModel* self);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static gchar* music_browser_column_model_get_first_item_text (MusicBrowserColumnModel* self,
                                                       gint n_items);
VALA_EXTERN gint music_browser_column_model_get_n_items (MusicBrowserColumnModel* self);
VALA_EXTERN void music_browser_column_model_set (MusicBrowserColumnModel* self,
                                     GtkTreeIter* iter,
                                     ...);
VALA_EXTERN void music_browser_column_model_remove (MusicBrowserColumnModel* self,
                                        GtkTreeIter* iter);
static gboolean music_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                             gint* sort_column_id,
                                                             GtkSortType* order);
static gboolean music_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base);
static void music_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                            GtkTreeIterCompareFunc sort_func,
                                                            gpointer sort_func_target,
                                                            GDestroyNotify sort_func_target_destroy_notify);
static void music_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base,
                                                         gint sort_column_id,
                                                         GtkSortType order);
VALA_EXTERN gint music_browser_column_model_sequence_iter_compare_func (MusicBrowserColumnModel* self,
                                                            GSequenceIter* a,
                                                            GSequenceIter* b);
static gint _music_browser_column_model_sequence_iter_compare_func_gsequence_iter_compare_func (GSequenceIter* a,
                                                                                         GSequenceIter* b,
                                                                                         gpointer self);
static void music_browser_column_model_real_set_sort_func (GtkTreeSortable* base,
                                                    gint sort_column_id,
                                                    GtkTreeIterCompareFunc sort_func,
                                                    gpointer sort_func_target,
                                                    GDestroyNotify sort_func_target_destroy_notify);
static void music_browser_column_model_finalize (GObject * obj);
static GType music_browser_column_model_get_type_once (void);
static void _vala_music_browser_column_model_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
music_browser_column_model_get_instance_private (MusicBrowserColumnModel* self)
{
	return G_STRUCT_MEMBER_P (self, MusicBrowserColumnModel_private_offset);
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
	g_boxed_free (gtk_tree_iter_get_type (), self);
}

/** Initialize data storage, columns, etc. **/
static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

MusicBrowserColumnModel*
music_browser_column_model_construct (GType object_type,
                                      MusicBrowserColumnCategory category)
{
	MusicBrowserColumnModel * self = NULL;
	GSequence* _tmp0_;
	self = (MusicBrowserColumnModel*) g_object_new (object_type, NULL);
	_tmp0_ = g_sequence_new (_g_free0_);
	_g_sequence_free0 (self->priv->rows);
	self->priv->rows = _tmp0_;
	self->priv->category = category;
	self->priv->sort_column_id = -2;
	self->priv->sort_direction = GTK_SORT_ASCENDING;
	return self;
}

MusicBrowserColumnModel*
music_browser_column_model_new (MusicBrowserColumnCategory category)
{
	return music_browser_column_model_construct (MUSIC_TYPE_BROWSER_COLUMN_MODEL, category);
}

/** Returns a set of flags supported by this interface **/
static GtkTreeModelFlags
music_browser_column_model_real_get_flags (GtkTreeModel* base)
{
	MusicBrowserColumnModel * self;
	GtkTreeModelFlags result;
	self = (MusicBrowserColumnModel*) base;
	result = GTK_TREE_MODEL_LIST_ONLY;
	return result;
}

/** Sets iter to a valid iterator pointing to path **/
static gboolean
music_browser_column_model_real_get_iter (GtkTreeModel* base,
                                          GtkTreeIter* iter,
                                          GtkTreePath* path)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gint path_index = 0;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GSequence* _tmp5_;
	GSequenceIter* seq_iter = NULL;
	GSequence* _tmp7_;
	GSequenceIter* _tmp8_;
	GSequenceIter* _tmp9_;
	GSequenceIter* _tmp10_;
	gboolean result;
	self = (MusicBrowserColumnModel*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	_tmp1_ = gtk_tree_path_get_indices_with_depth (path, &_tmp0_);
	_tmp2_ = _tmp1_[0];
	path_index = _tmp2_;
	_tmp5_ = self->priv->rows;
	if (g_sequence_get_length (_tmp5_) == 0) {
		_tmp4_ = TRUE;
	} else {
		_tmp4_ = path_index < 0;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		GSequence* _tmp6_;
		_tmp6_ = self->priv->rows;
		_tmp3_ = path_index >= g_sequence_get_length (_tmp6_);
	}
	if (_tmp3_) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_tmp7_ = self->priv->rows;
	_tmp8_ = g_sequence_get_iter_at_pos (_tmp7_, path_index);
	seq_iter = _tmp8_;
	_tmp9_ = seq_iter;
	if (_tmp9_ == NULL) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_vala_iter.stamp = self->priv->stamp;
	_tmp10_ = seq_iter;
	_vala_iter.user_data = _tmp10_;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

/** Returns the number of columns supported by tree_model. **/
static gint
music_browser_column_model_real_get_n_columns (GtkTreeModel* base)
{
	MusicBrowserColumnModel * self;
	gint result;
	self = (MusicBrowserColumnModel*) base;
	result = 1;
	return result;
}

static GType
music_browser_column_model_real_get_column_type (GtkTreeModel* base,
                                                 gint col)
{
	MusicBrowserColumnModel * self;
	GType result;
	self = (MusicBrowserColumnModel*) base;
	result = G_TYPE_STRING;
	return result;
}

/** Returns a newly-created Gtk.TreePath referenced by iter. **/
static GtkTreePath*
music_browser_column_model_real_get_path (GtkTreeModel* base,
                                          GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* result;
	self = (MusicBrowserColumnModel*) base;
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.user_data;
	_tmp2_ = g_strdup_printf ("%i", g_sequence_iter_get_position ((GSequenceIter*) _tmp1_));
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	return result;
}

/** Initializes and sets value to that at column. **/
static void
music_browser_column_model_real_get_value (GtkTreeModel* base,
                                           GtkTreeIter* iter,
                                           gint column,
                                           GValue* val)
{
	MusicBrowserColumnModel * self;
	GValue _vala_val = {0};
	GValue _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkTreeIter _tmp3_;
	GtkTreeIter _tmp4_;
	void* _tmp5_;
	self = (MusicBrowserColumnModel*) base;
	g_return_if_fail (iter != NULL);
	g_value_init (&_tmp0_, G_TYPE_STRING);
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	_vala_val = _tmp0_;
	_tmp3_ = *iter;
	if (_tmp3_.stamp != self->priv->stamp) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = column < 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = column >= 1;
	}
	if (_tmp1_) {
		if (val) {
			*val = _vala_val;
		} else {
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		}
		return;
	}
	_tmp4_ = *iter;
	_tmp5_ = _tmp4_.user_data;
	if (!g_sequence_iter_is_end ((GSequenceIter*) _tmp5_)) {
		GtkTreeIter _tmp6_;
		void* _tmp7_;
		gconstpointer _tmp8_;
		GValue _tmp9_ = {0};
		_tmp6_ = *iter;
		_tmp7_ = _tmp6_.user_data;
		_tmp8_ = g_sequence_get ((GSequenceIter*) _tmp7_);
		g_value_init (&_tmp9_, G_TYPE_STRING);
		g_value_set_string (&_tmp9_, (const gchar*) _tmp8_);
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		_vala_val = _tmp9_;
	}
	if (val) {
		*val = _vala_val;
	} else {
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	}
}

/** Sets iter to point to the first child of parent. **/
static gboolean
music_browser_column_model_real_iter_children (GtkTreeModel* base,
                                               GtkTreeIter* iter,
                                               GtkTreeIter* parent)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result;
	self = (MusicBrowserColumnModel*) base;
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	result = FALSE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

/** Returns true if iter has children, false otherwise. **/
static gboolean
music_browser_column_model_real_iter_has_child (GtkTreeModel* base,
                                                GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	gboolean result;
	self = (MusicBrowserColumnModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	result = FALSE;
	return result;
}

/** Returns the number of children that iter has. **/
static gint
music_browser_column_model_real_iter_n_children (GtkTreeModel* base,
                                                 GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	gint result;
	self = (MusicBrowserColumnModel*) base;
	if (iter == NULL) {
		GSequence* _tmp0_;
		_tmp0_ = self->priv->rows;
		result = g_sequence_get_length (_tmp0_);
		return result;
	}
	result = 0;
	return result;
}

/** Sets iter to point to the node following it at the current level. **/
static gboolean
music_browser_column_model_real_iter_next (GtkTreeModel* base,
                                           GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _tmp0_;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	GSequenceIter* _tmp3_;
	GtkTreeIter _tmp4_;
	void* _tmp5_;
	gboolean result;
	self = (MusicBrowserColumnModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	if (_tmp0_.stamp != self->priv->stamp) {
		result = FALSE;
		return result;
	}
	_tmp1_ = *iter;
	_tmp2_ = _tmp1_.user_data;
	_tmp3_ = g_sequence_iter_next ((GSequenceIter*) _tmp2_);
	(*iter).user_data = _tmp3_;
	_tmp4_ = *iter;
	_tmp5_ = _tmp4_.user_data;
	if (g_sequence_iter_is_end ((GSequenceIter*) _tmp5_)) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

/** Sets iter to be the child of parent, using the given index. **/
static gboolean
music_browser_column_model_real_iter_nth_child (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                GtkTreeIter* parent,
                                                gint n)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GSequence* _tmp3_;
	GSequenceIter* _tmp4_;
	gboolean result;
	self = (MusicBrowserColumnModel*) base;
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	if (n < 0) {
		_tmp1_ = TRUE;
	} else {
		GSequence* _tmp2_;
		_tmp2_ = self->priv->rows;
		_tmp1_ = n >= g_sequence_get_length (_tmp2_);
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = parent != NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_vala_iter.stamp = self->priv->stamp;
	_tmp3_ = self->priv->rows;
	_tmp4_ = g_sequence_get_iter_at_pos (_tmp3_, n);
	_vala_iter.user_data = _tmp4_;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

/** Sets iter to be the parent of child. **/
static gboolean
music_browser_column_model_real_iter_parent (GtkTreeModel* base,
                                             GtkTreeIter* iter,
                                             GtkTreeIter* child)
{
	MusicBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result;
	self = (MusicBrowserColumnModel*) base;
	g_return_val_if_fail (child != NULL, FALSE);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	result = FALSE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

/** Lets the tree ref the node. **/
static void
music_browser_column_model_real_ref_node (GtkTreeModel* base,
                                          GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	self = (MusicBrowserColumnModel*) base;
	g_return_if_fail (iter != NULL);
}

/** Lets the tree unref the node. **/
static void
music_browser_column_model_real_unref_node (GtkTreeModel* base,
                                            GtkTreeIter* iter)
{
	MusicBrowserColumnModel * self;
	self = (MusicBrowserColumnModel*) base;
	g_return_if_fail (iter != NULL);
}

/** simply adds iter to the model **/
void
music_browser_column_model_append (MusicBrowserColumnModel* self,
                                   GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	g_return_if_fail (self != NULL);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	_tmp0_ = self->priv->rows;
	_tmp1_ = g_strdup ("");
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
	added = _tmp2_;
	_vala_iter.stamp = self->priv->stamp;
	_vala_iter.user_data = added;
	if (iter) {
		*iter = _vala_iter;
	}
}

/** convenience method to insert strings into the model. No iters returned. **/
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

void
music_browser_column_model_append_items (MusicBrowserColumnModel* self,
                                         GeeCollection* strings,
                                         gboolean emit)
{
	GtkTreeIter* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (strings != NULL);
	_tmp0_ = self->priv->first_iter;
	if (_tmp0_ == NULL) {
		music_browser_column_model_add_first_element (self);
	}
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) strings);
		_s_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			gchar* s = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GSequenceIter* added = NULL;
			GSequence* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			GSequenceIter* _tmp8_;
			_tmp2_ = _s_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _s_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			s = (gchar*) _tmp4_;
			_tmp5_ = self->priv->rows;
			_tmp6_ = s;
			_tmp7_ = g_strdup (_tmp6_);
			_tmp8_ = g_sequence_append (_tmp5_, _tmp7_);
			added = _tmp8_;
			if (emit) {
				GtkTreePath* path = NULL;
				GSequenceIter* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GtkTreePath* _tmp12_;
				GtkTreePath* _tmp13_;
				GtkTreeIter iter = {0};
				GSequenceIter* _tmp14_;
				GtkTreePath* _tmp15_;
				GtkTreeIter _tmp16_;
				_tmp9_ = added;
				_tmp10_ = g_strdup_printf ("%i", g_sequence_iter_get_position (_tmp9_));
				_tmp11_ = _tmp10_;
				_tmp12_ = gtk_tree_path_new_from_string (_tmp11_);
				_tmp13_ = _tmp12_;
				_g_free0 (_tmp11_);
				path = _tmp13_;
				memset (&iter, 0, sizeof (GtkTreeIter));
				iter.stamp = self->priv->stamp;
				_tmp14_ = added;
				iter.user_data = _tmp14_;
				_tmp15_ = path;
				_tmp16_ = iter;
				gtk_tree_model_row_inserted ((GtkTreeModel*) self, _tmp15_, &_tmp16_);
				__vala_GtkTreePath_free0 (path);
			}
			_g_free0 (s);
		}
		_g_object_unref0 (_s_it);
	}
	music_browser_column_model_update_first_item (self);
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
}

static void
music_browser_column_model_add_first_element (MusicBrowserColumnModel* self)
{
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkTreeIter* _tmp4_;
	GtkTreeIter* _tmp5_;
	GtkTreeIter* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->rows;
	_tmp1_ = g_strdup ("All");
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
	added = _tmp2_;
	memset (&_tmp3_, 0, sizeof (GtkTreeIter));
	_tmp4_ = __vala_GtkTreeIter_copy0 (&_tmp3_);
	__vala_GtkTreeIter_free0 (self->priv->first_iter);
	self->priv->first_iter = _tmp4_;
	_tmp5_ = self->priv->first_iter;
	(*_tmp5_).stamp = self->priv->stamp;
	_tmp6_ = self->priv->first_iter;
	(*_tmp6_).user_data = added;
}

static void
music_browser_column_model_update_first_item (MusicBrowserColumnModel* self)
{
	GtkTreeIter* _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->first_iter;
	_tmp1_ = (*_tmp0_).user_data;
	_tmp2_ = music_browser_column_model_get_n_items (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_browser_column_model_get_first_item_text (self, _tmp3_);
	g_sequence_set ((GSequenceIter*) _tmp1_, _tmp4_);
}

static gchar*
music_browser_column_model_get_first_item_text (MusicBrowserColumnModel* self,
                                                gint n_items)
{
	gchar* rv = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	rv = _tmp0_;
	switch (self->priv->category) {
		case MUSIC_BROWSER_COLUMN_CATEGORY_GENRE:
		{
			if (n_items == 1) {
				gchar* _tmp1_;
				_tmp1_ = g_strdup (_ ("All Genres"));
				_g_free0 (rv);
				rv = _tmp1_;
			} else {
				if (n_items > 1) {
					gchar* _tmp2_;
					_tmp2_ = g_strdup_printf (_ ("All %i Genres"), n_items);
					_g_free0 (rv);
					rv = _tmp2_;
				} else {
					gchar* _tmp3_;
					_tmp3_ = g_strdup (_ ("No Genres"));
					_g_free0 (rv);
					rv = _tmp3_;
				}
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST:
		{
			if (n_items == 1) {
				gchar* _tmp4_;
				_tmp4_ = g_strdup (_ ("All Artists"));
				_g_free0 (rv);
				rv = _tmp4_;
			} else {
				if (n_items > 1) {
					gchar* _tmp5_;
					_tmp5_ = g_strdup_printf (_ ("All %i Artists"), n_items);
					_g_free0 (rv);
					rv = _tmp5_;
				} else {
					gchar* _tmp6_;
					_tmp6_ = g_strdup (_ ("No Artists"));
					_g_free0 (rv);
					rv = _tmp6_;
				}
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM:
		{
			if (n_items == 1) {
				gchar* _tmp7_;
				_tmp7_ = g_strdup (_ ("All Albums"));
				_g_free0 (rv);
				rv = _tmp7_;
			} else {
				if (n_items > 1) {
					gchar* _tmp8_;
					_tmp8_ = g_strdup_printf (_ ("All %i Albums"), n_items);
					_g_free0 (rv);
					rv = _tmp8_;
				} else {
					gchar* _tmp9_;
					_tmp9_ = g_strdup (_ ("No Albums"));
					_g_free0 (rv);
					rv = _tmp9_;
				}
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_YEAR:
		{
			if (n_items == 1) {
				gchar* _tmp10_;
				_tmp10_ = g_strdup (_ ("All Years"));
				_g_free0 (rv);
				rv = _tmp10_;
			} else {
				if (n_items > 1) {
					gchar* _tmp11_;
					_tmp11_ = g_strdup_printf (_ ("All %i Years"), n_items);
					_g_free0 (rv);
					rv = _tmp11_;
				} else {
					gchar* _tmp12_;
					_tmp12_ = g_strdup (_ ("No Years"));
					_g_free0 (rv);
					rv = _tmp12_;
				}
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_RATING:
		{
			if (n_items >= 1) {
				gchar* _tmp13_;
				_tmp13_ = g_strdup (_ ("All Ratings"));
				_g_free0 (rv);
				rv = _tmp13_;
			} else {
				gchar* _tmp14_;
				_tmp14_ = g_strdup (_ ("No Ratings"));
				_g_free0 (rv);
				rv = _tmp14_;
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_GROUPING:
		{
			if (n_items == 1) {
				gchar* _tmp15_;
				_tmp15_ = g_strdup (_ ("All Groupings"));
				_g_free0 (rv);
				rv = _tmp15_;
			} else {
				if (n_items > 1) {
					gchar* _tmp16_;
					_tmp16_ = g_strdup_printf (_ ("All %i Groupings"), n_items);
					_g_free0 (rv);
					rv = _tmp16_;
				} else {
					gchar* _tmp17_;
					_tmp17_ = g_strdup (_ ("No Groupings"));
					_g_free0 (rv);
					rv = _tmp17_;
				}
			}
			break;
		}
		case MUSIC_BROWSER_COLUMN_CATEGORY_COMPOSER:
		{
			if (n_items == 1) {
				gchar* _tmp18_;
				_tmp18_ = g_strdup (_ ("All Composers"));
				_g_free0 (rv);
				rv = _tmp18_;
			} else {
				if (n_items > 1) {
					gchar* _tmp19_;
					_tmp19_ = g_strdup_printf (_ ("All %i Composers"), n_items);
					_g_free0 (rv);
					rv = _tmp19_;
				} else {
					gchar* _tmp20_;
					_tmp20_ = g_strdup (_ ("No Composers"));
					_g_free0 (rv);
					rv = _tmp20_;
				}
			}
			break;
		}
		default:
		break;
	}
	result = rv;
	return result;
}

void
music_browser_column_model_set (MusicBrowserColumnModel* self,
                                GtkTreeIter* iter,
                                ...)
{
	GtkTreeIter _tmp0_;
	va_list args = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	if (_tmp0_.stamp != self->priv->stamp) {
		return;
	}
	va_start (args, iter);
	while (TRUE) {
		gint col = 0;
		gboolean _tmp1_ = FALSE;
		col = va_arg (args, gint);
		if (col < 0) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = col >= 1;
		}
		if (_tmp1_) {
			va_end (args);
			return;
		} else {
			if (col == 0) {
				gchar* val = NULL;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				GtkTreeIter _tmp4_;
				void* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				_tmp2_ = va_arg (args, gchar*);
				_tmp3_ = g_strdup (_tmp2_);
				val = _tmp3_;
				_tmp4_ = *iter;
				_tmp5_ = _tmp4_.user_data;
				_tmp6_ = val;
				_tmp7_ = g_strdup (_tmp6_);
				g_sequence_set ((GSequenceIter*) _tmp5_, _tmp7_);
				_g_free0 (val);
			}
		}
	}
}

void
music_browser_column_model_remove (MusicBrowserColumnModel* self,
                                   GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	GSequenceIter* sequence_iter = NULL;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	GtkTreePath* path = NULL;
	GSequenceIter* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreePath* _tmp7_;
	GSequenceIter* _tmp8_;
	GtkTreePath* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	if (_tmp0_.stamp != self->priv->stamp) {
		return;
	}
	_tmp1_ = *iter;
	_tmp2_ = _tmp1_.user_data;
	sequence_iter = (GSequenceIter*) _tmp2_;
	_tmp3_ = sequence_iter;
	_tmp4_ = g_strdup_printf ("%i", g_sequence_iter_get_position (_tmp3_));
	_tmp5_ = _tmp4_;
	_tmp6_ = gtk_tree_path_new_from_string (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	path = _tmp7_;
	_tmp8_ = sequence_iter;
	g_sequence_remove (_tmp8_);
	_tmp9_ = path;
	gtk_tree_model_row_deleted ((GtkTreeModel*) self, _tmp9_);
	__vala_GtkTreePath_free0 (path);
}

/** Fills in sort_column_id and order with the current sort column and the order. **/
static gboolean
music_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                    gint* sort_column_id,
                                                    GtkSortType* order)
{
	MusicBrowserColumnModel * self;
	gint _vala_sort_column_id = 0;
	GtkSortType _vala_order = 0;
	gboolean result;
	self = (MusicBrowserColumnModel*) base;
	_vala_sort_column_id = self->priv->sort_column_id;
	_vala_order = self->priv->sort_direction;
	result = TRUE;
	if (sort_column_id) {
		*sort_column_id = _vala_sort_column_id;
	}
	if (order) {
		*order = _vala_order;
	}
	return result;
}

/** Returns true if the model has a default sort function. **/
static gboolean
music_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base)
{
	MusicBrowserColumnModel * self;
	GtkTreeIterCompareFunc _tmp0_;
	gpointer _tmp0__target;
	gboolean result;
	self = (MusicBrowserColumnModel*) base;
	_tmp0_ = self->priv->default_sort_func;
	_tmp0__target = self->priv->default_sort_func_target;
	result = _tmp0_ != NULL;
	return result;
}

/** Sets the default comparison function used when sorting to be sort_func. **/
static void
music_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                       GtkTreeIterCompareFunc sort_func,
                                                       gpointer sort_func_target,
                                                       GDestroyNotify sort_func_target_destroy_notify)
{
	MusicBrowserColumnModel * self;
	self = (MusicBrowserColumnModel*) base;
	self->priv->default_sort_func = sort_func;
	self->priv->default_sort_func_target = sort_func_target;
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}

/** Sets the current sort column to be sort_column_id. **/
static gint
_music_browser_column_model_sequence_iter_compare_func_gsequence_iter_compare_func (GSequenceIter* a,
                                                                                    GSequenceIter* b,
                                                                                    gpointer self)
{
	gint result;
	result = music_browser_column_model_sequence_iter_compare_func ((MusicBrowserColumnModel*) self, a, b);
	return result;
}

static void
music_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base,
                                                    gint sort_column_id,
                                                    GtkSortType order)
{
	MusicBrowserColumnModel * self;
	gboolean _tmp0_ = FALSE;
	gboolean changed = FALSE;
	gboolean _tmp1_ = FALSE;
	self = (MusicBrowserColumnModel*) base;
	if (self->priv->sort_column_id != sort_column_id) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = order != self->priv->sort_direction;
	}
	changed = _tmp0_;
	self->priv->sort_column_id = sort_column_id;
	self->priv->sort_direction = order;
	if (changed) {
		_tmp1_ = sort_column_id >= 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GSequence* _tmp2_;
		_tmp2_ = self->priv->rows;
		g_sequence_sort_iter (_tmp2_, _music_browser_column_model_sequence_iter_compare_func_gsequence_iter_compare_func, self);
		gtk_tree_sortable_sort_column_changed ((GtkTreeSortable*) self);
	}
}

static void
music_browser_column_model_real_set_sort_func (GtkTreeSortable* base,
                                               gint sort_column_id,
                                               GtkTreeIterCompareFunc sort_func,
                                               gpointer sort_func_target,
                                               GDestroyNotify sort_func_target_destroy_notify)
{
	MusicBrowserColumnModel * self;
	self = (MusicBrowserColumnModel*) base;
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}

/** Custom function to use built in sort in Sequence to our advantage **/
gint
music_browser_column_model_sequence_iter_compare_func (MusicBrowserColumnModel* self,
                                                       GSequenceIter* a,
                                                       GSequenceIter* b)
{
	gint rv = 0;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	rv = 1;
	if (self->priv->sort_column_id < 0) {
		result = 0;
		return result;
	}
	if (self->priv->sort_column_id == 0) {
		GSequenceIter* first_sequence_iter = NULL;
		GtkTreeIter* _tmp0_;
		void* _tmp1_;
		GSequenceIter* _tmp2_;
		_tmp0_ = self->priv->first_iter;
		_tmp1_ = (*_tmp0_).user_data;
		first_sequence_iter = (GSequenceIter*) _tmp1_;
		_tmp2_ = first_sequence_iter;
		if (a == _tmp2_) {
			rv = -1;
		} else {
			GSequenceIter* _tmp3_;
			_tmp3_ = first_sequence_iter;
			if (b == _tmp3_) {
				rv = 1;
			} else {
				gboolean _tmp4_ = FALSE;
				if (self->priv->category == MUSIC_BROWSER_COLUMN_CATEGORY_ARTIST) {
					_tmp4_ = TRUE;
				} else {
					_tmp4_ = self->priv->category == MUSIC_BROWSER_COLUMN_CATEGORY_ALBUM;
				}
				if (_tmp4_) {
					gconstpointer _tmp5_;
					gconstpointer _tmp6_;
					_tmp5_ = g_sequence_get (a);
					_tmp6_ = g_sequence_get (b);
					rv = music_string_compare ((const gchar*) _tmp5_, (const gchar*) _tmp6_);
				} else {
					gconstpointer _tmp7_;
					gconstpointer _tmp8_;
					_tmp7_ = g_sequence_get (a);
					_tmp8_ = g_sequence_get (b);
					rv = music_string_compare ((const gchar*) _tmp7_, (const gchar*) _tmp8_);
				}
			}
		}
	}
	if (self->priv->sort_direction == GTK_SORT_DESCENDING) {
		gint _tmp9_ = 0;
		if (rv > 0) {
			_tmp9_ = -1;
		} else {
			_tmp9_ = 1;
		}
		rv = _tmp9_;
	}
	result = rv;
	return result;
}

gint
music_browser_column_model_get_n_items (MusicBrowserColumnModel* self)
{
	gint result;
	GSequence* _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->rows;
	result = g_sequence_get_length (_tmp0_) - 1;
	return result;
}

static void
music_browser_column_model_class_init (MusicBrowserColumnModelClass * klass,
                                       gpointer klass_data)
{
	music_browser_column_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicBrowserColumnModel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_browser_column_model_get_property;
	G_OBJECT_CLASS (klass)->finalize = music_browser_column_model_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY, music_browser_column_model_properties[MUSIC_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY] = g_param_spec_int ("n-items", "n-items", "n-items", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
music_browser_column_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface,
                                                          gpointer iface_data)
{
	music_browser_column_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel*)) music_browser_column_model_real_get_flags;
	iface->get_iter = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreePath*)) music_browser_column_model_real_get_iter;
	iface->get_n_columns = (gint (*) (GtkTreeModel*)) music_browser_column_model_real_get_n_columns;
	iface->get_column_type = (GType (*) (GtkTreeModel*, gint)) music_browser_column_model_real_get_column_type;
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_get_path;
	iface->get_value = (void (*) (GtkTreeModel*, GtkTreeIter*, gint, GValue*)) music_browser_column_model_real_get_value;
	iface->iter_children = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) music_browser_column_model_real_iter_children;
	iface->iter_has_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_iter_has_child;
	iface->iter_n_children = (gint (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_iter_n_children;
	iface->iter_next = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_iter_next;
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*, gint)) music_browser_column_model_real_iter_nth_child;
	iface->iter_parent = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) music_browser_column_model_real_iter_parent;
	iface->ref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_ref_node;
	iface->unref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) music_browser_column_model_real_unref_node;
}

static void
music_browser_column_model_gtk_tree_sortable_interface_init (GtkTreeSortableIface * iface,
                                                             gpointer iface_data)
{
	music_browser_column_model_gtk_tree_sortable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_sort_column_id = (gboolean (*) (GtkTreeSortable*, gint*, GtkSortType*)) music_browser_column_model_real_get_sort_column_id;
	iface->has_default_sort_func = (gboolean (*) (GtkTreeSortable*)) music_browser_column_model_real_has_default_sort_func;
	iface->set_default_sort_func = (void (*) (GtkTreeSortable*, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) music_browser_column_model_real_set_default_sort_func;
	iface->set_sort_column_id = (void (*) (GtkTreeSortable*, gint, GtkSortType)) music_browser_column_model_real_set_sort_column_id;
	iface->set_sort_func = (void (*) (GtkTreeSortable*, gint, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) music_browser_column_model_real_set_sort_func;
}

static void
music_browser_column_model_instance_init (MusicBrowserColumnModel * self,
                                          gpointer klass)
{
	self->priv = music_browser_column_model_get_instance_private (self);
	self->priv->stamp = (gint) g_random_int ();
}

static void
music_browser_column_model_finalize (GObject * obj)
{
	MusicBrowserColumnModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModel);
	_g_sequence_free0 (self->priv->rows);
	__vala_GtkTreeIter_free0 (self->priv->first_iter);
	G_OBJECT_CLASS (music_browser_column_model_parent_class)->finalize (obj);
}

static GType
music_browser_column_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicBrowserColumnModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_browser_column_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicBrowserColumnModel), 0, (GInstanceInitFunc) music_browser_column_model_instance_init, NULL };
	static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) music_browser_column_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gtk_tree_sortable_info = { (GInterfaceInitFunc) music_browser_column_model_gtk_tree_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_browser_column_model_type_id;
	music_browser_column_model_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicBrowserColumnModel", &g_define_type_info, 0);
	g_type_add_interface_static (music_browser_column_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
	g_type_add_interface_static (music_browser_column_model_type_id, gtk_tree_sortable_get_type (), &gtk_tree_sortable_info);
	MusicBrowserColumnModel_private_offset = g_type_add_instance_private (music_browser_column_model_type_id, sizeof (MusicBrowserColumnModelPrivate));
	return music_browser_column_model_type_id;
}

GType
music_browser_column_model_get_type (void)
{
	static volatile gsize music_browser_column_model_type_id__once = 0;
	if (g_once_init_enter (&music_browser_column_model_type_id__once)) {
		GType music_browser_column_model_type_id;
		music_browser_column_model_type_id = music_browser_column_model_get_type_once ();
		g_once_init_leave (&music_browser_column_model_type_id__once, music_browser_column_model_type_id);
	}
	return music_browser_column_model_type_id__once;
}

static void
_vala_music_browser_column_model_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	MusicBrowserColumnModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_BROWSER_COLUMN_MODEL, MusicBrowserColumnModel);
	switch (property_id) {
		case MUSIC_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY:
		g_value_set_int (value, music_browser_column_model_get_n_items (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

