/* TileRenderer.c generated by valac 0.55.1, the Vala compiler
 * generated from TileRenderer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <pango/pango.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_WIDGETS_TYPE_TILE_RENDERER (music_widgets_tile_renderer_get_type ())
#define MUSIC_WIDGETS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRenderer))
#define MUSIC_WIDGETS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRendererClass))
#define MUSIC_WIDGETS_IS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER))
#define MUSIC_WIDGETS_IS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_WIDGETS_TYPE_TILE_RENDERER))
#define MUSIC_WIDGETS_TILE_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRendererClass))

typedef struct _MusicWidgetsTileRenderer MusicWidgetsTileRenderer;
typedef struct _MusicWidgetsTileRendererClass MusicWidgetsTileRendererClass;
typedef struct _MusicWidgetsTileRendererPrivate MusicWidgetsTileRendererPrivate;
enum  {
	MUSIC_WIDGETS_TILE_RENDERER_0_PROPERTY,
	MUSIC_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY,
	MUSIC_WIDGETS_TILE_RENDERER_NUM_PROPERTIES
};
static GParamSpec* music_widgets_tile_renderer_properties[MUSIC_WIDGETS_TILE_RENDERER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicWidgetsTileRenderer {
	GtkCellRenderer parent_instance;
	MusicWidgetsTileRendererPrivate * priv;
};

struct _MusicWidgetsTileRendererClass {
	GtkCellRendererClass parent_class;
};

struct _MusicWidgetsTileRendererPrivate {
	MusicAlbum* _album;
	PangoLayout* title_text_layout;
	PangoLayout* subtitle_text_layout;
	GtkBorder margin;
	GtkBorder padding;
	GtkBorder border;
	GdkPixbuf* pixbuf;
};

static gint MusicWidgetsTileRenderer_private_offset;
static gpointer music_widgets_tile_renderer_parent_class = NULL;

VALA_EXTERN GType music_widgets_tile_renderer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicWidgetsTileRenderer, g_object_unref)
VALA_EXTERN MusicWidgetsTileRenderer* music_widgets_tile_renderer_new (void);
VALA_EXTERN MusicWidgetsTileRenderer* music_widgets_tile_renderer_construct (GType object_type);
static void __lambda54_ (MusicWidgetsTileRenderer* self);
static void ___lambda54__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void music_widgets_tile_renderer_real_get_size (GtkCellRenderer* base,
                                                GtkWidget* widget,
                                                GdkRectangle* cell_area,
                                                gint* x_offset,
                                                gint* y_offset,
                                                gint* width,
                                                gint* height);
static GtkSizeRequestMode music_widgets_tile_renderer_real_get_request_mode (GtkCellRenderer* base);
static void music_widgets_tile_renderer_real_get_preferred_width (GtkCellRenderer* base,
                                                           GtkWidget* widget,
                                                           gint* minimum_size,
                                                           gint* natural_size);
static void music_widgets_tile_renderer_update_layout_properties (MusicWidgetsTileRenderer* self,
                                                           GtkWidget* widget);
static gint music_widgets_tile_renderer_compute_total_image_width (MusicWidgetsTileRenderer* self);
static void music_widgets_tile_renderer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                      GtkWidget* widget,
                                                                      gint width,
                                                                      gint* minimum_height,
                                                                      gint* natural_height);
static gint music_widgets_tile_renderer_compute_total_image_height (MusicWidgetsTileRenderer* self);
static void music_widgets_tile_renderer_real_render (GtkCellRenderer* base,
                                              cairo_t* cr,
                                              GtkWidget* widget,
                                              GdkRectangle* bg_area,
                                              GdkRectangle* cell_area,
                                              GtkCellRendererState flags);
static void music_widgets_tile_renderer_render_image (MusicWidgetsTileRenderer* self,
                                               GtkStyleContext* ctx,
                                               cairo_t* cr,
                                               gint* x,
                                               gint* y,
                                               gint width,
                                               GtkCellRendererState flags);
static void music_widgets_tile_renderer_render_title (MusicWidgetsTileRenderer* self,
                                               GtkStyleContext* ctx,
                                               cairo_t* cr,
                                               gint x,
                                               gint* y,
                                               gint width);
static void music_widgets_tile_renderer_render_subtitle (MusicWidgetsTileRenderer* self,
                                                  GtkStyleContext* ctx,
                                                  cairo_t* cr,
                                                  gint x,
                                                  gint y,
                                                  gint width);
VALA_EXTERN MusicAlbum* music_widgets_tile_renderer_get_album (MusicWidgetsTileRenderer* self);
VALA_EXTERN void music_widgets_tile_renderer_set_album (MusicWidgetsTileRenderer* self,
                                            MusicAlbum* value);
static void music_widgets_tile_renderer_finalize (GObject * obj);
static GType music_widgets_tile_renderer_get_type_once (void);
static void _vala_music_widgets_tile_renderer_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_music_widgets_tile_renderer_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
music_widgets_tile_renderer_get_instance_private (MusicWidgetsTileRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicWidgetsTileRenderer_private_offset);
}

static void
__lambda54_ (MusicWidgetsTileRenderer* self)
{
	_g_object_unref0 (self->priv->pixbuf);
	self->priv->pixbuf = NULL;
}

static void
___lambda54__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda54_ ((MusicWidgetsTileRenderer*) self);
}

MusicWidgetsTileRenderer*
music_widgets_tile_renderer_construct (GType object_type)
{
	MusicWidgetsTileRenderer * self = NULL;
	self = (MusicWidgetsTileRenderer*) g_object_new (object_type, NULL);
	g_signal_connect_object ((GObject*) self, "notify::album", (GCallback) ___lambda54__g_object_notify, self, 0);
	return self;
}

MusicWidgetsTileRenderer*
music_widgets_tile_renderer_new (void)
{
	return music_widgets_tile_renderer_construct (MUSIC_WIDGETS_TYPE_TILE_RENDERER);
}

static void
music_widgets_tile_renderer_real_get_size (GtkCellRenderer* base,
                                           GtkWidget* widget,
                                           GdkRectangle* cell_area,
                                           gint* x_offset,
                                           gint* y_offset,
                                           gint* width,
                                           gint* height)
{
	MusicWidgetsTileRenderer * self;
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	self = (MusicWidgetsTileRenderer*) base;
	g_return_if_fail (widget != NULL);
	_vala_height = 0;
	_vala_width = _vala_height;
	_vala_y_offset = _vala_width;
	_vala_x_offset = _vala_y_offset;
	if (x_offset) {
		*x_offset = _vala_x_offset;
	}
	if (y_offset) {
		*y_offset = _vala_y_offset;
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
}

static GtkSizeRequestMode
music_widgets_tile_renderer_real_get_request_mode (GtkCellRenderer* base)
{
	MusicWidgetsTileRenderer * self;
	GtkSizeRequestMode result;
	self = (MusicWidgetsTileRenderer*) base;
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}

static void
music_widgets_tile_renderer_real_get_preferred_width (GtkCellRenderer* base,
                                                      GtkWidget* widget,
                                                      gint* minimum_size,
                                                      gint* natural_size)
{
	MusicWidgetsTileRenderer * self;
	gint _vala_minimum_size = 0;
	gint _vala_natural_size = 0;
	gint x_padding = 0;
	gint _tmp0_ = 0;
	gint width = 0;
	GtkBorder _tmp1_;
	GtkBorder _tmp2_;
	GtkBorder _tmp3_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_;
	GtkBorder _tmp6_;
	self = (MusicWidgetsTileRenderer*) base;
	g_return_if_fail (widget != NULL);
	music_widgets_tile_renderer_update_layout_properties (self, widget);
	gtk_cell_renderer_get_padding ((GtkCellRenderer*) self, &_tmp0_, NULL);
	x_padding = _tmp0_;
	_tmp1_ = self->priv->margin;
	_tmp2_ = self->priv->margin;
	_tmp3_ = self->priv->padding;
	_tmp4_ = self->priv->padding;
	_tmp5_ = self->priv->border;
	_tmp6_ = self->priv->border;
	width = ((((((music_widgets_tile_renderer_compute_total_image_width (self) + _tmp1_.left) + _tmp2_.right) + _tmp3_.left) + _tmp4_.right) + _tmp5_.left) + _tmp6_.right) + (2 * x_padding);
	_vala_natural_size = width;
	_vala_minimum_size = _vala_natural_size;
	if (minimum_size) {
		*minimum_size = _vala_minimum_size;
	}
	if (natural_size) {
		*natural_size = _vala_natural_size;
	}
}

static void
music_widgets_tile_renderer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                 GtkWidget* widget,
                                                                 gint width,
                                                                 gint* minimum_height,
                                                                 gint* natural_height)
{
	MusicWidgetsTileRenderer * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gint y_padding = 0;
	gint _tmp0_ = 0;
	gint subtitle_height = 0;
	gint title_height = 0;
	PangoLayout* _tmp1_;
	gint _tmp2_ = 0;
	PangoLayout* _tmp3_;
	gint _tmp4_ = 0;
	gint height = 0;
	GtkBorder _tmp5_;
	GtkBorder _tmp6_;
	GtkBorder _tmp7_;
	GtkBorder _tmp8_;
	GtkBorder _tmp9_;
	GtkBorder _tmp10_;
	self = (MusicWidgetsTileRenderer*) base;
	g_return_if_fail (widget != NULL);
	music_widgets_tile_renderer_update_layout_properties (self, widget);
	gtk_cell_renderer_get_padding ((GtkCellRenderer*) self, NULL, &_tmp0_);
	y_padding = _tmp0_;
	_tmp1_ = self->priv->title_text_layout;
	pango_layout_get_pixel_size (_tmp1_, NULL, &_tmp2_);
	title_height = _tmp2_;
	_tmp3_ = self->priv->subtitle_text_layout;
	pango_layout_get_pixel_size (_tmp3_, NULL, &_tmp4_);
	subtitle_height = _tmp4_;
	_tmp5_ = self->priv->margin;
	_tmp6_ = self->priv->margin;
	_tmp7_ = self->priv->padding;
	_tmp8_ = self->priv->padding;
	_tmp9_ = self->priv->border;
	_tmp10_ = self->priv->border;
	height = ((((((((music_widgets_tile_renderer_compute_total_image_height (self) + title_height) + subtitle_height) + _tmp5_.top) + (2 * _tmp6_.bottom)) + _tmp7_.top) + _tmp8_.bottom) + _tmp9_.top) + _tmp10_.bottom) + (2 * y_padding);
	_vala_natural_height = height;
	_vala_minimum_height = _vala_natural_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}

static void
music_widgets_tile_renderer_real_render (GtkCellRenderer* base,
                                         cairo_t* cr,
                                         GtkWidget* widget,
                                         GdkRectangle* bg_area,
                                         GdkRectangle* cell_area,
                                         GtkCellRendererState flags)
{
	MusicWidgetsTileRenderer * self;
	GdkRectangle aligned_area = {0};
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_ = {0};
	gint x = 0;
	GdkRectangle _tmp2_;
	gint y = 0;
	GdkRectangle _tmp3_;
	gint width = 0;
	GdkRectangle _tmp4_;
	gint height = 0;
	GdkRectangle _tmp5_;
	GtkBorder _tmp6_;
	GtkBorder _tmp7_;
	GtkBorder _tmp8_;
	GtkBorder _tmp9_;
	GtkBorder _tmp10_;
	GtkBorder _tmp11_;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp12_;
	GtkBorder _tmp13_;
	GtkBorder _tmp14_;
	GtkBorder _tmp15_;
	GtkBorder _tmp16_;
	GtkBorder _tmp17_;
	GtkBorder _tmp18_;
	GtkBorder _tmp19_;
	GtkBorder _tmp20_;
	GtkBorder _tmp21_;
	GtkBorder _tmp22_;
	GtkBorder _tmp23_;
	GtkBorder _tmp24_;
	self = (MusicWidgetsTileRenderer*) base;
	g_return_if_fail (cr != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (bg_area != NULL);
	g_return_if_fail (cell_area != NULL);
	music_widgets_tile_renderer_update_layout_properties (self, widget);
	_tmp0_ = *cell_area;
	gtk_cell_renderer_get_aligned_area ((GtkCellRenderer*) self, widget, flags, &_tmp0_, &_tmp1_);
	aligned_area = _tmp1_;
	_tmp2_ = aligned_area;
	x = _tmp2_.x;
	_tmp3_ = aligned_area;
	y = _tmp3_.y;
	_tmp4_ = aligned_area;
	width = _tmp4_.width;
	_tmp5_ = aligned_area;
	height = _tmp5_.height;
	_tmp6_ = self->priv->margin;
	_tmp7_ = self->priv->border;
	_tmp8_ = self->priv->padding;
	x += (gint) ((_tmp6_.left + _tmp7_.left) + _tmp8_.left);
	_tmp9_ = self->priv->margin;
	_tmp10_ = self->priv->border;
	_tmp11_ = self->priv->padding;
	y += (gint) ((_tmp9_.top + _tmp10_.top) + _tmp11_.top);
	_tmp12_ = gtk_widget_get_style_context (widget);
	ctx = _tmp12_;
	_tmp13_ = self->priv->margin;
	_tmp14_ = self->priv->margin;
	_tmp15_ = self->priv->border;
	_tmp16_ = self->priv->border;
	_tmp17_ = self->priv->padding;
	_tmp18_ = self->priv->padding;
	width -= (gint) (((((_tmp13_.left + _tmp14_.right) + _tmp15_.left) + _tmp16_.right) + _tmp17_.left) + _tmp18_.right);
	_tmp19_ = self->priv->margin;
	_tmp20_ = self->priv->margin;
	_tmp21_ = self->priv->border;
	_tmp22_ = self->priv->border;
	_tmp23_ = self->priv->padding;
	_tmp24_ = self->priv->padding;
	height -= (gint) (((((_tmp19_.top + _tmp20_.bottom) + _tmp21_.top) + _tmp22_.bottom) + _tmp23_.top) + _tmp24_.bottom);
	music_widgets_tile_renderer_render_image (self, ctx, cr, &x, &y, width, flags);
	music_widgets_tile_renderer_render_title (self, ctx, cr, x, &y, width);
	music_widgets_tile_renderer_render_subtitle (self, ctx, cr, x, y, width);
}

static void
music_widgets_tile_renderer_render_image (MusicWidgetsTileRenderer* self,
                                          GtkStyleContext* ctx,
                                          cairo_t* cr,
                                          gint* x,
                                          gint* y,
                                          gint width,
                                          GtkCellRendererState flags)
{
	gint image_width = 0;
	gint image_height = 0;
	GdkPixbuf* _tmp0_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_;
	GtkBorder _tmp6_;
	GtkBorder _tmp7_;
	GtkBorder _tmp8_;
	GtkBorder _tmp9_;
	GtkBorder _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (cr != NULL);
	image_width = music_widgets_tile_renderer_compute_total_image_width (self);
	image_height = music_widgets_tile_renderer_compute_total_image_height (self);
	*x = (*x) + ((width - image_width) / 2);
	gtk_style_context_save (ctx);
	gtk_style_context_add_class (ctx, "album");
	gtk_style_context_add_class (ctx, GRANITE_STYLE_CLASS_CARD);
	gtk_render_background (ctx, cr, (gdouble) (*x), (gdouble) (*y), (gdouble) 128, (gdouble) 128);
	_tmp0_ = self->priv->pixbuf;
	if (_tmp0_ != NULL) {
		gint scale_factor = 0;
		cairo_surface_t* surface = NULL;
		GdkPixbuf* _tmp1_;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
		scale_factor = gtk_style_context_get_scale (ctx);
		_tmp1_ = self->priv->pixbuf;
		_tmp2_ = gdk_cairo_surface_create_from_pixbuf (_tmp1_, scale_factor, NULL);
		surface = _tmp2_;
		_tmp3_ = surface;
		gtk_render_icon_surface (ctx, cr, _tmp3_, (gdouble) (*x), (gdouble) (*y));
		_cairo_surface_destroy0 (surface);
	}
	cairo_fill_preserve (cr);
	_tmp4_ = self->priv->border;
	_tmp5_ = self->priv->border;
	_tmp6_ = self->priv->border;
	_tmp7_ = self->priv->border;
	_tmp8_ = self->priv->border;
	_tmp9_ = self->priv->border;
	gtk_render_frame (ctx, cr, (gdouble) ((*x) - _tmp4_.left), (gdouble) ((*y) - _tmp5_.top), (gdouble) ((128 + _tmp6_.left) + _tmp7_.right), (gdouble) ((128 + _tmp8_.top) + _tmp9_.bottom));
	gtk_style_context_restore (ctx);
	*y = (*y) + image_height;
	_tmp10_ = self->priv->margin;
	*x = (*x) + (((image_width - 128) / 2) - _tmp10_.left);
}

static void
music_widgets_tile_renderer_render_title (MusicWidgetsTileRenderer* self,
                                          GtkStyleContext* ctx,
                                          cairo_t* cr,
                                          gint x,
                                          gint* y,
                                          gint width)
{
	PangoLayout* _tmp0_;
	gint title_height = 0;
	PangoLayout* _tmp1_;
	gint _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (cr != NULL);
	gtk_style_context_save (ctx);
	gtk_style_context_add_class (ctx, "h4");
	_tmp0_ = self->priv->title_text_layout;
	gtk_render_layout (ctx, cr, (gdouble) x, (gdouble) (*y), _tmp0_);
	gtk_style_context_restore (ctx);
	_tmp1_ = self->priv->title_text_layout;
	pango_layout_get_pixel_size (_tmp1_, NULL, &_tmp2_);
	title_height = _tmp2_;
	*y = (*y) + title_height;
}

static void
music_widgets_tile_renderer_render_subtitle (MusicWidgetsTileRenderer* self,
                                             GtkStyleContext* ctx,
                                             cairo_t* cr,
                                             gint x,
                                             gint y,
                                             gint width)
{
	PangoLayout* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = self->priv->subtitle_text_layout;
	gtk_render_layout (ctx, cr, (gdouble) x, (gdouble) y, _tmp0_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_widgets_tile_renderer_update_layout_properties (MusicWidgetsTileRenderer* self,
                                                      GtkWidget* widget)
{
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0U;
	gint scale = 0;
	MusicAlbum* _tmp2_;
	GdkPixbuf* _tmp3_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_ = {0};
	GtkBorder _tmp6_ = {0};
	MusicAlbum* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	PangoLayout* _tmp10_;
	PangoFontDescription* font_description = NULL;
	PangoFontDescription* _tmp11_ = NULL;
	PangoLayout* _tmp12_;
	PangoFontDescription* _tmp13_;
	PangoLayout* _tmp14_;
	PangoLayout* _tmp15_;
	gint text_width = 0;
	PangoLayout* _tmp16_;
	MusicAlbum* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	PangoLayout* _tmp20_;
	PangoFontDescription* _tmp21_ = NULL;
	PangoLayout* _tmp22_;
	PangoFontDescription* _tmp23_;
	PangoLayout* _tmp24_;
	PangoLayout* _tmp25_;
	PangoLayout* _tmp26_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = gtk_widget_get_style_context (widget);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	ctx = _tmp1_;
	state = gtk_style_context_get_state (ctx);
	scale = gtk_style_context_get_scale (ctx);
	_tmp2_ = self->priv->_album;
	_tmp3_ = music_album_get_cached_cover_pixbuf (_tmp2_, scale);
	_g_object_unref0 (self->priv->pixbuf);
	self->priv->pixbuf = _tmp3_;
	self->priv->border.left = (gint16) 12;
	self->priv->border.right = (gint16) 12;
	self->priv->border.bottom = (gint16) 12;
	self->priv->border.top = (gint16) 12;
	gtk_style_context_save (ctx);
	gtk_style_context_add_class (ctx, "album");
	_tmp4_ = self->priv->border;
	self->priv->margin = _tmp4_;
	gtk_style_context_get_padding (ctx, state, &_tmp5_);
	self->priv->padding = _tmp5_;
	gtk_style_context_get_border (ctx, state, &_tmp6_);
	self->priv->border = _tmp6_;
	gtk_style_context_restore (ctx);
	_tmp7_ = self->priv->_album;
	_tmp8_ = music_album_get_display_artist (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = gtk_widget_create_pango_layout (widget, _tmp9_);
	_g_object_unref0 (self->priv->subtitle_text_layout);
	self->priv->subtitle_text_layout = _tmp10_;
	_g_free0 (_tmp9_);
	gtk_style_context_get (ctx, state, GTK_STYLE_PROPERTY_FONT, &_tmp11_, NULL);
	font_description = _tmp11_;
	_tmp12_ = self->priv->subtitle_text_layout;
	_tmp13_ = font_description;
	pango_layout_set_font_description (_tmp12_, _tmp13_);
	_tmp14_ = self->priv->subtitle_text_layout;
	pango_layout_set_ellipsize (_tmp14_, PANGO_ELLIPSIZE_END);
	_tmp15_ = self->priv->subtitle_text_layout;
	pango_layout_set_alignment (_tmp15_, PANGO_ALIGN_LEFT);
	text_width = 128 * PANGO_SCALE;
	_tmp16_ = self->priv->subtitle_text_layout;
	pango_layout_set_width (_tmp16_, text_width);
	gtk_style_context_save (ctx);
	gtk_style_context_add_class (ctx, "h4");
	_tmp17_ = self->priv->_album;
	_tmp18_ = music_album_get_display_name (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = gtk_widget_create_pango_layout (widget, _tmp19_);
	_g_object_unref0 (self->priv->title_text_layout);
	self->priv->title_text_layout = _tmp20_;
	_g_free0 (_tmp19_);
	gtk_style_context_get (ctx, state, GTK_STYLE_PROPERTY_FONT, &_tmp21_, NULL);
	font_description = _tmp21_;
	_tmp22_ = self->priv->title_text_layout;
	_tmp23_ = font_description;
	pango_layout_set_font_description (_tmp22_, _tmp23_);
	_tmp24_ = self->priv->title_text_layout;
	pango_layout_set_width (_tmp24_, text_width);
	_tmp25_ = self->priv->title_text_layout;
	pango_layout_set_ellipsize (_tmp25_, PANGO_ELLIPSIZE_END);
	_tmp26_ = self->priv->title_text_layout;
	pango_layout_set_alignment (_tmp26_, PANGO_ALIGN_LEFT);
	gtk_style_context_restore (ctx);
	_g_object_unref0 (ctx);
}

static gint
music_widgets_tile_renderer_compute_total_image_width (MusicWidgetsTileRenderer* self)
{
	GtkBorder _tmp0_;
	GtkBorder _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->margin;
	_tmp1_ = self->priv->margin;
	result = (128 + _tmp0_.left) + _tmp1_.right;
	return result;
}

static gint
music_widgets_tile_renderer_compute_total_image_height (MusicWidgetsTileRenderer* self)
{
	GtkBorder _tmp0_;
	GtkBorder _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->margin;
	_tmp1_ = self->priv->margin;
	result = (128 + _tmp0_.top) + _tmp1_.bottom;
	return result;
}

MusicAlbum*
music_widgets_tile_renderer_get_album (MusicWidgetsTileRenderer* self)
{
	MusicAlbum* result;
	MusicAlbum* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_album;
	result = _tmp0_;
	return result;
}

void
music_widgets_tile_renderer_set_album (MusicWidgetsTileRenderer* self,
                                       MusicAlbum* value)
{
	MusicAlbum* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_widgets_tile_renderer_get_album (self);
	if (old_value != value) {
		MusicAlbum* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_album);
		self->priv->_album = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_widgets_tile_renderer_properties[MUSIC_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY]);
	}
}

static void
music_widgets_tile_renderer_class_init (MusicWidgetsTileRendererClass * klass,
                                        gpointer klass_data)
{
	music_widgets_tile_renderer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicWidgetsTileRenderer_private_offset);
	((GtkCellRendererClass *) klass)->get_size = (void (*) (GtkCellRenderer*, GtkWidget*, GdkRectangle*, gint*, gint*, gint*, gint*)) music_widgets_tile_renderer_real_get_size;
	((GtkCellRendererClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkCellRenderer*)) music_widgets_tile_renderer_real_get_request_mode;
	((GtkCellRendererClass *) klass)->get_preferred_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint*, gint*)) music_widgets_tile_renderer_real_get_preferred_width;
	((GtkCellRendererClass *) klass)->get_preferred_height_for_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint, gint*, gint*)) music_widgets_tile_renderer_real_get_preferred_height_for_width;
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer*, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) music_widgets_tile_renderer_real_render;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_widgets_tile_renderer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_widgets_tile_renderer_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_widgets_tile_renderer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY, music_widgets_tile_renderer_properties[MUSIC_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY] = g_param_spec_object ("album", "album", "album", MUSIC_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_widgets_tile_renderer_instance_init (MusicWidgetsTileRenderer * self,
                                           gpointer klass)
{
	self->priv = music_widgets_tile_renderer_get_instance_private (self);
}

static void
music_widgets_tile_renderer_finalize (GObject * obj)
{
	MusicWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRenderer);
	_g_object_unref0 (self->priv->_album);
	_g_object_unref0 (self->priv->title_text_layout);
	_g_object_unref0 (self->priv->subtitle_text_layout);
	_g_object_unref0 (self->priv->pixbuf);
	G_OBJECT_CLASS (music_widgets_tile_renderer_parent_class)->finalize (obj);
}

static GType
music_widgets_tile_renderer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicWidgetsTileRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_widgets_tile_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicWidgetsTileRenderer), 0, (GInstanceInitFunc) music_widgets_tile_renderer_instance_init, NULL };
	GType music_widgets_tile_renderer_type_id;
	music_widgets_tile_renderer_type_id = g_type_register_static (gtk_cell_renderer_get_type (), "MusicWidgetsTileRenderer", &g_define_type_info, 0);
	MusicWidgetsTileRenderer_private_offset = g_type_add_instance_private (music_widgets_tile_renderer_type_id, sizeof (MusicWidgetsTileRendererPrivate));
	return music_widgets_tile_renderer_type_id;
}

GType
music_widgets_tile_renderer_get_type (void)
{
	static volatile gsize music_widgets_tile_renderer_type_id__once = 0;
	if (g_once_init_enter (&music_widgets_tile_renderer_type_id__once)) {
		GType music_widgets_tile_renderer_type_id;
		music_widgets_tile_renderer_type_id = music_widgets_tile_renderer_get_type_once ();
		g_once_init_leave (&music_widgets_tile_renderer_type_id__once, music_widgets_tile_renderer_type_id);
	}
	return music_widgets_tile_renderer_type_id__once;
}

static void
_vala_music_widgets_tile_renderer_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	MusicWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRenderer);
	switch (property_id) {
		case MUSIC_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY:
		g_value_set_object (value, music_widgets_tile_renderer_get_album (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_widgets_tile_renderer_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	MusicWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_WIDGETS_TYPE_TILE_RENDERER, MusicWidgetsTileRenderer);
	switch (property_id) {
		case MUSIC_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY:
		music_widgets_tile_renderer_set_album (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

