/* MediaEditor.c generated by valac 0.55.1, the Vala compiler
 * generated from MediaEditor.vala, do not modify */

/*-
 * Copyright (c) 2012-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "music-lib.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

#define MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY (music_media_editor_activates_default_entry_get_type ())
#define MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY, MusicMediaEditorActivatesDefaultEntry))
#define MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY, MusicMediaEditorActivatesDefaultEntryClass))
#define MUSIC_MEDIA_EDITOR_IS_ACTIVATES_DEFAULT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY))
#define MUSIC_MEDIA_EDITOR_IS_ACTIVATES_DEFAULT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY))
#define MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY, MusicMediaEditorActivatesDefaultEntryClass))

typedef struct _MusicMediaEditorActivatesDefaultEntry MusicMediaEditorActivatesDefaultEntry;
typedef struct _MusicMediaEditorActivatesDefaultEntryClass MusicMediaEditorActivatesDefaultEntryClass;
enum  {
	MUSIC_MEDIA_EDITOR_0_PROPERTY,
	MUSIC_MEDIA_EDITOR_NUM_PROPERTIES
};
static GParamSpec* music_media_editor_properties[MUSIC_MEDIA_EDITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicMediaEditorActivatesDefaultEntryPrivate MusicMediaEditorActivatesDefaultEntryPrivate;
enum  {
	MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_0_PROPERTY,
	MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_NUM_PROPERTIES
};
static GParamSpec* music_media_editor_activates_default_entry_properties[MUSIC_MEDIA_EDITOR_ACTIVATES_DEFAULT_ENTRY_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _MusicMediaEditorPrivate {
	MusicMediaEditorActivatesDefaultEntry* title_entry;
	MusicMediaEditorActivatesDefaultEntry* artist_entry;
	MusicMediaEditorActivatesDefaultEntry* album_artist_entry;
	MusicMediaEditorActivatesDefaultEntry* album_entry;
	MusicMediaEditorActivatesDefaultEntry* genre_entry;
	MusicMediaEditorActivatesDefaultEntry* composer_entry;
	MusicMediaEditorActivatesDefaultEntry* grouping_entry;
	GtkTextView* comment_textview;
	GtkScrolledWindow* comment_scrolledwindow;
	GtkSpinButton* track_spinbutton;
	GtkSpinButton* disk_spinbutton;
	GtkSpinButton* year_spinbutton;
	MusicRatingWidget* rating_widget;
	GtkButton* previous_button;
	GtkButton* next_button;
	GeeTreeSet* media_list;
	GeeHashMap* temp_list;
	MusicMedia* current_media;
};

struct _MusicMediaEditorActivatesDefaultEntry {
	GtkEntry parent_instance;
	MusicMediaEditorActivatesDefaultEntryPrivate * priv;
};

struct _MusicMediaEditorActivatesDefaultEntryClass {
	GtkEntryClass parent_class;
};

static gint MusicMediaEditor_private_offset;
static gpointer music_media_editor_parent_class = NULL;
static gpointer music_media_editor_activates_default_entry_parent_class = NULL;

static GType music_media_editor_activates_default_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void music_media_editor_set_media (MusicMediaEditor* self,
                                   MusicMedia* m);
static void music_media_editor_previous_track (MusicMediaEditor* self);
static void music_media_editor_save_track (MusicMediaEditor* self);
static void music_media_editor_next_track (MusicMediaEditor* self);
static void music_media_editor_save_and_exit (MusicMediaEditor* self);
static MusicMediaEditorActivatesDefaultEntry* music_media_editor_activates_default_entry_new (void);
static MusicMediaEditorActivatesDefaultEntry* music_media_editor_activates_default_entry_construct (GType object_type);
static GObject * music_media_editor_activates_default_entry_constructor (GType type,
                                                                  guint n_construct_properties,
                                                                  GObjectConstructParam * construct_properties);
static GType music_media_editor_activates_default_entry_get_type_once (void);
static GObject * music_media_editor_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static guint _music_media_editor___lambda47_ (MusicMediaEditor* self,
                                       gint64* x);
static guint __music_media_editor___lambda47__gee_hash_data_func (gconstpointer v,
                                                           gpointer self);
static gboolean _music_media_editor___lambda48_ (MusicMediaEditor* self,
                                          gint64* a,
                                          gint64* b);
static gboolean __music_media_editor___lambda48__gee_equal_data_func (gconstpointer a,
                                                               gconstpointer b,
                                                               gpointer self);
static gint64* _int64_dup (gint64* self);
static void _music_media_editor_previous_track_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void _music_media_editor_next_track_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _music_media_editor___lambda49_ (MusicMediaEditor* self,
                                      gint response_id);
static void __music_media_editor___lambda49__gtk_dialog_response (GtkDialog* _sender,
                                                           gint response_id,
                                                           gpointer self);
static void music_media_editor_finalize (GObject * obj);
static GType music_media_editor_get_type_once (void);

static inline gpointer
music_media_editor_get_instance_private (MusicMediaEditor* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMediaEditor_private_offset);
}

MusicMediaEditor*
music_media_editor_construct (GType object_type,
                              GeeTreeSet* given_media)
{
	MusicMediaEditor * self = NULL;
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp3_;
	gpointer _tmp4_;
	MusicMedia* _tmp5_;
	g_return_val_if_fail (given_media != NULL, NULL);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	self = (MusicMediaEditor*) g_object_new (object_type, "deletable", FALSE, "destroy-with-parent", TRUE, "height-request", 400, "resizable", TRUE, "transient-for", _tmp1_, "width-request", 600, "window-position", GTK_WIN_POS_CENTER_ON_PARENT, NULL);
	_tmp2_ = self->priv->media_list;
	gee_collection_add_all ((GeeCollection*) _tmp2_, (GeeCollection*) given_media);
	_tmp3_ = self->priv->media_list;
	_tmp4_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp3_);
	_tmp5_ = (MusicMedia*) _tmp4_;
	music_media_editor_set_media (self, _tmp5_);
	_g_object_unref0 (_tmp5_);
	return self;
}

MusicMediaEditor*
music_media_editor_new (GeeTreeSet* given_media)
{
	return music_media_editor_construct (MUSIC_TYPE_MEDIA_EDITOR, given_media);
}

static void
music_media_editor_previous_track (MusicMediaEditor* self)
{
	GeeBidirIterator* iterator = NULL;
	GeeTreeSet* _tmp0_;
	MusicMedia* _tmp1_;
	GeeIterator* _tmp2_;
	GeeBidirIterator* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->media_list;
	_tmp1_ = self->priv->current_media;
	_tmp2_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp0_, _tmp1_);
	iterator = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_BIDIR_ITERATOR, GeeBidirIterator);
	_tmp3_ = iterator;
	if (gee_bidir_iterator_has_previous (_tmp3_)) {
		GeeBidirIterator* _tmp4_;
		GeeBidirIterator* _tmp5_;
		gpointer _tmp6_;
		MusicMedia* _tmp7_;
		music_media_editor_save_track (self);
		_tmp4_ = iterator;
		gee_bidir_iterator_previous (_tmp4_);
		_tmp5_ = iterator;
		_tmp6_ = gee_iterator_get ((GeeIterator*) _tmp5_);
		_tmp7_ = (MusicMedia*) _tmp6_;
		music_media_editor_set_media (self, _tmp7_);
		_g_object_unref0 (_tmp7_);
	} else {
		GtkButton* _tmp8_;
		_tmp8_ = self->priv->previous_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
	}
	_g_object_unref0 (iterator);
}

static void
music_media_editor_next_track (MusicMediaEditor* self)
{
	GeeIterator* iterator = NULL;
	GeeTreeSet* _tmp0_;
	MusicMedia* _tmp1_;
	GeeIterator* _tmp2_;
	GeeIterator* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->media_list;
	_tmp1_ = self->priv->current_media;
	_tmp2_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp0_, _tmp1_);
	iterator = _tmp2_;
	_tmp3_ = iterator;
	if (gee_iterator_has_next (_tmp3_)) {
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		gpointer _tmp6_;
		MusicMedia* _tmp7_;
		music_media_editor_save_track (self);
		_tmp4_ = iterator;
		gee_iterator_next (_tmp4_);
		_tmp5_ = iterator;
		_tmp6_ = gee_iterator_get (_tmp5_);
		_tmp7_ = (MusicMedia*) _tmp6_;
		music_media_editor_set_media (self, _tmp7_);
		_g_object_unref0 (_tmp7_);
	} else {
		GtkButton* _tmp8_;
		_tmp8_ = self->priv->next_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
	}
	_g_object_unref0 (iterator);
}

static void
music_media_editor_save_track (MusicMediaEditor* self)
{
	MusicMedia* m = NULL;
	MusicMedia* _tmp0_;
	MusicMedia* _tmp1_;
	MusicMediaEditorActivatesDefaultEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	MusicMediaEditorActivatesDefaultEntry* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	MusicMediaEditorActivatesDefaultEntry* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	MusicMediaEditorActivatesDefaultEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	MusicMediaEditorActivatesDefaultEntry* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	MusicMediaEditorActivatesDefaultEntry* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	MusicMediaEditorActivatesDefaultEntry* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GtkTextView* _tmp23_;
	GtkTextBuffer* _tmp24_;
	GtkTextBuffer* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkSpinButton* _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	GtkSpinButton* _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	GtkSpinButton* _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	MusicRatingWidget* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	GeeHashMap* _tmp41_;
	MusicMedia* _tmp42_;
	gint64 _tmp43_;
	gint64 _tmp44_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->current_media;
	_tmp1_ = music_media_copy (_tmp0_);
	m = _tmp1_;
	_tmp2_ = self->priv->title_entry;
	_tmp3_ = gtk_entry_get_text ((GtkEntry*) _tmp2_);
	_tmp4_ = _tmp3_;
	music_media_set_title (m, _tmp4_);
	_tmp5_ = self->priv->artist_entry;
	_tmp6_ = gtk_entry_get_text ((GtkEntry*) _tmp5_);
	_tmp7_ = _tmp6_;
	music_media_set_artist (m, _tmp7_);
	_tmp8_ = self->priv->album_artist_entry;
	_tmp9_ = gtk_entry_get_text ((GtkEntry*) _tmp8_);
	_tmp10_ = _tmp9_;
	music_media_set_album_artist (m, _tmp10_);
	_tmp11_ = self->priv->album_entry;
	_tmp12_ = gtk_entry_get_text ((GtkEntry*) _tmp11_);
	_tmp13_ = _tmp12_;
	music_media_set_album (m, _tmp13_);
	_tmp14_ = self->priv->genre_entry;
	_tmp15_ = gtk_entry_get_text ((GtkEntry*) _tmp14_);
	_tmp16_ = _tmp15_;
	music_media_set_genre (m, _tmp16_);
	_tmp17_ = self->priv->composer_entry;
	_tmp18_ = gtk_entry_get_text ((GtkEntry*) _tmp17_);
	_tmp19_ = _tmp18_;
	music_media_set_composer (m, _tmp19_);
	_tmp20_ = self->priv->grouping_entry;
	_tmp21_ = gtk_entry_get_text ((GtkEntry*) _tmp20_);
	_tmp22_ = _tmp21_;
	music_media_set_grouping (m, _tmp22_);
	_tmp23_ = self->priv->comment_textview;
	_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
	_tmp25_ = _tmp24_;
	g_object_get (_tmp25_, "text", &_tmp26_, NULL);
	_tmp27_ = _tmp26_;
	_tmp28_ = _tmp27_;
	music_media_set_comment (m, _tmp28_);
	_g_free0 (_tmp28_);
	_tmp29_ = self->priv->track_spinbutton;
	_tmp30_ = gtk_spin_button_get_value (_tmp29_);
	_tmp31_ = _tmp30_;
	music_media_set_track (m, (guint) ((gint) _tmp31_));
	_tmp32_ = self->priv->disk_spinbutton;
	_tmp33_ = gtk_spin_button_get_value (_tmp32_);
	_tmp34_ = _tmp33_;
	music_media_set_album_number (m, (guint) ((gint) _tmp34_));
	_tmp35_ = self->priv->year_spinbutton;
	_tmp36_ = gtk_spin_button_get_value (_tmp35_);
	_tmp37_ = _tmp36_;
	music_media_set_year (m, (guint) ((gint) _tmp37_));
	_tmp38_ = self->priv->rating_widget;
	_tmp39_ = music_rating_widget_get_rating (_tmp38_);
	_tmp40_ = _tmp39_;
	music_media_set_rating (m, (guint) _tmp40_);
	_tmp41_ = self->priv->temp_list;
	_tmp42_ = self->priv->current_media;
	_tmp43_ = music_media_get_rowid (_tmp42_);
	_tmp44_ = _tmp43_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, &_tmp44_, m);
	_g_object_unref0 (m);
}

static void
music_media_editor_save_and_exit (MusicMediaEditor* self)
{
	GeeTreeSet* _tmp62_;
	GeeHashMap* _tmp63_;
	g_return_if_fail (self != NULL);
	music_media_editor_save_track (self);
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
		_tmp0_ = self->priv->media_list;
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
		_m_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeHashMap* _tmp5_;
			MusicMedia* _tmp6_;
			gint64 _tmp7_;
			gint64 _tmp8_;
			_tmp2_ = _m_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _m_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			m = (MusicMedia*) _tmp4_;
			_tmp5_ = self->priv->temp_list;
			_tmp6_ = m;
			_tmp7_ = music_media_get_rowid (_tmp6_);
			_tmp8_ = _tmp7_;
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, &_tmp8_)) {
				MusicMedia* copy = NULL;
				GeeHashMap* _tmp9_;
				MusicMedia* _tmp10_;
				gint64 _tmp11_;
				gint64 _tmp12_;
				gpointer _tmp13_;
				MusicMedia* _tmp14_;
				MusicMedia* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				MusicMedia* _tmp18_;
				MusicMedia* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				MusicMedia* _tmp22_;
				MusicMedia* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				MusicMedia* _tmp26_;
				MusicMedia* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				MusicMedia* _tmp30_;
				MusicMedia* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				MusicMedia* _tmp34_;
				MusicMedia* _tmp35_;
				const gchar* _tmp36_;
				const gchar* _tmp37_;
				MusicMedia* _tmp38_;
				MusicMedia* _tmp39_;
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				MusicMedia* _tmp42_;
				MusicMedia* _tmp43_;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				MusicMedia* _tmp46_;
				MusicMedia* _tmp47_;
				guint _tmp48_;
				guint _tmp49_;
				MusicMedia* _tmp50_;
				MusicMedia* _tmp51_;
				guint _tmp52_;
				guint _tmp53_;
				MusicMedia* _tmp54_;
				MusicMedia* _tmp55_;
				guint _tmp56_;
				guint _tmp57_;
				MusicMedia* _tmp58_;
				MusicMedia* _tmp59_;
				guint _tmp60_;
				guint _tmp61_;
				_tmp9_ = self->priv->temp_list;
				_tmp10_ = m;
				_tmp11_ = music_media_get_rowid (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, &_tmp12_);
				copy = (MusicMedia*) _tmp13_;
				_tmp14_ = m;
				_tmp15_ = copy;
				_tmp16_ = music_media_get_title (_tmp15_);
				_tmp17_ = _tmp16_;
				music_media_set_title (_tmp14_, _tmp17_);
				_tmp18_ = m;
				_tmp19_ = copy;
				_tmp20_ = music_media_get_artist (_tmp19_);
				_tmp21_ = _tmp20_;
				music_media_set_artist (_tmp18_, _tmp21_);
				_tmp22_ = m;
				_tmp23_ = copy;
				_tmp24_ = music_media_get_album_artist (_tmp23_);
				_tmp25_ = _tmp24_;
				music_media_set_album_artist (_tmp22_, _tmp25_);
				_tmp26_ = m;
				_tmp27_ = copy;
				_tmp28_ = music_media_get_album (_tmp27_);
				_tmp29_ = _tmp28_;
				music_media_set_album (_tmp26_, _tmp29_);
				_tmp30_ = m;
				_tmp31_ = copy;
				_tmp32_ = music_media_get_genre (_tmp31_);
				_tmp33_ = _tmp32_;
				music_media_set_genre (_tmp30_, _tmp33_);
				_tmp34_ = m;
				_tmp35_ = copy;
				_tmp36_ = music_media_get_composer (_tmp35_);
				_tmp37_ = _tmp36_;
				music_media_set_composer (_tmp34_, _tmp37_);
				_tmp38_ = m;
				_tmp39_ = copy;
				_tmp40_ = music_media_get_grouping (_tmp39_);
				_tmp41_ = _tmp40_;
				music_media_set_grouping (_tmp38_, _tmp41_);
				_tmp42_ = m;
				_tmp43_ = copy;
				_tmp44_ = music_media_get_comment (_tmp43_);
				_tmp45_ = _tmp44_;
				music_media_set_comment (_tmp42_, _tmp45_);
				_tmp46_ = m;
				_tmp47_ = copy;
				_tmp48_ = music_media_get_track (_tmp47_);
				_tmp49_ = _tmp48_;
				music_media_set_track (_tmp46_, _tmp49_);
				_tmp50_ = m;
				_tmp51_ = copy;
				_tmp52_ = music_media_get_album_number (_tmp51_);
				_tmp53_ = _tmp52_;
				music_media_set_album_number (_tmp50_, _tmp53_);
				_tmp54_ = m;
				_tmp55_ = copy;
				_tmp56_ = music_media_get_year (_tmp55_);
				_tmp57_ = _tmp56_;
				music_media_set_year (_tmp54_, _tmp57_);
				_tmp58_ = m;
				_tmp59_ = copy;
				_tmp60_ = music_media_get_rating (_tmp59_);
				_tmp61_ = _tmp60_;
				music_media_set_rating (_tmp58_, _tmp61_);
				_g_object_unref0 (copy);
			}
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp62_ = self->priv->media_list;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp62_);
	_g_object_unref0 (self->priv->current_media);
	self->priv->current_media = NULL;
	_tmp63_ = self->priv->temp_list;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp63_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_media_editor_set_media (MusicMediaEditor* self,
                              MusicMedia* m)
{
	MusicMedia* _tmp0_;
	MusicMedia* considered_media = NULL;
	MusicMedia* _tmp1_;
	MusicMedia* _tmp2_;
	GeeHashMap* _tmp3_;
	MusicMedia* _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	MusicMediaEditorActivatesDefaultEntry* _tmp12_;
	MusicMedia* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	MusicMediaEditorActivatesDefaultEntry* _tmp16_;
	MusicMedia* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	MusicMediaEditorActivatesDefaultEntry* _tmp20_;
	MusicMedia* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	MusicMediaEditorActivatesDefaultEntry* _tmp24_;
	MusicMedia* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	MusicMediaEditorActivatesDefaultEntry* _tmp28_;
	MusicMedia* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	MusicMediaEditorActivatesDefaultEntry* _tmp32_;
	MusicMedia* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	MusicMediaEditorActivatesDefaultEntry* _tmp36_;
	MusicMedia* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	GtkTextView* _tmp40_;
	GtkTextBuffer* _tmp41_;
	GtkTextBuffer* _tmp42_;
	MusicMedia* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	GtkSpinButton* _tmp46_;
	MusicMedia* _tmp47_;
	guint _tmp48_;
	guint _tmp49_;
	GtkSpinButton* _tmp50_;
	MusicMedia* _tmp51_;
	guint _tmp52_;
	guint _tmp53_;
	GtkSpinButton* _tmp54_;
	MusicMedia* _tmp55_;
	guint _tmp56_;
	guint _tmp57_;
	MusicRatingWidget* _tmp58_;
	MusicMedia* _tmp59_;
	guint _tmp60_;
	guint _tmp61_;
	GeeBidirIterator* iterator = NULL;
	GeeTreeSet* _tmp62_;
	MusicMedia* _tmp63_;
	GeeIterator* _tmp64_;
	GtkButton* _tmp65_;
	GtkButton* _tmp66_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = _g_object_ref0 (m);
	_g_object_unref0 (self->priv->current_media);
	self->priv->current_media = _tmp0_;
	_tmp1_ = self->priv->current_media;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	considered_media = _tmp2_;
	_tmp3_ = self->priv->temp_list;
	_tmp4_ = self->priv->current_media;
	_tmp5_ = music_media_get_rowid (_tmp4_);
	_tmp6_ = _tmp5_;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, &_tmp6_)) {
		GeeHashMap* _tmp7_;
		MusicMedia* _tmp8_;
		gint64 _tmp9_;
		gint64 _tmp10_;
		gpointer _tmp11_;
		_tmp7_ = self->priv->temp_list;
		_tmp8_ = self->priv->current_media;
		_tmp9_ = music_media_get_rowid (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, &_tmp10_);
		_g_object_unref0 (considered_media);
		considered_media = (MusicMedia*) _tmp11_;
	}
	_tmp12_ = self->priv->title_entry;
	_tmp13_ = considered_media;
	_tmp14_ = music_media_get_title (_tmp13_);
	_tmp15_ = _tmp14_;
	gtk_entry_set_text ((GtkEntry*) _tmp12_, _tmp15_);
	_tmp16_ = self->priv->artist_entry;
	_tmp17_ = considered_media;
	_tmp18_ = music_media_get_artist (_tmp17_);
	_tmp19_ = _tmp18_;
	gtk_entry_set_text ((GtkEntry*) _tmp16_, _tmp19_);
	_tmp20_ = self->priv->album_artist_entry;
	_tmp21_ = considered_media;
	_tmp22_ = music_media_get_album_artist (_tmp21_);
	_tmp23_ = _tmp22_;
	gtk_entry_set_text ((GtkEntry*) _tmp20_, _tmp23_);
	_tmp24_ = self->priv->album_entry;
	_tmp25_ = considered_media;
	_tmp26_ = music_media_get_album (_tmp25_);
	_tmp27_ = _tmp26_;
	gtk_entry_set_text ((GtkEntry*) _tmp24_, _tmp27_);
	_tmp28_ = self->priv->genre_entry;
	_tmp29_ = considered_media;
	_tmp30_ = music_media_get_genre (_tmp29_);
	_tmp31_ = _tmp30_;
	gtk_entry_set_text ((GtkEntry*) _tmp28_, _tmp31_);
	_tmp32_ = self->priv->composer_entry;
	_tmp33_ = considered_media;
	_tmp34_ = music_media_get_composer (_tmp33_);
	_tmp35_ = _tmp34_;
	gtk_entry_set_text ((GtkEntry*) _tmp32_, _tmp35_);
	_tmp36_ = self->priv->grouping_entry;
	_tmp37_ = considered_media;
	_tmp38_ = music_media_get_grouping (_tmp37_);
	_tmp39_ = _tmp38_;
	gtk_entry_set_text ((GtkEntry*) _tmp36_, _tmp39_);
	_tmp40_ = self->priv->comment_textview;
	_tmp41_ = gtk_text_view_get_buffer (_tmp40_);
	_tmp42_ = _tmp41_;
	_tmp43_ = considered_media;
	_tmp44_ = music_media_get_comment (_tmp43_);
	_tmp45_ = _tmp44_;
	g_object_set (_tmp42_, "text", _tmp45_, NULL);
	_tmp46_ = self->priv->track_spinbutton;
	_tmp47_ = considered_media;
	_tmp48_ = music_media_get_track (_tmp47_);
	_tmp49_ = _tmp48_;
	gtk_spin_button_set_value (_tmp46_, (gdouble) _tmp49_);
	_tmp50_ = self->priv->disk_spinbutton;
	_tmp51_ = considered_media;
	_tmp52_ = music_media_get_album_number (_tmp51_);
	_tmp53_ = _tmp52_;
	gtk_spin_button_set_value (_tmp50_, (gdouble) _tmp53_);
	_tmp54_ = self->priv->year_spinbutton;
	_tmp55_ = considered_media;
	_tmp56_ = music_media_get_year (_tmp55_);
	_tmp57_ = _tmp56_;
	gtk_spin_button_set_value (_tmp54_, (gdouble) _tmp57_);
	_tmp58_ = self->priv->rating_widget;
	_tmp59_ = considered_media;
	_tmp60_ = music_media_get_rating (_tmp59_);
	_tmp61_ = _tmp60_;
	music_rating_widget_set_rating (_tmp58_, (gint) _tmp61_);
	_tmp62_ = self->priv->media_list;
	_tmp63_ = self->priv->current_media;
	_tmp64_ = gee_abstract_sorted_set_iterator_at ((GeeAbstractSortedSet*) _tmp62_, _tmp63_);
	iterator = G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, GEE_TYPE_BIDIR_ITERATOR, GeeBidirIterator);
	_tmp65_ = self->priv->previous_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp65_, gee_bidir_iterator_has_previous (iterator));
	_tmp66_ = self->priv->next_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp66_, gee_iterator_has_next ((GeeIterator*) iterator));
	_g_object_unref0 (iterator);
	_g_object_unref0 (considered_media);
}

static MusicMediaEditorActivatesDefaultEntry*
music_media_editor_activates_default_entry_construct (GType object_type)
{
	MusicMediaEditorActivatesDefaultEntry * self = NULL;
	self = (MusicMediaEditorActivatesDefaultEntry*) g_object_new (object_type, NULL);
	return self;
}

static MusicMediaEditorActivatesDefaultEntry*
music_media_editor_activates_default_entry_new (void)
{
	return music_media_editor_activates_default_entry_construct (MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY);
}

static GObject *
music_media_editor_activates_default_entry_constructor (GType type,
                                                        guint n_construct_properties,
                                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMediaEditorActivatesDefaultEntry * self;
	parent_class = G_OBJECT_CLASS (music_media_editor_activates_default_entry_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_MEDIA_EDITOR_TYPE_ACTIVATES_DEFAULT_ENTRY, MusicMediaEditorActivatesDefaultEntry);
	gtk_entry_set_activates_default ((GtkEntry*) self, TRUE);
	return obj;
}

static void
music_media_editor_activates_default_entry_class_init (MusicMediaEditorActivatesDefaultEntryClass * klass,
                                                       gpointer klass_data)
{
	music_media_editor_activates_default_entry_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = music_media_editor_activates_default_entry_constructor;
}

static void
music_media_editor_activates_default_entry_instance_init (MusicMediaEditorActivatesDefaultEntry * self,
                                                          gpointer klass)
{
}

static GType
music_media_editor_activates_default_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaEditorActivatesDefaultEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_editor_activates_default_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMediaEditorActivatesDefaultEntry), 0, (GInstanceInitFunc) music_media_editor_activates_default_entry_instance_init, NULL };
	GType music_media_editor_activates_default_entry_type_id;
	music_media_editor_activates_default_entry_type_id = g_type_register_static (gtk_entry_get_type (), "MusicMediaEditorActivatesDefaultEntry", &g_define_type_info, 0);
	return music_media_editor_activates_default_entry_type_id;
}

static GType
music_media_editor_activates_default_entry_get_type (void)
{
	static volatile gsize music_media_editor_activates_default_entry_type_id__once = 0;
	if (g_once_init_enter (&music_media_editor_activates_default_entry_type_id__once)) {
		GType music_media_editor_activates_default_entry_type_id;
		music_media_editor_activates_default_entry_type_id = music_media_editor_activates_default_entry_get_type_once ();
		g_once_init_leave (&music_media_editor_activates_default_entry_type_id__once, music_media_editor_activates_default_entry_type_id);
	}
	return music_media_editor_activates_default_entry_type_id__once;
}

static guint
_music_media_editor___lambda47_ (MusicMediaEditor* self,
                                 gint64* x)
{
	GHashFunc _tmp0_;
	guint result;
	_tmp0_ = g_int64_hash;
	result = _tmp0_ (x);
	return result;
}

static guint
__music_media_editor___lambda47__gee_hash_data_func (gconstpointer v,
                                                     gpointer self)
{
	guint result;
	result = _music_media_editor___lambda47_ ((MusicMediaEditor*) self, (gint64*) v);
	return result;
}

static gboolean
_music_media_editor___lambda48_ (MusicMediaEditor* self,
                                 gint64* a,
                                 gint64* b)
{
	GEqualFunc _tmp0_;
	_tmp0_ = g_int64_equal;
	_tmp0_ (a, b);
}

static gboolean
__music_media_editor___lambda48__gee_equal_data_func (gconstpointer a,
                                                      gconstpointer b,
                                                      gpointer self)
{
	gboolean result;
	result = _music_media_editor___lambda48_ ((MusicMediaEditor*) self, (gint64*) a, (gint64*) b);
	return result;
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}

static void
_music_media_editor_previous_track_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	music_media_editor_previous_track ((MusicMediaEditor*) self);
}

static void
_music_media_editor_next_track_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	music_media_editor_next_track ((MusicMediaEditor*) self);
}

static void
_music_media_editor___lambda49_ (MusicMediaEditor* self,
                                 gint response_id)
{
	if (response_id == ((gint) GTK_RESPONSE_APPLY)) {
		music_media_editor_save_and_exit (self);
	}
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
__music_media_editor___lambda49__gtk_dialog_response (GtkDialog* _sender,
                                                      gint response_id,
                                                      gpointer self)
{
	_music_media_editor___lambda49_ ((MusicMediaEditor*) self, response_id);
}

static GObject *
music_media_editor_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicMediaEditor * self;
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	MusicMediaEditorActivatesDefaultEntry* _tmp2_;
	MusicMediaEditorActivatesDefaultEntry* _tmp3_;
	MusicMediaEditorActivatesDefaultEntry* _tmp4_;
	MusicMediaEditorActivatesDefaultEntry* _tmp5_;
	MusicMediaEditorActivatesDefaultEntry* _tmp6_;
	MusicMediaEditorActivatesDefaultEntry* _tmp7_;
	MusicMediaEditorActivatesDefaultEntry* _tmp8_;
	GtkTextView* _tmp9_;
	GtkTextView* _tmp10_;
	GtkScrolledWindow* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	GtkTextView* _tmp14_;
	GtkSpinButton* _tmp15_;
	GtkSpinButton* _tmp16_;
	GDateTime* local_time = NULL;
	GDateTime* _tmp17_;
	GDateTime* _tmp18_;
	GtkSpinButton* _tmp19_;
	MusicRatingWidget* _tmp20_;
	MusicRatingWidget* _tmp21_;
	GtkFrame* comment_frame = NULL;
	GtkFrame* _tmp22_;
	GtkFrame* _tmp23_;
	GtkFrame* _tmp24_;
	GtkScrolledWindow* _tmp25_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp26_;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	GtkGrid* _tmp29_;
	GtkGrid* _tmp30_;
	GtkGrid* _tmp31_;
	GraniteHeaderLabel* _tmp32_;
	GraniteHeaderLabel* _tmp33_;
	GtkGrid* _tmp34_;
	MusicMediaEditorActivatesDefaultEntry* _tmp35_;
	GtkGrid* _tmp36_;
	GraniteHeaderLabel* _tmp37_;
	GraniteHeaderLabel* _tmp38_;
	GtkGrid* _tmp39_;
	MusicMediaEditorActivatesDefaultEntry* _tmp40_;
	GtkGrid* _tmp41_;
	GraniteHeaderLabel* _tmp42_;
	GraniteHeaderLabel* _tmp43_;
	GtkGrid* _tmp44_;
	MusicMediaEditorActivatesDefaultEntry* _tmp45_;
	GtkGrid* _tmp46_;
	GraniteHeaderLabel* _tmp47_;
	GraniteHeaderLabel* _tmp48_;
	GtkGrid* _tmp49_;
	MusicMediaEditorActivatesDefaultEntry* _tmp50_;
	GtkGrid* _tmp51_;
	GraniteHeaderLabel* _tmp52_;
	GraniteHeaderLabel* _tmp53_;
	GtkGrid* _tmp54_;
	MusicMediaEditorActivatesDefaultEntry* _tmp55_;
	GtkGrid* _tmp56_;
	GraniteHeaderLabel* _tmp57_;
	GraniteHeaderLabel* _tmp58_;
	GtkGrid* _tmp59_;
	MusicMediaEditorActivatesDefaultEntry* _tmp60_;
	GtkGrid* _tmp61_;
	GraniteHeaderLabel* _tmp62_;
	GraniteHeaderLabel* _tmp63_;
	GtkGrid* _tmp64_;
	MusicMediaEditorActivatesDefaultEntry* _tmp65_;
	GtkGrid* _tmp66_;
	GraniteHeaderLabel* _tmp67_;
	GraniteHeaderLabel* _tmp68_;
	GtkGrid* _tmp69_;
	GtkSpinButton* _tmp70_;
	GtkGrid* _tmp71_;
	GraniteHeaderLabel* _tmp72_;
	GraniteHeaderLabel* _tmp73_;
	GtkGrid* _tmp74_;
	GtkSpinButton* _tmp75_;
	GtkGrid* _tmp76_;
	GraniteHeaderLabel* _tmp77_;
	GraniteHeaderLabel* _tmp78_;
	GtkGrid* _tmp79_;
	GtkSpinButton* _tmp80_;
	GtkGrid* _tmp81_;
	GraniteHeaderLabel* _tmp82_;
	GraniteHeaderLabel* _tmp83_;
	GtkGrid* _tmp84_;
	MusicRatingWidget* _tmp85_;
	GtkGrid* _tmp86_;
	GraniteHeaderLabel* _tmp87_;
	GraniteHeaderLabel* _tmp88_;
	GtkGrid* _tmp89_;
	GtkFrame* _tmp90_;
	GtkBox* _tmp91_;
	GtkGrid* _tmp92_;
	GtkButton* _tmp93_;
	GtkButton* _tmp94_;
	GtkGrid* arrows_grid = NULL;
	GtkGrid* _tmp95_;
	GtkGrid* _tmp96_;
	GtkStyleContext* _tmp97_;
	GtkGrid* _tmp98_;
	GtkButton* _tmp99_;
	GtkGrid* _tmp100_;
	GtkButton* _tmp101_;
	GtkButton* save_button = NULL;
	GtkWidget* _tmp102_;
	GtkButton* _tmp103_;
	GtkButton* _tmp104_;
	GtkButton* _tmp105_;
	GtkStyleContext* _tmp106_;
	GtkButtonBox* action_area = NULL;
	GtkBox* _tmp107_;
	GtkButtonBox* _tmp108_;
	GtkButtonBox* _tmp109_;
	GtkButtonBox* _tmp110_;
	GtkButtonBox* _tmp111_;
	GtkGrid* _tmp112_;
	GtkButtonBox* _tmp113_;
	GtkGrid* _tmp114_;
	GtkButtonBox* _tmp115_;
	GtkGrid* _tmp116_;
	GtkButton* _tmp117_;
	GtkButton* _tmp118_;
	parent_class = G_OBJECT_CLASS (music_media_editor_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_EDITOR, MusicMediaEditor);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->media_list);
	self->priv->media_list = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, __music_media_editor___lambda47__gee_hash_data_func, g_object_ref (self), g_object_unref, __music_media_editor___lambda48__gee_equal_data_func, g_object_ref (self), g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->temp_list);
	self->priv->temp_list = _tmp1_;
	_tmp2_ = music_media_editor_activates_default_entry_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->title_entry);
	self->priv->title_entry = _tmp2_;
	_tmp3_ = music_media_editor_activates_default_entry_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->artist_entry);
	self->priv->artist_entry = _tmp3_;
	_tmp4_ = music_media_editor_activates_default_entry_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->album_artist_entry);
	self->priv->album_artist_entry = _tmp4_;
	_tmp5_ = music_media_editor_activates_default_entry_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->album_entry);
	self->priv->album_entry = _tmp5_;
	_tmp6_ = music_media_editor_activates_default_entry_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->genre_entry);
	self->priv->genre_entry = _tmp6_;
	_tmp7_ = music_media_editor_activates_default_entry_new ();
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->composer_entry);
	self->priv->composer_entry = _tmp7_;
	_tmp8_ = music_media_editor_activates_default_entry_new ();
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->grouping_entry);
	self->priv->grouping_entry = _tmp8_;
	_tmp9_ = (GtkTextView*) gtk_text_view_new ();
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->comment_textview);
	self->priv->comment_textview = _tmp9_;
	_tmp10_ = self->priv->comment_textview;
	gtk_text_view_set_wrap_mode (_tmp10_, GTK_WRAP_WORD_CHAR);
	_tmp11_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->comment_scrolledwindow);
	self->priv->comment_scrolledwindow = _tmp11_;
	_tmp12_ = self->priv->comment_scrolledwindow;
	gtk_scrolled_window_set_policy (_tmp12_, GTK_POLICY_EXTERNAL, GTK_POLICY_AUTOMATIC);
	_tmp13_ = self->priv->comment_scrolledwindow;
	_tmp14_ = self->priv->comment_textview;
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 500, (gdouble) 1);
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->track_spinbutton);
	self->priv->track_spinbutton = _tmp15_;
	_tmp16_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 500, (gdouble) 1);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->disk_spinbutton);
	self->priv->disk_spinbutton = _tmp16_;
	_tmp17_ = g_date_time_new_now_local ();
	local_time = _tmp17_;
	_tmp18_ = local_time;
	_tmp19_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) g_date_time_get_year (_tmp18_), (gdouble) 1);
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->year_spinbutton);
	self->priv->year_spinbutton = _tmp19_;
	_tmp20_ = music_rating_widget_new (FALSE, GTK_ICON_SIZE_MENU, FALSE);
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->rating_widget);
	self->priv->rating_widget = _tmp20_;
	_tmp21_ = self->priv->rating_widget;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp21_, TRUE);
	_tmp22_ = (GtkFrame*) gtk_frame_new (NULL);
	g_object_ref_sink (_tmp22_);
	comment_frame = _tmp22_;
	_tmp23_ = comment_frame;
	g_object_set ((GtkWidget*) _tmp23_, "expand", TRUE, NULL);
	_tmp24_ = comment_frame;
	_tmp25_ = self->priv->comment_scrolledwindow;
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp26_);
	grid = _tmp26_;
	_tmp27_ = grid;
	g_object_set ((GtkWidget*) _tmp27_, "expand", TRUE, NULL);
	_tmp28_ = grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp28_, 12);
	_tmp29_ = grid;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp29_, 12);
	_tmp30_ = grid;
	gtk_grid_set_column_spacing (_tmp30_, 12);
	_tmp31_ = grid;
	_tmp32_ = granite_header_label_new (_ ("Title:"));
	g_object_ref_sink (_tmp32_);
	_tmp33_ = _tmp32_;
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp33_, 0, 0, 1, 1);
	_g_object_unref0 (_tmp33_);
	_tmp34_ = grid;
	_tmp35_ = self->priv->title_entry;
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 0, 1, 1, 1);
	_tmp36_ = grid;
	_tmp37_ = granite_header_label_new (_ ("Artist:"));
	g_object_ref_sink (_tmp37_);
	_tmp38_ = _tmp37_;
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp38_, 1, 0, 1, 1);
	_g_object_unref0 (_tmp38_);
	_tmp39_ = grid;
	_tmp40_ = self->priv->artist_entry;
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp40_, 1, 1, 1, 1);
	_tmp41_ = grid;
	_tmp42_ = granite_header_label_new (_ ("Album:"));
	g_object_ref_sink (_tmp42_);
	_tmp43_ = _tmp42_;
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp43_, 0, 2, 1, 1);
	_g_object_unref0 (_tmp43_);
	_tmp44_ = grid;
	_tmp45_ = self->priv->album_entry;
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 0, 3, 1, 1);
	_tmp46_ = grid;
	_tmp47_ = granite_header_label_new (_ ("Album Artist:"));
	g_object_ref_sink (_tmp47_);
	_tmp48_ = _tmp47_;
	gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp48_, 1, 2, 1, 1);
	_g_object_unref0 (_tmp48_);
	_tmp49_ = grid;
	_tmp50_ = self->priv->album_artist_entry;
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 1, 3, 1, 1);
	_tmp51_ = grid;
	_tmp52_ = granite_header_label_new (_ ("Composer:"));
	g_object_ref_sink (_tmp52_);
	_tmp53_ = _tmp52_;
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp53_, 0, 4, 1, 1);
	_g_object_unref0 (_tmp53_);
	_tmp54_ = grid;
	_tmp55_ = self->priv->composer_entry;
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 0, 5, 1, 1);
	_tmp56_ = grid;
	_tmp57_ = granite_header_label_new (_ ("Grouping:"));
	g_object_ref_sink (_tmp57_);
	_tmp58_ = _tmp57_;
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp58_, 1, 4, 1, 1);
	_g_object_unref0 (_tmp58_);
	_tmp59_ = grid;
	_tmp60_ = self->priv->grouping_entry;
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 1, 5, 1, 1);
	_tmp61_ = grid;
	_tmp62_ = granite_header_label_new (_ ("Genre:"));
	g_object_ref_sink (_tmp62_);
	_tmp63_ = _tmp62_;
	gtk_grid_attach (_tmp61_, (GtkWidget*) _tmp63_, 0, 6, 1, 1);
	_g_object_unref0 (_tmp63_);
	_tmp64_ = grid;
	_tmp65_ = self->priv->genre_entry;
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 0, 7, 1, 1);
	_tmp66_ = grid;
	_tmp67_ = granite_header_label_new (_ ("Year:"));
	g_object_ref_sink (_tmp67_);
	_tmp68_ = _tmp67_;
	gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp68_, 1, 6, 1, 1);
	_g_object_unref0 (_tmp68_);
	_tmp69_ = grid;
	_tmp70_ = self->priv->year_spinbutton;
	gtk_grid_attach (_tmp69_, (GtkWidget*) _tmp70_, 1, 7, 1, 1);
	_tmp71_ = grid;
	_tmp72_ = granite_header_label_new (_ ("Track:"));
	g_object_ref_sink (_tmp72_);
	_tmp73_ = _tmp72_;
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp73_, 1, 8, 1, 1);
	_g_object_unref0 (_tmp73_);
	_tmp74_ = grid;
	_tmp75_ = self->priv->track_spinbutton;
	gtk_grid_attach (_tmp74_, (GtkWidget*) _tmp75_, 1, 9, 1, 1);
	_tmp76_ = grid;
	_tmp77_ = granite_header_label_new (_ ("Disc:"));
	g_object_ref_sink (_tmp77_);
	_tmp78_ = _tmp77_;
	gtk_grid_attach (_tmp76_, (GtkWidget*) _tmp78_, 1, 10, 1, 1);
	_g_object_unref0 (_tmp78_);
	_tmp79_ = grid;
	_tmp80_ = self->priv->disk_spinbutton;
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 1, 11, 1, 1);
	_tmp81_ = grid;
	_tmp82_ = granite_header_label_new (_ ("Rating:"));
	g_object_ref_sink (_tmp82_);
	_tmp83_ = _tmp82_;
	gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp83_, 1, 12, 1, 1);
	_g_object_unref0 (_tmp83_);
	_tmp84_ = grid;
	_tmp85_ = self->priv->rating_widget;
	gtk_grid_attach (_tmp84_, (GtkWidget*) _tmp85_, 1, 13, 1, 1);
	_tmp86_ = grid;
	_tmp87_ = granite_header_label_new (_ ("Comment:"));
	g_object_ref_sink (_tmp87_);
	_tmp88_ = _tmp87_;
	gtk_grid_attach (_tmp86_, (GtkWidget*) _tmp88_, 0, 8, 1, 1);
	_g_object_unref0 (_tmp88_);
	_tmp89_ = grid;
	_tmp90_ = comment_frame;
	gtk_grid_attach (_tmp89_, (GtkWidget*) _tmp90_, 0, 9, 1, 5);
	_tmp91_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	_tmp92_ = grid;
	gtk_container_add ((GtkContainer*) _tmp91_, (GtkWidget*) _tmp92_);
	_tmp93_ = (GtkButton*) gtk_button_new_from_icon_name ("go-previous-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp93_);
	_g_object_unref0 (self->priv->previous_button);
	self->priv->previous_button = _tmp93_;
	_tmp94_ = (GtkButton*) gtk_button_new_from_icon_name ("go-next-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp94_);
	_g_object_unref0 (self->priv->next_button);
	self->priv->next_button = _tmp94_;
	_tmp95_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp95_);
	arrows_grid = _tmp95_;
	_tmp96_ = arrows_grid;
	_tmp97_ = gtk_widget_get_style_context ((GtkWidget*) _tmp96_);
	gtk_style_context_add_class (_tmp97_, GTK_STYLE_CLASS_LINKED);
	_tmp98_ = arrows_grid;
	_tmp99_ = self->priv->previous_button;
	gtk_container_add ((GtkContainer*) _tmp98_, (GtkWidget*) _tmp99_);
	_tmp100_ = arrows_grid;
	_tmp101_ = self->priv->next_button;
	gtk_container_add ((GtkContainer*) _tmp100_, (GtkWidget*) _tmp101_);
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Close"), (gint) GTK_RESPONSE_CLOSE);
	_tmp102_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Save"), (gint) GTK_RESPONSE_APPLY);
	_tmp103_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, gtk_button_get_type (), GtkButton));
	save_button = _tmp103_;
	_tmp104_ = save_button;
	g_object_set ((GtkWidget*) _tmp104_, "has-default", TRUE, NULL);
	_tmp105_ = save_button;
	_tmp106_ = gtk_widget_get_style_context ((GtkWidget*) _tmp105_);
	gtk_style_context_add_class (_tmp106_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp107_ = gtk_dialog_get_action_area ((GtkDialog*) self);
	_tmp108_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp107_, gtk_button_box_get_type (), GtkButtonBox));
	action_area = _tmp108_;
	_tmp109_ = action_area;
	g_object_set ((GtkWidget*) _tmp109_, "margin", 5, NULL);
	_tmp110_ = action_area;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp110_, 14);
	_tmp111_ = action_area;
	_tmp112_ = arrows_grid;
	gtk_box_pack_start ((GtkBox*) _tmp111_, (GtkWidget*) _tmp112_, FALSE, FALSE, (guint) 0);
	_tmp113_ = action_area;
	_tmp114_ = arrows_grid;
	gtk_button_box_set_child_secondary (_tmp113_, (GtkWidget*) _tmp114_, TRUE);
	_tmp115_ = action_area;
	_tmp116_ = arrows_grid;
	gtk_button_box_set_child_non_homogeneous (_tmp115_, (GtkWidget*) _tmp116_, TRUE);
	_tmp117_ = self->priv->previous_button;
	g_signal_connect_object (_tmp117_, "clicked", (GCallback) _music_media_editor_previous_track_gtk_button_clicked, self, 0);
	_tmp118_ = self->priv->next_button;
	g_signal_connect_object (_tmp118_, "clicked", (GCallback) _music_media_editor_next_track_gtk_button_clicked, self, 0);
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) __music_media_editor___lambda49__gtk_dialog_response, self, 0);
	_g_object_unref0 (action_area);
	_g_object_unref0 (save_button);
	_g_object_unref0 (arrows_grid);
	_g_object_unref0 (grid);
	_g_object_unref0 (comment_frame);
	_g_date_time_unref0 (local_time);
	return obj;
}

static void
music_media_editor_class_init (MusicMediaEditorClass * klass,
                               gpointer klass_data)
{
	music_media_editor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicMediaEditor_private_offset);
	G_OBJECT_CLASS (klass)->constructor = music_media_editor_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_media_editor_finalize;
}

static void
music_media_editor_instance_init (MusicMediaEditor * self,
                                  gpointer klass)
{
	self->priv = music_media_editor_get_instance_private (self);
}

static void
music_media_editor_finalize (GObject * obj)
{
	MusicMediaEditor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_EDITOR, MusicMediaEditor);
	_g_object_unref0 (self->priv->title_entry);
	_g_object_unref0 (self->priv->artist_entry);
	_g_object_unref0 (self->priv->album_artist_entry);
	_g_object_unref0 (self->priv->album_entry);
	_g_object_unref0 (self->priv->genre_entry);
	_g_object_unref0 (self->priv->composer_entry);
	_g_object_unref0 (self->priv->grouping_entry);
	_g_object_unref0 (self->priv->comment_textview);
	_g_object_unref0 (self->priv->comment_scrolledwindow);
	_g_object_unref0 (self->priv->track_spinbutton);
	_g_object_unref0 (self->priv->disk_spinbutton);
	_g_object_unref0 (self->priv->year_spinbutton);
	_g_object_unref0 (self->priv->rating_widget);
	_g_object_unref0 (self->priv->previous_button);
	_g_object_unref0 (self->priv->next_button);
	_g_object_unref0 (self->priv->media_list);
	_g_object_unref0 (self->priv->temp_list);
	_g_object_unref0 (self->priv->current_media);
	G_OBJECT_CLASS (music_media_editor_parent_class)->finalize (obj);
}

static GType
music_media_editor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaEditorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_editor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMediaEditor), 0, (GInstanceInitFunc) music_media_editor_instance_init, NULL };
	GType music_media_editor_type_id;
	music_media_editor_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "MusicMediaEditor", &g_define_type_info, 0);
	MusicMediaEditor_private_offset = g_type_add_instance_private (music_media_editor_type_id, sizeof (MusicMediaEditorPrivate));
	return music_media_editor_type_id;
}

GType
music_media_editor_get_type (void)
{
	static volatile gsize music_media_editor_type_id__once = 0;
	if (g_once_init_enter (&music_media_editor_type_id__once)) {
		GType music_media_editor_type_id;
		music_media_editor_type_id = music_media_editor_get_type_once ();
		g_once_init_leave (&music_media_editor_type_id__once, music_media_editor_type_id);
	}
	return music_media_editor_type_id__once;
}

