/* GStreamerTagger.c generated by valac 0.55.1, the Vala compiler
 * generated from GStreamerTagger.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <gst/pbutils/pbutils.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gst/gst.h>
#include "io.elementary.music-core.h"
#include <float.h>
#include <math.h>
#include <time.h>

#define MUSIC_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT 5

enum  {
	MUSIC_GSTREAMER_TAGGER_0_PROPERTY,
	MUSIC_GSTREAMER_TAGGER_NUM_PROPERTIES
};
static GParamSpec* music_gstreamer_tagger_properties[MUSIC_GSTREAMER_TAGGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _gst_date_time_unref0(var) ((var == NULL) ? NULL : (var = (gst_date_time_unref (var), NULL)))
enum  {
	MUSIC_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL,
	MUSIC_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL,
	MUSIC_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL,
	MUSIC_GSTREAMER_TAGGER_NUM_SIGNALS
};
static guint music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_NUM_SIGNALS] = {0};

struct _MusicGStreamerTaggerPrivate {
	GstDiscoverer* d;
	GeeLinkedList* uri_queue;
	GRecMutex __lock_uri_queue;
	GCancellable* cancellable;
};

static gint MusicGStreamerTagger_private_offset;
static gpointer music_gstreamer_tagger_parent_class = NULL;

static void music_gstreamer_tagger_import_media (MusicGStreamerTagger* self,
                                          GstDiscovererInfo* info,
                                          GError* err);
static void _music_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                     GstDiscovererInfo* info,
                                                                     GError* err,
                                                                     gpointer self);
static void music_gstreamer_tagger_file_set_finished (MusicGStreamerTagger* self);
static void _music_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender,
                                                                        gpointer self);
static void music_gstreamer_tagger_import_next_file_set (MusicGStreamerTagger* self);
static void* __lambda12_ (MusicGStreamerTagger* self);
static gpointer ___lambda12__gthread_func (gpointer self);
static GDate* _g_date_dup (GDate* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void music_gstreamer_tagger_finalize (GObject * obj);
static GType music_gstreamer_tagger_get_type_once (void);

static inline gpointer
music_gstreamer_tagger_get_instance_private (MusicGStreamerTagger* self)
{
	return G_STRUCT_MEMBER_P (self, MusicGStreamerTagger_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_music_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                GstDiscovererInfo* info,
                                                                GError* err,
                                                                gpointer self)
{
	music_gstreamer_tagger_import_media ((MusicGStreamerTagger*) self, info, err);
}

static void
_music_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender,
                                                                   gpointer self)
{
	music_gstreamer_tagger_file_set_finished ((MusicGStreamerTagger*) self);
}

MusicGStreamerTagger*
music_gstreamer_tagger_construct (GType object_type,
                                  GCancellable* cancellable)
{
	MusicGStreamerTagger * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GError* _inner_error0_ = NULL;
	self = (MusicGStreamerTagger*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (self->priv->cancellable);
	self->priv->cancellable = _tmp0_;
	_tmp1_ = self->priv->cancellable;
	if (_tmp1_ == NULL) {
		GCancellable* _tmp2_;
		_tmp2_ = g_cancellable_new ();
		_g_object_unref0 (self->priv->cancellable);
		self->priv->cancellable = _tmp2_;
	}
	{
		GstDiscoverer* _tmp3_ = NULL;
		GstDiscoverer* _tmp4_;
		GstDiscoverer* _tmp5_;
		GstDiscoverer* _tmp6_;
		GstDiscoverer* _tmp7_;
		_tmp4_ = gst_discoverer_new ((GstClockTime) (MUSIC_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error0_);
		_tmp3_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp5_ = _tmp3_;
		_tmp3_ = NULL;
		_g_object_unref0 (self->priv->d);
		self->priv->d = _tmp5_;
		_tmp6_ = self->priv->d;
		g_signal_connect_object (_tmp6_, "discovered", (GCallback) _music_gstreamer_tagger_import_media_gst_discoverer_discovered, self, 0);
		_tmp7_ = self->priv->d;
		g_signal_connect_object (_tmp7_, "finished", (GCallback) _music_gstreamer_tagger_file_set_finished_gst_discoverer_finished, self, 0);
		_g_object_unref0 (_tmp3_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = err;
		_tmp9_ = _tmp8_->message;
		g_critical ("GStreamerTagger.vala:51: Could not create Gst discoverer object: %s", _tmp9_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	return self;
}

MusicGStreamerTagger*
music_gstreamer_tagger_new (GCancellable* cancellable)
{
	return music_gstreamer_tagger_construct (MUSIC_TYPE_GSTREAMER_TAGGER, cancellable);
}

static void
music_gstreamer_tagger_file_set_finished (MusicGStreamerTagger* self)
{
	GCancellable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cancellable;
	if (g_cancellable_is_cancelled (_tmp0_)) {
		GstDiscoverer* _tmp1_;
		g_debug ("GStreamerTagger.vala:57: import cancelled");
		_tmp1_ = self->priv->d;
		gst_discoverer_stop (_tmp1_);
		g_signal_emit (self, music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
	} else {
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->uri_queue;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		if (_tmp4_ == 0) {
			GstDiscoverer* _tmp5_;
			g_debug ("GStreamerTagger.vala:61: queue finished");
			_tmp5_ = self->priv->d;
			gst_discoverer_stop (_tmp5_);
			g_signal_emit (self, music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
		} else {
			music_gstreamer_tagger_import_next_file_set (self);
		}
	}
}

static void
music_gstreamer_tagger_import_next_file_set (MusicGStreamerTagger* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->uri_queue;
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
		{
			{
				gchar* uri = NULL;
				GeeLinkedList* _tmp1_;
				gpointer _tmp2_;
				_tmp1_ = self->priv->uri_queue;
				_tmp2_ = gee_deque_poll_head ((GeeDeque*) _tmp1_);
				uri = (gchar*) _tmp2_;
				{
					gboolean _tmp3_ = FALSE;
					_tmp3_ = TRUE;
					while (TRUE) {
						const gchar* _tmp6_;
						GstDiscoverer* _tmp7_;
						const gchar* _tmp8_;
						if (!_tmp3_) {
							GeeLinkedList* _tmp4_;
							gpointer _tmp5_;
							_tmp4_ = self->priv->uri_queue;
							_tmp5_ = gee_deque_poll_head ((GeeDeque*) _tmp4_);
							_g_free0 (uri);
							uri = (gchar*) _tmp5_;
						}
						_tmp3_ = FALSE;
						_tmp6_ = uri;
						if (!(_tmp6_ != NULL)) {
							break;
						}
						_tmp7_ = self->priv->d;
						_tmp8_ = uri;
						gst_discoverer_discover_uri_async (_tmp7_, _tmp8_);
					}
				}
				_g_free0 (uri);
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp9_;
			_tmp9_ = self->priv->uri_queue;
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void*
__lambda12_ (MusicGStreamerTagger* self)
{
	void* result;
	music_gstreamer_tagger_import_next_file_set (self);
	result = NULL;
	return result;
}

static gpointer
___lambda12__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda12_ ((MusicGStreamerTagger*) self);
	g_object_unref (self);
	return result;
}

void
music_gstreamer_tagger_discoverer_import_media (MusicGStreamerTagger* self,
                                                GeeCollection* uris)
{
	GstDiscoverer* _tmp3_;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (uris != NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->uri_queue;
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
		{
			GeeLinkedList* _tmp1_;
			_tmp1_ = self->priv->uri_queue;
			gee_collection_add_all ((GeeCollection*) _tmp1_, uris);
		}
		__finally0:
		{
			GeeLinkedList* _tmp2_;
			_tmp2_ = self->priv->uri_queue;
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = self->priv->d;
	gst_discoverer_start (_tmp3_);
	_tmp4_ = g_thread_new (NULL, ___lambda12__gthread_func, g_object_ref (self));
	_tmp5_ = _tmp4_;
	_g_thread_unref0 (_tmp5_);
}

static GDate*
_g_date_dup (GDate* self)
{
	GDate* dup;
	dup = g_new0 (GDate, 1);
	memcpy (dup, self, sizeof (GDate));
	return dup;
}

static gpointer
__g_date_dup0 (gpointer self)
{
	return self ? _g_date_dup (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
music_gstreamer_tagger_import_media (MusicGStreamerTagger* self,
                                     GstDiscovererInfo* info,
                                     GError* err)
{
	GCancellable* _tmp0_;
	gchar* uri = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean gstreamer_discovery_successful = FALSE;
	MusicMedia* m = NULL;
	const gchar* _tmp14_;
	MusicMedia* _tmp15_;
	guint64 duration = 0ULL;
	GstTagList* tags = NULL;
	GstTagList* _tmp16_;
	GstTagList* _tmp17_;
	MusicMedia* _tmp108_;
	GList* _tmp109_;
	MusicMedia* _tmp134_;
	MusicMedia* _tmp135_;
	GFile* _tmp136_;
	GFile* _tmp137_;
	MusicMedia* _tmp138_;
	time_t _tmp139_;
	MusicMedia* _tmp140_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	_tmp0_ = self->priv->cancellable;
	if (g_cancellable_is_cancelled (_tmp0_)) {
		GstDiscoverer* _tmp1_;
		_tmp1_ = self->priv->d;
		gst_discoverer_stop (_tmp1_);
		{
			GeeLinkedList* _tmp2_;
			_tmp2_ = self->priv->uri_queue;
			g_rec_mutex_lock (&self->priv->__lock_uri_queue);
			{
				GeeLinkedList* _tmp3_;
				_tmp3_ = self->priv->uri_queue;
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
			}
			__finally0:
			{
				GeeLinkedList* _tmp4_;
				_tmp4_ = self->priv->uri_queue;
				g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		g_signal_emit (self, music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
		return;
	}
	_tmp5_ = gst_discoverer_info_get_uri (info);
	_tmp6_ = g_strdup (_tmp5_);
	uri = _tmp6_;
	gstreamer_discovery_successful = FALSE;
	switch (gst_discoverer_info_get_result (info)) {
		case GST_DISCOVERER_OK:
		{
			gstreamer_discovery_successful = TRUE;
			break;
		}
		case GST_DISCOVERER_URI_INVALID:
		{
			const gchar* _tmp7_;
			_tmp7_ = uri;
			g_warning ("GStreamerTagger.vala:109: GStreamer could not import '%s': invalid URI" \
".", _tmp7_);
			break;
		}
		case GST_DISCOVERER_ERROR:
		{
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			_tmp8_ = uri;
			_tmp9_ = err->message;
			g_warning ("GStreamerTagger.vala:113: GStreamer could not import '%s': %s", _tmp8_, _tmp9_);
			break;
		}
		case GST_DISCOVERER_TIMEOUT:
		{
			const gchar* _tmp10_;
			_tmp10_ = uri;
			g_warning ("GStreamerTagger.vala:117: GStreamer could not import '%s': Discovery t" \
"imed out.", _tmp10_);
			break;
		}
		case GST_DISCOVERER_BUSY:
		{
			const gchar* _tmp11_;
			_tmp11_ = uri;
			g_warning ("GStreamerTagger.vala:121: GStreamer could not import '%s': Already dis" \
"covering a file.", _tmp11_);
			break;
		}
		case GST_DISCOVERER_MISSING_PLUGINS:
		{
			const gchar* _tmp12_;
			_tmp12_ = uri;
			g_warning ("GStreamerTagger.vala:125: GStreamer could not import '%s': Missing plu" \
"gins.", _tmp12_);
			break;
		}
		default:
		break;
	}
	if (!gstreamer_discovery_successful) {
		const gchar* _tmp13_;
		_tmp13_ = uri;
		g_signal_emit (self, music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL], 0, _tmp13_, err);
		_g_free0 (uri);
		return;
	}
	_tmp14_ = uri;
	_tmp15_ = music_media_new (_tmp14_);
	m = _tmp15_;
	duration = (guint64) gst_discoverer_info_get_duration (info);
	_tmp16_ = gst_discoverer_info_get_tags (info);
	tags = _tmp16_;
	_tmp17_ = tags;
	if (_tmp17_ != NULL) {
		gchar* title = NULL;
		GstTagList* _tmp18_;
		gchar* _tmp19_ = NULL;
		gboolean _tmp20_;
		gchar* artist = NULL;
		GstTagList* _tmp23_;
		gchar* _tmp24_ = NULL;
		gboolean _tmp25_;
		gchar* composer = NULL;
		GstTagList* _tmp28_;
		gchar* _tmp29_ = NULL;
		gboolean _tmp30_;
		gchar* album_artist = NULL;
		GstTagList* _tmp33_;
		gchar* _tmp34_ = NULL;
		gboolean _tmp35_;
		gchar* album = NULL;
		GstTagList* _tmp38_;
		gchar* _tmp39_ = NULL;
		gboolean _tmp40_;
		gchar* grouping = NULL;
		GstTagList* _tmp43_;
		gchar* _tmp44_ = NULL;
		gboolean _tmp45_;
		gchar* genre = NULL;
		GstTagList* _tmp48_;
		gchar* _tmp49_ = NULL;
		gboolean _tmp50_;
		gchar* comment = NULL;
		GstTagList* _tmp53_;
		gchar* _tmp54_ = NULL;
		gboolean _tmp55_;
		gchar* lyrics = NULL;
		GstTagList* _tmp58_;
		gchar* _tmp59_ = NULL;
		gboolean _tmp60_;
		guint track_number = 0U;
		GstTagList* _tmp63_;
		guint _tmp64_ = 0U;
		gboolean _tmp65_;
		guint track_count = 0U;
		GstTagList* _tmp67_;
		guint _tmp68_ = 0U;
		gboolean _tmp69_;
		guint album_number = 0U;
		GstTagList* _tmp71_;
		guint _tmp72_ = 0U;
		gboolean _tmp73_;
		guint album_count = 0U;
		GstTagList* _tmp75_;
		guint _tmp76_ = 0U;
		gboolean _tmp77_;
		guint bitrate = 0U;
		GstTagList* _tmp79_;
		guint _tmp80_ = 0U;
		gboolean _tmp81_;
		guint rating = 0U;
		GstTagList* _tmp83_;
		guint _tmp84_ = 0U;
		gboolean _tmp85_;
		GstDateTime* datetime = NULL;
		GstTagList* _tmp87_;
		GstDateTime* _tmp88_ = NULL;
		gboolean _tmp89_;
		gdouble bpm = 0.0;
		GstTagList* _tmp101_;
		gdouble _tmp102_ = 0.0;
		gboolean _tmp103_;
		_tmp18_ = tags;
		_tmp20_ = gst_tag_list_get_string (_tmp18_, GST_TAG_TITLE, &_tmp19_);
		_g_free0 (title);
		title = _tmp19_;
		if (_tmp20_) {
			MusicMedia* _tmp21_;
			const gchar* _tmp22_;
			_tmp21_ = m;
			_tmp22_ = title;
			music_media_set_title (_tmp21_, _tmp22_);
		}
		_tmp23_ = tags;
		_tmp25_ = gst_tag_list_get_string (_tmp23_, GST_TAG_ARTIST, &_tmp24_);
		_g_free0 (artist);
		artist = _tmp24_;
		if (_tmp25_) {
			MusicMedia* _tmp26_;
			const gchar* _tmp27_;
			_tmp26_ = m;
			_tmp27_ = artist;
			music_media_set_artist (_tmp26_, _tmp27_);
		}
		_tmp28_ = tags;
		_tmp30_ = gst_tag_list_get_string (_tmp28_, GST_TAG_COMPOSER, &_tmp29_);
		_g_free0 (composer);
		composer = _tmp29_;
		if (_tmp30_) {
			MusicMedia* _tmp31_;
			const gchar* _tmp32_;
			_tmp31_ = m;
			_tmp32_ = composer;
			music_media_set_composer (_tmp31_, _tmp32_);
		}
		_tmp33_ = tags;
		_tmp35_ = gst_tag_list_get_string (_tmp33_, GST_TAG_ALBUM_ARTIST, &_tmp34_);
		_g_free0 (album_artist);
		album_artist = _tmp34_;
		if (_tmp35_) {
			MusicMedia* _tmp36_;
			const gchar* _tmp37_;
			_tmp36_ = m;
			_tmp37_ = album_artist;
			music_media_set_album_artist (_tmp36_, _tmp37_);
		}
		_tmp38_ = tags;
		_tmp40_ = gst_tag_list_get_string (_tmp38_, GST_TAG_ALBUM, &_tmp39_);
		_g_free0 (album);
		album = _tmp39_;
		if (_tmp40_) {
			MusicMedia* _tmp41_;
			const gchar* _tmp42_;
			_tmp41_ = m;
			_tmp42_ = album;
			music_media_set_album (_tmp41_, _tmp42_);
		}
		_tmp43_ = tags;
		_tmp45_ = gst_tag_list_get_string (_tmp43_, GST_TAG_GROUPING, &_tmp44_);
		_g_free0 (grouping);
		grouping = _tmp44_;
		if (_tmp45_) {
			MusicMedia* _tmp46_;
			const gchar* _tmp47_;
			_tmp46_ = m;
			_tmp47_ = grouping;
			music_media_set_grouping (_tmp46_, _tmp47_);
		}
		_tmp48_ = tags;
		_tmp50_ = gst_tag_list_get_string (_tmp48_, GST_TAG_GENRE, &_tmp49_);
		_g_free0 (genre);
		genre = _tmp49_;
		if (_tmp50_) {
			MusicMedia* _tmp51_;
			const gchar* _tmp52_;
			_tmp51_ = m;
			_tmp52_ = genre;
			music_media_set_genre (_tmp51_, _tmp52_);
		}
		_tmp53_ = tags;
		_tmp55_ = gst_tag_list_get_string (_tmp53_, GST_TAG_COMMENT, &_tmp54_);
		_g_free0 (comment);
		comment = _tmp54_;
		if (_tmp55_) {
			MusicMedia* _tmp56_;
			const gchar* _tmp57_;
			_tmp56_ = m;
			_tmp57_ = comment;
			music_media_set_comment (_tmp56_, _tmp57_);
		}
		_tmp58_ = tags;
		_tmp60_ = gst_tag_list_get_string (_tmp58_, GST_TAG_LYRICS, &_tmp59_);
		_g_free0 (lyrics);
		lyrics = _tmp59_;
		if (_tmp60_) {
			MusicMedia* _tmp61_;
			const gchar* _tmp62_;
			_tmp61_ = m;
			_tmp62_ = lyrics;
			music_media_set_lyrics (_tmp61_, _tmp62_);
		}
		_tmp63_ = tags;
		_tmp65_ = gst_tag_list_get_uint (_tmp63_, GST_TAG_TRACK_NUMBER, &_tmp64_);
		track_number = _tmp64_;
		if (_tmp65_) {
			MusicMedia* _tmp66_;
			_tmp66_ = m;
			music_media_set_track (_tmp66_, track_number);
		}
		_tmp67_ = tags;
		_tmp69_ = gst_tag_list_get_uint (_tmp67_, GST_TAG_TRACK_COUNT, &_tmp68_);
		track_count = _tmp68_;
		if (_tmp69_) {
			MusicMedia* _tmp70_;
			_tmp70_ = m;
			music_media_set_track_count (_tmp70_, track_count);
		}
		_tmp71_ = tags;
		_tmp73_ = gst_tag_list_get_uint (_tmp71_, GST_TAG_ALBUM_VOLUME_NUMBER, &_tmp72_);
		album_number = _tmp72_;
		if (_tmp73_) {
			MusicMedia* _tmp74_;
			_tmp74_ = m;
			music_media_set_album_number (_tmp74_, album_number);
		}
		_tmp75_ = tags;
		_tmp77_ = gst_tag_list_get_uint (_tmp75_, GST_TAG_ALBUM_VOLUME_COUNT, &_tmp76_);
		album_count = _tmp76_;
		if (_tmp77_) {
			MusicMedia* _tmp78_;
			_tmp78_ = m;
			music_media_set_album_count (_tmp78_, album_count);
		}
		_tmp79_ = tags;
		_tmp81_ = gst_tag_list_get_uint (_tmp79_, GST_TAG_BITRATE, &_tmp80_);
		bitrate = _tmp80_;
		if (_tmp81_) {
			MusicMedia* _tmp82_;
			_tmp82_ = m;
			music_media_set_bitrate (_tmp82_, bitrate / 1000);
		}
		_tmp83_ = tags;
		_tmp85_ = gst_tag_list_get_uint (_tmp83_, GST_TAG_USER_RATING, &_tmp84_);
		rating = _tmp84_;
		if (_tmp85_) {
			MusicMedia* _tmp86_;
			_tmp86_ = m;
			music_media_set_rating (_tmp86_, rating);
		}
		_tmp87_ = tags;
		_tmp89_ = gst_tag_list_get_date_time (_tmp87_, GST_TAG_DATE_TIME, &_tmp88_);
		_gst_date_time_unref0 (datetime);
		datetime = _tmp88_;
		if (_tmp89_) {
			GstDateTime* _tmp90_;
			_tmp90_ = datetime;
			if (_tmp90_ != NULL) {
				MusicMedia* _tmp91_;
				GstDateTime* _tmp92_;
				_tmp91_ = m;
				_tmp92_ = datetime;
				music_media_set_year (_tmp91_, (guint) gst_date_time_get_year (_tmp92_));
			} else {
				GDate* date = NULL;
				GstTagList* _tmp93_;
				GDate _tmp94_ = {0};
				gboolean _tmp95_;
				GDate _tmp96_;
				GDate* _tmp97_;
				_tmp93_ = tags;
				_tmp95_ = gst_tag_list_get_date (_tmp93_, GST_TAG_DATE, &_tmp94_);
				_g_free0 (date);
				_tmp96_ = _tmp94_;
				_tmp97_ = __g_date_dup0 (&_tmp96_);
				date = _tmp97_;
				if (_tmp95_) {
					GDate* _tmp98_;
					_tmp98_ = date;
					if (_tmp98_ != NULL) {
						MusicMedia* _tmp99_;
						GDate* _tmp100_;
						_tmp99_ = m;
						_tmp100_ = date;
						music_media_set_year (_tmp99_, (guint) g_date_get_year (_tmp100_));
					}
				}
				_g_free0 (date);
			}
		}
		_tmp101_ = tags;
		_tmp103_ = gst_tag_list_get_double (_tmp101_, GST_TAG_BEATS_PER_MINUTE, &_tmp102_);
		bpm = _tmp102_;
		if (_tmp103_) {
			MusicMedia* _tmp104_;
			_tmp104_ = m;
			music_media_set_bpm (_tmp104_, (guint) CLAMP (bpm, (gdouble) 0, bpm));
		}
		if (duration == ((guint64) 0)) {
			GstTagList* _tmp105_;
			guint64 _tmp106_ = 0ULL;
			gboolean _tmp107_;
			_tmp105_ = tags;
			_tmp107_ = gst_tag_list_get_uint64 (_tmp105_, GST_TAG_DURATION, &_tmp106_);
			duration = _tmp106_;
			if (!_tmp107_) {
				duration = (guint64) 0;
			}
		}
		_gst_date_time_unref0 (datetime);
		_g_free0 (lyrics);
		_g_free0 (comment);
		_g_free0 (genre);
		_g_free0 (grouping);
		_g_free0 (album);
		_g_free0 (album_artist);
		_g_free0 (composer);
		_g_free0 (artist);
		_g_free0 (title);
	}
	_tmp108_ = m;
	music_media_set_length (_tmp108_, music_time_utils_nanoseconds_to_miliseconds (duration));
	_tmp109_ = gst_discoverer_info_get_audio_streams (info);
	{
		GList* stream_info_collection = NULL;
		GList* stream_info_it = NULL;
		stream_info_collection = _tmp109_;
		for (stream_info_it = stream_info_collection; stream_info_it != NULL; stream_info_it = stream_info_it->next) {
			GstDiscovererStreamInfo* _tmp110_;
			GstDiscovererStreamInfo* stream_info = NULL;
			_tmp110_ = _g_object_ref0 ((GstDiscovererStreamInfo*) stream_info_it->data);
			stream_info = _tmp110_;
			{
				GstDiscovererAudioInfo* audio_stream = NULL;
				GstDiscovererStreamInfo* _tmp111_;
				GstDiscovererAudioInfo* _tmp112_;
				GstDiscovererAudioInfo* _tmp113_;
				MusicMedia* _tmp114_;
				guint _tmp115_;
				guint _tmp116_;
				MusicMedia* _tmp124_;
				guint _tmp125_;
				guint _tmp126_;
				_tmp111_ = stream_info;
				_tmp112_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp111_, gst_discoverer_audio_info_get_type ()) ? ((GstDiscovererAudioInfo*) _tmp111_) : NULL);
				audio_stream = _tmp112_;
				_tmp113_ = audio_stream;
				if (_tmp113_ == NULL) {
					_g_object_unref0 (audio_stream);
					_g_object_unref0 (stream_info);
					continue;
				}
				_tmp114_ = m;
				_tmp115_ = music_media_get_samplerate (_tmp114_);
				_tmp116_ = _tmp115_;
				if (_tmp116_ == ((guint) 0)) {
					MusicMedia* _tmp117_;
					GstDiscovererAudioInfo* _tmp118_;
					MusicMedia* _tmp119_;
					guint _tmp120_;
					guint _tmp121_;
					gchar* _tmp122_;
					gchar* _tmp123_;
					g_debug ("GStreamerTagger.vala:247: Getting sample rate from stream info");
					_tmp117_ = m;
					_tmp118_ = audio_stream;
					music_media_set_samplerate (_tmp117_, gst_discoverer_audio_info_get_sample_rate (_tmp118_));
					_tmp119_ = m;
					_tmp120_ = music_media_get_samplerate (_tmp119_);
					_tmp121_ = _tmp120_;
					_tmp122_ = g_strdup_printf ("%u", _tmp121_);
					_tmp123_ = _tmp122_;
					g_debug ("GStreamerTagger.vala:249: Sample rate = %s", _tmp123_);
					_g_free0 (_tmp123_);
				}
				_tmp124_ = m;
				_tmp125_ = music_media_get_bitrate (_tmp124_);
				_tmp126_ = _tmp125_;
				if (_tmp126_ == ((guint) 0)) {
					MusicMedia* _tmp127_;
					GstDiscovererAudioInfo* _tmp128_;
					MusicMedia* _tmp129_;
					guint _tmp130_;
					guint _tmp131_;
					gchar* _tmp132_;
					gchar* _tmp133_;
					g_debug ("GStreamerTagger.vala:253: Getting bitrate from stream info");
					_tmp127_ = m;
					_tmp128_ = audio_stream;
					music_media_set_bitrate (_tmp127_, gst_discoverer_audio_info_get_bitrate (_tmp128_));
					_tmp129_ = m;
					_tmp130_ = music_media_get_bitrate (_tmp129_);
					_tmp131_ = _tmp130_;
					_tmp132_ = g_strdup_printf ("%u", _tmp131_);
					_tmp133_ = _tmp132_;
					g_debug ("GStreamerTagger.vala:255: Bitrate = %s", _tmp133_);
					_g_free0 (_tmp133_);
				}
				_g_object_unref0 (audio_stream);
				_g_object_unref0 (stream_info);
				break;
			}
		}
		(stream_info_collection == NULL) ? NULL : (stream_info_collection = (_g_list_free__g_object_unref0_ (stream_info_collection), NULL));
	}
	_tmp134_ = m;
	_tmp135_ = m;
	_tmp136_ = music_media_get_file (_tmp135_);
	_tmp137_ = _tmp136_;
	music_media_set_file_size (_tmp134_, music_file_utils_get_size (_tmp137_, NULL));
	_tmp138_ = m;
	_tmp139_ = time (NULL);
	music_media_set_date_added (_tmp138_, (guint) ((gint) _tmp139_));
	_tmp140_ = m;
	g_signal_emit (self, music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL], 0, _tmp140_);
	_g_object_unref0 (m);
	_g_free0 (uri);
}

static void
g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_POINTER) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_pointer (param_values + 2), data2);
}

static void
music_gstreamer_tagger_class_init (MusicGStreamerTaggerClass * klass,
                                   gpointer klass_data)
{
	music_gstreamer_tagger_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicGStreamerTagger_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_gstreamer_tagger_finalize;
	music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL] = g_signal_new ("media-imported", MUSIC_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_MEDIA);
	music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL] = g_signal_new ("import-error", MUSIC_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_POINTER);
	music_gstreamer_tagger_signals[MUSIC_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL] = g_signal_new ("queue-finished", MUSIC_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_gstreamer_tagger_instance_init (MusicGStreamerTagger * self,
                                      gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GCancellable* _tmp1_;
	self->priv = music_gstreamer_tagger_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_uri_queue);
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	self->priv->uri_queue = _tmp0_;
	_tmp1_ = g_cancellable_new ();
	self->priv->cancellable = _tmp1_;
}

static void
music_gstreamer_tagger_finalize (GObject * obj)
{
	MusicGStreamerTagger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_GSTREAMER_TAGGER, MusicGStreamerTagger);
	_g_object_unref0 (self->priv->d);
	g_rec_mutex_clear (&self->priv->__lock_uri_queue);
	_g_object_unref0 (self->priv->uri_queue);
	_g_object_unref0 (self->priv->cancellable);
	G_OBJECT_CLASS (music_gstreamer_tagger_parent_class)->finalize (obj);
}

static GType
music_gstreamer_tagger_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicGStreamerTaggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_gstreamer_tagger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicGStreamerTagger), 0, (GInstanceInitFunc) music_gstreamer_tagger_instance_init, NULL };
	GType music_gstreamer_tagger_type_id;
	music_gstreamer_tagger_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicGStreamerTagger", &g_define_type_info, 0);
	MusicGStreamerTagger_private_offset = g_type_add_instance_private (music_gstreamer_tagger_type_id, sizeof (MusicGStreamerTaggerPrivate));
	return music_gstreamer_tagger_type_id;
}

GType
music_gstreamer_tagger_get_type (void)
{
	static volatile gsize music_gstreamer_tagger_type_id__once = 0;
	if (g_once_init_enter (&music_gstreamer_tagger_type_id__once)) {
		GType music_gstreamer_tagger_type_id;
		music_gstreamer_tagger_type_id = music_gstreamer_tagger_get_type_once ();
		g_once_init_leave (&music_gstreamer_tagger_type_id__once, music_gstreamer_tagger_type_id);
	}
	return music_gstreamer_tagger_type_id__once;
}

