/* MediaKeyListener.c generated by valac 0.55.1, the Vala compiler
 * generated from MediaKeyListener.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include "music-lib.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"

enum  {
	GNOME_MEDIA_KEYS_MEDIA_PLAYER_KEY_PRESSED_SIGNAL,
	GNOME_MEDIA_KEYS_NUM_SIGNALS
};
static guint gnome_media_keys_signals[GNOME_MEDIA_KEYS_NUM_SIGNALS] = {0};
typedef GDBusProxy GnomeMediaKeysProxy;
typedef GDBusProxyClass GnomeMediaKeysProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_MEDIA_KEY_LISTENER_0_PROPERTY,
	MUSIC_MEDIA_KEY_LISTENER_NUM_PROPERTIES
};
static GParamSpec* music_media_key_listener_properties[MUSIC_MEDIA_KEY_LISTENER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MusicMediaKeyListenerPrivate {
	GnomeMediaKeys* media_object;
};

static gint MusicMediaKeyListener_private_offset;
static gpointer music_media_key_listener_parent_class = NULL;
static MusicMediaKeyListener* music_media_key_listener__instance;
static MusicMediaKeyListener* music_media_key_listener__instance = NULL;

static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GType gnome_media_keys_get_type_once (void);
static void gnome_media_keys_proxy_g_signal (GDBusProxy* proxy,
                                      const gchar* sender_name,
                                      const gchar* signal_name,
                                      GVariant* parameters);
static void _dbus_handle_gnome_media_keys_media_player_key_pressed (GnomeMediaKeys* self,
                                                             GVariant* parameters);
static void gnome_media_keys_proxy_grab_media_player_keys (GnomeMediaKeys* self,
                                                    const gchar* application,
                                                    guint32 time,
                                                    GError** error);
static void gnome_media_keys_proxy_release_media_player_keys (GnomeMediaKeys* self,
                                                       const gchar* application,
                                                       GError** error);
static void gnome_media_keys_proxy_gnome_media_keys_interface_init (GnomeMediaKeysIface* iface);
static void _dbus_gnome_media_keys_grab_media_player_keys (GnomeMediaKeys* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_gnome_media_keys_release_media_player_keys (GnomeMediaKeys* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void gnome_media_keys_dbus_interface_method_call (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* method_name,
                                                  GVariant* parameters,
                                                  GDBusMethodInvocation* invocation,
                                                  gpointer user_data);
static GVariant* gnome_media_keys_dbus_interface_get_property (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* property_name,
                                                        GError** error,
                                                        gpointer user_data);
static gboolean gnome_media_keys_dbus_interface_set_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GVariant* value,
                                                       GError** error,
                                                       gpointer user_data);
static void _dbus_gnome_media_keys_media_player_key_pressed (GObject* _sender,
                                                      const gchar* application,
                                                      const gchar* key,
                                                      gpointer* _data);
static void _gnome_media_keys_unregister_object (gpointer user_data);
static void music_media_key_listener_media_key_pressed (MusicMediaKeyListener* self,
                                                 GObject* bus,
                                                 const gchar* application,
                                                 const gchar* key);
static void _music_media_key_listener_media_key_pressed_gnome_media_keys_media_player_key_pressed (GnomeMediaKeys* _sender,
                                                                                            const gchar* application,
                                                                                            const gchar* key,
                                                                                            gpointer self);
static void music_media_key_listener_finalize (GObject * obj);
static GType music_media_key_listener_get_type_once (void);
static void _vala_music_media_key_listener_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);

static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_grab_media_player_keys_application = {-1, "application", "s", NULL};
static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_grab_media_player_keys_time = {-1, "time", "u", NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_grab_media_player_keys_in[] = {&_gnome_media_keys_dbus_arg_info_grab_media_player_keys_application, &_gnome_media_keys_dbus_arg_info_grab_media_player_keys_time, NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_grab_media_player_keys_out[] = {NULL};
static const GDBusMethodInfo _gnome_media_keys_dbus_method_info_grab_media_player_keys = {-1, "GrabMediaPlayerKeys", (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_grab_media_player_keys_in), (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_grab_media_player_keys_out), NULL};
static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_release_media_player_keys_application = {-1, "application", "s", NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_release_media_player_keys_in[] = {&_gnome_media_keys_dbus_arg_info_release_media_player_keys_application, NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_release_media_player_keys_out[] = {NULL};
static const GDBusMethodInfo _gnome_media_keys_dbus_method_info_release_media_player_keys = {-1, "ReleaseMediaPlayerKeys", (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_release_media_player_keys_in), (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_release_media_player_keys_out), NULL};
static const GDBusMethodInfo * const _gnome_media_keys_dbus_method_info[] = {&_gnome_media_keys_dbus_method_info_grab_media_player_keys, &_gnome_media_keys_dbus_method_info_release_media_player_keys, NULL};
static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_media_player_key_pressed_application = {-1, "application", "s", NULL};
static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_media_player_key_pressed_key = {-1, "key", "s", NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_media_player_key_pressed[] = {&_gnome_media_keys_dbus_arg_info_media_player_key_pressed_application, &_gnome_media_keys_dbus_arg_info_media_player_key_pressed_key, NULL};
static const GDBusSignalInfo _gnome_media_keys_dbus_signal_info_media_player_key_pressed = {-1, "MediaPlayerKeyPressed", (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_media_player_key_pressed), NULL};
static const GDBusSignalInfo * const _gnome_media_keys_dbus_signal_info[] = {&_gnome_media_keys_dbus_signal_info_media_player_key_pressed, NULL};
static const GDBusPropertyInfo * const _gnome_media_keys_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gnome_media_keys_dbus_interface_info = {-1, "org.gnome.SettingsDaemon.MediaKeys", (GDBusMethodInfo **) (&_gnome_media_keys_dbus_method_info), (GDBusSignalInfo **) (&_gnome_media_keys_dbus_signal_info), (GDBusPropertyInfo **) (&_gnome_media_keys_dbus_property_info), NULL};
static const GDBusInterfaceVTable _gnome_media_keys_dbus_interface_vtable = {gnome_media_keys_dbus_interface_method_call, gnome_media_keys_dbus_interface_get_property, gnome_media_keys_dbus_interface_set_property};

void
gnome_media_keys_grab_media_player_keys (GnomeMediaKeys* self,
                                         const gchar* application,
                                         guint32 time,
                                         GError** error)
{
	GnomeMediaKeysIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = GNOME_MEDIA_KEYS_GET_INTERFACE (self);
	if (_iface_->grab_media_player_keys) {
		_iface_->grab_media_player_keys (self, application, time, error);
	}
}

void
gnome_media_keys_release_media_player_keys (GnomeMediaKeys* self,
                                            const gchar* application,
                                            GError** error)
{
	GnomeMediaKeysIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = GNOME_MEDIA_KEYS_GET_INTERFACE (self);
	if (_iface_->release_media_player_keys) {
		_iface_->release_media_player_keys (self, application, error);
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
gnome_media_keys_default_init (GnomeMediaKeysIface * iface,
                               gpointer iface_data)
{
	gnome_media_keys_signals[GNOME_MEDIA_KEYS_MEDIA_PLAYER_KEY_PRESSED_SIGNAL] = g_signal_new ("media-player-key-pressed", TYPE_GNOME_MEDIA_KEYS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}

static GType
gnome_media_keys_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnomeMediaKeysIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_media_keys_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gnome_media_keys_type_id;
	gnome_media_keys_type_id = g_type_register_static (G_TYPE_INTERFACE, "GnomeMediaKeys", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gnome_media_keys_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (gnome_media_keys_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) gnome_media_keys_proxy_get_type);
	g_type_set_qdata (gnome_media_keys_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SettingsDaemon.MediaKeys");
	g_type_set_qdata (gnome_media_keys_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_gnome_media_keys_dbus_interface_info));
	g_type_set_qdata (gnome_media_keys_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gnome_media_keys_register_object);
	return gnome_media_keys_type_id;
}

GType
gnome_media_keys_get_type (void)
{
	static volatile gsize gnome_media_keys_type_id__once = 0;
	if (g_once_init_enter (&gnome_media_keys_type_id__once)) {
		GType gnome_media_keys_type_id;
		gnome_media_keys_type_id = gnome_media_keys_get_type_once ();
		g_once_init_leave (&gnome_media_keys_type_id__once, gnome_media_keys_type_id);
	}
	return gnome_media_keys_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (GnomeMediaKeysProxy, gnome_media_keys_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_GNOME_MEDIA_KEYS, gnome_media_keys_proxy_gnome_media_keys_interface_init) )
static void
gnome_media_keys_proxy_class_init (GnomeMediaKeysProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = gnome_media_keys_proxy_g_signal;
}

static void
_dbus_handle_gnome_media_keys_media_player_key_pressed (GnomeMediaKeys* self,
                                                        GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* application = NULL;
	GVariant* _tmp4_;
	gchar* key = NULL;
	GVariant* _tmp5_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	application = g_variant_dup_string (_tmp4_, NULL);
	g_variant_unref (_tmp4_);
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	key = g_variant_dup_string (_tmp5_, NULL);
	g_variant_unref (_tmp5_);
	g_signal_emit_by_name (self, "media-player-key-pressed", application, key);
	_g_free0 (application);
	_g_free0 (key);
}

static void
gnome_media_keys_proxy_g_signal (GDBusProxy* proxy,
                                 const gchar* sender_name,
                                 const gchar* signal_name,
                                 GVariant* parameters)
{
	if (strcmp (signal_name, "MediaPlayerKeyPressed") == 0) {
		_dbus_handle_gnome_media_keys_media_player_key_pressed ((GnomeMediaKeys*) proxy, parameters);
	}
}

static void
gnome_media_keys_proxy_init (GnomeMediaKeysProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_gnome_media_keys_dbus_interface_info));
}

static void
gnome_media_keys_proxy_grab_media_player_keys (GnomeMediaKeys* self,
                                               const gchar* application,
                                               guint32 time,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SettingsDaemon.MediaKeys", "GrabMediaPlayerKeys");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (application));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (time));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
gnome_media_keys_proxy_release_media_player_keys (GnomeMediaKeys* self,
                                                  const gchar* application,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SettingsDaemon.MediaKeys", "ReleaseMediaPlayerKeys");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (application));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
gnome_media_keys_proxy_gnome_media_keys_interface_init (GnomeMediaKeysIface* iface)
{
	iface->grab_media_player_keys = gnome_media_keys_proxy_grab_media_player_keys;
	iface->release_media_player_keys = gnome_media_keys_proxy_release_media_player_keys;
}

static void
_dbus_gnome_media_keys_grab_media_player_keys (GnomeMediaKeys* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* application = NULL;
	GVariant* _tmp6_;
	guint32 time = 0U;
	GVariant* _tmp7_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	application = g_variant_dup_string (_tmp6_, NULL);
	g_variant_unref (_tmp6_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	time = g_variant_get_uint32 (_tmp7_);
	g_variant_unref (_tmp7_);
	gnome_media_keys_grab_media_player_keys (self, application, time, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (application);
	;
}

static void
_dbus_gnome_media_keys_release_media_player_keys (GnomeMediaKeys* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* application = NULL;
	GVariant* _tmp8_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	application = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	gnome_media_keys_release_media_player_keys (self, application, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (application);
	;
}

static void
gnome_media_keys_dbus_interface_method_call (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* method_name,
                                             GVariant* parameters,
                                             GDBusMethodInvocation* invocation,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GrabMediaPlayerKeys") == 0) {
		_dbus_gnome_media_keys_grab_media_player_keys (object, parameters, invocation);
	} else if (strcmp (method_name, "ReleaseMediaPlayerKeys") == 0) {
		_dbus_gnome_media_keys_release_media_player_keys (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
gnome_media_keys_dbus_interface_get_property (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GError** error,
                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
gnome_media_keys_dbus_interface_set_property (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GVariant* value,
                                              GError** error,
                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_gnome_media_keys_media_player_key_pressed (GObject* _sender,
                                                 const gchar* application,
                                                 const gchar* key,
                                                 gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (application));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (key));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.SettingsDaemon.MediaKeys", "MediaPlayerKeyPressed", _arguments, NULL);
}

guint
gnome_media_keys_register_object (gpointer object,
                                  GDBusConnection* connection,
                                  const gchar* path,
                                  GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gnome_media_keys_dbus_interface_info), &_gnome_media_keys_dbus_interface_vtable, data, _gnome_media_keys_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "media-player-key-pressed", (GCallback) _dbus_gnome_media_keys_media_player_key_pressed, data);
	return result;
}

static void
_gnome_media_keys_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gnome_media_keys_media_player_key_pressed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
music_media_key_listener_get_instance_private (MusicMediaKeyListener* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMediaKeyListener_private_offset);
}

static void
_music_media_key_listener_media_key_pressed_gnome_media_keys_media_player_key_pressed (GnomeMediaKeys* _sender,
                                                                                       const gchar* application,
                                                                                       const gchar* key,
                                                                                       gpointer self)
{
	music_media_key_listener_media_key_pressed ((MusicMediaKeyListener*) self, _sender, application, key);
}

void
music_media_key_listener_init (MusicMediaKeyListener* self)
{
	GnomeMediaKeys* _tmp0_;
	GnomeMediaKeys* _tmp6_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->media_object;
	_vala_assert (_tmp0_ == NULL, "media_object == null");
	{
		GnomeMediaKeys* _tmp1_ = NULL;
		GnomeMediaKeys* _tmp2_;
		GnomeMediaKeys* _tmp3_;
		_tmp2_ = (GnomeMediaKeys*) g_initable_new (TYPE_GNOME_MEDIA_KEYS_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.gnome.SettingsDaemon.MediaKeys", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SettingsDaemon/MediaKeys", "g-interface-name", "org.gnome.SettingsDaemon.MediaKeys", NULL);
		_tmp1_ = (GnomeMediaKeys*) _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (self->priv->media_object);
		self->priv->media_object = _tmp3_;
		_g_object_unref0 (_tmp1_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("MediaKeyListener.vala:56: Mediakeys error: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp6_ = self->priv->media_object;
	if (_tmp6_ != NULL) {
		GnomeMediaKeys* _tmp7_;
		_tmp7_ = self->priv->media_object;
		g_signal_connect_object (_tmp7_, "media-player-key-pressed", (GCallback) _music_media_key_listener_media_key_pressed_gnome_media_keys_media_player_key_pressed, self, 0);
		{
			GnomeMediaKeys* _tmp8_;
			_tmp8_ = self->priv->media_object;
			gnome_media_keys_grab_media_player_keys (_tmp8_, BUILD_EXEC_NAME, (guint32) 0, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
			err = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp9_ = err;
			_tmp10_ = _tmp9_->message;
			g_warning ("MediaKeyListener.vala:64: Could not grab media player keys: %s", _tmp10_);
			_g_error_free0 (err);
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
music_media_key_listener_release_media_keys (MusicMediaKeyListener* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GnomeMediaKeys* _tmp0_;
		_tmp0_ = self->priv->media_object;
		gnome_media_keys_release_media_player_keys (_tmp0_, BUILD_EXEC_NAME, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = err;
		_tmp2_ = _tmp1_->message;
		g_warning ("MediaKeyListener.vala:73: Could not release media player keys: %s", _tmp2_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
music_media_key_listener_media_key_pressed (MusicMediaKeyListener* self,
                                            GObject* bus,
                                            const gchar* application,
                                            const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (bus != NULL);
	g_return_if_fail (application != NULL);
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (application, BUILD_EXEC_NAME) != 0) {
		return;
	}
	_tmp0_ = key;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("Previous")))) {
		switch (0) {
			default:
			{
				MusicLibraryWindow* _tmp3_;
				MusicLibraryWindow* _tmp4_;
				_tmp3_ = music_app_get_main_window ();
				_tmp4_ = _tmp3_;
				music_library_window_play_previous_media (_tmp4_, FALSE);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Play")))) {
		switch (0) {
			default:
			{
				MusicLibraryWindow* _tmp5_;
				MusicLibraryWindow* _tmp6_;
				_tmp5_ = music_app_get_main_window ();
				_tmp6_ = _tmp5_;
				music_library_window_play_media (_tmp6_, FALSE);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Next")))) {
		switch (0) {
			default:
			{
				MusicLibraryWindow* _tmp7_;
				MusicLibraryWindow* _tmp8_;
				_tmp7_ = music_app_get_main_window ();
				_tmp8_ = _tmp7_;
				music_library_window_play_next_media (_tmp8_, FALSE);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_message ("MediaKeyListener.vala:93: Unused key pressed: %s", key);
				break;
			}
		}
	}
}

MusicMediaKeyListener*
music_media_key_listener_construct (GType object_type)
{
	MusicMediaKeyListener * self = NULL;
	self = (MusicMediaKeyListener*) g_object_new (object_type, NULL);
	return self;
}

MusicMediaKeyListener*
music_media_key_listener_new (void)
{
	return music_media_key_listener_construct (MUSIC_TYPE_MEDIA_KEY_LISTENER);
}

MusicMediaKeyListener*
music_media_key_listener_get_instance (void)
{
	MusicMediaKeyListener* result;
	MusicMediaKeyListener* _tmp0_;
	MusicMediaKeyListener* _tmp2_;
	_tmp0_ = music_media_key_listener__instance;
	if (_tmp0_ == NULL) {
		MusicMediaKeyListener* _tmp1_;
		_tmp1_ = music_media_key_listener_new ();
		_g_object_unref0 (music_media_key_listener__instance);
		music_media_key_listener__instance = _tmp1_;
	}
	_tmp2_ = music_media_key_listener__instance;
	result = _tmp2_;
	return result;
}

static void
music_media_key_listener_class_init (MusicMediaKeyListenerClass * klass,
                                     gpointer klass_data)
{
	music_media_key_listener_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicMediaKeyListener_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_media_key_listener_get_property;
	G_OBJECT_CLASS (klass)->finalize = music_media_key_listener_finalize;
}

static void
music_media_key_listener_instance_init (MusicMediaKeyListener * self,
                                        gpointer klass)
{
	self->priv = music_media_key_listener_get_instance_private (self);
}

static void
music_media_key_listener_finalize (GObject * obj)
{
	MusicMediaKeyListener * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA_KEY_LISTENER, MusicMediaKeyListener);
	_g_object_unref0 (self->priv->media_object);
	G_OBJECT_CLASS (music_media_key_listener_parent_class)->finalize (obj);
}

static GType
music_media_key_listener_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaKeyListenerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_key_listener_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMediaKeyListener), 0, (GInstanceInitFunc) music_media_key_listener_instance_init, NULL };
	GType music_media_key_listener_type_id;
	music_media_key_listener_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicMediaKeyListener", &g_define_type_info, 0);
	MusicMediaKeyListener_private_offset = g_type_add_instance_private (music_media_key_listener_type_id, sizeof (MusicMediaKeyListenerPrivate));
	return music_media_key_listener_type_id;
}

GType
music_media_key_listener_get_type (void)
{
	static volatile gsize music_media_key_listener_type_id__once = 0;
	if (g_once_init_enter (&music_media_key_listener_type_id__once)) {
		GType music_media_key_listener_type_id;
		music_media_key_listener_type_id = music_media_key_listener_get_type_once ();
		g_once_init_leave (&music_media_key_listener_type_id__once, music_media_key_listener_type_id);
	}
	return music_media_key_listener_type_id__once;
}

static void
_vala_music_media_key_listener_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	MusicMediaKeyListener * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA_KEY_LISTENER, MusicMediaKeyListener);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

