/* AlbumsView.c generated by valac 0.55.1, the Vala compiler
 * generated from AlbumsView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_ALBUMS_VIEW_0_PROPERTY,
	MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY,
	MUSIC_ALBUMS_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_albums_view_properties[MUSIC_ALBUMS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MusicAlbumsViewPrivate {
	MusicFastGrid* icon_view;
	MusicViewWrapper* _parent_view_wrapper;
};

static gint MusicAlbumsView_private_offset;
static gpointer music_albums_view_parent_class = NULL;
static MusicAlbumListGrid* music_albums_view__popup;
static MusicAlbumListGrid* music_albums_view__popup = NULL;
static MusicViewInterfaceIface * music_albums_view_music_view_interface_parent_iface = NULL;

static void music_albums_view_on_item_selected (MusicAlbumsView* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static void music_albums_view_on_item_activated (MusicAlbumsView* self,
                                          GtkTreePath* path);
static MusicAlbumListGrid* music_albums_view_get_popup_list_view (MusicAlbumsView* self);
static void music_albums_view_on_drag_begin (MusicAlbumsView* self,
                                      GtkWidget* sender,
                                      GdkDragContext* context);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void music_albums_view_on_drag_data_get (MusicAlbumsView* self,
                                         GdkDragContext* context,
                                         GtkSelectionData* selection_data,
                                         guint info,
                                         guint time_);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GeeCollection* music_albums_view_real_get_visible_media (MusicViewInterface* base);
static GeeCollection* music_albums_view_get_visible_albums (MusicAlbumsView* self);
static GeeCollection* music_albums_view_real_get_media (MusicViewInterface* base);
static GeeCollection* music_albums_view_get_albums (MusicAlbumsView* self);
static void music_albums_view_real_refilter (MusicViewInterface* base);
static void music_albums_view_real_update_media (MusicViewInterface* base,
                                          GeeCollection* media);
static void _gtk_widget_queue_draw_music_album_cover_rendered (MusicAlbum* _sender,
                                                        gpointer self);
static void _gtk_widget_queue_draw_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static void music_albums_view_real_set_media (MusicViewInterface* base,
                                       GeeCollection* to_add);
static void music_albums_view_real_add_media (MusicViewInterface* base,
                                       GeeCollection* media);
static void music_albums_view_real_remove_media (MusicViewInterface* base,
                                          GeeCollection* to_remove);
static gint __lambda55_ (MusicAlbumsView* self,
                  MusicAlbum* a,
                  MusicAlbum* b);
static gint ___lambda55__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static GObject * music_albums_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static gint _music_albums_view_compare_func_music_fast_grid_sort_compare_func (GObject* a,
                                                                        GObject* b,
                                                                        gpointer self);
static void _music_albums_view_search_func_music_fast_grid_view_search_func (GeeHashMap* showing,
                                                                      gpointer self);
static void _music_albums_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self);
static void _music_albums_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   GtkSelectionData* selection_data,
                                                                   guint info,
                                                                   guint time_,
                                                                   gpointer self);
static void _music_albums_view_on_item_activated_gtk_icon_view_item_activated (GtkIconView* _sender,
                                                                        GtkTreePath* path,
                                                                        gpointer self);
static void _music_albums_view_on_item_selected_gtk_icon_view_selection_changed (GtkIconView* _sender,
                                                                          gpointer self);
static void _music_albums_view___lambda56_ (MusicAlbumsView* self);
static void __music_albums_view___lambda56__g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _music_albums_view___lambda57_ (MusicAlbumsView* self);
static void __music_albums_view___lambda57__music_library_search_finished (MusicLibrary* _sender,
                                                                    gpointer self);
static void music_albums_view_finalize (GObject * obj);
static GType music_albums_view_get_type_once (void);
static void _vala_music_albums_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_music_albums_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_albums_view_get_instance_private (MusicAlbumsView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicAlbumsView_private_offset);
}

MusicAlbumsView*
music_albums_view_construct (GType object_type,
                             MusicViewWrapper* view_wrapper)
{
	MusicAlbumsView * self = NULL;
	g_return_val_if_fail (view_wrapper != NULL, NULL);
	self = (MusicAlbumsView*) g_object_new (object_type, "parent-view-wrapper", view_wrapper, NULL);
	return self;
}

MusicAlbumsView*
music_albums_view_new (MusicViewWrapper* view_wrapper)
{
	return music_albums_view_construct (MUSIC_TYPE_ALBUMS_VIEW, view_wrapper);
}

void
music_albums_view_clear_objects (MusicAlbumsView* self)
{
	MusicFastGrid* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->icon_view;
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_tmp2_ = _tmp1_;
	music_fast_grid_set_table (_tmp0_, _tmp2_, TRUE);
	_g_object_unref0 (_tmp2_);
}

GeeCollection*
music_albums_view_get_objects (MusicAlbumsView* self)
{
	MusicFastGrid* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->icon_view;
	_tmp1_ = music_fast_grid_get_table (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_map_get_values (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp2_);
	result = _tmp5_;
	return result;
}

GeeCollection*
music_albums_view_get_visible_objects (MusicAlbumsView* self)
{
	MusicFastGrid* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->icon_view;
	_tmp1_ = music_fast_grid_get_visible_table (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_map_get_values (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp2_);
	result = _tmp5_;
	return result;
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
}

static void
music_albums_view_on_item_selected (MusicAlbumsView* self)
{
	GList* path = NULL;
	MusicFastGrid* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GObject* obj = NULL;
	MusicFastGrid* _tmp3_;
	GList* _tmp4_;
	gconstpointer _tmp5_;
	gint _tmp6_ = 0;
	gint* _tmp7_;
	gint _tmp8_;
	GObject* _tmp9_;
	GObject* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->icon_view;
	_tmp1_ = gtk_icon_view_get_selected_items ((GtkIconView*) _tmp0_);
	path = _tmp1_;
	_tmp2_ = path;
	if (_tmp2_ == NULL) {
		music_albums_view_item_activated (self, NULL);
		(path == NULL) ? NULL : (path = (_g_list_free___vala_GtkTreePath_free0_ (path), NULL));
		return;
	}
	_tmp3_ = self->priv->icon_view;
	_tmp4_ = path;
	_tmp5_ = _tmp4_->data;
	_tmp7_ = gtk_tree_path_get_indices_with_depth ((GtkTreePath*) _tmp5_, &_tmp6_);
	_tmp8_ = _tmp7_[0];
	_tmp9_ = music_fast_grid_get_object_from_index (_tmp3_, _tmp8_);
	obj = _tmp9_;
	_tmp10_ = obj;
	music_albums_view_item_activated (self, _tmp10_);
	_g_object_unref0 (obj);
	(path == NULL) ? NULL : (path = (_g_list_free___vala_GtkTreePath_free0_ (path), NULL));
}

static void
music_albums_view_on_item_activated (MusicAlbumsView* self,
                                     GtkTreePath* path)
{
	MusicAlbumListGrid* _tmp0_;
	MusicAlbumListGrid* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_albums_view_get_popup_list_view (self);
	_tmp1_ = _tmp0_;
	music_album_list_grid_play_active_list (_tmp1_);
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
	return g_boxed_copy (gtk_tree_path_get_type (), self);
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
	return self ? _vala_GtkTreePath_copy (self) : NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_albums_view_on_drag_begin (MusicAlbumsView* self,
                                 GtkWidget* sender,
                                 GdkDragContext* context)
{
	GList* selected_items = NULL;
	MusicFastGrid* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (context != NULL);
	g_debug ("AlbumsView.vala:114: drag begin");
	_tmp0_ = self->priv->icon_view;
	_tmp1_ = gtk_icon_view_get_selected_items ((GtkIconView*) _tmp0_);
	selected_items = _tmp1_;
	_tmp2_ = selected_items;
	if (g_list_length (_tmp2_) > ((guint) 0)) {
		GtkTreePath* path = NULL;
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GtkTreePath* _tmp5_;
		GObject* obj = NULL;
		MusicFastGrid* _tmp6_;
		GtkTreePath* _tmp7_;
		gint _tmp8_ = 0;
		gint* _tmp9_;
		gint _tmp10_;
		GObject* _tmp11_;
		GIcon* drag_icon = NULL;
		GObject* _tmp12_;
		GIcon* _tmp13_;
		GIcon* _tmp14_;
		GIcon* _tmp15_;
		GIcon* _tmp16_;
		_tmp3_ = selected_items;
		_tmp4_ = g_list_nth_data (_tmp3_, (guint) 0);
		_tmp5_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp4_);
		path = _tmp5_;
		_tmp6_ = self->priv->icon_view;
		_tmp7_ = path;
		_tmp9_ = gtk_tree_path_get_indices_with_depth (_tmp7_, &_tmp8_);
		_tmp10_ = _tmp9_[0];
		_tmp11_ = music_fast_grid_get_object_from_index (_tmp6_, _tmp10_);
		obj = _tmp11_;
		_tmp12_ = obj;
		_tmp13_ = music_album_get_cover_icon (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, MUSIC_TYPE_ALBUM, MusicAlbum));
		_tmp14_ = _tmp13_;
		_tmp15_ = _g_object_ref0 (_tmp14_);
		drag_icon = _tmp15_;
		_tmp16_ = drag_icon;
		gtk_drag_set_icon_gicon (context, _tmp16_, 0, 0);
		_g_object_unref0 (drag_icon);
		_g_object_unref0 (obj);
		__vala_GtkTreePath_free0 (path);
	}
	(selected_items == NULL) ? NULL : (selected_items = (_g_list_free___vala_GtkTreePath_free0_ (selected_items), NULL));
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
music_albums_view_on_drag_data_get (MusicAlbumsView* self,
                                    GdkDragContext* context,
                                    GtkSelectionData* selection_data,
                                    guint info,
                                    guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	GList* selected_items = NULL;
	MusicFastGrid* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GtkTreePath* path = NULL;
	GList* _tmp3_;
	gconstpointer _tmp4_;
	GtkTreePath* _tmp5_;
	GObject* obj = NULL;
	MusicFastGrid* _tmp6_;
	GtkTreePath* _tmp7_;
	gint _tmp8_ = 0;
	gint* _tmp9_;
	gint _tmp10_;
	GObject* _tmp11_;
	GObject* _tmp12_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	uris = NULL;
	uris_length1 = 0;
	_uris_size_ = uris_length1;
	_tmp0_ = self->priv->icon_view;
	_tmp1_ = gtk_icon_view_get_selected_items ((GtkIconView*) _tmp0_);
	selected_items = _tmp1_;
	_tmp2_ = selected_items;
	if (g_list_length (_tmp2_) <= ((guint) 0)) {
		(selected_items == NULL) ? NULL : (selected_items = (_g_list_free___vala_GtkTreePath_free0_ (selected_items), NULL));
		uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_tmp3_ = selected_items;
	_tmp4_ = g_list_nth_data (_tmp3_, (guint) 0);
	_tmp5_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp4_);
	path = _tmp5_;
	_tmp6_ = self->priv->icon_view;
	_tmp7_ = path;
	_tmp9_ = gtk_tree_path_get_indices_with_depth (_tmp7_, &_tmp8_);
	_tmp10_ = _tmp9_[0];
	_tmp11_ = music_fast_grid_get_object_from_index (_tmp6_, _tmp10_);
	obj = _tmp11_;
	_tmp12_ = obj;
	if (_tmp12_ == NULL) {
		_g_object_unref0 (obj);
		__vala_GtkTreePath_free0 (path);
		(selected_items == NULL) ? NULL : (selected_items = (_g_list_free___vala_GtkTreePath_free0_ (selected_items), NULL));
		uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	{
		GeeIterator* _m_it = NULL;
		GObject* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
		_tmp13_ = obj;
		_tmp14_ = music_albums_view_get_selected_media (self, _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
		_tmp17_ = _tmp16_;
		_g_object_unref0 (_tmp15_);
		_m_it = _tmp17_;
		while (TRUE) {
			GeeIterator* _tmp18_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			MusicMedia* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			_tmp18_ = _m_it;
			if (!gee_iterator_next (_tmp18_)) {
				break;
			}
			_tmp19_ = _m_it;
			_tmp20_ = gee_iterator_get (_tmp19_);
			m = (MusicMedia*) _tmp20_;
			_tmp21_ = m;
			_tmp22_ = music_media_get_uri (_tmp21_);
			_tmp23_ = _tmp22_;
			_vala_array_add4 (&uris, &uris_length1, &_uris_size_, _tmp23_);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp24_ = uris;
	_tmp24__length1 = uris_length1;
	if (_tmp24_ != NULL) {
		gchar** _tmp25_;
		gint _tmp25__length1;
		_tmp25_ = uris;
		_tmp25__length1 = uris_length1;
		gtk_selection_data_set_uris (selection_data, _tmp25_);
	}
	_g_object_unref0 (obj);
	__vala_GtkTreePath_free0 (path);
	(selected_items == NULL) ? NULL : (selected_items = (_g_list_free___vala_GtkTreePath_free0_ (selected_items), NULL));
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
}

static GeeCollection*
music_albums_view_real_get_visible_media (MusicViewInterface* base)
{
	MusicAlbumsView * self;
	GeeTreeSet* all_visible_media = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
	self = (MusicAlbumsView*) base;
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	all_visible_media = _tmp0_;
	{
		GeeIterator* _album_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp1_ = music_albums_view_get_visible_albums (self);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_album_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			MusicAlbum* album = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeCollection* album_media = NULL;
			MusicAlbum* _tmp8_;
			GeeCollection* _tmp9_;
			GeeTreeSet* _tmp10_;
			GeeCollection* _tmp11_;
			_tmp5_ = _album_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _album_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			album = (MusicAlbum*) _tmp7_;
			_tmp8_ = album;
			_tmp9_ = music_album_get_media (_tmp8_, (guint) 1);
			album_media = _tmp9_;
			_tmp10_ = all_visible_media;
			_tmp11_ = album_media;
			gee_collection_add_all ((GeeCollection*) _tmp10_, _tmp11_);
			_g_object_unref0 (album_media);
			_g_object_unref0 (album);
		}
		_g_object_unref0 (_album_it);
	}
	result = (GeeCollection*) all_visible_media;
	return result;
}

static GeeCollection*
music_albums_view_real_get_media (MusicViewInterface* base)
{
	MusicAlbumsView * self;
	GeeTreeSet* all_media = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
	self = (MusicAlbumsView*) base;
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	all_media = _tmp0_;
	{
		GeeIterator* _album_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp1_ = music_albums_view_get_albums (self);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_album_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			MusicAlbum* album = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeCollection* album_media = NULL;
			MusicAlbum* _tmp8_;
			GeeCollection* _tmp9_;
			GeeTreeSet* _tmp10_;
			GeeCollection* _tmp11_;
			_tmp5_ = _album_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _album_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			album = (MusicAlbum*) _tmp7_;
			_tmp8_ = album;
			_tmp9_ = music_album_get_media (_tmp8_, (guint) 1);
			album_media = _tmp9_;
			_tmp10_ = all_media;
			_tmp11_ = album_media;
			gee_collection_add_all ((GeeCollection*) _tmp10_, _tmp11_);
			_g_object_unref0 (album_media);
			_g_object_unref0 (album);
		}
		_g_object_unref0 (_album_it);
	}
	result = (GeeCollection*) all_media;
	return result;
}

static GeeCollection*
music_albums_view_get_visible_albums (MusicAlbumsView* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_albums_view_get_visible_objects (self);
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
	return result;
}

static GeeCollection*
music_albums_view_get_albums (MusicAlbumsView* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_albums_view_get_objects (self);
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
	return result;
}

static void
music_albums_view_real_refilter (MusicViewInterface* base)
{
	MusicAlbumsView * self;
	MusicFastGrid* _tmp0_;
	self = (MusicAlbumsView*) base;
	_tmp0_ = self->priv->icon_view;
	music_fast_grid_do_search (_tmp0_);
}

static void
_gtk_widget_queue_draw_music_album_cover_rendered (MusicAlbum* _sender,
                                                   gpointer self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
_gtk_widget_queue_draw_g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
music_albums_view_real_update_media (MusicViewInterface* base,
                                     GeeCollection* media)
{
	MusicAlbumsView * self;
	GeeTreeSet* medias_to_update = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* medias_to_add = NULL;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* albums_to_remove = NULL;
	GeeTreeSet* _tmp3_;
	MusicFastGrid* _tmp31_;
	GeeTreeSet* _tmp32_;
	GeeTreeSet* _tmp33_;
	MusicFastGrid* _tmp34_;
	self = (MusicAlbumsView*) base;
	g_return_if_fail (media != NULL);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	medias_to_update = _tmp0_;
	_tmp1_ = medias_to_update;
	gee_collection_add_all ((GeeCollection*) _tmp1_, media);
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	medias_to_add = _tmp2_;
	_tmp3_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	albums_to_remove = _tmp3_;
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp4_ = medias_to_update;
		_tmp5_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp4_);
		_m_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MusicMedia* _tmp9_;
			MusicAlbum* album = NULL;
			MusicMedia* _tmp10_;
			MusicAlbum* _tmp11_;
			MusicAlbum* _tmp12_;
			MusicAlbum* _tmp13_;
			MusicAlbum* _tmp14_;
			MusicAlbum* _tmp15_;
			MusicMedia* _tmp16_;
			_tmp6_ = _m_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _m_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			m = (MusicMedia*) _tmp8_;
			_tmp9_ = m;
			if (_tmp9_ == NULL) {
				_g_object_unref0 (m);
				continue;
			}
			_tmp10_ = m;
			_tmp11_ = music_media_get_album_info (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = _g_object_ref0 (_tmp12_);
			album = _tmp13_;
			_tmp14_ = album;
			if (_tmp14_ == NULL) {
				_g_object_unref0 (album);
				_g_object_unref0 (m);
				continue;
			}
			_tmp15_ = album;
			_tmp16_ = m;
			if (!music_album_is_compatible (_tmp15_, _tmp16_)) {
				GeeTreeSet* _tmp17_;
				MusicMedia* _tmp18_;
				MusicAlbum* _tmp19_;
				MusicMedia* _tmp20_;
				MusicAlbum* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
				_tmp17_ = medias_to_add;
				_tmp18_ = m;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
				_tmp19_ = album;
				_tmp20_ = m;
				music_album_remove_media (_tmp19_, _tmp20_);
				_tmp21_ = album;
				_tmp22_ = music_album_get_is_empty (_tmp21_);
				_tmp23_ = _tmp22_;
				if (_tmp23_ == TRUE) {
					MusicAlbum* _tmp24_;
					guint _tmp25_;
					MusicAlbum* _tmp26_;
					guint _tmp27_;
					GQuark _tmp28_;
					GeeTreeSet* _tmp29_;
					MusicAlbum* _tmp30_;
					_tmp24_ = album;
					g_signal_parse_name ("cover-rendered", MUSIC_TYPE_ALBUM, &_tmp25_, NULL, FALSE);
					g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _gtk_widget_queue_draw_music_album_cover_rendered, (GtkWidget*) self);
					_tmp26_ = album;
					g_signal_parse_name ("notify::cover-icon", G_TYPE_OBJECT, &_tmp27_, &_tmp28_, TRUE);
					g_signal_handlers_disconnect_matched ((GObject*) _tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, _tmp28_, NULL, (GCallback) _gtk_widget_queue_draw_g_object_notify, (GtkWidget*) self);
					_tmp29_ = albums_to_remove;
					_tmp30_ = album;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
				}
			}
			_g_object_unref0 (album);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp31_ = self->priv->icon_view;
	_tmp32_ = albums_to_remove;
	music_fast_grid_remove_objects (_tmp31_, (GeeCollection*) _tmp32_);
	_tmp33_ = medias_to_add;
	music_view_interface_add_media ((MusicViewInterface*) self, (GeeCollection*) _tmp33_);
	_tmp34_ = self->priv->icon_view;
	_tmp34_->research_needed = TRUE;
	_g_object_unref0 (albums_to_remove);
	_g_object_unref0 (medias_to_add);
	_g_object_unref0 (medias_to_update);
}

static void
music_albums_view_real_set_media (MusicViewInterface* base,
                                  GeeCollection* to_add)
{
	MusicAlbumsView * self;
	self = (MusicAlbumsView*) base;
	g_return_if_fail (to_add != NULL);
	music_albums_view_clear_objects (self);
	music_view_interface_add_media ((MusicViewInterface*) self, to_add);
}

static void
music_albums_view_real_add_media (MusicViewInterface* base,
                                  GeeCollection* media)
{
	MusicAlbumsView * self;
	GeeTreeSet* medias_to_add = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* albums_to_append = NULL;
	GeeTreeSet* _tmp2_;
	GeeCollection* albums = NULL;
	GeeCollection* _tmp3_;
	GeeTreeSet* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	MusicFastGrid* _tmp22_;
	GeeTreeSet* _tmp23_;
	MusicFastGrid* _tmp24_;
	self = (MusicAlbumsView*) base;
	g_return_if_fail (media != NULL);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	medias_to_add = _tmp0_;
	_tmp1_ = medias_to_add;
	gee_collection_add_all ((GeeCollection*) _tmp1_, media);
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	albums_to_append = _tmp2_;
	_tmp3_ = music_albums_view_get_albums (self);
	albums = _tmp3_;
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp4_ = medias_to_add;
		_tmp5_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp4_);
		_m_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MusicAlbum* album = NULL;
			MusicMedia* _tmp9_;
			MusicAlbum* _tmp10_;
			MusicAlbum* _tmp11_;
			MusicAlbum* _tmp12_;
			GeeCollection* _tmp13_;
			MusicAlbum* _tmp14_;
			_tmp6_ = _m_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _m_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			m = (MusicMedia*) _tmp8_;
			_tmp9_ = m;
			_tmp10_ = music_media_get_album_info (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = _g_object_ref0 (_tmp11_);
			album = _tmp12_;
			_tmp13_ = albums;
			_tmp14_ = album;
			if (!gee_collection_contains (_tmp13_, _tmp14_)) {
				GeeTreeSet* _tmp15_;
				MusicAlbum* _tmp16_;
				MusicAlbum* _tmp17_;
				MusicAlbum* _tmp18_;
				_tmp15_ = albums_to_append;
				_tmp16_ = album;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
				_tmp17_ = album;
				g_signal_connect_object (_tmp17_, "cover-rendered", (GCallback) _gtk_widget_queue_draw_music_album_cover_rendered, (GtkWidget*) self, 0);
				_tmp18_ = album;
				g_signal_connect_object ((GObject*) _tmp18_, "notify::cover-icon", (GCallback) _gtk_widget_queue_draw_g_object_notify, (GtkWidget*) self, 0);
			}
			_g_object_unref0 (album);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp19_ = albums_to_append;
	_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
	_tmp21_ = _tmp20_;
	if (_tmp21_ <= 0) {
		_g_object_unref0 (albums);
		_g_object_unref0 (albums_to_append);
		_g_object_unref0 (medias_to_add);
		return;
	}
	_tmp22_ = self->priv->icon_view;
	_tmp23_ = albums_to_append;
	music_fast_grid_add_objects (_tmp22_, (GeeCollection*) _tmp23_);
	_tmp24_ = self->priv->icon_view;
	_tmp24_->research_needed = TRUE;
	_g_object_unref0 (albums);
	_g_object_unref0 (albums_to_append);
	_g_object_unref0 (medias_to_add);
}

static void
music_albums_view_real_remove_media (MusicViewInterface* base,
                                     GeeCollection* to_remove)
{
	MusicAlbumsView * self;
	GeeTreeSet* albums_to_remove = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	MusicFastGrid* _tmp26_;
	GeeTreeSet* _tmp27_;
	MusicFastGrid* _tmp28_;
	self = (MusicAlbumsView*) base;
	g_return_if_fail (to_remove != NULL);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	albums_to_remove = _tmp0_;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_remove);
		_m_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicMedia* _tmp5_;
			MusicAlbum* album = NULL;
			MusicMedia* _tmp6_;
			MusicAlbum* _tmp7_;
			MusicAlbum* _tmp8_;
			MusicAlbum* _tmp9_;
			MusicAlbum* _tmp10_;
			MusicAlbum* _tmp11_;
			MusicMedia* _tmp12_;
			MusicAlbum* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
			_tmp2_ = _m_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _m_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			m = (MusicMedia*) _tmp4_;
			_tmp5_ = m;
			if (_tmp5_ == NULL) {
				_g_object_unref0 (m);
				continue;
			}
			_tmp6_ = m;
			_tmp7_ = music_media_get_album_info (_tmp6_);
			_tmp8_ = _tmp7_;
			_tmp9_ = _g_object_ref0 (_tmp8_);
			album = _tmp9_;
			_tmp10_ = album;
			if (_tmp10_ == NULL) {
				_g_object_unref0 (album);
				_g_object_unref0 (m);
				continue;
			}
			_tmp11_ = album;
			_tmp12_ = m;
			music_album_remove_media (_tmp11_, _tmp12_);
			_tmp13_ = album;
			_tmp14_ = music_album_get_is_empty (_tmp13_);
			_tmp15_ = _tmp14_;
			if (_tmp15_ == TRUE) {
				MusicAlbum* _tmp16_;
				guint _tmp17_;
				MusicAlbum* _tmp18_;
				guint _tmp19_;
				GQuark _tmp20_;
				GeeTreeSet* _tmp21_;
				MusicAlbum* _tmp22_;
				_tmp16_ = album;
				g_signal_parse_name ("cover-rendered", MUSIC_TYPE_ALBUM, &_tmp17_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _gtk_widget_queue_draw_music_album_cover_rendered, (GtkWidget*) self);
				_tmp18_ = album;
				g_signal_parse_name ("notify::cover-icon", G_TYPE_OBJECT, &_tmp19_, &_tmp20_, TRUE);
				g_signal_handlers_disconnect_matched ((GObject*) _tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, _tmp20_, NULL, (GCallback) _gtk_widget_queue_draw_g_object_notify, (GtkWidget*) self);
				_tmp21_ = albums_to_remove;
				_tmp22_ = album;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
			}
			_g_object_unref0 (album);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp23_ = albums_to_remove;
	_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
	_tmp25_ = _tmp24_;
	if (_tmp25_ <= 0) {
		_g_object_unref0 (albums_to_remove);
		return;
	}
	_tmp26_ = self->priv->icon_view;
	_tmp27_ = albums_to_remove;
	music_fast_grid_remove_objects (_tmp26_, (GeeCollection*) _tmp27_);
	_tmp28_ = self->priv->icon_view;
	_tmp28_->research_needed = TRUE;
	_g_object_unref0 (albums_to_remove);
}

void
music_albums_view_item_activated (MusicAlbumsView* self,
                                  GObject* object)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MusicAlbum* album = NULL;
	MusicAlbum* _tmp6_;
	MusicAlbum* _tmp7_;
	MusicAlbumListGrid* _tmp8_;
	MusicAlbumListGrid* _tmp9_;
	MusicViewWrapper* _tmp10_;
	MusicAlbumListGrid* _tmp11_;
	MusicAlbumListGrid* _tmp12_;
	MusicAlbum* _tmp13_;
	MusicAlbumListGrid* _tmp14_;
	MusicAlbumListGrid* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_library_window_get_initialization_finished (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		return;
	}
	if (object == NULL) {
		MusicAlbumListGrid* _tmp4_;
		MusicAlbumListGrid* _tmp5_;
		_tmp4_ = music_albums_view_get_popup_list_view (self);
		_tmp5_ = _tmp4_;
		gtk_widget_hide ((GtkWidget*) _tmp5_);
		return;
	}
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, MUSIC_TYPE_ALBUM) ? ((MusicAlbum*) object) : NULL);
	album = _tmp6_;
	_tmp7_ = album;
	g_return_if_fail (_tmp7_ != NULL);
	_tmp8_ = music_albums_view_get_popup_list_view (self);
	_tmp9_ = _tmp8_;
	_tmp10_ = self->priv->_parent_view_wrapper;
	music_album_list_grid_set_view_wrapper (_tmp9_, _tmp10_);
	_tmp11_ = music_albums_view_get_popup_list_view (self);
	_tmp12_ = _tmp11_;
	_tmp13_ = album;
	music_album_list_grid_set_album (_tmp12_, _tmp13_);
	_tmp14_ = music_albums_view_get_popup_list_view (self);
	_tmp15_ = _tmp14_;
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
	_g_object_unref0 (album);
}

gint
music_albums_view_compare_func (MusicAlbumsView* self,
                                GObject* o_a,
                                GObject* o_b)
{
	MusicAlbum* album_a = NULL;
	MusicAlbum* _tmp0_;
	MusicAlbum* album_b = NULL;
	MusicAlbum* _tmp1_;
	MusicAlbum* _tmp2_;
	MusicAlbum* _tmp5_;
	gint order = 0;
	MusicAlbum* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	MusicAlbum* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gint _tmp12_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (o_a != NULL, 0);
	g_return_val_if_fail (o_b != NULL, 0);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (o_a, MUSIC_TYPE_ALBUM) ? ((MusicAlbum*) o_a) : NULL);
	album_a = _tmp0_;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (o_b, MUSIC_TYPE_ALBUM) ? ((MusicAlbum*) o_b) : NULL);
	album_b = _tmp1_;
	_tmp2_ = album_a;
	if (_tmp2_ == NULL) {
		gint _tmp3_ = 0;
		MusicAlbum* _tmp4_;
		_tmp4_ = album_b;
		if (_tmp4_ != NULL) {
			_tmp3_ = -1;
		} else {
			_tmp3_ = 0;
		}
		result = _tmp3_;
		_g_object_unref0 (album_b);
		_g_object_unref0 (album_a);
		return result;
	}
	_tmp5_ = album_b;
	if (_tmp5_ == NULL) {
		result = 1;
		_g_object_unref0 (album_b);
		_g_object_unref0 (album_a);
		return result;
	}
	_tmp6_ = album_a;
	_tmp7_ = music_album_get_display_artist (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = album_b;
	_tmp10_ = music_album_get_display_artist (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = music_string_compare (_tmp8_, _tmp11_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	order = _tmp12_;
	if (order == 0) {
		MusicAlbum* _tmp13_;
		guint _tmp14_;
		guint _tmp15_;
		MusicAlbum* _tmp16_;
		guint _tmp17_;
		guint _tmp18_;
		_tmp13_ = album_a;
		_tmp14_ = music_album_get_year (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = album_b;
		_tmp17_ = music_album_get_year (_tmp16_);
		_tmp18_ = _tmp17_;
		order = music_compare_standard_unsigned (_tmp15_, _tmp18_);
	}
	if (order == 0) {
		MusicAlbum* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		MusicAlbum* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		_tmp19_ = album_a;
		_tmp20_ = music_album_get_display_name (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = album_b;
		_tmp23_ = music_album_get_display_name (_tmp22_);
		_tmp24_ = _tmp23_;
		order = music_string_compare (_tmp21_, _tmp24_);
		_g_free0 (_tmp24_);
		_g_free0 (_tmp21_);
	}
	result = order;
	_g_object_unref0 (album_b);
	_g_object_unref0 (album_a);
	return result;
}

static gint
__lambda55_ (MusicAlbumsView* self,
             MusicAlbum* a,
             MusicAlbum* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	guint _tmp12_;
	gint result;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = music_album_get_display_name (a);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_album_get_display_name (b);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	order = _tmp4_;
	if (order != 0) {
		result = order;
		return result;
	}
	_tmp5_ = music_album_get_display_artist (a);
	_tmp6_ = _tmp5_;
	_tmp7_ = music_album_get_display_artist (b);
	_tmp8_ = _tmp7_;
	order = music_string_compare (_tmp6_, _tmp8_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	if (order != 0) {
		result = order;
		return result;
	}
	_tmp9_ = music_album_get_year (a);
	_tmp10_ = _tmp9_;
	_tmp11_ = music_album_get_year (b);
	_tmp12_ = _tmp11_;
	result = ((gint) _tmp10_) - ((gint) _tmp12_);
	return result;
}

static gint
___lambda55__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda55_ ((MusicAlbumsView*) self, (MusicAlbum*) a, (MusicAlbum*) b);
	return result;
}

void
music_albums_view_search_func (MusicAlbumsView* self,
                               GeeHashMap* showing)
{
	GeeCollection* _result_ = NULL;
	MusicViewWrapper* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* _tmp2_;
	GeeCollection* _tmp3_;
	GeeTreeSet* albums = NULL;
	GeeTreeSet* _tmp4_;
	gint _tmp22_;
	gint _tmp23_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (showing != NULL);
	_tmp0_ = self->priv->_parent_view_wrapper;
	_tmp1_ = music_view_wrapper_get_library (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = music_library_get_search_result (_tmp2_);
	_result_ = _tmp3_;
	_tmp4_ = gee_tree_set_new (MUSIC_TYPE_ALBUM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, ___lambda55__gcompare_data_func, g_object_ref (self), g_object_unref);
	albums = _tmp4_;
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		_tmp5_ = _result_;
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
		_m_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeTreeSet* _tmp10_;
			MusicMedia* _tmp11_;
			MusicAlbum* _tmp12_;
			MusicAlbum* _tmp13_;
			_tmp7_ = _m_it;
			if (!gee_iterator_next (_tmp7_)) {
				break;
			}
			_tmp8_ = _m_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			m = (MusicMedia*) _tmp9_;
			_tmp10_ = albums;
			_tmp11_ = m;
			_tmp12_ = music_media_get_album_info (_tmp11_);
			_tmp13_ = _tmp12_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp13_);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	{
		GeeIterator* _album_it = NULL;
		GeeTreeSet* _tmp14_;
		GeeIterator* _tmp15_;
		_tmp14_ = albums;
		_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
		_album_it = _tmp15_;
		while (TRUE) {
			GeeIterator* _tmp16_;
			MusicAlbum* album = NULL;
			GeeIterator* _tmp17_;
			gpointer _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			MusicAlbum* _tmp21_;
			_tmp16_ = _album_it;
			if (!gee_iterator_next (_tmp16_)) {
				break;
			}
			_tmp17_ = _album_it;
			_tmp18_ = gee_iterator_get (_tmp17_);
			album = (MusicAlbum*) _tmp18_;
			_tmp19_ = gee_abstract_map_get_size ((GeeAbstractMap*) showing);
			_tmp20_ = _tmp19_;
			_tmp21_ = album;
			gee_abstract_map_set ((GeeAbstractMap*) showing, (gpointer) ((gintptr) _tmp20_), (GObject*) _tmp21_);
			_g_object_unref0 (album);
		}
		_g_object_unref0 (_album_it);
	}
	_tmp22_ = gee_abstract_map_get_size ((GeeAbstractMap*) showing);
	_tmp23_ = _tmp22_;
	if (_tmp23_ < 1) {
		MusicLibraryWindow* _tmp24_;
		MusicLibraryWindow* _tmp25_;
		MusicViewStack* _tmp26_;
		MusicViewStack* _tmp27_;
		_tmp24_ = music_app_get_main_window ();
		_tmp25_ = _tmp24_;
		_tmp26_ = music_library_window_get_view_stack (_tmp25_);
		_tmp27_ = _tmp26_;
		music_view_stack_show_alert (_tmp27_);
	}
	_g_object_unref0 (albums);
	_g_object_unref0 (_result_);
}

GeeCollection*
music_albums_view_get_selected_media (MusicAlbumsView* self,
                                      GObject* obj)
{
	MusicAlbum* album = NULL;
	MusicAlbum* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (obj != NULL, NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (obj, MUSIC_TYPE_ALBUM) ? ((MusicAlbum*) obj) : NULL);
	album = _tmp0_;
	g_return_val_if_fail (album != NULL, NULL);
	_tmp1_ = music_album_get_media (album, (guint) 1);
	result = _tmp1_;
	_g_object_unref0 (album);
	return result;
}

static MusicAlbumListGrid*
music_albums_view_get_popup_list_view (MusicAlbumsView* self)
{
	MusicAlbumListGrid* result;
	MusicAlbumListGrid* _tmp0_;
	MusicAlbumListGrid* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_albums_view__popup;
	if (_tmp0_ == NULL) {
		MusicViewWrapper* _tmp1_;
		MusicAlbumListGrid* _tmp2_;
		MusicAlbumListGrid* _tmp3_;
		_tmp1_ = self->priv->_parent_view_wrapper;
		_tmp2_ = music_album_list_grid_new (_tmp1_);
		g_object_ref_sink (_tmp2_);
		_g_object_unref0 (music_albums_view__popup);
		music_albums_view__popup = _tmp2_;
		_tmp3_ = music_albums_view__popup;
		gtk_paned_pack2 ((GtkPaned*) self, (GtkWidget*) _tmp3_, FALSE, FALSE);
	}
	_tmp4_ = music_albums_view__popup;
	result = _tmp4_;
	return result;
}

MusicViewWrapper*
music_albums_view_get_parent_view_wrapper (MusicAlbumsView* self)
{
	MusicViewWrapper* result;
	MusicViewWrapper* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_parent_view_wrapper;
	result = _tmp0_;
	return result;
}

static void
music_albums_view_set_parent_view_wrapper (MusicAlbumsView* self,
                                           MusicViewWrapper* value)
{
	MusicViewWrapper* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_albums_view_get_parent_view_wrapper (self);
	if (old_value != value) {
		MusicViewWrapper* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_parent_view_wrapper);
		self->priv->_parent_view_wrapper = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_albums_view_properties[MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY]);
	}
}

static gint
_music_albums_view_compare_func_music_fast_grid_sort_compare_func (GObject* a,
                                                                   GObject* b,
                                                                   gpointer self)
{
	gint result;
	result = music_albums_view_compare_func ((MusicAlbumsView*) self, a, b);
	return result;
}

static void
_music_albums_view_search_func_music_fast_grid_view_search_func (GeeHashMap* showing,
                                                                 gpointer self)
{
	music_albums_view_search_func ((MusicAlbumsView*) self, showing);
}

static void
_music_albums_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        gpointer self)
{
	music_albums_view_on_drag_begin ((MusicAlbumsView*) self, _sender, context);
}

static void
_music_albums_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              GtkSelectionData* selection_data,
                                                              guint info,
                                                              guint time_,
                                                              gpointer self)
{
	music_albums_view_on_drag_data_get ((MusicAlbumsView*) self, context, selection_data, info, time_);
}

static void
_music_albums_view_on_item_activated_gtk_icon_view_item_activated (GtkIconView* _sender,
                                                                   GtkTreePath* path,
                                                                   gpointer self)
{
	music_albums_view_on_item_activated ((MusicAlbumsView*) self, path);
}

static void
_music_albums_view_on_item_selected_gtk_icon_view_selection_changed (GtkIconView* _sender,
                                                                     gpointer self)
{
	music_albums_view_on_item_selected ((MusicAlbumsView*) self);
}

static void
_music_albums_view___lambda56_ (MusicAlbumsView* self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
	gtk_widget_queue_resize ((GtkWidget*) self);
}

static void
__music_albums_view___lambda56__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
	_music_albums_view___lambda56_ ((MusicAlbumsView*) self);
}

static void
_music_albums_view___lambda57_ (MusicAlbumsView* self)
{
	MusicFastGrid* _tmp0_;
	_tmp0_ = self->priv->icon_view;
	_tmp0_->research_needed = TRUE;
}

static void
__music_albums_view___lambda57__music_library_search_finished (MusicLibrary* _sender,
                                                               gpointer self)
{
	_music_albums_view___lambda57_ ((MusicAlbumsView*) self);
}

static GObject *
music_albums_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicAlbumsView * self;
	MusicFastGrid* _tmp0_;
	MusicFastGrid* _tmp1_;
	MusicFastGrid* _tmp2_;
	MusicFastGrid* _tmp3_;
	MusicFastGrid* _tmp4_;
	MusicFastGrid* _tmp5_;
	MusicFastGrid* _tmp6_;
	MusicFastGrid* _tmp7_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp8_;
	GtkScrolledWindow* _tmp9_;
	GtkScrolledWindow* _tmp10_;
	MusicFastGrid* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	MusicViewWrapper* _tmp13_;
	MusicLibrary* _tmp14_;
	MusicLibrary* _tmp15_;
	GtkTargetEntry te = {0};
	GtkTargetEntry _tmp16_ = {0};
	MusicFastGrid* _tmp17_;
	GtkTargetEntry _tmp18_;
	GtkTargetEntry* _tmp19_;
	GtkTargetEntry* _tmp20_;
	gint _tmp20__length1;
	parent_class = G_OBJECT_CLASS (music_albums_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView);
	_tmp0_ = music_fast_grid_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->icon_view);
	self->priv->icon_view = _tmp0_;
	_tmp1_ = self->priv->icon_view;
	_tmp1_->compare_func = _music_albums_view_compare_func_music_fast_grid_sort_compare_func;
	_tmp1_->compare_func_target = self;
	_tmp2_ = self->priv->icon_view;
	_tmp2_->search_func = _music_albums_view_search_func_music_fast_grid_view_search_func;
	_tmp2_->search_func_target = self;
	_tmp3_ = self->priv->icon_view;
	gtk_icon_view_set_columns ((GtkIconView*) _tmp3_, -1);
	_tmp4_ = self->priv->icon_view;
	g_signal_connect_object ((GtkWidget*) _tmp4_, "drag-begin", (GCallback) _music_albums_view_on_drag_begin_gtk_widget_drag_begin, self, G_CONNECT_AFTER);
	_tmp5_ = self->priv->icon_view;
	g_signal_connect_object ((GtkWidget*) _tmp5_, "drag-data-get", (GCallback) _music_albums_view_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
	_tmp6_ = self->priv->icon_view;
	g_signal_connect_object ((GtkIconView*) _tmp6_, "item-activated", (GCallback) _music_albums_view_on_item_activated_gtk_icon_view_item_activated, self, 0);
	_tmp7_ = self->priv->icon_view;
	g_signal_connect_object ((GtkIconView*) _tmp7_, "selection-changed", (GCallback) _music_albums_view_on_item_selected_gtk_icon_view_selection_changed, self, 0);
	_tmp8_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp8_);
	scroll = _tmp8_;
	_tmp9_ = scroll;
	gtk_scrolled_window_set_policy (_tmp9_, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	_tmp10_ = scroll;
	_tmp11_ = self->priv->icon_view;
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
	_tmp12_ = scroll;
	gtk_paned_pack1 ((GtkPaned*) self, (GtkWidget*) _tmp12_, TRUE, FALSE);
	gtk_widget_show_all ((GtkWidget*) self);
	music_albums_view_clear_objects (self);
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_signal_connect_object ((GObject*) self, "notify::scale-factor", (GCallback) __music_albums_view___lambda56__g_object_notify, self, 0);
	_tmp13_ = self->priv->_parent_view_wrapper;
	_tmp14_ = music_view_wrapper_get_library (_tmp13_);
	_tmp15_ = _tmp14_;
	g_signal_connect_object (_tmp15_, "search-finished", (GCallback) __music_albums_view___lambda57__music_library_search_finished, self, 0);
	_tmp16_.target = "text/uri-list";
	_tmp16_.flags = (guint) GTK_TARGET_SAME_APP;
	_tmp16_.info = (guint) 0;
	te = _tmp16_;
	_tmp17_ = self->priv->icon_view;
	_tmp18_ = te;
	_tmp19_ = g_new0 (GtkTargetEntry, 1);
	_tmp19_[0] = _tmp18_;
	_tmp20_ = _tmp19_;
	_tmp20__length1 = 1;
	gtk_drag_source_set ((GtkWidget*) _tmp17_, GDK_BUTTON1_MASK, _tmp20_, (gint) 1, GDK_ACTION_COPY);
	_tmp20_ = (g_free (_tmp20_), NULL);
	_g_object_unref0 (scroll);
	return obj;
}

static void
music_albums_view_class_init (MusicAlbumsViewClass * klass,
                              gpointer klass_data)
{
	music_albums_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicAlbumsView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_albums_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_albums_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_albums_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_albums_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY, music_albums_view_properties[MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY] = g_param_spec_object ("parent-view-wrapper", "parent-view-wrapper", "parent-view-wrapper", MUSIC_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
music_albums_view_music_view_interface_interface_init (MusicViewInterfaceIface * iface,
                                                       gpointer iface_data)
{
	music_albums_view_music_view_interface_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_visible_media = (GeeCollection* (*) (MusicViewInterface*)) music_albums_view_real_get_visible_media;
	iface->get_media = (GeeCollection* (*) (MusicViewInterface*)) music_albums_view_real_get_media;
	iface->refilter = (void (*) (MusicViewInterface*)) music_albums_view_real_refilter;
	iface->update_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_albums_view_real_update_media;
	iface->set_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_albums_view_real_set_media;
	iface->add_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_albums_view_real_add_media;
	iface->remove_media = (void (*) (MusicViewInterface*, GeeCollection*)) music_albums_view_real_remove_media;
}

static void
music_albums_view_instance_init (MusicAlbumsView * self,
                                 gpointer klass)
{
	self->priv = music_albums_view_get_instance_private (self);
}

static void
music_albums_view_finalize (GObject * obj)
{
	MusicAlbumsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView);
	_g_object_unref0 (self->priv->icon_view);
	_g_object_unref0 (self->priv->_parent_view_wrapper);
	G_OBJECT_CLASS (music_albums_view_parent_class)->finalize (obj);
}

static GType
music_albums_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicAlbumsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_albums_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicAlbumsView), 0, (GInstanceInitFunc) music_albums_view_instance_init, NULL };
	static const GInterfaceInfo music_view_interface_info = { (GInterfaceInitFunc) music_albums_view_music_view_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_albums_view_type_id;
	music_albums_view_type_id = g_type_register_static (gtk_paned_get_type (), "MusicAlbumsView", &g_define_type_info, 0);
	g_type_add_interface_static (music_albums_view_type_id, MUSIC_TYPE_VIEW_INTERFACE, &music_view_interface_info);
	MusicAlbumsView_private_offset = g_type_add_instance_private (music_albums_view_type_id, sizeof (MusicAlbumsViewPrivate));
	return music_albums_view_type_id;
}

GType
music_albums_view_get_type (void)
{
	static volatile gsize music_albums_view_type_id__once = 0;
	if (g_once_init_enter (&music_albums_view_type_id__once)) {
		GType music_albums_view_type_id;
		music_albums_view_type_id = music_albums_view_get_type_once ();
		g_once_init_leave (&music_albums_view_type_id__once, music_albums_view_type_id);
	}
	return music_albums_view_type_id__once;
}

static void
_vala_music_albums_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	MusicAlbumsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView);
	switch (property_id) {
		case MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY:
		g_value_set_object (value, music_albums_view_get_parent_view_wrapper (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_albums_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	MusicAlbumsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView);
	switch (property_id) {
		case MUSIC_ALBUMS_VIEW_PARENT_VIEW_WRAPPER_PROPERTY:
		music_albums_view_set_parent_view_wrapper (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

