/* GenericList.c generated by valac 0.55.1, the Vala compiler
 * generated from GenericList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "music-lib.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#define MUSIC_GENERIC_LIST_OPTIMAL_COLUMN -2

enum  {
	MUSIC_GENERIC_LIST_0_PROPERTY,
	MUSIC_GENERIC_LIST_COLUMNS_PROPERTY,
	MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY,
	MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY,
	MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY,
	MUSIC_GENERIC_LIST_TVS_PROPERTY,
	MUSIC_GENERIC_LIST_HINT_PROPERTY,
	MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY,
	MUSIC_GENERIC_LIST_NUM_PROPERTIES
};
static GParamSpec* music_generic_list_properties[MUSIC_GENERIC_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _music_cell_data_function_helper_unref0(var) ((var == NULL) ? NULL : (var = (music_cell_data_function_helper_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicGenericListMediaPlayedData MusicGenericListMediaPlayedData;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
enum  {
	MUSIC_GENERIC_LIST_IMPORT_REQUESTED_SIGNAL,
	MUSIC_GENERIC_LIST_ROWS_REORDERED_SIGNAL,
	MUSIC_GENERIC_LIST_NUM_SIGNALS
};
static guint music_generic_list_signals[MUSIC_GENERIC_LIST_NUM_SIGNALS] = {0};

struct _MusicGenericListPrivate {
	GeeList* _columns;
	gboolean _research_needed;
	gboolean _is_current_list;
	MusicPlaylist* _playlist;
	MusicTreeViewSetup* _tvs;
	MusicViewWrapper* _parent_wrapper;
	MusicGenericListSortCompareFunc compare_func;
	gpointer compare_func_target;
	MusicGenericListViewSearchFunc search_func;
	gpointer search_func_target;
};

struct _MusicGenericListMediaPlayedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicGenericList* self;
	MusicMedia* m;
};

static gint MusicGenericList_private_offset;
static gpointer music_generic_list_parent_class = NULL;

static void music_generic_list_real_add_column (MusicGenericList* self,
                                         GtkTreeViewColumn* column,
                                         MusicListColumn type);
static void music_generic_list_real_media_remove_clicked (MusicGenericList* self);
static MusicMedia* music_generic_list_get_media_from_index (MusicGenericList* self,
                                                     gint index);
static void music_generic_list_on_rows_reordered (MusicGenericList* self);
static void music_generic_list_real_row_activated (GtkTreeView* base,
                                            GtkTreePath* path,
                                            GtkTreeViewColumn* column);
static void music_generic_list_media_played_data_free (gpointer _data);
static void music_generic_list_media_played (MusicGenericList* self,
                                      MusicMedia* m,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void music_generic_list_media_played_finish (MusicGenericList* self,
                                             GAsyncResult* _res_);
static gboolean music_generic_list_media_played_co (MusicGenericListMediaPlayedData* _data_);
static gboolean _music_generic_list_media_played_co_gsource_func (gpointer self);
static void music_generic_list_set_is_current_list (MusicGenericList* self,
                                             gboolean value);
static GeeList* music_generic_list_start_at (MusicGenericList* self,
                                      MusicMedia* start,
                                      GeeList* media);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static void music_generic_list_reorder_requested (MusicGenericList* self,
                                           gint column,
                                           GtkSortType direction);
static void music_generic_list_quicksort (MusicGenericList* self,
                                   gint start,
                                   gint end);
static void music_generic_list_swap (MusicGenericList* self,
                              gint a,
                              gint b);
static void music_generic_list_on_drag_begin (MusicGenericList* self,
                                       GtkWidget* sender,
                                       GdkDragContext* context);
static void music_generic_list_on_drag_data_get (MusicGenericList* self,
                                          GdkDragContext* context,
                                          GtkSelectionData* selection_data,
                                          guint info,
                                          guint time_);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void music_generic_list_on_drag_end (MusicGenericList* self,
                                     GtkWidget* sender,
                                     GdkDragContext* context);
static GObject * music_generic_list_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _music_generic_list_reorder_requested_music_fast_model_reorder_requested (MusicFastModel* _sender,
                                                                               gint column,
                                                                               GtkSortType direction,
                                                                               gpointer self);
static void _music_generic_list_on_rows_reordered_music_generic_list_rows_reordered (MusicGenericList* _sender,
                                                                              gpointer self);
static gboolean _music_generic_list___lambda40_ (MusicGenericList* self,
                                          GdkEventKey* event);
static gboolean __music_generic_list___lambda40__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static void _music_generic_list_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              gpointer self);
static void _music_generic_list_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    GtkSelectionData* selection_data,
                                                                    guint info,
                                                                    guint time_,
                                                                    gpointer self);
static void _music_generic_list_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                          GdkDragContext* context,
                                                          gpointer self);
static void _gtk_widget_queue_draw_music_library_media_updated (MusicLibrary* _sender,
                                                         GeeCollection* medias,
                                                         gpointer self);
static void _music_generic_list___lambda41_ (MusicGenericList* self);
static void __music_generic_list___lambda41__music_playback_manager_queue_cleared (MusicPlaybackManager* _sender,
                                                                            gpointer self);
static void _music_generic_list_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                           MusicMedia* played_media,
                                                                           gpointer self);
static void music_generic_list_finalize (GObject * obj);
static GType music_generic_list_get_type_once (void);
static void _vala_music_generic_list_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_music_generic_list_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_generic_list_get_instance_private (MusicGenericList* self)
{
	return G_STRUCT_MEMBER_P (self, MusicGenericList_private_offset);
}

MusicGenericList*
music_generic_list_construct (GType object_type,
                              MusicViewWrapper* view_wrapper,
                              MusicTreeViewSetup* tvs)
{
	MusicGenericList * self = NULL;
	g_return_val_if_fail (view_wrapper != NULL, NULL);
	g_return_val_if_fail (tvs != NULL, NULL);
	self = (MusicGenericList*) g_object_new (object_type, "parent-wrapper", view_wrapper, "tvs", tvs, NULL);
	return self;
}

static void
music_generic_list_real_add_column (MusicGenericList* self,
                                    GtkTreeViewColumn* column,
                                    MusicListColumn type)
{
	g_critical ("Type `%s' does not implement abstract method `music_generic_list_add_column'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_generic_list_add_column (MusicGenericList* self,
                               GtkTreeViewColumn* column,
                               MusicListColumn type)
{
	MusicGenericListClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_GENERIC_LIST_GET_CLASS (self);
	if (_klass_->add_column) {
		_klass_->add_column (self, column, type);
	}
}

static void
music_generic_list_real_media_remove_clicked (MusicGenericList* self)
{
	g_critical ("Type `%s' does not implement abstract method `music_generic_list_media_remove_clicked'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_generic_list_media_remove_clicked (MusicGenericList* self)
{
	MusicGenericListClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_GENERIC_LIST_GET_CLASS (self);
	if (_klass_->media_remove_clicked) {
		_klass_->media_remove_clicked (self);
	}
}

void
music_generic_list_set_media (MusicGenericList* self,
                              GeeCollection* to_add)
{
	GeeArrayList* new_table = NULL;
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_add != NULL);
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	new_table = _tmp0_;
	gee_array_list_add_all (new_table, to_add);
	music_generic_list_set_table (self, new_table, TRUE);
	music_generic_list_scroll_to_current_media (self, FALSE);
	_g_object_unref0 (new_table);
}

void
music_generic_list_set_fixed_column_width (MusicGenericList* self,
                                           GtkWidget* treeview,
                                           GtkTreeViewColumn* column,
                                           GtkCellRendererText* renderer,
                                           gchar** strings,
                                           gint strings_length1,
                                           gint padding)
{
	gint max_width = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (treeview != NULL);
	g_return_if_fail (column != NULL);
	g_return_if_fail (renderer != NULL);
	max_width = 0;
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
		str_collection = strings;
		str_collection_length1 = strings_length1;
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
			const gchar* str = NULL;
			str = str_collection[str_it];
			{
				const gchar* _tmp0_;
				GtkRequisition natural_size = {0};
				GtkRequisition _tmp1_ = {0};
				GtkRequisition _tmp2_;
				_tmp0_ = str;
				g_object_set (renderer, "text", _tmp0_, NULL);
				gtk_cell_renderer_get_preferred_size ((GtkCellRenderer*) renderer, treeview, NULL, &_tmp1_);
				natural_size = _tmp1_;
				_tmp2_ = natural_size;
				if (_tmp2_.width > max_width) {
					GtkRequisition _tmp3_;
					_tmp3_ = natural_size;
					max_width = _tmp3_.width;
				}
			}
		}
	}
	gtk_tree_view_column_set_fixed_width (column, max_width + padding);
}

static MusicMedia*
music_generic_list_get_media_from_index (MusicGenericList* self,
                                         gint index)
{
	MusicMedia* _tmp0_;
	MusicMedia* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_generic_list_get_object_from_index (self, index);
	result = _tmp0_;
	return result;
}

void
music_generic_list_on_rating_cell_changed (MusicGenericList* self,
                                           gint new_rating,
                                           GtkWidget* widget,
                                           const gchar* path)
{
	MusicMedia* m = NULL;
	MusicMedia* _tmp0_;
	GeeTreeSet* to_update = NULL;
	GeeTreeSet* _tmp1_;
	MusicViewWrapper* _tmp2_;
	MusicViewWrapper* _tmp3_;
	MusicLibrary* _tmp4_;
	MusicLibrary* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = music_generic_list_get_media_from_index (self, atoi (path));
	m = _tmp0_;
	g_return_if_fail (m != NULL);
	music_media_set_rating (m, (guint) new_rating);
	_tmp1_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	to_update = _tmp1_;
	gee_abstract_collection_add ((GeeAbstractCollection*) to_update, m);
	_tmp2_ = music_generic_list_get_parent_wrapper (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_view_wrapper_get_library (_tmp3_);
	_tmp5_ = _tmp4_;
	music_library_update_medias (_tmp5_, (GeeCollection*) to_update, TRUE, TRUE);
	_g_object_unref0 (to_update);
	_g_object_unref0 (m);
}

static void
music_generic_list_on_rows_reordered (MusicGenericList* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	music_generic_list_scroll_to_current_media (self, FALSE);
	_tmp0_ = self->priv->_is_current_list;
	if (_tmp0_) {
		music_generic_list_set_as_current_list (self, NULL);
	}
}

static void
music_generic_list_real_row_activated (GtkTreeView* base,
                                       GtkTreePath* path,
                                       GtkTreeViewColumn* column)
{
	MusicGenericList * self;
	MusicMedia* m = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicViewWrapperHint _tmp4_;
	MusicViewWrapperHint _tmp5_;
	MusicPlaybackManager* _tmp11_;
	MusicPlaybackManager* _tmp12_;
	MusicMedia* _tmp13_;
	MusicPlaybackManager* _tmp14_;
	MusicPlaybackManager* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	self = (MusicGenericList*) base;
	g_return_if_fail (path != NULL);
	g_return_if_fail (column != NULL);
	_tmp0_ = gtk_tree_path_to_string (path);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_generic_list_get_media_from_index (self, atoi (_tmp1_));
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	m = _tmp3_;
	_tmp4_ = music_generic_list_get_hint (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == MUSIC_VIEW_WRAPPER_HINT_QUEUE) {
		MusicPlaybackManager* _tmp6_;
		MusicPlaybackManager* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = music_app_get_player ();
		_tmp7_ = _tmp6_;
		_tmp8_ = gtk_tree_path_to_string (path);
		_tmp9_ = _tmp8_;
		music_playback_manager_set_current_index (_tmp7_, atoi (_tmp9_));
		_g_free0 (_tmp9_);
	} else {
		MusicMedia* _tmp10_;
		_tmp10_ = m;
		music_generic_list_set_as_current_list (self, _tmp10_);
	}
	_tmp11_ = music_app_get_player ();
	_tmp12_ = _tmp11_;
	_tmp13_ = m;
	music_playback_manager_play_media (_tmp12_, _tmp13_);
	_tmp14_ = music_app_get_player ();
	_tmp15_ = _tmp14_;
	_tmp16_ = music_playback_manager_get_playing (_tmp15_);
	_tmp17_ = _tmp16_;
	if (!_tmp17_) {
		MusicLibraryWindow* _tmp18_;
		MusicLibraryWindow* _tmp19_;
		_tmp18_ = music_app_get_main_window ();
		_tmp19_ = _tmp18_;
		music_library_window_play_media (_tmp19_, FALSE);
	}
	_g_object_unref0 (m);
}

static void
music_generic_list_media_played_data_free (gpointer _data)
{
	MusicGenericListMediaPlayedData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->m);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicGenericListMediaPlayedData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_generic_list_media_played (MusicGenericList* self,
                                 MusicMedia* m,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	MusicGenericListMediaPlayedData* _data_;
	MusicGenericList* _tmp0_;
	MusicMedia* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_data_ = g_slice_new0 (MusicGenericListMediaPlayedData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_generic_list_media_played_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (m);
	_g_object_unref0 (_data_->m);
	_data_->m = _tmp1_;
	music_generic_list_media_played_co (_data_);
}

static void
music_generic_list_media_played_finish (MusicGenericList* self,
                                        GAsyncResult* _res_)
{
	MusicGenericListMediaPlayedData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
_music_generic_list_media_played_co_gsource_func (gpointer self)
{
	gboolean result;
	result = music_generic_list_media_played_co (self);
	return result;
}

static gboolean
music_generic_list_media_played_co (MusicGenericListMediaPlayedData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	gtk_widget_queue_draw ((GtkWidget*) _data_->self);
	g_idle_add_full (G_PRIORITY_HIGH_IDLE + 10, _music_generic_list_media_played_co_gsource_func, _data_, NULL);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	music_generic_list_scroll_to_current_media (_data_->self, FALSE);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

void
music_generic_list_set_as_current_list (MusicGenericList* self,
                                        MusicMedia* m)
{
	MusicMedia* _tmp0_ = NULL;
	MusicMedia* to_set = NULL;
	MusicMedia* _tmp5_;
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp6_;
	MusicSettingsMain* _tmp7_;
	GeeList* queue = NULL;
	MusicMedia* _tmp43_;
	GeeBidirList* _tmp44_;
	GeeBidirList* _tmp45_;
	GeeList* _tmp46_;
	GeeList* _tmp47_;
	MusicPlaybackManager* _tmp59_;
	MusicPlaybackManager* _tmp60_;
	MusicPlaybackManager* _tmp61_;
	MusicPlaybackManager* _tmp62_;
	GeeList* _tmp63_;
	MusicPlaybackManager* _tmp64_;
	MusicPlaybackManager* _tmp65_;
	MusicViewWrapper* view = NULL;
	MusicLibraryWindow* _tmp66_;
	MusicLibraryWindow* _tmp67_;
	GeeHashMap* _tmp68_;
	MusicPlaybackManager* _tmp69_;
	MusicPlaybackManager* _tmp70_;
	MusicStaticPlaylist* _tmp71_;
	gpointer _tmp72_;
	MusicListView* _tmp73_;
	MusicListView* _tmp74_;
	MusicMusicListView* _tmp75_;
	MusicMusicListView* _tmp76_;
	MusicTreeViewSetup* _tmp77_;
	MusicListColumn _tmp78_;
	MusicListColumn _tmp79_;
	MusicTreeViewSetup* _tmp80_;
	GtkSortType _tmp81_;
	GtkSortType _tmp82_;
	MusicPlaybackManager* _tmp83_;
	MusicPlaybackManager* _tmp84_;
	MusicMedia* _tmp85_;
	MusicMedia* _tmp86_;
	g_return_if_fail (self != NULL);
	if (m == NULL) {
		MusicPlaybackManager* _tmp1_;
		MusicPlaybackManager* _tmp2_;
		MusicMedia* _tmp3_;
		MusicMedia* _tmp4_;
		_tmp1_ = music_app_get_player ();
		_tmp2_ = _tmp1_;
		_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = m;
	}
	_tmp5_ = _g_object_ref0 (_tmp0_);
	to_set = _tmp5_;
	music_generic_list_set_is_current_list (self, TRUE);
	_tmp6_ = music_settings_main_get_default ();
	main_settings = _tmp6_;
	_tmp7_ = main_settings;
	if (!music_settings_main_privacy_mode_enabled (_tmp7_)) {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		MusicPlaylist* _tmp10_;
		_tmp10_ = self->priv->_playlist;
		if (_tmp10_ == NULL) {
			_tmp9_ = TRUE;
		} else {
			MusicPlaylist* _tmp11_;
			MusicLibrariesManager* _tmp12_;
			MusicLibrary* _tmp13_;
			MusicStaticPlaylist* _tmp14_;
			_tmp11_ = self->priv->_playlist;
			_tmp12_ = music_libraries_manager;
			_tmp13_ = _tmp12_->local_library;
			_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary)->p_music;
			_tmp9_ = _tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, MUSIC_TYPE_PLAYLIST, MusicPlaylist);
		}
		if (_tmp9_) {
			_tmp8_ = TRUE;
		} else {
			MusicViewWrapper* _tmp15_;
			MusicViewWrapper* _tmp16_;
			MusicLibrary* _tmp17_;
			MusicLibrary* _tmp18_;
			MusicLibrariesManager* _tmp19_;
			MusicLibrary* _tmp20_;
			_tmp15_ = music_generic_list_get_parent_wrapper (self);
			_tmp16_ = _tmp15_;
			_tmp17_ = music_view_wrapper_get_library (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = music_libraries_manager;
			_tmp20_ = _tmp19_->local_library;
			_tmp8_ = _tmp18_ != _tmp20_;
		}
		if (_tmp8_) {
			GSettings* _tmp21_;
			GSettings* _tmp22_;
			_tmp21_ = music_app_get_saved_state ();
			_tmp22_ = _tmp21_;
			g_settings_set_string (_tmp22_, "last-playlist-playing", "");
		} else {
			MusicPlaylist* _tmp23_;
			_tmp23_ = self->priv->_playlist;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, MUSIC_TYPE_SMART_PLAYLIST)) {
				GSettings* _tmp24_;
				GSettings* _tmp25_;
				MusicPlaylist* _tmp26_;
				gint64 _tmp27_;
				gint64 _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				_tmp24_ = music_app_get_saved_state ();
				_tmp25_ = _tmp24_;
				_tmp26_ = self->priv->_playlist;
				_tmp27_ = music_playlist_get_rowid (_tmp26_);
				_tmp28_ = _tmp27_;
				_tmp29_ = g_strdup_printf ("s%lld", _tmp28_);
				_tmp30_ = _tmp29_;
				g_settings_set_string (_tmp25_, "last-playlist-playing", _tmp30_);
				_g_free0 (_tmp30_);
			} else {
				MusicPlaylist* _tmp31_;
				gboolean _tmp32_;
				gboolean _tmp33_;
				_tmp31_ = self->priv->_playlist;
				_tmp32_ = music_static_playlist_get_read_only (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist));
				_tmp33_ = _tmp32_;
				if (_tmp33_ == FALSE) {
					GSettings* _tmp34_;
					GSettings* _tmp35_;
					MusicPlaylist* _tmp36_;
					gint64 _tmp37_;
					gint64 _tmp38_;
					gchar* _tmp39_;
					gchar* _tmp40_;
					_tmp34_ = music_app_get_saved_state ();
					_tmp35_ = _tmp34_;
					_tmp36_ = self->priv->_playlist;
					_tmp37_ = music_playlist_get_rowid (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = g_strdup_printf ("p%lld", _tmp38_);
					_tmp40_ = _tmp39_;
					g_settings_set_string (_tmp35_, "last-playlist-playing", _tmp40_);
					_g_free0 (_tmp40_);
				} else {
					GSettings* _tmp41_;
					GSettings* _tmp42_;
					_tmp41_ = music_app_get_saved_state ();
					_tmp42_ = _tmp41_;
					g_settings_set_string (_tmp42_, "last-playlist-playing", "");
				}
			}
		}
	}
	_tmp43_ = to_set;
	_tmp44_ = music_generic_list_get_visible_table (self);
	_tmp45_ = _tmp44_;
	_tmp46_ = music_generic_list_start_at (self, _tmp43_, (GeeList*) _tmp45_);
	_tmp47_ = _tmp46_;
	_g_object_unref0 (_tmp45_);
	queue = _tmp47_;
	{
		GeeList* _q_list = NULL;
		GeeList* _tmp48_;
		gint _q_size = 0;
		GeeList* _tmp49_;
		gint _tmp50_;
		gint _tmp51_;
		gint _q_index = 0;
		_tmp48_ = queue;
		_q_list = _tmp48_;
		_tmp49_ = _q_list;
		_tmp50_ = gee_collection_get_size ((GeeCollection*) _tmp49_);
		_tmp51_ = _tmp50_;
		_q_size = _tmp51_;
		_q_index = -1;
		while (TRUE) {
			gint _tmp52_;
			gint _tmp53_;
			MusicMedia* q = NULL;
			GeeList* _tmp54_;
			gpointer _tmp55_;
			MusicMedia* _tmp56_;
			const gchar* _tmp57_;
			const gchar* _tmp58_;
			_q_index = _q_index + 1;
			_tmp52_ = _q_index;
			_tmp53_ = _q_size;
			if (!(_tmp52_ < _tmp53_)) {
				break;
			}
			_tmp54_ = _q_list;
			_tmp55_ = gee_list_get (_tmp54_, _q_index);
			q = (MusicMedia*) _tmp55_;
			_tmp56_ = q;
			_tmp57_ = music_media_get_title (_tmp56_);
			_tmp58_ = _tmp57_;
			g_debug ("GenericList.vala:259: QUEING: %s", _tmp58_);
			_g_object_unref0 (q);
		}
	}
	_tmp59_ = music_app_get_player ();
	_tmp60_ = _tmp59_;
	music_playback_manager_clear_queue (_tmp60_);
	_tmp61_ = music_app_get_player ();
	_tmp62_ = _tmp61_;
	_tmp63_ = queue;
	music_playback_manager_queue_media (_tmp62_, (GeeCollection*) _tmp63_);
	_tmp64_ = music_app_get_player ();
	_tmp65_ = _tmp64_;
	music_playback_manager_set_current_index (_tmp65_, 0);
	_tmp66_ = music_app_get_main_window ();
	_tmp67_ = _tmp66_;
	_tmp68_ = _tmp67_->match_playlists;
	_tmp69_ = music_app_get_player ();
	_tmp70_ = _tmp69_;
	_tmp71_ = _tmp70_->queue_playlist;
	_tmp72_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp68_, (MusicPlaylist*) _tmp71_);
	view = (MusicViewWrapper*) _tmp72_;
	_tmp73_ = music_view_wrapper_get_list_view (view);
	_tmp74_ = _tmp73_;
	_tmp75_ = music_list_view_get_list_view (_tmp74_);
	_tmp76_ = _tmp75_;
	_tmp77_ = self->priv->_tvs;
	_tmp78_ = music_tree_view_setup_get_sort_column_id (_tmp77_);
	_tmp79_ = _tmp78_;
	_tmp80_ = self->priv->_tvs;
	_tmp81_ = music_tree_view_setup_get_sort_direction (_tmp80_);
	_tmp82_ = _tmp81_;
	music_generic_list_set_sort_column_id ((MusicGenericList*) _tmp76_, (gint) _tmp79_, _tmp82_);
	_tmp83_ = music_app_get_player ();
	_tmp84_ = _tmp83_;
	_tmp85_ = music_playback_manager_get_current_media (_tmp84_);
	_tmp86_ = _tmp85_;
	music_generic_list_media_played (self, _tmp86_, NULL, NULL);
	_g_object_unref0 (view);
	_g_object_unref0 (queue);
	_g_object_unref0 (main_settings);
	_g_object_unref0 (to_set);
}

/**
    * Shift a list (of media) to make it start at a given element
    */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static GeeList*
music_generic_list_start_at (MusicGenericList* self,
                             MusicMedia* start,
                             GeeList* media)
{
	gint index = 0;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GeeArrayList* res = NULL;
	GeeArrayList* _tmp27_;
	GeeArrayList* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	GeeList* _tmp31_;
	GeeList* _tmp32_;
	GeeArrayList* _tmp33_;
	GeeList* _tmp34_;
	GeeList* _tmp35_;
	GeeList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (start != NULL, NULL);
	g_return_val_if_fail (media != NULL, NULL);
	index = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp2_ = FALSE;
			gint _tmp3_;
			gint _tmp4_;
			if (!_tmp0_) {
				gint _tmp1_;
				index = index + 1;
				_tmp1_ = index;
			}
			_tmp0_ = FALSE;
			_tmp3_ = gee_collection_get_size ((GeeCollection*) media);
			_tmp4_ = _tmp3_;
			if (index < _tmp4_) {
				gpointer _tmp5_;
				MusicMedia* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				_tmp5_ = gee_list_get (media, index);
				_tmp6_ = (MusicMedia*) _tmp5_;
				_tmp7_ = music_media_get_uri (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = _tmp8_;
				_tmp10_ = music_media_get_uri (start);
				_tmp11_ = _tmp10_;
				_tmp12_ = _tmp11_;
				_tmp2_ = g_strcmp0 (_tmp9_, _tmp12_) != 0;
				_g_free0 (_tmp12_);
				_g_free0 (_tmp9_);
				_g_object_unref0 (_tmp6_);
			} else {
				_tmp2_ = FALSE;
			}
			if (!_tmp2_) {
				break;
			}
		}
	}
	_tmp13_ = music_media_get_title (start);
	_tmp14_ = _tmp13_;
	_tmp15_ = string_to_string (_tmp14_);
	_tmp16_ = gee_collection_get_size ((GeeCollection*) media);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_strdup_printf ("%i", _tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strdup_printf ("%i", index);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_strconcat ("TO START: '", _tmp15_, "', size = ", _tmp19_, ", index: ", _tmp21_, NULL);
	_tmp23_ = _tmp22_;
	g_debug ("GenericList.vala:278: %s", _tmp23_);
	_g_free0 (_tmp23_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp19_);
	_tmp24_ = gee_collection_get_size ((GeeCollection*) media);
	_tmp25_ = _tmp24_;
	if (index == _tmp25_) {
		GeeList* _tmp26_;
		_tmp26_ = _g_object_ref0 (media);
		result = _tmp26_;
		return result;
	}
	_tmp27_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	res = _tmp27_;
	_tmp28_ = res;
	_tmp29_ = gee_collection_get_size ((GeeCollection*) media);
	_tmp30_ = _tmp29_;
	_tmp31_ = gee_list_slice (media, index, _tmp30_);
	_tmp32_ = _tmp31_;
	gee_array_list_add_all (_tmp28_, (GeeCollection*) _tmp32_);
	_g_object_unref0 (_tmp32_);
	_tmp33_ = res;
	_tmp34_ = gee_list_slice (media, 0, index);
	_tmp35_ = _tmp34_;
	gee_array_list_add_all (_tmp33_, (GeeCollection*) _tmp35_);
	_g_object_unref0 (_tmp35_);
	result = (GeeList*) res;
	return result;
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
	return g_boxed_copy (gtk_tree_path_get_type (), self);
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
	return self ? _vala_GtkTreePath_copy (self) : NULL;
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
}

GeeCollection*
music_generic_list_get_selected_medias (MusicGenericList* self)
{
	GeeArrayQueue* rv = NULL;
	GeeArrayQueue* _tmp0_;
	GtkTreeModel* temp = NULL;
	GtkTreeSelection* _tmp1_;
	GtkTreeModel* _tmp2_ = NULL;
	GList* _tmp3_;
	GtkTreeModel* _tmp4_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_queue_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	rv = _tmp0_;
	_tmp1_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	_tmp3_ = gtk_tree_selection_get_selected_rows (_tmp1_, &_tmp2_);
	_g_object_unref0 (temp);
	_tmp4_ = _g_object_ref0 (_tmp2_);
	temp = _tmp4_;
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
		path_collection = _tmp3_;
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
			GtkTreePath* _tmp5_;
			GtkTreePath* path = NULL;
			_tmp5_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) path_it->data);
			path = _tmp5_;
			{
				MusicMedia* m = NULL;
				GtkTreePath* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				MusicMedia* _tmp9_;
				MusicMedia* _tmp10_;
				GeeArrayQueue* _tmp11_;
				MusicMedia* _tmp12_;
				_tmp6_ = path;
				_tmp7_ = gtk_tree_path_to_string (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = music_generic_list_get_media_from_index (self, atoi (_tmp8_));
				_tmp10_ = _tmp9_;
				_g_free0 (_tmp8_);
				m = _tmp10_;
				_tmp11_ = rv;
				_tmp12_ = m;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
				_g_object_unref0 (m);
				__vala_GtkTreePath_free0 (path);
			}
		}
		(path_collection == NULL) ? NULL : (path_collection = (_g_list_free___vala_GtkTreePath_free0_ (path_collection), NULL));
	}
	result = (GeeCollection*) rv;
	_g_object_unref0 (temp);
	return result;
}

void
music_generic_list_scroll_to_current_media (MusicGenericList* self,
                                            gboolean unfilter_if_not_found)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		return;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				GeeBidirList* _tmp6_;
				GeeBidirList* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gboolean _tmp10_;
				MusicMedia* m = NULL;
				MusicMedia* _tmp11_;
				MusicMedia* _tmp12_;
				MusicPlaybackManager* _tmp13_;
				MusicPlaybackManager* _tmp14_;
				MusicMedia* _tmp15_;
				MusicMedia* _tmp16_;
				if (!_tmp4_) {
					gint _tmp5_;
					i = i + 1;
					_tmp5_ = i;
				}
				_tmp4_ = FALSE;
				_tmp6_ = music_generic_list_get_visible_table (self);
				_tmp7_ = _tmp6_;
				_tmp8_ = gee_collection_get_size ((GeeCollection*) _tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = !(i < _tmp9_);
				_g_object_unref0 (_tmp7_);
				if (_tmp10_) {
					break;
				}
				_tmp11_ = music_generic_list_get_media_from_index (self, i);
				m = _tmp11_;
				_tmp12_ = m;
				_tmp13_ = music_app_get_player ();
				_tmp14_ = _tmp13_;
				_tmp15_ = music_playback_manager_get_current_media (_tmp14_);
				_tmp16_ = _tmp15_;
				if (_tmp12_ == _tmp16_) {
					GtkTreePath* path = NULL;
					GtkTreePath* _tmp17_;
					gboolean center_cell = FALSE;
					GtkTreePath* start_path = NULL;
					GtkTreePath* end_path = NULL;
					GtkTreePath* _tmp18_ = NULL;
					GtkTreePath* _tmp19_ = NULL;
					gboolean _tmp20_;
					GtkTreePath* _tmp30_;
					GtkTreeViewColumn* column = NULL;
					GtkTreeViewColumn* _tmp31_;
					GtkTreeViewColumn* _tmp32_;
					GtkTreePath* _tmp33_;
					GtkTreeViewColumn* _tmp34_;
					GtkTreeViewColumn* _tmp35_;
					GList* _tmp36_;
					GList* _tmp37_;
					gconstpointer _tmp38_;
					_tmp17_ = gtk_tree_path_new_from_indices (i, -1, -1);
					path = _tmp17_;
					center_cell = FALSE;
					_tmp20_ = gtk_tree_view_get_visible_range ((GtkTreeView*) self, &_tmp18_, &_tmp19_);
					__vala_GtkTreePath_free0 (start_path);
					start_path = _tmp18_;
					__vala_GtkTreePath_free0 (end_path);
					end_path = _tmp19_;
					if (_tmp20_) {
						gint start_index = 0;
						GtkTreePath* _tmp21_;
						gint _tmp22_ = 0;
						gint* _tmp23_;
						gint _tmp24_;
						gint end_index = 0;
						GtkTreePath* _tmp25_;
						gint _tmp26_ = 0;
						gint* _tmp27_;
						gint _tmp28_;
						gboolean _tmp29_ = FALSE;
						_tmp21_ = start_path;
						_tmp23_ = gtk_tree_path_get_indices_with_depth (_tmp21_, &_tmp22_);
						_tmp24_ = _tmp23_[0];
						start_index = _tmp24_;
						_tmp25_ = end_path;
						_tmp27_ = gtk_tree_path_get_indices_with_depth (_tmp25_, &_tmp26_);
						_tmp28_ = _tmp27_[0];
						end_index = _tmp28_;
						if (i < (start_index - 1)) {
							_tmp29_ = TRUE;
						} else {
							_tmp29_ = i > (end_index + 1);
						}
						if (_tmp29_) {
							center_cell = TRUE;
						}
					}
					_tmp30_ = path;
					gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp30_, NULL, center_cell, 0.5f, (gfloat) 0);
					_tmp31_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
					_tmp32_ = _g_object_ref0 (_tmp31_);
					column = _tmp32_;
					_tmp33_ = path;
					_tmp34_ = column;
					_tmp35_ = column;
					_tmp36_ = gtk_cell_layout_get_cells ((GtkCellLayout*) _tmp35_);
					_tmp37_ = _tmp36_;
					_tmp38_ = g_list_nth_data (_tmp37_, (guint) 0);
					gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp33_, _tmp34_, (GtkCellRenderer*) _tmp38_, FALSE);
					(_tmp37_ == NULL) ? NULL : (_tmp37_ = (g_list_free (_tmp37_), NULL));
					_g_object_unref0 (column);
					__vala_GtkTreePath_free0 (end_path);
					__vala_GtkTreePath_free0 (start_path);
					__vala_GtkTreePath_free0 (path);
					_g_object_unref0 (m);
					break;
				}
				_g_object_unref0 (m);
			}
		}
	}
}

/** Should not be manipulated by client */
GeeBidirList*
music_generic_list_get_table (MusicGenericList* self)
{
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->table;
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

/** Should not be manipulated by client */
GeeBidirList*
music_generic_list_get_visible_table (MusicGenericList* self)
{
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->showing;
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

gint
music_generic_list_get_index_from_iter (GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gint result;
	g_return_val_if_fail (iter != NULL, 0);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.user_data;
	result = (gint) _tmp1_;
	return result;
}

MusicMedia*
music_generic_list_get_object_from_index (MusicGenericList* self,
                                          gint index)
{
	MusicMedia* _tmp0_ = NULL;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	MusicMedia* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->showing;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (index < _tmp3_) {
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
		_tmp4_ = self->showing;
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, index);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = (MusicMedia*) _tmp5_;
	} else {
		_g_object_unref0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}

void
music_generic_list_set_value_func (MusicGenericList* self,
                                   MusicFastModelValueReturnFunc func,
                                   gpointer func_target)
{
	MusicFastModel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->fm;
	music_fast_model_set_value_func (_tmp0_, func, func_target);
}

void
music_generic_list_set_table (MusicGenericList* self,
                              GeeArrayList* table,
                              gboolean do_resort)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (table != NULL);
	_tmp0_ = _g_object_ref0 (table);
	_g_object_unref0 (self->table);
	self->table = _tmp0_;
	if (do_resort) {
		music_generic_list_resort (self);
	} else {
		music_generic_list_do_search (self, NULL);
	}
}

void
music_generic_list_set_search_func (MusicGenericList* self,
                                    MusicGenericListViewSearchFunc func,
                                    gpointer func_target)
{
	g_return_if_fail (self != NULL);
	self->priv->search_func = func;
	self->priv->search_func_target = func_target;
}

void
music_generic_list_do_search (MusicGenericList* self,
                              const gchar* search)
{
	gboolean _tmp0_ = FALSE;
	MusicGenericListViewSearchFunc _tmp1_;
	gpointer _tmp1__target;
	gint old_size = 0;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* _tmp6_;
	const gchar* _tmp7_ = NULL;
	MusicGenericListViewSearchFunc _tmp8_;
	gpointer _tmp8__target;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->search_func;
	_tmp1__target = self->priv->search_func_target;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = self->priv->_research_needed;
		_tmp0_ = _tmp2_ == FALSE;
	}
	if (_tmp0_) {
		return;
	}
	music_generic_list_set_research_needed (self, FALSE);
	_tmp3_ = self->showing;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	old_size = _tmp5_;
	_tmp6_ = self->showing;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp6_);
	_tmp7_ = search;
	if (_tmp7_ == NULL) {
		_tmp7_ = "";
	}
	_tmp8_ = self->priv->search_func;
	_tmp8__target = self->priv->search_func_target;
	_tmp9_ = self->table;
	_tmp10_ = self->showing;
	_tmp8_ (_tmp7_, _tmp9_, _tmp10_, _tmp8__target);
	_tmp11_ = self->showing;
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
	_tmp13_ = _tmp12_;
	if (_tmp13_ == old_size) {
		MusicFastModel* _tmp14_;
		GeeArrayList* _tmp15_;
		_tmp14_ = self->fm;
		_tmp15_ = self->showing;
		music_fast_model_set_table (_tmp14_, _tmp15_);
		gtk_widget_queue_draw ((GtkWidget*) self);
	} else {
		if (old_size == 0) {
			MusicFastModel* _tmp16_;
			GeeArrayList* _tmp17_;
			MusicFastModel* _tmp18_;
			gtk_tree_view_set_model ((GtkTreeView*) self, NULL);
			_tmp16_ = self->fm;
			_tmp17_ = self->showing;
			music_fast_model_set_table (_tmp16_, _tmp17_);
			_tmp18_ = self->fm;
			gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp18_);
		} else {
			GeeArrayList* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			_tmp19_ = self->showing;
			_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
			_tmp21_ = _tmp20_;
			if (old_size > _tmp21_) {
				MusicFastModel* _tmp31_;
				GeeArrayList* _tmp32_;
				while (TRUE) {
					MusicFastModel* _tmp22_;
					GeeArrayList* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					GtkTreeIter iter = {0};
					MusicFastModel* _tmp26_;
					MusicFastModel* _tmp27_;
					GtkTreeIter _tmp28_ = {0};
					MusicFastModel* _tmp29_;
					GtkTreeIter _tmp30_;
					_tmp22_ = self->fm;
					_tmp23_ = self->showing;
					_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
					_tmp25_ = _tmp24_;
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp22_, NULL) > _tmp25_)) {
						break;
					}
					_tmp26_ = self->fm;
					_tmp27_ = self->fm;
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp26_, &_tmp28_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp27_, NULL) - 1);
					iter = _tmp28_;
					_tmp29_ = self->fm;
					_tmp30_ = iter;
					music_fast_model_remove (_tmp29_, &_tmp30_);
				}
				_tmp31_ = self->fm;
				_tmp32_ = self->showing;
				music_fast_model_set_table (_tmp31_, _tmp32_);
				gtk_widget_queue_draw ((GtkWidget*) self);
			} else {
				GeeArrayList* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				_tmp33_ = self->showing;
				_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
				_tmp35_ = _tmp34_;
				if (_tmp35_ > old_size) {
					GtkTreeIter iter = {0};
					MusicFastModel* _tmp42_;
					GeeArrayList* _tmp43_;
					while (TRUE) {
						MusicFastModel* _tmp36_;
						GeeArrayList* _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
						MusicFastModel* _tmp40_;
						GtkTreeIter _tmp41_ = {0};
						_tmp36_ = self->fm;
						_tmp37_ = self->showing;
						_tmp38_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp37_);
						_tmp39_ = _tmp38_;
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp36_, NULL) < _tmp39_)) {
							break;
						}
						_tmp40_ = self->fm;
						music_fast_model_append (_tmp40_, &_tmp41_);
						iter = _tmp41_;
					}
					_tmp42_ = self->fm;
					_tmp43_ = self->showing;
					music_fast_model_set_table (_tmp42_, _tmp43_);
					gtk_widget_queue_draw ((GtkWidget*) self);
				}
			}
		}
	}
}

void
music_generic_list_set_sort_column_id (MusicGenericList* self,
                                       gint sort_column_id,
                                       GtkSortType order)
{
	MusicFastModel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->fm;
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp0_, sort_column_id, order);
}

static void
music_generic_list_reorder_requested (MusicGenericList* self,
                                      gint column,
                                      GtkSortType direction)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	if (column == self->sort_column_id) {
		_tmp0_ = direction == self->sort_direction;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	self->sort_column_id = column;
	self->sort_direction = direction;
	_tmp1_ = self->table;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	music_generic_list_quicksort (self, 0, _tmp3_ - 1);
	music_generic_list_set_research_needed (self, TRUE);
	music_generic_list_do_search (self, NULL);
	g_signal_emit (self, music_generic_list_signals[MUSIC_GENERIC_LIST_ROWS_REORDERED_SIGNAL], 0);
}

void
music_generic_list_resort (MusicGenericList* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	music_generic_list_quicksort (self, 0, _tmp2_ - 1);
	music_generic_list_set_research_needed (self, TRUE);
	music_generic_list_do_search (self, NULL);
}

void
music_generic_list_set_compare_func (MusicGenericList* self,
                                     MusicGenericListSortCompareFunc func,
                                     gpointer func_target)
{
	g_return_if_fail (self != NULL);
	self->priv->compare_func = func;
	self->priv->compare_func_target = func_target;
}

static void
music_generic_list_swap (MusicGenericList* self,
                         gint a,
                         gint b)
{
	MusicMedia* temp = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	MusicMedia* _tmp5_;
	GeeArrayList* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, a);
	temp = (MusicMedia*) _tmp1_;
	_tmp2_ = self->table;
	_tmp3_ = self->table;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, b);
	_tmp5_ = (MusicMedia*) _tmp4_;
	gee_abstract_list_set ((GeeAbstractList*) _tmp2_, a, _tmp5_);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = self->table;
	gee_abstract_list_set ((GeeAbstractList*) _tmp6_, b, temp);
	_g_object_unref0 (temp);
}

static void
music_generic_list_quicksort (MusicGenericList* self,
                              gint start,
                              gint end)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint pivot_index = 0;
	MusicMedia* pivot = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	gint i = 0;
	gint j = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		return;
	}
	pivot_index = (start + end) / 2;
	_tmp3_ = self->table;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, pivot_index);
	pivot = (MusicMedia*) _tmp4_;
	i = start;
	j = end;
	while (TRUE) {
		if (!(i <= j)) {
			break;
		}
		while (TRUE) {
			gboolean _tmp5_ = FALSE;
			gint _tmp11_;
			if (i < end) {
				MusicGenericListSortCompareFunc _tmp6_;
				gpointer _tmp6__target;
				GeeArrayList* _tmp7_;
				gpointer _tmp8_;
				MusicMedia* _tmp9_;
				MusicMedia* _tmp10_;
				_tmp6_ = self->priv->compare_func;
				_tmp6__target = self->priv->compare_func_target;
				_tmp7_ = self->table;
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, i);
				_tmp9_ = (MusicMedia*) _tmp8_;
				_tmp10_ = pivot;
				_tmp5_ = _tmp6_ (self->sort_column_id, self->sort_direction, _tmp9_, _tmp10_, i, pivot_index, _tmp6__target) < 0;
				_g_object_unref0 (_tmp9_);
			} else {
				_tmp5_ = FALSE;
			}
			if (!_tmp5_) {
				break;
			}
			i = i + 1;
			_tmp11_ = i;
		}
		while (TRUE) {
			gboolean _tmp12_ = FALSE;
			gint _tmp18_;
			if (j > start) {
				MusicGenericListSortCompareFunc _tmp13_;
				gpointer _tmp13__target;
				GeeArrayList* _tmp14_;
				gpointer _tmp15_;
				MusicMedia* _tmp16_;
				MusicMedia* _tmp17_;
				_tmp13_ = self->priv->compare_func;
				_tmp13__target = self->priv->compare_func_target;
				_tmp14_ = self->table;
				_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, j);
				_tmp16_ = (MusicMedia*) _tmp15_;
				_tmp17_ = pivot;
				_tmp12_ = _tmp13_ (self->sort_column_id, self->sort_direction, _tmp16_, _tmp17_, j, pivot_index, _tmp13__target) > 0;
				_g_object_unref0 (_tmp16_);
			} else {
				_tmp12_ = FALSE;
			}
			if (!_tmp12_) {
				break;
			}
			j = j - 1;
			_tmp18_ = j;
		}
		if (i <= j) {
			gint _tmp19_;
			gint _tmp20_;
			music_generic_list_swap (self, i, j);
			i = i + 1;
			_tmp19_ = i;
			j = j - 1;
			_tmp20_ = j;
		}
	}
	if (start < j) {
		music_generic_list_quicksort (self, start, j);
	}
	if (i < end) {
		music_generic_list_quicksort (self, i, end);
	}
	_g_object_unref0 (pivot);
}

/** **********************************************************
     * Drag and drop support. GenericList is a source for media and can
     * be dragged to a playlist in the sidebar. No support for reordering
     * is implemented yet.
    ***************************************************************/
static void
music_generic_list_on_drag_begin (MusicGenericList* self,
                                  GtkWidget* sender,
                                  GdkDragContext* context)
{
	gint selected_rows = 0;
	GtkTreeSelection* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (context != NULL);
	self->dragging = TRUE;
	g_debug ("GenericList.vala:492: drag begin");
	gdk_drag_abort (context, gtk_get_current_event_time ());
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	selected_rows = gtk_tree_selection_count_selected_rows (_tmp0_);
	if (selected_rows > 0) {
		gtk_drag_source_set_icon_name ((GtkWidget*) self, "audio-x-generic");
	}
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
music_generic_list_on_drag_data_get (MusicGenericList* self,
                                     GdkDragContext* context,
                                     GtkSelectionData* selection_data,
                                     guint info,
                                     guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	uris = NULL;
	uris_length1 = 0;
	_uris_size_ = uris_length1;
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = music_generic_list_get_selected_medias (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_m_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicMedia* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp4_ = _m_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _m_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			m = (MusicMedia*) _tmp6_;
			_tmp7_ = m;
			_tmp8_ = music_media_get_uri (_tmp7_);
			_tmp9_ = _tmp8_;
			_vala_array_add13 (&uris, &uris_length1, &_uris_size_, _tmp9_);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp10_ = uris;
	_tmp10__length1 = uris_length1;
	if (_tmp10_ != NULL) {
		gchar** _tmp11_;
		gint _tmp11__length1;
		_tmp11_ = uris;
		_tmp11__length1 = uris_length1;
		gtk_selection_data_set_uris (selection_data, _tmp11_);
	}
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
}

static void
music_generic_list_on_drag_end (MusicGenericList* self,
                                GtkWidget* sender,
                                GdkDragContext* context)
{
	GtkTargetEntry* _tmp0_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (context != NULL);
	self->dragging = FALSE;
	g_debug ("GenericList.vala:515: drag end\n");
	_tmp0_ = g_new0 (GtkTargetEntry, 0);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 0;
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, _tmp1_, (gint) 0, GDK_ACTION_COPY | GDK_ACTION_MOVE);
	_tmp1_ = (g_free (_tmp1_), NULL);
}

GeeList*
music_generic_list_get_columns (MusicGenericList* self)
{
	GeeList* result;
	GeeList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_columns;
	result = _tmp0_;
	return result;
}

void
music_generic_list_set_columns (MusicGenericList* self,
                                GeeList* value)
{
	GeeList* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_generic_list_get_columns (self);
	if (old_value != value) {
		GeeList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_columns);
		self->priv->_columns = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_COLUMNS_PROPERTY]);
	}
}

gboolean
music_generic_list_get_research_needed (MusicGenericList* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_research_needed;
	return result;
}

void
music_generic_list_set_research_needed (MusicGenericList* self,
                                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_generic_list_get_research_needed (self);
	if (old_value != value) {
		self->priv->_research_needed = value;
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY]);
	}
}

gboolean
music_generic_list_get_is_current_list (MusicGenericList* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_current_list;
	return result;
}

static void
music_generic_list_set_is_current_list (MusicGenericList* self,
                                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_generic_list_get_is_current_list (self);
	if (old_value != value) {
		self->priv->_is_current_list = value;
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY]);
	}
}

MusicPlaylist*
music_generic_list_get_playlist (MusicGenericList* self)
{
	MusicPlaylist* result;
	MusicPlaylist* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_playlist;
	result = _tmp0_;
	return result;
}

void
music_generic_list_set_playlist (MusicGenericList* self,
                                 MusicPlaylist* value)
{
	MusicPlaylist* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_generic_list_get_playlist (self);
	if (old_value != value) {
		MusicPlaylist* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_playlist);
		self->priv->_playlist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY]);
	}
}

MusicTreeViewSetup*
music_generic_list_get_tvs (MusicGenericList* self)
{
	MusicTreeViewSetup* result;
	MusicTreeViewSetup* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tvs;
	result = _tmp0_;
	return result;
}

void
music_generic_list_set_tvs (MusicGenericList* self,
                            MusicTreeViewSetup* value)
{
	MusicTreeViewSetup* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_generic_list_get_tvs (self);
	if (old_value != value) {
		MusicTreeViewSetup* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_tvs);
		self->priv->_tvs = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_TVS_PROPERTY]);
	}
}

MusicViewWrapperHint
music_generic_list_get_hint (MusicGenericList* self)
{
	MusicViewWrapperHint result;
	MusicTreeViewSetup* _tmp0_;
	MusicViewWrapperHint _tmp1_;
	MusicViewWrapperHint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_tvs;
	_tmp1_ = music_tree_view_setup_get_hint (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
music_generic_list_set_hint (MusicGenericList* self,
                             MusicViewWrapperHint value)
{
	MusicTreeViewSetup* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_tvs;
	music_tree_view_setup_set_hint (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_HINT_PROPERTY]);
}

MusicViewWrapper*
music_generic_list_get_parent_wrapper (MusicGenericList* self)
{
	MusicViewWrapper* result;
	MusicViewWrapper* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_parent_wrapper;
	result = _tmp0_;
	return result;
}

void
music_generic_list_set_parent_wrapper (MusicGenericList* self,
                                       MusicViewWrapper* value)
{
	MusicViewWrapper* _tmp0_;
	MusicPlaylist* _tmp1_;
	MusicPlaylist* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_parent_wrapper);
	self->priv->_parent_wrapper = _tmp0_;
	_tmp1_ = music_view_wrapper_get_playlist (value);
	_tmp2_ = _tmp1_;
	music_generic_list_set_playlist (self, _tmp2_);
	g_object_notify_by_pspec ((GObject *) self, music_generic_list_properties[MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY]);
}

static void
_music_generic_list_reorder_requested_music_fast_model_reorder_requested (MusicFastModel* _sender,
                                                                          gint column,
                                                                          GtkSortType direction,
                                                                          gpointer self)
{
	music_generic_list_reorder_requested ((MusicGenericList*) self, column, direction);
}

static void
_music_generic_list_on_rows_reordered_music_generic_list_rows_reordered (MusicGenericList* _sender,
                                                                         gpointer self)
{
	music_generic_list_on_rows_reordered ((MusicGenericList*) self);
}

static gboolean
_music_generic_list___lambda40_ (MusicGenericList* self,
                                 GdkEventKey* event)
{
	gboolean result;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->keyval == GDK_KEY_Delete) {
		music_generic_list_media_remove_clicked (self);
	}
	result = FALSE;
	return result;
}

static gboolean
__music_generic_list___lambda40__gtk_widget_key_press_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = _music_generic_list___lambda40_ ((MusicGenericList*) self, event);
	return result;
}

static void
_music_generic_list_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                         GdkDragContext* context,
                                                         gpointer self)
{
	music_generic_list_on_drag_begin ((MusicGenericList*) self, _sender, context);
}

static void
_music_generic_list_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                               GdkDragContext* context,
                                                               GtkSelectionData* selection_data,
                                                               guint info,
                                                               guint time_,
                                                               gpointer self)
{
	music_generic_list_on_drag_data_get ((MusicGenericList*) self, context, selection_data, info, time_);
}

static void
_music_generic_list_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                     GdkDragContext* context,
                                                     gpointer self)
{
	music_generic_list_on_drag_end ((MusicGenericList*) self, _sender, context);
}

static void
_gtk_widget_queue_draw_music_library_media_updated (MusicLibrary* _sender,
                                                    GeeCollection* medias,
                                                    gpointer self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
_music_generic_list___lambda41_ (MusicGenericList* self)
{
	music_generic_list_set_is_current_list (self, FALSE);
}

static void
__music_generic_list___lambda41__music_playback_manager_queue_cleared (MusicPlaybackManager* _sender,
                                                                       gpointer self)
{
	_music_generic_list___lambda41_ ((MusicGenericList*) self);
}

static void
_music_generic_list_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                      MusicMedia* played_media,
                                                                      gpointer self)
{
	music_generic_list_media_played ((MusicGenericList*) self, played_media, NULL, NULL);
}

static GObject *
music_generic_list_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicGenericList * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeList* _tmp10_;
	MusicFastModel* _tmp11_;
	MusicFastModel* _tmp12_;
	GeeArrayList* _tmp13_;
	MusicFastModel* _tmp14_;
	MusicCellDataFunctionHelper* _tmp15_;
	MusicTreeViewSetup* _tmp16_;
	MusicListColumn _tmp17_;
	MusicListColumn _tmp18_;
	MusicTreeViewSetup* _tmp19_;
	GtkSortType _tmp20_;
	GtkSortType _tmp21_;
	GtkTreeSelection* _tmp34_;
	GtkTargetEntry te = {0};
	GtkTargetEntry _tmp35_ = {0};
	GtkTargetEntry _tmp36_;
	GtkTargetEntry* _tmp37_;
	GtkTargetEntry* _tmp38_;
	gint _tmp38__length1;
	MusicViewWrapper* _tmp39_;
	MusicViewWrapper* _tmp40_;
	MusicLibrary* _tmp41_;
	MusicLibrary* _tmp42_;
	MusicPlaybackManager* _tmp43_;
	MusicPlaybackManager* _tmp44_;
	MusicPlaybackManager* _tmp45_;
	MusicPlaybackManager* _tmp46_;
	parent_class = G_OBJECT_CLASS (music_generic_list_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_GENERIC_LIST, MusicGenericList);
	_tmp0_ = gee_array_list_new (G_TYPE_GTYPE, NULL, NULL, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	music_generic_list_set_columns (self, (GeeList*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	{
		GeeIterator* _type_it = NULL;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp2_ = music_list_column_get_all ();
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_type_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			MusicListColumn type = 0;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeList* _tmp9_;
			_tmp6_ = _type_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _type_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			type = (MusicListColumn) ((gintptr) _tmp8_);
			_tmp9_ = self->priv->_columns;
			gee_collection_add ((GeeCollection*) _tmp9_, (gpointer) ((gintptr) music_list_column_get_data_type (type)));
		}
		_g_object_unref0 (_type_it);
	}
	_tmp10_ = self->priv->_columns;
	_tmp11_ = music_fast_model_new (_tmp10_);
	_g_object_unref0 (self->fm);
	self->fm = _tmp11_;
	self->sort_column_id = MUSIC_GENERIC_LIST_OPTIMAL_COLUMN;
	self->sort_direction = GTK_SORT_ASCENDING;
	_tmp12_ = self->fm;
	g_signal_connect_object (_tmp12_, "reorder-requested", (GCallback) _music_generic_list_reorder_requested_music_fast_model_reorder_requested, self, 0);
	_tmp13_ = self->table;
	music_generic_list_set_table (self, _tmp13_, TRUE);
	_tmp14_ = self->fm;
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp14_);
	_tmp15_ = music_cell_data_function_helper_new (self);
	_music_cell_data_function_helper_unref0 (self->cell_data_helper);
	self->cell_data_helper = _tmp15_;
	_tmp16_ = self->priv->_tvs;
	_tmp17_ = music_tree_view_setup_get_sort_column_id (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = self->priv->_tvs;
	_tmp20_ = music_tree_view_setup_get_sort_direction (_tmp19_);
	_tmp21_ = _tmp20_;
	music_generic_list_set_sort_column_id (self, (gint) _tmp18_, _tmp21_);
	gtk_tree_view_set_enable_search ((GtkTreeView*) self, FALSE);
	gtk_tree_view_set_fixed_height_mode ((GtkTreeView*) self, TRUE);
	gtk_tree_view_set_reorderable ((GtkTreeView*) self, FALSE);
	{
		GeeIterator* _tvc_it = NULL;
		MusicTreeViewSetup* _tmp22_;
		GeeCollection* _tmp23_;
		GeeCollection* _tmp24_;
		GeeIterator* _tmp25_;
		GeeIterator* _tmp26_;
		_tmp22_ = self->priv->_tvs;
		_tmp23_ = music_tree_view_setup_get_columns (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = gee_iterable_iterator ((GeeIterable*) _tmp24_);
		_tmp26_ = _tmp25_;
		_g_object_unref0 (_tmp24_);
		_tvc_it = _tmp26_;
		while (TRUE) {
			GeeIterator* _tmp27_;
			GtkTreeViewColumn* tvc = NULL;
			GeeIterator* _tmp28_;
			gpointer _tmp29_;
			GtkTreeViewColumn* _tmp30_;
			GtkTreeViewColumn* _tmp31_;
			MusicListColumn* _tmp32_;
			MusicListColumn* _tmp33_;
			_tmp27_ = _tvc_it;
			if (!gee_iterator_next (_tmp27_)) {
				break;
			}
			_tmp28_ = _tvc_it;
			_tmp29_ = gee_iterator_get (_tmp28_);
			tvc = (GtkTreeViewColumn*) _tmp29_;
			_tmp30_ = tvc;
			_tmp31_ = tvc;
			_tmp32_ = music_tree_view_setup_get_column_type (_tmp31_);
			_tmp33_ = _tmp32_;
			music_generic_list_add_column (self, _tmp30_, *_tmp33_);
			_g_free0 (_tmp33_);
			_g_object_unref0 (tvc);
		}
		_g_object_unref0 (_tvc_it);
	}
	_tmp34_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	gtk_tree_selection_set_mode (_tmp34_, GTK_SELECTION_MULTIPLE);
	g_signal_connect_object (self, "rows-reordered", (GCallback) _music_generic_list_on_rows_reordered_music_generic_list_rows_reordered, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) __music_generic_list___lambda40__gtk_widget_key_press_event, self, 0);
	_tmp35_.target = "text/uri-list";
	_tmp35_.flags = (guint) GTK_TARGET_SAME_APP;
	_tmp35_.info = (guint) 0;
	te = _tmp35_;
	_tmp36_ = te;
	_tmp37_ = g_new0 (GtkTargetEntry, 1);
	_tmp37_[0] = _tmp36_;
	_tmp38_ = _tmp37_;
	_tmp38__length1 = 1;
	gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, _tmp38_, (gint) 1, GDK_ACTION_COPY);
	_tmp38_ = (g_free (_tmp38_), NULL);
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) _music_generic_list_on_drag_begin_gtk_widget_drag_begin, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) _music_generic_list_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "drag-end", (GCallback) _music_generic_list_on_drag_end_gtk_widget_drag_end, self, 0);
	_tmp39_ = music_generic_list_get_parent_wrapper (self);
	_tmp40_ = _tmp39_;
	_tmp41_ = music_view_wrapper_get_library (_tmp40_);
	_tmp42_ = _tmp41_;
	g_signal_connect_object (_tmp42_, "media-updated", (GCallback) _gtk_widget_queue_draw_music_library_media_updated, (GtkWidget*) self, 0);
	_tmp43_ = music_app_get_player ();
	_tmp44_ = _tmp43_;
	g_signal_connect_object (_tmp44_, "queue-cleared", (GCallback) __music_generic_list___lambda41__music_playback_manager_queue_cleared, self, 0);
	_tmp45_ = music_app_get_player ();
	_tmp46_ = _tmp45_;
	g_signal_connect_object (_tmp46_, "media-played", (GCallback) _music_generic_list_media_played_music_playback_manager_media_played, self, 0);
	return obj;
}

static void
music_generic_list_class_init (MusicGenericListClass * klass,
                               gpointer klass_data)
{
	music_generic_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicGenericList_private_offset);
	((MusicGenericListClass *) klass)->add_column = (void (*) (MusicGenericList*, GtkTreeViewColumn*, MusicListColumn)) music_generic_list_real_add_column;
	((MusicGenericListClass *) klass)->media_remove_clicked = (void (*) (MusicGenericList*)) music_generic_list_real_media_remove_clicked;
	((GtkTreeViewClass *) klass)->row_activated = (void (*) (GtkTreeView*, GtkTreePath*, GtkTreeViewColumn*)) music_generic_list_real_row_activated;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_generic_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_generic_list_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_generic_list_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_generic_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_COLUMNS_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY] = g_param_spec_boolean ("research-needed", "research-needed", "research-needed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY] = g_param_spec_boolean ("is-current-list", "is-current-list", "is-current-list", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY] = g_param_spec_object ("playlist", "playlist", "playlist", MUSIC_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_TVS_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_TVS_PROPERTY] = g_param_spec_object ("tvs", "tvs", "tvs", MUSIC_TYPE_TREE_VIEW_SETUP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_HINT_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY, music_generic_list_properties[MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY] = g_param_spec_object ("parent-wrapper", "parent-wrapper", "parent-wrapper", MUSIC_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	music_generic_list_signals[MUSIC_GENERIC_LIST_IMPORT_REQUESTED_SIGNAL] = g_signal_new ("import-requested", MUSIC_TYPE_GENERIC_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	music_generic_list_signals[MUSIC_GENERIC_LIST_ROWS_REORDERED_SIGNAL] = g_signal_new ("rows-reordered", MUSIC_TYPE_GENERIC_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_generic_list_instance_init (MusicGenericList * self,
                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	self->priv = music_generic_list_get_instance_private (self);
	self->priv->_research_needed = FALSE;
	self->priv->_playlist = NULL;
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->table = _tmp0_;
	_tmp1_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->showing = _tmp1_;
}

static void
music_generic_list_finalize (GObject * obj)
{
	MusicGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_GENERIC_LIST, MusicGenericList);
	_g_object_unref0 (self->priv->_columns);
	_g_object_unref0 (self->priv->_playlist);
	_g_object_unref0 (self->priv->_tvs);
	_g_object_unref0 (self->priv->_parent_wrapper);
	_g_object_unref0 (self->fm);
	_g_object_unref0 (self->table);
	_g_object_unref0 (self->showing);
	_music_cell_data_function_helper_unref0 (self->cell_data_helper);
	G_OBJECT_CLASS (music_generic_list_parent_class)->finalize (obj);
}

static GType
music_generic_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicGenericListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_generic_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicGenericList), 0, (GInstanceInitFunc) music_generic_list_instance_init, NULL };
	GType music_generic_list_type_id;
	music_generic_list_type_id = g_type_register_static (gtk_tree_view_get_type (), "MusicGenericList", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MusicGenericList_private_offset = g_type_add_instance_private (music_generic_list_type_id, sizeof (MusicGenericListPrivate));
	return music_generic_list_type_id;
}

GType
music_generic_list_get_type (void)
{
	static volatile gsize music_generic_list_type_id__once = 0;
	if (g_once_init_enter (&music_generic_list_type_id__once)) {
		GType music_generic_list_type_id;
		music_generic_list_type_id = music_generic_list_get_type_once ();
		g_once_init_leave (&music_generic_list_type_id__once, music_generic_list_type_id);
	}
	return music_generic_list_type_id__once;
}

static void
_vala_music_generic_list_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MusicGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_GENERIC_LIST, MusicGenericList);
	switch (property_id) {
		case MUSIC_GENERIC_LIST_COLUMNS_PROPERTY:
		g_value_set_object (value, music_generic_list_get_columns (self));
		break;
		case MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY:
		g_value_set_boolean (value, music_generic_list_get_research_needed (self));
		break;
		case MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY:
		g_value_set_boolean (value, music_generic_list_get_is_current_list (self));
		break;
		case MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY:
		g_value_set_object (value, music_generic_list_get_playlist (self));
		break;
		case MUSIC_GENERIC_LIST_TVS_PROPERTY:
		g_value_set_object (value, music_generic_list_get_tvs (self));
		break;
		case MUSIC_GENERIC_LIST_HINT_PROPERTY:
		g_value_set_enum (value, music_generic_list_get_hint (self));
		break;
		case MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY:
		g_value_set_object (value, music_generic_list_get_parent_wrapper (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_generic_list_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MusicGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_GENERIC_LIST, MusicGenericList);
	switch (property_id) {
		case MUSIC_GENERIC_LIST_COLUMNS_PROPERTY:
		music_generic_list_set_columns (self, g_value_get_object (value));
		break;
		case MUSIC_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY:
		music_generic_list_set_research_needed (self, g_value_get_boolean (value));
		break;
		case MUSIC_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY:
		music_generic_list_set_is_current_list (self, g_value_get_boolean (value));
		break;
		case MUSIC_GENERIC_LIST_PLAYLIST_PROPERTY:
		music_generic_list_set_playlist (self, g_value_get_object (value));
		break;
		case MUSIC_GENERIC_LIST_TVS_PROPERTY:
		music_generic_list_set_tvs (self, g_value_get_object (value));
		break;
		case MUSIC_GENERIC_LIST_HINT_PROPERTY:
		music_generic_list_set_hint (self, g_value_get_enum (value));
		break;
		case MUSIC_GENERIC_LIST_PARENT_WRAPPER_PROPERTY:
		music_generic_list_set_parent_wrapper (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

