/* SourceListView.c generated by valac 0.55.1, the Vala compiler
 * generated from SourceListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* Add an interface so that SourceListItem and SourceListExpandableItem still share a common*/
/* ancestor that is compatible with the SourceList widget.*/

#include "music-lib.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "io.elementary.music-core.h"
#include <gee.h>

enum  {
	MUSIC_SOURCE_LIST_ITEM_0_PROPERTY,
	MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY,
	MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY,
	MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY,
	MUSIC_SOURCE_LIST_ITEM_NUM_PROPERTIES
};
static GParamSpec* music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL,
	MUSIC_SOURCE_LIST_ITEM_NUM_SIGNALS
};
static guint music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_NUM_SIGNALS] = {0};
enum  {
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_0_PROPERTY,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES
};
static GParamSpec* music_source_list_expandable_item_properties[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES];
typedef struct _Block32Data Block32Data;
enum  {
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS
};
static guint music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS] = {0};
enum  {
	MUSIC_PLAY_LIST_CATEGORY_0_PROPERTY,
	MUSIC_PLAY_LIST_CATEGORY_NUM_PROPERTIES
};
static GParamSpec* music_play_list_category_properties[MUSIC_PLAY_LIST_CATEGORY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	MUSIC_PLAY_LIST_CATEGORY_NUM_SIGNALS
};
static guint music_play_list_category_signals[MUSIC_PLAY_LIST_CATEGORY_NUM_SIGNALS] = {0};
enum  {
	MUSIC_SOURCE_LIST_ROOT_0_PROPERTY,
	MUSIC_SOURCE_LIST_ROOT_NUM_PROPERTIES
};
static GParamSpec* music_source_list_root_properties[MUSIC_SOURCE_LIST_ROOT_NUM_PROPERTIES];
enum  {
	MUSIC_SOURCE_LIST_VIEW_0_PROPERTY,
	MUSIC_SOURCE_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_source_list_view_properties[MUSIC_SOURCE_LIST_VIEW_NUM_PROPERTIES];
typedef struct _Block33Data Block33Data;
enum  {
	MUSIC_SOURCE_LIST_VIEW_EDITED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	MUSIC_SOURCE_LIST_VIEW_NUM_SIGNALS
};
static guint music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_NUM_SIGNALS] = {0};

struct _MusicSourceListItemPrivate {
	GtkGrid* _view;
	MusicViewWrapperHint _hint;
	GIcon* _activatable_icon;
	GtkMenu* playlist_menu;
};

struct _MusicSourceListExpandableItemPrivate {
	GtkGrid* _view;
	GtkMenu* device_menu;
};

struct _Block32Data {
	int _ref_count_;
	MusicSourceListExpandableItem* self;
	GtkGrid* view;
};

struct _MusicPlayListCategoryPrivate {
	GtkMenu* playlist_menu;
};

struct _MusicSourceListViewPrivate {
	GraniteWidgetsSourceListExpandableItem* library_category;
	GraniteWidgetsSourceListExpandableItem* devices_category;
	GraniteWidgetsSourceListExpandableItem* network_category;
	MusicPlayListCategory* playlists_category;
};

struct _Block33Data {
	int _ref_count_;
	MusicSourceListView* self;
	MusicSourceListItem* sourcelist_item;
	MusicSourceListExpandableItem* expandable_item;
};

static gint MusicSourceListItem_private_offset;
static gpointer music_source_list_item_parent_class = NULL;
static MusicSourceListEntryIface * music_source_list_item_music_source_list_entry_parent_iface = NULL;
static GraniteWidgetsSourceListDragDestIface * music_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = NULL;
static gint MusicSourceListExpandableItem_private_offset;
static gpointer music_source_list_expandable_item_parent_class = NULL;
static MusicSourceListEntryIface * music_source_list_expandable_item_music_source_list_entry_parent_iface = NULL;
static gint MusicPlayListCategory_private_offset;
static gpointer music_play_list_category_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * music_play_list_category_granite_widgets_source_list_sortable_parent_iface = NULL;
static gpointer music_source_list_root_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * music_source_list_root_granite_widgets_source_list_sortable_parent_iface = NULL;
static gint MusicSourceListView_private_offset;
static gpointer music_source_list_view_parent_class = NULL;

static GType music_source_list_entry_get_type_once (void);
static GtkMenu* music_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean music_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base,
                                                         GdkDragContext* context,
                                                         GtkSelectionData* data);
static GdkDragAction music_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base,
                                                         GdkDragContext* context,
                                                         GtkSelectionData* data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static GObject * music_source_list_item_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _music_source_list_item____lambda77_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda78_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda79_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda80_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda81_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item____lambda82_ (MusicSourceListItem* self);
static void __music_source_list_item____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _music_source_list_item___lambda83_ (MusicSourceListItem* self);
static void __music_source_list_item___lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self);
static void music_source_list_item_finalize (GObject * obj);
static GType music_source_list_item_get_type_once (void);
static void _vala_music_source_list_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_source_list_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static void ___lambda88_ (Block32Data* _data32_);
static void ____lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda89_ (Block32Data* _data32_);
static void ____lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void _____lambda90_ (Block32Data* _data32_);
static void ______lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _____lambda91_ (Block32Data* _data32_);
static void ______lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _____lambda92_ (Block32Data* _data32_);
static void ______lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static GtkMenu* music_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static void music_source_list_expandable_item_finalize (GObject * obj);
static GType music_source_list_expandable_item_get_type_once (void);
static void _vala_music_source_list_expandable_item_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_music_source_list_expandable_item_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
static GtkMenu* music_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean music_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint music_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base,
                                            GraniteWidgetsSourceListItem* a,
                                            GraniteWidgetsSourceListItem* b);
static GObject * music_play_list_category_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _music_play_list_category___lambda84_ (MusicPlayListCategory* self);
static void __music_play_list_category___lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void _music_play_list_category___lambda85_ (MusicPlayListCategory* self);
static void __music_play_list_category___lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void _music_play_list_category___lambda86_ (MusicPlayListCategory* self);
static void __music_play_list_category___lambda86__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void music_play_list_category_finalize (GObject * obj);
static GType music_play_list_category_get_type_once (void);
static gboolean music_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint music_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base,
                                          GraniteWidgetsSourceListItem* a,
                                          GraniteWidgetsSourceListItem* b);
static GType music_source_list_root_get_type_once (void);
static void __lambda87_ (MusicSourceListView* self);
static void ___lambda87__music_play_list_category_playlist_import_clicked (MusicPlayListCategory* _sender,
                                                                    gpointer self);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static void __lambda93_ (MusicSourceListView* self);
static void ___lambda93__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender,
                                                              gpointer self);
static void __lambda94_ (Block33Data* _data33_,
                  const gchar* new_name);
static void ___lambda94__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender,
                                                           const gchar* new_name,
                                                           gpointer self);
static void __lambda95_ (Block33Data* _data33_,
                  GraniteWidgetsSourceListItem* sl);
static void ___lambda95__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender,
                                                                     gpointer self);
static void __lambda96_ (MusicSourceListView* self,
                  GtkGrid* view,
                  MusicSourceListItem* item);
static void ___lambda96__music_source_list_item_playlist_rename_clicked (MusicSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  MusicSourceListItem* item,
                                                                  gpointer self);
static void __lambda97_ (MusicSourceListView* self,
                  GtkGrid* view);
static void ___lambda97__music_source_list_item_playlist_edit_clicked (MusicSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda98_ (MusicSourceListView* self,
                  GtkGrid* view);
static void ___lambda98__music_source_list_item_playlist_remove_clicked (MusicSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  gpointer self);
static void __lambda99_ (MusicSourceListView* self,
                  GtkGrid* view);
static void ___lambda99__music_source_list_item_playlist_save_clicked (MusicSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda100_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda100__music_source_list_item_playlist_export_clicked (MusicSourceListItem* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda101_ (MusicSourceListView* self,
                   GtkGrid* view,
                   gchar** uris,
                   gint uris_length1);
static void ___lambda101__music_source_list_item_playlist_media_added (MusicSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gchar** media,
                                                                gint media_length1,
                                                                gpointer self);
static void __lambda102_ (Block33Data* _data33_,
                   GtkGrid* view);
static GtkGrid* music_source_list_view_get_device_from_item (MusicSourceListView* self,
                                                      MusicSourceListExpandableItem* item);
static void ___lambda102__music_source_list_expandable_item_device_import_clicked (MusicSourceListExpandableItem* _sender,
                                                                            GtkGrid* view,
                                                                            gpointer self);
static void __lambda103_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda103__music_source_list_expandable_item_device_eject_clicked (MusicSourceListExpandableItem* _sender,
                                                                           GtkGrid* view,
                                                                           gpointer self);
static void __lambda104_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda104__music_source_list_expandable_item_device_sync_clicked (MusicSourceListExpandableItem* _sender,
                                                                          GtkGrid* view,
                                                                          gpointer self);
static void __lambda105_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda105__music_source_list_expandable_item_device_new_playlist_clicked (MusicSourceListExpandableItem* _sender,
                                                                                  GtkGrid* view,
                                                                                  gpointer self);
static void __lambda106_ (MusicSourceListView* self,
                   GtkGrid* view);
static void ___lambda106__music_source_list_expandable_item_device_new_smartplaylist_clicked (MusicSourceListExpandableItem* _sender,
                                                                                       GtkGrid* view,
                                                                                       gpointer self);
static void music_source_list_view_real_item_selected (GraniteWidgetsSourceList* base,
                                                GraniteWidgetsSourceListItem* item);
static void music_source_list_view_enumerate_children_items (MusicSourceListView* self,
                                                      MusicSourceListExpandableItem* exp_item,
                                                      GeeTreeSet** pages);
static void music_source_list_view_enumerate_children_pages (MusicSourceListView* self,
                                                      MusicSourceListExpandableItem* exp_item,
                                                      GeeTreeSet** pages);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void music_source_list_view_finalize (GObject * obj);
static GType music_source_list_view_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static void
music_source_list_entry_default_init (MusicSourceListEntryIface * iface,
                                      gpointer iface_data)
{
}

static GType
music_source_list_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListEntryIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_entry_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType music_source_list_entry_type_id;
	music_source_list_entry_type_id = g_type_register_static (G_TYPE_INTERFACE, "MusicSourceListEntry", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (music_source_list_entry_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	return music_source_list_entry_type_id;
}

GType
music_source_list_entry_get_type (void)
{
	static volatile gsize music_source_list_entry_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_entry_type_id__once)) {
		GType music_source_list_entry_type_id;
		music_source_list_entry_type_id = music_source_list_entry_get_type_once ();
		g_once_init_leave (&music_source_list_entry_type_id__once, music_source_list_entry_type_id);
	}
	return music_source_list_entry_type_id__once;
}

static inline gpointer
music_source_list_item_get_instance_private (MusicSourceListItem* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSourceListItem_private_offset);
}

MusicSourceListItem*
music_source_list_item_construct (GType object_type,
                                  GtkGrid* view,
                                  const gchar* name,
                                  MusicViewWrapperHint hint,
                                  GIcon* icon,
                                  GIcon* activatable_icon)
{
	MusicSourceListItem * self = NULL;
	g_return_val_if_fail (view != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	self = (MusicSourceListItem*) g_object_new (object_type, "activatable-icon", activatable_icon, "hint", hint, "icon", icon, "name", name, "view", view, NULL);
	return self;
}

MusicSourceListItem*
music_source_list_item_new (GtkGrid* view,
                            const gchar* name,
                            MusicViewWrapperHint hint,
                            GIcon* icon,
                            GIcon* activatable_icon)
{
	return music_source_list_item_construct (MUSIC_TYPE_SOURCE_LIST_ITEM, view, name, hint, icon, activatable_icon);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkMenu*
music_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	MusicSourceListItem * self;
	GtkMenu* _tmp0_;
	GtkMenu* result;
	self = (MusicSourceListItem*) base;
	_tmp0_ = self->priv->playlist_menu;
	if (_tmp0_ != NULL) {
		GtkMenu* _tmp1_;
		GtkWidget* _tmp2_;
		GtkMenu* _tmp4_;
		GtkMenu* _tmp5_;
		_tmp1_ = self->priv->playlist_menu;
		_tmp2_ = gtk_menu_get_attach_widget (_tmp1_);
		if (_tmp2_ != NULL) {
			GtkMenu* _tmp3_;
			_tmp3_ = self->priv->playlist_menu;
			gtk_menu_detach (_tmp3_);
		}
		_tmp4_ = self->priv->playlist_menu;
		_tmp5_ = _g_object_ref0 (_tmp4_);
		result = _tmp5_;
		return result;
	}
	result = NULL;
	return result;
}

static gboolean
music_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base,
                                                GdkDragContext* context,
                                                GtkSelectionData* data)
{
	MusicSourceListItem * self;
	gboolean _tmp0_ = FALSE;
	MusicViewWrapperHint _tmp1_;
	gboolean result;
	self = (MusicSourceListItem*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	g_return_val_if_fail (data != NULL, FALSE);
	_tmp1_ = self->priv->_hint;
	if (_tmp1_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
		_tmp0_ = gtk_selection_data_get_target (data) == gdk_atom_intern_static_string ("text/uri-list");
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static GdkDragAction
music_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base,
                                           GdkDragContext* context,
                                           GtkSelectionData* data)
{
	MusicSourceListItem * self;
	GtkGrid* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GdkDragAction result;
	self = (MusicSourceListItem*) base;
	g_return_val_if_fail (context != NULL, 0U);
	g_return_val_if_fail (data != NULL, 0U);
	_tmp0_ = self->priv->_view;
	_tmp2_ = _tmp1_ = gtk_selection_data_get_uris (data);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, _tmp0_, _tmp3_, (gint) _vala_array_length (_tmp1_));
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	result = GDK_ACTION_COPY;
	return result;
}

GtkGrid*
music_source_list_item_get_view (MusicSourceListItem* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view;
	result = _tmp0_;
	return result;
}

static void
music_source_list_item_set_view (MusicSourceListItem* self,
                                 GtkGrid* value)
{
	GtkGrid* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_source_list_item_get_view (self);
	if (old_value != value) {
		GtkGrid* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view);
		self->priv->_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY]);
	}
}

MusicViewWrapperHint
music_source_list_item_get_hint (MusicSourceListItem* self)
{
	MusicViewWrapperHint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_hint;
	return result;
}

static void
music_source_list_item_set_hint (MusicSourceListItem* self,
                                 MusicViewWrapperHint value)
{
	MusicViewWrapperHint old_value;
	g_return_if_fail (self != NULL);
	old_value = music_source_list_item_get_hint (self);
	if (old_value != value) {
		self->priv->_hint = value;
		g_object_notify_by_pspec ((GObject *) self, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY]);
	}
}

GIcon*
music_source_list_item_get_activatable_icon (MusicSourceListItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_activatable_icon;
	result = _tmp0_;
	return result;
}

static void
music_source_list_item_set_activatable_icon (MusicSourceListItem* self,
                                             GIcon* value)
{
	GIcon* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_source_list_item_get_activatable_icon (self);
	if (old_value != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_activatable_icon);
		self->priv->_activatable_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOXED_INT) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_int (param_values + 3), data2);
}

static void
_music_source_list_item____lambda77_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_, self);
}

static void
__music_source_list_item____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_music_source_list_item____lambda77_ ((MusicSourceListItem*) self);
}

static void
_music_source_list_item____lambda78_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
}

static void
__music_source_list_item____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_music_source_list_item____lambda78_ ((MusicSourceListItem*) self);
}

static void
_music_source_list_item____lambda79_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_, self);
}

static void
__music_source_list_item____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_music_source_list_item____lambda79_ ((MusicSourceListItem*) self);
}

static void
_music_source_list_item____lambda80_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, _tmp0_);
}

static void
__music_source_list_item____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_music_source_list_item____lambda80_ ((MusicSourceListItem*) self);
}

static void
_music_source_list_item____lambda81_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
}

static void
__music_source_list_item____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_music_source_list_item____lambda81_ ((MusicSourceListItem*) self);
}

static void
_music_source_list_item____lambda82_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, _tmp0_);
}

static void
__music_source_list_item____lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
	_music_source_list_item____lambda82_ ((MusicSourceListItem*) self);
}

static void
_music_source_list_item___lambda83_ (MusicSourceListItem* self)
{
	GtkGrid* _tmp0_;
	_tmp0_ = self->priv->_view;
	g_signal_emit (self, music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, _tmp0_);
}

static void
__music_source_list_item___lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self)
{
	_music_source_list_item___lambda83_ ((MusicSourceListItem*) self);
}

static GObject *
music_source_list_item_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicSourceListItem * self;
	GtkMenu* _tmp0_;
	MusicViewWrapperHint _tmp1_;
	GtkMenuItem* playlist_export = NULL;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenu* _tmp28_;
	GtkMenuItem* _tmp29_;
	GtkMenu* _tmp30_;
	parent_class = G_OBJECT_CLASS (music_source_list_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem);
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->playlist_menu);
	self->priv->playlist_menu = _tmp0_;
	_tmp1_ = self->priv->_hint;
	switch (_tmp1_) {
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
		{
			GtkMenuItem* playlist_rename = NULL;
			GtkMenuItem* _tmp2_;
			GtkMenuItem* playlist_remove = NULL;
			GtkMenuItem* _tmp3_;
			GtkMenu* _tmp4_;
			GtkMenuItem* _tmp5_;
			GtkMenu* _tmp6_;
			GtkMenuItem* _tmp7_;
			GtkMenuItem* _tmp8_;
			GtkMenuItem* _tmp9_;
			_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
			g_object_ref_sink (_tmp2_);
			playlist_rename = _tmp2_;
			_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
			g_object_ref_sink (_tmp3_);
			playlist_remove = _tmp3_;
			_tmp4_ = self->priv->playlist_menu;
			_tmp5_ = playlist_rename;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
			_tmp6_ = self->priv->playlist_menu;
			_tmp7_ = playlist_remove;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp6_, _tmp7_);
			_tmp8_ = playlist_rename;
			g_signal_connect_object (_tmp8_, "activate", (GCallback) __music_source_list_item____lambda77__gtk_menu_item_activate, self, 0);
			_tmp9_ = playlist_remove;
			g_signal_connect_object (_tmp9_, "activate", (GCallback) __music_source_list_item____lambda78__gtk_menu_item_activate, self, 0);
			_g_object_unref0 (playlist_remove);
			_g_object_unref0 (playlist_rename);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
		{
			GtkMenuItem* playlist_rename = NULL;
			GtkMenuItem* _tmp10_;
			GtkMenuItem* playlist_edit = NULL;
			GtkMenuItem* _tmp11_;
			GtkMenuItem* playlist_remove = NULL;
			GtkMenuItem* _tmp12_;
			GtkMenu* _tmp13_;
			GtkMenuItem* _tmp14_;
			GtkMenu* _tmp15_;
			GtkMenuItem* _tmp16_;
			GtkMenu* _tmp17_;
			GtkMenuItem* _tmp18_;
			GtkMenuItem* _tmp19_;
			GtkMenuItem* _tmp20_;
			GtkMenuItem* _tmp21_;
			_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
			g_object_ref_sink (_tmp10_);
			playlist_rename = _tmp10_;
			_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit…"));
			g_object_ref_sink (_tmp11_);
			playlist_edit = _tmp11_;
			_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
			g_object_ref_sink (_tmp12_);
			playlist_remove = _tmp12_;
			_tmp13_ = self->priv->playlist_menu;
			_tmp14_ = playlist_rename;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp13_, _tmp14_);
			_tmp15_ = self->priv->playlist_menu;
			_tmp16_ = playlist_edit;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp15_, _tmp16_);
			_tmp17_ = self->priv->playlist_menu;
			_tmp18_ = playlist_remove;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp17_, _tmp18_);
			_tmp19_ = playlist_rename;
			g_signal_connect_object (_tmp19_, "activate", (GCallback) __music_source_list_item____lambda79__gtk_menu_item_activate, self, 0);
			_tmp20_ = playlist_edit;
			g_signal_connect_object (_tmp20_, "activate", (GCallback) __music_source_list_item____lambda80__gtk_menu_item_activate, self, 0);
			_tmp21_ = playlist_remove;
			g_signal_connect_object (_tmp21_, "activate", (GCallback) __music_source_list_item____lambda81__gtk_menu_item_activate, self, 0);
			_g_object_unref0 (playlist_remove);
			_g_object_unref0 (playlist_edit);
			_g_object_unref0 (playlist_rename);
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
		{
			GtkMenuItem* playlist_save = NULL;
			GtkMenuItem* _tmp22_;
			GtkMenu* _tmp23_;
			GtkMenuItem* _tmp24_;
			GtkMenuItem* _tmp25_;
			_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Save as Playlist"));
			g_object_ref_sink (_tmp22_);
			playlist_save = _tmp22_;
			_tmp23_ = self->priv->playlist_menu;
			_tmp24_ = playlist_save;
			gtk_menu_shell_append ((GtkMenuShell*) _tmp23_, _tmp24_);
			_tmp25_ = playlist_save;
			g_signal_connect_object (_tmp25_, "activate", (GCallback) __music_source_list_item____lambda82__gtk_menu_item_activate, self, 0);
			_g_object_unref0 (playlist_save);
			break;
		}
		default:
		break;
	}
	_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Export…"));
	g_object_ref_sink (_tmp26_);
	playlist_export = _tmp26_;
	_tmp27_ = playlist_export;
	g_signal_connect_object (_tmp27_, "activate", (GCallback) __music_source_list_item___lambda83__gtk_menu_item_activate, self, 0);
	_tmp28_ = self->priv->playlist_menu;
	_tmp29_ = playlist_export;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp28_, _tmp29_);
	_tmp30_ = self->priv->playlist_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp30_);
	_g_object_unref0 (playlist_export);
	return obj;
}

static void
music_source_list_item_class_init (MusicSourceListItemClass * klass,
                                   gpointer klass_data)
{
	music_source_list_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicSourceListItem_private_offset);
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) music_source_list_item_real_get_context_menu;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_source_list_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_source_list_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_source_list_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_source_list_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY, music_source_list_item_properties[MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY] = g_param_spec_object ("activatable-icon", "activatable-icon", "activatable-icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, gtk_grid_get_type (), MUSIC_TYPE_SOURCE_LIST_ITEM);
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_item_signals[MUSIC_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", MUSIC_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT, G_TYPE_NONE, 3, gtk_grid_get_type (), G_TYPE_STRV, G_TYPE_INT);
}

static void
music_source_list_item_music_source_list_entry_interface_init (MusicSourceListEntryIface * iface,
                                                               gpointer iface_data)
{
	music_source_list_item_music_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
}

static void
music_source_list_item_granite_widgets_source_list_drag_dest_interface_init (GraniteWidgetsSourceListDragDestIface * iface,
                                                                             gpointer iface_data)
{
	music_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = g_type_interface_peek_parent (iface);
	iface->data_drop_possible = (gboolean (*) (GraniteWidgetsSourceListDragDest*, GdkDragContext*, GtkSelectionData*)) music_source_list_item_real_data_drop_possible;
	iface->data_received = (GdkDragAction (*) (GraniteWidgetsSourceListDragDest*, GdkDragContext*, GtkSelectionData*)) music_source_list_item_real_data_received;
}

static void
music_source_list_item_instance_init (MusicSourceListItem * self,
                                      gpointer klass)
{
	self->priv = music_source_list_item_get_instance_private (self);
}

static void
music_source_list_item_finalize (GObject * obj)
{
	MusicSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem);
	_g_object_unref0 (self->priv->_view);
	_g_object_unref0 (self->priv->_activatable_icon);
	_g_object_unref0 (self->priv->playlist_menu);
	G_OBJECT_CLASS (music_source_list_item_parent_class)->finalize (obj);
}

/**
 * SourceList item. It stores the number of the corresponding page in the notebook widget.
 */
static GType
music_source_list_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSourceListItem), 0, (GInstanceInitFunc) music_source_list_item_instance_init, NULL };
	static const GInterfaceInfo music_source_list_entry_info = { (GInterfaceInitFunc) music_source_list_item_music_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo granite_widgets_source_list_drag_dest_info = { (GInterfaceInitFunc) music_source_list_item_granite_widgets_source_list_drag_dest_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_source_list_item_type_id;
	music_source_list_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, "MusicSourceListItem", &g_define_type_info, 0);
	g_type_add_interface_static (music_source_list_item_type_id, MUSIC_TYPE_SOURCE_LIST_ENTRY, &music_source_list_entry_info);
	g_type_add_interface_static (music_source_list_item_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, &granite_widgets_source_list_drag_dest_info);
	MusicSourceListItem_private_offset = g_type_add_instance_private (music_source_list_item_type_id, sizeof (MusicSourceListItemPrivate));
	return music_source_list_item_type_id;
}

GType
music_source_list_item_get_type (void)
{
	static volatile gsize music_source_list_item_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_item_type_id__once)) {
		GType music_source_list_item_type_id;
		music_source_list_item_type_id = music_source_list_item_get_type_once ();
		g_once_init_leave (&music_source_list_item_type_id__once, music_source_list_item_type_id);
	}
	return music_source_list_item_type_id__once;
}

static void
_vala_music_source_list_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem);
	switch (property_id) {
		case MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY:
		g_value_set_object (value, music_source_list_item_get_view (self));
		break;
		case MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY:
		g_value_set_enum (value, music_source_list_item_get_hint (self));
		break;
		case MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY:
		g_value_set_object (value, music_source_list_item_get_activatable_icon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_source_list_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem);
	switch (property_id) {
		case MUSIC_SOURCE_LIST_ITEM_VIEW_PROPERTY:
		music_source_list_item_set_view (self, g_value_get_object (value));
		break;
		case MUSIC_SOURCE_LIST_ITEM_HINT_PROPERTY:
		music_source_list_item_set_hint (self, g_value_get_enum (value));
		break;
		case MUSIC_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY:
		music_source_list_item_set_activatable_icon (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
music_source_list_expandable_item_get_instance_private (MusicSourceListExpandableItem* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSourceListExpandableItem_private_offset);
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
	g_atomic_int_inc (&_data32_->_ref_count_);
	return _data32_;
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
		MusicSourceListExpandableItem* self;
		self = _data32_->self;
		_g_object_unref0 (_data32_->view);
		_g_object_unref0 (self);
		g_slice_free (Block32Data, _data32_);
	}
}

static void
___lambda88_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
	self = _data32_->self;
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _data32_->view);
}

static void
____lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	___lambda88_ (self);
}

static void
___lambda89_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
	self = _data32_->self;
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL], 0, _data32_->view);
}

static void
____lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
	___lambda89_ (self);
}

static void
_____lambda90_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
	self = _data32_->self;
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, _data32_->view);
}

static void
______lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
	_____lambda90_ (self);
}

static void
_____lambda91_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
	self = _data32_->self;
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, _data32_->view);
}

static void
______lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
	_____lambda91_ (self);
}

static void
_____lambda92_ (Block32Data* _data32_)
{
	MusicSourceListExpandableItem* self;
	self = _data32_->self;
	g_signal_emit (self, music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL], 0, _data32_->view);
}

static void
______lambda92__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
	_____lambda92_ (self);
}

MusicSourceListExpandableItem*
music_source_list_expandable_item_construct (GType object_type,
                                             GtkGrid* view,
                                             const gchar* name,
                                             MusicViewWrapperHint hint,
                                             GIcon* icon,
                                             GIcon* activatable_icon,
                                             GObject* give_more_information)
{
	MusicSourceListExpandableItem * self = NULL;
	Block32Data* _data32_;
	GtkGrid* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp28_;
	g_return_val_if_fail (view != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	_data32_ = g_slice_new0 (Block32Data);
	_data32_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (view);
	_g_object_unref0 (_data32_->view);
	_data32_->view = _tmp0_;
	self = (MusicSourceListExpandableItem*) granite_widgets_source_list_expandable_item_construct (object_type, name);
	_data32_->self = g_object_ref (self);
	music_source_list_expandable_item_set_view (self, _data32_->view);
	granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) self, icon);
	self->hint = hint;
	if (activatable_icon != NULL) {
		granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) self, activatable_icon);
	}
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->device_menu);
	self->priv->device_menu = _tmp1_;
	if (hint == MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO) {
		GtkMenuItem* import_menuitem = NULL;
		GtkMenuItem* _tmp2_;
		GtkMenuItem* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenuItem* _tmp5_;
		_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library"));
		g_object_ref_sink (_tmp2_);
		import_menuitem = _tmp2_;
		_tmp3_ = import_menuitem;
		g_signal_connect_data (_tmp3_, "activate", (GCallback) ____lambda88__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
		_tmp4_ = self->priv->device_menu;
		_tmp5_ = import_menuitem;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
		_g_object_unref0 (import_menuitem);
	}
	if (hint == MUSIC_VIEW_WRAPPER_HINT_DEVICE) {
		GtkMenuItem* eject_menuitem = NULL;
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkMenu* _tmp26_;
		GtkMenuItem* _tmp27_;
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Eject"));
		g_object_ref_sink (_tmp6_);
		eject_menuitem = _tmp6_;
		_tmp7_ = eject_menuitem;
		g_signal_connect_data (_tmp7_, "activate", (GCallback) ____lambda89__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
		if (G_TYPE_CHECK_INSTANCE_TYPE (give_more_information, MUSIC_TYPE_DEVICE)) {
			MusicDevice* device = NULL;
			MusicDevice* _tmp8_;
			MusicLibrary* device_library = NULL;
			MusicDevice* _tmp9_;
			MusicLibrary* _tmp10_;
			MusicLibrary* _tmp11_;
			MusicLibrary* _tmp16_;
			MusicDevice* _tmp21_;
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (give_more_information, MUSIC_TYPE_DEVICE, MusicDevice));
			device = _tmp8_;
			_tmp9_ = device;
			_tmp10_ = music_device_get_library (_tmp9_);
			device_library = _tmp10_;
			_tmp11_ = device_library;
			if (music_library_support_playlists (_tmp11_)) {
				GtkMenuItem* add_playlist_menuitem = NULL;
				GtkMenuItem* _tmp12_;
				GtkMenuItem* _tmp13_;
				GtkMenu* _tmp14_;
				GtkMenuItem* _tmp15_;
				_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
				g_object_ref_sink (_tmp12_);
				add_playlist_menuitem = _tmp12_;
				_tmp13_ = add_playlist_menuitem;
				g_signal_connect_data (_tmp13_, "activate", (GCallback) ______lambda90__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
				_tmp14_ = self->priv->device_menu;
				_tmp15_ = add_playlist_menuitem;
				gtk_menu_shell_append ((GtkMenuShell*) _tmp14_, _tmp15_);
				_g_object_unref0 (add_playlist_menuitem);
			}
			_tmp16_ = device_library;
			if (music_library_support_smart_playlists (_tmp16_)) {
				GtkMenuItem* add_smart_playlist_menuitem = NULL;
				GtkMenuItem* _tmp17_;
				GtkMenuItem* _tmp18_;
				GtkMenu* _tmp19_;
				GtkMenuItem* _tmp20_;
				_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
				g_object_ref_sink (_tmp17_);
				add_smart_playlist_menuitem = _tmp17_;
				_tmp18_ = add_smart_playlist_menuitem;
				g_signal_connect_data (_tmp18_, "activate", (GCallback) ______lambda91__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
				_tmp19_ = self->priv->device_menu;
				_tmp20_ = add_smart_playlist_menuitem;
				gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, _tmp20_);
				_g_object_unref0 (add_smart_playlist_menuitem);
			}
			_tmp21_ = device;
			if (music_device_read_only (_tmp21_) == FALSE) {
				GtkMenuItem* sync_menuitem = NULL;
				GtkMenuItem* _tmp22_;
				GtkMenuItem* _tmp23_;
				GtkMenu* _tmp24_;
				GtkMenuItem* _tmp25_;
				_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Sync"));
				g_object_ref_sink (_tmp22_);
				sync_menuitem = _tmp22_;
				_tmp23_ = sync_menuitem;
				g_signal_connect_data (_tmp23_, "activate", (GCallback) ______lambda92__gtk_menu_item_activate, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
				_tmp24_ = self->priv->device_menu;
				_tmp25_ = sync_menuitem;
				gtk_menu_shell_append ((GtkMenuShell*) _tmp24_, _tmp25_);
				_g_object_unref0 (sync_menuitem);
			}
			_g_object_unref0 (device_library);
			_g_object_unref0 (device);
		}
		_tmp26_ = self->priv->device_menu;
		_tmp27_ = eject_menuitem;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp26_, _tmp27_);
		_g_object_unref0 (eject_menuitem);
	}
	_tmp28_ = self->priv->device_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
	block32_data_unref (_data32_);
	_data32_ = NULL;
	return self;
}

MusicSourceListExpandableItem*
music_source_list_expandable_item_new (GtkGrid* view,
                                       const gchar* name,
                                       MusicViewWrapperHint hint,
                                       GIcon* icon,
                                       GIcon* activatable_icon,
                                       GObject* give_more_information)
{
	return music_source_list_expandable_item_construct (MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, view, name, hint, icon, activatable_icon, give_more_information);
}

static GtkMenu*
music_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	MusicSourceListExpandableItem * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* result;
	self = (MusicSourceListExpandableItem*) base;
	_tmp0_ = self->priv->device_menu;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

GtkGrid*
music_source_list_expandable_item_get_view (MusicSourceListExpandableItem* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view;
	result = _tmp0_;
	return result;
}

void
music_source_list_expandable_item_set_view (MusicSourceListExpandableItem* self,
                                            GtkGrid* value)
{
	GtkGrid* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_source_list_expandable_item_get_view (self);
	if (old_value != value) {
		GtkGrid* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view);
		self->priv->_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_source_list_expandable_item_properties[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY]);
	}
}

static void
music_source_list_expandable_item_class_init (MusicSourceListExpandableItemClass * klass,
                                              gpointer klass_data)
{
	music_source_list_expandable_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicSourceListExpandableItem_private_offset);
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) music_source_list_expandable_item_real_get_context_menu;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_source_list_expandable_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_source_list_expandable_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_source_list_expandable_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY, music_source_list_expandable_item_properties[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_expandable_item_signals[MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
}

static void
music_source_list_expandable_item_music_source_list_entry_interface_init (MusicSourceListEntryIface * iface,
                                                                          gpointer iface_data)
{
	music_source_list_expandable_item_music_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
}

static void
music_source_list_expandable_item_instance_init (MusicSourceListExpandableItem * self,
                                                 gpointer klass)
{
	self->priv = music_source_list_expandable_item_get_instance_private (self);
}

static void
music_source_list_expandable_item_finalize (GObject * obj)
{
	MusicSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem);
	_g_object_unref0 (self->priv->_view);
	_g_object_unref0 (self->priv->device_menu);
	G_OBJECT_CLASS (music_source_list_expandable_item_parent_class)->finalize (obj);
}

static GType
music_source_list_expandable_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSourceListExpandableItem), 0, (GInstanceInitFunc) music_source_list_expandable_item_instance_init, NULL };
	static const GInterfaceInfo music_source_list_entry_info = { (GInterfaceInitFunc) music_source_list_expandable_item_music_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_source_list_expandable_item_type_id;
	music_source_list_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "MusicSourceListExpandableItem", &g_define_type_info, 0);
	g_type_add_interface_static (music_source_list_expandable_item_type_id, MUSIC_TYPE_SOURCE_LIST_ENTRY, &music_source_list_entry_info);
	MusicSourceListExpandableItem_private_offset = g_type_add_instance_private (music_source_list_expandable_item_type_id, sizeof (MusicSourceListExpandableItemPrivate));
	return music_source_list_expandable_item_type_id;
}

GType
music_source_list_expandable_item_get_type (void)
{
	static volatile gsize music_source_list_expandable_item_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_expandable_item_type_id__once)) {
		GType music_source_list_expandable_item_type_id;
		music_source_list_expandable_item_type_id = music_source_list_expandable_item_get_type_once ();
		g_once_init_leave (&music_source_list_expandable_item_type_id__once, music_source_list_expandable_item_type_id);
	}
	return music_source_list_expandable_item_type_id__once;
}

static void
_vala_music_source_list_expandable_item_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	MusicSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem);
	switch (property_id) {
		case MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY:
		g_value_set_object (value, music_source_list_expandable_item_get_view (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_source_list_expandable_item_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	MusicSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem);
	switch (property_id) {
		case MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY:
		music_source_list_expandable_item_set_view (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
music_play_list_category_get_instance_private (MusicPlayListCategory* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlayListCategory_private_offset);
}

MusicPlayListCategory*
music_play_list_category_construct (GType object_type,
                                    const gchar* name)
{
	MusicPlayListCategory * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (MusicPlayListCategory*) g_object_new (object_type, "name", name, NULL);
	return self;
}

MusicPlayListCategory*
music_play_list_category_new (const gchar* name)
{
	return music_play_list_category_construct (MUSIC_TYPE_PLAY_LIST_CATEGORY, name);
}

static GtkMenu*
music_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	MusicPlayListCategory * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* result;
	self = (MusicPlayListCategory*) base;
	_tmp0_ = self->priv->playlist_menu;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static gboolean
music_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	MusicPlayListCategory * self;
	gboolean result;
	self = (MusicPlayListCategory*) base;
	result = TRUE;
	return result;
}

static gint
music_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base,
                                       GraniteWidgetsSourceListItem* a,
                                       GraniteWidgetsSourceListItem* b)
{
	MusicPlayListCategory * self;
	MusicSourceListItem* item_a = NULL;
	MusicSourceListItem* _tmp0_;
	MusicSourceListItem* item_b = NULL;
	MusicSourceListItem* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MusicSourceListItem* _tmp3_;
	MusicSourceListItem* _tmp5_;
	MusicViewWrapperHint _tmp6_;
	MusicViewWrapperHint _tmp7_;
	MusicSourceListItem* _tmp23_;
	MusicViewWrapperHint _tmp24_;
	MusicViewWrapperHint _tmp25_;
	MusicSourceListItem* _tmp35_;
	MusicViewWrapperHint _tmp36_;
	MusicViewWrapperHint _tmp37_;
	gint result;
	self = (MusicPlayListCategory*) base;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = _g_object_ref0 (MUSIC_IS_SOURCE_LIST_ITEM (a) ? ((MusicSourceListItem*) a) : NULL);
	item_a = _tmp0_;
	_tmp1_ = _g_object_ref0 (MUSIC_IS_SOURCE_LIST_ITEM (b) ? ((MusicSourceListItem*) b) : NULL);
	item_b = _tmp1_;
	_tmp3_ = item_a;
	if (_tmp3_ == NULL) {
		_tmp2_ = TRUE;
	} else {
		MusicSourceListItem* _tmp4_;
		_tmp4_ = item_b;
		_tmp2_ = _tmp4_ == NULL;
	}
	if (_tmp2_) {
		result = 0;
		_g_object_unref0 (item_b);
		_g_object_unref0 (item_a);
		return result;
	}
	_tmp5_ = item_a;
	_tmp6_ = music_source_list_item_get_hint (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
		MusicSourceListItem* _tmp8_;
		MusicViewWrapperHint _tmp9_;
		MusicViewWrapperHint _tmp10_;
		_tmp8_ = item_b;
		_tmp9_ = music_source_list_item_get_hint (_tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
			GCompareFunc _tmp11_;
			MusicSourceListItem* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			MusicSourceListItem* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gint _tmp22_;
			_tmp11_ = ((GCompareFunc) g_strcmp0);
			_tmp12_ = item_a;
			_tmp13_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = g_utf8_collate_key (_tmp14_, (gssize) -1);
			_tmp16_ = _tmp15_;
			_tmp17_ = item_b;
			_tmp18_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp17_);
			_tmp19_ = _tmp18_;
			_tmp20_ = g_utf8_collate_key (_tmp19_, (gssize) -1);
			_tmp21_ = _tmp20_;
			_tmp22_ = _tmp11_ (_tmp16_, _tmp21_);
			_g_free0 (_tmp21_);
			_g_free0 (_tmp16_);
			result = _tmp22_;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
		result = -1;
		_g_object_unref0 (item_b);
		_g_object_unref0 (item_a);
		return result;
	}
	_tmp23_ = item_a;
	_tmp24_ = music_source_list_item_get_hint (_tmp23_);
	_tmp25_ = _tmp24_;
	if (_tmp25_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
		MusicSourceListItem* _tmp26_;
		MusicViewWrapperHint _tmp27_;
		MusicViewWrapperHint _tmp28_;
		MusicSourceListItem* _tmp29_;
		MusicViewWrapperHint _tmp30_;
		MusicViewWrapperHint _tmp31_;
		MusicSourceListItem* _tmp32_;
		MusicViewWrapperHint _tmp33_;
		MusicViewWrapperHint _tmp34_;
		_tmp26_ = item_b;
		_tmp27_ = music_source_list_item_get_hint (_tmp26_);
		_tmp28_ = _tmp27_;
		if (_tmp28_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
			result = 1;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
		_tmp29_ = item_b;
		_tmp30_ = music_source_list_item_get_hint (_tmp29_);
		_tmp31_ = _tmp30_;
		if (_tmp31_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
			result = 0;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
		_tmp32_ = item_b;
		_tmp33_ = music_source_list_item_get_hint (_tmp32_);
		_tmp34_ = _tmp33_;
		if (_tmp34_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
			result = -1;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
	}
	_tmp35_ = item_a;
	_tmp36_ = music_source_list_item_get_hint (_tmp35_);
	_tmp37_ = _tmp36_;
	if (_tmp37_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
		MusicSourceListItem* _tmp38_;
		MusicViewWrapperHint _tmp39_;
		MusicViewWrapperHint _tmp40_;
		_tmp38_ = item_b;
		_tmp39_ = music_source_list_item_get_hint (_tmp38_);
		_tmp40_ = _tmp39_;
		if (_tmp40_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
			result = 0;
			_g_object_unref0 (item_b);
			_g_object_unref0 (item_a);
			return result;
		}
		result = 1;
		_g_object_unref0 (item_b);
		_g_object_unref0 (item_a);
		return result;
	}
	result = 0;
	_g_object_unref0 (item_b);
	_g_object_unref0 (item_a);
	return result;
}

static void
_music_play_list_category___lambda84_ (MusicPlayListCategory* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicLocalLibrary* _tmp2_;
	MusicLocalLibrary* _tmp3_;
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_library_window_get_library_manager (self);
	_tmp3_ = _tmp2_;
	music_library_window_create_new_playlist (_tmp1_, (MusicLibrary*) _tmp3_);
}

static void
__music_play_list_category___lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
	_music_play_list_category___lambda84_ ((MusicPlayListCategory*) self);
}

static void
_music_play_list_category___lambda85_ (MusicPlayListCategory* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	music_library_window_show_smart_playlist_dialog (_tmp1_, NULL);
}

static void
__music_play_list_category___lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
	_music_play_list_category___lambda85_ ((MusicPlayListCategory*) self);
}

static void
_music_play_list_category___lambda86_ (MusicPlayListCategory* self)
{
	g_signal_emit (self, music_play_list_category_signals[MUSIC_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
}

static void
__music_play_list_category___lambda86__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
	_music_play_list_category___lambda86_ ((MusicPlayListCategory*) self);
}

static GObject *
music_play_list_category_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPlayListCategory * self;
	GtkMenuItem* playlist_new = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* smart_playlist_new = NULL;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* playlist_import = NULL;
	GtkMenuItem* _tmp2_;
	GtkMenu* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenu* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
	parent_class = G_OBJECT_CLASS (music_play_list_category_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAY_LIST_CATEGORY, MusicPlayListCategory);
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
	g_object_ref_sink (_tmp0_);
	playlist_new = _tmp0_;
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
	g_object_ref_sink (_tmp1_);
	smart_playlist_new = _tmp1_;
	_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import Playlists"));
	g_object_ref_sink (_tmp2_);
	playlist_import = _tmp2_;
	_tmp3_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->playlist_menu);
	self->priv->playlist_menu = _tmp3_;
	_tmp4_ = self->priv->playlist_menu;
	_tmp5_ = playlist_new;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
	_tmp6_ = self->priv->playlist_menu;
	_tmp7_ = smart_playlist_new;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp6_, _tmp7_);
	_tmp8_ = self->priv->playlist_menu;
	_tmp9_ = playlist_import;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, _tmp9_);
	_tmp10_ = self->priv->playlist_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
	_tmp11_ = playlist_new;
	g_signal_connect_object (_tmp11_, "activate", (GCallback) __music_play_list_category___lambda84__gtk_menu_item_activate, self, 0);
	_tmp12_ = smart_playlist_new;
	g_signal_connect_object (_tmp12_, "activate", (GCallback) __music_play_list_category___lambda85__gtk_menu_item_activate, self, 0);
	_tmp13_ = playlist_import;
	g_signal_connect_object (_tmp13_, "activate", (GCallback) __music_play_list_category___lambda86__gtk_menu_item_activate, self, 0);
	_g_object_unref0 (playlist_import);
	_g_object_unref0 (smart_playlist_new);
	_g_object_unref0 (playlist_new);
	return obj;
}

static void
music_play_list_category_class_init (MusicPlayListCategoryClass * klass,
                                     gpointer klass_data)
{
	music_play_list_category_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPlayListCategory_private_offset);
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) music_play_list_category_real_get_context_menu;
	G_OBJECT_CLASS (klass)->constructor = music_play_list_category_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_play_list_category_finalize;
	music_play_list_category_signals[MUSIC_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", MUSIC_TYPE_PLAY_LIST_CATEGORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_play_list_category_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface,
                                                                              gpointer iface_data)
{
	music_play_list_category_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable*)) music_play_list_category_real_allow_dnd_sorting;
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable*, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) music_play_list_category_real_compare;
}

static void
music_play_list_category_instance_init (MusicPlayListCategory * self,
                                        gpointer klass)
{
	self->priv = music_play_list_category_get_instance_private (self);
}

static void
music_play_list_category_finalize (GObject * obj)
{
	MusicPlayListCategory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAY_LIST_CATEGORY, MusicPlayListCategory);
	_g_object_unref0 (self->priv->playlist_menu);
	G_OBJECT_CLASS (music_play_list_category_parent_class)->finalize (obj);
}

static GType
music_play_list_category_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlayListCategoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_play_list_category_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlayListCategory), 0, (GInstanceInitFunc) music_play_list_category_instance_init, NULL };
	static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) music_play_list_category_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_play_list_category_type_id;
	music_play_list_category_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "MusicPlayListCategory", &g_define_type_info, 0);
	g_type_add_interface_static (music_play_list_category_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
	MusicPlayListCategory_private_offset = g_type_add_instance_private (music_play_list_category_type_id, sizeof (MusicPlayListCategoryPrivate));
	return music_play_list_category_type_id;
}

GType
music_play_list_category_get_type (void)
{
	static volatile gsize music_play_list_category_type_id__once = 0;
	if (g_once_init_enter (&music_play_list_category_type_id__once)) {
		GType music_play_list_category_type_id;
		music_play_list_category_type_id = music_play_list_category_get_type_once ();
		g_once_init_leave (&music_play_list_category_type_id__once, music_play_list_category_type_id);
	}
	return music_play_list_category_type_id__once;
}

MusicSourceListRoot*
music_source_list_root_construct (GType object_type)
{
	MusicSourceListRoot * self = NULL;
	self = (MusicSourceListRoot*) granite_widgets_source_list_expandable_item_construct (object_type, "SourceListRoot");
	return self;
}

MusicSourceListRoot*
music_source_list_root_new (void)
{
	return music_source_list_root_construct (MUSIC_TYPE_SOURCE_LIST_ROOT);
}

static gboolean
music_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	MusicSourceListRoot * self;
	gboolean result;
	self = (MusicSourceListRoot*) base;
	result = TRUE;
	return result;
}

static gint
music_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base,
                                     GraniteWidgetsSourceListItem* a,
                                     GraniteWidgetsSourceListItem* b)
{
	MusicSourceListRoot * self;
	gint result;
	self = (MusicSourceListRoot*) base;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	result = 0;
	return result;
}

static void
music_source_list_root_class_init (MusicSourceListRootClass * klass,
                                   gpointer klass_data)
{
	music_source_list_root_parent_class = g_type_class_peek_parent (klass);
}

static void
music_source_list_root_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface,
                                                                            gpointer iface_data)
{
	music_source_list_root_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable*)) music_source_list_root_real_allow_dnd_sorting;
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable*, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) music_source_list_root_real_compare;
}

static void
music_source_list_root_instance_init (MusicSourceListRoot * self,
                                      gpointer klass)
{
}

static GType
music_source_list_root_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSourceListRoot), 0, (GInstanceInitFunc) music_source_list_root_instance_init, NULL };
	static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) music_source_list_root_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_source_list_root_type_id;
	music_source_list_root_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "MusicSourceListRoot", &g_define_type_info, 0);
	g_type_add_interface_static (music_source_list_root_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
	return music_source_list_root_type_id;
}

GType
music_source_list_root_get_type (void)
{
	static volatile gsize music_source_list_root_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_root_type_id__once)) {
		GType music_source_list_root_type_id;
		music_source_list_root_type_id = music_source_list_root_get_type_once ();
		g_once_init_leave (&music_source_list_root_type_id__once, music_source_list_root_type_id);
	}
	return music_source_list_root_type_id__once;
}

static inline gpointer
music_source_list_view_get_instance_private (MusicSourceListView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSourceListView_private_offset);
}

static void
__lambda87_ (MusicSourceListView* self)
{
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
}

static void
___lambda87__music_play_list_category_playlist_import_clicked (MusicPlayListCategory* _sender,
                                                               gpointer self)
{
	__lambda87_ ((MusicSourceListView*) self);
}

MusicSourceListView*
music_source_list_view_construct (GType object_type)
{
	MusicSourceListView * self = NULL;
	MusicSourceListRoot* _tmp0_;
	MusicSourceListRoot* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListExpandableItem* _tmp4_;
	MusicPlayListCategory* _tmp5_;
	MusicPlayListCategory* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
	GraniteWidgetsSourceListExpandableItem* _tmp10_;
	GraniteWidgetsSourceListExpandableItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	GraniteWidgetsSourceListExpandableItem* _tmp16_;
	GraniteWidgetsSourceListExpandableItem* _tmp17_;
	MusicPlayListCategory* _tmp18_;
	GraniteWidgetsSourceListExpandableItem* _tmp19_;
	GraniteWidgetsSourceListExpandableItem* _tmp20_;
	GtkTargetEntry uri_list_entry = {0};
	GtkTargetEntry _tmp21_ = {0};
	GtkTargetEntry _tmp22_;
	GtkTargetEntry* _tmp23_;
	GtkTargetEntry* _tmp24_;
	gint _tmp24__length1;
	_tmp0_ = music_source_list_root_new ();
	_tmp1_ = _tmp0_;
	self = (MusicSourceListView*) granite_widgets_source_list_construct (object_type, (GraniteWidgetsSourceListExpandableItem*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = granite_widgets_source_list_expandable_item_new (_ ("Library"));
	_g_object_unref0 (self->priv->library_category);
	self->priv->library_category = _tmp2_;
	_tmp3_ = granite_widgets_source_list_expandable_item_new (_ ("Devices"));
	_g_object_unref0 (self->priv->devices_category);
	self->priv->devices_category = _tmp3_;
	_tmp4_ = granite_widgets_source_list_expandable_item_new (_ ("Network"));
	_g_object_unref0 (self->priv->network_category);
	self->priv->network_category = _tmp4_;
	_tmp5_ = music_play_list_category_new (_ ("Playlists"));
	_g_object_unref0 (self->priv->playlists_category);
	self->priv->playlists_category = _tmp5_;
	_tmp6_ = self->priv->playlists_category;
	g_signal_connect_object (_tmp6_, "playlist-import-clicked", (GCallback) ___lambda87__music_play_list_category_playlist_import_clicked, self, 0);
	_tmp7_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->priv->library_category;
	granite_widgets_source_list_expandable_item_add (_tmp8_, (GraniteWidgetsSourceListItem*) _tmp9_);
	_tmp10_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp11_ = _tmp10_;
	_tmp12_ = self->priv->devices_category;
	granite_widgets_source_list_expandable_item_add (_tmp11_, (GraniteWidgetsSourceListItem*) _tmp12_);
	_tmp13_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp14_ = _tmp13_;
	_tmp15_ = self->priv->network_category;
	granite_widgets_source_list_expandable_item_add (_tmp14_, (GraniteWidgetsSourceListItem*) _tmp15_);
	_tmp16_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp17_ = _tmp16_;
	_tmp18_ = self->priv->playlists_category;
	granite_widgets_source_list_expandable_item_add (_tmp17_, (GraniteWidgetsSourceListItem*) _tmp18_);
	_tmp19_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
	_tmp20_ = _tmp19_;
	granite_widgets_source_list_expandable_item_expand_all (_tmp20_, FALSE, FALSE);
	_tmp21_.target = "text/uri-list";
	_tmp21_.flags = (guint) GTK_TARGET_SAME_APP;
	_tmp21_.info = (guint) 0;
	uri_list_entry = _tmp21_;
	_tmp22_ = uri_list_entry;
	_tmp23_ = g_new0 (GtkTargetEntry, 1);
	_tmp23_[0] = _tmp22_;
	_tmp24_ = _tmp23_;
	_tmp24__length1 = 1;
	granite_widgets_source_list_enable_drag_dest ((GraniteWidgetsSourceList*) self, _tmp24_, (gint) 1, GDK_ACTION_COPY);
	_tmp24_ = (g_free (_tmp24_), NULL);
	return self;
}

MusicSourceListView*
music_source_list_view_new (void)
{
	return music_source_list_view_construct (MUSIC_TYPE_SOURCE_LIST_VIEW);
}

/**
     * Change the visibility of each category
     */
void
music_source_list_view_change_playlist_category_visibility (MusicSourceListView* self,
                                                            gboolean visible)
{
	MusicPlayListCategory* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->playlists_category;
	granite_widgets_source_list_item_set_visible ((GraniteWidgetsSourceListItem*) _tmp0_, visible);
}

/**
     * Adds an item to the sidebar for the ViewWrapper object.
     * It chooses the appropiate category based on the object's hint property.
     *
     * TODO: Change ViewWrapper.Hint to core values.
     */
static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
	g_atomic_int_inc (&_data33_->_ref_count_);
	return _data33_;
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
		MusicSourceListView* self;
		self = _data33_->self;
		_g_object_unref0 (_data33_->expandable_item);
		_g_object_unref0 (_data33_->sourcelist_item);
		_g_object_unref0 (self);
		g_slice_free (Block33Data, _data33_);
	}
}

static void
__lambda93_ (MusicSourceListView* self)
{
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL], 0);
}

static void
___lambda93__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender,
                                                         gpointer self)
{
	__lambda93_ ((MusicSourceListView*) self);
}

static void
__lambda94_ (Block33Data* _data33_,
             const gchar* new_name)
{
	MusicSourceListView* self;
	MusicSourceListItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	self = _data33_->self;
	g_return_if_fail (new_name != NULL);
	_tmp0_ = _data33_->sourcelist_item;
	_tmp1_ = music_source_list_item_get_view (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_EDITED_SIGNAL], 0, _tmp2_, new_name);
}

static void
___lambda94__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender,
                                                      const gchar* new_name,
                                                      gpointer self)
{
	__lambda94_ (self, new_name);
}

static void
__lambda95_ (Block33Data* _data33_,
             GraniteWidgetsSourceListItem* sl)
{
	MusicSourceListView* self;
	MusicSourceListItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	self = _data33_->self;
	g_return_if_fail (sl != NULL);
	_tmp0_ = _data33_->sourcelist_item;
	_tmp1_ = music_source_list_item_get_view (_tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL], 0, _tmp2_);
}

static void
___lambda95__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender,
                                                                gpointer self)
{
	__lambda95_ (self, _sender);
}

static void
__lambda96_ (MusicSourceListView* self,
             GtkGrid* view,
             MusicSourceListItem* item)
{
	g_return_if_fail (view != NULL);
	g_return_if_fail (item != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, view);
	granite_widgets_source_list_start_editing_item ((GraniteWidgetsSourceList*) self, (GraniteWidgetsSourceListItem*) item);
}

static void
___lambda96__music_source_list_item_playlist_rename_clicked (MusicSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             MusicSourceListItem* item,
                                                             gpointer self)
{
	__lambda96_ ((MusicSourceListView*) self, view, item);
}

static void
__lambda97_ (MusicSourceListView* self,
             GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, view);
}

static void
___lambda97__music_source_list_item_playlist_edit_clicked (MusicSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
	__lambda97_ ((MusicSourceListView*) self, view);
}

static void
__lambda98_ (MusicSourceListView* self,
             GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, view);
}

static void
___lambda98__music_source_list_item_playlist_remove_clicked (MusicSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             gpointer self)
{
	__lambda98_ ((MusicSourceListView*) self, view);
}

static void
__lambda99_ (MusicSourceListView* self,
             GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, view);
}

static void
___lambda99__music_source_list_item_playlist_save_clicked (MusicSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
	__lambda99_ ((MusicSourceListView*) self, view);
}

static void
__lambda100_ (MusicSourceListView* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, view);
}

static void
___lambda100__music_source_list_item_playlist_export_clicked (MusicSourceListItem* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
	__lambda100_ ((MusicSourceListView*) self, view);
}

static void
__lambda101_ (MusicSourceListView* self,
              GtkGrid* view,
              gchar** uris,
              gint uris_length1)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, view, uris, (gint) uris_length1);
}

static void
___lambda101__music_source_list_item_playlist_media_added (MusicSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gchar** media,
                                                           gint media_length1,
                                                           gpointer self)
{
	__lambda101_ ((MusicSourceListView*) self, view, media, media_length1);
}

static void
__lambda102_ (Block33Data* _data33_,
              GtkGrid* view)
{
	MusicSourceListView* self;
	MusicSourceListExpandableItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	self = _data33_->self;
	g_return_if_fail (view != NULL);
	_tmp0_ = _data33_->expandable_item;
	_tmp1_ = music_source_list_view_get_device_from_item (self, _tmp0_);
	_tmp2_ = _tmp1_;
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
___lambda102__music_source_list_expandable_item_device_import_clicked (MusicSourceListExpandableItem* _sender,
                                                                       GtkGrid* view,
                                                                       gpointer self)
{
	__lambda102_ (self, view);
}

static void
__lambda103_ (MusicSourceListView* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL], 0, view);
}

static void
___lambda103__music_source_list_expandable_item_device_eject_clicked (MusicSourceListExpandableItem* _sender,
                                                                      GtkGrid* view,
                                                                      gpointer self)
{
	__lambda103_ ((MusicSourceListView*) self, view);
}

static void
__lambda104_ (MusicSourceListView* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL], 0, view);
}

static void
___lambda104__music_source_list_expandable_item_device_sync_clicked (MusicSourceListExpandableItem* _sender,
                                                                     GtkGrid* view,
                                                                     gpointer self)
{
	__lambda104_ ((MusicSourceListView*) self, view);
}

static void
__lambda105_ (MusicSourceListView* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, view);
}

static void
___lambda105__music_source_list_expandable_item_device_new_playlist_clicked (MusicSourceListExpandableItem* _sender,
                                                                             GtkGrid* view,
                                                                             gpointer self)
{
	__lambda105_ ((MusicSourceListView*) self, view);
}

static void
__lambda106_ (MusicSourceListView* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, view);
}

static void
___lambda106__music_source_list_expandable_item_device_new_smartplaylist_clicked (MusicSourceListExpandableItem* _sender,
                                                                                  GtkGrid* view,
                                                                                  gpointer self)
{
	__lambda106_ ((MusicSourceListView*) self, view);
}

MusicSourceListEntry*
music_source_list_view_add_item (MusicSourceListView* self,
                                 GtkGrid* view,
                                 const gchar* name,
                                 MusicViewWrapperHint hint,
                                 GIcon* icon,
                                 GIcon* activatable_icon,
                                 MusicSourceListExpandableItem* into_expandable,
                                 GObject* give_more_information)
{
	Block33Data* _data33_;
	MusicSourceListItem* _tmp0_;
	MusicSourceListExpandableItem* _tmp1_;
	MusicSourceListItem* _tmp5_;
	MusicSourceListItem* _tmp6_;
	MusicSourceListExpandableItem* _tmp7_;
	MusicSourceListItem* _tmp8_;
	MusicSourceListItem* _tmp9_;
	MusicSourceListItem* _tmp10_;
	MusicSourceListItem* _tmp11_;
	MusicSourceListItem* _tmp12_;
	MusicSourceListItem* _tmp13_;
	MusicSourceListExpandableItem* _tmp14_;
	MusicSourceListExpandableItem* _tmp15_;
	MusicSourceListExpandableItem* _tmp16_;
	MusicSourceListExpandableItem* _tmp17_;
	MusicSourceListExpandableItem* _tmp18_;
	MusicSourceListEntry* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (view != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	_data33_ = g_slice_new0 (Block33Data);
	_data33_->_ref_count_ = 1;
	_data33_->self = g_object_ref (self);
	_tmp0_ = music_source_list_item_new (view, name, hint, icon, activatable_icon);
	_data33_->sourcelist_item = _tmp0_;
	_tmp1_ = music_source_list_expandable_item_new (view, name, hint, icon, activatable_icon, give_more_information);
	_data33_->expandable_item = _tmp1_;
	if (hint == MUSIC_VIEW_WRAPPER_HINT_DEVICE) {
		MusicSourceListExpandableItem* _tmp2_;
		MusicSourceListExpandableItem* _tmp3_;
		_tmp2_ = _data33_->expandable_item;
		granite_widgets_source_list_expandable_item_set_collapsible ((GraniteWidgetsSourceListExpandableItem*) _tmp2_, FALSE);
		_tmp3_ = _data33_->expandable_item;
		granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) _tmp3_, icon);
		if (activatable_icon != NULL) {
			MusicSourceListExpandableItem* _tmp4_;
			_tmp4_ = _data33_->expandable_item;
			granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) _tmp4_, activatable_icon);
		}
	}
	_tmp5_ = _data33_->sourcelist_item;
	g_signal_connect_object ((GraniteWidgetsSourceListItem*) _tmp5_, "activated", (GCallback) ___lambda93__granite_widgets_source_list_item_activated, self, 0);
	_tmp6_ = _data33_->sourcelist_item;
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp6_, "edited", (GCallback) ___lambda94__granite_widgets_source_list_item_edited, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
	_tmp7_ = _data33_->expandable_item;
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp7_, "action-activated", (GCallback) ___lambda95__granite_widgets_source_list_item_action_activated, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
	_tmp8_ = _data33_->sourcelist_item;
	g_signal_connect_object (_tmp8_, "playlist-rename-clicked", (GCallback) ___lambda96__music_source_list_item_playlist_rename_clicked, self, 0);
	_tmp9_ = _data33_->sourcelist_item;
	g_signal_connect_object (_tmp9_, "playlist-edit-clicked", (GCallback) ___lambda97__music_source_list_item_playlist_edit_clicked, self, 0);
	_tmp10_ = _data33_->sourcelist_item;
	g_signal_connect_object (_tmp10_, "playlist-remove-clicked", (GCallback) ___lambda98__music_source_list_item_playlist_remove_clicked, self, 0);
	_tmp11_ = _data33_->sourcelist_item;
	g_signal_connect_object (_tmp11_, "playlist-save-clicked", (GCallback) ___lambda99__music_source_list_item_playlist_save_clicked, self, 0);
	_tmp12_ = _data33_->sourcelist_item;
	g_signal_connect_object (_tmp12_, "playlist-export-clicked", (GCallback) ___lambda100__music_source_list_item_playlist_export_clicked, self, 0);
	_tmp13_ = _data33_->sourcelist_item;
	g_signal_connect_object (_tmp13_, "playlist-media-added", (GCallback) ___lambda101__music_source_list_item_playlist_media_added, self, 0);
	_tmp14_ = _data33_->expandable_item;
	g_signal_connect_data (_tmp14_, "device-import-clicked", (GCallback) ___lambda102__music_source_list_expandable_item_device_import_clicked, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
	_tmp15_ = _data33_->expandable_item;
	g_signal_connect_object (_tmp15_, "device-eject-clicked", (GCallback) ___lambda103__music_source_list_expandable_item_device_eject_clicked, self, 0);
	_tmp16_ = _data33_->expandable_item;
	g_signal_connect_object (_tmp16_, "device-sync-clicked", (GCallback) ___lambda104__music_source_list_expandable_item_device_sync_clicked, self, 0);
	_tmp17_ = _data33_->expandable_item;
	g_signal_connect_object (_tmp17_, "device-new-playlist-clicked", (GCallback) ___lambda105__music_source_list_expandable_item_device_new_playlist_clicked, self, 0);
	_tmp18_ = _data33_->expandable_item;
	g_signal_connect_object (_tmp18_, "device-new-smartplaylist-clicked", (GCallback) ___lambda106__music_source_list_expandable_item_device_new_smartplaylist_clicked, self, 0);
	switch (hint) {
		case MUSIC_VIEW_WRAPPER_HINT_MUSIC:
		{
			if (into_expandable == NULL) {
				GraniteWidgetsSourceListExpandableItem* _tmp19_;
				MusicSourceListItem* _tmp20_;
				_tmp19_ = self->priv->library_category;
				_tmp20_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add (_tmp19_, (GraniteWidgetsSourceListItem*) _tmp20_);
			} else {
				MusicSourceListItem* _tmp21_;
				_tmp21_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp21_);
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
		{
			if (into_expandable == NULL) {
				MusicSourceListItem* _tmp22_;
				MusicPlayListCategory* _tmp23_;
				MusicSourceListItem* _tmp24_;
				_tmp22_ = _data33_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp22_, TRUE);
				_tmp23_ = self->priv->playlists_category;
				_tmp24_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp23_, (GraniteWidgetsSourceListItem*) _tmp24_);
			} else {
				MusicSourceListItem* _tmp25_;
				MusicSourceListItem* _tmp26_;
				_tmp25_ = _data33_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp25_, TRUE);
				_tmp26_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp26_);
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
		{
			if (into_expandable == NULL) {
				MusicSourceListItem* _tmp27_;
				MusicPlayListCategory* _tmp28_;
				MusicSourceListItem* _tmp29_;
				_tmp27_ = _data33_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp27_, FALSE);
				_tmp28_ = self->priv->playlists_category;
				_tmp29_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp28_, (GraniteWidgetsSourceListItem*) _tmp29_);
			} else {
				MusicSourceListItem* _tmp30_;
				MusicSourceListItem* _tmp31_;
				_tmp30_ = _data33_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp30_, FALSE);
				_tmp31_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp31_);
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
		{
			if (into_expandable == NULL) {
				MusicSourceListItem* _tmp32_;
				MusicPlayListCategory* _tmp33_;
				MusicSourceListItem* _tmp34_;
				_tmp32_ = _data33_->sourcelist_item;
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp32_, TRUE);
				_tmp33_ = self->priv->playlists_category;
				_tmp34_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp33_, (GraniteWidgetsSourceListItem*) _tmp34_);
			} else {
				MusicSourceListItem* _tmp35_;
				_tmp35_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp35_);
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE:
		{
			if (into_expandable == NULL) {
				GraniteWidgetsSourceListExpandableItem* _tmp36_;
				MusicSourceListExpandableItem* _tmp37_;
				_tmp36_ = self->priv->devices_category;
				_tmp37_ = _data33_->expandable_item;
				granite_widgets_source_list_expandable_item_add (_tmp36_, (GraniteWidgetsSourceListItem*) _tmp37_);
			} else {
				MusicSourceListExpandableItem* _tmp38_;
				_tmp38_ = _data33_->expandable_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp38_);
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
		{
			if (into_expandable == NULL) {
				GraniteWidgetsSourceListExpandableItem* _tmp39_;
				MusicSourceListExpandableItem* _tmp40_;
				_tmp39_ = self->priv->devices_category;
				_tmp40_ = _data33_->expandable_item;
				granite_widgets_source_list_expandable_item_add (_tmp39_, (GraniteWidgetsSourceListItem*) _tmp40_);
			} else {
				MusicSourceListExpandableItem* _tmp41_;
				_tmp41_ = _data33_->expandable_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp41_);
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE:
		{
			if (into_expandable == NULL) {
				GraniteWidgetsSourceListExpandableItem* _tmp42_;
				MusicSourceListItem* _tmp43_;
				_tmp42_ = self->priv->network_category;
				_tmp43_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add (_tmp42_, (GraniteWidgetsSourceListItem*) _tmp43_);
			} else {
				MusicSourceListItem* _tmp44_;
				_tmp44_ = _data33_->sourcelist_item;
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp44_);
			}
			break;
		}
		default:
		{
			break;
		}
	}
	if (hint == MUSIC_VIEW_WRAPPER_HINT_DEVICE) {
		MusicSourceListExpandableItem* _tmp45_;
		MusicSourceListEntry* _tmp46_;
		_tmp45_ = _data33_->expandable_item;
		_tmp46_ = _g_object_ref0 ((MusicSourceListEntry*) _tmp45_);
		result = _tmp46_;
		block33_data_unref (_data33_);
		_data33_ = NULL;
		return result;
	} else {
		MusicSourceListItem* _tmp47_;
		MusicSourceListEntry* _tmp48_;
		_tmp47_ = _data33_->sourcelist_item;
		_tmp48_ = _g_object_ref0 ((MusicSourceListEntry*) _tmp47_);
		result = _tmp48_;
		block33_data_unref (_data33_);
		_data33_ = NULL;
		return result;
	}
}

static void
music_source_list_view_real_item_selected (GraniteWidgetsSourceList* base,
                                           GraniteWidgetsSourceListItem* item)
{
	MusicSourceListView * self;
	self = (MusicSourceListView*) base;
	if (MUSIC_IS_SOURCE_LIST_ITEM (item)) {
		MusicSourceListItem* sidebar_item = NULL;
		MusicSourceListItem* _tmp0_;
		MusicSourceListItem* _tmp1_;
		GtkGrid* _tmp2_;
		GtkGrid* _tmp3_;
		_tmp0_ = _g_object_ref0 (MUSIC_IS_SOURCE_LIST_ITEM (item) ? ((MusicSourceListItem*) item) : NULL);
		sidebar_item = _tmp0_;
		_tmp1_ = sidebar_item;
		_tmp2_ = music_source_list_item_get_view (_tmp1_);
		_tmp3_ = _tmp2_;
		g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp3_);
		_g_object_unref0 (sidebar_item);
	} else {
		if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (item)) {
			MusicSourceListExpandableItem* sidebar_item = NULL;
			MusicSourceListExpandableItem* _tmp4_;
			MusicSourceListExpandableItem* _tmp5_;
			GtkGrid* _tmp6_;
			GtkGrid* _tmp7_;
			_tmp4_ = _g_object_ref0 (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (item) ? ((MusicSourceListExpandableItem*) item) : NULL);
			sidebar_item = _tmp4_;
			_tmp5_ = sidebar_item;
			_tmp6_ = music_source_list_expandable_item_get_view (_tmp5_);
			_tmp7_ = _tmp6_;
			g_signal_emit (self, music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp7_);
			_g_object_unref0 (sidebar_item);
		}
	}
}

void
music_source_list_view_remove_playlist (MusicSourceListView* self,
                                        MusicViewWrapper* view)
{
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	{
		GeeIterator* _playlist_it = NULL;
		MusicPlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->playlists_category;
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_playlist_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
			_tmp6_ = _playlist_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _playlist_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			playlist = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = playlist;
			if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp9_)) {
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
				_tmp10_ = playlist;
				_tmp11_ = music_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
				_tmp12_ = _tmp11_;
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
					MusicPlayListCategory* _tmp13_;
					GraniteWidgetsSourceListItem* _tmp14_;
					_tmp13_ = self->priv->playlists_category;
					_tmp14_ = playlist;
					granite_widgets_source_list_expandable_item_remove ((GraniteWidgetsSourceListExpandableItem*) _tmp13_, _tmp14_);
					_g_object_unref0 (playlist);
					_g_object_unref0 (_playlist_it);
					return;
				}
			}
			_g_object_unref0 (playlist);
		}
		_g_object_unref0 (_playlist_it);
	}
	_tmp15_ = gee_tree_set_new (MUSIC_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	items = _tmp15_;
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
		GeeIterator* _tmp21_;
		_tmp16_ = self->priv->devices_category;
		_tmp17_ = granite_widgets_source_list_expandable_item_get_children (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = _tmp18_;
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
		_tmp21_ = _tmp20_;
		_g_object_unref0 (_tmp19_);
		_device_it = _tmp21_;
		while (TRUE) {
			GeeIterator* _tmp22_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp23_;
			gpointer _tmp24_;
			GraniteWidgetsSourceListItem* _tmp25_;
			_tmp22_ = _device_it;
			if (!gee_iterator_next (_tmp22_)) {
				break;
			}
			_tmp23_ = _device_it;
			_tmp24_ = gee_iterator_get (_tmp23_);
			device = (GraniteWidgetsSourceListItem*) _tmp24_;
			_tmp25_ = device;
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp25_)) {
				GraniteWidgetsSourceListItem* _tmp26_;
				_tmp26_ = device;
				music_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), &items);
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp27_;
					GeeIterator* _tmp28_;
					_tmp27_ = items;
					_tmp28_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp27_);
					_item_it = _tmp28_;
					while (TRUE) {
						GeeIterator* _tmp29_;
						MusicSourceListItem* item = NULL;
						GeeIterator* _tmp30_;
						gpointer _tmp31_;
						MusicSourceListItem* _tmp32_;
						GtkGrid* _tmp33_;
						GtkGrid* _tmp34_;
						_tmp29_ = _item_it;
						if (!gee_iterator_next (_tmp29_)) {
							break;
						}
						_tmp30_ = _item_it;
						_tmp31_ = gee_iterator_get (_tmp30_);
						item = (MusicSourceListItem*) _tmp31_;
						_tmp32_ = item;
						_tmp33_ = music_source_list_item_get_view (_tmp32_);
						_tmp34_ = _tmp33_;
						if (_tmp34_ == G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid)) {
							MusicSourceListItem* _tmp35_;
							GraniteWidgetsSourceListExpandableItem* _tmp36_;
							GraniteWidgetsSourceListExpandableItem* _tmp37_;
							MusicSourceListItem* _tmp38_;
							_tmp35_ = item;
							_tmp36_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) _tmp35_);
							_tmp37_ = _tmp36_;
							_tmp38_ = item;
							granite_widgets_source_list_expandable_item_remove (_tmp37_, (GraniteWidgetsSourceListItem*) _tmp38_);
							_g_object_unref0 (item);
							_g_object_unref0 (_item_it);
							_g_object_unref0 (device);
							_g_object_unref0 (_device_it);
							_g_object_unref0 (items);
							return;
						}
						_g_object_unref0 (item);
					}
					_g_object_unref0 (_item_it);
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
	_g_object_unref0 (items);
}

GeeCollection*
music_source_list_view_remove_device (MusicSourceListView* self,
                                      MusicDeviceView* view)
{
	GeeTreeSet* pages = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (view != NULL, NULL);
	_tmp0_ = gee_tree_set_new (gtk_grid_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	pages = _tmp0_;
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
		_tmp1_ = self->priv->devices_category;
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp4_);
		_device_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
			_tmp7_ = _device_it;
			if (!gee_iterator_next (_tmp7_)) {
				break;
			}
			_tmp8_ = _device_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			device = (GraniteWidgetsSourceListItem*) _tmp9_;
			_tmp10_ = device;
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp10_)) {
				GraniteWidgetsSourceListItem* _tmp11_;
				GtkGrid* _tmp12_;
				GtkGrid* _tmp13_;
				_tmp11_ = device;
				_tmp12_ = music_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
				_tmp13_ = _tmp12_;
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp13_) {
					GraniteWidgetsSourceListItem* _tmp14_;
					GraniteWidgetsSourceListExpandableItem* _tmp15_;
					GraniteWidgetsSourceListItem* _tmp16_;
					_tmp14_ = device;
					music_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), &pages);
					_tmp15_ = self->priv->devices_category;
					_tmp16_ = device;
					granite_widgets_source_list_expandable_item_remove (_tmp15_, _tmp16_);
					result = (GeeCollection*) pages;
					_g_object_unref0 (device);
					_g_object_unref0 (_device_it);
					return result;
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
	result = (GeeCollection*) pages;
	return result;
}

static GtkGrid*
music_source_list_view_get_device_from_item (MusicSourceListView* self,
                                             MusicSourceListExpandableItem* item)
{
	GtkGrid* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->devices_category;
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_device_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListExpandableItem* _tmp9_;
			GraniteWidgetsSourceListExpandableItem* _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
			_tmp6_ = _device_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _device_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			device = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) item);
			_tmp10_ = _tmp9_;
			_tmp11_ = device;
			if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem)) {
				GraniteWidgetsSourceListItem* _tmp12_;
				_tmp12_ = device;
				if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp12_)) {
					GraniteWidgetsSourceListItem* _tmp13_;
					GtkGrid* _tmp14_;
					GtkGrid* _tmp15_;
					GtkGrid* _tmp16_;
					_tmp13_ = device;
					_tmp14_ = music_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
					_tmp15_ = _tmp14_;
					_tmp16_ = _g_object_ref0 (_tmp15_);
					result = _tmp16_;
					_g_object_unref0 (device);
					_g_object_unref0 (_device_it);
					return result;
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
	result = NULL;
	return result;
}

static void
music_source_list_view_enumerate_children_pages (MusicSourceListView* self,
                                                 MusicSourceListExpandableItem* exp_item,
                                                 GeeTreeSet** pages)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (exp_item != NULL);
	g_return_if_fail (*pages != NULL);
	{
		GeeIterator* _views_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (exp_item, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
		_tmp1_ = _tmp0_;
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_views_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
			_tmp5_ = _views_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _views_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			views = (GraniteWidgetsSourceListItem*) _tmp7_;
			_tmp8_ = views;
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp8_)) {
				GraniteWidgetsSourceListItem* _tmp9_;
				GtkGrid* _tmp10_;
				GtkGrid* _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
				_tmp9_ = views;
				_tmp10_ = music_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
				_tmp11_ = _tmp10_;
				gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), _tmp11_);
				_tmp12_ = views;
				music_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), pages);
			} else {
				GraniteWidgetsSourceListItem* _tmp13_;
				_tmp13_ = views;
				if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp13_)) {
					GraniteWidgetsSourceListItem* _tmp14_;
					GtkGrid* _tmp15_;
					GtkGrid* _tmp16_;
					_tmp14_ = views;
					_tmp15_ = music_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
					_tmp16_ = _tmp15_;
					gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), _tmp16_);
				}
			}
			_g_object_unref0 (views);
		}
		_g_object_unref0 (_views_it);
	}
}

static void
music_source_list_view_enumerate_children_items (MusicSourceListView* self,
                                                 MusicSourceListExpandableItem* exp_item,
                                                 GeeTreeSet** pages)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (exp_item != NULL);
	g_return_if_fail (*pages != NULL);
	{
		GeeIterator* _views_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (exp_item, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
		_tmp1_ = _tmp0_;
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_views_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
			_tmp5_ = _views_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _views_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			views = (GraniteWidgetsSourceListItem*) _tmp7_;
			_tmp8_ = views;
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp8_)) {
				GraniteWidgetsSourceListItem* _tmp9_;
				_tmp9_ = views;
				music_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), pages);
			} else {
				GraniteWidgetsSourceListItem* _tmp10_;
				_tmp10_ = views;
				if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp10_)) {
					GraniteWidgetsSourceListItem* _tmp11_;
					_tmp11_ = views;
					gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
				}
			}
			_g_object_unref0 (views);
		}
		_g_object_unref0 (_views_it);
	}
}

void
music_source_list_view_change_playlist_name (MusicSourceListView* self,
                                             MusicViewWrapper* view,
                                             const gchar* new_name)
{
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	g_return_if_fail (new_name != NULL);
	{
		GeeIterator* _playlist_it = NULL;
		MusicPlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->playlists_category;
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_playlist_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
			_tmp6_ = _playlist_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _playlist_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			playlist = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = playlist;
			if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp9_)) {
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
				_tmp10_ = playlist;
				_tmp11_ = music_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
				_tmp12_ = _tmp11_;
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
					GraniteWidgetsSourceListItem* _tmp13_;
					_tmp13_ = playlist;
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem), new_name);
					_g_object_unref0 (playlist);
					_g_object_unref0 (_playlist_it);
					return;
				}
			}
			_g_object_unref0 (playlist);
		}
		_g_object_unref0 (_playlist_it);
	}
	_tmp14_ = gee_tree_set_new (MUSIC_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	items = _tmp14_;
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
		_tmp15_ = self->priv->devices_category;
		_tmp16_ = granite_widgets_source_list_expandable_item_get_children (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = _tmp17_;
		_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
		_tmp20_ = _tmp19_;
		_g_object_unref0 (_tmp18_);
		_device_it = _tmp20_;
		while (TRUE) {
			GeeIterator* _tmp21_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			GraniteWidgetsSourceListItem* _tmp24_;
			_tmp21_ = _device_it;
			if (!gee_iterator_next (_tmp21_)) {
				break;
			}
			_tmp22_ = _device_it;
			_tmp23_ = gee_iterator_get (_tmp22_);
			device = (GraniteWidgetsSourceListItem*) _tmp23_;
			_tmp24_ = device;
			if (MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp24_)) {
				GraniteWidgetsSourceListItem* _tmp25_;
				_tmp25_ = device;
				music_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), &items);
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp26_;
					GeeIterator* _tmp27_;
					_tmp26_ = items;
					_tmp27_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp26_);
					_item_it = _tmp27_;
					while (TRUE) {
						GeeIterator* _tmp28_;
						MusicSourceListItem* item = NULL;
						GeeIterator* _tmp29_;
						gpointer _tmp30_;
						MusicSourceListItem* _tmp31_;
						GtkGrid* _tmp32_;
						GtkGrid* _tmp33_;
						_tmp28_ = _item_it;
						if (!gee_iterator_next (_tmp28_)) {
							break;
						}
						_tmp29_ = _item_it;
						_tmp30_ = gee_iterator_get (_tmp29_);
						item = (MusicSourceListItem*) _tmp30_;
						_tmp31_ = item;
						_tmp32_ = music_source_list_item_get_view (_tmp31_);
						_tmp33_ = _tmp32_;
						if (_tmp33_ == G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid)) {
							MusicSourceListItem* _tmp34_;
							_tmp34_ = item;
							granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem), new_name);
							_g_object_unref0 (item);
							_g_object_unref0 (_item_it);
							_g_object_unref0 (device);
							_g_object_unref0 (_device_it);
							_g_object_unref0 (items);
							return;
						}
						_g_object_unref0 (item);
					}
					_g_object_unref0 (_item_it);
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
	_g_object_unref0 (items);
}

void
music_source_list_view_change_device_name (MusicSourceListView* self,
                                           MusicDeviceView* view,
                                           const gchar* new_name)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	g_return_if_fail (new_name != NULL);
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->devices_category;
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_device_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
			_tmp6_ = _device_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _device_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			device = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = device;
			if (MUSIC_IS_SOURCE_LIST_ITEM (_tmp9_)) {
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
				_tmp10_ = device;
				_tmp11_ = music_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem));
				_tmp12_ = _tmp11_;
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
					GraniteWidgetsSourceListItem* _tmp13_;
					_tmp13_ = device;
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, MUSIC_TYPE_SOURCE_LIST_ITEM, MusicSourceListItem), new_name);
					_g_object_unref0 (device);
					_g_object_unref0 (_device_it);
					return;
				}
			}
			_g_object_unref0 (device);
		}
		_g_object_unref0 (_device_it);
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
music_source_list_view_class_init (MusicSourceListViewClass * klass,
                                   gpointer klass_data)
{
	music_source_list_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicSourceListView_private_offset);
	((GraniteWidgetsSourceListClass *) klass)->item_selected = (void (*) (GraniteWidgetsSourceList*, GraniteWidgetsSourceListItem*)) music_source_list_view_real_item_selected;
	G_OBJECT_CLASS (klass)->finalize = music_source_list_view_finalize;
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_EDITED_SIGNAL] = g_signal_new ("edited", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, gtk_grid_get_type (), G_TYPE_STRING);
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL] = g_signal_new ("item-action-activated", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL] = g_signal_new ("activated", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT, G_TYPE_NONE, 3, gtk_grid_get_type (), G_TYPE_STRV, G_TYPE_INT);
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
	music_source_list_view_signals[MUSIC_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", MUSIC_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
}

static void
music_source_list_view_instance_init (MusicSourceListView * self,
                                      gpointer klass)
{
	self->priv = music_source_list_view_get_instance_private (self);
}

static void
music_source_list_view_finalize (GObject * obj)
{
	MusicSourceListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SOURCE_LIST_VIEW, MusicSourceListView);
	_g_object_unref0 (self->priv->library_category);
	_g_object_unref0 (self->priv->devices_category);
	_g_object_unref0 (self->priv->network_category);
	_g_object_unref0 (self->priv->playlists_category);
	G_OBJECT_CLASS (music_source_list_view_parent_class)->finalize (obj);
}

static GType
music_source_list_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSourceListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_source_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSourceListView), 0, (GInstanceInitFunc) music_source_list_view_instance_init, NULL };
	GType music_source_list_view_type_id;
	music_source_list_view_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_SOURCE_LIST, "MusicSourceListView", &g_define_type_info, 0);
	MusicSourceListView_private_offset = g_type_add_instance_private (music_source_list_view_type_id, sizeof (MusicSourceListViewPrivate));
	return music_source_list_view_type_id;
}

GType
music_source_list_view_get_type (void)
{
	static volatile gsize music_source_list_view_type_id__once = 0;
	if (g_once_init_enter (&music_source_list_view_type_id__once)) {
		GType music_source_list_view_type_id;
		music_source_list_view_type_id = music_source_list_view_get_type_once ();
		g_once_init_leave (&music_source_list_view_type_id__once, music_source_list_view_type_id);
	}
	return music_source_list_view_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

