/* ViewSelector.c generated by valac 0.55.1, the Vala compiler
 * generated from ViewSelector.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include "music-lib.h"
#include <granite.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_WIDGETS_VIEW_SELECTOR_0_PROPERTY,
	MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY,
	MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY,
	MUSIC_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL,
	MUSIC_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL,
	MUSIC_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS
};
static guint music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS] = {0};

struct _MusicWidgetsViewSelectorPrivate {
	GraniteWidgetsModeButton* mode_button;
	MusicWidgetsViewSelectorMode mode;
};

static gint MusicWidgetsViewSelector_private_offset;
static gpointer music_widgets_view_selector_parent_class = NULL;

static void __lambda58_ (MusicWidgetsViewSelector* self);
static void ___lambda58__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                            GtkWidget* widget,
                                                            gpointer self);
static void music_widgets_view_selector_finalize (GObject * obj);
static GType music_widgets_view_selector_get_type_once (void);
static void _vala_music_widgets_view_selector_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_music_widgets_view_selector_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_widgets_view_selector_get_instance_private (MusicWidgetsViewSelector* self)
{
	return G_STRUCT_MEMBER_P (self, MusicWidgetsViewSelector_private_offset);
}

static GType
music_widgets_view_selector_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID, "MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID", "grid"}, {MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST, "MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST", "list"}, {MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN, "MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN", "column"}, {0, NULL, NULL}};
	GType music_widgets_view_selector_mode_type_id;
	music_widgets_view_selector_mode_type_id = g_enum_register_static ("MusicWidgetsViewSelectorMode", values);
	return music_widgets_view_selector_mode_type_id;
}

GType
music_widgets_view_selector_mode_get_type (void)
{
	static volatile gsize music_widgets_view_selector_mode_type_id__once = 0;
	if (g_once_init_enter (&music_widgets_view_selector_mode_type_id__once)) {
		GType music_widgets_view_selector_mode_type_id;
		music_widgets_view_selector_mode_type_id = music_widgets_view_selector_mode_get_type_once ();
		g_once_init_leave (&music_widgets_view_selector_mode_type_id__once, music_widgets_view_selector_mode_type_id);
	}
	return music_widgets_view_selector_mode_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda58_ (MusicWidgetsViewSelector* self)
{
	gint new_mode = 0;
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	_tmp0_ = self->priv->mode_button;
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
	_tmp2_ = _tmp1_;
	new_mode = _tmp2_;
	if (new_mode <= 2) {
		music_widgets_view_selector_set_selected (self, (MusicWidgetsViewSelectorMode) new_mode);
	} else {
		GraniteWidgetsModeButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->mode_button;
		_tmp4_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			music_widgets_view_selector_set_selected (self, self->priv->mode);
		}
	}
}

static void
___lambda58__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                       GtkWidget* widget,
                                                       gpointer self)
{
	__lambda58_ ((MusicWidgetsViewSelector*) self);
}

MusicWidgetsViewSelector*
music_widgets_view_selector_construct (GType object_type)
{
	MusicWidgetsViewSelector * self = NULL;
	GtkApplication* application_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkImage* image = NULL;
	GtkImage* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkImage* list = NULL;
	GtkImage* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkImage* column = NULL;
	GtkImage* _tmp14_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GraniteWidgetsModeButton* _tmp20_;
	GraniteWidgetsModeButton* _tmp21_;
	GraniteWidgetsModeButton* _tmp22_;
	GraniteWidgetsModeButton* _tmp23_;
	GraniteWidgetsModeButton* _tmp24_;
	GraniteWidgetsModeButton* _tmp25_;
	self = (MusicWidgetsViewSelector*) g_object_new (object_type, NULL);
	_tmp0_ = g_application_get_default ();
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
	application_instance = _tmp1_;
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("view-grid-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp2_);
	image = _tmp2_;
	_tmp4_ = _tmp3_ = gtk_application_get_accels_for_action (application_instance, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _vala_array_length (_tmp3_);
	_tmp6_ = granite_markup_accel_tooltip (_tmp5_, (gint) _vala_array_length (_tmp3_), _ ("View as albums"));
	_tmp7_ = _tmp6_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) image, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("view-list-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp8_);
	list = _tmp8_;
	_tmp10_ = _tmp9_ = gtk_application_get_accels_for_action (application_instance, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST);
	_tmp11_ = _tmp10_;
	_tmp11__length1 = _vala_array_length (_tmp9_);
	_tmp12_ = granite_markup_accel_tooltip (_tmp11_, (gint) _vala_array_length (_tmp9_), _ ("View as list"));
	_tmp13_ = _tmp12_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) list, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
	_tmp14_ = (GtkImage*) gtk_image_new_from_icon_name ("view-column-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp14_);
	column = _tmp14_;
	_tmp16_ = _tmp15_ = gtk_application_get_accels_for_action (application_instance, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS);
	_tmp17_ = _tmp16_;
	_tmp17__length1 = _vala_array_length (_tmp15_);
	_tmp18_ = granite_markup_accel_tooltip (_tmp17_, (gint) _vala_array_length (_tmp15_), _ ("View in columns"));
	_tmp19_ = _tmp18_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) column, _tmp19_);
	_g_free0 (_tmp19_);
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
	_tmp20_ = granite_widgets_mode_button_new ();
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->mode_button);
	self->priv->mode_button = _tmp20_;
	_tmp21_ = self->priv->mode_button;
	granite_widgets_mode_button_append (_tmp21_, (GtkWidget*) image);
	_tmp22_ = self->priv->mode_button;
	granite_widgets_mode_button_append (_tmp22_, (GtkWidget*) list);
	_tmp23_ = self->priv->mode_button;
	granite_widgets_mode_button_append (_tmp23_, (GtkWidget*) column);
	_tmp24_ = self->priv->mode_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
	_tmp25_ = self->priv->mode_button;
	g_signal_connect_object (_tmp25_, "mode-changed", (GCallback) ___lambda58__granite_widgets_mode_button_mode_changed, self, 0);
	_g_object_unref0 (column);
	_g_object_unref0 (list);
	_g_object_unref0 (image);
	_g_object_unref0 (application_instance);
	return self;
}

MusicWidgetsViewSelector*
music_widgets_view_selector_new (void)
{
	return music_widgets_view_selector_construct (MUSIC_WIDGETS_TYPE_VIEW_SELECTOR);
}

gboolean
music_widgets_view_selector_get_column_browser_toggle_active (MusicWidgetsViewSelector* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->mode == MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
	return result;
}

void
music_widgets_view_selector_set_column_browser_toggle_active (MusicWidgetsViewSelector* self,
                                                              gboolean active)
{
	g_return_if_fail (self != NULL);
	if (active) {
		music_widgets_view_selector_set_selected (self, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN);
	} else {
		if (music_widgets_view_selector_get_column_browser_toggle_active (self)) {
			music_widgets_view_selector_set_selected (self, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST);
		}
	}
}

MusicWidgetsViewSelectorMode
music_widgets_view_selector_get_selected (MusicWidgetsViewSelector* self)
{
	MusicWidgetsViewSelectorMode result;
	MusicWidgetsViewSelectorMode _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (self->priv->mode != MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN) {
		_tmp0_ = self->priv->mode;
	} else {
		_tmp0_ = MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST;
	}
	result = _tmp0_;
	return result;
}

void
music_widgets_view_selector_set_selected (MusicWidgetsViewSelector* self,
                                          MusicWidgetsViewSelectorMode value)
{
	GraniteWidgetsModeButton* _tmp0_;
	gboolean is_column_mode = FALSE;
	MusicWidgetsViewSelectorMode _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	if (self->priv->mode == value) {
		return;
	}
	self->priv->mode = value;
	_tmp0_ = self->priv->mode_button;
	granite_widgets_mode_button_set_selected (_tmp0_, (gint) value);
	is_column_mode = value == MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
	g_signal_emit (self, music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL], 0, is_column_mode);
	if (is_column_mode) {
		_tmp1_ = MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST;
	} else {
		_tmp1_ = value;
	}
	g_signal_emit (self, music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL], 0, _tmp1_);
	g_object_notify_by_pspec ((GObject *) self, music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY]);
}

gboolean
music_widgets_view_selector_get_sensitive (MusicWidgetsViewSelector* self)
{
	gboolean result;
	GraniteWidgetsModeButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->mode_button;
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
music_widgets_view_selector_set_sensitive (MusicWidgetsViewSelector* self,
                                           gboolean value)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_ = 0;
	GraniteWidgetsModeButton* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	MusicLibraryWindow* _tmp4_;
	GAction* _tmp5_;
	MusicLibraryWindow* _tmp6_;
	MusicLibraryWindow* _tmp7_;
	GAction* _tmp8_;
	MusicLibraryWindow* _tmp9_;
	MusicLibraryWindow* _tmp10_;
	GAction* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mode_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, value);
	if (value) {
		_tmp1_ = (gint) self->priv->mode;
	} else {
		_tmp1_ = -1;
	}
	_tmp2_ = self->priv->mode_button;
	granite_widgets_mode_button_set_active (_tmp2_, _tmp1_);
	_tmp3_ = music_app_get_main_window ();
	_tmp4_ = _tmp3_;
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), value);
	_tmp6_ = music_app_get_main_window ();
	_tmp7_ = _tmp6_;
	_tmp8_ = g_action_map_lookup_action ((GActionMap*) _tmp7_, MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_simple_action_get_type (), GSimpleAction), value);
	_tmp9_ = music_app_get_main_window ();
	_tmp10_ = _tmp9_;
	_tmp11_ = g_action_map_lookup_action ((GActionMap*) _tmp10_, MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_simple_action_get_type (), GSimpleAction), value);
	g_object_notify_by_pspec ((GObject *) self, music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY]);
}

static void
music_widgets_view_selector_class_init (MusicWidgetsViewSelectorClass * klass,
                                        gpointer klass_data)
{
	music_widgets_view_selector_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicWidgetsViewSelector_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_widgets_view_selector_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_widgets_view_selector_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_widgets_view_selector_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY, music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY] = g_param_spec_enum ("selected", "selected", "selected", MUSIC_WIDGETS_VIEW_SELECTOR_TYPE_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY, music_widgets_view_selector_properties[MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY] = g_param_spec_boolean ("sensitive", "sensitive", "sensitive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL] = g_signal_new ("mode-changed", MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, MUSIC_WIDGETS_VIEW_SELECTOR_TYPE_MODE);
	music_widgets_view_selector_signals[MUSIC_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL] = g_signal_new ("column-browser-toggled", MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
music_widgets_view_selector_instance_init (MusicWidgetsViewSelector * self,
                                           gpointer klass)
{
	self->priv = music_widgets_view_selector_get_instance_private (self);
}

static void
music_widgets_view_selector_finalize (GObject * obj)
{
	MusicWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector);
	_g_object_unref0 (self->priv->mode_button);
	G_OBJECT_CLASS (music_widgets_view_selector_parent_class)->finalize (obj);
}

static GType
music_widgets_view_selector_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicWidgetsViewSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_widgets_view_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicWidgetsViewSelector), 0, (GInstanceInitFunc) music_widgets_view_selector_instance_init, NULL };
	GType music_widgets_view_selector_type_id;
	music_widgets_view_selector_type_id = g_type_register_static (gtk_tool_item_get_type (), "MusicWidgetsViewSelector", &g_define_type_info, 0);
	MusicWidgetsViewSelector_private_offset = g_type_add_instance_private (music_widgets_view_selector_type_id, sizeof (MusicWidgetsViewSelectorPrivate));
	return music_widgets_view_selector_type_id;
}

GType
music_widgets_view_selector_get_type (void)
{
	static volatile gsize music_widgets_view_selector_type_id__once = 0;
	if (g_once_init_enter (&music_widgets_view_selector_type_id__once)) {
		GType music_widgets_view_selector_type_id;
		music_widgets_view_selector_type_id = music_widgets_view_selector_get_type_once ();
		g_once_init_leave (&music_widgets_view_selector_type_id__once, music_widgets_view_selector_type_id);
	}
	return music_widgets_view_selector_type_id__once;
}

static void
_vala_music_widgets_view_selector_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	MusicWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector);
	switch (property_id) {
		case MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
		g_value_set_enum (value, music_widgets_view_selector_get_selected (self));
		break;
		case MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY:
		g_value_set_boolean (value, music_widgets_view_selector_get_sensitive (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_widgets_view_selector_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	MusicWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector);
	switch (property_id) {
		case MUSIC_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
		music_widgets_view_selector_set_selected (self, g_value_get_enum (value));
		break;
		case MUSIC_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY:
		music_widgets_view_selector_set_sensitive (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

