/* AudioPlayerLibrary.c generated by valac 0.55.1, the Vala compiler
 * generated from AudioPlayerLibrary.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "audioplayer-device.h"
#include <gee.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "music-lib.h"
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY_0_PROPERTY,
	MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* music_plugins_audio_player_library_properties[MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;

struct _MusicPluginsAudioPlayerLibraryPrivate {
	MusicPluginsAudioPlayerDevice* device;
	GeeLinkedList* medias;
	GRecMutex __lock_medias;
	GeeLinkedList* searched_medias;
	GRecMutex __lock_searched_medias;
	GeeLinkedList* playlists;
	gboolean operation_cancelled;
	gboolean is_doing_file_operations;
	gboolean queue_is_finished;
	GeeLinkedList* imported_files;
	gboolean is_initialized;
};

struct _Block1Data {
	int _ref_count_;
	MusicPluginsAudioPlayerLibrary* self;
	MusicStaticPlaylist* p;
};

static gint MusicPluginsAudioPlayerLibrary_private_offset;
static gpointer music_plugins_audio_player_library_parent_class = NULL;
static GType music_plugins_audio_player_library_type_id = 0;

static void music_plugins_audio_player_library_media_imported_from_tagger (MusicPluginsAudioPlayerLibrary* self,
                                                                    MusicMedia* m);
static void _music_plugins_audio_player_library_media_imported_from_tagger_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                                                           MusicMedia* m,
                                                                                                           gpointer self);
static void music_plugins_audio_player_library_import_error (MusicPluginsAudioPlayerLibrary* self,
                                                      const gchar* file);
static void _music_plugins_audio_player_library_import_error_music_gstreamer_tagger_import_error (MusicGStreamerTagger* _sender,
                                                                                           const gchar* file_uri,
                                                                                           GError* _error_,
                                                                                           gpointer self);
static void _music_plugins_audio_player_library_queue_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                                               gpointer self);
static void __lambda4_ (MusicPluginsAudioPlayerLibrary* self);
static void ___lambda4__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                               gpointer self);
static void music_plugins_audio_player_library_real_initialize_library (MusicLibrary* base);
static void music_plugins_audio_player_library_real_add_files_to_library (MusicLibrary* base,
                                                                   GeeCollection* files);
static GeeCollection* music_plugins_audio_player_library_real_get_medias (MusicLibrary* base);
static GeeCollection* music_plugins_audio_player_library_real_get_playlists (MusicLibrary* base);
static GeeCollection* music_plugins_audio_player_library_real_get_smart_playlists (MusicLibrary* base);
static void music_plugins_audio_player_library_real_search_medias (MusicLibrary* base,
                                                            const gchar* search);
static GeeCollection* music_plugins_audio_player_library_real_get_search_result (MusicLibrary* base);
static void music_plugins_audio_player_library_real_add_media (MusicLibrary* base,
                                                        MusicMedia* m);
static void music_plugins_audio_player_library_real_add_medias (MusicLibrary* base,
                                                         GeeCollection* list);
static gboolean _music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self);
static MusicMedia* music_plugins_audio_player_library_real_media_from_id (MusicLibrary* base,
                                                                   gint64 id);
static GeeCollection* music_plugins_audio_player_library_real_medias_from_ids (MusicLibrary* base,
                                                                        GeeCollection* ids);
static GeeCollection* music_plugins_audio_player_library_real_medias_from_uris (MusicLibrary* base,
                                                                         GeeCollection* uris);
static MusicMedia* music_plugins_audio_player_library_real_find_media (MusicLibrary* base,
                                                                MusicMedia* to_find);
static MusicMedia* music_plugins_audio_player_library_real_media_from_file (MusicLibrary* base,
                                                                     GFile* file);
static MusicMedia* music_plugins_audio_player_library_real_media_from_uri (MusicLibrary* base,
                                                                    const gchar* uri);
static void music_plugins_audio_player_library_real_update_media (MusicLibrary* base,
                                                           MusicMedia* s,
                                                           gboolean update_meta,
                                                           gboolean record_time);
static void music_plugins_audio_player_library_real_update_medias (MusicLibrary* base,
                                                            GeeCollection* updates,
                                                            gboolean update_meta,
                                                            gboolean record_time);
static void music_plugins_audio_player_library_real_remove_media (MusicLibrary* base,
                                                           MusicMedia* m,
                                                           gboolean trash);
static void music_plugins_audio_player_library_real_remove_medias (MusicLibrary* base,
                                                            GeeCollection* list,
                                                            gboolean trash);
static gboolean music_plugins_audio_player_library_real_support_smart_playlists (MusicLibrary* base);
static void music_plugins_audio_player_library_real_add_smart_playlist (MusicLibrary* base,
                                                                 MusicSmartPlaylist* p);
static void music_plugins_audio_player_library_real_remove_smart_playlist (MusicLibrary* base,
                                                                    gint64 id);
static MusicSmartPlaylist* music_plugins_audio_player_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                                                    gint64 id);
static MusicSmartPlaylist* music_plugins_audio_player_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                                                      const gchar* name);
static gboolean music_plugins_audio_player_library_real_support_playlists (MusicLibrary* base);
static void music_plugins_audio_player_library_real_add_playlist (MusicLibrary* base,
                                                           MusicStaticPlaylist* p);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void music_plugins_audio_player_library_keep_playlist_synchronized (MusicPluginsAudioPlayerLibrary* self,
                                                                    MusicStaticPlaylist* p);
static void __lambda5_ (Block1Data* _data1_);
static void ___lambda5__music_playlist_media_added (MusicPlaylist* _sender,
                                             GeeCollection* media,
                                             gpointer self);
static void __lambda6_ (Block1Data* _data1_);
static void ___lambda6__music_playlist_media_removed (MusicPlaylist* _sender,
                                               GeeCollection* media,
                                               gpointer self);
static void __lambda7_ (Block1Data* _data1_,
                 const gchar* old_name);
static void music_plugins_audio_player_library_remove_playlist_from_name (MusicPluginsAudioPlayerLibrary* self,
                                                                   const gchar* name);
static void ___lambda7__music_playlist_updated (MusicPlaylist* _sender,
                                         const gchar* old_name,
                                         gpointer self);
static void music_plugins_audio_player_library_real_remove_playlist (MusicLibrary* base,
                                                              gint64 id);
static MusicStaticPlaylist* music_plugins_audio_player_library_real_playlist_from_id (MusicLibrary* base,
                                                                               gint64 id);
static MusicStaticPlaylist* music_plugins_audio_player_library_real_playlist_from_name (MusicLibrary* base,
                                                                                 const gchar* name);
static gboolean music_plugins_audio_player_library_real_start_file_operations (MusicLibrary* base,
                                                                        const gchar* message);
static gboolean music_plugins_audio_player_library_real_doing_file_operations (MusicLibrary* base);
static void music_plugins_audio_player_library_real_finish_file_operations (MusicLibrary* base);
static void music_plugins_audio_player_library_finalize (GObject * obj);

static inline gpointer
music_plugins_audio_player_library_get_instance_private (MusicPluginsAudioPlayerLibrary* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsAudioPlayerLibrary_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_music_plugins_audio_player_library_media_imported_from_tagger_music_gstreamer_tagger_media_imported (MusicGStreamerTagger* _sender,
                                                                                                      MusicMedia* m,
                                                                                                      gpointer self)
{
	music_plugins_audio_player_library_media_imported_from_tagger ((MusicPluginsAudioPlayerLibrary*) self, m);
}

static void
_music_plugins_audio_player_library_import_error_music_gstreamer_tagger_import_error (MusicGStreamerTagger* _sender,
                                                                                      const gchar* file_uri,
                                                                                      GError* _error_,
                                                                                      gpointer self)
{
	music_plugins_audio_player_library_import_error ((MusicPluginsAudioPlayerLibrary*) self, file_uri);
}

static void
_music_plugins_audio_player_library_queue_finished_music_gstreamer_tagger_queue_finished (MusicGStreamerTagger* _sender,
                                                                                          gpointer self)
{
	music_plugins_audio_player_library_queue_finished ((MusicPluginsAudioPlayerLibrary*) self);
}

static void
__lambda4_ (MusicPluginsAudioPlayerLibrary* self)
{
	self->priv->operation_cancelled = TRUE;
}

static void
___lambda4__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                          gpointer self)
{
	__lambda4_ ((MusicPluginsAudioPlayerLibrary*) self);
}

MusicPluginsAudioPlayerLibrary*
music_plugins_audio_player_library_construct (GType object_type,
                                              MusicPluginsAudioPlayerDevice* device)
{
	MusicPluginsAudioPlayerLibrary * self = NULL;
	MusicPluginsAudioPlayerDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	GeeLinkedList* _tmp4_;
	MusicGStreamerTagger* _tmp5_;
	MusicGStreamerTagger* _tmp6_;
	MusicGStreamerTagger* _tmp7_;
	MusicGStreamerTagger* _tmp8_;
	MusicNotificationManager* _tmp9_;
	MusicNotificationManager* _tmp10_;
	g_return_val_if_fail (device != NULL, NULL);
	self = (MusicPluginsAudioPlayerLibrary*) music_library_construct (object_type);
	_tmp0_ = _g_object_ref0 (device);
	_g_object_unref0 (self->priv->device);
	self->priv->device = _tmp0_;
	_tmp1_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->medias);
	self->priv->medias = _tmp1_;
	_tmp2_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->searched_medias);
	self->priv->searched_medias = _tmp2_;
	_tmp3_ = gee_linked_list_new (MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->playlists);
	self->priv->playlists = _tmp3_;
	_tmp4_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->imported_files);
	self->priv->imported_files = _tmp4_;
	_tmp5_ = music_gstreamer_tagger_new (NULL);
	_g_object_unref0 (self->tagger);
	self->tagger = _tmp5_;
	_tmp6_ = self->tagger;
	g_signal_connect_object (_tmp6_, "media-imported", (GCallback) _music_plugins_audio_player_library_media_imported_from_tagger_music_gstreamer_tagger_media_imported, self, 0);
	_tmp7_ = self->tagger;
	g_signal_connect_object (_tmp7_, "import-error", (GCallback) _music_plugins_audio_player_library_import_error_music_gstreamer_tagger_import_error, self, 0);
	_tmp8_ = self->tagger;
	g_signal_connect_object (_tmp8_, "queue-finished", (GCallback) _music_plugins_audio_player_library_queue_finished_music_gstreamer_tagger_queue_finished, self, 0);
	_tmp9_ = music_notification_manager_get_default ();
	_tmp10_ = _tmp9_;
	g_signal_connect_object (_tmp10_, "progress-canceled", (GCallback) ___lambda4__music_notification_manager_progress_canceled, self, 0);
	_g_object_unref0 (_tmp10_);
	return self;
}

MusicPluginsAudioPlayerLibrary*
music_plugins_audio_player_library_new (MusicPluginsAudioPlayerDevice* device)
{
	return music_plugins_audio_player_library_construct (MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, device);
}

static void
music_plugins_audio_player_library_media_imported_from_tagger (MusicPluginsAudioPlayerLibrary* self,
                                                               MusicMedia* m)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	music_media_set_is_temporary (m, TRUE);
	_tmp0_ = self->priv->medias;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, m);
	music_media_set_rowid (m, (gint64) self->medias_rowid);
	_tmp1_ = self->medias_rowid;
	self->medias_rowid = _tmp1_ + 1;
	if (self->priv->queue_is_finished) {
		g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
	}
}

static void
music_plugins_audio_player_library_import_error (MusicPluginsAudioPlayerLibrary* self,
                                                 const gchar* file)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
}

void
music_plugins_audio_player_library_queue_finished (MusicPluginsAudioPlayerLibrary* self)
{
	MusicLibrariesManager* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->queue_is_finished = TRUE;
	_tmp0_ = music_libraries_manager;
	_tmp0_->progress = (gdouble) 1;
	if (self->priv->is_initialized == FALSE) {
		MusicPluginsAudioPlayerDevice* _tmp1_;
		MusicPluginsAudioPlayerDevice* _tmp2_;
		self->priv->is_initialized = TRUE;
		_tmp1_ = self->priv->device;
		_tmp2_ = self->priv->device;
		g_signal_emit_by_name ((MusicDevice*) _tmp1_, "initialized", (MusicDevice*) _tmp2_);
		music_library_search_medias ((MusicLibrary*) self, "");
	}
}

static void
music_plugins_audio_player_library_real_initialize_library (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	self = (MusicPluginsAudioPlayerLibrary*) base;
}

static void
music_plugins_audio_player_library_real_add_files_to_library (MusicLibrary* base,
                                                              GeeCollection* files)
{
	MusicPluginsAudioPlayerLibrary * self;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (files != NULL);
}

static GeeCollection*
music_plugins_audio_player_library_real_get_medias (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	_tmp0_ = self->priv->medias;
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
	result = _tmp1_;
	return result;
}

static GeeCollection*
music_plugins_audio_player_library_real_get_playlists (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	_tmp0_ = self->priv->playlists;
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
	result = _tmp1_;
	return result;
}

static GeeCollection*
music_plugins_audio_player_library_real_get_smart_playlists (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_SMART_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	result = (GeeCollection*) _tmp0_;
	return result;
}

static void
music_plugins_audio_player_library_real_search_medias (MusicLibrary* base,
                                                       const gchar* search)
{
	MusicPluginsAudioPlayerLibrary * self;
	GError* _inner_error0_ = NULL;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (search != NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->searched_medias;
		g_rec_mutex_lock (&self->priv->__lock_searched_medias);
		{
			GeeLinkedList* _tmp1_;
			gboolean _tmp2_ = FALSE;
			guint parsed_rating = 0U;
			gchar* parsed_search_string = NULL;
			guint _tmp6_ = 0U;
			gchar* _tmp7_ = NULL;
			gboolean rating_search = FALSE;
			_tmp1_ = self->priv->searched_medias;
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
			if (g_strcmp0 (search, "") == 0) {
				_tmp2_ = TRUE;
			} else {
				_tmp2_ = search == NULL;
			}
			if (_tmp2_) {
				GeeLinkedList* _tmp3_;
				GeeLinkedList* _tmp4_;
				_tmp3_ = self->priv->searched_medias;
				_tmp4_ = self->priv->medias;
				gee_collection_add_all ((GeeCollection*) _tmp3_, (GeeCollection*) _tmp4_);
				g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
				{
					GeeLinkedList* _tmp5_;
					_tmp5_ = self->priv->searched_medias;
					g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
				}
				return;
			}
			music_string_base_search_method (search, &_tmp6_, &_tmp7_);
			parsed_rating = _tmp6_;
			_g_free0 (parsed_search_string);
			parsed_search_string = _tmp7_;
			rating_search = parsed_rating > ((guint) 0);
			{
				GeeLinkedList* _tmp8_;
				_tmp8_ = self->priv->medias;
				g_rec_mutex_lock (&self->priv->__lock_medias);
				{
					{
						GeeLinkedList* _m_list = NULL;
						GeeLinkedList* _tmp9_;
						gint _m_size = 0;
						GeeLinkedList* _tmp10_;
						gint _tmp11_;
						gint _tmp12_;
						gint _m_index = 0;
						_tmp9_ = self->priv->medias;
						_m_list = _tmp9_;
						_tmp10_ = _m_list;
						_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
						_tmp12_ = _tmp11_;
						_m_size = _tmp12_;
						_m_index = -1;
						while (TRUE) {
							gint _tmp13_;
							gint _tmp14_;
							MusicMedia* m = NULL;
							GeeLinkedList* _tmp15_;
							gpointer _tmp16_;
							_m_index = _m_index + 1;
							_tmp13_ = _m_index;
							_tmp14_ = _m_size;
							if (!(_tmp13_ < _tmp14_)) {
								break;
							}
							_tmp15_ = _m_list;
							_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _m_index);
							m = (MusicMedia*) _tmp16_;
							if (rating_search) {
								MusicMedia* _tmp17_;
								guint _tmp18_;
								guint _tmp19_;
								_tmp17_ = m;
								_tmp18_ = music_media_get_rating (_tmp17_);
								_tmp19_ = _tmp18_;
								if (_tmp19_ == parsed_rating) {
									GeeLinkedList* _tmp20_;
									MusicMedia* _tmp21_;
									_tmp20_ = self->priv->searched_medias;
									_tmp21_ = m;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
								}
							} else {
								MusicMedia* _tmp22_;
								const gchar* _tmp23_;
								_tmp22_ = m;
								_tmp23_ = parsed_search_string;
								if (music_search_match_string_to_media (_tmp22_, _tmp23_)) {
									GeeLinkedList* _tmp24_;
									MusicMedia* _tmp25_;
									_tmp24_ = self->priv->searched_medias;
									_tmp25_ = m;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
								}
							}
							_g_object_unref0 (m);
						}
					}
				}
				__finally1:
				{
					GeeLinkedList* _tmp26_;
					_tmp26_ = self->priv->medias;
					g_rec_mutex_unlock (&self->priv->__lock_medias);
				}
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_free0 (parsed_search_string);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_g_free0 (parsed_search_string);
		}
		__finally0:
		{
			GeeLinkedList* _tmp27_;
			_tmp27_ = self->priv->searched_medias;
			g_rec_mutex_unlock (&self->priv->__lock_searched_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	g_signal_emit_by_name ((MusicLibrary*) self, "search-finished");
}

static GeeCollection*
music_plugins_audio_player_library_real_get_search_result (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	_tmp0_ = self->priv->searched_medias;
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
	result = _tmp1_;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
music_plugins_audio_player_library_real_add_media (MusicLibrary* base,
                                                   MusicMedia* m)
{
	MusicPluginsAudioPlayerLibrary * self;
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	MusicPluginsAudioPlayerDevice* _tmp12_;
	gchar* _tmp13_;
	MusicLibrariesManager* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GFile* file = NULL;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* destination_file = NULL;
	MusicPluginsAudioPlayerDevice* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GFile* _tmp35_;
	GFile* _tmp36_;
	GeeLinkedList* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GError* _inner_error0_ = NULL;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (m != NULL);
	if (m == NULL) {
		return;
	}
	_tmp0_ = g_strdup (_ ("Adding <b>$NAME</b> by <b>$ARTIST</b> to $DEVICE"));
	current_operation = _tmp0_;
	_tmp2_ = music_media_get_title (m);
	_tmp3_ = _tmp2_;
	_tmp1_ = _tmp3_;
	if (_tmp1_ == NULL) {
		_tmp1_ = "";
	}
	_tmp4_ = current_operation;
	_tmp5_ = string_replace (_tmp4_, "$NAME", _tmp1_);
	_g_free0 (current_operation);
	current_operation = _tmp5_;
	_tmp7_ = music_media_get_artist (m);
	_tmp8_ = _tmp7_;
	_tmp6_ = _tmp8_;
	if (_tmp6_ == NULL) {
		_tmp6_ = "";
	}
	_tmp9_ = current_operation;
	_tmp10_ = string_replace (_tmp9_, "$ARTIST", _tmp6_);
	_g_free0 (current_operation);
	current_operation = _tmp10_;
	_tmp12_ = self->priv->device;
	_tmp13_ = music_device_get_display_name ((MusicDevice*) _tmp12_);
	_tmp11_ = _tmp13_;
	if (_tmp11_ == NULL) {
		gchar* _tmp14_;
		_tmp14_ = g_strdup ("");
		_g_free0 (_tmp11_);
		_tmp11_ = _tmp14_;
	}
	_tmp15_ = music_libraries_manager;
	_tmp16_ = current_operation;
	_tmp17_ = string_replace (_tmp16_, "$DEVICE", _tmp11_);
	_g_free0 (_tmp15_->current_operation);
	_tmp15_->current_operation = _tmp17_;
	_tmp18_ = music_media_get_title (m);
	_tmp19_ = _tmp18_;
	_tmp20_ = music_media_get_artist (m);
	_tmp21_ = _tmp20_;
	g_debug ("AudioPlayerLibrary.vala:150: Adding media %s by %s\n", _tmp19_, _tmp21_);
	_tmp22_ = music_media_get_uri (m);
	_tmp23_ = _tmp22_;
	_tmp24_ = _tmp23_;
	_tmp25_ = g_file_new_for_uri (_tmp24_);
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp24_);
	file = _tmp26_;
	_tmp27_ = self->priv->device;
	_tmp28_ = music_plugins_audio_player_device_get_music_folder (_tmp27_);
	_tmp29_ = _tmp28_;
	_tmp30_ = file;
	_tmp31_ = g_file_get_basename (_tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = g_strconcat (_tmp29_, _tmp32_, NULL);
	_tmp34_ = _tmp33_;
	_tmp35_ = g_file_new_for_uri (_tmp34_);
	_tmp36_ = _tmp35_;
	_g_free0 (_tmp34_);
	_g_free0 (_tmp32_);
	_g_free0 (_tmp29_);
	destination_file = _tmp36_;
	{
		GFile* _tmp37_;
		GFile* _tmp38_;
		_tmp37_ = file;
		_tmp38_ = destination_file;
		g_file_copy (_tmp37_, _tmp38_, G_FILE_COPY_ALL_METADATA, NULL, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp39_ = music_media_get_title (m);
		_tmp40_ = _tmp39_;
		_tmp41_ = err;
		_tmp42_ = _tmp41_->message;
		g_warning ("AudioPlayerLibrary.vala:158: Failed to copy track %s : %s\n", _tmp40_, _tmp42_);
		_g_error_free0 (err);
		_g_object_unref0 (destination_file);
		_g_object_unref0 (file);
		_g_free0 (_tmp11_);
		_g_free0 (current_operation);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (destination_file);
		_g_object_unref0 (file);
		_g_free0 (_tmp11_);
		_g_free0 (current_operation);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp43_ = self->priv->imported_files;
	_tmp44_ = destination_file;
	_tmp45_ = g_file_get_uri (_tmp44_);
	_tmp46_ = _tmp45_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, _tmp46_);
	_g_free0 (_tmp46_);
	_g_object_unref0 (destination_file);
	_g_object_unref0 (file);
	_g_free0 (_tmp11_);
	_g_free0 (current_operation);
}

static gboolean
_music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = music_libraries_manager_do_progress_notification_with_timeout ((MusicLibrariesManager*) self);
	return result;
}

static void
music_plugins_audio_player_library_real_add_medias (MusicLibrary* base,
                                                    GeeCollection* list)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicLibrariesManager* _tmp0_;
	MusicPluginsAudioPlayerDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	MusicLibrariesManager* _tmp5_;
	gint sub_index = 0;
	GeeLinkedList* medias_to_sync = NULL;
	GeeLinkedList* _tmp6_;
	GeeLinkedList* _tmp7_;
	MusicPluginsAudioPlayerDevice* _tmp8_;
	GeeLinkedList* _tmp9_;
	GeeCollection* _tmp10_;
	GeeCollection* _tmp11_;
	GeeLinkedList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint total_medias = 0;
	GeeLinkedList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (list != NULL);
	if (music_library_doing_file_operations ((MusicLibrary*) self)) {
		g_warning ("AudioPlayerLibrary.vala:167: Tried to add when already syncing\n");
		return;
	}
	_tmp0_ = music_libraries_manager;
	_tmp1_ = self->priv->device;
	_tmp2_ = music_device_get_display_name ((MusicDevice*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf (_ ("Syncing <b>%s</b>…"), _tmp3_);
	_g_free0 (_tmp0_->current_operation);
	_tmp0_->current_operation = _tmp4_;
	_g_free0 (_tmp3_);
	self->priv->is_doing_file_operations = TRUE;
	_tmp5_ = music_libraries_manager;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp5_), g_object_unref);
	sub_index = 0;
	_tmp6_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	medias_to_sync = _tmp6_;
	_tmp7_ = medias_to_sync;
	_tmp8_ = self->priv->device;
	_tmp9_ = self->priv->medias;
	_tmp10_ = music_device_delete_doubles ((MusicDevice*) _tmp8_, list, (GeeCollection*) _tmp9_);
	_tmp11_ = _tmp10_;
	gee_collection_add_all ((GeeCollection*) _tmp7_, _tmp11_);
	_g_object_unref0 (_tmp11_);
	_tmp12_ = medias_to_sync;
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
	_tmp14_ = _tmp13_;
	g_message ("AudioPlayerLibrary.vala:179: Found %d medias to add.", _tmp14_);
	_tmp15_ = medias_to_sync;
	_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
	_tmp17_ = _tmp16_;
	total_medias = _tmp17_;
	if (total_medias > 0) {
		MusicPluginsAudioPlayerDevice* _tmp18_;
		GeeLinkedList* _tmp19_;
		_tmp18_ = self->priv->device;
		_tmp19_ = medias_to_sync;
		if (music_device_will_fit ((MusicDevice*) _tmp18_, (GeeCollection*) _tmp19_)) {
			GeeLinkedList* _tmp20_;
			MusicGStreamerTagger* _tmp32_;
			GeeLinkedList* _tmp33_;
			_tmp20_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
			_g_object_unref0 (self->priv->imported_files);
			self->priv->imported_files = _tmp20_;
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp21_;
				gint _m_size = 0;
				GeeLinkedList* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _m_index = 0;
				_tmp21_ = medias_to_sync;
				_m_list = _tmp21_;
				_tmp22_ = _m_list;
				_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
				_tmp24_ = _tmp23_;
				_m_size = _tmp24_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp25_;
					gint _tmp26_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp27_;
					gpointer _tmp28_;
					MusicMedia* _tmp29_;
					gint _tmp30_;
					MusicLibrariesManager* _tmp31_;
					_m_index = _m_index + 1;
					_tmp25_ = _m_index;
					_tmp26_ = _m_size;
					if (!(_tmp25_ < _tmp26_)) {
						break;
					}
					_tmp27_ = _m_list;
					_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _m_index);
					m = (MusicMedia*) _tmp28_;
					_tmp29_ = m;
					music_library_add_media ((MusicLibrary*) self, _tmp29_);
					sub_index = sub_index + 1;
					_tmp30_ = sub_index;
					_tmp31_ = music_libraries_manager;
					_tmp31_->progress = (gdouble) (sub_index / total_medias);
					_g_object_unref0 (m);
				}
			}
			_tmp32_ = self->tagger;
			_tmp33_ = self->priv->imported_files;
			music_gstreamer_tagger_discoverer_import_media (_tmp32_, (GeeCollection*) _tmp33_);
		}
	}
	_g_object_unref0 (medias_to_sync);
	return;
}

static MusicMedia*
music_plugins_audio_player_library_real_media_from_id (MusicLibrary* base,
                                                       gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				gint _m_size = 0;
				GeeLinkedList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _m_index = 0;
				_tmp1_ = self->priv->medias;
				_m_list = _tmp1_;
				_tmp2_ = _m_list;
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				_m_size = _tmp4_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp7_;
					gpointer _tmp8_;
					MusicMedia* _tmp9_;
					gint64 _tmp10_;
					gint64 _tmp11_;
					_m_index = _m_index + 1;
					_tmp5_ = _m_index;
					_tmp6_ = _m_size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = _m_list;
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
					m = (MusicMedia*) _tmp8_;
					_tmp9_ = m;
					_tmp10_ = music_media_get_rowid (_tmp9_);
					_tmp11_ = _tmp10_;
					if (_tmp11_ == id) {
						result = m;
						{
							GeeLinkedList* _tmp12_;
							_tmp12_ = self->priv->medias;
							g_rec_mutex_unlock (&self->priv->__lock_medias);
						}
						return result;
					}
					_g_object_unref0 (m);
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp13_;
			_tmp13_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}

static GeeCollection*
music_plugins_audio_player_library_real_medias_from_ids (MusicLibrary* base,
                                                         GeeCollection* ids)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (ids != NULL, NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	media_collection = _tmp0_;
	{
		GeeLinkedList* _tmp1_;
		_tmp1_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
				_tmp2_ = self->priv->medias;
				_m_list = _tmp2_;
				_tmp3_ = _m_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_m_size = _tmp5_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp8_;
					gpointer _tmp9_;
					MusicMedia* _tmp10_;
					gint64 _tmp11_;
					gint64 _tmp12_;
					GeeLinkedList* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					_m_index = _m_index + 1;
					_tmp6_ = _m_index;
					_tmp7_ = _m_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _m_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _m_index);
					m = (MusicMedia*) _tmp9_;
					_tmp10_ = m;
					_tmp11_ = music_media_get_rowid (_tmp10_);
					_tmp12_ = _tmp11_;
					if (gee_collection_contains (ids, &_tmp12_)) {
						GeeLinkedList* _tmp13_;
						MusicMedia* _tmp14_;
						_tmp13_ = media_collection;
						_tmp14_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
					}
					_tmp15_ = media_collection;
					_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
					_tmp17_ = _tmp16_;
					_tmp18_ = gee_collection_get_size (ids);
					_tmp19_ = _tmp18_;
					if (_tmp17_ == _tmp19_) {
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp20_;
			_tmp20_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (media_collection);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = (GeeCollection*) media_collection;
	return result;
}

static GeeCollection*
music_plugins_audio_player_library_real_medias_from_uris (MusicLibrary* base,
                                                          GeeCollection* uris)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeLinkedList* media_collection = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (uris != NULL, NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	media_collection = _tmp0_;
	{
		GeeLinkedList* _tmp1_;
		_tmp1_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp2_;
				gint _m_size = 0;
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _m_index = 0;
				_tmp2_ = self->priv->medias;
				_m_list = _tmp2_;
				_tmp3_ = _m_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_m_size = _tmp5_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp8_;
					gpointer _tmp9_;
					MusicMedia* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gboolean _tmp14_;
					GeeLinkedList* _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					_m_index = _m_index + 1;
					_tmp6_ = _m_index;
					_tmp7_ = _m_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _m_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _m_index);
					m = (MusicMedia*) _tmp9_;
					_tmp10_ = m;
					_tmp11_ = music_media_get_uri (_tmp10_);
					_tmp12_ = _tmp11_;
					_tmp13_ = _tmp12_;
					_tmp14_ = gee_collection_contains (uris, _tmp13_);
					_g_free0 (_tmp13_);
					if (_tmp14_) {
						GeeLinkedList* _tmp15_;
						MusicMedia* _tmp16_;
						_tmp15_ = media_collection;
						_tmp16_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
					}
					_tmp17_ = media_collection;
					_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
					_tmp19_ = _tmp18_;
					_tmp20_ = gee_collection_get_size (uris);
					_tmp21_ = _tmp20_;
					if (_tmp19_ == _tmp21_) {
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp22_;
			_tmp22_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (media_collection);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = (GeeCollection*) media_collection;
	return result;
}

static MusicMedia*
music_plugins_audio_player_library_real_find_media (MusicLibrary* base,
                                                    MusicMedia* to_find)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicMedia* found = NULL;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (to_find != NULL, NULL);
	found = NULL;
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				gint _m_size = 0;
				GeeLinkedList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _m_index = 0;
				_tmp1_ = self->priv->medias;
				_m_list = _tmp1_;
				_tmp2_ = _m_list;
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				_m_size = _tmp4_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp7_;
					gpointer _tmp8_;
					gboolean _tmp9_ = FALSE;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					MusicMedia* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gboolean _tmp19_;
					_m_index = _m_index + 1;
					_tmp5_ = _m_index;
					_tmp6_ = _m_size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = _m_list;
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
					m = (MusicMedia*) _tmp8_;
					_tmp10_ = music_media_get_title (to_find);
					_tmp11_ = _tmp10_;
					_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
					_tmp13_ = _tmp12_;
					_tmp14_ = m;
					_tmp15_ = music_media_get_title (_tmp14_);
					_tmp16_ = _tmp15_;
					_tmp17_ = g_utf8_strdown (_tmp16_, (gssize) -1);
					_tmp18_ = _tmp17_;
					_tmp19_ = g_strcmp0 (_tmp13_, _tmp18_) == 0;
					_g_free0 (_tmp18_);
					_g_free0 (_tmp13_);
					if (_tmp19_) {
						const gchar* _tmp20_;
						const gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						MusicMedia* _tmp24_;
						const gchar* _tmp25_;
						const gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						_tmp20_ = music_media_get_artist (to_find);
						_tmp21_ = _tmp20_;
						_tmp22_ = g_utf8_strdown (_tmp21_, (gssize) -1);
						_tmp23_ = _tmp22_;
						_tmp24_ = m;
						_tmp25_ = music_media_get_artist (_tmp24_);
						_tmp26_ = _tmp25_;
						_tmp27_ = g_utf8_strdown (_tmp26_, (gssize) -1);
						_tmp28_ = _tmp27_;
						_tmp9_ = g_strcmp0 (_tmp23_, _tmp28_) == 0;
						_g_free0 (_tmp28_);
						_g_free0 (_tmp23_);
					} else {
						_tmp9_ = FALSE;
					}
					if (_tmp9_) {
						MusicMedia* _tmp29_;
						MusicMedia* _tmp30_;
						_tmp29_ = m;
						_tmp30_ = _g_object_ref0 (_tmp29_);
						_g_object_unref0 (found);
						found = _tmp30_;
						_g_object_unref0 (m);
						break;
					}
					_g_object_unref0 (m);
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp31_;
			_tmp31_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (found);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = found;
	return result;
}

static MusicMedia*
music_plugins_audio_player_library_real_media_from_file (MusicLibrary* base,
                                                         GFile* file)
{
	MusicPluginsAudioPlayerLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				gint _m_size = 0;
				GeeLinkedList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _m_index = 0;
				_tmp1_ = self->priv->medias;
				_m_list = _tmp1_;
				_tmp2_ = _m_list;
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				_m_size = _tmp4_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp7_;
					gpointer _tmp8_;
					gboolean _tmp9_ = FALSE;
					MusicMedia* _tmp10_;
					_m_index = _m_index + 1;
					_tmp5_ = _m_index;
					_tmp6_ = _m_size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = _m_list;
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
					m = (MusicMedia*) _tmp8_;
					_tmp10_ = m;
					if (_tmp10_ != NULL) {
						MusicMedia* _tmp11_;
						GFile* _tmp12_;
						GFile* _tmp13_;
						_tmp11_ = m;
						_tmp12_ = music_media_get_file (_tmp11_);
						_tmp13_ = _tmp12_;
						_tmp9_ = g_file_equal (_tmp13_, file);
					} else {
						_tmp9_ = FALSE;
					}
					if (_tmp9_) {
						result = m;
						{
							GeeLinkedList* _tmp14_;
							_tmp14_ = self->priv->medias;
							g_rec_mutex_unlock (&self->priv->__lock_medias);
						}
						return result;
					}
					_g_object_unref0 (m);
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp15_;
			_tmp15_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}

static MusicMedia*
music_plugins_audio_player_library_real_media_from_uri (MusicLibrary* base,
                                                        const gchar* uri)
{
	MusicPluginsAudioPlayerLibrary * self;
	GError* _inner_error0_ = NULL;
	MusicMedia* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (uri != NULL, NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->medias;
		g_rec_mutex_lock (&self->priv->__lock_medias);
		{
			{
				GeeLinkedList* _m_list = NULL;
				GeeLinkedList* _tmp1_;
				gint _m_size = 0;
				GeeLinkedList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _m_index = 0;
				_tmp1_ = self->priv->medias;
				_m_list = _tmp1_;
				_tmp2_ = _m_list;
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				_m_size = _tmp4_;
				_m_index = -1;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					MusicMedia* m = NULL;
					GeeLinkedList* _tmp7_;
					gpointer _tmp8_;
					gboolean _tmp9_ = FALSE;
					MusicMedia* _tmp10_;
					_m_index = _m_index + 1;
					_tmp5_ = _m_index;
					_tmp6_ = _m_size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = _m_list;
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _m_index);
					m = (MusicMedia*) _tmp8_;
					_tmp10_ = m;
					if (_tmp10_ != NULL) {
						MusicMedia* _tmp11_;
						gchar* _tmp12_;
						gchar* _tmp13_;
						gchar* _tmp14_;
						_tmp11_ = m;
						_tmp12_ = music_media_get_uri (_tmp11_);
						_tmp13_ = _tmp12_;
						_tmp14_ = _tmp13_;
						_tmp9_ = g_strcmp0 (_tmp14_, uri) == 0;
						_g_free0 (_tmp14_);
					} else {
						_tmp9_ = FALSE;
					}
					if (_tmp9_) {
						result = m;
						{
							GeeLinkedList* _tmp15_;
							_tmp15_ = self->priv->medias;
							g_rec_mutex_unlock (&self->priv->__lock_medias);
						}
						return result;
					}
					_g_object_unref0 (m);
				}
			}
		}
		__finally0:
		{
			GeeLinkedList* _tmp16_;
			_tmp16_ = self->priv->medias;
			g_rec_mutex_unlock (&self->priv->__lock_medias);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = NULL;
	return result;
}

static void
music_plugins_audio_player_library_real_update_media (MusicLibrary* base,
                                                      MusicMedia* s,
                                                      gboolean update_meta,
                                                      gboolean record_time)
{
	MusicPluginsAudioPlayerLibrary * self;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (s != NULL);
}

static void
music_plugins_audio_player_library_real_update_medias (MusicLibrary* base,
                                                       GeeCollection* updates,
                                                       gboolean update_meta,
                                                       gboolean record_time)
{
	MusicPluginsAudioPlayerLibrary * self;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (updates != NULL);
}

static void
music_plugins_audio_player_library_real_remove_media (MusicLibrary* base,
                                                      MusicMedia* m,
                                                      gboolean trash)
{
	MusicPluginsAudioPlayerLibrary * self;
	gchar* current_operation = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	MusicPluginsAudioPlayerDevice* _tmp12_;
	gchar* _tmp13_;
	MusicLibrariesManager* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	GError* _inner_error0_ = NULL;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = g_strdup (_ ("Removing <b>$NAME</b> by <b>$ARTIST</b> from $DEVICE"));
	current_operation = _tmp0_;
	_tmp2_ = music_media_get_title (m);
	_tmp3_ = _tmp2_;
	_tmp1_ = _tmp3_;
	if (_tmp1_ == NULL) {
		_tmp1_ = "";
	}
	_tmp4_ = current_operation;
	_tmp5_ = string_replace (_tmp4_, "$NAME", _tmp1_);
	_g_free0 (current_operation);
	current_operation = _tmp5_;
	_tmp7_ = music_media_get_artist (m);
	_tmp8_ = _tmp7_;
	_tmp6_ = _tmp8_;
	if (_tmp6_ == NULL) {
		_tmp6_ = "";
	}
	_tmp9_ = current_operation;
	_tmp10_ = string_replace (_tmp9_, "$ARTIST", _tmp6_);
	_g_free0 (current_operation);
	current_operation = _tmp10_;
	_tmp12_ = self->priv->device;
	_tmp13_ = music_device_get_display_name ((MusicDevice*) _tmp12_);
	_tmp11_ = _tmp13_;
	if (_tmp11_ == NULL) {
		gchar* _tmp14_;
		_tmp14_ = g_strdup ("");
		_g_free0 (_tmp11_);
		_tmp11_ = _tmp14_;
	}
	_tmp15_ = music_libraries_manager;
	_tmp16_ = current_operation;
	_tmp17_ = string_replace (_tmp16_, "$DEVICE", _tmp11_);
	_g_free0 (_tmp15_->current_operation);
	_tmp15_->current_operation = _tmp17_;
	_tmp18_ = music_media_get_uri (m);
	_tmp19_ = _tmp18_;
	_tmp20_ = _tmp19_;
	_tmp21_ = _tmp20_ != NULL;
	_g_free0 (_tmp20_);
	if (_tmp21_) {
		GFile* file = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		_tmp22_ = music_media_get_uri (m);
		_tmp23_ = _tmp22_;
		_tmp24_ = _tmp23_;
		_tmp25_ = g_file_new_for_uri (_tmp24_);
		_tmp26_ = _tmp25_;
		_g_free0 (_tmp24_);
		file = _tmp26_;
		_tmp27_ = file;
		if (g_file_query_exists (_tmp27_, NULL)) {
			GeeArrayList* media_list = NULL;
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			GeeArrayList* _tmp30_;
			GeeLinkedList* _tmp31_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			_tmp28_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			media_list = _tmp28_;
			_tmp29_ = media_list;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, m);
			_tmp30_ = media_list;
			g_signal_emit_by_name ((MusicLibrary*) self, "media-removed", (GeeCollection*) _tmp30_);
			_tmp31_ = self->priv->medias;
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp31_, m);
			{
				GFile* _tmp32_;
				_tmp32_ = file;
				g_file_delete (_tmp32_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				GError* _tmp36_;
				const gchar* _tmp37_;
				err = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp33_ = music_media_get_uri (m);
				_tmp34_ = _tmp33_;
				_tmp35_ = _tmp34_;
				_tmp36_ = err;
				_tmp37_ = _tmp36_->message;
				g_warning ("AudioPlayerLibrary.vala:299: Could not delete File at %s: %s", _tmp35_, _tmp37_);
				_g_free0 (_tmp35_);
				_g_error_free0 (err);
				_g_object_unref0 (media_list);
				_g_object_unref0 (file);
				_g_free0 (_tmp11_);
				_g_free0 (current_operation);
				return;
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (media_list);
				_g_object_unref0 (file);
				_g_free0 (_tmp11_);
				_g_free0 (current_operation);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_tmp38_ = music_media_get_uri (m);
			_tmp39_ = _tmp38_;
			_tmp40_ = _tmp39_;
			g_debug ("AudioPlayerLibrary.vala:302: Successfully removed music file %s", _tmp40_);
			_g_free0 (_tmp40_);
			_g_object_unref0 (media_list);
		} else {
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			_tmp41_ = music_media_get_uri (m);
			_tmp42_ = _tmp41_;
			_tmp43_ = _tmp42_;
			g_warning ("AudioPlayerLibrary.vala:304: File not found, could not delete File at " \
"%s. File may already be deleted", _tmp43_);
			_g_free0 (_tmp43_);
		}
		_g_object_unref0 (file);
	}
	_g_free0 (_tmp11_);
	_g_free0 (current_operation);
}

static void
music_plugins_audio_player_library_real_remove_medias (MusicLibrary* base,
                                                       GeeCollection* list,
                                                       gboolean trash)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicLibrariesManager* _tmp0_;
	MusicPluginsAudioPlayerDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint total = 0;
	gint _tmp5_;
	gint _tmp6_;
	MusicLibrariesManager* _tmp7_;
	gint sub_index = 0;
	MusicLibrariesManager* _tmp15_;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (list != NULL);
	if (music_library_doing_file_operations ((MusicLibrary*) self)) {
		g_warning ("AudioPlayerLibrary.vala:311: Tried to add when already syncing\n");
		return;
	}
	_tmp0_ = music_libraries_manager;
	_tmp1_ = self->priv->device;
	_tmp2_ = music_device_get_display_name ((MusicDevice*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf (_ ("Removing from <b>%s</b>…"), _tmp3_);
	_g_free0 (_tmp0_->current_operation);
	_tmp0_->current_operation = _tmp4_;
	_g_free0 (_tmp3_);
	_tmp5_ = gee_collection_get_size (list);
	_tmp6_ = _tmp5_;
	total = _tmp6_;
	_tmp7_ = music_libraries_manager;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_tmp7_), g_object_unref);
	sub_index = 0;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp8_;
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) list);
		_m_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			MusicMedia* _tmp12_;
			gint _tmp13_;
			MusicLibrariesManager* _tmp14_;
			_tmp9_ = _m_it;
			if (!gee_iterator_next (_tmp9_)) {
				break;
			}
			_tmp10_ = _m_it;
			_tmp11_ = gee_iterator_get (_tmp10_);
			m = (MusicMedia*) _tmp11_;
			_tmp12_ = m;
			music_library_remove_media ((MusicLibrary*) self, _tmp12_, TRUE);
			sub_index = sub_index + 1;
			_tmp13_ = sub_index;
			_tmp14_ = music_libraries_manager;
			_tmp14_->progress = (gdouble) (sub_index / total);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp15_ = music_libraries_manager;
	_tmp15_->progress = (gdouble) 1;
	g_signal_emit_by_name ((MusicLibrary*) self, "file-operations-done");
}

static gboolean
music_plugins_audio_player_library_real_support_smart_playlists (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	gboolean result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	result = FALSE;
	return result;
}

static void
music_plugins_audio_player_library_real_add_smart_playlist (MusicLibrary* base,
                                                            MusicSmartPlaylist* p)
{
	MusicPluginsAudioPlayerLibrary * self;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (p != NULL);
}

static void
music_plugins_audio_player_library_real_remove_smart_playlist (MusicLibrary* base,
                                                               gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	self = (MusicPluginsAudioPlayerLibrary*) base;
}

static MusicSmartPlaylist*
music_plugins_audio_player_library_real_smart_playlist_from_id (MusicLibrary* base,
                                                                gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicSmartPlaylist* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	result = NULL;
	return result;
}

static MusicSmartPlaylist*
music_plugins_audio_player_library_real_smart_playlist_from_name (MusicLibrary* base,
                                                                  const gchar* name)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicSmartPlaylist* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (name != NULL, NULL);
	result = NULL;
	return result;
}

static gboolean
music_plugins_audio_player_library_real_support_playlists (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	gboolean result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	result = FALSE;
	return result;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		MusicPluginsAudioPlayerLibrary* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->p);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda5_ (Block1Data* _data1_)
{
	MusicPluginsAudioPlayerLibrary* self;
	self = _data1_->self;
	music_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
}

static void
___lambda5__music_playlist_media_added (MusicPlaylist* _sender,
                                        GeeCollection* media,
                                        gpointer self)
{
	__lambda5_ (self);
}

static void
__lambda6_ (Block1Data* _data1_)
{
	MusicPluginsAudioPlayerLibrary* self;
	self = _data1_->self;
	music_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
}

static void
___lambda6__music_playlist_media_removed (MusicPlaylist* _sender,
                                          GeeCollection* media,
                                          gpointer self)
{
	__lambda6_ (self);
}

static void
__lambda7_ (Block1Data* _data1_,
            const gchar* old_name)
{
	MusicPluginsAudioPlayerLibrary* self;
	self = _data1_->self;
	music_plugins_audio_player_library_remove_playlist_from_name (self, old_name);
	music_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
}

static void
___lambda7__music_playlist_updated (MusicPlaylist* _sender,
                                    const gchar* old_name,
                                    gpointer self)
{
	__lambda7_ (self, old_name);
}

static void
music_plugins_audio_player_library_real_add_playlist (MusicLibrary* base,
                                                      MusicStaticPlaylist* p)
{
	MusicPluginsAudioPlayerLibrary * self;
	Block1Data* _data1_;
	MusicStaticPlaylist* _tmp0_;
	GeeLinkedList* _tmp1_;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_if_fail (p != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (p);
	_g_object_unref0 (_data1_->p);
	_data1_->p = _tmp0_;
	_tmp1_ = self->priv->playlists;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _data1_->p);
	g_signal_emit_by_name ((MusicLibrary*) self, "playlist-added", _data1_->p);
	music_plugins_audio_player_library_keep_playlist_synchronized (self, _data1_->p);
	g_signal_connect_data ((MusicPlaylist*) _data1_->p, "media-added", (GCallback) ___lambda5__music_playlist_media_added, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	g_signal_connect_data ((MusicPlaylist*) _data1_->p, "media-removed", (GCallback) ___lambda6__music_playlist_media_removed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	g_signal_connect_data ((MusicPlaylist*) _data1_->p, "updated", (GCallback) ___lambda7__music_playlist_updated, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static void
music_plugins_audio_player_library_real_remove_playlist (MusicLibrary* base,
                                                         gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	_tmp0_ = music_library_get_playlists ((MusicLibrary*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_collection_get_size (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = id < ((gint64) _tmp3_);
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GeeArrayList* array_v = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
		_tmp5_ = gee_array_list_new (MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		array_v = _tmp5_;
		_tmp6_ = array_v;
		_tmp7_ = self->priv->playlists;
		gee_array_list_add_all (_tmp6_, (GeeCollection*) _tmp7_);
		{
			GeeArrayList* _p_list = NULL;
			GeeArrayList* _tmp8_;
			gint _p_size = 0;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _p_index = 0;
			_tmp8_ = array_v;
			_p_list = _tmp8_;
			_tmp9_ = _p_list;
			_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
			_tmp11_ = _tmp10_;
			_p_size = _tmp11_;
			_p_index = -1;
			while (TRUE) {
				gint _tmp12_;
				gint _tmp13_;
				MusicStaticPlaylist* p = NULL;
				GeeArrayList* _tmp14_;
				gpointer _tmp15_;
				MusicStaticPlaylist* _tmp16_;
				gint64 _tmp17_;
				gint64 _tmp18_;
				_p_index = _p_index + 1;
				_tmp12_ = _p_index;
				_tmp13_ = _p_size;
				if (!(_tmp12_ < _tmp13_)) {
					break;
				}
				_tmp14_ = _p_list;
				_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _p_index);
				p = (MusicStaticPlaylist*) _tmp15_;
				_tmp16_ = p;
				_tmp17_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp16_);
				_tmp18_ = _tmp17_;
				if (_tmp18_ == id) {
					MusicStaticPlaylist* _tmp19_;
					const gchar* _tmp20_;
					const gchar* _tmp21_;
					MusicStaticPlaylist* _tmp22_;
					GeeLinkedList* _tmp23_;
					MusicStaticPlaylist* _tmp24_;
					_tmp19_ = p;
					_tmp20_ = music_playlist_get_name ((MusicPlaylist*) _tmp19_);
					_tmp21_ = _tmp20_;
					music_plugins_audio_player_library_remove_playlist_from_name (self, _tmp21_);
					_tmp22_ = p;
					g_signal_emit_by_name ((MusicLibrary*) self, "playlist-removed", _tmp22_);
					_tmp23_ = self->priv->playlists;
					_tmp24_ = p;
					gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp23_, _tmp24_);
					_g_object_unref0 (p);
					_g_object_unref0 (array_v);
					return;
				}
				_g_object_unref0 (p);
			}
		}
		_g_object_unref0 (array_v);
	}
}

static void
music_plugins_audio_player_library_remove_playlist_from_name (MusicPluginsAudioPlayerLibrary* self,
                                                              const gchar* name)
{
	GFile* dest = NULL;
	MusicPluginsAudioPlayerDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->device;
	_tmp1_ = music_plugins_audio_player_device_get_music_folder (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = string_replace (name, "/", "_");
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, ".m3u", NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_build_path ("/", _tmp2_, "Playlists", _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_file_new_for_uri (_tmp8_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	dest = _tmp10_;
	{
		GFile* _tmp11_;
		_tmp11_ = dest;
		if (g_file_query_exists (_tmp11_, NULL)) {
			GFile* _tmp12_;
			_tmp12_ = dest;
			g_file_delete (_tmp12_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GFile* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = dest;
		_tmp14_ = g_file_get_path (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = err;
		_tmp17_ = _tmp16_->message;
		g_warning ("AudioPlayerLibrary.vala:395: Could not remove playlist %s to file %s: " \
"%s", name, _tmp15_, _tmp17_);
		_g_free0 (_tmp15_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (dest);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (dest);
}

static void
music_plugins_audio_player_library_keep_playlist_synchronized (MusicPluginsAudioPlayerLibrary* self,
                                                               MusicStaticPlaylist* p)
{
	gchar* content = NULL;
	MusicPluginsAudioPlayerDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	MusicPluginsAudioPlayerDevice* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* dest = NULL;
	MusicPluginsAudioPlayerDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->device;
	_tmp1_ = music_device_get_uri ((MusicDevice*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = music_playlists_utils_get_playlist_m3u_file ((MusicPlaylist*) p, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	content = _tmp4_;
	_tmp5_ = content;
	_tmp6_ = self->priv->device;
	_tmp7_ = music_device_get_uri ((MusicDevice*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_file_new_for_uri (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_file_get_path (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = string_replace (_tmp5_, _tmp12_, "");
	_g_free0 (content);
	content = _tmp13_;
	_g_free0 (_tmp12_);
	_g_object_unref0 (_tmp10_);
	_g_free0 (_tmp8_);
	_tmp14_ = self->priv->device;
	_tmp15_ = music_plugins_audio_player_device_get_music_folder (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = music_playlist_get_name ((MusicPlaylist*) p);
	_tmp18_ = _tmp17_;
	_tmp19_ = string_replace (_tmp18_, "/", "_");
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strconcat (_tmp20_, ".m3u", NULL);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_build_path ("/", _tmp16_, "Playlists", _tmp22_, NULL);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_file_new_for_uri (_tmp24_);
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp24_);
	_g_free0 (_tmp22_);
	_g_free0 (_tmp20_);
	_g_free0 (_tmp16_);
	dest = _tmp26_;
	{
		GFile* _tmp27_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp29_;
		GFileOutputStream* _tmp30_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp31_;
		GDataOutputStream* _tmp32_;
		GDataOutputStream* _tmp33_;
		const gchar* _tmp34_;
		_tmp27_ = dest;
		if (g_file_query_exists (_tmp27_, NULL)) {
			GFile* _tmp28_;
			_tmp28_ = dest;
			g_file_delete (_tmp28_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		_tmp29_ = dest;
		_tmp30_ = g_file_create (_tmp29_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
		file_stream = _tmp30_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp31_ = file_stream;
		_tmp32_ = g_data_output_stream_new ((GOutputStream*) _tmp31_);
		data_stream = _tmp32_;
		_tmp33_ = data_stream;
		_tmp34_ = content;
		g_data_output_stream_put_string (_tmp33_, _tmp34_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (data_stream);
			_g_object_unref0 (file_stream);
			goto __catch0_g_error;
		}
		_g_object_unref0 (data_stream);
		_g_object_unref0 (file_stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		GFile* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		GError* _tmp40_;
		const gchar* _tmp41_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp35_ = music_playlist_get_name ((MusicPlaylist*) p);
		_tmp36_ = _tmp35_;
		_tmp37_ = dest;
		_tmp38_ = g_file_get_path (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = err;
		_tmp41_ = _tmp40_->message;
		g_warning ("AudioPlayerLibrary.vala:424: Could not save playlist %s to m3u file %s" \
": %s\n", _tmp36_, _tmp39_, _tmp41_);
		_g_free0 (_tmp39_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (dest);
		_g_free0 (content);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (dest);
	_g_free0 (content);
}

static MusicStaticPlaylist*
music_plugins_audio_player_library_real_playlist_from_id (MusicLibrary* base,
                                                          gint64 id)
{
	MusicPluginsAudioPlayerLibrary * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	MusicStaticPlaylist* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	_tmp0_ = music_library_get_playlists ((MusicLibrary*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_collection_get_size (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = id < ((gint64) _tmp3_);
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GeeArrayList* array = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		_tmp5_ = gee_array_list_new (MUSIC_TYPE_STATIC_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		array = _tmp5_;
		_tmp6_ = array;
		_tmp7_ = music_library_get_playlists ((MusicLibrary*) self);
		_tmp8_ = _tmp7_;
		gee_array_list_add_all (_tmp6_, _tmp8_);
		_g_object_unref0 (_tmp8_);
		{
			GeeArrayList* _playlist_list = NULL;
			GeeArrayList* _tmp9_;
			gint _playlist_size = 0;
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _playlist_index = 0;
			_tmp9_ = array;
			_playlist_list = _tmp9_;
			_tmp10_ = _playlist_list;
			_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
			_tmp12_ = _tmp11_;
			_playlist_size = _tmp12_;
			_playlist_index = -1;
			while (TRUE) {
				gint _tmp13_;
				gint _tmp14_;
				MusicStaticPlaylist* playlist = NULL;
				GeeArrayList* _tmp15_;
				gpointer _tmp16_;
				MusicStaticPlaylist* _tmp17_;
				gint64 _tmp18_;
				gint64 _tmp19_;
				_playlist_index = _playlist_index + 1;
				_tmp13_ = _playlist_index;
				_tmp14_ = _playlist_size;
				if (!(_tmp13_ < _tmp14_)) {
					break;
				}
				_tmp15_ = _playlist_list;
				_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _playlist_index);
				playlist = (MusicStaticPlaylist*) _tmp16_;
				_tmp17_ = playlist;
				_tmp18_ = music_playlist_get_rowid ((MusicPlaylist*) _tmp17_);
				_tmp19_ = _tmp18_;
				if (_tmp19_ == id) {
					result = playlist;
					_g_object_unref0 (array);
					return result;
				}
				_g_object_unref0 (playlist);
			}
		}
		_g_object_unref0 (array);
	}
	result = NULL;
	return result;
}

static MusicStaticPlaylist*
music_plugins_audio_player_library_real_playlist_from_name (MusicLibrary* base,
                                                            const gchar* name)
{
	MusicPluginsAudioPlayerLibrary * self;
	MusicStaticPlaylist* result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	g_return_val_if_fail (name != NULL, NULL);
	{
		GeeIterator* _playlist_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = music_library_get_playlists ((MusicLibrary*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_playlist_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			MusicStaticPlaylist* playlist = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicStaticPlaylist* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			_tmp4_ = _playlist_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _playlist_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			playlist = (MusicStaticPlaylist*) _tmp6_;
			_tmp7_ = playlist;
			_tmp8_ = music_playlist_get_name ((MusicPlaylist*) _tmp7_);
			_tmp9_ = _tmp8_;
			if (g_strcmp0 (_tmp9_, name) == 0) {
				result = playlist;
				_g_object_unref0 (_playlist_it);
				return result;
			}
			_g_object_unref0 (playlist);
		}
		_g_object_unref0 (_playlist_it);
	}
	result = NULL;
	return result;
}

static gboolean
music_plugins_audio_player_library_real_start_file_operations (MusicLibrary* base,
                                                               const gchar* message)
{
	MusicPluginsAudioPlayerLibrary * self;
	gboolean result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	if (music_library_doing_file_operations ((MusicLibrary*) self)) {
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

static gboolean
music_plugins_audio_player_library_real_doing_file_operations (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	gboolean result;
	self = (MusicPluginsAudioPlayerLibrary*) base;
	result = self->priv->is_doing_file_operations;
	return result;
}

static void
music_plugins_audio_player_library_real_finish_file_operations (MusicLibrary* base)
{
	MusicPluginsAudioPlayerLibrary * self;
	self = (MusicPluginsAudioPlayerLibrary*) base;
}

static void
music_plugins_audio_player_library_class_init (MusicPluginsAudioPlayerLibraryClass * klass,
                                               gpointer klass_data)
{
	music_plugins_audio_player_library_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsAudioPlayerLibrary_private_offset);
	((MusicLibraryClass *) klass)->initialize_library = (void (*) (MusicLibrary*)) music_plugins_audio_player_library_real_initialize_library;
	((MusicLibraryClass *) klass)->add_files_to_library = (void (*) (MusicLibrary*, GeeCollection*)) music_plugins_audio_player_library_real_add_files_to_library;
	((MusicLibraryClass *) klass)->get_medias = (GeeCollection* (*) (MusicLibrary*)) music_plugins_audio_player_library_real_get_medias;
	((MusicLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (MusicLibrary*)) music_plugins_audio_player_library_real_get_playlists;
	((MusicLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (MusicLibrary*)) music_plugins_audio_player_library_real_get_smart_playlists;
	((MusicLibraryClass *) klass)->search_medias = (void (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_search_medias;
	((MusicLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (MusicLibrary*)) music_plugins_audio_player_library_real_get_search_result;
	((MusicLibraryClass *) klass)->add_media = (void (*) (MusicLibrary*, MusicMedia*)) music_plugins_audio_player_library_real_add_media;
	((MusicLibraryClass *) klass)->add_medias = (void (*) (MusicLibrary*, GeeCollection*)) music_plugins_audio_player_library_real_add_medias;
	((MusicLibraryClass *) klass)->media_from_id = (MusicMedia* (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_media_from_id;
	((MusicLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_plugins_audio_player_library_real_medias_from_ids;
	((MusicLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_plugins_audio_player_library_real_medias_from_uris;
	((MusicLibraryClass *) klass)->find_media = (MusicMedia* (*) (MusicLibrary*, MusicMedia*)) music_plugins_audio_player_library_real_find_media;
	((MusicLibraryClass *) klass)->media_from_file = (MusicMedia* (*) (MusicLibrary*, GFile*)) music_plugins_audio_player_library_real_media_from_file;
	((MusicLibraryClass *) klass)->media_from_uri = (MusicMedia* (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_media_from_uri;
	((MusicLibraryClass *) klass)->update_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean, gboolean)) music_plugins_audio_player_library_real_update_media;
	((MusicLibraryClass *) klass)->update_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean, gboolean)) music_plugins_audio_player_library_real_update_medias;
	((MusicLibraryClass *) klass)->remove_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean)) music_plugins_audio_player_library_real_remove_media;
	((MusicLibraryClass *) klass)->remove_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean)) music_plugins_audio_player_library_real_remove_medias;
	((MusicLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (MusicLibrary*)) music_plugins_audio_player_library_real_support_smart_playlists;
	((MusicLibraryClass *) klass)->add_smart_playlist = (void (*) (MusicLibrary*, MusicSmartPlaylist*)) music_plugins_audio_player_library_real_add_smart_playlist;
	((MusicLibraryClass *) klass)->remove_smart_playlist = (void (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_remove_smart_playlist;
	((MusicLibraryClass *) klass)->smart_playlist_from_id = (MusicSmartPlaylist* (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_smart_playlist_from_id;
	((MusicLibraryClass *) klass)->smart_playlist_from_name = (MusicSmartPlaylist* (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_smart_playlist_from_name;
	((MusicLibraryClass *) klass)->support_playlists = (gboolean (*) (MusicLibrary*)) music_plugins_audio_player_library_real_support_playlists;
	((MusicLibraryClass *) klass)->add_playlist = (void (*) (MusicLibrary*, MusicStaticPlaylist*)) music_plugins_audio_player_library_real_add_playlist;
	((MusicLibraryClass *) klass)->remove_playlist = (void (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_remove_playlist;
	((MusicLibraryClass *) klass)->playlist_from_id = (MusicStaticPlaylist* (*) (MusicLibrary*, gint64)) music_plugins_audio_player_library_real_playlist_from_id;
	((MusicLibraryClass *) klass)->playlist_from_name = (MusicStaticPlaylist* (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_playlist_from_name;
	((MusicLibraryClass *) klass)->start_file_operations = (gboolean (*) (MusicLibrary*, const gchar*)) music_plugins_audio_player_library_real_start_file_operations;
	((MusicLibraryClass *) klass)->doing_file_operations = (gboolean (*) (MusicLibrary*)) music_plugins_audio_player_library_real_doing_file_operations;
	((MusicLibraryClass *) klass)->finish_file_operations = (void (*) (MusicLibrary*)) music_plugins_audio_player_library_real_finish_file_operations;
	G_OBJECT_CLASS (klass)->finalize = music_plugins_audio_player_library_finalize;
}

static void
music_plugins_audio_player_library_instance_init (MusicPluginsAudioPlayerLibrary * self,
                                                  gpointer klass)
{
	self->priv = music_plugins_audio_player_library_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_medias);
	g_rec_mutex_init (&self->priv->__lock_searched_medias);
	self->priv->operation_cancelled = FALSE;
	self->priv->is_doing_file_operations = FALSE;
	self->priv->queue_is_finished = FALSE;
	self->priv->is_initialized = FALSE;
	self->medias_rowid = 0;
	self->playlists_rowid = 0;
	self->smartplaylists_rowid = 0;
}

static void
music_plugins_audio_player_library_finalize (GObject * obj)
{
	MusicPluginsAudioPlayerLibrary * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, MusicPluginsAudioPlayerLibrary);
	_g_object_unref0 (self->priv->device);
	g_rec_mutex_clear (&self->priv->__lock_medias);
	_g_object_unref0 (self->priv->medias);
	g_rec_mutex_clear (&self->priv->__lock_searched_medias);
	_g_object_unref0 (self->priv->searched_medias);
	_g_object_unref0 (self->priv->playlists);
	_g_object_unref0 (self->priv->imported_files);
	_g_object_unref0 (self->tagger);
	G_OBJECT_CLASS (music_plugins_audio_player_library_parent_class)->finalize (obj);
}

GType
music_plugins_audio_player_library_get_type (void)
{
	return music_plugins_audio_player_library_type_id;
}

GType
music_plugins_audio_player_library_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsAudioPlayerLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_audio_player_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsAudioPlayerLibrary), 0, (GInstanceInitFunc) music_plugins_audio_player_library_instance_init, NULL };
	music_plugins_audio_player_library_type_id = g_type_module_register_type (module, MUSIC_TYPE_LIBRARY, "MusicPluginsAudioPlayerLibrary", &g_define_type_info, 0);
	MusicPluginsAudioPlayerLibrary_private_offset = sizeof (MusicPluginsAudioPlayerLibraryPrivate);
	return music_plugins_audio_player_library_type_id;
}

