/* iPodMediaHelper.c generated by valac 0.55.1, the Vala compiler
 * generated from iPodMediaHelper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include "ipod-device.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gpod/itdb.h>
#include "io.elementary.music-core.h"
#include <time.h>
#include <gobject/gvaluecollector.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MusicPluginsParamSpeciPodMediaHelper MusicPluginsParamSpeciPodMediaHelper;

struct _MusicPluginsParamSpeciPodMediaHelper {
	GParamSpec parent_instance;
};

static gpointer music_plugins_ipod_media_helper_parent_class = NULL;
static GType music_plugins_ipod_media_helper_type_id = 0;

static void music_plugins_ipod_media_helper_finalize (MusicPluginsiPodMediaHelper * obj);

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gchar*
_vala_itdb_filename_ipod2fs (const gchar* ipod_file)
{
	gchar* retval = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (ipod_file != NULL, NULL);
	_tmp0_ = g_strdup (ipod_file);
	retval = _tmp0_;
	itdb_filename_ipod2fs (retval);
	result = retval;
	return result;
}

MusicMedia*
music_plugins_ipod_media_helper_media_from_track (const gchar* uri,
                                                  Itdb_Track* track)
{
	MusicMedia* rv = NULL;
	MusicMedia* _tmp8_;
	MusicMedia* _tmp15_;
	MusicMedia* _tmp16_;
	const gchar* _tmp17_;
	MusicMedia* _tmp18_;
	const gchar* _tmp19_;
	MusicMedia* _tmp20_;
	const gchar* _tmp21_;
	MusicMedia* _tmp22_;
	const gchar* _tmp23_;
	MusicMedia* _tmp24_;
	const gchar* _tmp25_;
	MusicMedia* _tmp26_;
	const gchar* _tmp27_;
	MusicMedia* _tmp28_;
	const gchar* _tmp29_;
	MusicMedia* _tmp30_;
	const gchar* _tmp31_;
	MusicMedia* _tmp32_;
	MusicMedia* _tmp33_;
	MusicMedia* _tmp34_;
	MusicMedia* _tmp35_;
	MusicMedia* _tmp36_;
	MusicMedia* _tmp37_;
	MusicMedia* _tmp38_;
	MusicMedia* _tmp39_;
	MusicMedia* _tmp40_;
	MusicMedia* _tmp41_;
	MusicMedia* _tmp42_;
	MusicMedia* _tmp43_;
	MusicMedia* _tmp44_;
	MusicMedia* _tmp45_;
	MusicMedia* _tmp46_;
	MusicMedia* _tmp47_;
	gboolean _tmp48_ = FALSE;
	MusicMedia* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	MusicMedia* result;
	g_return_val_if_fail (uri != NULL, NULL);
	g_return_val_if_fail (track != NULL, NULL);
	rv = NULL;
	if (g_str_has_suffix (uri, "/")) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		MusicMedia* _tmp7_;
		_tmp0_ = string_slice (uri, (glong) 0, (glong) (g_utf8_strlen (uri, (gssize) -1) - 1));
		_tmp1_ = _tmp0_;
		_tmp2_ = track->ipod_path;
		_tmp3_ = _vala_itdb_filename_ipod2fs (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = music_media_new (_tmp6_);
		_g_object_unref0 (rv);
		rv = _tmp7_;
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		_g_free0 (_tmp1_);
	}
	_tmp8_ = rv;
	if (_tmp8_ == NULL) {
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		MusicMedia* _tmp14_;
		_tmp9_ = track->ipod_path;
		_tmp10_ = _vala_itdb_filename_ipod2fs (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strconcat (uri, _tmp11_, NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = music_media_new (_tmp13_);
		_g_object_unref0 (rv);
		rv = _tmp14_;
		_g_free0 (_tmp13_);
		_g_free0 (_tmp11_);
	}
	_tmp15_ = rv;
	music_media_set_is_temporary (_tmp15_, TRUE);
	_tmp16_ = rv;
	_tmp17_ = track->title;
	music_media_set_title (_tmp16_, _tmp17_);
	_tmp18_ = rv;
	_tmp19_ = track->artist;
	music_media_set_artist (_tmp18_, _tmp19_);
	_tmp20_ = rv;
	_tmp21_ = track->albumartist;
	music_media_set_album_artist (_tmp20_, _tmp21_);
	_tmp22_ = rv;
	_tmp23_ = track->album;
	music_media_set_album (_tmp22_, _tmp23_);
	_tmp24_ = rv;
	_tmp25_ = track->genre;
	music_media_set_genre (_tmp24_, _tmp25_);
	_tmp26_ = rv;
	_tmp27_ = track->comment;
	music_media_set_comment (_tmp26_, _tmp27_);
	_tmp28_ = rv;
	_tmp29_ = track->composer;
	music_media_set_composer (_tmp28_, _tmp29_);
	_tmp30_ = rv;
	_tmp31_ = track->grouping;
	music_media_set_grouping (_tmp30_, _tmp31_);
	_tmp32_ = rv;
	music_media_set_album_number (_tmp32_, (guint) track->cd_nr);
	_tmp33_ = rv;
	music_media_set_album_count (_tmp33_, (guint) track->cds);
	_tmp34_ = rv;
	music_media_set_track (_tmp34_, (guint) track->track_nr);
	_tmp35_ = rv;
	music_media_set_track_count (_tmp35_, (guint) track->tracks);
	_tmp36_ = rv;
	music_media_set_bitrate (_tmp36_, (guint) track->bitrate);
	_tmp37_ = rv;
	music_media_set_year (_tmp37_, (guint) track->year);
	_tmp38_ = rv;
	music_media_set_date_added (_tmp38_, (guint) ((gint) track->time_added));
	_tmp39_ = rv;
	music_media_set_last_modified (_tmp39_, (guint) ((gint) track->time_modified));
	_tmp40_ = rv;
	music_media_set_last_played (_tmp40_, (guint) ((gint) track->time_played));
	_tmp41_ = rv;
	music_media_set_rating (_tmp41_, track->rating * 20);
	_tmp42_ = rv;
	music_media_set_play_count (_tmp42_, track->playcount);
	_tmp43_ = rv;
	music_media_set_bpm (_tmp43_, (guint) track->BPM);
	_tmp44_ = rv;
	music_media_set_skip_count (_tmp44_, track->skipcount);
	_tmp45_ = rv;
	music_media_set_length (_tmp45_, (guint) track->tracklen);
	_tmp46_ = rv;
	music_media_set_file_size (_tmp46_, (guint64) track->size);
	_tmp47_ = rv;
	music_media_set_resume_pos (_tmp47_, (gint) track->bookmark_time);
	_tmp49_ = rv;
	_tmp50_ = music_media_get_artist (_tmp49_);
	_tmp51_ = _tmp50_;
	if (g_strcmp0 (_tmp51_, "") == 0) {
		MusicMedia* _tmp52_;
		const gchar* _tmp53_;
		const gchar* _tmp54_;
		_tmp52_ = rv;
		_tmp53_ = music_media_get_album_artist (_tmp52_);
		_tmp54_ = _tmp53_;
		_tmp48_ = g_strcmp0 (_tmp54_, "") != 0;
	} else {
		_tmp48_ = FALSE;
	}
	if (_tmp48_) {
		MusicMedia* _tmp55_;
		MusicMedia* _tmp56_;
		const gchar* _tmp57_;
		const gchar* _tmp58_;
		_tmp55_ = rv;
		_tmp56_ = rv;
		_tmp57_ = music_media_get_album_artist (_tmp56_);
		_tmp58_ = _tmp57_;
		music_media_set_artist (_tmp55_, _tmp58_);
	} else {
		gboolean _tmp59_ = FALSE;
		MusicMedia* _tmp60_;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
		_tmp60_ = rv;
		_tmp61_ = music_media_get_album_artist (_tmp60_);
		_tmp62_ = _tmp61_;
		if (g_strcmp0 (_tmp62_, "") == 0) {
			MusicMedia* _tmp63_;
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			_tmp63_ = rv;
			_tmp64_ = music_media_get_artist (_tmp63_);
			_tmp65_ = _tmp64_;
			_tmp59_ = g_strcmp0 (_tmp65_, "") != 0;
		} else {
			_tmp59_ = FALSE;
		}
		if (_tmp59_) {
			MusicMedia* _tmp66_;
			MusicMedia* _tmp67_;
			const gchar* _tmp68_;
			const gchar* _tmp69_;
			_tmp66_ = rv;
			_tmp67_ = rv;
			_tmp68_ = music_media_get_artist (_tmp67_);
			_tmp69_ = _tmp68_;
			music_media_set_album_artist (_tmp66_, _tmp69_);
		}
	}
	result = rv;
	return result;
}

void
music_plugins_ipod_media_helper_update_track (Itdb_Track** t,
                                              MusicMedia* m)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	guint _tmp24_;
	guint _tmp25_;
	guint _tmp26_;
	guint _tmp27_;
	guint _tmp28_;
	guint _tmp29_;
	guint _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	guint _tmp33_;
	guint _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	guint _tmp49_;
	guint64 _tmp50_;
	guint64 _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	gint _tmp55_ = 0;
	guint _tmp56_;
	guint _tmp57_;
	gint _tmp58_;
	gint _tmp59_;
	gboolean _tmp60_ = FALSE;
	const gchar* _tmp61_;
	g_return_if_fail (*t != NULL);
	g_return_if_fail (m != NULL);
	if ((*t) == NULL) {
		return;
	}
	_tmp0_ = music_media_get_display_title (m);
	_g_free0 ((*t)->title);
	(*t)->title = _tmp0_;
	_tmp1_ = music_media_get_artist (m);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*t)->artist);
	(*t)->artist = _tmp3_;
	_tmp4_ = music_media_get_album_artist (m);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 ((*t)->albumartist);
	(*t)->albumartist = _tmp6_;
	_tmp7_ = music_media_get_album (m);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strdup (_tmp8_);
	_g_free0 ((*t)->album);
	(*t)->album = _tmp9_;
	_tmp10_ = music_media_get_genre (m);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strdup (_tmp11_);
	_g_free0 ((*t)->genre);
	(*t)->genre = _tmp12_;
	_tmp13_ = music_media_get_comment (m);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_strdup (_tmp14_);
	_g_free0 ((*t)->comment);
	(*t)->comment = _tmp15_;
	_tmp16_ = music_media_get_composer (m);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_strdup (_tmp17_);
	_g_free0 ((*t)->composer);
	(*t)->composer = _tmp18_;
	_tmp19_ = music_media_get_grouping (m);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strdup (_tmp20_);
	_g_free0 ((*t)->grouping);
	(*t)->grouping = _tmp21_;
	_tmp22_ = music_media_get_album_number (m);
	_tmp23_ = _tmp22_;
	(*t)->cd_nr = (gint) _tmp23_;
	_tmp24_ = music_media_get_album_count (m);
	_tmp25_ = _tmp24_;
	(*t)->cds = (gint) _tmp25_;
	_tmp26_ = music_media_get_track (m);
	_tmp27_ = _tmp26_;
	(*t)->track_nr = (gint) _tmp27_;
	_tmp28_ = music_media_get_track_count (m);
	_tmp29_ = _tmp28_;
	(*t)->tracks = (gint) _tmp29_;
	_tmp30_ = music_media_get_bitrate (m);
	_tmp31_ = _tmp30_;
	(*t)->bitrate = (gint) _tmp31_;
	_tmp32_ = music_media_get_year (m);
	_tmp33_ = _tmp32_;
	(*t)->year = (gint) _tmp33_;
	_tmp34_ = music_media_get_last_modified (m);
	_tmp35_ = _tmp34_;
	(*t)->time_modified = (time_t) _tmp35_;
	_tmp36_ = music_media_get_last_played (m);
	_tmp37_ = _tmp36_;
	(*t)->time_played = (time_t) _tmp37_;
	_tmp38_ = music_media_get_rating (m);
	_tmp39_ = _tmp38_;
	(*t)->rating = _tmp39_ * 20;
	_tmp40_ = music_media_get_play_count (m);
	_tmp41_ = _tmp40_;
	(*t)->playcount = _tmp41_;
	_tmp42_ = music_media_get_play_count (m);
	_tmp43_ = _tmp42_;
	(*t)->recent_playcount = _tmp43_;
	_tmp44_ = music_media_get_bpm (m);
	_tmp45_ = _tmp44_;
	(*t)->BPM = (guint16) _tmp45_;
	_tmp46_ = music_media_get_skip_count (m);
	_tmp47_ = _tmp46_;
	(*t)->skipcount = _tmp47_;
	_tmp48_ = music_media_get_length (m);
	_tmp49_ = _tmp48_;
	(*t)->tracklen = (gint) _tmp49_;
	_tmp50_ = music_media_get_file_size (m);
	_tmp51_ = _tmp50_;
	(*t)->size = (guint32) ((guint) _tmp51_);
	(*t)->mediatype = (guint) ITDB_MEDIATYPE_AUDIO;
	(*t)->lyrics_flag = (guint8) 1;
	_tmp52_ = music_media_get_lyrics (m);
	_tmp53_ = _tmp52_;
	_tmp54_ = g_strdup (_tmp53_);
	_g_free0 ((*t)->description);
	(*t)->description = _tmp54_;
	_tmp56_ = music_media_get_play_count (m);
	_tmp57_ = _tmp56_;
	if (_tmp57_ == ((guint) 0)) {
		_tmp55_ = 1;
	} else {
		_tmp55_ = 0;
	}
	(*t)->mark_unplayed = (guint8) _tmp55_;
	_tmp58_ = music_media_get_resume_pos (m);
	_tmp59_ = _tmp58_;
	(*t)->bookmark_time = (guint) _tmp59_;
	_tmp61_ = (*t)->artist;
	if (g_strcmp0 (_tmp61_, "") == 0) {
		gboolean _tmp62_ = FALSE;
		const gchar* _tmp63_;
		_tmp63_ = (*t)->albumartist;
		if (g_strcmp0 (_tmp63_, "") != 0) {
			_tmp62_ = TRUE;
		} else {
			const gchar* _tmp64_;
			_tmp64_ = (*t)->albumartist;
			_tmp62_ = _tmp64_ != NULL;
		}
		_tmp60_ = _tmp62_;
	} else {
		_tmp60_ = FALSE;
	}
	if (_tmp60_) {
		const gchar* _tmp65_;
		gchar* _tmp66_;
		_tmp65_ = (*t)->albumartist;
		_tmp66_ = g_strdup (_tmp65_);
		_g_free0 ((*t)->artist);
		(*t)->artist = _tmp66_;
	} else {
		gboolean _tmp67_ = FALSE;
		const gchar* _tmp68_;
		_tmp68_ = (*t)->albumartist;
		if (g_strcmp0 (_tmp68_, "") == 0) {
			gboolean _tmp69_ = FALSE;
			const gchar* _tmp70_;
			_tmp70_ = (*t)->artist;
			if (g_strcmp0 (_tmp70_, "") != 0) {
				_tmp69_ = TRUE;
			} else {
				const gchar* _tmp71_;
				_tmp71_ = (*t)->artist;
				_tmp69_ = _tmp71_ != NULL;
			}
			_tmp67_ = _tmp69_;
		} else {
			_tmp67_ = FALSE;
		}
		if (_tmp67_) {
			const gchar* _tmp72_;
			gchar* _tmp73_;
			_tmp72_ = (*t)->artist;
			_tmp73_ = g_strdup (_tmp72_);
			_g_free0 ((*t)->albumartist);
			(*t)->albumartist = _tmp73_;
		}
	}
}

/**
     * caller *must* set ipod_path
     */
Itdb_Track*
music_plugins_ipod_media_helper_track_from_media (MusicMedia* m)
{
	Itdb_Track* t = NULL;
	Itdb_Track* _tmp0_;
	Itdb_Track* tu = NULL;
	Itdb_Track* result;
	g_return_val_if_fail (m != NULL, NULL);
	_tmp0_ = itdb_track_new ();
	t = _tmp0_;
	tu = t;
	music_plugins_ipod_media_helper_update_track (&tu, m);
	result = t;
	return result;
}

MusicPluginsiPodMediaHelper*
music_plugins_ipod_media_helper_construct (GType object_type)
{
	MusicPluginsiPodMediaHelper* self = NULL;
	self = (MusicPluginsiPodMediaHelper*) g_type_create_instance (object_type);
	return self;
}

MusicPluginsiPodMediaHelper*
music_plugins_ipod_media_helper_new (void)
{
	return music_plugins_ipod_media_helper_construct (MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER);
}

static void
music_plugins_value_ipod_media_helper_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
music_plugins_value_ipod_media_helper_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		music_plugins_ipod_media_helper_unref (value->data[0].v_pointer);
	}
}

static void
music_plugins_value_ipod_media_helper_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = music_plugins_ipod_media_helper_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
music_plugins_value_ipod_media_helper_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
music_plugins_value_ipod_media_helper_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		MusicPluginsiPodMediaHelper * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = music_plugins_ipod_media_helper_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
music_plugins_value_ipod_media_helper_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	MusicPluginsiPodMediaHelper ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = music_plugins_ipod_media_helper_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
music_plugins_param_spec_ipod_media_helper (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	MusicPluginsParamSpeciPodMediaHelper* spec;
	g_return_val_if_fail (g_type_is_a (object_type, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
music_plugins_value_get_ipod_media_helper (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER), NULL);
	return value->data[0].v_pointer;
}

void
music_plugins_value_set_ipod_media_helper (GValue* value,
                                           gpointer v_object)
{
	MusicPluginsiPodMediaHelper * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		music_plugins_ipod_media_helper_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		music_plugins_ipod_media_helper_unref (old);
	}
}

void
music_plugins_value_take_ipod_media_helper (GValue* value,
                                            gpointer v_object)
{
	MusicPluginsiPodMediaHelper * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		music_plugins_ipod_media_helper_unref (old);
	}
}

static void
music_plugins_ipod_media_helper_class_init (MusicPluginsiPodMediaHelperClass * klass,
                                            gpointer klass_data)
{
	music_plugins_ipod_media_helper_parent_class = g_type_class_peek_parent (klass);
	((MusicPluginsiPodMediaHelperClass *) klass)->finalize = music_plugins_ipod_media_helper_finalize;
}

static void
music_plugins_ipod_media_helper_instance_init (MusicPluginsiPodMediaHelper * self,
                                               gpointer klass)
{
	self->ref_count = 1;
}

static void
music_plugins_ipod_media_helper_finalize (MusicPluginsiPodMediaHelper * obj)
{
	MusicPluginsiPodMediaHelper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_MEDIA_HELPER, MusicPluginsiPodMediaHelper);
	g_signal_handlers_destroy (self);
}

GType
music_plugins_ipod_media_helper_get_type (void)
{
	return music_plugins_ipod_media_helper_type_id;
}

GType
music_plugins_ipod_media_helper_register_type (GTypeModule * module)
{
	static const GTypeValueTable g_define_type_value_table = { music_plugins_value_ipod_media_helper_init, music_plugins_value_ipod_media_helper_free_value, music_plugins_value_ipod_media_helper_copy_value, music_plugins_value_ipod_media_helper_peek_pointer, "p", music_plugins_value_ipod_media_helper_collect_value, "p", music_plugins_value_ipod_media_helper_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodMediaHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_media_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodMediaHelper), 0, (GInstanceInitFunc) music_plugins_ipod_media_helper_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	music_plugins_ipod_media_helper_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MusicPluginsiPodMediaHelper", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return music_plugins_ipod_media_helper_type_id;
}

gpointer
music_plugins_ipod_media_helper_ref (gpointer instance)
{
	MusicPluginsiPodMediaHelper * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
music_plugins_ipod_media_helper_unref (gpointer instance)
{
	MusicPluginsiPodMediaHelper * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		MUSIC_PLUGINS_IPOD_MEDIA_HELPER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

