/* LibraryWindow.c generated by valac 0.55.1, the Vala compiler
 * generated from LibraryWindow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <handy.h>
#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <granite.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <libgda/libgda.h>
#include <float.h>
#include <math.h>
#include <gst/gst.h>
#include <time.h>

#define MUSIC_LIBRARY_WINDOW_ACTION_PREFIX "win."
#define MUSIC_LIBRARY_WINDOW_ACTION_IMPORT "action_import"
#define MUSIC_LIBRARY_WINDOW_ACTION_PLAY "action_play"
#define MUSIC_LIBRARY_WINDOW_ACTION_PLAY_NEXT "action_play_next"
#define MUSIC_LIBRARY_WINDOW_ACTION_PLAY_PREVIOUS "action_play_previous"
#define MUSIC_LIBRARY_WINDOW_ACTION_QUIT "action_quit"
#define MUSIC_LIBRARY_WINDOW_ACTION_SEARCH "action_search"
#define MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS "action_view_albums"
#define MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS "action_view_columns"
#define MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST "action_view_list"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;
typedef struct _MusicLibraryWindowPrivate MusicLibraryWindowPrivate;

#define MUSIC_TYPE_VIEW_WRAPPER (music_view_wrapper_get_type ())
#define MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper))
#define MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))
#define MUSIC_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))

typedef struct _MusicViewWrapper MusicViewWrapper;
typedef struct _MusicViewWrapperClass MusicViewWrapperClass;

#define MUSIC_TYPE_SOURCE_LIST_VIEW (music_source_list_view_get_type ())
#define MUSIC_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_SOURCE_LIST_VIEW, MusicSourceListView))
#define MUSIC_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_SOURCE_LIST_VIEW, MusicSourceListViewClass))
#define MUSIC_IS_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_SOURCE_LIST_VIEW))
#define MUSIC_IS_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_SOURCE_LIST_VIEW))
#define MUSIC_SOURCE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_SOURCE_LIST_VIEW, MusicSourceListViewClass))

typedef struct _MusicSourceListView MusicSourceListView;
typedef struct _MusicSourceListViewClass MusicSourceListViewClass;

#define MUSIC_TYPE_VIEW_STACK (music_view_stack_get_type ())
#define MUSIC_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_STACK, MusicViewStack))
#define MUSIC_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_STACK, MusicViewStackClass))
#define MUSIC_IS_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_STACK))
#define MUSIC_IS_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_STACK))
#define MUSIC_VIEW_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_STACK, MusicViewStackClass))

typedef struct _MusicViewStack MusicViewStack;
typedef struct _MusicViewStackClass MusicViewStackClass;

#define MUSIC_WIDGETS_TYPE_VIEW_SELECTOR (music_widgets_view_selector_get_type ())
#define MUSIC_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector))
#define MUSIC_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelectorClass))
#define MUSIC_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR))
#define MUSIC_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR))
#define MUSIC_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelectorClass))

typedef struct _MusicWidgetsViewSelector MusicWidgetsViewSelector;
typedef struct _MusicWidgetsViewSelectorClass MusicWidgetsViewSelectorClass;

#define MUSIC_WIDGETS_TYPE_STATUS_BAR (music_widgets_status_bar_get_type ())
#define MUSIC_WIDGETS_STATUS_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_WIDGETS_TYPE_STATUS_BAR, MusicWidgetsStatusBar))
#define MUSIC_WIDGETS_STATUS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_WIDGETS_TYPE_STATUS_BAR, MusicWidgetsStatusBarClass))
#define MUSIC_WIDGETS_IS_STATUS_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_WIDGETS_TYPE_STATUS_BAR))
#define MUSIC_WIDGETS_IS_STATUS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_WIDGETS_TYPE_STATUS_BAR))
#define MUSIC_WIDGETS_STATUS_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_WIDGETS_TYPE_STATUS_BAR, MusicWidgetsStatusBarClass))

typedef struct _MusicWidgetsStatusBar MusicWidgetsStatusBar;
typedef struct _MusicWidgetsStatusBarClass MusicWidgetsStatusBarClass;

#define MUSIC_TYPE_PREFERENCES_WINDOW (music_preferences_window_get_type ())
#define MUSIC_PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PREFERENCES_WINDOW, MusicPreferencesWindow))
#define MUSIC_PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PREFERENCES_WINDOW, MusicPreferencesWindowClass))
#define MUSIC_IS_PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PREFERENCES_WINDOW))
#define MUSIC_IS_PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PREFERENCES_WINDOW))
#define MUSIC_PREFERENCES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PREFERENCES_WINDOW, MusicPreferencesWindowClass))

typedef struct _MusicPreferencesWindow MusicPreferencesWindow;
typedef struct _MusicPreferencesWindowClass MusicPreferencesWindowClass;

#define MUSIC_TYPE_TOP_DISPLAY (music_top_display_get_type ())
#define MUSIC_TOP_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_TOP_DISPLAY, MusicTopDisplay))
#define MUSIC_TOP_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_TOP_DISPLAY, MusicTopDisplayClass))
#define MUSIC_IS_TOP_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_TOP_DISPLAY))
#define MUSIC_IS_TOP_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_TOP_DISPLAY))
#define MUSIC_TOP_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_TOP_DISPLAY, MusicTopDisplayClass))

typedef struct _MusicTopDisplay MusicTopDisplay;
typedef struct _MusicTopDisplayClass MusicTopDisplayClass;

#define MUSIC_TYPE_DEVICE_VIEW (music_device_view_get_type ())
#define MUSIC_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView))
#define MUSIC_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_VIEW, MusicDeviceViewClass))
#define MUSIC_IS_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_VIEW))
#define MUSIC_IS_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_VIEW))
#define MUSIC_DEVICE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_VIEW, MusicDeviceViewClass))

typedef struct _MusicDeviceView MusicDeviceView;
typedef struct _MusicDeviceViewClass MusicDeviceViewClass;

#define MUSIC_TYPE_SOURCE_LIST_ENTRY (music_source_list_entry_get_type ())
#define MUSIC_SOURCE_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_SOURCE_LIST_ENTRY, MusicSourceListEntry))
#define MUSIC_IS_SOURCE_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_SOURCE_LIST_ENTRY))
#define MUSIC_SOURCE_LIST_ENTRY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), MUSIC_TYPE_SOURCE_LIST_ENTRY, MusicSourceListEntryIface))

typedef struct _MusicSourceListEntry MusicSourceListEntry;
typedef struct _MusicSourceListEntryIface MusicSourceListEntryIface;
enum  {
	MUSIC_LIBRARY_WINDOW_0_PROPERTY,
	MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY,
	MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY,
	MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY,
	MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY,
	MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY,
	MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY,
	MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY,
	MUSIC_LIBRARY_WINDOW_LIBRARY_MANAGER_PROPERTY,
	MUSIC_LIBRARY_WINDOW_NUM_PROPERTIES
};
static GParamSpec* music_library_window_properties[MUSIC_LIBRARY_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;

#define MUSIC_TYPE_LOCAL_LIBRARY (music_local_library_get_type ())
#define MUSIC_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary))
#define MUSIC_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))
#define MUSIC_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_LIBRARY))
#define MUSIC_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibraryClass))

typedef struct _MusicLocalLibrary MusicLocalLibrary;
typedef struct _MusicLocalLibraryClass MusicLocalLibraryClass;

#define MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER (music_playlist_view_wrapper_get_type ())
#define MUSIC_PLAYLIST_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper))
#define MUSIC_PLAYLIST_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapperClass))
#define MUSIC_IS_PLAYLIST_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER))
#define MUSIC_IS_PLAYLIST_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER))
#define MUSIC_PLAYLIST_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapperClass))

typedef struct _MusicPlaylistViewWrapper MusicPlaylistViewWrapper;
typedef struct _MusicPlaylistViewWrapperClass MusicPlaylistViewWrapperClass;
typedef enum  {
	MUSIC_VIEW_WRAPPER_HINT_NONE,
	MUSIC_VIEW_WRAPPER_HINT_MUSIC,
	MUSIC_VIEW_WRAPPER_HINT_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_CDROM,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST,
	MUSIC_VIEW_WRAPPER_HINT_QUEUE
} MusicViewWrapperHint;

#define MUSIC_VIEW_WRAPPER_TYPE_HINT (music_view_wrapper_hint_get_type ())

#define MUSIC_TYPE_DEVICE_VIEW_WRAPPER (music_device_view_wrapper_get_type ())
#define MUSIC_DEVICE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper))
#define MUSIC_DEVICE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapperClass))
#define MUSIC_IS_DEVICE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER))
#define MUSIC_IS_DEVICE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_VIEW_WRAPPER))
#define MUSIC_DEVICE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapperClass))

typedef struct _MusicDeviceViewWrapper MusicDeviceViewWrapper;
typedef struct _MusicDeviceViewWrapperClass MusicDeviceViewWrapperClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} MusicWidgetsViewSelectorMode;

#define MUSIC_WIDGETS_VIEW_SELECTOR_TYPE_MODE (music_widgets_view_selector_mode_get_type ())

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _MusicLocalLibraryPrivate MusicLocalLibraryPrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _MusicLibraryWindowShowNotificationFromMediaAsyncData MusicLibraryWindowShowNotificationFromMediaAsyncData;
typedef struct _MusicLibraryWindowNotifyCurrentMediaAsyncData MusicLibraryWindowNotifyCurrentMediaAsyncData;

#define MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM (music_source_list_expandable_item_get_type ())
#define MUSIC_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem))
#define MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItemClass))
#define MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM))
#define MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM))
#define MUSIC_SOURCE_LIST_EXPANDABLE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItemClass))

typedef struct _MusicSourceListExpandableItem MusicSourceListExpandableItem;
typedef struct _MusicSourceListExpandableItemClass MusicSourceListExpandableItemClass;
typedef struct _MusicPlaybackManagerPrivate MusicPlaybackManagerPrivate;

#define MUSIC_TYPE_HISTORY_PLAYLIST (music_history_playlist_get_type ())
#define MUSIC_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylist))
#define MUSIC_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))
#define MUSIC_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_HISTORY_PLAYLIST))
#define MUSIC_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_HISTORY_PLAYLIST, MusicHistoryPlaylistClass))

typedef struct _MusicHistoryPlaylist MusicHistoryPlaylist;
typedef struct _MusicHistoryPlaylistClass MusicHistoryPlaylistClass;

#define MUSIC_TYPE_STREAMER (music_streamer_get_type ())
#define MUSIC_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_STREAMER, MusicStreamer))
#define MUSIC_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_STREAMER, MusicStreamerClass))
#define MUSIC_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_STREAMER))
#define MUSIC_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_STREAMER))
#define MUSIC_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_STREAMER, MusicStreamerClass))

typedef struct _MusicStreamer MusicStreamer;
typedef struct _MusicStreamerClass MusicStreamerClass;

#define MUSIC_TYPE_TREE_VIEW_SETUP (music_tree_view_setup_get_type ())
#define MUSIC_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetup))
#define MUSIC_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetupClass))
#define MUSIC_IS_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_TREE_VIEW_SETUP))
#define MUSIC_IS_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_TREE_VIEW_SETUP))
#define MUSIC_TREE_VIEW_SETUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_TREE_VIEW_SETUP, MusicTreeViewSetupClass))

typedef struct _MusicTreeViewSetup MusicTreeViewSetup;
typedef struct _MusicTreeViewSetupClass MusicTreeViewSetupClass;

#define MUSIC_TYPE_MUSIC_VIEW_WRAPPER (music_music_view_wrapper_get_type ())
#define MUSIC_MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MUSIC_VIEW_WRAPPER, MusicMusicViewWrapper))
#define MUSIC_MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MUSIC_VIEW_WRAPPER, MusicMusicViewWrapperClass))
#define MUSIC_IS_MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MUSIC_VIEW_WRAPPER))
#define MUSIC_IS_MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MUSIC_VIEW_WRAPPER))
#define MUSIC_MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MUSIC_VIEW_WRAPPER, MusicMusicViewWrapperClass))

typedef struct _MusicMusicViewWrapper MusicMusicViewWrapper;
typedef struct _MusicMusicViewWrapperClass MusicMusicViewWrapperClass;
typedef struct _Block4Data Block4Data;
typedef struct _MusicLibraryWindowUpdateSensitivitiesData MusicLibraryWindowUpdateSensitivitiesData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;

#define MUSIC_TYPE_DEVICE_PREFERENCES (music_device_preferences_get_type ())
#define MUSIC_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferences))
#define MUSIC_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferencesClass))
#define MUSIC_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_PREFERENCES))
#define MUSIC_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_PREFERENCES))
#define MUSIC_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferencesClass))

typedef struct _MusicDevicePreferences MusicDevicePreferences;
typedef struct _MusicDevicePreferencesClass MusicDevicePreferencesClass;
typedef struct _Block7Data Block7Data;

#define MUSIC_TYPE_LOCAL_STATIC_PLAYLIST (music_local_static_playlist_get_type ())
#define MUSIC_LOCAL_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylist))
#define MUSIC_LOCAL_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylistClass))
#define MUSIC_IS_LOCAL_STATIC_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST))
#define MUSIC_IS_LOCAL_STATIC_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST))
#define MUSIC_LOCAL_STATIC_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_STATIC_PLAYLIST, MusicLocalStaticPlaylistClass))

typedef struct _MusicLocalStaticPlaylist MusicLocalStaticPlaylist;
typedef struct _MusicLocalStaticPlaylistClass MusicLocalStaticPlaylistClass;
typedef struct _Block8Data Block8Data;

#define MUSIC_TYPE_LOCAL_SMART_PLAYLIST (music_local_smart_playlist_get_type ())
#define MUSIC_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylist))
#define MUSIC_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylistClass))
#define MUSIC_IS_LOCAL_SMART_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST))
#define MUSIC_IS_LOCAL_SMART_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LOCAL_SMART_PLAYLIST))
#define MUSIC_LOCAL_SMART_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LOCAL_SMART_PLAYLIST, MusicLocalSmartPlaylistClass))

typedef struct _MusicLocalSmartPlaylist MusicLocalSmartPlaylist;
typedef struct _MusicLocalSmartPlaylistClass MusicLocalSmartPlaylistClass;

#define MUSIC_TYPE_SMART_PLAYLIST_EDITOR (music_smart_playlist_editor_get_type ())
#define MUSIC_SMART_PLAYLIST_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_SMART_PLAYLIST_EDITOR, MusicSmartPlaylistEditor))
#define MUSIC_SMART_PLAYLIST_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_SMART_PLAYLIST_EDITOR, MusicSmartPlaylistEditorClass))
#define MUSIC_IS_SMART_PLAYLIST_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_SMART_PLAYLIST_EDITOR))
#define MUSIC_IS_SMART_PLAYLIST_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_SMART_PLAYLIST_EDITOR))
#define MUSIC_SMART_PLAYLIST_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_SMART_PLAYLIST_EDITOR, MusicSmartPlaylistEditorClass))

typedef struct _MusicSmartPlaylistEditor MusicSmartPlaylistEditor;
typedef struct _MusicSmartPlaylistEditorClass MusicSmartPlaylistEditorClass;
typedef struct _Block9Data Block9Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block10Data Block10Data;

#define MUSIC_TYPE_SET_MUSIC_FOLDER_CONFIRMATION (music_set_music_folder_confirmation_get_type ())
#define MUSIC_SET_MUSIC_FOLDER_CONFIRMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_SET_MUSIC_FOLDER_CONFIRMATION, MusicSetMusicFolderConfirmation))
#define MUSIC_SET_MUSIC_FOLDER_CONFIRMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_SET_MUSIC_FOLDER_CONFIRMATION, MusicSetMusicFolderConfirmationClass))
#define MUSIC_IS_SET_MUSIC_FOLDER_CONFIRMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_SET_MUSIC_FOLDER_CONFIRMATION))
#define MUSIC_IS_SET_MUSIC_FOLDER_CONFIRMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_SET_MUSIC_FOLDER_CONFIRMATION))
#define MUSIC_SET_MUSIC_FOLDER_CONFIRMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_SET_MUSIC_FOLDER_CONFIRMATION, MusicSetMusicFolderConfirmationClass))

typedef struct _MusicSetMusicFolderConfirmation MusicSetMusicFolderConfirmation;
typedef struct _MusicSetMusicFolderConfirmationClass MusicSetMusicFolderConfirmationClass;
typedef struct _MusicStreamerPrivate MusicStreamerPrivate;
enum  {
	MUSIC_LIBRARY_WINDOW_PLAY_PAUSE_CHANGED_SIGNAL,
	MUSIC_LIBRARY_WINDOW_NUM_SIGNALS
};
static guint music_library_window_signals[MUSIC_LIBRARY_WINDOW_NUM_SIGNALS] = {0};

struct _MusicLibraryWindow {
	HdyApplicationWindow parent_instance;
	MusicLibraryWindowPrivate * priv;
	GeeHashMap* match_playlists;
};

struct _MusicLibraryWindowClass {
	HdyApplicationWindowClass parent_class;
	void (*playback_stopped) (MusicLibraryWindow* self, gint64 was_playing);
	void (*play_media) (MusicLibraryWindow* self, gboolean inhibit_notifications);
	void (*play_next_media) (MusicLibraryWindow* self, gboolean inhibit_notifications);
	void (*play_previous_media) (MusicLibraryWindow* self, gboolean inhibit_notifications);
	void (*action_import) (MusicLibraryWindow* self);
	void (*end_of_stream) (MusicLibraryWindow* self);
	void (*error_occured) (MusicLibraryWindow* self);
	void (*current_position_update) (MusicLibraryWindow* self, gint64 position);
	void (*drag_received) (MusicLibraryWindow* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* data, guint info, guint timestamp);
};

struct _MusicSourceListEntryIface {
	GTypeInterface parent_iface;
};

struct _MusicLibraryWindowPrivate {
	gboolean _initialization_finished;
	gboolean _newly_created_playlist;
	MusicSourceListView* _source_list_view;
	MusicViewStack* _view_stack;
	MusicWidgetsViewSelector* _view_selector;
	GtkSearchEntry* _search_entry;
	MusicWidgetsStatusBar* _statusbar;
	gboolean _media_considered_played;
	gboolean _added_to_play_count;
	gboolean _media_considered_previewed;
	gboolean _media_half_played_sended;
	gboolean _search_field_has_focus;
	guint configure_id;
	GCancellable* notification_cancellable;
	MusicPreferencesWindow* preferences;
	MusicSettingsMain* main_settings;
	MusicTopDisplay* top_display;
	GRecMutex __lock_match_playlists;
	GeeHashMap* match_devices;
	GRecMutex __lock_match_devices;
	GeeHashMap* match_playlist_entry;
	gboolean update_sensitivities_pending;
};

struct _Block3Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	GtkButton* play_button;
};

struct _MusicLocalLibrary {
	MusicLibrary parent_instance;
	MusicLocalLibraryPrivate * priv;
	MusicStaticPlaylist* p_music;
};

struct _MusicLocalLibraryClass {
	MusicLibraryClass parent_class;
};

struct _MusicLibraryWindowShowNotificationFromMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLibraryWindow* self;
	MusicMedia* media;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	gchar* primary_text;
	gchar* _tmp3_;
	GString* secondary_text;
	GString* _tmp4_;
	GString* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GString* _tmp8_;
	GString* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GCancellable* _tmp12_;
	const gchar* _tmp13_;
	GString* _tmp14_;
	const gchar* _tmp15_;
	MusicAlbum* _tmp16_;
	MusicAlbum* _tmp17_;
	GIcon* _tmp18_;
	GIcon* _tmp19_;
};

struct _MusicLibraryWindowNotifyCurrentMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLibraryWindow* self;
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicMedia* _tmp6_;
	MusicMedia* _tmp7_;
};

struct _MusicPlaybackManager {
	GObject parent_instance;
	MusicPlaybackManagerPrivate * priv;
	MusicStaticPlaylist* queue_playlist;
	MusicHistoryPlaylist* history_playlist;
	MusicStreamer* file_player;
	MusicPlayback* player;
};

struct _MusicPlaybackManagerClass {
	GObjectClass parent_class;
};

struct _Block4Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicPlaylist* p;
};

struct _MusicLibraryWindowUpdateSensitivitiesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLibraryWindow* self;
};

struct _Block5Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicDevice* d;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	MusicSourceListEntry* entry;
};

struct _Block7Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicSourceListEntry* entry;
};

struct _Block8Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicPlaylistViewWrapper* view;
	MusicSmartPlaylist* p;
};

struct _Block9Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	MusicMedia* m;
};

struct _Block10Data {
	int _ref_count_;
	MusicLibraryWindow* self;
	gchar* folder;
};

struct _MusicStreamer {
	GObject parent_instance;
	MusicStreamerPrivate * priv;
	GstElement* cdda;
	gboolean set_resume_pos;
};

struct _MusicStreamerClass {
	GObjectClass parent_class;
};

static gint MusicLibraryWindow_private_offset;
static gpointer music_library_window_parent_class = NULL;
static MusicLibraryWindowInterfaceIface * music_library_window_music_library_window_interface_parent_iface = NULL;

VALA_EXTERN GType music_library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
VALA_EXTERN GType music_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewWrapper, g_object_unref)
VALA_EXTERN GType music_source_list_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicSourceListView, g_object_unref)
VALA_EXTERN GType music_view_stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewStack, g_object_unref)
VALA_EXTERN GType music_widgets_view_selector_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicWidgetsViewSelector, g_object_unref)
VALA_EXTERN GType music_widgets_status_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicWidgetsStatusBar, g_object_unref)
VALA_EXTERN GType music_preferences_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPreferencesWindow, g_object_unref)
VALA_EXTERN GType music_top_display_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicTopDisplay, g_object_unref)
VALA_EXTERN GType music_device_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicDeviceView, g_object_unref)
VALA_EXTERN GType music_source_list_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void music_library_window_playback_stopped (MusicLibraryWindow* self,
                                            gint64 was_playing);
VALA_EXTERN void music_library_window_play_media (MusicLibraryWindow* self,
                                      gboolean inhibit_notifications);
VALA_EXTERN void music_library_window_play_next_media (MusicLibraryWindow* self,
                                           gboolean inhibit_notifications);
VALA_EXTERN void music_library_window_play_previous_media (MusicLibraryWindow* self,
                                               gboolean inhibit_notifications);
VALA_EXTERN void music_library_window_action_import (MusicLibraryWindow* self);
VALA_EXTERN void music_library_window_end_of_stream (MusicLibraryWindow* self);
VALA_EXTERN void music_library_window_error_occured (MusicLibraryWindow* self);
VALA_EXTERN void music_library_window_current_position_update (MusicLibraryWindow* self,
                                                   gint64 position);
VALA_EXTERN void music_library_window_drag_received (MusicLibraryWindow* self,
                                         GdkDragContext* context,
                                         gint x,
                                         gint y,
                                         GtkSelectionData* data,
                                         guint info,
                                         guint timestamp);
static void _music_library_window_action_import_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void music_library_window_action_play (MusicLibraryWindow* self);
static void _music_library_window_action_play_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void music_library_window_action_play_next (MusicLibraryWindow* self);
static void _music_library_window_action_play_next_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void music_library_window_action_play_previous (MusicLibraryWindow* self);
static void _music_library_window_action_play_previous_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void music_library_window_action_quit (MusicLibraryWindow* self);
static void _music_library_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void music_library_window_action_search (MusicLibraryWindow* self);
static void _music_library_window_action_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void music_library_window_action_view_albums (MusicLibraryWindow* self);
static void _music_library_window_action_view_albums_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void music_library_window_action_view_columns (MusicLibraryWindow* self);
static void _music_library_window_action_view_columns_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void music_library_window_action_view_list (MusicLibraryWindow* self);
static void _music_library_window_action_view_list_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
VALA_EXTERN MusicLibraryWindow* music_library_window_new (GtkApplication* application);
VALA_EXTERN MusicLibraryWindow* music_library_window_construct (GType object_type,
                                                    GtkApplication* application);
static gboolean music_library_window_real_key_press_event (GtkWidget* base,
                                                    GdkEventKey* event);
static gboolean music_library_window_get_search_field_has_focus (MusicLibraryWindow* self);
VALA_EXTERN GtkSearchEntry* music_library_window_get_search_entry (MusicLibraryWindow* self);
VALA_EXTERN MusicSourceListView* music_library_window_get_source_list_view (MusicLibraryWindow* self);
static gboolean _vala_unichar_array_contains (gunichar * stack,
                                       gssize stack_length,
                                       const gunichar needle);
VALA_EXTERN void music_library_window_build_ui (MusicLibraryWindow* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN GSettings* music_app_get_saved_state (void);
static void music_library_window_on_quit (MusicLibraryWindow* self);
static void _music_library_window_on_quit_gtk_widget_destroy (GtkWidget* _sender,
                                                       gpointer self);
static void music_library_window_edit_preferences_click (MusicLibraryWindow* self);
static void _music_library_window_edit_preferences_click_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                          gpointer self);
static void music_library_window_set_search_entry (MusicLibraryWindow* self,
                                            GtkSearchEntry* value);
VALA_EXTERN MusicWidgetsViewSelector* music_widgets_view_selector_new (void);
VALA_EXTERN MusicWidgetsViewSelector* music_widgets_view_selector_construct (GType object_type);
static void music_library_window_set_view_selector (MusicLibraryWindow* self,
                                             MusicWidgetsViewSelector* value);
VALA_EXTERN MusicWidgetsViewSelector* music_library_window_get_view_selector (MusicLibraryWindow* self);
VALA_EXTERN MusicTopDisplay* music_top_display_new (void);
VALA_EXTERN MusicTopDisplay* music_top_display_construct (GType object_type);
VALA_EXTERN MusicViewStack* music_view_stack_new (void);
VALA_EXTERN MusicViewStack* music_view_stack_construct (GType object_type);
static void music_library_window_set_view_stack (MusicLibraryWindow* self,
                                          MusicViewStack* value);
VALA_EXTERN MusicSourceListView* music_source_list_view_new (void);
VALA_EXTERN MusicSourceListView* music_source_list_view_construct (GType object_type);
static void music_library_window_set_source_list_view (MusicLibraryWindow* self,
                                                MusicSourceListView* value);
VALA_EXTERN MusicWidgetsStatusBar* music_widgets_status_bar_new (void);
VALA_EXTERN MusicWidgetsStatusBar* music_widgets_status_bar_construct (GType object_type);
static void music_library_window_set_statusbar (MusicLibraryWindow* self,
                                         MusicWidgetsStatusBar* value);
VALA_EXTERN MusicWidgetsStatusBar* music_library_window_get_statusbar (MusicLibraryWindow* self);
VALA_EXTERN MusicViewStack* music_library_window_get_view_stack (MusicLibraryWindow* self);
static void __lambda134_ (Block3Data* _data3_,
                   const gchar* name,
                   GVariant* new_state);
static void ___lambda134__g_action_group_action_state_changed (GActionGroup* _sender,
                                                        const gchar* action_name,
                                                        GVariant* state,
                                                        gpointer self);
VALA_EXTERN GType music_local_library_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalLibrary, g_object_unref)
VALA_EXTERN MusicLocalLibrary* music_library_window_get_library_manager (MusicLibraryWindow* self);
static void __lambda135_ (MusicLibraryWindow* self);
VALA_EXTERN void music_view_stack_hide_alert (MusicViewStack* self);
static void ___lambda135__music_library_search_finished (MusicLibrary* _sender,
                                                  gpointer self);
static void __lambda136_ (MusicLibraryWindow* self,
                   MusicLibrary* lib);
static void __lambda137_ (MusicLibraryWindow* self);
static void ___lambda137__music_library_search_finished (MusicLibrary* _sender,
                                                  gpointer self);
static void ___lambda136__music_libraries_manager_library_added (MusicLibrariesManager* _sender,
                                                          MusicLibrary* library,
                                                          gpointer self);
static void __lambda138_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda138__music_source_list_view_selection_changed (MusicSourceListView* _sender,
                                                             GtkGrid* view,
                                                             gpointer self);
static void __lambda139_ (MusicLibraryWindow* self);
static void music_library_window_set_search_field_has_focus (MusicLibraryWindow* self,
                                                      gboolean value);
static void ___lambda139__music_source_list_view_activated (MusicSourceListView* _sender,
                                                     gpointer self);
static void __lambda140_ (MusicLibraryWindow* self,
                   GtkGrid* view);
VALA_EXTERN MusicDevice* music_device_view_get_device (MusicDeviceView* self);
static void ___lambda140__music_source_list_view_item_action_activated (MusicSourceListView* _sender,
                                                                 GtkGrid* view,
                                                                 gpointer self);
static void music_library_window_playlist_name_edited (MusicLibraryWindow* self,
                                                GtkGrid* view_wrapper,
                                                const gchar* new_name);
static void _music_library_window_playlist_name_edited_music_source_list_view_edited (MusicSourceListView* _sender,
                                                                               GtkGrid* view,
                                                                               const gchar* new_name,
                                                                               gpointer self);
static void __lambda143_ (MusicLibraryWindow* self,
                   GtkGrid* view);
VALA_EXTERN GType music_playlist_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaylistViewWrapper, g_object_unref)
static void ___lambda143__music_source_list_view_playlist_rename_clicked (MusicSourceListView* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda144_ (MusicLibraryWindow* self,
                   GtkGrid* view);
VALA_EXTERN MusicPlaylist* music_view_wrapper_get_playlist (MusicViewWrapper* self);
VALA_EXTERN void music_library_window_show_smart_playlist_dialog (MusicLibraryWindow* self,
                                                      MusicSmartPlaylist* smartplaylist);
static void ___lambda144__music_source_list_view_playlist_edit_clicked (MusicSourceListView* _sender,
                                                                 GtkGrid* view,
                                                                 gpointer self);
static void __lambda145_ (MusicLibraryWindow* self,
                   GtkGrid* view);
VALA_EXTERN GType music_view_wrapper_hint_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MusicViewWrapperHint music_view_wrapper_get_hint (MusicViewWrapper* self);
VALA_EXTERN MusicLibrary* music_view_wrapper_get_library (MusicViewWrapper* self);
static void ___lambda145__music_source_list_view_playlist_remove_clicked (MusicSourceListView* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda146_ (MusicLibraryWindow* self,
                   GtkGrid* view);
VALA_EXTERN GType music_device_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicDeviceViewWrapper, g_object_unref)
VALA_EXTERN MusicDevice* music_device_view_wrapper_get_d (MusicDeviceViewWrapper* self);
static void ___lambda146__music_source_list_view_device_import_clicked (MusicSourceListView* _sender,
                                                                 GtkGrid* view,
                                                                 gpointer self);
static void __lambda147_ (MusicLibraryWindow* self,
                   GtkGrid* view);
VALA_EXTERN void music_library_window_create_new_playlist (MusicLibraryWindow* self,
                                               MusicLibrary* library);
static void ___lambda147__music_source_list_view_device_new_playlist_clicked (MusicSourceListView* _sender,
                                                                       GtkGrid* view,
                                                                       gpointer self);
static void __lambda148_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda148__music_source_list_view_device_sync_clicked (MusicSourceListView* _sender,
                                                               GtkGrid* view,
                                                               gpointer self);
static void __lambda149_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda149__music_source_list_view_device_eject_clicked (MusicSourceListView* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda150_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda150__music_source_list_view_playlist_remove_clicked (MusicSourceListView* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda151_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda151__music_source_list_view_playlist_save_clicked (MusicSourceListView* _sender,
                                                                 GtkGrid* view,
                                                                 gpointer self);
static void __lambda152_ (MusicLibraryWindow* self,
                   GtkGrid* view);
static void ___lambda152__music_source_list_view_playlist_export_clicked (MusicSourceListView* _sender,
                                                                   GtkGrid* view,
                                                                   gpointer self);
static void __lambda153_ (MusicLibraryWindow* self,
                   GtkGrid* view,
                   gchar** uris,
                   gint uris_length1);
static void ___lambda153__music_source_list_view_playlist_media_added (MusicSourceListView* _sender,
                                                                GtkGrid* view,
                                                                gchar** uris,
                                                                gint uris_length1,
                                                                gpointer self);
static void __lambda154_ (MusicLibraryWindow* self);
static void ___lambda154__music_source_list_view_playlist_import_clicked (MusicSourceListView* _sender,
                                                                   gpointer self);
static void music_library_window_load_playlists (MusicLibraryWindow* self);
static void music_library_window_update_sensitivities_sync (MusicLibraryWindow* self);
VALA_EXTERN GType music_widgets_view_selector_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void music_widgets_view_selector_set_selected (MusicWidgetsViewSelector* self,
                                               MusicWidgetsViewSelectorMode value);
VALA_EXTERN void music_local_library_rescan_music_folder (MusicLocalLibrary* self);
static void music_library_window_set_initialization_finished (MusicLibraryWindow* self,
                                                       gboolean value);
static void music_library_window_search_entry_activate (MusicLibraryWindow* self);
static void _music_library_window_search_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                                     gpointer self);
static void __lambda162_ (MusicLibraryWindow* self);
static void ___lambda162__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                    gpointer self);
VALA_EXTERN GType music_playback_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
VALA_EXTERN MusicPlaybackManager* music_app_get_player (void);
VALA_EXTERN void music_playback_manager_play_media (MusicPlaybackManager* self,
                                        MusicMedia* m);
static void music_library_window_show_playlist_view (MusicLibraryWindow* self,
                                              MusicPlaylist* p);
VALA_EXTERN void music_library_window_show_notification (MusicLibraryWindow* self,
                                             const gchar* title,
                                             const gchar* body,
                                             GIcon* icon,
                                             GNotificationPriority priority,
                                             const gchar* context);
static void music_library_window_show_notification_from_media_async_data_free (gpointer _data);
static void music_library_window_show_notification_from_media_async (MusicLibraryWindow* self,
                                                              MusicMedia* media,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static void music_library_window_show_notification_from_media_finish (MusicLibraryWindow* self,
                                                               GAsyncResult* _res_);
static gboolean music_library_window_show_notification_from_media_async_co (MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_);
static void music_library_window_notify_current_media_async_data_free (gpointer _data);
static void music_library_window_notify_current_media_async (MusicLibraryWindow* self,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void music_library_window_notify_current_media_finish (MusicLibraryWindow* self,
                                                       GAsyncResult* _res_);
static gboolean music_library_window_notify_current_media_async_co (MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_);
VALA_EXTERN MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
static void music_library_window_notify_current_media_async_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static void music_library_window_set_active_view (MusicLibraryWindow* self,
                                           MusicViewWrapper* view);
VALA_EXTERN gboolean music_library_window_get_initialization_finished (MusicLibraryWindow* self);
VALA_EXTERN void music_view_wrapper_set_as_current_view (MusicViewWrapper* self);
VALA_EXTERN GType music_source_list_expandable_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicSourceListExpandableItem, g_object_unref)
static void music_library_window_add_smartplaylist (MusicLibraryWindow* self,
                                             MusicSmartPlaylist* smartplaylist,
                                             MusicLibrary* library,
                                             MusicSourceListExpandableItem* entry);
static void music_library_window_add_playlist (MusicLibraryWindow* self,
                                        MusicStaticPlaylist* playlist,
                                        MusicLibrary* library,
                                        MusicSourceListExpandableItem* entry);
VALA_EXTERN GType music_history_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicHistoryPlaylist, g_object_unref)
VALA_EXTERN GType music_streamer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicStreamer, g_object_unref)
VALA_EXTERN GType music_tree_view_setup_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicTreeViewSetup, g_object_unref)
VALA_EXTERN GdaConnection* music_local_library_get_connection (MusicLocalLibrary* self);
VALA_EXTERN MusicTreeViewSetup* music_tree_view_setup_new (MusicViewWrapperHint hint,
                                               const gchar* uid,
                                               GdaConnection* connection);
VALA_EXTERN MusicTreeViewSetup* music_tree_view_setup_construct (GType object_type,
                                                     MusicViewWrapperHint hint,
                                                     const gchar* uid,
                                                     GdaConnection* connection);
VALA_EXTERN GType music_music_view_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMusicViewWrapper, g_object_unref)
VALA_EXTERN MusicMusicViewWrapper* music_music_view_wrapper_new (MusicTreeViewSetup* tvs,
                                                     MusicLibrary* library,
                                                     MusicTopDisplay* top_display);
VALA_EXTERN MusicMusicViewWrapper* music_music_view_wrapper_construct (GType object_type,
                                                           MusicTreeViewSetup* tvs,
                                                           MusicLibrary* library,
                                                           MusicTopDisplay* top_display);
VALA_EXTERN void music_view_stack_add_view (MusicViewStack* self,
                                GtkWidget* view);
VALA_EXTERN MusicSourceListEntry* music_source_list_view_add_item (MusicSourceListView* self,
                                                       GtkGrid* view,
                                                       const gchar* name,
                                                       MusicViewWrapperHint hint,
                                                       GIcon* icon,
                                                       GIcon* activatable_icon,
                                                       MusicSourceListExpandableItem* into_expandable,
                                                       GObject* give_more_information);
static void music_library_window_update_badge_on_playlist_update (MusicLibraryWindow* self,
                                                           MusicPlaylist* p,
                                                           MusicSourceListEntry* entry);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda157_ (Block4Data* _data4_,
                   GeeCollection* s);
static void music_library_window_update_playlist_badge (MusicLibraryWindow* self,
                                                 MusicPlaylist* playlist);
static void ___lambda157__music_playlist_media_added (MusicPlaylist* _sender,
                                               GeeCollection* media,
                                               gpointer self);
static void __lambda158_ (Block4Data* _data4_,
                   GeeCollection* s);
static void ___lambda158__music_playlist_media_removed (MusicPlaylist* _sender,
                                                 GeeCollection* media,
                                                 gpointer self);
static void __lambda159_ (Block4Data* _data4_,
                   MusicPlaylist* s);
static void ___lambda159__music_playlist_cleared (MusicPlaylist* _sender,
                                           gpointer self);
static void music_library_window_real_update_sensitivities_data_free (gpointer _data);
static void music_library_window_real_update_sensitivities (MusicLibraryWindowInterface* base,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gboolean music_library_window_real_update_sensitivities_co (MusicLibraryWindowUpdateSensitivitiesData* _data_);
VALA_EXTERN gboolean music_local_library_get_main_directory_set (MusicLocalLibrary* self);
VALA_EXTERN GeeCollection* music_playback_manager_get_current_media_list (MusicPlaybackManager* self);
VALA_EXTERN void music_source_list_view_change_playlist_category_visibility (MusicSourceListView* self,
                                                                 gboolean visible);
VALA_EXTERN void music_widgets_status_bar_set_playlist_menubutton_sensitive (MusicWidgetsStatusBar* self,
                                                                 gboolean value);
VALA_EXTERN gboolean music_playback_manager_get_playing (MusicPlaybackManager* self);
static GVariant* _variant_new1 (gboolean value);
static GVariant* _variant_new2 (gboolean value);
static void music_library_window_change_device_name (MusicLibraryWindow* self,
                                              MusicDevice* device);
VALA_EXTERN void music_source_list_view_change_device_name (MusicSourceListView* self,
                                                MusicDeviceView* view,
                                                const gchar* new_name);
static void music_library_window_remove_device (MusicLibraryWindow* self,
                                         MusicDevice* device);
VALA_EXTERN GeeCollection* music_source_list_view_remove_device (MusicSourceListView* self,
                                                     MusicDeviceView* view);
VALA_EXTERN void music_view_stack_remove_view (MusicViewStack* self,
                                   GtkWidget* view);
static void music_library_window_create_device_source_list (MusicLibraryWindow* self,
                                                     MusicDevice* d);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN GType music_device_preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicDevicePreferences, g_object_unref)
VALA_EXTERN MusicDevicePreferences* music_local_library_get_preferences_for_device (MusicLocalLibrary* self,
                                                                        MusicDevice* d);
VALA_EXTERN MusicDeviceView* music_device_view_new (MusicDevice* device,
                                        MusicDevicePreferences* preferences);
VALA_EXTERN MusicDeviceView* music_device_view_construct (GType object_type,
                                              MusicDevice* device,
                                              MusicDevicePreferences* preferences);
VALA_EXTERN MusicDeviceViewWrapper* music_device_view_wrapper_new (MusicTreeViewSetup* tvs,
                                                       MusicDevice* d,
                                                       MusicLibrary* library);
VALA_EXTERN MusicDeviceViewWrapper* music_device_view_wrapper_construct (GType object_type,
                                                             MusicTreeViewSetup* tvs,
                                                             MusicDevice* d,
                                                             MusicLibrary* library);
static void music_library_window_create_playlist_source_list (MusicLibraryWindow* self,
                                                       MusicStaticPlaylist* p,
                                                       MusicSourceListExpandableItem* into_expandable,
                                                       MusicLibrary* library);
static void ______lambda163_ (Block6Data* _data6_,
                       MusicStaticPlaylist* np);
static void _______lambda163__music_library_playlist_added (MusicLibrary* _sender,
                                                     MusicStaticPlaylist* playlist,
                                                     gpointer self);
static void ______lambda164_ (MusicLibraryWindow* self,
                       MusicStaticPlaylist* np);
static void music_library_window_remove_playlist (MusicLibraryWindow* self,
                                           MusicStaticPlaylist* playlist);
static void _______lambda164__music_library_playlist_removed (MusicLibrary* _sender,
                                                       MusicStaticPlaylist* playlist,
                                                       gpointer self);
VALA_EXTERN void music_source_list_view_remove_playlist (MusicSourceListView* self,
                                             MusicViewWrapper* view);
VALA_EXTERN void music_library_window_set_newly_created_playlist (MusicLibraryWindow* self,
                                                      gboolean value);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
VALA_EXTERN GType music_local_static_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalStaticPlaylist, g_object_unref)
VALA_EXTERN MusicPlaylistViewWrapper* music_playlist_view_wrapper_new (MusicPlaylist* playlist,
                                                           MusicViewWrapperHint hint,
                                                           MusicTreeViewSetup* tvs,
                                                           MusicLibrary* library);
VALA_EXTERN MusicPlaylistViewWrapper* music_playlist_view_wrapper_construct (GType object_type,
                                                                 MusicPlaylist* playlist,
                                                                 MusicViewWrapperHint hint,
                                                                 MusicTreeViewSetup* tvs,
                                                                 MusicLibrary* library);
VALA_EXTERN void music_playlist_view_wrapper_set_no_media_alert_message (MusicPlaylistViewWrapper* self,
                                                             const gchar* head,
                                                             const gchar* body);
VALA_EXTERN void music_playback_manager_queue_media (MusicPlaybackManager* self,
                                         GeeCollection* to_queue);
VALA_EXTERN gboolean music_library_window_get_newly_created_playlist (MusicLibraryWindow* self);
static gboolean ___lambda160_ (Block7Data* _data7_);
static gboolean ____lambda160__gsource_func (gpointer self);
static void music_library_window_create_smartplaylist_source_list (MusicLibraryWindow* self,
                                                            MusicSmartPlaylist* p,
                                                            MusicSourceListExpandableItem* into_expandable,
                                                            MusicLibrary* library);
static void music_library_window_remove_smartplaylist (MusicLibraryWindow* self,
                                                MusicSmartPlaylist* smartplaylist);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
VALA_EXTERN GType music_local_smart_playlist_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLocalSmartPlaylist, g_object_unref)
static void __lambda155_ (MusicLibraryWindow* self,
                   MusicPlaylist* playlist);
static void ___lambda155__music_playlist_view_wrapper_button_clicked (MusicPlaylistViewWrapper* _sender,
                                                               MusicPlaylist* p,
                                                               gpointer self);
static void __lambda156_ (Block8Data* _data8_,
                   const gchar* old_name);
VALA_EXTERN void music_source_list_view_change_playlist_name (MusicSourceListView* self,
                                                  MusicViewWrapper* view,
                                                  const gchar* new_name);
static void ___lambda156__music_playlist_updated (MusicPlaylist* _sender,
                                           const gchar* old_name,
                                           gpointer self);
VALA_EXTERN GType music_smart_playlist_editor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicSmartPlaylistEditor, g_object_unref)
VALA_EXTERN MusicSmartPlaylistEditor* music_smart_playlist_editor_new (MusicSmartPlaylist* smart_playlist,
                                                           MusicLibrary* library);
VALA_EXTERN MusicSmartPlaylistEditor* music_smart_playlist_editor_construct (GType object_type,
                                                                 MusicSmartPlaylist* smart_playlist,
                                                                 MusicLibrary* library);
static void music_library_window_media_played (MusicLibraryWindow* self,
                                        MusicMedia* m);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
VALA_EXTERN void music_top_display_update_media (MusicTopDisplay* self);
static void music_library_window_set_media_considered_previewed (MusicLibraryWindow* self,
                                                          gboolean value);
static void music_library_window_set_media_considered_played (MusicLibraryWindow* self,
                                                       gboolean value);
static void music_library_window_set_added_to_play_count (MusicLibraryWindow* self,
                                                   gboolean value);
static void music_library_window_set_media_half_played_sended (MusicLibraryWindow* self,
                                                        gboolean value);
static gboolean __lambda165_ (Block9Data* _data9_);
static void* ___lambda166_ (MusicLibraryWindow* self);
static gpointer ____lambda166__gthread_func (gpointer self);
static gboolean ___lambda165__gsource_func (gpointer self);
static void music_library_window_real_playback_stopped (MusicLibraryWindow* self,
                                                 gint64 was_playing);
static GVariant* _variant_new3 (gboolean value);
static void music_library_window_real_play_media (MusicLibraryWindow* self,
                                           gboolean inhibit_notifications);
VALA_EXTERN MusicMedia* music_playback_manager_get_next (MusicPlaybackManager* self,
                                             gboolean play);
VALA_EXTERN void music_playback_manager_start_playback (MusicPlaybackManager* self);
VALA_EXTERN void music_playback_manager_pause_playback (MusicPlaybackManager* self);
static void music_library_window_real_play_next_media (MusicLibraryWindow* self,
                                                gboolean inhibit_notifications);
static gboolean music_library_window_get_added_to_play_count (MusicLibraryWindow* self);
VALA_EXTERN void music_playback_manager_stop_playback (MusicPlaybackManager* self);
static void music_library_window_real_play_previous_media (MusicLibraryWindow* self,
                                                    gboolean inhibit_notifications);
VALA_EXTERN MusicMedia* music_playback_manager_get_previous (MusicPlaybackManager* self,
                                                 gboolean play);
VALA_EXTERN gboolean music_top_display_change_value (MusicTopDisplay* self,
                                         GtkScrollType scroll,
                                         gdouble val);
static void music_library_window_real_action_import (MusicLibraryWindow* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
VALA_EXTERN void music_local_library_add_folder_to_library (MusicLocalLibrary* self,
                                                GeeCollection* folders);
VALA_EXTERN MusicPreferencesWindow* music_preferences_window_new (void);
VALA_EXTERN MusicPreferencesWindow* music_preferences_window_construct (GType object_type);
VALA_EXTERN void music_library_window_set_music_folder (MusicLibraryWindow* self,
                                            const gchar* folder);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN GType music_set_music_folder_confirmation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicSetMusicFolderConfirmation, g_object_unref)
VALA_EXTERN MusicSetMusicFolderConfirmation* music_set_music_folder_confirmation_new (const gchar* path);
VALA_EXTERN MusicSetMusicFolderConfirmation* music_set_music_folder_confirmation_construct (GType object_type,
                                                                                const gchar* path);
static void ___lambda122_ (Block10Data* _data10_,
                    gboolean cont);
VALA_EXTERN void music_local_library_set_music_folder (MusicLocalLibrary* self,
                                           const gchar* folder,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN void music_local_library_set_music_folder_finish (MusicLocalLibrary* self,
                                                  GAsyncResult* _res_);
static void ____lambda122__music_set_music_folder_confirmation_finished (MusicSetMusicFolderConfirmation* _sender,
                                                                  gboolean response,
                                                                  gpointer self);
static void music_library_window_real_end_of_stream (MusicLibraryWindow* self);
static void music_library_window_real_error_occured (MusicLibraryWindow* self);
static void music_library_window_real_current_position_update (MusicLibraryWindow* self,
                                                        gint64 position);
static gboolean music_library_window_get_media_considered_previewed (MusicLibraryWindow* self);
static gboolean music_library_window_get_media_considered_played (MusicLibraryWindow* self);
static gboolean music_library_window_get_media_half_played_sended (MusicLibraryWindow* self);
VALA_EXTERN void music_view_wrapper_play_first_media (MusicViewWrapper* self,
                                          gboolean* force);
static void music_library_window_real_drag_received (MusicLibraryWindow* self,
                                              GdkDragContext* context,
                                              gint x,
                                              gint y,
                                              GtkSelectionData* data,
                                              guint info,
                                              guint timestamp);
static void music_library_window_show_alert (MusicLibraryWindow* self,
                                      const gchar* title,
                                      const gchar* message);
VALA_EXTERN MusicWidgetsViewSelectorMode music_widgets_view_selector_get_selected (MusicWidgetsViewSelector* self);
static gboolean music_library_window_real_delete_event (GtkWidget* base,
                                                 GdkEventAny* event);
VALA_EXTERN GSettings* music_app_get_settings (void);
static gboolean music_library_window_real_configure_event (GtkWidget* base,
                                                    GdkEventConfigure* event);
static gboolean ___lambda167_ (MusicLibraryWindow* self);
static gboolean ____lambda167__gsource_func (gpointer self);
static GObject * music_library_window_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _music_library_window_interface_update_sensitivities_music_library_media_added (MusicLibrary* _sender,
                                                                                     GeeCollection* medias,
                                                                                     gpointer self);
static void _music_library_window_interface_update_sensitivities_music_library_media_removed (MusicLibrary* _sender,
                                                                                       GeeCollection* medias,
                                                                                       gpointer self);
static void _music_library_window___lambda168_ (MusicLibraryWindow* self,
                                         MusicStaticPlaylist* p);
static void __music_library_window___lambda168__music_library_playlist_added (MusicLibrary* _sender,
                                                                       MusicStaticPlaylist* playlist,
                                                                       gpointer self);
static void _music_library_window___lambda169_ (MusicLibraryWindow* self,
                                         MusicStaticPlaylist* p);
static void __music_library_window___lambda169__music_library_playlist_removed (MusicLibrary* _sender,
                                                                         MusicStaticPlaylist* playlist,
                                                                         gpointer self);
static void _music_library_window___lambda170_ (MusicLibraryWindow* self,
                                         MusicSmartPlaylist* p);
static void __music_library_window___lambda170__music_library_smartplaylist_added (MusicLibrary* _sender,
                                                                            MusicSmartPlaylist* smartplaylist,
                                                                            gpointer self);
static void _music_library_window___lambda171_ (MusicLibraryWindow* self,
                                         MusicSmartPlaylist* p);
static void __music_library_window___lambda171__music_library_smartplaylist_removed (MusicLibrary* _sender,
                                                                              MusicSmartPlaylist* smartplaylist,
                                                                              gpointer self);
static void _music_library_window___lambda172_ (MusicLibraryWindow* self,
                                         MusicDevice* item);
static void __music_library_window___lambda172__music_device_manager_device_added (MusicDeviceManager* _sender,
                                                                            MusicDevice* d,
                                                                            gpointer self);
static void _music_library_window_change_device_name_music_device_manager_device_name_changed (MusicDeviceManager* _sender,
                                                                                        MusicDevice* d,
                                                                                        gpointer self);
static void _music_library_window_remove_device_music_device_manager_device_removed (MusicDeviceManager* _sender,
                                                                              MusicDevice* d,
                                                                              gpointer self);
static void _music_library_window_end_of_stream_music_playback_end_of_stream (MusicPlayback* _sender,
                                                                       gpointer self);
static void _music_library_window_current_position_update_music_playback_current_position_update (MusicPlayback* _sender,
                                                                                           gint64 position,
                                                                                           gpointer self);
static void _music_library_window_error_occured_music_playback_error_occured (MusicPlayback* _sender,
                                                                       gpointer self);
static void _music_library_window_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                             MusicMedia* played_media,
                                                                             gpointer self);
static void _music_library_window_playback_stopped_music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                                     gint64 was_playing,
                                                                                     gpointer self);
static void _music_library_window___lambda173_ (MusicLibraryWindow* self);
static void __music_library_window___lambda173__music_playback_manager_changing_player (MusicPlaybackManager* _sender,
                                                                                 gpointer self);
static void _music_library_window___lambda174_ (MusicLibraryWindow* self);
static void __music_library_window___lambda174__music_playback_manager_player_changed (MusicPlaybackManager* _sender,
                                                                                gpointer self);
static void _music_library_window_show_alert_music_notification_manager_show_alert (MusicNotificationManager* _sender,
                                                                             const gchar* title,
                                                                             const gchar* message,
                                                                             gpointer self);
static void _music_library_window___lambda175_ (MusicLibraryWindow* self,
                                         MusicStaticPlaylist* playlist);
static void __music_library_window___lambda175__music_libraries_manager_add_headless_playlist (MusicLibrariesManager* _sender,
                                                                                        MusicStaticPlaylist* playlist,
                                                                                        gpointer self);
VALA_EXTERN void music_playback_manager_clear_queue (MusicPlaybackManager* self);
static void music_library_window_finalize (GObject * obj);
static GType music_library_window_get_type_once (void);
static void _vala_music_library_window_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_music_library_window_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GActionEntry MUSIC_LIBRARY_WINDOW_ACTION_ENTRIES[9] = {{MUSIC_LIBRARY_WINDOW_ACTION_IMPORT, _music_library_window_action_import_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_PLAY, _music_library_window_action_play_gsimple_action_activate_callback, NULL, "false"}, {MUSIC_LIBRARY_WINDOW_ACTION_PLAY_NEXT, _music_library_window_action_play_next_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_PLAY_PREVIOUS, _music_library_window_action_play_previous_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_QUIT, _music_library_window_action_quit_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_SEARCH, _music_library_window_action_search_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS, _music_library_window_action_view_albums_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS, _music_library_window_action_view_columns_gsimple_action_activate_callback}, {MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST, _music_library_window_action_view_list_gsimple_action_activate_callback}};

static inline gpointer
music_library_window_get_instance_private (MusicLibraryWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLibraryWindow_private_offset);
}

static void
_music_library_window_action_import_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
	music_library_window_action_import ((MusicLibraryWindow*) self);
}

static void
_music_library_window_action_play_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
	music_library_window_action_play ((MusicLibraryWindow*) self);
}

static void
_music_library_window_action_play_next_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
	music_library_window_action_play_next ((MusicLibraryWindow*) self);
}

static void
_music_library_window_action_play_previous_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
	music_library_window_action_play_previous ((MusicLibraryWindow*) self);
}

static void
_music_library_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
	music_library_window_action_quit ((MusicLibraryWindow*) self);
}

static void
_music_library_window_action_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
	music_library_window_action_search ((MusicLibraryWindow*) self);
}

static void
_music_library_window_action_view_albums_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
	music_library_window_action_view_albums ((MusicLibraryWindow*) self);
}

static void
_music_library_window_action_view_columns_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
	music_library_window_action_view_columns ((MusicLibraryWindow*) self);
}

static void
_music_library_window_action_view_list_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
	music_library_window_action_view_list ((MusicLibraryWindow*) self);
}

MusicLibraryWindow*
music_library_window_construct (GType object_type,
                                GtkApplication* application)
{
	MusicLibraryWindow * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	g_return_val_if_fail (application != NULL, NULL);
	self = (MusicLibraryWindow*) g_object_new (object_type, "application", application, NULL);
	_tmp0_ = g_strdup ("<Control>q");
	_tmp1_ = g_strdup ("<Control>w");
	_tmp2_ = g_new0 (gchar*, 2 + 1);
	_tmp2_[0] = _tmp0_;
	_tmp2_[1] = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = 2;
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_QUIT, _tmp3_);
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	_tmp4_ = g_strdup ("<Control>f");
	_tmp5_ = g_new0 (gchar*, 1 + 1);
	_tmp5_[0] = _tmp4_;
	_tmp6_ = _tmp5_;
	_tmp6__length1 = 1;
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_SEARCH, _tmp6_);
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
	_tmp7_ = g_strdup ("<Control>1");
	_tmp8_ = g_new0 (gchar*, 1 + 1);
	_tmp8_[0] = _tmp7_;
	_tmp9_ = _tmp8_;
	_tmp9__length1 = 1;
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS, _tmp9_);
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
	_tmp10_ = g_strdup ("<Control>2");
	_tmp11_ = g_new0 (gchar*, 1 + 1);
	_tmp11_[0] = _tmp10_;
	_tmp12_ = _tmp11_;
	_tmp12__length1 = 1;
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_LIST, _tmp12_);
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
	_tmp13_ = g_strdup ("<Control>3");
	_tmp14_ = g_new0 (gchar*, 1 + 1);
	_tmp14_[0] = _tmp13_;
	_tmp15_ = _tmp14_;
	_tmp15__length1 = 1;
	gtk_application_set_accels_for_action (application, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS, _tmp15_);
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
	return self;
}

MusicLibraryWindow*
music_library_window_new (GtkApplication* application)
{
	return music_library_window_construct (MUSIC_TYPE_LIBRARY_WINDOW, application);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}

static gboolean
_vala_unichar_array_contains (gunichar * stack,
                              gssize stack_length,
                              const gunichar needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

static gboolean
music_library_window_real_key_press_event (GtkWidget* base,
                                           GdkEventKey* event)
{
	MusicLibraryWindow * self;
	GtkWidget* focus_widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkWidget* _tmp3_;
	GdkModifierType modifiers = 0U;
	gboolean modifiers_active = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean result;
	self = (MusicLibraryWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = gtk_window_get_focus ((GtkWindow*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	focus_widget = _tmp1_;
	_tmp3_ = focus_widget;
	if (_tmp3_ != NULL) {
		GtkWidget* _tmp4_;
		_tmp4_ = focus_widget;
		_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_editable_get_type ());
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		result = GTK_WIDGET_CLASS (music_library_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
		_g_object_unref0 (focus_widget);
		return result;
	}
	modifiers = gtk_accelerator_get_default_mod_mask ();
	modifiers_active = (event->state & modifiers) != 0;
	if (!modifiers_active) {
		gboolean _tmp6_;
		_tmp6_ = self->priv->_search_field_has_focus;
		_tmp5_ = _tmp6_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gunichar typed_unichar = 0U;
		const gchar* _tmp15_;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		if (event->keyval == GDK_KEY_space) {
			GtkSearchEntry* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			_tmp9_ = self->priv->_search_entry;
			g_object_get ((GtkWidget*) _tmp9_, "has-focus", &_tmp10_, NULL);
			_tmp11_ = _tmp10_;
			_tmp8_ = !_tmp11_;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			MusicSourceListView* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
			_tmp12_ = self->priv->_source_list_view;
			_tmp13_ = granite_widgets_source_list_get_editing ((GraniteWidgetsSourceList*) _tmp12_);
			_tmp14_ = _tmp13_;
			_tmp7_ = !_tmp14_;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			music_library_window_play_media (self, FALSE);
			result = TRUE;
			_g_object_unref0 (focus_widget);
			return result;
		}
		_tmp15_ = event->string;
		typed_unichar = string_get_char (_tmp15_, (glong) 0);
		if (g_unichar_validate (typed_unichar)) {
			GtkSearchEntry* _tmp18_;
			gboolean _tmp19_;
			gboolean _tmp20_;
			_tmp18_ = self->priv->_search_entry;
			_tmp19_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp18_);
			_tmp20_ = _tmp19_;
			_tmp17_ = _tmp20_;
		} else {
			_tmp17_ = FALSE;
		}
		if (_tmp17_) {
			GtkSearchEntry* _tmp21_;
			gboolean _tmp22_;
			gboolean _tmp23_;
			_tmp21_ = self->priv->_search_entry;
			g_object_get ((GtkWidget*) _tmp21_, "has-focus", &_tmp22_, NULL);
			_tmp23_ = _tmp22_;
			_tmp16_ = !_tmp23_;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			gunichar* special_chars = NULL;
			gunichar* _tmp24_;
			gint special_chars_length1;
			gint _special_chars_size_;
			gboolean _tmp25_ = FALSE;
			_tmp24_ = g_new0 (gunichar, 27);
			_tmp24_[0] = (gunichar) '&';
			_tmp24_[1] = (gunichar) '.';
			_tmp24_[2] = (gunichar) '-';
			_tmp24_[3] = (gunichar) '\\';
			_tmp24_[4] = (gunichar) '%';
			_tmp24_[5] = (gunichar) '(';
			_tmp24_[6] = (gunichar) ')';
			_tmp24_[7] = (gunichar) '=';
			_tmp24_[8] = (gunichar) '@';
			_tmp24_[9] = (gunichar) '#';
			_tmp24_[10] = (gunichar) '+';
			_tmp24_[11] = (gunichar) '<';
			_tmp24_[12] = (gunichar) '>';
			_tmp24_[13] = (gunichar) ';';
			_tmp24_[14] = (gunichar) ':';
			_tmp24_[15] = 191U;
			_tmp24_[16] = (gunichar) '?';
			_tmp24_[17] = 161U;
			_tmp24_[18] = (gunichar) '_';
			_tmp24_[19] = 168U;
			_tmp24_[20] = (gunichar) '*';
			_tmp24_[21] = (gunichar) '$';
			_tmp24_[22] = (gunichar) '"';
			_tmp24_[23] = (gunichar) '[';
			_tmp24_[24] = (gunichar) ']';
			_tmp24_[25] = (gunichar) '!';
			_tmp24_[26] = (gunichar) '~';
			special_chars = _tmp24_;
			special_chars_length1 = 27;
			_special_chars_size_ = special_chars_length1;
			if (g_unichar_isalnum (typed_unichar)) {
				_tmp25_ = TRUE;
			} else {
				gunichar* _tmp26_;
				gint _tmp26__length1;
				_tmp26_ = special_chars;
				_tmp26__length1 = special_chars_length1;
				_tmp25_ = _vala_unichar_array_contains (_tmp26_, _tmp26__length1, typed_unichar);
			}
			if (_tmp25_) {
				music_library_window_action_search (self);
			}
			special_chars = (g_free (special_chars), NULL);
		}
	}
	result = GTK_WIDGET_CLASS (music_library_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
	_g_object_unref0 (focus_widget);
	return result;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		MusicLibraryWindow* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->play_button);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
_music_library_window_on_quit_gtk_widget_destroy (GtkWidget* _sender,
                                                  gpointer self)
{
	music_library_window_on_quit ((MusicLibraryWindow*) self);
}

static void
_music_library_window_edit_preferences_click_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self)
{
	music_library_window_edit_preferences_click ((MusicLibraryWindow*) self);
}

static void
__lambda134_ (Block3Data* _data3_,
              const gchar* name,
              GVariant* new_state)
{
	MusicLibraryWindow* self;
	self = _data3_->self;
	g_return_if_fail (name != NULL);
	g_return_if_fail (new_state != NULL);
	if (g_strcmp0 (name, MUSIC_LIBRARY_WINDOW_ACTION_PLAY) == 0) {
		if (g_variant_get_boolean (new_state) == FALSE) {
			GtkButton* _tmp0_;
			GtkImage* _tmp1_;
			GtkImage* _tmp2_;
			GtkButton* _tmp3_;
			_tmp0_ = _data3_->play_button;
			_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
			g_object_ref_sink (_tmp1_);
			_tmp2_ = _tmp1_;
			gtk_button_set_image (_tmp0_, (GtkWidget*) _tmp2_);
			_g_object_unref0 (_tmp2_);
			_tmp3_ = _data3_->play_button;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _ ("Play"));
		} else {
			GtkButton* _tmp4_;
			GtkImage* _tmp5_;
			GtkImage* _tmp6_;
			GtkButton* _tmp7_;
			_tmp4_ = _data3_->play_button;
			_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
			g_object_ref_sink (_tmp5_);
			_tmp6_ = _tmp5_;
			gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp6_);
			_g_object_unref0 (_tmp6_);
			_tmp7_ = _data3_->play_button;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _ ("Pause"));
		}
	}
}

static void
___lambda134__g_action_group_action_state_changed (GActionGroup* _sender,
                                                   const gchar* action_name,
                                                   GVariant* state,
                                                   gpointer self)
{
	__lambda134_ (self, action_name, state);
}

static void
__lambda135_ (MusicLibraryWindow* self)
{
	MusicViewStack* _tmp0_;
	_tmp0_ = self->priv->_view_stack;
	music_view_stack_hide_alert (_tmp0_);
}

static void
___lambda135__music_library_search_finished (MusicLibrary* _sender,
                                             gpointer self)
{
	__lambda135_ ((MusicLibraryWindow*) self);
}

static void
__lambda137_ (MusicLibraryWindow* self)
{
	MusicViewStack* _tmp0_;
	_tmp0_ = self->priv->_view_stack;
	music_view_stack_hide_alert (_tmp0_);
}

static void
___lambda137__music_library_search_finished (MusicLibrary* _sender,
                                             gpointer self)
{
	__lambda137_ ((MusicLibraryWindow*) self);
}

static void
__lambda136_ (MusicLibraryWindow* self,
              MusicLibrary* lib)
{
	g_return_if_fail (lib != NULL);
	g_signal_connect_object (lib, "search-finished", (GCallback) ___lambda137__music_library_search_finished, self, 0);
}

static void
___lambda136__music_libraries_manager_library_added (MusicLibrariesManager* _sender,
                                                     MusicLibrary* library,
                                                     gpointer self)
{
	__lambda136_ ((MusicLibraryWindow*) self, library);
}

static void
__lambda138_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	MusicViewStack* _tmp0_;
	g_return_if_fail (view != NULL);
	_tmp0_ = self->priv->_view_stack;
	gtk_stack_set_visible_child ((GtkStack*) _tmp0_, (GtkWidget*) view);
}

static void
___lambda138__music_source_list_view_selection_changed (MusicSourceListView* _sender,
                                                        GtkGrid* view,
                                                        gpointer self)
{
	__lambda138_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda139_ (MusicLibraryWindow* self)
{
	music_library_window_set_search_field_has_focus (self, FALSE);
}

static void
___lambda139__music_source_list_view_activated (MusicSourceListView* _sender,
                                                gpointer self)
{
	__lambda139_ ((MusicLibraryWindow*) self);
}

static void
__lambda140_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_DEVICE_VIEW (view)) {
		MusicDevice* _tmp0_;
		MusicDevice* _tmp1_;
		_tmp0_ = music_device_view_get_device (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView));
		_tmp1_ = _tmp0_;
		music_device_eject (_tmp1_);
	}
}

static void
___lambda140__music_source_list_view_item_action_activated (MusicSourceListView* _sender,
                                                            GtkGrid* view,
                                                            gpointer self)
{
	__lambda140_ ((MusicLibraryWindow*) self, view);
}

static void
_music_library_window_playlist_name_edited_music_source_list_view_edited (MusicSourceListView* _sender,
                                                                          GtkGrid* view,
                                                                          const gchar* new_name,
                                                                          gpointer self)
{
	music_library_window_playlist_name_edited ((MusicLibraryWindow*) self, view, new_name);
}

static void
__lambda143_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
		music_library_window_set_search_field_has_focus (self, FALSE);
	}
}

static void
___lambda143__music_source_list_view_playlist_rename_clicked (MusicSourceListView* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
	__lambda143_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda144_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
		MusicPlaylist* p = NULL;
		MusicPlaylist* _tmp0_;
		MusicPlaylist* _tmp1_;
		MusicPlaylist* _tmp2_;
		MusicPlaylist* _tmp3_;
		_tmp0_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
		_tmp1_ = _tmp0_;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		p = _tmp2_;
		_tmp3_ = p;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, MUSIC_TYPE_SMART_PLAYLIST)) {
			MusicPlaylist* _tmp4_;
			_tmp4_ = p;
			music_library_window_show_smart_playlist_dialog (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist));
		}
		_g_object_unref0 (p);
	}
}

static void
___lambda144__music_source_list_view_playlist_edit_clicked (MusicSourceListView* _sender,
                                                            GtkGrid* view,
                                                            gpointer self)
{
	__lambda144_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda145_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
		playlistview = _tmp0_;
		_tmp1_ = playlistview;
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
		_tmp3_ = _tmp2_;
		if (_tmp3_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
			MusicPlaylistViewWrapper* _tmp4_;
			MusicLibrary* _tmp5_;
			MusicLibrary* _tmp6_;
			MusicPlaylistViewWrapper* _tmp7_;
			MusicPlaylist* _tmp8_;
			MusicPlaylist* _tmp9_;
			gint64 _tmp10_;
			gint64 _tmp11_;
			_tmp4_ = playlistview;
			_tmp5_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp4_);
			_tmp6_ = _tmp5_;
			_tmp7_ = playlistview;
			_tmp8_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = music_playlist_get_rowid (_tmp9_);
			_tmp11_ = _tmp10_;
			music_library_remove_playlist (_tmp6_, _tmp11_);
		} else {
			MusicPlaylistViewWrapper* _tmp12_;
			MusicViewWrapperHint _tmp13_;
			MusicViewWrapperHint _tmp14_;
			_tmp12_ = playlistview;
			_tmp13_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp12_);
			_tmp14_ = _tmp13_;
			if (_tmp14_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
				MusicPlaylistViewWrapper* _tmp15_;
				MusicLibrary* _tmp16_;
				MusicLibrary* _tmp17_;
				MusicPlaylistViewWrapper* _tmp18_;
				MusicPlaylist* _tmp19_;
				MusicPlaylist* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
				_tmp15_ = playlistview;
				_tmp16_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = playlistview;
				_tmp19_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp18_);
				_tmp20_ = _tmp19_;
				_tmp21_ = music_playlist_get_rowid (_tmp20_);
				_tmp22_ = _tmp21_;
				music_library_remove_smart_playlist (_tmp17_, _tmp22_);
			}
		}
		_g_object_unref0 (playlistview);
	}
}

static void
___lambda145__music_source_list_view_playlist_remove_clicked (MusicSourceListView* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
	__lambda145_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda146_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_DEVICE_VIEW_WRAPPER (view)) {
		{
			GeeIterator* _device_it = NULL;
			MusicDeviceManager* _tmp0_;
			MusicDeviceManager* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
			_tmp0_ = music_device_manager_get_default ();
			_tmp1_ = _tmp0_;
			_tmp2_ = music_device_manager_get_initialized_devices (_tmp1_);
			_tmp3_ = _tmp2_;
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
			_tmp5_ = _tmp4_;
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (_tmp1_);
			_device_it = _tmp5_;
			while (TRUE) {
				GeeIterator* _tmp6_;
				MusicDevice* device = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				MusicDevice* _tmp9_;
				MusicDevice* _tmp10_;
				MusicDevice* _tmp11_;
				_tmp6_ = _device_it;
				if (!gee_iterator_next (_tmp6_)) {
					break;
				}
				_tmp7_ = _device_it;
				_tmp8_ = gee_iterator_get (_tmp7_);
				device = (MusicDevice*) _tmp8_;
				_tmp9_ = music_device_view_wrapper_get_d (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
				_tmp10_ = _tmp9_;
				_tmp11_ = device;
				if (_tmp10_ == _tmp11_) {
					MusicLibrariesManager* _tmp12_;
					MusicDevice* _tmp13_;
					MusicLibrary* _tmp14_;
					MusicLibrary* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
					_tmp12_ = music_libraries_manager;
					_tmp13_ = device;
					_tmp14_ = music_device_get_library (_tmp13_);
					_tmp15_ = _tmp14_;
					_tmp16_ = music_library_get_medias (_tmp15_);
					_tmp17_ = _tmp16_;
					music_libraries_manager_transfer_to_local_library (_tmp12_, _tmp17_);
					_g_object_unref0 (_tmp17_);
					_g_object_unref0 (_tmp15_);
					break;
				}
			}
			_g_object_unref0 (_device_it);
		}
	}
}

static void
___lambda146__music_source_list_view_device_import_clicked (MusicSourceListView* _sender,
                                                            GtkGrid* view,
                                                            gpointer self)
{
	__lambda146_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda147_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_DEVICE_VIEW_WRAPPER (view)) {
		{
			GeeIterator* _device_it = NULL;
			MusicDeviceManager* _tmp0_;
			MusicDeviceManager* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
			_tmp0_ = music_device_manager_get_default ();
			_tmp1_ = _tmp0_;
			_tmp2_ = music_device_manager_get_initialized_devices (_tmp1_);
			_tmp3_ = _tmp2_;
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
			_tmp5_ = _tmp4_;
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (_tmp1_);
			_device_it = _tmp5_;
			while (TRUE) {
				GeeIterator* _tmp6_;
				MusicDevice* device = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				MusicDevice* _tmp9_;
				MusicDevice* _tmp10_;
				MusicDevice* _tmp11_;
				_tmp6_ = _device_it;
				if (!gee_iterator_next (_tmp6_)) {
					break;
				}
				_tmp7_ = _device_it;
				_tmp8_ = gee_iterator_get (_tmp7_);
				device = (MusicDevice*) _tmp8_;
				_tmp9_ = music_device_view_wrapper_get_d (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
				_tmp10_ = _tmp9_;
				_tmp11_ = device;
				if (_tmp10_ == _tmp11_) {
					MusicDevice* _tmp12_;
					MusicLibrary* _tmp13_;
					MusicLibrary* _tmp14_;
					_tmp12_ = device;
					_tmp13_ = music_device_get_library (_tmp12_);
					_tmp14_ = _tmp13_;
					music_library_window_create_new_playlist (self, _tmp14_);
					_g_object_unref0 (_tmp14_);
					break;
				}
			}
			_g_object_unref0 (_device_it);
		}
	}
}

static void
___lambda147__music_source_list_view_device_new_playlist_clicked (MusicSourceListView* _sender,
                                                                  GtkGrid* view,
                                                                  gpointer self)
{
	__lambda147_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda148_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_DEVICE_VIEW_WRAPPER (view)) {
		{
			GeeIterator* _device_it = NULL;
			MusicDeviceManager* _tmp0_;
			MusicDeviceManager* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
			_tmp0_ = music_device_manager_get_default ();
			_tmp1_ = _tmp0_;
			_tmp2_ = music_device_manager_get_initialized_devices (_tmp1_);
			_tmp3_ = _tmp2_;
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
			_tmp5_ = _tmp4_;
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (_tmp1_);
			_device_it = _tmp5_;
			while (TRUE) {
				GeeIterator* _tmp6_;
				MusicDevice* device = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				MusicDevice* _tmp9_;
				MusicDevice* _tmp10_;
				MusicDevice* _tmp11_;
				_tmp6_ = _device_it;
				if (!gee_iterator_next (_tmp6_)) {
					break;
				}
				_tmp7_ = _device_it;
				_tmp8_ = gee_iterator_get (_tmp7_);
				device = (MusicDevice*) _tmp8_;
				_tmp9_ = music_device_view_wrapper_get_d (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
				_tmp10_ = _tmp9_;
				_tmp11_ = device;
				if (_tmp10_ == _tmp11_) {
					MusicDevice* _tmp12_;
					_tmp12_ = device;
					music_device_synchronize (_tmp12_);
					break;
				}
			}
			_g_object_unref0 (_device_it);
		}
	}
}

static void
___lambda148__music_source_list_view_device_sync_clicked (MusicSourceListView* _sender,
                                                          GtkGrid* view,
                                                          gpointer self)
{
	__lambda148_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda149_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_DEVICE_VIEW_WRAPPER (view)) {
		{
			GeeIterator* _device_it = NULL;
			MusicDeviceManager* _tmp0_;
			MusicDeviceManager* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
			_tmp0_ = music_device_manager_get_default ();
			_tmp1_ = _tmp0_;
			_tmp2_ = music_device_manager_get_initialized_devices (_tmp1_);
			_tmp3_ = _tmp2_;
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
			_tmp5_ = _tmp4_;
			_g_object_unref0 (_tmp3_);
			_g_object_unref0 (_tmp1_);
			_device_it = _tmp5_;
			while (TRUE) {
				GeeIterator* _tmp6_;
				MusicDevice* device = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				MusicDevice* _tmp9_;
				MusicDevice* _tmp10_;
				MusicDevice* _tmp11_;
				_tmp6_ = _device_it;
				if (!gee_iterator_next (_tmp6_)) {
					break;
				}
				_tmp7_ = _device_it;
				_tmp8_ = gee_iterator_get (_tmp7_);
				device = (MusicDevice*) _tmp8_;
				_tmp9_ = music_device_view_wrapper_get_d (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_DEVICE_VIEW_WRAPPER, MusicDeviceViewWrapper));
				_tmp10_ = _tmp9_;
				_tmp11_ = device;
				if (_tmp10_ == _tmp11_) {
					MusicDevice* _tmp12_;
					_tmp12_ = device;
					music_device_eject (_tmp12_);
					break;
				}
			}
			_g_object_unref0 (_device_it);
		}
	}
}

static void
___lambda149__music_source_list_view_device_eject_clicked (MusicSourceListView* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
	__lambda149_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda150_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
		playlistview = _tmp0_;
		_tmp1_ = playlistview;
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
		_tmp3_ = _tmp2_;
		if (_tmp3_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
			MusicPlaylistViewWrapper* _tmp4_;
			MusicLibrary* _tmp5_;
			MusicLibrary* _tmp6_;
			MusicPlaylistViewWrapper* _tmp7_;
			MusicPlaylist* _tmp8_;
			MusicPlaylist* _tmp9_;
			gint64 _tmp10_;
			gint64 _tmp11_;
			_tmp4_ = playlistview;
			_tmp5_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp4_);
			_tmp6_ = _tmp5_;
			_tmp7_ = playlistview;
			_tmp8_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = music_playlist_get_rowid (_tmp9_);
			_tmp11_ = _tmp10_;
			music_library_remove_playlist (_tmp6_, _tmp11_);
		} else {
			MusicPlaylistViewWrapper* _tmp12_;
			MusicViewWrapperHint _tmp13_;
			MusicViewWrapperHint _tmp14_;
			_tmp12_ = playlistview;
			_tmp13_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp12_);
			_tmp14_ = _tmp13_;
			if (_tmp14_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
				MusicPlaylistViewWrapper* _tmp15_;
				MusicLibrary* _tmp16_;
				MusicLibrary* _tmp17_;
				MusicPlaylistViewWrapper* _tmp18_;
				MusicPlaylist* _tmp19_;
				MusicPlaylist* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
				_tmp15_ = playlistview;
				_tmp16_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = playlistview;
				_tmp19_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp18_);
				_tmp20_ = _tmp19_;
				_tmp21_ = music_playlist_get_rowid (_tmp20_);
				_tmp22_ = _tmp21_;
				music_library_remove_smart_playlist (_tmp17_, _tmp22_);
			}
		}
		_g_object_unref0 (playlistview);
	}
}

static void
___lambda150__music_source_list_view_playlist_remove_clicked (MusicSourceListView* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
	__lambda150_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda151_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
		MusicPlaylist* playlist = NULL;
		MusicPlaylistViewWrapper* _tmp4_;
		MusicPlaylist* _tmp5_;
		MusicPlaylist* _tmp6_;
		MusicPlaylist* _tmp7_;
		MusicPlaylist* _tmp8_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
		playlistview = _tmp0_;
		_tmp1_ = playlistview;
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
		_tmp3_ = _tmp2_;
		if (_tmp3_ != MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
			_g_object_unref0 (playlistview);
			return;
		}
		_tmp4_ = playlistview;
		_tmp5_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = _g_object_ref0 (_tmp6_);
		playlist = _tmp7_;
		_tmp8_ = playlist;
		if (_tmp8_ != NULL) {
			MusicStaticPlaylist* new_playlist = NULL;
			MusicStaticPlaylist* _tmp9_;
			MusicStaticPlaylist* _tmp10_;
			MusicLocalLibrary* _tmp11_;
			MusicLocalLibrary* _tmp12_;
			GeeCollection* _tmp13_;
			GeeCollection* _tmp14_;
			MusicPlaylist* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			MusicStaticPlaylist* _tmp20_;
			MusicPlaylist* _tmp21_;
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			MusicLocalLibrary* _tmp24_;
			MusicLocalLibrary* _tmp25_;
			MusicStaticPlaylist* _tmp26_;
			_tmp9_ = music_static_playlist_new ();
			new_playlist = _tmp9_;
			_tmp10_ = new_playlist;
			_tmp11_ = music_library_window_get_library_manager (self);
			_tmp12_ = _tmp11_;
			_tmp13_ = music_library_get_playlists ((MusicLibrary*) _tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = playlist;
			_tmp16_ = music_playlist_get_name (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = music_playlists_utils_get_new_playlist_name (_tmp14_, _tmp17_);
			_tmp19_ = _tmp18_;
			music_playlist_set_name ((MusicPlaylist*) _tmp10_, _tmp19_);
			_g_free0 (_tmp19_);
			_g_object_unref0 (_tmp14_);
			_tmp20_ = new_playlist;
			_tmp21_ = playlist;
			_tmp22_ = music_playlist_get_medias (_tmp21_);
			_tmp23_ = _tmp22_;
			music_playlist_add_medias ((MusicPlaylist*) _tmp20_, (GeeCollection*) _tmp23_);
			_tmp24_ = music_library_window_get_library_manager (self);
			_tmp25_ = _tmp24_;
			_tmp26_ = new_playlist;
			music_library_add_playlist ((MusicLibrary*) _tmp25_, _tmp26_);
			_g_object_unref0 (new_playlist);
		}
		_g_object_unref0 (playlist);
		_g_object_unref0 (playlistview);
	}
}

static void
___lambda151__music_source_list_view_playlist_save_clicked (MusicSourceListView* _sender,
                                                            GtkGrid* view,
                                                            gpointer self)
{
	__lambda151_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda152_ (MusicLibraryWindow* self,
              GtkGrid* view)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
		playlistview = _tmp0_;
		_tmp1_ = playlistview;
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
		_tmp3_ = _tmp2_;
		switch (_tmp3_) {
			case MUSIC_VIEW_WRAPPER_HINT_PLAYLIST:
			case MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
			{
				MusicPlaylistViewWrapper* _tmp4_;
				MusicPlaylist* _tmp5_;
				MusicPlaylist* _tmp6_;
				_tmp4_ = playlistview;
				_tmp5_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp4_);
				_tmp6_ = _tmp5_;
				music_playlists_utils_export_playlist (_tmp6_);
				break;
			}
			case MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
			{
				MusicPlaylistViewWrapper* _tmp7_;
				MusicPlaylist* _tmp8_;
				MusicPlaylist* _tmp9_;
				_tmp7_ = playlistview;
				_tmp8_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp7_);
				_tmp9_ = _tmp8_;
				music_playlists_utils_export_playlist (_tmp9_);
				break;
			}
			default:
			break;
		}
		_g_object_unref0 (playlistview);
	}
}

static void
___lambda152__music_source_list_view_playlist_export_clicked (MusicSourceListView* _sender,
                                                              GtkGrid* view,
                                                              gpointer self)
{
	__lambda152_ ((MusicLibraryWindow*) self, view);
}

static void
__lambda153_ (MusicLibraryWindow* self,
              GtkGrid* view,
              gchar** uris,
              gint uris_length1)
{
	g_return_if_fail (view != NULL);
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view)) {
		MusicPlaylistViewWrapper* playlistview = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		MusicPlaylistViewWrapper* _tmp1_;
		MusicViewWrapperHint _tmp2_;
		MusicViewWrapperHint _tmp3_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_PLAYLIST_VIEW_WRAPPER, MusicPlaylistViewWrapper));
		playlistview = _tmp0_;
		_tmp1_ = playlistview;
		_tmp2_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp1_);
		_tmp3_ = _tmp2_;
		if (_tmp3_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
			MusicLibrary* library = NULL;
			MusicPlaylistViewWrapper* _tmp4_;
			MusicLibrary* _tmp5_;
			MusicLibrary* _tmp6_;
			MusicLibrary* _tmp7_;
			MusicPlaylist* playlist = NULL;
			MusicPlaylistViewWrapper* _tmp8_;
			MusicPlaylist* _tmp9_;
			MusicPlaylist* _tmp10_;
			MusicPlaylist* _tmp11_;
			MusicPlaylist* _tmp12_;
			GeeHashSet* uri_set = NULL;
			GeeHashSet* _tmp13_;
			GeeCollection* media_list = NULL;
			MusicLibrary* _tmp17_;
			GeeHashSet* _tmp18_;
			GeeCollection* _tmp19_;
			MusicPlaylist* _tmp20_;
			GeeCollection* _tmp21_;
			_tmp4_ = playlistview;
			_tmp5_ = music_view_wrapper_get_library ((MusicViewWrapper*) _tmp4_);
			_tmp6_ = _tmp5_;
			_tmp7_ = _g_object_ref0 (_tmp6_);
			library = _tmp7_;
			_tmp8_ = playlistview;
			_tmp9_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = _g_object_ref0 (_tmp10_);
			playlist = _tmp11_;
			_tmp12_ = playlist;
			if (_tmp12_ == NULL) {
				_g_object_unref0 (playlist);
				_g_object_unref0 (library);
				_g_object_unref0 (playlistview);
				return;
			}
			_tmp13_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
			uri_set = _tmp13_;
			{
				gchar** uri_collection = NULL;
				gint uri_collection_length1 = 0;
				gint _uri_collection_size_ = 0;
				gint uri_it = 0;
				uri_collection = uris;
				uri_collection_length1 = uris_length1;
				for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
					gchar* _tmp14_;
					gchar* uri = NULL;
					_tmp14_ = g_strdup (uri_collection[uri_it]);
					uri = _tmp14_;
					{
						GeeHashSet* _tmp15_;
						const gchar* _tmp16_;
						_tmp15_ = uri_set;
						_tmp16_ = uri;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
						_g_free0 (uri);
					}
				}
			}
			_tmp17_ = library;
			_tmp18_ = uri_set;
			_tmp19_ = music_library_medias_from_uris (_tmp17_, (GeeCollection*) _tmp18_);
			media_list = _tmp19_;
			_tmp20_ = playlist;
			_tmp21_ = media_list;
			music_playlist_add_medias (_tmp20_, _tmp21_);
			_g_object_unref0 (media_list);
			_g_object_unref0 (uri_set);
			_g_object_unref0 (playlist);
			_g_object_unref0 (library);
		}
		_g_object_unref0 (playlistview);
	}
}

static void
___lambda153__music_source_list_view_playlist_media_added (MusicSourceListView* _sender,
                                                           GtkGrid* view,
                                                           gchar** uris,
                                                           gint uris_length1,
                                                           gpointer self)
{
	__lambda153_ ((MusicLibraryWindow*) self, view, uris, uris_length1);
}

static void
__lambda154_ (MusicLibraryWindow* self)
{
	GError* _inner_error0_ = NULL;
	{
		GeeHashMap* _tmp0_ = NULL;
		GeeHashMap* _tmp1_;
		MusicLocalLibrary* _tmp2_;
		MusicLocalLibrary* _tmp3_;
		_tmp1_ = music_playlists_utils_get_playlists_to_import ("Playlist", &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = music_library_window_get_library_manager (self);
		_tmp3_ = _tmp2_;
		music_playlists_utils_import_from_playlist_file_info (_tmp0_, (MusicLibrary*) _tmp3_);
		music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("LibraryWindow.vala:488: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda154__music_source_list_view_playlist_import_clicked (MusicSourceListView* _sender,
                                                              gpointer self)
{
	__lambda154_ ((MusicLibraryWindow*) self);
}

static void
_music_library_window_search_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                                gpointer self)
{
	music_library_window_search_entry_activate ((MusicLibraryWindow*) self);
}

static void
__lambda162_ (MusicLibraryWindow* self)
{
	GtkSearchEntry* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	_tmp0_ = self->priv->_search_entry;
	_tmp1_ = gtk_entry_get_text_length ((GtkEntry*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != ((guint) 1)) {
		MusicLibrariesManager* _tmp3_;
		GtkSearchEntry* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp3_ = music_libraries_manager;
		_tmp4_ = self->priv->_search_entry;
		_tmp5_ = gtk_entry_get_text ((GtkEntry*) _tmp4_);
		_tmp6_ = _tmp5_;
		music_libraries_manager_search_for_string (_tmp3_, _tmp6_);
	}
}

static void
___lambda162__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                               gpointer self)
{
	__lambda162_ ((MusicLibraryWindow*) self);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
	g_return_val_if_fail (str != NULL, 0LL);
	result = g_ascii_strtoll (str, NULL, _base);
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

void
music_library_window_build_ui (MusicLibraryWindow* self)
{
	Block3Data* _data3_;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint window_x = 0;
	gint window_y = 0;
	gint window_width = 0;
	gint window_height = 0;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gboolean _tmp12_ = FALSE;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
	GtkMenuItem* import_menuitem = NULL;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* preferences_menuitem = NULL;
	GtkMenuItem* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenu* menu = NULL;
	GtkMenu* _tmp19_;
	GtkMenu* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenu* _tmp22_;
	GtkSeparatorMenuItem* _tmp23_;
	GtkSeparatorMenuItem* _tmp24_;
	GtkMenu* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenu* _tmp27_;
	GtkMenuButton* menu_button = NULL;
	GtkMenuButton* _tmp28_;
	GtkMenuButton* _tmp29_;
	GtkImage* _tmp30_;
	GtkImage* _tmp31_;
	GtkMenuButton* _tmp32_;
	GtkMenu* _tmp33_;
	GtkMenuButton* _tmp34_;
	GtkButton* previous_button = NULL;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkButton* next_button = NULL;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkSearchEntry* _tmp44_;
	GtkSearchEntry* _tmp45_;
	GtkSearchEntry* _tmp46_;
	GtkSearchEntry* _tmp47_;
	MusicWidgetsViewSelector* _tmp48_;
	MusicWidgetsViewSelector* _tmp49_;
	MusicWidgetsViewSelector* _tmp50_;
	MusicWidgetsViewSelector* _tmp51_;
	MusicWidgetsViewSelector* _tmp52_;
	MusicTopDisplay* _tmp53_;
	MusicTopDisplay* _tmp54_;
	MusicTopDisplay* _tmp55_;
	HdyHeaderBar* headerbar = NULL;
	HdyHeaderBar* _tmp56_;
	HdyHeaderBar* _tmp57_;
	HdyHeaderBar* _tmp58_;
	GtkButton* _tmp59_;
	HdyHeaderBar* _tmp60_;
	GtkButton* _tmp61_;
	HdyHeaderBar* _tmp62_;
	GtkButton* _tmp63_;
	HdyHeaderBar* _tmp64_;
	MusicWidgetsViewSelector* _tmp65_;
	HdyHeaderBar* _tmp66_;
	GtkMenuButton* _tmp67_;
	HdyHeaderBar* _tmp68_;
	GtkSearchEntry* _tmp69_;
	HdyHeaderBar* _tmp70_;
	HdyHeaderBar* _tmp71_;
	MusicTopDisplay* _tmp72_;
	HdyHeaderBar* _tmp73_;
	MusicViewStack* _tmp74_;
	MusicViewStack* _tmp75_;
	MusicSourceListView* _tmp76_;
	MusicSourceListView* _tmp77_;
	MusicWidgetsStatusBar* _tmp78_;
	MusicWidgetsStatusBar* _tmp79_;
	GtkGrid* sidebar_grid = NULL;
	GtkGrid* _tmp80_;
	GtkGrid* _tmp81_;
	GtkGrid* _tmp82_;
	GtkStyleContext* _tmp83_;
	GtkGrid* _tmp84_;
	MusicSourceListView* _tmp85_;
	GtkGrid* _tmp86_;
	MusicWidgetsStatusBar* _tmp87_;
	GtkPaned* main_hpaned = NULL;
	GtkPaned* _tmp88_;
	GtkPaned* _tmp89_;
	GtkGrid* _tmp90_;
	GtkPaned* _tmp91_;
	MusicViewStack* _tmp92_;
	GtkPaned* _tmp93_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp94_;
	GtkGrid* _tmp95_;
	HdyHeaderBar* _tmp96_;
	GtkGrid* _tmp97_;
	GtkPaned* _tmp98_;
	GtkGrid* _tmp99_;
	GtkGrid* _tmp100_;
	GSettings* _tmp101_;
	GSettings* _tmp102_;
	GtkPaned* _tmp103_;
	MusicLocalLibrary* _tmp104_;
	MusicLocalLibrary* _tmp105_;
	MusicLibrariesManager* _tmp106_;
	MusicSourceListView* _tmp107_;
	MusicSourceListView* _tmp108_;
	MusicSourceListView* _tmp109_;
	MusicSourceListView* _tmp110_;
	MusicSourceListView* _tmp111_;
	MusicSourceListView* _tmp112_;
	MusicSourceListView* _tmp113_;
	MusicSourceListView* _tmp114_;
	MusicSourceListView* _tmp115_;
	MusicSourceListView* _tmp116_;
	MusicSourceListView* _tmp117_;
	MusicSourceListView* _tmp118_;
	MusicSourceListView* _tmp119_;
	MusicSourceListView* _tmp120_;
	MusicSourceListView* _tmp121_;
	MusicSourceListView* _tmp122_;
	MusicWidgetsViewSelector* _tmp123_;
	GSettings* _tmp124_;
	GSettings* _tmp125_;
	MusicLocalLibrary* _tmp126_;
	MusicLocalLibrary* _tmp127_;
	gchar* search_string = NULL;
	GSettings* _tmp128_;
	GSettings* _tmp129_;
	gchar* _tmp130_;
	GtkSearchEntry* _tmp131_;
	GtkSearchEntry* _tmp132_;
	GtkSearchEntry* _tmp133_;
	const gchar* _tmp134_;
	gint64 last_playing_id = 0LL;
	GSettings* _tmp135_;
	GSettings* _tmp136_;
	MusicLibrariesManager* _tmp148_;
	const gchar* _tmp149_;
	gchar* last_playlist_playing = NULL;
	GSettings* _tmp150_;
	GSettings* _tmp151_;
	gchar* _tmp152_;
	const gchar* _tmp153_;
	g_return_if_fail (self != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	g_object_set ((GtkWidget*) self, "height-request", 350, NULL);
	g_object_set ((GtkWidget*) self, "width-request", 400, NULL);
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_application_get_application_id ((GApplication*) _tmp1_);
	_tmp3_ = _tmp2_;
	gtk_window_set_icon_name ((GtkWindow*) self, _tmp3_);
	gtk_window_set_title ((GtkWindow*) self, _ ("Music"));
	_tmp4_ = music_app_get_saved_state ();
	_tmp5_ = _tmp4_;
	g_settings_get (_tmp5_, "window-position", "(ii)", &_tmp6_, &_tmp7_);
	window_x = _tmp6_;
	window_y = _tmp7_;
	_tmp8_ = music_app_get_saved_state ();
	_tmp9_ = _tmp8_;
	g_settings_get (_tmp9_, "window-size", "(ii)", &_tmp10_, &_tmp11_);
	window_width = _tmp10_;
	window_height = _tmp11_;
	gtk_window_set_default_size ((GtkWindow*) self, window_width, window_height);
	if (window_x != -1) {
		_tmp12_ = TRUE;
	} else {
		_tmp12_ = window_y != -1;
	}
	if (_tmp12_) {
		gtk_window_move ((GtkWindow*) self, window_x, window_y);
	}
	_tmp13_ = music_app_get_saved_state ();
	_tmp14_ = _tmp13_;
	if (g_settings_get_boolean (_tmp14_, "window-maximized")) {
		gtk_window_maximize ((GtkWindow*) self);
	}
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) _music_library_window_on_quit_gtk_widget_destroy, self, 0);
	_tmp15_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library…"));
	g_object_ref_sink (_tmp15_);
	import_menuitem = _tmp15_;
	_tmp16_ = import_menuitem;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp16_, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_IMPORT);
	_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Preferences"));
	g_object_ref_sink (_tmp17_);
	preferences_menuitem = _tmp17_;
	_tmp18_ = preferences_menuitem;
	g_signal_connect_object (_tmp18_, "activate", (GCallback) _music_library_window_edit_preferences_click_gtk_menu_item_activate, self, 0);
	_tmp19_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp19_);
	menu = _tmp19_;
	_tmp20_ = menu;
	_tmp21_ = import_menuitem;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp20_, _tmp21_);
	_tmp22_ = menu;
	_tmp23_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp23_);
	_tmp24_ = _tmp23_;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp22_, (GtkMenuItem*) _tmp24_);
	_g_object_unref0 (_tmp24_);
	_tmp25_ = menu;
	_tmp26_ = preferences_menuitem;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp25_, _tmp26_);
	_tmp27_ = menu;
	gtk_widget_show_all ((GtkWidget*) _tmp27_);
	_tmp28_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp28_);
	menu_button = _tmp28_;
	_tmp29_ = menu_button;
	_tmp30_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp30_);
	_tmp31_ = _tmp30_;
	gtk_button_set_image ((GtkButton*) _tmp29_, (GtkWidget*) _tmp31_);
	_g_object_unref0 (_tmp31_);
	_tmp32_ = menu_button;
	_tmp33_ = menu;
	gtk_menu_button_set_popup (_tmp32_, _tmp33_);
	_tmp34_ = menu_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp34_, GTK_ALIGN_CENTER);
	_tmp35_ = (GtkButton*) gtk_button_new_from_icon_name ("media-skip-backward-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp35_);
	previous_button = _tmp35_;
	_tmp36_ = previous_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp36_, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_PLAY_PREVIOUS);
	_tmp37_ = previous_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp37_, _ ("Previous"));
	_tmp38_ = (GtkButton*) gtk_button_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp38_);
	_data3_->play_button = _tmp38_;
	_tmp39_ = _data3_->play_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp39_, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp40_ = _data3_->play_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp40_, _ ("Play"));
	_tmp41_ = (GtkButton*) gtk_button_new_from_icon_name ("media-skip-forward-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp41_);
	next_button = _tmp41_;
	_tmp42_ = next_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp42_, MUSIC_LIBRARY_WINDOW_ACTION_PREFIX MUSIC_LIBRARY_WINDOW_ACTION_PLAY_NEXT);
	_tmp43_ = next_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp43_, _ ("Next"));
	_tmp44_ = (GtkSearchEntry*) gtk_search_entry_new ();
	g_object_ref_sink (_tmp44_);
	_tmp45_ = _tmp44_;
	music_library_window_set_search_entry (self, _tmp45_);
	_g_object_unref0 (_tmp45_);
	_tmp46_ = self->priv->_search_entry;
	gtk_widget_set_valign ((GtkWidget*) _tmp46_, GTK_ALIGN_CENTER);
	_tmp47_ = self->priv->_search_entry;
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp47_, _ ("Search Music"));
	_tmp48_ = music_widgets_view_selector_new ();
	g_object_ref_sink (_tmp48_);
	_tmp49_ = _tmp48_;
	music_library_window_set_view_selector (self, _tmp49_);
	_g_object_unref0 (_tmp49_);
	_tmp50_ = self->priv->_view_selector;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp50_, 12);
	_tmp51_ = self->priv->_view_selector;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp51_, 6);
	_tmp52_ = self->priv->_view_selector;
	gtk_widget_set_valign ((GtkWidget*) _tmp52_, GTK_ALIGN_CENTER);
	_tmp53_ = music_top_display_new ();
	g_object_ref_sink (_tmp53_);
	_g_object_unref0 (self->priv->top_display);
	self->priv->top_display = _tmp53_;
	_tmp54_ = self->priv->top_display;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp54_, 30);
	_tmp55_ = self->priv->top_display;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp55_, 30);
	_tmp56_ = (HdyHeaderBar*) hdy_header_bar_new ();
	g_object_ref_sink (_tmp56_);
	headerbar = _tmp56_;
	_tmp57_ = headerbar;
	hdy_header_bar_set_show_close_button (_tmp57_, TRUE);
	_tmp58_ = headerbar;
	_tmp59_ = previous_button;
	hdy_header_bar_pack_start (_tmp58_, (GtkWidget*) _tmp59_);
	_tmp60_ = headerbar;
	_tmp61_ = _data3_->play_button;
	hdy_header_bar_pack_start (_tmp60_, (GtkWidget*) _tmp61_);
	_tmp62_ = headerbar;
	_tmp63_ = next_button;
	hdy_header_bar_pack_start (_tmp62_, (GtkWidget*) _tmp63_);
	_tmp64_ = headerbar;
	_tmp65_ = self->priv->_view_selector;
	hdy_header_bar_pack_start (_tmp64_, (GtkWidget*) _tmp65_);
	_tmp66_ = headerbar;
	_tmp67_ = menu_button;
	hdy_header_bar_pack_end (_tmp66_, (GtkWidget*) _tmp67_);
	_tmp68_ = headerbar;
	_tmp69_ = self->priv->_search_entry;
	hdy_header_bar_pack_end (_tmp68_, (GtkWidget*) _tmp69_);
	_tmp70_ = headerbar;
	hdy_header_bar_set_title (_tmp70_, _ ("Music"));
	_tmp71_ = headerbar;
	_tmp72_ = self->priv->top_display;
	hdy_header_bar_set_custom_title (_tmp71_, (GtkWidget*) _tmp72_);
	_tmp73_ = headerbar;
	gtk_widget_show_all ((GtkWidget*) _tmp73_);
	_tmp74_ = music_view_stack_new ();
	g_object_ref_sink (_tmp74_);
	_tmp75_ = _tmp74_;
	music_library_window_set_view_stack (self, _tmp75_);
	_g_object_unref0 (_tmp75_);
	_tmp76_ = music_source_list_view_new ();
	g_object_ref_sink (_tmp76_);
	_tmp77_ = _tmp76_;
	music_library_window_set_source_list_view (self, _tmp77_);
	_g_object_unref0 (_tmp77_);
	_tmp78_ = music_widgets_status_bar_new ();
	g_object_ref_sink (_tmp78_);
	_tmp79_ = _tmp78_;
	music_library_window_set_statusbar (self, _tmp79_);
	_g_object_unref0 (_tmp79_);
	_tmp80_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp80_);
	sidebar_grid = _tmp80_;
	_tmp81_ = sidebar_grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp81_, GTK_ORIENTATION_VERTICAL);
	_tmp82_ = sidebar_grid;
	_tmp83_ = gtk_widget_get_style_context ((GtkWidget*) _tmp82_);
	gtk_style_context_add_class (_tmp83_, GTK_STYLE_CLASS_SIDEBAR);
	_tmp84_ = sidebar_grid;
	_tmp85_ = self->priv->_source_list_view;
	gtk_container_add ((GtkContainer*) _tmp84_, (GtkWidget*) _tmp85_);
	_tmp86_ = sidebar_grid;
	_tmp87_ = self->priv->_statusbar;
	gtk_container_add ((GtkContainer*) _tmp86_, (GtkWidget*) _tmp87_);
	_tmp88_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp88_);
	main_hpaned = _tmp88_;
	_tmp89_ = main_hpaned;
	_tmp90_ = sidebar_grid;
	gtk_paned_pack1 (_tmp89_, (GtkWidget*) _tmp90_, FALSE, FALSE);
	_tmp91_ = main_hpaned;
	_tmp92_ = self->priv->_view_stack;
	gtk_paned_pack2 (_tmp91_, (GtkWidget*) _tmp92_, TRUE, FALSE);
	_tmp93_ = main_hpaned;
	gtk_widget_show_all ((GtkWidget*) _tmp93_);
	_tmp94_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp94_);
	grid = _tmp94_;
	_tmp95_ = grid;
	_tmp96_ = headerbar;
	gtk_grid_attach (_tmp95_, (GtkWidget*) _tmp96_, 0, 0, 1, 1);
	_tmp97_ = grid;
	_tmp98_ = main_hpaned;
	gtk_grid_attach (_tmp97_, (GtkWidget*) _tmp98_, 0, 1, 1, 1);
	_tmp99_ = grid;
	gtk_widget_show_all ((GtkWidget*) _tmp99_);
	_tmp100_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp100_);
	_tmp101_ = music_app_get_saved_state ();
	_tmp102_ = _tmp101_;
	_tmp103_ = main_hpaned;
	g_settings_bind (_tmp102_, "sidebar-width", (GObject*) _tmp103_, "position", G_SETTINGS_BIND_DEFAULT);
	g_signal_connect_data ((GActionGroup*) self, "action-state-changed", (GCallback) ___lambda134__g_action_group_action_state_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp104_ = music_library_window_get_library_manager (self);
	_tmp105_ = _tmp104_;
	g_signal_connect_object ((MusicLibrary*) _tmp105_, "search-finished", (GCallback) ___lambda135__music_library_search_finished, self, 0);
	_tmp106_ = music_libraries_manager;
	g_signal_connect_object (_tmp106_, "library-added", (GCallback) ___lambda136__music_libraries_manager_library_added, self, 0);
	_tmp107_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp107_, "selection-changed", (GCallback) ___lambda138__music_source_list_view_selection_changed, self, 0);
	_tmp108_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp108_, "activated", (GCallback) ___lambda139__music_source_list_view_activated, self, 0);
	_tmp109_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp109_, "item-action-activated", (GCallback) ___lambda140__music_source_list_view_item_action_activated, self, 0);
	_tmp110_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp110_, "edited", (GCallback) _music_library_window_playlist_name_edited_music_source_list_view_edited, self, 0);
	_tmp111_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp111_, "playlist-rename-clicked", (GCallback) ___lambda143__music_source_list_view_playlist_rename_clicked, self, 0);
	_tmp112_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp112_, "playlist-edit-clicked", (GCallback) ___lambda144__music_source_list_view_playlist_edit_clicked, self, 0);
	_tmp113_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp113_, "playlist-remove-clicked", (GCallback) ___lambda145__music_source_list_view_playlist_remove_clicked, self, 0);
	_tmp114_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp114_, "device-import-clicked", (GCallback) ___lambda146__music_source_list_view_device_import_clicked, self, 0);
	_tmp115_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp115_, "device-new-playlist-clicked", (GCallback) ___lambda147__music_source_list_view_device_new_playlist_clicked, self, 0);
	_tmp116_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp116_, "device-sync-clicked", (GCallback) ___lambda148__music_source_list_view_device_sync_clicked, self, 0);
	_tmp117_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp117_, "device-eject-clicked", (GCallback) ___lambda149__music_source_list_view_device_eject_clicked, self, 0);
	_tmp118_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp118_, "playlist-remove-clicked", (GCallback) ___lambda150__music_source_list_view_playlist_remove_clicked, self, 0);
	_tmp119_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp119_, "playlist-save-clicked", (GCallback) ___lambda151__music_source_list_view_playlist_save_clicked, self, 0);
	_tmp120_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp120_, "playlist-export-clicked", (GCallback) ___lambda152__music_source_list_view_playlist_export_clicked, self, 0);
	_tmp121_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp121_, "playlist-media-added", (GCallback) ___lambda153__music_source_list_view_playlist_media_added, self, 0);
	_tmp122_ = self->priv->_source_list_view;
	g_signal_connect_object (_tmp122_, "playlist-import-clicked", (GCallback) ___lambda154__music_source_list_view_playlist_import_clicked, self, 0);
	music_library_window_load_playlists (self);
	music_library_window_update_sensitivities_sync (self);
	_tmp123_ = self->priv->_view_selector;
	_tmp124_ = music_app_get_saved_state ();
	_tmp125_ = _tmp124_;
	music_widgets_view_selector_set_selected (_tmp123_, (MusicWidgetsViewSelectorMode) g_settings_get_int (_tmp125_, "view-mode"));
	_tmp126_ = music_library_window_get_library_manager (self);
	_tmp127_ = _tmp126_;
	music_local_library_rescan_music_folder (_tmp127_);
	music_library_window_set_initialization_finished (self, TRUE);
	_tmp128_ = music_app_get_saved_state ();
	_tmp129_ = _tmp128_;
	_tmp130_ = g_settings_get_string (_tmp129_, "search-string");
	search_string = _tmp130_;
	_tmp131_ = self->priv->_search_entry;
	g_signal_connect_object ((GtkEntry*) _tmp131_, "activate", (GCallback) _music_library_window_search_entry_activate_gtk_entry_activate, self, 0);
	_tmp132_ = self->priv->_search_entry;
	g_signal_connect_object (_tmp132_, "search-changed", (GCallback) ___lambda162__gtk_search_entry_search_changed, self, 0);
	_tmp133_ = self->priv->_search_entry;
	_tmp134_ = search_string;
	gtk_entry_set_text ((GtkEntry*) _tmp133_, _tmp134_);
	_tmp135_ = music_app_get_saved_state ();
	_tmp136_ = _tmp135_;
	last_playing_id = g_settings_get_int64 (_tmp136_, "last-media-playing");
	if (last_playing_id >= ((gint64) 0)) {
		MusicMedia* last_playing_media = NULL;
		MusicLocalLibrary* _tmp137_;
		MusicLocalLibrary* _tmp138_;
		MusicMedia* _tmp139_;
		gboolean _tmp140_ = FALSE;
		MusicMedia* _tmp141_;
		_tmp137_ = music_library_window_get_library_manager (self);
		_tmp138_ = _tmp137_;
		_tmp139_ = music_library_media_from_id ((MusicLibrary*) _tmp138_, last_playing_id);
		last_playing_media = _tmp139_;
		_tmp141_ = last_playing_media;
		if (_tmp141_ != NULL) {
			MusicMedia* _tmp142_;
			GFile* _tmp143_;
			GFile* _tmp144_;
			_tmp142_ = last_playing_media;
			_tmp143_ = music_media_get_file (_tmp142_);
			_tmp144_ = _tmp143_;
			_tmp140_ = g_file_query_exists (_tmp144_, NULL);
		} else {
			_tmp140_ = FALSE;
		}
		if (_tmp140_) {
			MusicPlaybackManager* _tmp145_;
			MusicPlaybackManager* _tmp146_;
			MusicMedia* _tmp147_;
			_tmp145_ = music_app_get_player ();
			_tmp146_ = _tmp145_;
			_tmp147_ = last_playing_media;
			music_playback_manager_play_media (_tmp146_, _tmp147_);
		}
		_g_object_unref0 (last_playing_media);
	}
	_tmp148_ = music_libraries_manager;
	_tmp149_ = search_string;
	music_libraries_manager_search_for_string (_tmp148_, _tmp149_);
	_tmp150_ = music_app_get_saved_state ();
	_tmp151_ = _tmp150_;
	_tmp152_ = g_settings_get_string (_tmp151_, "last-playlist-playing");
	last_playlist_playing = _tmp152_;
	_tmp153_ = last_playlist_playing;
	if (g_strcmp0 (_tmp153_, "") != 0) {
		MusicPlaylist* p = NULL;
		const gchar* _tmp154_;
		MusicPlaylist* _tmp169_;
		p = NULL;
		_tmp154_ = last_playlist_playing;
		if (string_contains (_tmp154_, "s")) {
			gint64 rowid = 0LL;
			const gchar* _tmp155_;
			gchar* _tmp156_;
			gchar* _tmp157_;
			gint64 _tmp158_;
			MusicLocalLibrary* _tmp159_;
			MusicLocalLibrary* _tmp160_;
			MusicSmartPlaylist* _tmp161_;
			_tmp155_ = last_playlist_playing;
			_tmp156_ = string_replace (_tmp155_, "s", "");
			_tmp157_ = _tmp156_;
			_tmp158_ = int64_parse (_tmp157_, (guint) 0);
			_g_free0 (_tmp157_);
			rowid = _tmp158_;
			_tmp159_ = music_library_window_get_library_manager (self);
			_tmp160_ = _tmp159_;
			_tmp161_ = music_library_smart_playlist_from_id ((MusicLibrary*) _tmp160_, rowid);
			_g_object_unref0 (p);
			p = (MusicPlaylist*) _tmp161_;
		} else {
			gint64 rowid = 0LL;
			const gchar* _tmp162_;
			gchar* _tmp163_;
			gchar* _tmp164_;
			gint64 _tmp165_;
			MusicLocalLibrary* _tmp166_;
			MusicLocalLibrary* _tmp167_;
			MusicStaticPlaylist* _tmp168_;
			_tmp162_ = last_playlist_playing;
			_tmp163_ = string_replace (_tmp162_, "p", "");
			_tmp164_ = _tmp163_;
			_tmp165_ = int64_parse (_tmp164_, (guint) 0);
			_g_free0 (_tmp164_);
			rowid = _tmp165_;
			_tmp166_ = music_library_window_get_library_manager (self);
			_tmp167_ = _tmp166_;
			_tmp168_ = music_library_playlist_from_id ((MusicLibrary*) _tmp167_, rowid);
			_g_object_unref0 (p);
			p = (MusicPlaylist*) _tmp168_;
		}
		_tmp169_ = p;
		if (_tmp169_ != NULL) {
			MusicPlaylist* _tmp170_;
			_tmp170_ = p;
			music_library_window_show_playlist_view (self, _tmp170_);
		} else {
			MusicLocalLibrary* _tmp171_;
			MusicLocalLibrary* _tmp172_;
			MusicStaticPlaylist* _tmp173_;
			_tmp171_ = music_library_window_get_library_manager (self);
			_tmp172_ = _tmp171_;
			_tmp173_ = _tmp172_->p_music;
			music_library_window_show_playlist_view (self, (MusicPlaylist*) _tmp173_);
		}
		_g_object_unref0 (p);
	} else {
		MusicLocalLibrary* _tmp174_;
		MusicLocalLibrary* _tmp175_;
		MusicStaticPlaylist* _tmp176_;
		_tmp174_ = music_library_window_get_library_manager (self);
		_tmp175_ = _tmp174_;
		_tmp176_ = _tmp175_->p_music;
		music_library_window_show_playlist_view (self, (MusicPlaylist*) _tmp176_);
	}
	_g_free0 (last_playlist_playing);
	_g_free0 (search_string);
	_g_object_unref0 (grid);
	_g_object_unref0 (main_hpaned);
	_g_object_unref0 (sidebar_grid);
	_g_object_unref0 (headerbar);
	_g_object_unref0 (next_button);
	_g_object_unref0 (previous_button);
	_g_object_unref0 (menu_button);
	_g_object_unref0 (menu);
	_g_object_unref0 (preferences_menuitem);
	_g_object_unref0 (import_menuitem);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

/**
     * Notifications
     */
void
music_library_window_show_notification (MusicLibraryWindow* self,
                                        const gchar* title,
                                        const gchar* body,
                                        GIcon* icon,
                                        GNotificationPriority priority,
                                        const gchar* context)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GNotification* notification = NULL;
	GNotification* _tmp2_;
	GNotification* _tmp3_;
	GNotification* _tmp4_;
	GNotification* _tmp11_;
	GApplication* _tmp12_;
	GNotification* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (body != NULL);
	g_return_if_fail (context != NULL);
	g_object_get ((GtkWindow*) self, "is-active", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		return;
	}
	_tmp2_ = g_notification_new (title);
	notification = _tmp2_;
	_tmp3_ = notification;
	g_notification_set_body (_tmp3_, body);
	_tmp4_ = notification;
	g_notification_set_priority (_tmp4_, priority);
	if (icon != NULL) {
		GNotification* _tmp5_;
		_tmp5_ = notification;
		g_notification_set_icon (_tmp5_, icon);
	} else {
		GNotification* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GThemedIcon* _tmp9_;
		GThemedIcon* _tmp10_;
		_tmp6_ = notification;
		_tmp7_ = gtk_window_get_icon_name ((GtkWindow*) self);
		_tmp8_ = _tmp7_;
		_tmp9_ = (GThemedIcon*) g_themed_icon_new (_tmp8_);
		_tmp10_ = _tmp9_;
		g_notification_set_icon (_tmp6_, (GIcon*) _tmp10_);
		_g_object_unref0 (_tmp10_);
	}
	_tmp11_ = notification;
	g_notification_set_default_action (_tmp11_, "app.present");
	_tmp12_ = g_application_get_default ();
	_tmp13_ = notification;
	g_application_send_notification (_tmp12_, context, _tmp13_);
	_g_object_unref0 (notification);
}

static void
music_library_window_show_notification_from_media_async_data_free (gpointer _data)
{
	MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->media);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicLibraryWindowShowNotificationFromMediaAsyncData, _data_);
}

static void
music_library_window_show_notification_from_media_async (MusicLibraryWindow* self,
                                                         MusicMedia* media,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_;
	MusicLibraryWindow* _tmp0_;
	MusicMedia* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_data_ = g_slice_new0 (MusicLibraryWindowShowNotificationFromMediaAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_library_window_show_notification_from_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (media);
	_g_object_unref0 (_data_->media);
	_data_->media = _tmp1_;
	music_library_window_show_notification_from_media_async_co (_data_);
}

static void
music_library_window_show_notification_from_media_finish (MusicLibraryWindow* self,
                                                          GAsyncResult* _res_)
{
	MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
music_library_window_show_notification_from_media_async_co (MusicLibraryWindowShowNotificationFromMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (_data_->media == NULL) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp0_ = _data_->self->priv->notification_cancellable;
	if (_data_->_tmp0_ != NULL) {
		_data_->_tmp1_ = _data_->self->priv->notification_cancellable;
		g_cancellable_cancel (_data_->_tmp1_);
	}
	_data_->_tmp2_ = g_cancellable_new ();
	_g_object_unref0 (_data_->self->priv->notification_cancellable);
	_data_->self->priv->notification_cancellable = _data_->_tmp2_;
	_data_->_tmp3_ = music_media_get_display_title (_data_->media);
	_data_->primary_text = _data_->_tmp3_;
	_data_->_tmp4_ = g_string_new ("");
	_data_->secondary_text = _data_->_tmp4_;
	_data_->_tmp5_ = _data_->secondary_text;
	_data_->_tmp6_ = music_media_get_display_artist (_data_->media);
	_data_->_tmp7_ = _data_->_tmp6_;
	g_string_append (_data_->_tmp5_, _data_->_tmp7_);
	_g_free0 (_data_->_tmp7_);
	_data_->_tmp8_ = _data_->secondary_text;
	g_string_append (_data_->_tmp8_, "\n");
	_data_->_tmp9_ = _data_->secondary_text;
	_data_->_tmp10_ = music_media_get_display_album (_data_->media);
	_data_->_tmp11_ = _data_->_tmp10_;
	g_string_append (_data_->_tmp9_, _data_->_tmp11_);
	_g_free0 (_data_->_tmp11_);
	_data_->_tmp12_ = _data_->self->priv->notification_cancellable;
	if (!g_cancellable_is_cancelled (_data_->_tmp12_)) {
		_data_->_tmp13_ = _data_->primary_text;
		_data_->_tmp14_ = _data_->secondary_text;
		_data_->_tmp15_ = _data_->_tmp14_->str;
		_data_->_tmp16_ = music_media_get_album_info (_data_->media);
		_data_->_tmp17_ = _data_->_tmp16_;
		_data_->_tmp18_ = music_album_get_cover_icon (_data_->_tmp17_);
		_data_->_tmp19_ = _data_->_tmp18_;
		music_library_window_show_notification (_data_->self, _data_->_tmp13_, _data_->_tmp15_, _data_->_tmp19_, G_NOTIFICATION_PRIORITY_LOW, "music");
	}
	_g_string_free0 (_data_->secondary_text);
	_g_free0 (_data_->primary_text);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
music_library_window_notify_current_media_async_data_free (gpointer _data)
{
	MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicLibraryWindowNotifyCurrentMediaAsyncData, _data_);
}

static void
music_library_window_notify_current_media_async (MusicLibraryWindow* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_;
	MusicLibraryWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (MusicLibraryWindowNotifyCurrentMediaAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_library_window_notify_current_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	music_library_window_notify_current_media_async_co (_data_);
}

static void
music_library_window_notify_current_media_finish (MusicLibraryWindow* self,
                                                  GAsyncResult* _res_)
{
	MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
music_library_window_notify_current_media_async_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	music_library_window_notify_current_media_async_co (_data_);
}

static gboolean
music_library_window_notify_current_media_async_co (MusicLibraryWindowNotifyCurrentMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = music_app_get_player ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = music_playback_manager_get_current_media (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	if (_data_->_tmp3_ != NULL) {
		_data_->_tmp4_ = music_app_get_player ();
		_data_->_tmp5_ = _data_->_tmp4_;
		_data_->_tmp6_ = music_playback_manager_get_current_media (_data_->_tmp5_);
		_data_->_tmp7_ = _data_->_tmp6_;
		_data_->_state_ = 1;
		music_library_window_show_notification_from_media_async (_data_->self, _data_->_tmp7_, music_library_window_notify_current_media_async_ready, _data_);
		return FALSE;
		_state_1:
		music_library_window_show_notification_from_media_finish (_data_->self, _data_->_res_);
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

/**
     * Sets the given view as the active item
     */
static void
music_library_window_set_active_view (MusicLibraryWindow* self,
                                      MusicViewWrapper* view)
{
	gboolean _tmp0_;
	MusicViewStack* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (view != NULL);
	_tmp0_ = self->priv->_initialization_finished;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->_view_stack;
	gtk_stack_set_visible_child ((GtkStack*) _tmp1_, (GtkWidget*) view);
	if (MUSIC_IS_VIEW_WRAPPER (view)) {
		music_view_wrapper_set_as_current_view (G_TYPE_CHECK_INSTANCE_CAST (view, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper));
	}
}

static void
music_library_window_load_playlists (MusicLibraryWindow* self)
{
	MusicLibrariesManager* _tmp24_;
	MusicPlaybackManager* _tmp25_;
	MusicPlaybackManager* _tmp26_;
	MusicStaticPlaylist* _tmp27_;
	MusicLibrariesManager* _tmp28_;
	MusicPlaybackManager* _tmp29_;
	MusicPlaybackManager* _tmp30_;
	MusicHistoryPlaylist* _tmp31_;
	MusicTreeViewSetup* music_tvs = NULL;
	MusicLocalLibrary* _tmp32_;
	MusicLocalLibrary* _tmp33_;
	GdaConnection* _tmp34_;
	GdaConnection* _tmp35_;
	MusicTreeViewSetup* _tmp36_;
	MusicMusicViewWrapper* music_view_wrapper = NULL;
	MusicLocalLibrary* _tmp37_;
	MusicLocalLibrary* _tmp38_;
	MusicTopDisplay* _tmp39_;
	MusicMusicViewWrapper* _tmp40_;
	MusicViewStack* _tmp41_;
	MusicSourceListEntry* entry = NULL;
	MusicSourceListView* _tmp42_;
	GThemedIcon* _tmp43_;
	GThemedIcon* _tmp44_;
	MusicSourceListEntry* _tmp45_;
	MusicSourceListEntry* _tmp46_;
	GeeHashMap* _tmp47_;
	MusicLocalLibrary* _tmp48_;
	MusicLocalLibrary* _tmp49_;
	MusicStaticPlaylist* _tmp50_;
	GeeHashMap* _tmp51_;
	MusicLocalLibrary* _tmp52_;
	MusicLocalLibrary* _tmp53_;
	MusicStaticPlaylist* _tmp54_;
	g_return_if_fail (self != NULL);
	g_debug ("LibraryWindow.vala:612: Loading playlists");
	{
		GeeIterator* _p_it = NULL;
		MusicLocalLibrary* _tmp0_;
		MusicLocalLibrary* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = music_library_window_get_library_manager (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = music_library_get_smart_playlists ((MusicLibrary*) _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_p_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			MusicSmartPlaylist* p = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			MusicSmartPlaylist* _tmp9_;
			MusicLocalLibrary* _tmp10_;
			MusicLocalLibrary* _tmp11_;
			_tmp6_ = _p_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _p_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			p = (MusicSmartPlaylist*) _tmp8_;
			_tmp9_ = p;
			_tmp10_ = music_library_window_get_library_manager (self);
			_tmp11_ = _tmp10_;
			music_library_window_add_smartplaylist (self, _tmp9_, (MusicLibrary*) _tmp11_, NULL);
			_g_object_unref0 (p);
		}
		_g_object_unref0 (_p_it);
	}
	{
		GeeIterator* _p_it = NULL;
		MusicLocalLibrary* _tmp12_;
		MusicLocalLibrary* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
		_tmp12_ = music_library_window_get_library_manager (self);
		_tmp13_ = _tmp12_;
		_tmp14_ = music_library_get_playlists ((MusicLibrary*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
		_tmp17_ = _tmp16_;
		_g_object_unref0 (_tmp15_);
		_p_it = _tmp17_;
		while (TRUE) {
			GeeIterator* _tmp18_;
			MusicStaticPlaylist* p = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			MusicStaticPlaylist* _tmp21_;
			MusicLocalLibrary* _tmp22_;
			MusicLocalLibrary* _tmp23_;
			_tmp18_ = _p_it;
			if (!gee_iterator_next (_tmp18_)) {
				break;
			}
			_tmp19_ = _p_it;
			_tmp20_ = gee_iterator_get (_tmp19_);
			p = (MusicStaticPlaylist*) _tmp20_;
			_tmp21_ = p;
			_tmp22_ = music_library_window_get_library_manager (self);
			_tmp23_ = _tmp22_;
			music_library_window_add_playlist (self, _tmp21_, (MusicLibrary*) _tmp23_, NULL);
			_g_object_unref0 (p);
		}
		_g_object_unref0 (_p_it);
	}
	_tmp24_ = music_libraries_manager;
	_tmp25_ = music_app_get_player ();
	_tmp26_ = _tmp25_;
	_tmp27_ = _tmp26_->queue_playlist;
	g_signal_emit_by_name (_tmp24_, "add-headless-playlist", _tmp27_);
	_tmp28_ = music_libraries_manager;
	_tmp29_ = music_app_get_player ();
	_tmp30_ = _tmp29_;
	_tmp31_ = _tmp30_->history_playlist;
	g_signal_emit_by_name (_tmp28_, "add-headless-playlist", (MusicStaticPlaylist*) _tmp31_);
	_tmp32_ = music_library_window_get_library_manager (self);
	_tmp33_ = _tmp32_;
	_tmp34_ = music_local_library_get_connection (_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp36_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_MUSIC, "library:main", _tmp35_);
	music_tvs = _tmp36_;
	_tmp37_ = music_library_window_get_library_manager (self);
	_tmp38_ = _tmp37_;
	_tmp39_ = self->priv->top_display;
	_tmp40_ = music_music_view_wrapper_new (music_tvs, (MusicLibrary*) _tmp38_, _tmp39_);
	g_object_ref_sink (_tmp40_);
	music_view_wrapper = _tmp40_;
	_tmp41_ = self->priv->_view_stack;
	music_view_stack_add_view (_tmp41_, (GtkWidget*) music_view_wrapper);
	_tmp42_ = self->priv->_source_list_view;
	_tmp43_ = (GThemedIcon*) g_themed_icon_new ("library-music");
	_tmp44_ = _tmp43_;
	_tmp45_ = music_source_list_view_add_item (_tmp42_, (GtkGrid*) music_view_wrapper, _ ("Music"), MUSIC_VIEW_WRAPPER_HINT_MUSIC, (GIcon*) _tmp44_, NULL, NULL, NULL);
	_tmp46_ = _tmp45_;
	_g_object_unref0 (_tmp44_);
	entry = _tmp46_;
	_tmp47_ = self->priv->match_playlist_entry;
	_tmp48_ = music_library_window_get_library_manager (self);
	_tmp49_ = _tmp48_;
	_tmp50_ = _tmp49_->p_music;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp47_, (MusicPlaylist*) _tmp50_, entry);
	_tmp51_ = self->match_playlists;
	_tmp52_ = music_library_window_get_library_manager (self);
	_tmp53_ = _tmp52_;
	_tmp54_ = _tmp53_->p_music;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp51_, (MusicPlaylist*) _tmp54_, (MusicViewWrapper*) music_view_wrapper);
	g_debug ("LibraryWindow.vala:638: Finished loading playlists");
	_g_object_unref0 (entry);
	_g_object_unref0 (music_view_wrapper);
	_g_object_unref0 (music_tvs);
}

/**
     * SourceList Configuration
     */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		MusicLibraryWindow* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->p);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
__lambda157_ (Block4Data* _data4_,
              GeeCollection* s)
{
	MusicLibraryWindow* self;
	self = _data4_->self;
	g_return_if_fail (s != NULL);
	music_library_window_update_playlist_badge (self, _data4_->p);
}

static void
___lambda157__music_playlist_media_added (MusicPlaylist* _sender,
                                          GeeCollection* media,
                                          gpointer self)
{
	__lambda157_ (self, media);
}

static void
__lambda158_ (Block4Data* _data4_,
              GeeCollection* s)
{
	MusicLibraryWindow* self;
	self = _data4_->self;
	g_return_if_fail (s != NULL);
	music_library_window_update_playlist_badge (self, _data4_->p);
}

static void
___lambda158__music_playlist_media_removed (MusicPlaylist* _sender,
                                            GeeCollection* media,
                                            gpointer self)
{
	__lambda158_ (self, media);
}

static void
__lambda159_ (Block4Data* _data4_,
              MusicPlaylist* s)
{
	MusicLibraryWindow* self;
	self = _data4_->self;
	g_return_if_fail (s != NULL);
	music_library_window_update_playlist_badge (self, _data4_->p);
}

static void
___lambda159__music_playlist_cleared (MusicPlaylist* _sender,
                                      gpointer self)
{
	__lambda159_ (self, _sender);
}

static void
music_library_window_update_badge_on_playlist_update (MusicLibraryWindow* self,
                                                      MusicPlaylist* p,
                                                      MusicSourceListEntry* entry)
{
	Block4Data* _data4_;
	MusicPlaylist* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	g_return_if_fail (entry != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (p);
	_g_object_unref0 (_data4_->p);
	_data4_->p = _tmp0_;
	g_signal_connect_data (_data4_->p, "media-added", (GCallback) ___lambda157__music_playlist_media_added, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	g_signal_connect_data (_data4_->p, "media-removed", (GCallback) ___lambda158__music_playlist_media_removed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	g_signal_connect_data (_data4_->p, "cleared", (GCallback) ___lambda159__music_playlist_cleared, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

static void
music_library_window_update_playlist_badge (MusicLibraryWindow* self,
                                            MusicPlaylist* playlist)
{
	MusicSourceListEntry* entry = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gint media_count = 0;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* new_badge = NULL;
	gchar* _tmp9_;
	MusicSourceListEntry* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (playlist != NULL);
	_tmp0_ = self->priv->match_playlist_entry;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, playlist);
	entry = (MusicSourceListEntry*) _tmp1_;
	_tmp2_ = music_playlist_get_medias (playlist);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	media_count = _tmp5_;
	if (media_count > 0) {
		gchar* _tmp7_;
		_tmp7_ = g_strdup_printf ("%i", media_count);
		_g_free0 (_tmp6_);
		_tmp6_ = _tmp7_;
	} else {
		gchar* _tmp8_;
		_tmp8_ = g_strdup ("");
		_g_free0 (_tmp6_);
		_tmp6_ = _tmp8_;
	}
	_tmp9_ = g_strdup (_tmp6_);
	new_badge = _tmp9_;
	_tmp10_ = entry;
	granite_widgets_source_list_item_set_badge ((GraniteWidgetsSourceListItem*) _tmp10_, new_badge);
	_g_free0 (new_badge);
	_g_free0 (_tmp6_);
	_g_object_unref0 (entry);
}

static void
music_library_window_real_update_sensitivities_data_free (gpointer _data)
{
	MusicLibraryWindowUpdateSensitivitiesData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicLibraryWindowUpdateSensitivitiesData, _data_);
}

static void
music_library_window_real_update_sensitivities (MusicLibraryWindowInterface* base,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	MusicLibraryWindow * self;
	MusicLibraryWindowUpdateSensitivitiesData* _data_;
	MusicLibraryWindow* _tmp0_;
	self = (MusicLibraryWindow*) base;
	_data_ = g_slice_new0 (MusicLibraryWindowUpdateSensitivitiesData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_library_window_real_update_sensitivities_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	music_library_window_real_update_sensitivities_co (_data_);
}

static void
music_library_window_update_sensitivities_finish (MusicLibraryWindowInterface* base,
                                                  GAsyncResult* _res_)
{
	MusicLibraryWindowUpdateSensitivitiesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
music_library_window_real_update_sensitivities_co (MusicLibraryWindowUpdateSensitivitiesData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (_data_->self->priv->update_sensitivities_pending) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->self->priv->update_sensitivities_pending = TRUE;
	music_library_window_update_sensitivities_sync (_data_->self);
	_data_->self->priv->update_sensitivities_pending = FALSE;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static GVariant*
_variant_new1 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static GVariant*
_variant_new2 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
music_library_window_update_sensitivities_sync (MusicLibraryWindow* self)
{
	gboolean folder_set = FALSE;
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean have_media = FALSE;
	MusicLocalLibrary* _tmp4_;
	MusicLocalLibrary* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gboolean _tmp10_;
	gboolean doing_ops = FALSE;
	MusicLocalLibrary* _tmp11_;
	MusicLocalLibrary* _tmp12_;
	gboolean media_active = FALSE;
	MusicPlaybackManager* _tmp13_;
	MusicPlaybackManager* _tmp14_;
	MusicMedia* _tmp15_;
	MusicMedia* _tmp16_;
	gboolean media_available = FALSE;
	MusicPlaybackManager* _tmp17_;
	MusicPlaybackManager* _tmp18_;
	GeeCollection* _tmp19_;
	GeeCollection* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_ = FALSE;
	GAction* _tmp25_;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	GAction* _tmp28_;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	GAction* _tmp31_;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	GAction* _tmp34_;
	MusicSourceListView* _tmp35_;
	gboolean _tmp36_ = FALSE;
	MusicWidgetsStatusBar* _tmp37_;
	gboolean _tmp38_ = FALSE;
	g_return_if_fail (self != NULL);
	g_debug ("LibraryWindow.vala:674: UPDATE SENSITIVITIES");
	_tmp0_ = music_library_window_get_library_manager (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_local_library_get_main_directory_set (_tmp1_);
	_tmp3_ = _tmp2_;
	folder_set = _tmp3_;
	_tmp4_ = music_library_window_get_library_manager (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = music_library_get_medias ((MusicLibrary*) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = gee_collection_get_size (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_ > 0;
	_g_object_unref0 (_tmp7_);
	have_media = _tmp10_;
	_tmp11_ = music_library_window_get_library_manager (self);
	_tmp12_ = _tmp11_;
	doing_ops = music_library_doing_file_operations ((MusicLibrary*) _tmp12_);
	_tmp13_ = music_app_get_player ();
	_tmp14_ = _tmp13_;
	_tmp15_ = music_playback_manager_get_current_media (_tmp14_);
	_tmp16_ = _tmp15_;
	media_active = _tmp16_ != NULL;
	_tmp17_ = music_app_get_player ();
	_tmp18_ = _tmp17_;
	_tmp19_ = music_playback_manager_get_current_media_list (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = gee_collection_get_size (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = _tmp22_ > 0;
	_g_object_unref0 (_tmp20_);
	media_available = _tmp23_;
	if (!doing_ops) {
		_tmp24_ = folder_set;
	} else {
		_tmp24_ = FALSE;
	}
	_tmp25_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_IMPORT);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, g_simple_action_get_type (), GSimpleAction), _tmp24_);
	if (media_active) {
		_tmp27_ = TRUE;
	} else {
		_tmp27_ = media_available;
	}
	if (_tmp27_) {
		_tmp26_ = TRUE;
	} else {
		_tmp26_ = have_media;
	}
	_tmp28_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, g_simple_action_get_type (), GSimpleAction), _tmp26_);
	if (media_active) {
		_tmp30_ = TRUE;
	} else {
		_tmp30_ = media_available;
	}
	if (_tmp30_) {
		_tmp29_ = TRUE;
	} else {
		_tmp29_ = have_media;
	}
	_tmp31_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY_NEXT);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, g_simple_action_get_type (), GSimpleAction), _tmp29_);
	if (media_active) {
		_tmp33_ = TRUE;
	} else {
		_tmp33_ = media_available;
	}
	if (_tmp33_) {
		_tmp32_ = TRUE;
	} else {
		_tmp32_ = have_media;
	}
	_tmp34_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY_PREVIOUS);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, g_simple_action_get_type (), GSimpleAction), _tmp32_);
	_tmp35_ = self->priv->_source_list_view;
	music_source_list_view_change_playlist_category_visibility (_tmp35_, have_media);
	if (folder_set) {
		_tmp36_ = have_media;
	} else {
		_tmp36_ = FALSE;
	}
	_tmp37_ = self->priv->_statusbar;
	music_widgets_status_bar_set_playlist_menubutton_sensitive (_tmp37_, _tmp36_);
	if (!media_active) {
		_tmp38_ = TRUE;
	} else {
		gboolean _tmp39_ = FALSE;
		if (have_media) {
			MusicPlaybackManager* _tmp40_;
			MusicPlaybackManager* _tmp41_;
			gboolean _tmp42_;
			gboolean _tmp43_;
			_tmp40_ = music_app_get_player ();
			_tmp41_ = _tmp40_;
			_tmp42_ = music_playback_manager_get_playing (_tmp41_);
			_tmp43_ = _tmp42_;
			_tmp39_ = !_tmp43_;
		} else {
			_tmp39_ = FALSE;
		}
		_tmp38_ = _tmp39_;
	}
	if (_tmp38_) {
		GAction* _tmp44_;
		GVariant* _tmp45_;
		_tmp44_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
		_tmp45_ = _variant_new1 (FALSE);
		g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, g_simple_action_get_type (), GSimpleAction), _tmp45_);
		_g_variant_unref0 (_tmp45_);
	} else {
		GAction* _tmp46_;
		GVariant* _tmp47_;
		_tmp46_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
		_tmp47_ = _variant_new2 (TRUE);
		g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, g_simple_action_get_type (), GSimpleAction), _tmp47_);
		_g_variant_unref0 (_tmp47_);
	}
}

/**
     * Devices
     */
static void
music_library_window_change_device_name (MusicLibraryWindow* self,
                                         MusicDevice* device)
{
	MusicDeviceView* view = NULL;
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	MusicDeviceView* _tmp4_;
	MusicSourceListView* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = self->priv->match_devices;
	_tmp1_ = music_device_get_unique_identifier (device);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp2_);
	_tmp4_ = (MusicDeviceView*) _tmp3_;
	_g_free0 (_tmp2_);
	view = _tmp4_;
	_tmp5_ = self->priv->_source_list_view;
	_tmp6_ = music_device_get_display_name (device);
	_tmp7_ = _tmp6_;
	music_source_list_view_change_device_name (_tmp5_, view, _tmp7_);
	_g_free0 (_tmp7_);
	_g_object_unref0 (view);
}

static void
music_library_window_remove_device (MusicLibraryWindow* self,
                                    MusicDevice* device)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	MusicDeviceView* view = NULL;
	GeeHashMap* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gpointer _tmp7_;
	MusicDeviceView* _tmp8_;
	GeeHashMap* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	MusicViewStack* _tmp23_;
	MusicDeviceView* _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = self->priv->match_devices;
	_tmp1_ = music_device_get_unique_identifier (device);
	_tmp2_ = _tmp1_;
	_tmp3_ = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		return;
	}
	_tmp4_ = self->priv->match_devices;
	_tmp5_ = music_device_get_unique_identifier (device);
	_tmp6_ = _tmp5_;
	_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp6_);
	_tmp8_ = (MusicDeviceView*) _tmp7_;
	_g_free0 (_tmp6_);
	view = _tmp8_;
	{
		GeeIterator* _subview_it = NULL;
		MusicSourceListView* _tmp9_;
		MusicDeviceView* _tmp10_;
		GeeCollection* _tmp11_;
		GeeCollection* _tmp12_;
		GeeIterator* _tmp13_;
		GeeIterator* _tmp14_;
		_tmp9_ = self->priv->_source_list_view;
		_tmp10_ = view;
		_tmp11_ = music_source_list_view_remove_device (_tmp9_, _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
		_tmp14_ = _tmp13_;
		_g_object_unref0 (_tmp12_);
		_subview_it = _tmp14_;
		while (TRUE) {
			GeeIterator* _tmp15_;
			GtkGrid* subview = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			MusicViewStack* _tmp18_;
			GtkGrid* _tmp19_;
			_tmp15_ = _subview_it;
			if (!gee_iterator_next (_tmp15_)) {
				break;
			}
			_tmp16_ = _subview_it;
			_tmp17_ = gee_iterator_get (_tmp16_);
			subview = (GtkGrid*) _tmp17_;
			_tmp18_ = self->priv->_view_stack;
			_tmp19_ = subview;
			music_view_stack_remove_view (_tmp18_, (GtkWidget*) _tmp19_);
			_g_object_unref0 (subview);
		}
		_g_object_unref0 (_subview_it);
	}
	_tmp20_ = self->priv->match_devices;
	_tmp21_ = music_device_get_unique_identifier (device);
	_tmp22_ = _tmp21_;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp20_, _tmp22_, NULL);
	_g_free0 (_tmp22_);
	_tmp23_ = self->priv->_view_stack;
	_tmp24_ = view;
	music_view_stack_remove_view (_tmp23_, (GtkWidget*) _tmp24_);
	_g_object_unref0 (view);
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		MusicLibraryWindow* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->d);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		MusicLibraryWindow* self;
		self = _data6_->_data5_->self;
		_g_object_unref0 (_data6_->entry);
		block5_data_unref (_data6_->_data5_);
		_data6_->_data5_ = NULL;
		g_slice_free (Block6Data, _data6_);
	}
}

static void
______lambda163_ (Block6Data* _data6_,
                  MusicStaticPlaylist* np)
{
	Block5Data* _data5_;
	MusicLibraryWindow* self;
	MusicLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicSourceListEntry* _tmp2_;
	_data5_ = _data6_->_data5_;
	self = _data5_->self;
	g_return_if_fail (np != NULL);
	_tmp0_ = music_device_get_library (_data5_->d);
	_tmp1_ = _tmp0_;
	_tmp2_ = _data6_->entry;
	music_library_window_add_playlist (self, np, _tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem));
	_g_object_unref0 (_tmp1_);
}

static void
_______lambda163__music_library_playlist_added (MusicLibrary* _sender,
                                                MusicStaticPlaylist* playlist,
                                                gpointer self)
{
	______lambda163_ (self, playlist);
}

static void
______lambda164_ (MusicLibraryWindow* self,
                  MusicStaticPlaylist* np)
{
	g_return_if_fail (np != NULL);
	music_library_window_remove_playlist (self, np);
}

static void
_______lambda164__music_library_playlist_removed (MusicLibrary* _sender,
                                                  MusicStaticPlaylist* playlist,
                                                  gpointer self)
{
	______lambda164_ ((MusicLibraryWindow*) self, playlist);
}

static void
music_library_window_create_device_source_list (MusicLibraryWindow* self,
                                                MusicDevice* d)
{
	Block5Data* _data5_;
	MusicDevice* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (d != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (d);
	_g_object_unref0 (_data5_->d);
	_data5_->d = _tmp0_;
	{
		GeeHashMap* _tmp1_;
		_tmp1_ = self->priv->match_devices;
		g_rec_mutex_lock (&self->priv->__lock_match_devices);
		{
			Block6Data* _data6_;
			MusicDevicePreferences* pref = NULL;
			MusicLocalLibrary* _tmp2_;
			MusicLocalLibrary* _tmp3_;
			MusicDevicePreferences* _tmp4_;
			MusicDeviceView* dv = NULL;
			MusicDevicePreferences* _tmp5_;
			MusicDeviceView* _tmp6_;
			MusicViewStack* _tmp7_;
			MusicDeviceView* _tmp8_;
			GeeHashMap* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			MusicDeviceView* _tmp12_;
			_data6_ = g_slice_new0 (Block6Data);
			_data6_->_ref_count_ = 1;
			_data6_->_data5_ = block5_data_ref (_data5_);
			_tmp2_ = music_library_window_get_library_manager (self);
			_tmp3_ = _tmp2_;
			_tmp4_ = music_local_library_get_preferences_for_device (_tmp3_, _data5_->d);
			pref = _tmp4_;
			_tmp5_ = pref;
			_tmp6_ = music_device_view_new (_data5_->d, _tmp5_);
			g_object_ref_sink (_tmp6_);
			dv = _tmp6_;
			_tmp7_ = self->priv->_view_stack;
			_tmp8_ = dv;
			music_view_stack_add_view (_tmp7_, (GtkWidget*) _tmp8_);
			_tmp9_ = self->priv->match_devices;
			_tmp10_ = music_device_get_unique_identifier (_data5_->d);
			_tmp11_ = _tmp10_;
			_tmp12_ = dv;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp11_, _tmp12_);
			_g_free0 (_tmp11_);
			if (music_device_only_use_custom_view (_data5_->d)) {
				MusicLibrary* _tmp13_;
				MusicLibrary* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				MusicSourceListView* _tmp19_;
				MusicDeviceView* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				GIcon* _tmp23_;
				GIcon* _tmp24_;
				GThemedIcon* _tmp25_;
				GThemedIcon* _tmp26_;
				MusicSourceListEntry* _tmp27_;
				_tmp13_ = music_device_get_library (_data5_->d);
				_tmp14_ = _tmp13_;
				_tmp15_ = music_library_get_medias (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = gee_collection_get_size (_tmp16_);
				_tmp18_ = _tmp17_;
				g_message ("LibraryWindow.vala:730: new custom device (probably a CD) added with %" \
"d songs.\n", _tmp18_);
				_g_object_unref0 (_tmp16_);
				_g_object_unref0 (_tmp14_);
				_tmp19_ = self->priv->_source_list_view;
				_tmp20_ = dv;
				_tmp21_ = music_device_get_display_name (_data5_->d);
				_tmp22_ = _tmp21_;
				_tmp23_ = music_device_get_icon (_data5_->d);
				_tmp24_ = _tmp23_;
				_tmp25_ = (GThemedIcon*) g_themed_icon_new ("media-eject-symbolic");
				_tmp26_ = _tmp25_;
				_tmp27_ = music_source_list_view_add_item (_tmp19_, (GtkGrid*) _tmp20_, _tmp22_, MUSIC_VIEW_WRAPPER_HINT_DEVICE, _tmp24_, (GIcon*) _tmp26_, NULL, (GObject*) _data5_->d);
				_g_object_unref0 (_data6_->entry);
				_data6_->entry = _tmp27_;
				_g_object_unref0 (_tmp26_);
				_g_object_unref0 (_tmp24_);
				_g_free0 (_tmp22_);
			} else {
				MusicLibrary* _tmp28_;
				MusicLibrary* _tmp29_;
				GeeCollection* _tmp30_;
				GeeCollection* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				MusicTreeViewSetup* tvs = NULL;
				MusicTreeViewSetup* _tmp34_;
				MusicDeviceViewWrapper* music_view_wrapper = NULL;
				MusicTreeViewSetup* _tmp35_;
				MusicLibrary* _tmp36_;
				MusicLibrary* _tmp37_;
				MusicDeviceViewWrapper* _tmp38_;
				MusicDeviceViewWrapper* _tmp39_;
				MusicViewStack* _tmp40_;
				MusicDeviceViewWrapper* _tmp41_;
				MusicSourceListView* _tmp42_;
				MusicDeviceView* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				GIcon* _tmp46_;
				GIcon* _tmp47_;
				GThemedIcon* _tmp48_;
				GThemedIcon* _tmp49_;
				MusicSourceListEntry* _tmp50_;
				MusicSourceListView* _tmp51_;
				MusicDeviceViewWrapper* _tmp52_;
				GThemedIcon* _tmp53_;
				GThemedIcon* _tmp54_;
				MusicSourceListEntry* _tmp55_;
				MusicSourceListEntry* _tmp56_;
				MusicSourceListEntry* _tmp57_;
				MusicLibrary* _tmp58_;
				MusicLibrary* _tmp59_;
				gboolean _tmp60_;
				_tmp28_ = music_device_get_library (_data5_->d);
				_tmp29_ = _tmp28_;
				_tmp30_ = music_library_get_medias (_tmp29_);
				_tmp31_ = _tmp30_;
				_tmp32_ = gee_collection_get_size (_tmp31_);
				_tmp33_ = _tmp32_;
				g_debug ("LibraryWindow.vala:745: adding device view with %d\n", _tmp33_);
				_g_object_unref0 (_tmp31_);
				_g_object_unref0 (_tmp29_);
				_tmp34_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO, NULL, NULL);
				tvs = _tmp34_;
				_tmp35_ = tvs;
				_tmp36_ = music_device_get_library (_data5_->d);
				_tmp37_ = _tmp36_;
				_tmp38_ = music_device_view_wrapper_new (_tmp35_, _data5_->d, _tmp37_);
				g_object_ref_sink (_tmp38_);
				_tmp39_ = _tmp38_;
				_g_object_unref0 (_tmp37_);
				music_view_wrapper = _tmp39_;
				_tmp40_ = self->priv->_view_stack;
				_tmp41_ = music_view_wrapper;
				music_view_stack_add_view (_tmp40_, (GtkWidget*) _tmp41_);
				_tmp42_ = self->priv->_source_list_view;
				_tmp43_ = dv;
				_tmp44_ = music_device_get_display_name (_data5_->d);
				_tmp45_ = _tmp44_;
				_tmp46_ = music_device_get_icon (_data5_->d);
				_tmp47_ = _tmp46_;
				_tmp48_ = (GThemedIcon*) g_themed_icon_new ("media-eject-symbolic");
				_tmp49_ = _tmp48_;
				_tmp50_ = music_source_list_view_add_item (_tmp42_, (GtkGrid*) _tmp43_, _tmp45_, MUSIC_VIEW_WRAPPER_HINT_DEVICE, _tmp47_, (GIcon*) _tmp49_, NULL, (GObject*) _data5_->d);
				_g_object_unref0 (_data6_->entry);
				_data6_->entry = _tmp50_;
				_g_object_unref0 (_tmp49_);
				_g_object_unref0 (_tmp47_);
				_g_free0 (_tmp45_);
				_tmp51_ = self->priv->_source_list_view;
				_tmp52_ = music_view_wrapper;
				_tmp53_ = (GThemedIcon*) g_themed_icon_new ("library-music");
				_tmp54_ = _tmp53_;
				_tmp55_ = _data6_->entry;
				_tmp56_ = music_source_list_view_add_item (_tmp51_, (GtkGrid*) _tmp52_, _ ("Music"), MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO, (GIcon*) _tmp54_, NULL, MUSIC_IS_SOURCE_LIST_EXPANDABLE_ITEM (_tmp55_) ? ((MusicSourceListExpandableItem*) _tmp55_) : NULL, (GObject*) _data5_->d);
				_tmp57_ = _tmp56_;
				_g_object_unref0 (_tmp57_);
				_g_object_unref0 (_tmp54_);
				_tmp58_ = music_device_get_library (_data5_->d);
				_tmp59_ = _tmp58_;
				_tmp60_ = music_library_support_playlists (_tmp59_) == TRUE;
				_g_object_unref0 (_tmp59_);
				if (_tmp60_) {
					MusicLibrary* _tmp74_;
					MusicLibrary* _tmp75_;
					MusicLibrary* _tmp76_;
					MusicLibrary* _tmp77_;
					{
						GeeIterator* _p_it = NULL;
						MusicLibrary* _tmp61_;
						MusicLibrary* _tmp62_;
						GeeCollection* _tmp63_;
						GeeCollection* _tmp64_;
						GeeIterator* _tmp65_;
						GeeIterator* _tmp66_;
						_tmp61_ = music_device_get_library (_data5_->d);
						_tmp62_ = _tmp61_;
						_tmp63_ = music_library_get_playlists (_tmp62_);
						_tmp64_ = _tmp63_;
						_tmp65_ = gee_iterable_iterator ((GeeIterable*) _tmp64_);
						_tmp66_ = _tmp65_;
						_g_object_unref0 (_tmp64_);
						_g_object_unref0 (_tmp62_);
						_p_it = _tmp66_;
						while (TRUE) {
							GeeIterator* _tmp67_;
							MusicStaticPlaylist* p = NULL;
							GeeIterator* _tmp68_;
							gpointer _tmp69_;
							MusicStaticPlaylist* _tmp70_;
							MusicSourceListEntry* _tmp71_;
							MusicLibrary* _tmp72_;
							MusicLibrary* _tmp73_;
							_tmp67_ = _p_it;
							if (!gee_iterator_next (_tmp67_)) {
								break;
							}
							_tmp68_ = _p_it;
							_tmp69_ = gee_iterator_get (_tmp68_);
							p = (MusicStaticPlaylist*) _tmp69_;
							_tmp70_ = p;
							_tmp71_ = _data6_->entry;
							_tmp72_ = music_device_get_library (_data5_->d);
							_tmp73_ = _tmp72_;
							music_library_window_create_playlist_source_list (self, _tmp70_, G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, MUSIC_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, MusicSourceListExpandableItem), _tmp73_);
							_g_object_unref0 (_tmp73_);
							_g_object_unref0 (p);
						}
						_g_object_unref0 (_p_it);
					}
					_tmp74_ = music_device_get_library (_data5_->d);
					_tmp75_ = _tmp74_;
					g_signal_connect_data (_tmp75_, "playlist-added", (GCallback) _______lambda163__music_library_playlist_added, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
					_g_object_unref0 (_tmp75_);
					_tmp76_ = music_device_get_library (_data5_->d);
					_tmp77_ = _tmp76_;
					g_signal_connect_object (_tmp77_, "playlist-removed", (GCallback) _______lambda164__music_library_playlist_removed, self, 0);
					_g_object_unref0 (_tmp77_);
				}
				_g_object_unref0 (music_view_wrapper);
				_g_object_unref0 (tvs);
			}
			_g_object_unref0 (dv);
			_g_object_unref0 (pref);
			block6_data_unref (_data6_);
			_data6_ = NULL;
		}
		__finally0:
		{
			GeeHashMap* _tmp78_;
			_tmp78_ = self->priv->match_devices;
			g_rec_mutex_unlock (&self->priv->__lock_match_devices);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			block5_data_unref (_data5_);
			_data5_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	block5_data_unref (_data5_);
	_data5_ = NULL;
}

/**
     * StaticPlaylists
     */
static void
music_library_window_add_playlist (MusicLibraryWindow* self,
                                   MusicStaticPlaylist* playlist,
                                   MusicLibrary* library,
                                   MusicSourceListExpandableItem* entry)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (playlist != NULL);
	music_library_window_create_playlist_source_list (self, playlist, entry, library);
}

static void
music_library_window_remove_playlist (MusicLibraryWindow* self,
                                      MusicStaticPlaylist* playlist)
{
	MusicViewWrapper* view = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MusicViewStack* _tmp7_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (playlist != NULL);
	_tmp0_ = self->match_playlists;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (MusicPlaylist*) playlist);
	view = (MusicViewWrapper*) _tmp1_;
	{
		GeeHashMap* _tmp2_;
		_tmp2_ = self->match_playlists;
		g_rec_mutex_lock (&self->priv->__lock_match_playlists);
		{
			MusicSourceListView* _tmp3_;
			GeeHashMap* _tmp4_;
			GeeHashMap* _tmp5_;
			_tmp3_ = self->priv->_source_list_view;
			music_source_list_view_remove_playlist (_tmp3_, view);
			_tmp4_ = self->priv->match_playlist_entry;
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, (MusicPlaylist*) playlist, NULL);
			_tmp5_ = self->match_playlists;
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, (MusicPlaylist*) playlist, NULL);
		}
		__finally0:
		{
			GeeHashMap* _tmp6_;
			_tmp6_ = self->match_playlists;
			g_rec_mutex_unlock (&self->priv->__lock_match_playlists);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (view);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp7_ = self->priv->_view_stack;
	music_view_stack_remove_view (_tmp7_, (GtkWidget*) view);
	_g_object_unref0 (view);
}

void
music_library_window_create_new_playlist (MusicLibraryWindow* self,
                                          MusicLibrary* library)
{
	MusicStaticPlaylist* playlist = NULL;
	MusicStaticPlaylist* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	MusicLocalLibrary* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_static_playlist_new ();
	playlist = _tmp0_;
	_tmp1_ = music_library_window_get_library_manager (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = music_library_get_playlists ((MusicLibrary*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = music_playlists_utils_get_new_playlist_name (_tmp4_, NULL);
	_tmp6_ = _tmp5_;
	music_playlist_set_name ((MusicPlaylist*) playlist, _tmp6_);
	_g_free0 (_tmp6_);
	_g_object_unref0 (_tmp4_);
	music_library_window_set_newly_created_playlist (self, TRUE);
	music_library_add_playlist (library, playlist);
	_g_object_unref0 (playlist);
}

static void
music_library_window_show_playlist_view (MusicLibraryWindow* self,
                                         MusicPlaylist* p)
{
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->match_playlists;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, p)) {
		MusicSourceListView* _tmp1_;
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		MusicSourceListEntry* _tmp4_;
		GeeHashMap* _tmp5_;
		gpointer _tmp6_;
		MusicViewWrapper* _tmp7_;
		_tmp1_ = self->priv->_source_list_view;
		_tmp2_ = self->priv->match_playlist_entry;
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, p);
		_tmp4_ = (MusicSourceListEntry*) _tmp3_;
		granite_widgets_source_list_set_selected ((GraniteWidgetsSourceList*) _tmp1_, (GraniteWidgetsSourceListItem*) _tmp4_);
		_g_object_unref0 (_tmp4_);
		_tmp5_ = self->match_playlists;
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, p);
		_tmp7_ = (MusicViewWrapper*) _tmp6_;
		music_library_window_set_active_view (self, _tmp7_);
		_g_object_unref0 (_tmp7_);
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		MusicLibraryWindow* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->entry);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static gboolean
___lambda160_ (Block7Data* _data7_)
{
	MusicLibraryWindow* self;
	MusicSourceListView* _tmp0_;
	MusicSourceListEntry* _tmp1_;
	gboolean result;
	self = _data7_->self;
	_tmp0_ = self->priv->_source_list_view;
	_tmp1_ = _data7_->entry;
	granite_widgets_source_list_start_editing_item ((GraniteWidgetsSourceList*) _tmp0_, (GraniteWidgetsSourceListItem*) _tmp1_);
	result = FALSE;
	return result;
}

static gboolean
____lambda160__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda160_ (self);
	return result;
}

static void
music_library_window_create_playlist_source_list (MusicLibraryWindow* self,
                                                  MusicStaticPlaylist* p,
                                                  MusicSourceListExpandableItem* into_expandable,
                                                  MusicLibrary* library)
{
	Block7Data* _data7_;
	MusicViewWrapperHint hint = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicTreeViewSetup* tvs = NULL;
	MusicPlaylistViewWrapper* view = NULL;
	MusicTreeViewSetup* _tmp28_;
	MusicPlaylistViewWrapper* _tmp29_;
	MusicViewStack* _tmp30_;
	MusicPlaylistViewWrapper* _tmp31_;
	MusicSourceListView* _tmp32_;
	MusicPlaylistViewWrapper* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	GIcon* _tmp36_;
	MusicSourceListEntry* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	MusicPlaybackManager* _tmp41_;
	MusicPlaybackManager* _tmp42_;
	MusicStaticPlaylist* _tmp43_;
	GeeHashMap* _tmp53_;
	MusicSourceListEntry* _tmp54_;
	GeeHashMap* _tmp55_;
	MusicPlaylistViewWrapper* _tmp56_;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	hint = MUSIC_VIEW_WRAPPER_HINT_PLAYLIST;
	_tmp0_ = music_static_playlist_get_read_only (p);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == TRUE) {
		hint = MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST;
	}
	tvs = NULL;
	if (MUSIC_IS_LOCAL_STATIC_PLAYLIST (p)) {
		gint64 _tmp2_;
		gint64 _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		MusicLocalLibrary* _tmp6_;
		MusicLocalLibrary* _tmp7_;
		GdaConnection* _tmp8_;
		GdaConnection* _tmp9_;
		MusicTreeViewSetup* _tmp10_;
		_tmp2_ = music_playlist_get_rowid ((MusicPlaylist*) p);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strdup_printf ("library:p%lld", _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = music_library_window_get_library_manager (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = music_local_library_get_connection (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = music_tree_view_setup_new (hint, _tmp5_, _tmp9_);
		_g_object_unref0 (tvs);
		tvs = _tmp10_;
		_g_free0 (_tmp5_);
	} else {
		MusicPlaybackManager* _tmp11_;
		MusicPlaybackManager* _tmp12_;
		MusicStaticPlaylist* _tmp13_;
		_tmp11_ = music_app_get_player ();
		_tmp12_ = _tmp11_;
		_tmp13_ = _tmp12_->queue_playlist;
		if (p == _tmp13_) {
			MusicLocalLibrary* _tmp14_;
			MusicLocalLibrary* _tmp15_;
			GdaConnection* _tmp16_;
			GdaConnection* _tmp17_;
			MusicTreeViewSetup* _tmp18_;
			_tmp14_ = music_library_window_get_library_manager (self);
			_tmp15_ = _tmp14_;
			_tmp16_ = music_local_library_get_connection (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_QUEUE, "library:queue", _tmp17_);
			_g_object_unref0 (tvs);
			tvs = _tmp18_;
		} else {
			MusicPlaybackManager* _tmp19_;
			MusicPlaybackManager* _tmp20_;
			MusicHistoryPlaylist* _tmp21_;
			_tmp19_ = music_app_get_player ();
			_tmp20_ = _tmp19_;
			_tmp21_ = _tmp20_->history_playlist;
			if (p == G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist)) {
				MusicLocalLibrary* _tmp22_;
				MusicLocalLibrary* _tmp23_;
				GdaConnection* _tmp24_;
				GdaConnection* _tmp25_;
				MusicTreeViewSetup* _tmp26_;
				_tmp22_ = music_library_window_get_library_manager (self);
				_tmp23_ = _tmp22_;
				_tmp24_ = music_local_library_get_connection (_tmp23_);
				_tmp25_ = _tmp24_;
				_tmp26_ = music_tree_view_setup_new (hint, "library:history", _tmp25_);
				_g_object_unref0 (tvs);
				tvs = _tmp26_;
			} else {
				MusicTreeViewSetup* _tmp27_;
				_tmp27_ = music_tree_view_setup_new (hint, NULL, NULL);
				_g_object_unref0 (tvs);
				tvs = _tmp27_;
			}
		}
	}
	_tmp28_ = tvs;
	_tmp29_ = music_playlist_view_wrapper_new ((MusicPlaylist*) p, hint, _tmp28_, library);
	g_object_ref_sink (_tmp29_);
	view = _tmp29_;
	_tmp30_ = self->priv->_view_stack;
	_tmp31_ = view;
	music_view_stack_add_view (_tmp30_, (GtkWidget*) _tmp31_);
	_tmp32_ = self->priv->_source_list_view;
	_tmp33_ = view;
	_tmp34_ = music_playlist_get_name ((MusicPlaylist*) p);
	_tmp35_ = _tmp34_;
	_tmp36_ = ((MusicPlaylist*) p)->icon;
	_tmp37_ = music_source_list_view_add_item (_tmp32_, (GtkGrid*) _tmp33_, _tmp35_, hint, _tmp36_, NULL, into_expandable, NULL);
	_data7_->entry = _tmp37_;
	_tmp38_ = music_static_playlist_get_show_badge (p);
	_tmp39_ = _tmp38_;
	if (_tmp39_ == TRUE) {
		MusicSourceListEntry* _tmp40_;
		_tmp40_ = _data7_->entry;
		music_library_window_update_badge_on_playlist_update (self, (MusicPlaylist*) p, _tmp40_);
	}
	_tmp41_ = music_app_get_player ();
	_tmp42_ = _tmp41_;
	_tmp43_ = _tmp42_->queue_playlist;
	if (p == _tmp43_) {
		MusicPlaylistViewWrapper* _tmp44_;
		MusicPlaybackManager* _tmp45_;
		MusicPlaybackManager* _tmp46_;
		GeeArrayList* _tmp47_;
		GeeArrayList* _tmp48_;
		_tmp44_ = view;
		music_playlist_view_wrapper_set_no_media_alert_message (_tmp44_, _ ("No songs in Queue"), _ ("To add songs to the queue, use the <b>secondary click</b> on an item a" \
"nd choose <b>Queue</b>. When a song finishes, the queued songs will be" \
" played first before the next song in the currently playing list."));
		_tmp45_ = music_app_get_player ();
		_tmp46_ = _tmp45_;
		_tmp47_ = music_playlist_get_medias ((MusicPlaylist*) p);
		_tmp48_ = _tmp47_;
		music_playback_manager_queue_media (_tmp46_, (GeeCollection*) _tmp48_);
	} else {
		MusicPlaybackManager* _tmp49_;
		MusicPlaybackManager* _tmp50_;
		MusicHistoryPlaylist* _tmp51_;
		_tmp49_ = music_app_get_player ();
		_tmp50_ = _tmp49_;
		_tmp51_ = _tmp50_->history_playlist;
		if (p == G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist)) {
			MusicPlaylistViewWrapper* _tmp52_;
			_tmp52_ = view;
			music_playlist_view_wrapper_set_no_media_alert_message (_tmp52_, _ ("No songs in History"), _ ("After a part of a song has been played, it is added to the history lis" \
"t.\n" \
"You can use this list to see all the songs you have played during the " \
"current session."));
		}
	}
	_tmp53_ = self->priv->match_playlist_entry;
	_tmp54_ = _data7_->entry;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp53_, (MusicPlaylist*) p, _tmp54_);
	_tmp55_ = self->match_playlists;
	_tmp56_ = view;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp55_, (MusicPlaylist*) p, (MusicViewWrapper*) _tmp56_);
	_tmp58_ = self->priv->_newly_created_playlist;
	if (_tmp58_ == TRUE) {
		gboolean _tmp59_;
		gboolean _tmp60_;
		_tmp59_ = music_static_playlist_get_read_only (p);
		_tmp60_ = _tmp59_;
		_tmp57_ = _tmp60_ == FALSE;
	} else {
		_tmp57_ = FALSE;
	}
	if (_tmp57_) {
		music_library_window_set_newly_created_playlist (self, FALSE);
		music_library_window_show_playlist_view (self, (MusicPlaylist*) p);
		g_idle_add_full (G_PRIORITY_LOW, ____lambda160__gsource_func, block7_data_ref (_data7_), block7_data_unref);
	}
	_g_object_unref0 (view);
	_g_object_unref0 (tvs);
	block7_data_unref (_data7_);
	_data7_ = NULL;
}

/**
     * SmartPlaylists
     */
static void
music_library_window_add_smartplaylist (MusicLibraryWindow* self,
                                        MusicSmartPlaylist* smartplaylist,
                                        MusicLibrary* library,
                                        MusicSourceListExpandableItem* entry)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (smartplaylist != NULL);
	_tmp0_ = music_library_window_get_library_manager (self);
	_tmp1_ = _tmp0_;
	music_library_window_create_smartplaylist_source_list (self, smartplaylist, NULL, (MusicLibrary*) _tmp1_);
}

static void
music_library_window_remove_smartplaylist (MusicLibraryWindow* self,
                                           MusicSmartPlaylist* smartplaylist)
{
	MusicViewWrapper* view = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	MusicViewStack* _tmp7_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (smartplaylist != NULL);
	_tmp0_ = self->match_playlists;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (MusicPlaylist*) smartplaylist);
	view = (MusicViewWrapper*) _tmp1_;
	{
		GeeHashMap* _tmp2_;
		_tmp2_ = self->match_playlists;
		g_rec_mutex_lock (&self->priv->__lock_match_playlists);
		{
			GeeHashMap* _tmp3_;
			MusicSourceListView* _tmp4_;
			GeeHashMap* _tmp5_;
			_tmp3_ = self->match_playlists;
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, (MusicPlaylist*) smartplaylist, NULL);
			_tmp4_ = self->priv->_source_list_view;
			music_source_list_view_remove_playlist (_tmp4_, view);
			_tmp5_ = self->match_playlists;
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, (MusicPlaylist*) smartplaylist, NULL);
		}
		__finally0:
		{
			GeeHashMap* _tmp6_;
			_tmp6_ = self->match_playlists;
			g_rec_mutex_unlock (&self->priv->__lock_match_playlists);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (view);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp7_ = self->priv->_view_stack;
	music_view_stack_remove_view (_tmp7_, (GtkWidget*) view);
	_g_object_unref0 (view);
}

static void
music_library_window_playlist_name_edited (MusicLibraryWindow* self,
                                           GtkGrid* view_wrapper,
                                           const gchar* new_name)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (view_wrapper != NULL);
	g_return_if_fail (new_name != NULL);
	music_library_window_set_search_field_has_focus (self, TRUE);
	if (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view_wrapper)) {
		MusicPlaylistViewWrapper* view = NULL;
		MusicPlaylistViewWrapper* _tmp0_;
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		MusicPlaylistViewWrapper* _tmp3_;
		MusicViewWrapperHint _tmp4_;
		MusicViewWrapperHint _tmp5_;
		_tmp0_ = _g_object_ref0 (MUSIC_IS_PLAYLIST_VIEW_WRAPPER (view_wrapper) ? ((MusicPlaylistViewWrapper*) view_wrapper) : NULL);
		view = _tmp0_;
		_tmp3_ = view;
		_tmp4_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_ == MUSIC_VIEW_WRAPPER_HINT_PLAYLIST) {
			_tmp2_ = TRUE;
		} else {
			MusicPlaylistViewWrapper* _tmp6_;
			MusicViewWrapperHint _tmp7_;
			MusicViewWrapperHint _tmp8_;
			_tmp6_ = view;
			_tmp7_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp6_);
			_tmp8_ = _tmp7_;
			_tmp2_ = _tmp8_ == MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST;
		}
		if (_tmp2_) {
			_tmp1_ = TRUE;
		} else {
			MusicPlaylistViewWrapper* _tmp9_;
			MusicViewWrapperHint _tmp10_;
			MusicViewWrapperHint _tmp11_;
			_tmp9_ = view;
			_tmp10_ = music_view_wrapper_get_hint ((MusicViewWrapper*) _tmp9_);
			_tmp11_ = _tmp10_;
			_tmp1_ = _tmp11_ == MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST;
		}
		if (_tmp1_) {
			{
				GeeIterator* _entry_it = NULL;
				GeeHashMap* _tmp12_;
				GeeSet* _tmp13_;
				GeeSet* _tmp14_;
				GeeSet* _tmp15_;
				GeeIterator* _tmp16_;
				GeeIterator* _tmp17_;
				_tmp12_ = self->match_playlists;
				_tmp13_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = _tmp14_;
				_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
				_tmp17_ = _tmp16_;
				_g_object_unref0 (_tmp15_);
				_entry_it = _tmp17_;
				while (TRUE) {
					GeeIterator* _tmp18_;
					GeeMapEntry* entry = NULL;
					GeeIterator* _tmp19_;
					gpointer _tmp20_;
					GeeMapEntry* _tmp21_;
					gconstpointer _tmp22_;
					gconstpointer _tmp23_;
					MusicPlaylistViewWrapper* _tmp24_;
					MusicPlaylist* _tmp25_;
					MusicPlaylist* _tmp26_;
					_tmp18_ = _entry_it;
					if (!gee_iterator_next (_tmp18_)) {
						break;
					}
					_tmp19_ = _entry_it;
					_tmp20_ = gee_iterator_get (_tmp19_);
					entry = (GeeMapEntry*) _tmp20_;
					_tmp21_ = entry;
					_tmp22_ = gee_map_entry_get_key (_tmp21_);
					_tmp23_ = _tmp22_;
					_tmp24_ = view;
					_tmp25_ = music_view_wrapper_get_playlist ((MusicViewWrapper*) _tmp24_);
					_tmp26_ = _tmp25_;
					if (((MusicPlaylist*) _tmp23_) == _tmp26_) {
						GeeMapEntry* _tmp27_;
						gconstpointer _tmp28_;
						gconstpointer _tmp29_;
						const gchar* _tmp30_;
						const gchar* _tmp31_;
						_tmp27_ = entry;
						_tmp28_ = gee_map_entry_get_key (_tmp27_);
						_tmp29_ = _tmp28_;
						_tmp30_ = music_playlist_get_name ((MusicPlaylist*) _tmp29_);
						_tmp31_ = _tmp30_;
						if (g_strcmp0 (_tmp31_, new_name) != 0) {
							GeeMapEntry* _tmp32_;
							gconstpointer _tmp33_;
							gconstpointer _tmp34_;
							_tmp32_ = entry;
							_tmp33_ = gee_map_entry_get_key (_tmp32_);
							_tmp34_ = _tmp33_;
							music_playlist_set_name ((MusicPlaylist*) _tmp34_, new_name);
							_g_object_unref0 (entry);
							_g_object_unref0 (_entry_it);
							_g_object_unref0 (view);
							return;
						}
					}
					_g_object_unref0 (entry);
				}
				_g_object_unref0 (_entry_it);
			}
		}
		_g_object_unref0 (view);
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		MusicLibraryWindow* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->view);
		_g_object_unref0 (_data8_->p);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
__lambda155_ (MusicLibraryWindow* self,
              MusicPlaylist* playlist)
{
	g_return_if_fail (playlist != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (playlist, MUSIC_TYPE_SMART_PLAYLIST)) {
		music_library_window_show_smart_playlist_dialog (self, G_TYPE_CHECK_INSTANCE_CAST (playlist, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist));
	}
}

static void
___lambda155__music_playlist_view_wrapper_button_clicked (MusicPlaylistViewWrapper* _sender,
                                                          MusicPlaylist* p,
                                                          gpointer self)
{
	__lambda155_ ((MusicLibraryWindow*) self, p);
}

static void
__lambda156_ (Block8Data* _data8_,
              const gchar* old_name)
{
	MusicLibraryWindow* self;
	self = _data8_->self;
	if (old_name != NULL) {
		MusicSourceListView* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp0_ = self->priv->_source_list_view;
		_tmp1_ = music_playlist_get_name ((MusicPlaylist*) _data8_->p);
		_tmp2_ = _tmp1_;
		music_source_list_view_change_playlist_name (_tmp0_, (MusicViewWrapper*) _data8_->view, _tmp2_);
	}
}

static void
___lambda156__music_playlist_updated (MusicPlaylist* _sender,
                                      const gchar* old_name,
                                      gpointer self)
{
	__lambda156_ (self, old_name);
}

static void
music_library_window_create_smartplaylist_source_list (MusicLibraryWindow* self,
                                                       MusicSmartPlaylist* p,
                                                       MusicSourceListExpandableItem* into_expandable,
                                                       MusicLibrary* library)
{
	Block8Data* _data8_;
	MusicSmartPlaylist* _tmp0_;
	MusicTreeViewSetup* tvs = NULL;
	MusicTreeViewSetup* _tmp11_;
	MusicLocalLibrary* _tmp12_;
	MusicLocalLibrary* _tmp13_;
	MusicPlaylistViewWrapper* _tmp14_;
	MusicViewStack* _tmp15_;
	MusicSourceListEntry* entry = NULL;
	MusicSourceListView* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GIcon* _tmp19_;
	MusicSourceListEntry* _tmp20_;
	gboolean _tmp25_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (p);
	_g_object_unref0 (_data8_->p);
	_data8_->p = _tmp0_;
	tvs = NULL;
	if (MUSIC_IS_LOCAL_SMART_PLAYLIST (_data8_->p)) {
		gint64 _tmp1_;
		gint64 _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		MusicLocalLibrary* _tmp5_;
		MusicLocalLibrary* _tmp6_;
		GdaConnection* _tmp7_;
		GdaConnection* _tmp8_;
		MusicTreeViewSetup* _tmp9_;
		_tmp1_ = music_playlist_get_rowid ((MusicPlaylist*) _data8_->p);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strdup_printf ("library:s%lld", _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = music_library_window_get_library_manager (self);
		_tmp6_ = _tmp5_;
		_tmp7_ = music_local_library_get_connection (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, _tmp4_, _tmp8_);
		_g_object_unref0 (tvs);
		tvs = _tmp9_;
		_g_free0 (_tmp4_);
	} else {
		MusicTreeViewSetup* _tmp10_;
		_tmp10_ = music_tree_view_setup_new (MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, NULL, NULL);
		_g_object_unref0 (tvs);
		tvs = _tmp10_;
	}
	_tmp11_ = tvs;
	_tmp12_ = music_library_window_get_library_manager (self);
	_tmp13_ = _tmp12_;
	_tmp14_ = music_playlist_view_wrapper_new ((MusicPlaylist*) _data8_->p, MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, _tmp11_, (MusicLibrary*) _tmp13_);
	g_object_ref_sink (_tmp14_);
	_data8_->view = _tmp14_;
	g_signal_connect_object (_data8_->view, "button-clicked", (GCallback) ___lambda155__music_playlist_view_wrapper_button_clicked, self, 0);
	_tmp15_ = self->priv->_view_stack;
	music_view_stack_add_view (_tmp15_, (GtkWidget*) _data8_->view);
	_tmp16_ = self->priv->_source_list_view;
	_tmp17_ = music_playlist_get_name ((MusicPlaylist*) _data8_->p);
	_tmp18_ = _tmp17_;
	_tmp19_ = ((MusicPlaylist*) _data8_->p)->icon;
	_tmp20_ = music_source_list_view_add_item (_tmp16_, (GtkGrid*) _data8_->view, _tmp18_, MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, _tmp19_, NULL, NULL, NULL);
	entry = _tmp20_;
	g_signal_connect_data ((MusicPlaylist*) _data8_->p, "updated", (GCallback) ___lambda156__music_playlist_updated, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	{
		GeeHashMap* _tmp21_;
		_tmp21_ = self->match_playlists;
		g_rec_mutex_lock (&self->priv->__lock_match_playlists);
		{
			GeeHashMap* _tmp22_;
			GeeHashMap* _tmp23_;
			_tmp22_ = self->priv->match_playlist_entry;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, (MusicPlaylist*) _data8_->p, entry);
			_tmp23_ = self->match_playlists;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, (MusicPlaylist*) _data8_->p, (MusicViewWrapper*) _data8_->view);
		}
		__finally0:
		{
			GeeHashMap* _tmp24_;
			_tmp24_ = self->match_playlists;
			g_rec_mutex_unlock (&self->priv->__lock_match_playlists);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (entry);
			_g_object_unref0 (tvs);
			block8_data_unref (_data8_);
			_data8_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp25_ = self->priv->_newly_created_playlist;
	if (_tmp25_ == TRUE) {
		music_library_window_set_newly_created_playlist (self, FALSE);
		music_library_window_show_playlist_view (self, (MusicPlaylist*) _data8_->p);
	}
	_g_object_unref0 (entry);
	_g_object_unref0 (tvs);
	block8_data_unref (_data8_);
	_data8_ = NULL;
}

/**
     * Dialogs from the interface
     */
void
music_library_window_show_smart_playlist_dialog (MusicLibraryWindow* self,
                                                 MusicSmartPlaylist* smartplaylist)
{
	MusicSmartPlaylistEditor* spe = NULL;
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	MusicSmartPlaylistEditor* _tmp2_;
	MusicSmartPlaylistEditor* _tmp3_;
	g_return_if_fail (self != NULL);
	spe = NULL;
	_tmp0_ = music_library_window_get_library_manager (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_smart_playlist_editor_new (smartplaylist, (MusicLibrary*) _tmp1_);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (spe);
	spe = _tmp2_;
	_tmp3_ = spe;
	gtk_widget_show ((GtkWidget*) _tmp3_);
	_g_object_unref0 (spe);
}

/** This should be used whenever a call to play a new media is made
     *
     * XXX: this doesn't belong here, but to the playback manager
     * @param s The media that is now playing
     */
static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		MusicLibraryWindow* self;
		self = _data9_->self;
		_g_object_unref0 (_data9_->m);
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}

static void*
___lambda166_ (MusicLibraryWindow* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	void* result;
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	g_signal_emit_by_name ((MusicLibraryWindowInterface*) self, "update-media-info", _tmp3_);
	result = NULL;
	return result;
}

static gpointer
____lambda166__gthread_func (gpointer self)
{
	gpointer result;
	result = ___lambda166_ ((MusicLibraryWindow*) self);
	g_object_unref (self);
	return result;
}

static gboolean
__lambda165_ (Block9Data* _data9_)
{
	MusicLibraryWindow* self;
	gboolean _tmp0_ = FALSE;
	MusicPlaybackManager* _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	gboolean result;
	self = _data9_->self;
	_tmp1_ = music_app_get_player ();
	_tmp2_ = _tmp1_;
	_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ != NULL) {
		MusicPlaybackManager* _tmp5_;
		MusicPlaybackManager* _tmp6_;
		MusicMedia* _tmp7_;
		MusicMedia* _tmp8_;
		_tmp5_ = music_app_get_player ();
		_tmp6_ = _tmp5_;
		_tmp7_ = music_playback_manager_get_current_media (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp8_ == _data9_->m;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GThread* _tmp9_;
		GThread* _tmp10_;
		_tmp9_ = g_thread_new (NULL, ____lambda166__gthread_func, g_object_ref (self));
		_tmp10_ = _tmp9_;
		_g_thread_unref0 (_tmp10_);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda165__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda165_ (self);
	return result;
}

static void
music_library_window_media_played (MusicLibraryWindow* self,
                                   MusicMedia* m)
{
	Block9Data* _data9_;
	MusicMedia* _tmp0_;
	MusicTopDisplay* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_data9_ = g_slice_new0 (Block9Data);
	_data9_->_ref_count_ = 1;
	_data9_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (m);
	_g_object_unref0 (_data9_->m);
	_data9_->m = _tmp0_;
	_tmp1_ = self->priv->top_display;
	music_top_display_update_media (_tmp1_);
	music_library_window_set_media_considered_previewed (self, FALSE);
	music_library_window_set_media_considered_played (self, FALSE);
	music_library_window_set_added_to_play_count (self, FALSE);
	music_library_window_set_media_half_played_sended (self, FALSE);
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 3000, ___lambda165__gsource_func, block9_data_ref (_data9_), block9_data_unref);
	block9_data_unref (_data9_);
	_data9_ = NULL;
}

static GVariant*
_variant_new3 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static void
music_library_window_real_playback_stopped (MusicLibraryWindow* self,
                                            gint64 was_playing)
{
	GAction* _tmp0_;
	GVariant* _tmp1_;
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp1_ = _variant_new3 (FALSE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), _tmp1_);
	_g_variant_unref0 (_tmp1_);
	music_library_window_set_media_considered_previewed (self, FALSE);
	music_library_window_set_media_considered_played (self, FALSE);
	music_library_window_set_added_to_play_count (self, FALSE);
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
	g_debug ("LibraryWindow.vala:961: playback stopped");
}

void
music_library_window_playback_stopped (MusicLibraryWindow* self,
                                       gint64 was_playing)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->playback_stopped) {
		_klass_->playback_stopped (self, was_playing);
	}
}

static void
music_library_window_real_play_media (MusicLibraryWindow* self,
                                      gboolean inhibit_notifications)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		MusicPlaybackManager* _tmp4_;
		MusicPlaybackManager* _tmp5_;
		MusicMedia* _tmp6_;
		MusicMedia* _tmp7_;
		MusicPlaybackManager* _tmp8_;
		MusicPlaybackManager* _tmp9_;
		g_debug ("LibraryWindow.vala:966: No media is currently playing. Starting from t" \
"he top\n");
		_tmp4_ = music_app_get_player ();
		_tmp5_ = _tmp4_;
		_tmp6_ = music_playback_manager_get_next (_tmp5_, TRUE);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp7_);
		_tmp8_ = music_app_get_player ();
		_tmp9_ = _tmp8_;
		music_playback_manager_start_playback (_tmp9_);
		if (!inhibit_notifications) {
			music_library_window_notify_current_media_async (self, NULL, NULL);
		}
	} else {
		MusicPlaybackManager* _tmp10_;
		MusicPlaybackManager* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		_tmp10_ = music_app_get_player ();
		_tmp11_ = _tmp10_;
		_tmp12_ = music_playback_manager_get_playing (_tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp13_) {
			MusicPlaybackManager* _tmp14_;
			MusicPlaybackManager* _tmp15_;
			_tmp14_ = music_app_get_player ();
			_tmp15_ = _tmp14_;
			music_playback_manager_pause_playback (_tmp15_);
		} else {
			MusicPlaybackManager* _tmp16_;
			MusicPlaybackManager* _tmp17_;
			_tmp16_ = music_app_get_player ();
			_tmp17_ = _tmp16_;
			music_playback_manager_start_playback (_tmp17_);
		}
	}
	g_signal_emit (self, music_library_window_signals[MUSIC_LIBRARY_WINDOW_PLAY_PAUSE_CHANGED_SIGNAL], 0);
}

void
music_library_window_play_media (MusicLibraryWindow* self,
                                 gboolean inhibit_notifications)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->play_media) {
		_klass_->play_media (self, inhibit_notifications);
	}
}

static void
music_library_window_real_play_next_media (MusicLibraryWindow* self,
                                           gboolean inhibit_notifications)
{
	gboolean _tmp0_;
	MusicMedia* m = NULL;
	MusicPlaybackManager* _tmp7_;
	MusicPlaybackManager* _tmp8_;
	MusicMedia* _tmp9_;
	MusicMedia* _tmp10_;
	_tmp0_ = self->priv->_added_to_play_count;
	if (!_tmp0_) {
		MusicPlaybackManager* _tmp1_;
		MusicPlaybackManager* _tmp2_;
		MusicMedia* _tmp3_;
		MusicMedia* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
		_tmp1_ = music_app_get_player ();
		_tmp2_ = _tmp1_;
		_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = music_media_get_skip_count (_tmp4_);
		_tmp6_ = _tmp5_;
		music_media_set_skip_count (_tmp4_, _tmp6_ + 1);
	}
	_tmp7_ = music_app_get_player ();
	_tmp8_ = _tmp7_;
	_tmp9_ = music_playback_manager_get_next (_tmp8_, TRUE);
	m = _tmp9_;
	_tmp10_ = m;
	if (_tmp10_ == NULL) {
		MusicPlaybackManager* _tmp11_;
		MusicPlaybackManager* _tmp12_;
		_tmp11_ = music_app_get_player ();
		_tmp12_ = _tmp11_;
		music_playback_manager_stop_playback (_tmp12_);
		music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
		_g_object_unref0 (m);
		return;
	}
	if (!inhibit_notifications) {
		music_library_window_notify_current_media_async (self, NULL, NULL);
	}
	_g_object_unref0 (m);
}

void
music_library_window_play_next_media (MusicLibraryWindow* self,
                                      gboolean inhibit_notifications)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->play_next_media) {
		_klass_->play_next_media (self, inhibit_notifications);
	}
}

static void
music_library_window_real_play_previous_media (MusicLibraryWindow* self,
                                               gboolean inhibit_notifications)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlayback* _tmp2_;
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_->player;
	if (music_playback_get_position (_tmp2_) < 5000000000LL) {
		gboolean play = FALSE;
		MusicMedia* prev = NULL;
		MusicPlaybackManager* _tmp3_;
		MusicPlaybackManager* _tmp4_;
		MusicMedia* _tmp5_;
		MusicMedia* _tmp6_;
		play = TRUE;
		_tmp3_ = music_app_get_player ();
		_tmp4_ = _tmp3_;
		_tmp5_ = music_playback_manager_get_previous (_tmp4_, TRUE);
		prev = _tmp5_;
		_tmp6_ = prev;
		if (_tmp6_ == NULL) {
			MusicPlaybackManager* _tmp7_;
			MusicPlaybackManager* _tmp8_;
			_tmp7_ = music_app_get_player ();
			_tmp8_ = _tmp7_;
			music_playback_manager_stop_playback (_tmp8_);
			music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
			_g_object_unref0 (prev);
			return;
		} else {
			gboolean _tmp9_ = FALSE;
			if (play) {
				_tmp9_ = !inhibit_notifications;
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				music_library_window_notify_current_media_async (self, NULL, NULL);
			}
		}
		_g_object_unref0 (prev);
	} else {
		MusicTopDisplay* _tmp10_;
		_tmp10_ = self->priv->top_display;
		music_top_display_change_value (_tmp10_, GTK_SCROLL_NONE, (gdouble) 0);
	}
}

void
music_library_window_play_previous_media (MusicLibraryWindow* self,
                                          gboolean inhibit_notifications)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->play_previous_media) {
		_klass_->play_previous_media (self, inhibit_notifications);
	}
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

static void
music_library_window_real_action_import (MusicLibraryWindow* self)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	_tmp0_ = music_library_window_get_library_manager (self);
	_tmp1_ = _tmp0_;
	if (!music_library_doing_file_operations ((MusicLibrary*) _tmp1_)) {
		GtkFileChooserNative* file_chooser = NULL;
		GtkFileChooserNative* _tmp2_;
		GtkFileChooserNative* _tmp3_;
		GtkFileChooserNative* _tmp4_;
		GeeTreeSet* folders = NULL;
		GeeTreeSet* _tmp5_;
		GtkFileChooserNative* _tmp6_;
		GtkFileChooserNative* _tmp12_;
		GeeTreeSet* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
		MusicSettingsMain* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		gboolean _tmp21_;
		_tmp2_ = gtk_file_chooser_native_new (_ ("Import Music"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, _ ("Open"), _ ("Cancel"));
		file_chooser = _tmp2_;
		_tmp3_ = file_chooser;
		gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp3_, TRUE);
		_tmp4_ = file_chooser;
		gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp4_, TRUE);
		_tmp5_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
		folders = _tmp5_;
		_tmp6_ = file_chooser;
		if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp6_) == ((gint) GTK_RESPONSE_ACCEPT)) {
			GtkFileChooserNative* _tmp7_;
			GSList* _tmp8_;
			_tmp7_ = file_chooser;
			_tmp8_ = gtk_file_chooser_get_filenames ((GtkFileChooser*) _tmp7_);
			{
				GSList* folder_collection = NULL;
				GSList* folder_it = NULL;
				folder_collection = _tmp8_;
				for (folder_it = folder_collection; folder_it != NULL; folder_it = folder_it->next) {
					gchar* _tmp9_;
					gchar* folder = NULL;
					_tmp9_ = g_strdup ((const gchar*) folder_it->data);
					folder = _tmp9_;
					{
						GeeTreeSet* _tmp10_;
						const gchar* _tmp11_;
						_tmp10_ = folders;
						_tmp11_ = folder;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
						_g_free0 (folder);
					}
				}
				(folder_collection == NULL) ? NULL : (folder_collection = (_g_slist_free__g_free0_ (folder_collection), NULL));
			}
		}
		_tmp12_ = file_chooser;
		gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp12_);
		_tmp13_ = folders;
		_tmp14_ = gee_collection_get_is_empty ((GeeCollection*) _tmp13_);
		_tmp15_ = _tmp14_;
		if (_tmp15_) {
			_g_object_unref0 (folders);
			_g_object_unref0 (file_chooser);
			return;
		}
		_tmp16_ = self->priv->main_settings;
		_tmp17_ = music_settings_main_get_music_folder (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_file_new_for_path (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_file_query_exists (_tmp20_, NULL);
		_g_object_unref0 (_tmp20_);
		if (_tmp21_) {
			MusicLocalLibrary* _tmp22_;
			MusicLocalLibrary* _tmp23_;
			GeeTreeSet* _tmp24_;
			_tmp22_ = music_library_window_get_library_manager (self);
			_tmp23_ = _tmp22_;
			_tmp24_ = folders;
			music_local_library_add_folder_to_library (_tmp23_, (GeeCollection*) _tmp24_);
			music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
		}
		_g_object_unref0 (folders);
		_g_object_unref0 (file_chooser);
	} else {
		g_debug ("LibraryWindow.vala:1053: Can't add to library.. already doing file ope" \
"rations\n");
	}
}

void
music_library_window_action_import (MusicLibraryWindow* self)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->action_import) {
		_klass_->action_import (self);
	}
}

static void
music_library_window_action_play (MusicLibraryWindow* self)
{
	g_return_if_fail (self != NULL);
	music_library_window_play_media (self, FALSE);
}

static void
music_library_window_action_play_next (MusicLibraryWindow* self)
{
	g_return_if_fail (self != NULL);
	music_library_window_play_next_media (self, FALSE);
}

static void
music_library_window_action_play_previous (MusicLibraryWindow* self)
{
	g_return_if_fail (self != NULL);
	music_library_window_play_previous_media (self, FALSE);
}

static void
music_library_window_action_quit (MusicLibraryWindow* self)
{
	g_return_if_fail (self != NULL);
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
music_library_window_action_search (MusicLibraryWindow* self)
{
	GtkSearchEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_search_entry;
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
}

static void
music_library_window_action_view_albums (MusicLibraryWindow* self)
{
	MusicWidgetsViewSelector* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_view_selector;
	music_widgets_view_selector_set_selected (_tmp0_, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID);
}

static void
music_library_window_action_view_columns (MusicLibraryWindow* self)
{
	MusicWidgetsViewSelector* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_view_selector;
	music_widgets_view_selector_set_selected (_tmp0_, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN);
}

static void
music_library_window_action_view_list (MusicLibraryWindow* self)
{
	MusicWidgetsViewSelector* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_view_selector;
	music_widgets_view_selector_set_selected (_tmp0_, MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST);
}

static void
music_library_window_edit_preferences_click (MusicLibraryWindow* self)
{
	MusicPreferencesWindow* _tmp0_;
	MusicPreferencesWindow* _tmp2_;
	MusicPreferencesWindow* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->preferences;
	if (_tmp0_ == NULL) {
		MusicPreferencesWindow* _tmp1_;
		_tmp1_ = music_preferences_window_new ();
		g_object_ref_sink (_tmp1_);
		_g_object_unref0 (self->priv->preferences);
		self->priv->preferences = _tmp1_;
	}
	_tmp2_ = self->priv->preferences;
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->preferences;
	gtk_dialog_run ((GtkDialog*) _tmp3_);
	_g_object_unref0 (self->priv->preferences);
	self->priv->preferences = NULL;
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		MusicLibraryWindow* self;
		self = _data10_->self;
		_g_free0 (_data10_->folder);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static void
___lambda122_ (Block10Data* _data10_,
               gboolean cont)
{
	MusicLibraryWindow* self;
	self = _data10_->self;
	if (cont) {
		MusicLocalLibrary* _tmp0_;
		MusicLocalLibrary* _tmp1_;
		_tmp0_ = music_library_window_get_library_manager (self);
		_tmp1_ = _tmp0_;
		music_local_library_set_music_folder (_tmp1_, _data10_->folder, NULL, NULL);
	}
}

static void
____lambda122__music_set_music_folder_confirmation_finished (MusicSetMusicFolderConfirmation* _sender,
                                                             gboolean response,
                                                             gpointer self)
{
	___lambda122_ (self, response);
}

void
music_library_window_set_music_folder (MusicLibraryWindow* self,
                                       const gchar* folder)
{
	Block10Data* _data10_;
	gchar* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	MusicLocalLibrary* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp14_ = FALSE;
	MusicLocalLibrary* _tmp15_;
	MusicLocalLibrary* _tmp16_;
	GeeCollection* _tmp17_;
	GeeCollection* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (folder != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = g_strdup (folder);
	_g_free0 (_data10_->folder);
	_data10_->folder = _tmp0_;
	_tmp1_ = music_library_window_get_library_manager (self);
	_tmp2_ = _tmp1_;
	if (music_library_doing_file_operations ((MusicLibrary*) _tmp2_)) {
		block10_data_unref (_data10_);
		_data10_ = NULL;
		return;
	}
	if (g_strcmp0 (_data10_->folder, "") == 0) {
		_tmp3_ = TRUE;
	} else {
		gboolean _tmp4_ = FALSE;
		MusicSettingsMain* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp5_ = self->priv->main_settings;
		_tmp6_ = music_settings_main_get_music_folder (_tmp5_);
		_tmp7_ = _tmp6_;
		if (g_strcmp0 (_data10_->folder, _tmp7_) == 0) {
			MusicLocalLibrary* _tmp8_;
			MusicLocalLibrary* _tmp9_;
			GeeCollection* _tmp10_;
			GeeCollection* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
			_tmp8_ = music_library_window_get_library_manager (self);
			_tmp9_ = _tmp8_;
			_tmp10_ = music_library_get_medias ((MusicLibrary*) _tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = gee_collection_get_is_empty (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp4_ = !_tmp13_;
			_g_object_unref0 (_tmp11_);
		} else {
			_tmp4_ = FALSE;
		}
		_tmp3_ = _tmp4_;
	}
	if (_tmp3_) {
		block10_data_unref (_data10_);
		_data10_ = NULL;
		return;
	}
	_tmp15_ = music_library_window_get_library_manager (self);
	_tmp16_ = _tmp15_;
	_tmp17_ = music_library_get_medias ((MusicLibrary*) _tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = gee_collection_get_is_empty (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = !_tmp20_;
	_g_object_unref0 (_tmp18_);
	if (_tmp21_) {
		_tmp14_ = TRUE;
	} else {
		MusicLocalLibrary* _tmp22_;
		MusicLocalLibrary* _tmp23_;
		_tmp22_ = music_library_window_get_library_manager (self);
		_tmp23_ = _tmp22_;
		_tmp14_ = music_library_playlist_count_without_read_only ((MusicLibrary*) _tmp23_) > 0;
	}
	if (_tmp14_) {
		MusicSetMusicFolderConfirmation* smfc = NULL;
		MusicSetMusicFolderConfirmation* _tmp24_;
		MusicSetMusicFolderConfirmation* _tmp25_;
		_tmp24_ = music_set_music_folder_confirmation_new (_data10_->folder);
		g_object_ref_sink (_tmp24_);
		smfc = _tmp24_;
		_tmp25_ = smfc;
		g_signal_connect_data (_tmp25_, "finished", (GCallback) ____lambda122__music_set_music_folder_confirmation_finished, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
		_g_object_unref0 (smfc);
	} else {
		MusicLocalLibrary* _tmp26_;
		MusicLocalLibrary* _tmp27_;
		_tmp26_ = music_library_window_get_library_manager (self);
		_tmp27_ = _tmp26_;
		music_local_library_set_music_folder (_tmp27_, _data10_->folder, NULL, NULL);
	}
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

static void
music_library_window_real_end_of_stream (MusicLibraryWindow* self)
{
	music_library_window_play_next_media (self, FALSE);
}

void
music_library_window_end_of_stream (MusicLibraryWindow* self)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->end_of_stream) {
		_klass_->end_of_stream (self);
	}
}

static void
music_library_window_real_error_occured (MusicLibraryWindow* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		music_library_window_play_media (self, FALSE);
	}
}

void
music_library_window_error_occured (MusicLibraryWindow* self)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->error_occured) {
		_klass_->error_occured (self);
	}
}

static void
music_library_window_real_current_position_update (MusicLibraryWindow* self,
                                                   gint64 position)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	gdouble sec = 0.0;
	gdouble media_length = 0.0;
	MusicPlaybackManager* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicMedia* _tmp6_;
	MusicMedia* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	MusicPlaybackManager* _tmp10_;
	MusicPlaybackManager* _tmp11_;
	MusicStreamer* _tmp12_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp61_ = FALSE;
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		return;
	}
	sec = ((gdouble) position) / 1000000000;
	_tmp4_ = music_app_get_player ();
	_tmp5_ = _tmp4_;
	_tmp6_ = music_playback_manager_get_current_media (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = music_media_get_length (_tmp7_);
	_tmp9_ = _tmp8_;
	media_length = ((gdouble) _tmp9_) / 1000;
	_tmp10_ = music_app_get_player ();
	_tmp11_ = _tmp10_;
	_tmp12_ = _tmp11_->file_player;
	if (_tmp12_->set_resume_pos) {
		MusicPlaybackManager* _tmp13_;
		MusicPlaybackManager* _tmp14_;
		MusicMedia* _tmp15_;
		MusicMedia* _tmp16_;
		_tmp13_ = music_app_get_player ();
		_tmp14_ = _tmp13_;
		_tmp15_ = music_playback_manager_get_current_media (_tmp14_);
		_tmp16_ = _tmp15_;
		music_media_set_resume_pos (_tmp16_, (gint) sec);
	}
	if (sec > ((gdouble) 3)) {
		gboolean _tmp18_;
		_tmp18_ = self->priv->_media_considered_previewed;
		_tmp17_ = !_tmp18_;
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		MusicPlaybackManager* _tmp19_;
		MusicPlaybackManager* _tmp20_;
		MusicMedia* _tmp21_;
		MusicMedia* _tmp22_;
		music_library_window_set_media_considered_previewed (self, TRUE);
		_tmp19_ = music_app_get_player ();
		_tmp20_ = _tmp19_;
		_tmp21_ = music_playback_manager_get_current_media (_tmp20_);
		_tmp22_ = _tmp21_;
		g_signal_emit_by_name ((MusicLibraryWindowInterface*) self, "update-media-info", _tmp22_);
	}
	if (sec > ((gdouble) 30)) {
		gboolean _tmp24_;
		_tmp24_ = self->priv->_media_considered_played;
		_tmp23_ = !_tmp24_;
	} else {
		_tmp23_ = FALSE;
	}
	if (_tmp23_) {
		MusicPlaybackManager* _tmp25_;
		MusicPlaybackManager* _tmp26_;
		MusicMedia* _tmp27_;
		MusicMedia* _tmp28_;
		time_t _tmp29_;
		MusicLocalLibrary* _tmp30_;
		MusicLocalLibrary* _tmp31_;
		MusicPlaybackManager* _tmp32_;
		MusicPlaybackManager* _tmp33_;
		MusicMedia* _tmp34_;
		MusicMedia* _tmp35_;
		MusicPlaybackManager* _tmp36_;
		MusicPlaybackManager* _tmp37_;
		MusicHistoryPlaylist* _tmp38_;
		GeeArrayList* _tmp39_;
		GeeArrayList* _tmp40_;
		MusicPlaybackManager* _tmp41_;
		MusicPlaybackManager* _tmp42_;
		MusicMedia* _tmp43_;
		MusicMedia* _tmp44_;
		music_library_window_set_media_considered_played (self, TRUE);
		_tmp25_ = music_app_get_player ();
		_tmp26_ = _tmp25_;
		_tmp27_ = music_playback_manager_get_current_media (_tmp26_);
		_tmp28_ = _tmp27_;
		_tmp29_ = time (NULL);
		music_media_set_last_played (_tmp28_, (guint) ((gint) _tmp29_));
		_tmp30_ = music_library_window_get_library_manager (self);
		_tmp31_ = _tmp30_;
		_tmp32_ = music_app_get_player ();
		_tmp33_ = _tmp32_;
		_tmp34_ = music_playback_manager_get_current_media (_tmp33_);
		_tmp35_ = _tmp34_;
		music_library_update_media ((MusicLibrary*) _tmp31_, _tmp35_, FALSE, FALSE);
		_tmp36_ = music_app_get_player ();
		_tmp37_ = _tmp36_;
		_tmp38_ = _tmp37_->history_playlist;
		_tmp39_ = music_playlist_get_medias ((MusicPlaylist*) _tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = music_app_get_player ();
		_tmp42_ = _tmp41_;
		_tmp43_ = music_playback_manager_get_current_media (_tmp42_);
		_tmp44_ = _tmp43_;
		if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp40_, _tmp44_)) {
			GeeTreeSet* temp_media = NULL;
			GeeTreeSet* _tmp45_;
			GeeTreeSet* _tmp46_;
			MusicPlaybackManager* _tmp47_;
			MusicPlaybackManager* _tmp48_;
			MusicMedia* _tmp49_;
			MusicMedia* _tmp50_;
			MusicPlaybackManager* _tmp51_;
			MusicPlaybackManager* _tmp52_;
			MusicHistoryPlaylist* _tmp53_;
			GeeTreeSet* _tmp54_;
			_tmp45_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			temp_media = _tmp45_;
			_tmp46_ = temp_media;
			_tmp47_ = music_app_get_player ();
			_tmp48_ = _tmp47_;
			_tmp49_ = music_playback_manager_get_current_media (_tmp48_);
			_tmp50_ = _tmp49_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp46_, _tmp50_);
			_tmp51_ = music_app_get_player ();
			_tmp52_ = _tmp51_;
			_tmp53_ = _tmp52_->history_playlist;
			_tmp54_ = temp_media;
			music_playlist_add_medias ((MusicPlaylist*) _tmp53_, (GeeCollection*) _tmp54_);
			_g_object_unref0 (temp_media);
		}
	}
	if ((sec / media_length) > 0.50) {
		gboolean _tmp56_;
		_tmp56_ = self->priv->_media_half_played_sended;
		_tmp55_ = _tmp56_ == FALSE;
	} else {
		_tmp55_ = FALSE;
	}
	if (_tmp55_) {
		MusicPlaybackManager* _tmp57_;
		MusicPlaybackManager* _tmp58_;
		MusicMedia* _tmp59_;
		MusicMedia* _tmp60_;
		_tmp57_ = music_app_get_player ();
		_tmp58_ = _tmp57_;
		_tmp59_ = music_playback_manager_get_current_media (_tmp58_);
		_tmp60_ = _tmp59_;
		g_signal_emit_by_name ((MusicLibraryWindowInterface*) self, "media-half-played", _tmp60_);
		music_library_window_set_media_half_played_sended (self, TRUE);
	}
	if ((sec / media_length) > 0.80) {
		gboolean _tmp62_;
		_tmp62_ = self->priv->_added_to_play_count;
		_tmp61_ = !_tmp62_;
	} else {
		_tmp61_ = FALSE;
	}
	if (_tmp61_) {
		MusicPlaybackManager* _tmp63_;
		MusicPlaybackManager* _tmp64_;
		MusicMedia* _tmp65_;
		MusicMedia* _tmp66_;
		guint _tmp67_;
		guint _tmp68_;
		MusicLocalLibrary* _tmp69_;
		MusicLocalLibrary* _tmp70_;
		MusicPlaybackManager* _tmp71_;
		MusicPlaybackManager* _tmp72_;
		MusicMedia* _tmp73_;
		MusicMedia* _tmp74_;
		music_library_window_set_added_to_play_count (self, TRUE);
		_tmp63_ = music_app_get_player ();
		_tmp64_ = _tmp63_;
		_tmp65_ = music_playback_manager_get_current_media (_tmp64_);
		_tmp66_ = _tmp65_;
		_tmp67_ = music_media_get_play_count (_tmp66_);
		_tmp68_ = _tmp67_;
		music_media_set_play_count (_tmp66_, _tmp68_ + 1);
		_tmp69_ = music_library_window_get_library_manager (self);
		_tmp70_ = _tmp69_;
		_tmp71_ = music_app_get_player ();
		_tmp72_ = _tmp71_;
		_tmp73_ = music_playback_manager_get_current_media (_tmp72_);
		_tmp74_ = _tmp73_;
		music_library_update_media ((MusicLibrary*) _tmp70_, _tmp74_, FALSE, FALSE);
	}
}

void
music_library_window_current_position_update (MusicLibraryWindow* self,
                                              gint64 position)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->current_position_update) {
		_klass_->current_position_update (self, position);
	}
}

static void
music_library_window_search_entry_activate (MusicLibraryWindow* self)
{
	GtkWidget* vw = NULL;
	MusicViewStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkWidget* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_view_stack;
	_tmp1_ = gtk_stack_get_visible_child ((GtkStack*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	vw = _tmp3_;
	_tmp5_ = vw;
	if (_tmp5_ != NULL) {
		GtkWidget* _tmp6_;
		_tmp6_ = vw;
		_tmp4_ = MUSIC_IS_VIEW_WRAPPER (_tmp6_);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GtkWidget* _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = vw;
		_tmp8_ = FALSE;
		music_view_wrapper_play_first_media (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper), &_tmp8_);
	}
	_g_object_unref0 (vw);
}

static void
music_library_window_real_drag_received (MusicLibraryWindow* self,
                                         GdkDragContext* context,
                                         gint x,
                                         gint y,
                                         GtkSelectionData* data,
                                         guint info,
                                         guint timestamp)
{
	GeeTreeSet* files_dragged = NULL;
	GeeTreeSet* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	MusicLocalLibrary* _tmp10_;
	MusicLocalLibrary* _tmp11_;
	GeeTreeSet* _tmp12_;
	g_return_if_fail (context != NULL);
	g_return_if_fail (data != NULL);
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	files_dragged = _tmp0_;
	g_debug ("LibraryWindow.vala:1184: dragged\n");
	_tmp2_ = _tmp1_ = gtk_selection_data_get_uris (data);
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
		uri_collection = _tmp2_;
		uri_collection_length1 = _vala_array_length (_tmp1_);
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
			gchar* _tmp3_;
			gchar* uri = NULL;
			_tmp3_ = g_strdup (uri_collection[uri_it]);
			uri = _tmp3_;
			{
				GeeTreeSet* _tmp4_;
				const gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				_tmp4_ = files_dragged;
				_tmp5_ = uri;
				_tmp6_ = g_file_new_for_uri (_tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = g_file_get_path (_tmp7_);
				_tmp9_ = _tmp8_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp9_);
				_g_free0 (_tmp9_);
				_g_object_unref0 (_tmp7_);
				_g_free0 (uri);
			}
		}
		uri_collection = (_vala_array_free (uri_collection, uri_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp10_ = music_library_window_get_library_manager (self);
	_tmp11_ = _tmp10_;
	_tmp12_ = files_dragged;
	music_library_add_files_to_library ((MusicLibrary*) _tmp11_, (GeeCollection*) _tmp12_);
	_g_object_unref0 (files_dragged);
}

void
music_library_window_drag_received (MusicLibraryWindow* self,
                                    GdkDragContext* context,
                                    gint x,
                                    gint y,
                                    GtkSelectionData* data,
                                    guint info,
                                    guint timestamp)
{
	MusicLibraryWindowClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_WINDOW_GET_CLASS (self);
	if (_klass_->drag_received) {
		_klass_->drag_received (self, context, x, y, data, info, timestamp);
	}
}

static void
music_library_window_show_alert (MusicLibraryWindow* self,
                                 const gchar* title,
                                 const gchar* message)
{
	GraniteMessageDialog* dialog = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GraniteMessageDialog* _tmp2_;
	GraniteMessageDialog* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
	_tmp1_ = _tmp0_;
	_tmp2_ = granite_message_dialog_new (title, message, (GIcon*) _tmp1_, GTK_BUTTONS_CLOSE);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	dialog = _tmp3_;
	gtk_window_set_transient_for ((GtkWindow*) dialog, (GtkWindow*) self);
	gtk_dialog_run ((GtkDialog*) dialog);
	gtk_widget_destroy ((GtkWidget*) dialog);
	_g_object_unref0 (dialog);
}

static void
music_library_window_on_quit (MusicLibraryWindow* self)
{
	MusicSettingsMain* _tmp0_;
	MusicPlaybackManager* _tmp28_;
	MusicPlaybackManager* _tmp29_;
	MusicPlayback* _tmp30_;
	GSettings* _tmp31_;
	GSettings* _tmp32_;
	MusicWidgetsViewSelector* _tmp33_;
	MusicWidgetsViewSelectorMode _tmp34_;
	MusicWidgetsViewSelectorMode _tmp35_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main_settings;
	if (!music_settings_main_privacy_mode_enabled (_tmp0_)) {
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		MusicPlaybackManager* _tmp3_;
		MusicPlaybackManager* _tmp4_;
		MusicPlayback* _tmp5_;
		MusicPlaybackManager* _tmp6_;
		MusicPlaybackManager* _tmp7_;
		MusicMedia* _tmp8_;
		MusicMedia* _tmp9_;
		GSettings* _tmp23_;
		GSettings* _tmp24_;
		GtkSearchEntry* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		_tmp1_ = music_app_get_saved_state ();
		_tmp2_ = _tmp1_;
		_tmp3_ = music_app_get_player ();
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_->player;
		g_settings_set_int (_tmp2_, "last-media-position", (gint) (((gdouble) music_playback_get_position (_tmp5_)) / MUSIC_TIME_UTILS_NANO_INV));
		_tmp6_ = music_app_get_player ();
		_tmp7_ = _tmp6_;
		_tmp8_ = music_playback_manager_get_current_media (_tmp7_);
		_tmp9_ = _tmp8_;
		if (_tmp9_ != NULL) {
			MusicPlaybackManager* _tmp10_;
			MusicPlaybackManager* _tmp11_;
			MusicMedia* _tmp12_;
			MusicMedia* _tmp13_;
			MusicPlaybackManager* _tmp14_;
			MusicPlaybackManager* _tmp15_;
			MusicPlayback* _tmp16_;
			MusicLocalLibrary* _tmp17_;
			MusicLocalLibrary* _tmp18_;
			MusicPlaybackManager* _tmp19_;
			MusicPlaybackManager* _tmp20_;
			MusicMedia* _tmp21_;
			MusicMedia* _tmp22_;
			_tmp10_ = music_app_get_player ();
			_tmp11_ = _tmp10_;
			_tmp12_ = music_playback_manager_get_current_media (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = music_app_get_player ();
			_tmp15_ = _tmp14_;
			_tmp16_ = _tmp15_->player;
			music_media_set_resume_pos (_tmp13_, (gint) (((gdouble) music_playback_get_position (_tmp16_)) / MUSIC_TIME_UTILS_NANO_INV));
			_tmp17_ = music_library_window_get_library_manager (self);
			_tmp18_ = _tmp17_;
			_tmp19_ = music_app_get_player ();
			_tmp20_ = _tmp19_;
			_tmp21_ = music_playback_manager_get_current_media (_tmp20_);
			_tmp22_ = _tmp21_;
			music_library_update_media ((MusicLibrary*) _tmp18_, _tmp22_, FALSE, FALSE);
		}
		_tmp23_ = music_app_get_saved_state ();
		_tmp24_ = _tmp23_;
		_tmp25_ = self->priv->_search_entry;
		_tmp26_ = gtk_entry_get_text ((GtkEntry*) _tmp25_);
		_tmp27_ = _tmp26_;
		g_settings_set_string (_tmp24_, "search-string", _tmp27_);
	}
	_tmp28_ = music_app_get_player ();
	_tmp29_ = _tmp28_;
	_tmp30_ = _tmp29_->player;
	music_playback_pause (_tmp30_);
	_tmp31_ = music_app_get_saved_state ();
	_tmp32_ = _tmp31_;
	_tmp33_ = self->priv->_view_selector;
	_tmp34_ = music_widgets_view_selector_get_selected (_tmp33_);
	_tmp35_ = _tmp34_;
	g_settings_set_int (_tmp32_, "view-mode", (gint) _tmp35_);
}

/**
     * Called when the user tries to quit the application using a mechanism provided
     * by the desktop shell (close button, quicklists, etc.)
     *
     * This doesn't apply to calls to App.instance.quit ()
     */
static gboolean
music_library_window_real_delete_event (GtkWidget* base,
                                        GdkEventAny* event)
{
	MusicLibraryWindow * self;
	gboolean _tmp0_ = FALSE;
	MusicPlaybackManager* _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	gboolean playing = FALSE;
	gboolean _tmp9_ = FALSE;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	gboolean result;
	self = (MusicLibraryWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = music_app_get_player ();
	_tmp2_ = _tmp1_;
	_tmp3_ = music_playback_manager_get_current_media (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ != NULL) {
		MusicPlaybackManager* _tmp5_;
		MusicPlaybackManager* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp5_ = music_app_get_player ();
		_tmp6_ = _tmp5_;
		_tmp7_ = music_playback_manager_get_playing (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	playing = _tmp0_;
	_tmp10_ = music_app_get_settings ();
	_tmp11_ = _tmp10_;
	if (!g_settings_get_boolean (_tmp11_, "close-while-playing")) {
		_tmp9_ = playing;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		gtk_widget_hide ((GtkWidget*) self);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda167_ (MusicLibraryWindow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean result;
	self->priv->configure_id = (guint) 0;
	_tmp0_ = music_app_get_saved_state ();
	_tmp1_ = _tmp0_;
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	g_settings_set_boolean (_tmp1_, "window-maximized", _tmp3_);
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	if (!_tmp5_) {
		gint width = 0;
		gint height = 0;
		gint root_x = 0;
		gint root_y = 0;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		GSettings* _tmp10_;
		GSettings* _tmp11_;
		GSettings* _tmp12_;
		GSettings* _tmp13_;
		gtk_window_get_position ((GtkWindow*) self, &_tmp6_, &_tmp7_);
		root_x = _tmp6_;
		root_y = _tmp7_;
		gtk_window_get_size ((GtkWindow*) self, &_tmp8_, &_tmp9_);
		width = _tmp8_;
		height = _tmp9_;
		_tmp10_ = music_app_get_saved_state ();
		_tmp11_ = _tmp10_;
		g_settings_set (_tmp11_, "window-position", "(ii)", root_x, root_y);
		_tmp12_ = music_app_get_saved_state ();
		_tmp13_ = _tmp12_;
		g_settings_set (_tmp13_, "window-size", "(ii)", width, height);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda167__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda167_ ((MusicLibraryWindow*) self);
	return result;
}

static gboolean
music_library_window_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event)
{
	MusicLibraryWindow * self;
	gboolean result;
	self = (MusicLibraryWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (self->priv->configure_id == ((guint) 0)) {
		self->priv->configure_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, ____lambda167__gsource_func, g_object_ref (self), g_object_unref);
	}
	result = GTK_WIDGET_CLASS (music_library_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), event);
	return result;
}

gboolean
music_library_window_get_initialization_finished (MusicLibraryWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_initialization_finished;
	return result;
}

static void
music_library_window_set_initialization_finished (MusicLibraryWindow* self,
                                                  gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_library_window_get_initialization_finished (self);
	if (old_value != value) {
		self->priv->_initialization_finished = value;
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY]);
	}
}

gboolean
music_library_window_get_newly_created_playlist (MusicLibraryWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_newly_created_playlist;
	return result;
}

void
music_library_window_set_newly_created_playlist (MusicLibraryWindow* self,
                                                 gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_library_window_get_newly_created_playlist (self);
	if (old_value != value) {
		self->priv->_newly_created_playlist = value;
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY]);
	}
}

MusicSourceListView*
music_library_window_get_source_list_view (MusicLibraryWindow* self)
{
	MusicSourceListView* result;
	MusicSourceListView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_source_list_view;
	result = _tmp0_;
	return result;
}

static void
music_library_window_set_source_list_view (MusicLibraryWindow* self,
                                           MusicSourceListView* value)
{
	MusicSourceListView* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_library_window_get_source_list_view (self);
	if (old_value != value) {
		MusicSourceListView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_source_list_view);
		self->priv->_source_list_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY]);
	}
}

MusicViewStack*
music_library_window_get_view_stack (MusicLibraryWindow* self)
{
	MusicViewStack* result;
	MusicViewStack* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view_stack;
	result = _tmp0_;
	return result;
}

static void
music_library_window_set_view_stack (MusicLibraryWindow* self,
                                     MusicViewStack* value)
{
	MusicViewStack* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_library_window_get_view_stack (self);
	if (old_value != value) {
		MusicViewStack* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view_stack);
		self->priv->_view_stack = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY]);
	}
}

MusicWidgetsViewSelector*
music_library_window_get_view_selector (MusicLibraryWindow* self)
{
	MusicWidgetsViewSelector* result;
	MusicWidgetsViewSelector* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view_selector;
	result = _tmp0_;
	return result;
}

static void
music_library_window_set_view_selector (MusicLibraryWindow* self,
                                        MusicWidgetsViewSelector* value)
{
	MusicWidgetsViewSelector* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_library_window_get_view_selector (self);
	if (old_value != value) {
		MusicWidgetsViewSelector* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view_selector);
		self->priv->_view_selector = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY]);
	}
}

GtkSearchEntry*
music_library_window_get_search_entry (MusicLibraryWindow* self)
{
	GtkSearchEntry* result;
	GtkSearchEntry* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_search_entry;
	result = _tmp0_;
	return result;
}

static void
music_library_window_set_search_entry (MusicLibraryWindow* self,
                                       GtkSearchEntry* value)
{
	GtkSearchEntry* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_library_window_get_search_entry (self);
	if (old_value != value) {
		GtkSearchEntry* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_search_entry);
		self->priv->_search_entry = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY]);
	}
}

MusicWidgetsStatusBar*
music_library_window_get_statusbar (MusicLibraryWindow* self)
{
	MusicWidgetsStatusBar* result;
	MusicWidgetsStatusBar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_statusbar;
	result = _tmp0_;
	return result;
}

static void
music_library_window_set_statusbar (MusicLibraryWindow* self,
                                    MusicWidgetsStatusBar* value)
{
	MusicWidgetsStatusBar* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_library_window_get_statusbar (self);
	if (old_value != value) {
		MusicWidgetsStatusBar* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_statusbar);
		self->priv->_statusbar = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_library_window_properties[MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY]);
	}
}

MusicLocalLibrary*
music_library_window_get_library_manager (MusicLibraryWindow* self)
{
	MusicLocalLibrary* result;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, MUSIC_TYPE_LOCAL_LIBRARY, MusicLocalLibrary);
	return result;
}

static gboolean
music_library_window_get_media_considered_played (MusicLibraryWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_media_considered_played;
	return result;
}

static void
music_library_window_set_media_considered_played (MusicLibraryWindow* self,
                                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_media_considered_played = value;
}

static gboolean
music_library_window_get_added_to_play_count (MusicLibraryWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_added_to_play_count;
	return result;
}

static void
music_library_window_set_added_to_play_count (MusicLibraryWindow* self,
                                              gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_added_to_play_count = value;
}

static gboolean
music_library_window_get_media_considered_previewed (MusicLibraryWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_media_considered_previewed;
	return result;
}

static void
music_library_window_set_media_considered_previewed (MusicLibraryWindow* self,
                                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_media_considered_previewed = value;
}

static gboolean
music_library_window_get_media_half_played_sended (MusicLibraryWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_media_half_played_sended;
	return result;
}

static void
music_library_window_set_media_half_played_sended (MusicLibraryWindow* self,
                                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_media_half_played_sended = value;
}

static gboolean
music_library_window_get_search_field_has_focus (MusicLibraryWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_search_field_has_focus;
	return result;
}

static void
music_library_window_set_search_field_has_focus (MusicLibraryWindow* self,
                                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_search_field_has_focus = value;
}

static void
_music_library_window_interface_update_sensitivities_music_library_media_added (MusicLibrary* _sender,
                                                                                GeeCollection* medias,
                                                                                gpointer self)
{
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
}

static void
_music_library_window_interface_update_sensitivities_music_library_media_removed (MusicLibrary* _sender,
                                                                                  GeeCollection* medias,
                                                                                  gpointer self)
{
	music_library_window_interface_update_sensitivities ((MusicLibraryWindowInterface*) self, NULL, NULL);
}

static void
_music_library_window___lambda168_ (MusicLibraryWindow* self,
                                    MusicStaticPlaylist* p)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	g_return_if_fail (p != NULL);
	_tmp0_ = music_library_window_get_library_manager (self);
	_tmp1_ = _tmp0_;
	music_library_window_add_playlist (self, p, (MusicLibrary*) _tmp1_, NULL);
}

static void
__music_library_window___lambda168__music_library_playlist_added (MusicLibrary* _sender,
                                                                  MusicStaticPlaylist* playlist,
                                                                  gpointer self)
{
	_music_library_window___lambda168_ ((MusicLibraryWindow*) self, playlist);
}

static void
_music_library_window___lambda169_ (MusicLibraryWindow* self,
                                    MusicStaticPlaylist* p)
{
	g_return_if_fail (p != NULL);
	music_library_window_remove_playlist (self, p);
}

static void
__music_library_window___lambda169__music_library_playlist_removed (MusicLibrary* _sender,
                                                                    MusicStaticPlaylist* playlist,
                                                                    gpointer self)
{
	_music_library_window___lambda169_ ((MusicLibraryWindow*) self, playlist);
}

static void
_music_library_window___lambda170_ (MusicLibraryWindow* self,
                                    MusicSmartPlaylist* p)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	g_return_if_fail (p != NULL);
	_tmp0_ = music_library_window_get_library_manager (self);
	_tmp1_ = _tmp0_;
	music_library_window_add_smartplaylist (self, p, (MusicLibrary*) _tmp1_, NULL);
}

static void
__music_library_window___lambda170__music_library_smartplaylist_added (MusicLibrary* _sender,
                                                                       MusicSmartPlaylist* smartplaylist,
                                                                       gpointer self)
{
	_music_library_window___lambda170_ ((MusicLibraryWindow*) self, smartplaylist);
}

static void
_music_library_window___lambda171_ (MusicLibraryWindow* self,
                                    MusicSmartPlaylist* p)
{
	g_return_if_fail (p != NULL);
	music_library_window_remove_smartplaylist (self, p);
}

static void
__music_library_window___lambda171__music_library_smartplaylist_removed (MusicLibrary* _sender,
                                                                         MusicSmartPlaylist* smartplaylist,
                                                                         gpointer self)
{
	_music_library_window___lambda171_ ((MusicLibraryWindow*) self, smartplaylist);
}

static void
_music_library_window___lambda172_ (MusicLibraryWindow* self,
                                    MusicDevice* item)
{
	g_return_if_fail (item != NULL);
	music_library_window_create_device_source_list (self, item);
}

static void
__music_library_window___lambda172__music_device_manager_device_added (MusicDeviceManager* _sender,
                                                                       MusicDevice* d,
                                                                       gpointer self)
{
	_music_library_window___lambda172_ ((MusicLibraryWindow*) self, d);
}

static void
_music_library_window_change_device_name_music_device_manager_device_name_changed (MusicDeviceManager* _sender,
                                                                                   MusicDevice* d,
                                                                                   gpointer self)
{
	music_library_window_change_device_name ((MusicLibraryWindow*) self, d);
}

static void
_music_library_window_remove_device_music_device_manager_device_removed (MusicDeviceManager* _sender,
                                                                         MusicDevice* d,
                                                                         gpointer self)
{
	music_library_window_remove_device ((MusicLibraryWindow*) self, d);
}

static void
_music_library_window_end_of_stream_music_playback_end_of_stream (MusicPlayback* _sender,
                                                                  gpointer self)
{
	music_library_window_end_of_stream ((MusicLibraryWindow*) self);
}

static void
_music_library_window_current_position_update_music_playback_current_position_update (MusicPlayback* _sender,
                                                                                      gint64 position,
                                                                                      gpointer self)
{
	music_library_window_current_position_update ((MusicLibraryWindow*) self, position);
}

static void
_music_library_window_error_occured_music_playback_error_occured (MusicPlayback* _sender,
                                                                  gpointer self)
{
	music_library_window_error_occured ((MusicLibraryWindow*) self);
}

static void
_music_library_window_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                        MusicMedia* played_media,
                                                                        gpointer self)
{
	music_library_window_media_played ((MusicLibraryWindow*) self, played_media);
}

static void
_music_library_window_playback_stopped_music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                                gint64 was_playing,
                                                                                gpointer self)
{
	music_library_window_playback_stopped ((MusicLibraryWindow*) self, was_playing);
}

static void
_music_library_window___lambda173_ (MusicLibraryWindow* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlayback* _tmp2_;
	guint _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicPlayback* _tmp6_;
	guint _tmp7_;
	MusicPlaybackManager* _tmp8_;
	MusicPlaybackManager* _tmp9_;
	MusicPlayback* _tmp10_;
	guint _tmp11_;
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_->player;
	g_signal_parse_name ("end-of-stream", MUSIC_TYPE_PLAYBACK, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _music_library_window_end_of_stream_music_playback_end_of_stream, self);
	_tmp4_ = music_app_get_player ();
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_->player;
	g_signal_parse_name ("current-position-update", MUSIC_TYPE_PLAYBACK, &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _music_library_window_current_position_update_music_playback_current_position_update, self);
	_tmp8_ = music_app_get_player ();
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_->player;
	g_signal_parse_name ("error-occured", MUSIC_TYPE_PLAYBACK, &_tmp11_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _music_library_window_error_occured_music_playback_error_occured, self);
}

static void
__music_library_window___lambda173__music_playback_manager_changing_player (MusicPlaybackManager* _sender,
                                                                            gpointer self)
{
	_music_library_window___lambda173_ ((MusicLibraryWindow*) self);
}

static void
_music_library_window___lambda174_ (MusicLibraryWindow* self)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlayback* _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicPlayback* _tmp5_;
	MusicPlaybackManager* _tmp6_;
	MusicPlaybackManager* _tmp7_;
	MusicPlayback* _tmp8_;
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_->player;
	g_signal_connect_object (_tmp2_, "end-of-stream", (GCallback) _music_library_window_end_of_stream_music_playback_end_of_stream, self, 0);
	_tmp3_ = music_app_get_player ();
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_->player;
	g_signal_connect_object (_tmp5_, "current-position-update", (GCallback) _music_library_window_current_position_update_music_playback_current_position_update, self, 0);
	_tmp6_ = music_app_get_player ();
	_tmp7_ = _tmp6_;
	_tmp8_ = _tmp7_->player;
	g_signal_connect_object (_tmp8_, "error-occured", (GCallback) _music_library_window_error_occured_music_playback_error_occured, self, 0);
}

static void
__music_library_window___lambda174__music_playback_manager_player_changed (MusicPlaybackManager* _sender,
                                                                           gpointer self)
{
	_music_library_window___lambda174_ ((MusicLibraryWindow*) self);
}

static void
_music_library_window_show_alert_music_notification_manager_show_alert (MusicNotificationManager* _sender,
                                                                        const gchar* title,
                                                                        const gchar* message,
                                                                        gpointer self)
{
	music_library_window_show_alert ((MusicLibraryWindow*) self, title, message);
}

static void
_music_library_window___lambda175_ (MusicLibraryWindow* self,
                                    MusicStaticPlaylist* playlist)
{
	MusicLocalLibrary* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	g_return_if_fail (playlist != NULL);
	_tmp0_ = music_library_window_get_library_manager (self);
	_tmp1_ = _tmp0_;
	music_library_window_add_playlist (self, playlist, (MusicLibrary*) _tmp1_, NULL);
}

static void
__music_library_window___lambda175__music_libraries_manager_add_headless_playlist (MusicLibrariesManager* _sender,
                                                                                   MusicStaticPlaylist* playlist,
                                                                                   gpointer self)
{
	_music_library_window___lambda175_ ((MusicLibraryWindow*) self, playlist);
}

static GObject *
music_library_window_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicLibraryWindow * self;
	MusicSettingsMain* _tmp0_;
	MusicLocalLibrary* _tmp1_;
	MusicLocalLibrary* _tmp2_;
	MusicLocalLibrary* _tmp3_;
	MusicLocalLibrary* _tmp4_;
	MusicLocalLibrary* _tmp5_;
	MusicLocalLibrary* _tmp6_;
	MusicLocalLibrary* _tmp7_;
	MusicLocalLibrary* _tmp8_;
	MusicLocalLibrary* _tmp9_;
	MusicLocalLibrary* _tmp10_;
	MusicLocalLibrary* _tmp11_;
	MusicLocalLibrary* _tmp12_;
	MusicDeviceManager* device_manager = NULL;
	MusicDeviceManager* _tmp13_;
	MusicDeviceManager* _tmp14_;
	MusicDeviceManager* _tmp15_;
	MusicDeviceManager* _tmp16_;
	MusicPlaybackManager* _tmp17_;
	MusicPlaybackManager* _tmp18_;
	MusicPlayback* _tmp19_;
	MusicPlaybackManager* _tmp20_;
	MusicPlaybackManager* _tmp21_;
	MusicPlayback* _tmp22_;
	MusicPlaybackManager* _tmp23_;
	MusicPlaybackManager* _tmp24_;
	MusicPlayback* _tmp25_;
	MusicPlaybackManager* _tmp26_;
	MusicPlaybackManager* _tmp27_;
	MusicPlaybackManager* _tmp28_;
	MusicPlaybackManager* _tmp29_;
	MusicPlaybackManager* _tmp30_;
	MusicPlaybackManager* _tmp31_;
	MusicPlaybackManager* _tmp32_;
	MusicPlaybackManager* _tmp33_;
	MusicNotificationManager* _tmp34_;
	MusicNotificationManager* _tmp35_;
	GeeHashMap* _tmp36_;
	GeeHashMap* _tmp37_;
	GeeHashMap* _tmp38_;
	MusicLibrariesManager* _tmp39_;
	MusicLocalLibrary* _tmp40_;
	MusicLocalLibrary* _tmp41_;
	GeeCollection* _tmp42_;
	GeeCollection* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	gboolean _tmp46_;
	parent_class = G_OBJECT_CLASS (music_library_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow);
	hdy_init ();
	g_action_map_add_action_entries ((GActionMap*) self, MUSIC_LIBRARY_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (MUSIC_LIBRARY_WINDOW_ACTION_ENTRIES), self);
	_tmp0_ = music_settings_main_get_default ();
	_g_object_unref0 (self->priv->main_settings);
	self->priv->main_settings = _tmp0_;
	_tmp1_ = music_library_window_get_library_manager (self);
	_tmp2_ = _tmp1_;
	g_signal_connect_object ((MusicLibrary*) _tmp2_, "media-added", (GCallback) _music_library_window_interface_update_sensitivities_music_library_media_added, (MusicLibraryWindowInterface*) self, 0);
	_tmp3_ = music_library_window_get_library_manager (self);
	_tmp4_ = _tmp3_;
	g_signal_connect_object ((MusicLibrary*) _tmp4_, "media-removed", (GCallback) _music_library_window_interface_update_sensitivities_music_library_media_removed, (MusicLibraryWindowInterface*) self, 0);
	_tmp5_ = music_library_window_get_library_manager (self);
	_tmp6_ = _tmp5_;
	g_signal_connect_object ((MusicLibrary*) _tmp6_, "playlist-added", (GCallback) __music_library_window___lambda168__music_library_playlist_added, self, 0);
	_tmp7_ = music_library_window_get_library_manager (self);
	_tmp8_ = _tmp7_;
	g_signal_connect_object ((MusicLibrary*) _tmp8_, "playlist-removed", (GCallback) __music_library_window___lambda169__music_library_playlist_removed, self, 0);
	_tmp9_ = music_library_window_get_library_manager (self);
	_tmp10_ = _tmp9_;
	g_signal_connect_object ((MusicLibrary*) _tmp10_, "smartplaylist-added", (GCallback) __music_library_window___lambda170__music_library_smartplaylist_added, self, 0);
	_tmp11_ = music_library_window_get_library_manager (self);
	_tmp12_ = _tmp11_;
	g_signal_connect_object ((MusicLibrary*) _tmp12_, "smartplaylist-removed", (GCallback) __music_library_window___lambda171__music_library_smartplaylist_removed, self, 0);
	_tmp13_ = music_device_manager_get_default ();
	device_manager = _tmp13_;
	_tmp14_ = device_manager;
	g_signal_connect_object (_tmp14_, "device-added", (GCallback) __music_library_window___lambda172__music_device_manager_device_added, self, 0);
	_tmp15_ = device_manager;
	g_signal_connect_object (_tmp15_, "device-name-changed", (GCallback) _music_library_window_change_device_name_music_device_manager_device_name_changed, self, 0);
	_tmp16_ = device_manager;
	g_signal_connect_object (_tmp16_, "device-removed", (GCallback) _music_library_window_remove_device_music_device_manager_device_removed, self, 0);
	_tmp17_ = music_app_get_player ();
	_tmp18_ = _tmp17_;
	_tmp19_ = _tmp18_->player;
	g_signal_connect_object (_tmp19_, "end-of-stream", (GCallback) _music_library_window_end_of_stream_music_playback_end_of_stream, self, 0);
	_tmp20_ = music_app_get_player ();
	_tmp21_ = _tmp20_;
	_tmp22_ = _tmp21_->player;
	g_signal_connect_object (_tmp22_, "current-position-update", (GCallback) _music_library_window_current_position_update_music_playback_current_position_update, self, 0);
	_tmp23_ = music_app_get_player ();
	_tmp24_ = _tmp23_;
	_tmp25_ = _tmp24_->player;
	g_signal_connect_object (_tmp25_, "error-occured", (GCallback) _music_library_window_error_occured_music_playback_error_occured, self, 0);
	_tmp26_ = music_app_get_player ();
	_tmp27_ = _tmp26_;
	g_signal_connect_object (_tmp27_, "media-played", (GCallback) _music_library_window_media_played_music_playback_manager_media_played, self, G_CONNECT_AFTER);
	_tmp28_ = music_app_get_player ();
	_tmp29_ = _tmp28_;
	g_signal_connect_object (_tmp29_, "playback-stopped", (GCallback) _music_library_window_playback_stopped_music_playback_manager_playback_stopped, self, 0);
	_tmp30_ = music_app_get_player ();
	_tmp31_ = _tmp30_;
	g_signal_connect_object (_tmp31_, "changing-player", (GCallback) __music_library_window___lambda173__music_playback_manager_changing_player, self, 0);
	_tmp32_ = music_app_get_player ();
	_tmp33_ = _tmp32_;
	g_signal_connect_object (_tmp33_, "player-changed", (GCallback) __music_library_window___lambda174__music_playback_manager_player_changed, self, 0);
	_tmp34_ = music_notification_manager_get_default ();
	_tmp35_ = _tmp34_;
	g_signal_connect_object (_tmp35_, "show-alert", (GCallback) _music_library_window_show_alert_music_notification_manager_show_alert, self, 0);
	_g_object_unref0 (_tmp35_);
	_tmp36_ = gee_hash_map_new (MUSIC_TYPE_PLAYLIST, NULL, NULL, MUSIC_TYPE_VIEW_WRAPPER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->match_playlists);
	self->match_playlists = _tmp36_;
	_tmp37_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, MUSIC_TYPE_DEVICE_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->match_devices);
	self->priv->match_devices = _tmp37_;
	_tmp38_ = gee_hash_map_new (MUSIC_TYPE_PLAYLIST, NULL, NULL, MUSIC_TYPE_SOURCE_LIST_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->match_playlist_entry);
	self->priv->match_playlist_entry = _tmp38_;
	_tmp39_ = music_libraries_manager;
	g_signal_connect_object (_tmp39_, "add-headless-playlist", (GCallback) __music_library_window___lambda175__music_libraries_manager_add_headless_playlist, self, 0);
	_tmp40_ = music_library_window_get_library_manager (self);
	_tmp41_ = _tmp40_;
	_tmp42_ = music_library_get_medias ((MusicLibrary*) _tmp41_);
	_tmp43_ = _tmp42_;
	_tmp44_ = gee_collection_get_size (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = _tmp45_ > 0;
	_g_object_unref0 (_tmp43_);
	if (_tmp46_) {
		MusicPlaybackManager* _tmp47_;
		MusicPlaybackManager* _tmp48_;
		gint last_media_position = 0;
		GSettings* _tmp49_;
		GSettings* _tmp50_;
		gboolean _tmp51_ = FALSE;
		MusicPlaybackManager* _tmp52_;
		MusicPlaybackManager* _tmp53_;
		MusicMedia* _tmp54_;
		MusicMedia* _tmp55_;
		_tmp47_ = music_app_get_player ();
		_tmp48_ = _tmp47_;
		music_playback_manager_clear_queue (_tmp48_);
		_tmp49_ = music_app_get_saved_state ();
		_tmp50_ = _tmp49_;
		last_media_position = g_settings_get_int (_tmp50_, "last-media-position");
		if (last_media_position > 5) {
			music_library_window_set_media_considered_previewed (self, TRUE);
			if (last_media_position > 30) {
				music_library_window_set_media_considered_played (self, TRUE);
			}
		}
		_tmp52_ = music_app_get_player ();
		_tmp53_ = _tmp52_;
		_tmp54_ = music_playback_manager_get_current_media (_tmp53_);
		_tmp55_ = _tmp54_;
		if (_tmp55_ != NULL) {
			MusicPlaybackManager* _tmp56_;
			MusicPlaybackManager* _tmp57_;
			MusicMedia* _tmp58_;
			MusicMedia* _tmp59_;
			guint _tmp60_;
			guint _tmp61_;
			_tmp56_ = music_app_get_player ();
			_tmp57_ = _tmp56_;
			_tmp58_ = music_playback_manager_get_current_media (_tmp57_);
			_tmp59_ = _tmp58_;
			_tmp60_ = music_media_get_length (_tmp59_);
			_tmp61_ = _tmp60_;
			_tmp51_ = ((gdouble) (last_media_position / ((gdouble) _tmp61_))) > 0.90;
		} else {
			_tmp51_ = FALSE;
		}
		if (_tmp51_) {
			music_library_window_set_added_to_play_count (self, TRUE);
		}
	}
	_g_object_unref0 (device_manager);
	return obj;
}

static void
music_library_window_class_init (MusicLibraryWindowClass * klass,
                                 gpointer klass_data)
{
	music_library_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicLibraryWindow_private_offset);
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) music_library_window_real_key_press_event;
	((MusicLibraryWindowClass *) klass)->playback_stopped = (void (*) (MusicLibraryWindow*, gint64)) music_library_window_real_playback_stopped;
	((MusicLibraryWindowClass *) klass)->play_media = (void (*) (MusicLibraryWindow*, gboolean)) music_library_window_real_play_media;
	((MusicLibraryWindowClass *) klass)->play_next_media = (void (*) (MusicLibraryWindow*, gboolean)) music_library_window_real_play_next_media;
	((MusicLibraryWindowClass *) klass)->play_previous_media = (void (*) (MusicLibraryWindow*, gboolean)) music_library_window_real_play_previous_media;
	((MusicLibraryWindowClass *) klass)->action_import = (void (*) (MusicLibraryWindow*)) music_library_window_real_action_import;
	((MusicLibraryWindowClass *) klass)->end_of_stream = (void (*) (MusicLibraryWindow*)) music_library_window_real_end_of_stream;
	((MusicLibraryWindowClass *) klass)->error_occured = (void (*) (MusicLibraryWindow*)) music_library_window_real_error_occured;
	((MusicLibraryWindowClass *) klass)->current_position_update = (void (*) (MusicLibraryWindow*, gint64)) music_library_window_real_current_position_update;
	((MusicLibraryWindowClass *) klass)->drag_received = (void (*) (MusicLibraryWindow*, GdkDragContext*, gint, gint, GtkSelectionData*, guint, guint)) music_library_window_real_drag_received;
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) music_library_window_real_delete_event;
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) music_library_window_real_configure_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_library_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_library_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_library_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_library_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY] = g_param_spec_boolean ("initialization-finished", "initialization-finished", "initialization-finished", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY] = g_param_spec_boolean ("newly-created-playlist", "newly-created-playlist", "newly-created-playlist", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY] = g_param_spec_object ("source-list-view", "source-list-view", "source-list-view", MUSIC_TYPE_SOURCE_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY] = g_param_spec_object ("view-stack", "view-stack", "view-stack", MUSIC_TYPE_VIEW_STACK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY] = g_param_spec_object ("view-selector", "view-selector", "view-selector", MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY] = g_param_spec_object ("search-entry", "search-entry", "search-entry", gtk_search_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY] = g_param_spec_object ("statusbar", "statusbar", "statusbar", MUSIC_WIDGETS_TYPE_STATUS_BAR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_LIBRARY_WINDOW_LIBRARY_MANAGER_PROPERTY, music_library_window_properties[MUSIC_LIBRARY_WINDOW_LIBRARY_MANAGER_PROPERTY] = g_param_spec_object ("library-manager", "library-manager", "library-manager", MUSIC_TYPE_LOCAL_LIBRARY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	music_library_window_signals[MUSIC_LIBRARY_WINDOW_PLAY_PAUSE_CHANGED_SIGNAL] = g_signal_new ("play-pause-changed", MUSIC_TYPE_LIBRARY_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_library_window_music_library_window_interface_interface_init (MusicLibraryWindowInterfaceIface * iface,
                                                                    gpointer iface_data)
{
	music_library_window_music_library_window_interface_parent_iface = g_type_interface_peek_parent (iface);
	iface->update_sensitivities = (void (*) (MusicLibraryWindowInterface*, GAsyncReadyCallback, gpointer)) music_library_window_real_update_sensitivities;
	iface->update_sensitivities_finish = (void (*) (MusicLibraryWindowInterface*, GAsyncResult*)) music_library_window_update_sensitivities_finish;
}

static void
music_library_window_instance_init (MusicLibraryWindow * self,
                                    gpointer klass)
{
	self->priv = music_library_window_get_instance_private (self);
	self->priv->_initialization_finished = FALSE;
	self->priv->_newly_created_playlist = FALSE;
	self->priv->_media_considered_played = FALSE;
	self->priv->_added_to_play_count = FALSE;
	self->priv->_media_considered_previewed = FALSE;
	self->priv->_media_half_played_sended = FALSE;
	self->priv->_search_field_has_focus = TRUE;
	self->priv->preferences = NULL;
	g_rec_mutex_init (&self->priv->__lock_match_playlists);
	g_rec_mutex_init (&self->priv->__lock_match_devices);
	self->priv->update_sensitivities_pending = FALSE;
}

static void
music_library_window_finalize (GObject * obj)
{
	MusicLibraryWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow);
	_g_object_unref0 (self->priv->_source_list_view);
	_g_object_unref0 (self->priv->_view_stack);
	_g_object_unref0 (self->priv->_view_selector);
	_g_object_unref0 (self->priv->_search_entry);
	_g_object_unref0 (self->priv->_statusbar);
	_g_object_unref0 (self->priv->notification_cancellable);
	_g_object_unref0 (self->priv->preferences);
	_g_object_unref0 (self->priv->main_settings);
	_g_object_unref0 (self->priv->top_display);
	g_rec_mutex_clear (&self->priv->__lock_match_playlists);
	_g_object_unref0 (self->match_playlists);
	g_rec_mutex_clear (&self->priv->__lock_match_devices);
	_g_object_unref0 (self->priv->match_devices);
	_g_object_unref0 (self->priv->match_playlist_entry);
	G_OBJECT_CLASS (music_library_window_parent_class)->finalize (obj);
}

static GType
music_library_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLibraryWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_library_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLibraryWindow), 0, (GInstanceInitFunc) music_library_window_instance_init, NULL };
	static const GInterfaceInfo music_library_window_interface_info = { (GInterfaceInitFunc) music_library_window_music_library_window_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_library_window_type_id;
	music_library_window_type_id = g_type_register_static (hdy_application_window_get_type (), "MusicLibraryWindow", &g_define_type_info, 0);
	g_type_add_interface_static (music_library_window_type_id, MUSIC_TYPE_LIBRARY_WINDOW_INTERFACE, &music_library_window_interface_info);
	MusicLibraryWindow_private_offset = g_type_add_instance_private (music_library_window_type_id, sizeof (MusicLibraryWindowPrivate));
	return music_library_window_type_id;
}

GType
music_library_window_get_type (void)
{
	static volatile gsize music_library_window_type_id__once = 0;
	if (g_once_init_enter (&music_library_window_type_id__once)) {
		GType music_library_window_type_id;
		music_library_window_type_id = music_library_window_get_type_once ();
		g_once_init_leave (&music_library_window_type_id__once, music_library_window_type_id);
	}
	return music_library_window_type_id__once;
}

static void
_vala_music_library_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MusicLibraryWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow);
	switch (property_id) {
		case MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY:
		g_value_set_boolean (value, music_library_window_get_initialization_finished (self));
		break;
		case MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY:
		g_value_set_boolean (value, music_library_window_get_newly_created_playlist (self));
		break;
		case MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY:
		g_value_set_object (value, music_library_window_get_source_list_view (self));
		break;
		case MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY:
		g_value_set_object (value, music_library_window_get_view_stack (self));
		break;
		case MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY:
		g_value_set_object (value, music_library_window_get_view_selector (self));
		break;
		case MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY:
		g_value_set_object (value, music_library_window_get_search_entry (self));
		break;
		case MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY:
		g_value_set_object (value, music_library_window_get_statusbar (self));
		break;
		case MUSIC_LIBRARY_WINDOW_LIBRARY_MANAGER_PROPERTY:
		g_value_set_object (value, music_library_window_get_library_manager (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_library_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MusicLibraryWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow);
	switch (property_id) {
		case MUSIC_LIBRARY_WINDOW_INITIALIZATION_FINISHED_PROPERTY:
		music_library_window_set_initialization_finished (self, g_value_get_boolean (value));
		break;
		case MUSIC_LIBRARY_WINDOW_NEWLY_CREATED_PLAYLIST_PROPERTY:
		music_library_window_set_newly_created_playlist (self, g_value_get_boolean (value));
		break;
		case MUSIC_LIBRARY_WINDOW_SOURCE_LIST_VIEW_PROPERTY:
		music_library_window_set_source_list_view (self, g_value_get_object (value));
		break;
		case MUSIC_LIBRARY_WINDOW_VIEW_STACK_PROPERTY:
		music_library_window_set_view_stack (self, g_value_get_object (value));
		break;
		case MUSIC_LIBRARY_WINDOW_VIEW_SELECTOR_PROPERTY:
		music_library_window_set_view_selector (self, g_value_get_object (value));
		break;
		case MUSIC_LIBRARY_WINDOW_SEARCH_ENTRY_PROPERTY:
		music_library_window_set_search_entry (self, g_value_get_object (value));
		break;
		case MUSIC_LIBRARY_WINDOW_STATUSBAR_PROPERTY:
		music_library_window_set_statusbar (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

