/* MPRIS.c generated by valac 0.55.1, the Vala compiler
 * generated from MPRIS.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include "music-lib.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#define MPRIS_PLAYER_INTERFACE_NAME "org.mpris.MediaPlayer2.Player"
#define MPRIS_PLAYLISTS_INTERFACE_NAME "org.mpris.MediaPlayer2.Playlists"
#define MPRIS_PLAYLISTS_PLAYLIST_ID "/io/elementary/music/Playlists/%d"

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	MPRIS_ROOT_0_PROPERTY,
	MPRIS_ROOT_CAN_QUIT_PROPERTY,
	MPRIS_ROOT_CAN_RAISE_PROPERTY,
	MPRIS_ROOT_HAS_TRACK_LIST_PROPERTY,
	MPRIS_ROOT_DESKTOP_ENTRY_PROPERTY,
	MPRIS_ROOT_IDENTITY_PROPERTY,
	MPRIS_ROOT_SUPPORTED_URI_SCHEMES_PROPERTY,
	MPRIS_ROOT_SUPPORTED_MIME_TYPES_PROPERTY,
	MPRIS_ROOT_NUM_PROPERTIES
};
static GParamSpec* mpris_root_properties[MPRIS_ROOT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MPRIS_PLAYER_0_PROPERTY,
	MPRIS_PLAYER_CONN_PROPERTY,
	MPRIS_PLAYER_PLAYBACK_STATUS_PROPERTY,
	MPRIS_PLAYER_LOOP_STATUS_PROPERTY,
	MPRIS_PLAYER_RATE_PROPERTY,
	MPRIS_PLAYER_SHUFFLE_PROPERTY,
	MPRIS_PLAYER_METADATA_PROPERTY,
	MPRIS_PLAYER_VOLUME_PROPERTY,
	MPRIS_PLAYER_POSITION_PROPERTY,
	MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY,
	MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY,
	MPRIS_PLAYER_CAN_PLAY_PROPERTY,
	MPRIS_PLAYER_CAN_PAUSE_PROPERTY,
	MPRIS_PLAYER_CAN_SEEK_PROPERTY,
	MPRIS_PLAYER_CAN_CONTROL_PROPERTY,
	MPRIS_PLAYER_NUM_PROPERTIES
};
static GParamSpec* mpris_player_properties[MPRIS_PLAYER_NUM_PROPERTIES];
typedef enum  {
	MPRIS_PLAYER_DIRECTION_NEXT = 0,
	MPRIS_PLAYER_DIRECTION_PREVIOUS,
	MPRIS_PLAYER_DIRECTION_STOP
} MprisPlayerDirection;

#define MPRIS_PLAYER_TYPE_DIRECTION (mpris_player_direction_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
enum  {
	MPRIS_PLAYER_SEEKED_SIGNAL,
	MPRIS_PLAYER_NUM_SIGNALS
};
static guint mpris_player_signals[MPRIS_PLAYER_NUM_SIGNALS] = {0};
enum  {
	MPRIS_PLAYLISTS_0_PROPERTY,
	MPRIS_PLAYLISTS_CONN_PROPERTY,
	MPRIS_PLAYLISTS_PLAYLIST_COUNT_PROPERTY,
	MPRIS_PLAYLISTS_ORDERINGS_PROPERTY,
	MPRIS_PLAYLISTS_ACTIVE_PLAYLIST_PROPERTY,
	MPRIS_PLAYLISTS_NUM_PROPERTIES
};
static GParamSpec* mpris_playlists_properties[MPRIS_PLAYLISTS_NUM_PROPERTIES];
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	MPRIS_PLAYLISTS_PLAYLIST_CHANGED_SIGNAL,
	MPRIS_PLAYLISTS_NUM_SIGNALS
};
static guint mpris_playlists_signals[MPRIS_PLAYLISTS_NUM_SIGNALS] = {0};

struct _MprisPlayerPrivate {
	GDBusConnection* _conn;
	guint send_property_source;
	guint update_metadata_source;
	GHashTable* changed_properties;
	GHashTable* _metadata;
	gchar* default_image_url;
};

struct _MprisPlaylistsPrivate {
	GDBusConnection* _conn;
	guint send_property_source;
	GHashTable* changed_properties;
};

static gpointer mpris_root_parent_class = NULL;
static gint MprisPlayer_private_offset;
static gpointer mpris_player_parent_class = NULL;
static gint MprisPlaylists_private_offset;
static gpointer mpris_playlists_parent_class = NULL;
static gchar** mpris_playlists_all_orderings;
static gint mpris_playlists_all_orderings_length1;
static gchar** mpris_playlists_all_orderings = NULL;
static gint mpris_playlists_all_orderings_length1 = 0;
static gint _mpris_playlists_all_orderings_size_ = 0;

VALA_EXTERN void music_mpris_on_bus_acquired (GDBusConnection* connection,
                                  const gchar* name);
static void _music_mpris_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection,
                                                          const gchar* name,
                                                          gpointer self);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static GType mpris_root_get_type_once (void);
static void _vala_mpris_root_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _dbus_mpris_root_quit (MprisRoot* self,
                            GVariant* _parameters_,
                            GDBusMethodInvocation* invocation);
static void _dbus_mpris_root_raise (MprisRoot* self,
                             GVariant* _parameters_,
                             GDBusMethodInvocation* invocation);
static void mpris_root_dbus_interface_method_call (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* method_name,
                                            GVariant* parameters,
                                            GDBusMethodInvocation* invocation,
                                            gpointer user_data);
static GVariant* mpris_root_dbus_interface_get_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GError** error,
                                                  gpointer user_data);
static GVariant* _dbus_mpris_root_get_can_quit (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_can_raise (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_has_track_list (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_desktop_entry (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_identity (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_supported_uri_schemes (MprisRoot* self);
static GVariant* _dbus_mpris_root_get_supported_mime_types (MprisRoot* self);
static gboolean mpris_root_dbus_interface_set_property (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* property_name,
                                                 GVariant* value,
                                                 GError** error,
                                                 gpointer user_data);
static void _mpris_root_unregister_object (gpointer user_data);
static GType mpris_player_direction_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void mpris_player_refresh_current_media (MprisPlayer* self);
static void mpris_player_on_media_played (MprisPlayer* self,
                                   MusicMedia* s);
static void mpris_player_playing_changed (MprisPlayer* self);
static void mpris_player_trigger_metadata_update (MprisPlayer* self);
static gboolean __lambda177_ (MprisPlayer* self);
static GVariant* _variant_new6 (gchar* value);
static void mpris_player_queue_property_for_notification (MprisPlayer* self,
                                                   const gchar* property,
                                                   GVariant* val);
static GVariant* _variant_new7 (GHashTable* value);
static gboolean ___lambda177__gsource_func (gpointer self);
static void mpris_player_update_metadata (MprisPlayer* self,
                                   MusicMedia* s);
static void mpris_player_set_media_metadata (MprisPlayer* self,
                                      MusicMedia* s);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
static char* mpris_player_get_track_id (MprisPlayer* self,
                                 MusicMedia* m);
static GVariant* _variant_new8 (char* value);
static GVariant* _variant_new9 (guint64 value);
static GVariant* _variant_new10 (const gchar* value);
static GVariant* _variant_new11 (gint value);
static GVariant* _variant_new12 (gchar* value);
static GVariant* _variant_new13 (gchar* value);
static gchar** mpris_player_get_simple_string_array (const gchar* text,
                                              gint* result_length1);
static GVariant* _variant_new14 (gchar** value,
                          gint value_length1);
static GVariant* _variant_new15 (gchar** value,
                          gint value_length1);
static GVariant* _variant_new16 (gchar** value,
                          gint value_length1);
static GVariant* _variant_new17 (const gchar* value);
static GVariant* _variant_new18 (gchar** value,
                          gint value_length1);
static GVariant* _variant_new19 (gchar** value,
                          gint value_length1);
static GVariant* _variant_new20 (gchar* value);
static GVariant* _variant_new21 (gint value);
static GVariant* _variant_new22 (gint value);
static GVariant* _variant_new23 (gint value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static gboolean mpris_player_send_property_change (MprisPlayer* self);
static gboolean _mpris_player_send_property_change_gsource_func (gpointer self);
static GVariant* _variant_new24 (const gchar* value);
static GVariant* _variant_new25 (gboolean value);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * mpris_player_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _mpris_player_on_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                        MusicMedia* played_media,
                                                                        gpointer self);
static void _mpris_player___lambda178_ (MprisPlayer* self);
static void __mpris_player___lambda178__music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                          gint64 was_playing,
                                                                          gpointer self);
static void _mpris_player_refresh_current_media_music_library_media_updated (MusicLibrary* _sender,
                                                                      GeeCollection* medias,
                                                                      gpointer self);
static void _mpris_player_playing_changed_music_library_window_play_pause_changed (MusicLibraryWindow* _sender,
                                                                            gpointer self);
static void mpris_player_finalize (GObject * obj);
static GType mpris_player_get_type_once (void);
static void _vala_mpris_player_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_mpris_player_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _dbus_mpris_player_next (MprisPlayer* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_previous (MprisPlayer* self,
                                  GVariant* _parameters_,
                                  GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_pause (MprisPlayer* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_play_pause (MprisPlayer* self,
                                    GVariant* _parameters_,
                                    GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_stop (MprisPlayer* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_play (MprisPlayer* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_seek (MprisPlayer* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_set_position (MprisPlayer* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_open_uri (MprisPlayer* self,
                                  GVariant* _parameters_,
                                  GDBusMethodInvocation* invocation);
static void mpris_player_dbus_interface_method_call (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* method_name,
                                              GVariant* parameters,
                                              GDBusMethodInvocation* invocation,
                                              gpointer user_data);
static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GError** error,
                                                    gpointer user_data);
static GVariant* _dbus_mpris_player_get_playback_status (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_loop_status (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_rate (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_shuffle (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_metadata (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_volume (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_position (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_can_go_next (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_can_go_previous (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_can_play (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_can_pause (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_can_seek (MprisPlayer* self);
static GVariant* _dbus_mpris_player_get_can_control (MprisPlayer* self);
static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GVariant* value,
                                                   GError** error,
                                                   gpointer user_data);
static void _dbus_mpris_player_set_loop_status (MprisPlayer* self,
                                         GVariant* _value);
static void _dbus_mpris_player_set_rate (MprisPlayer* self,
                                  GVariant* _value);
static void _dbus_mpris_player_set_shuffle (MprisPlayer* self,
                                     GVariant* _value);
static void _dbus_mpris_player_set_volume (MprisPlayer* self,
                                    GVariant* _value);
static void _dbus_mpris_player_seeked (GObject* _sender,
                                gint64 position,
                                gpointer* _data);
static void _mpris_player_unregister_object (gpointer user_data);
static void mpris_playlists_playlist_added (MprisPlaylists* self,
                                     MusicPlaylist* p);
static GVariant* _variant_new26 (guint value);
static void mpris_playlists_queue_property_for_notification (MprisPlaylists* self,
                                                      const gchar* property,
                                                      GVariant* val);
static void mpris_playlists_playlist_removed (MprisPlaylists* self,
                                       MusicPlaylist* p);
static GVariant* _variant_new27 (guint value);
static gboolean mpris_playlists_send_property_change (MprisPlaylists* self);
static gboolean _mpris_playlists_send_property_change_gsource_func (gpointer self);
static GObject * mpris_playlists_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _mpris_playlists_playlist_added_music_library_playlist_added (MusicLibrary* _sender,
                                                                   MusicStaticPlaylist* playlist,
                                                                   gpointer self);
static void _mpris_playlists_playlist_removed_music_library_playlist_removed (MusicLibrary* _sender,
                                                                       MusicStaticPlaylist* playlist,
                                                                       gpointer self);
static void mpris_playlists_finalize (GObject * obj);
static GType mpris_playlists_get_type_once (void);
static void _vala_mpris_playlists_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_mpris_playlists_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _dbus_mpris_playlists_activate_playlist (MprisPlaylists* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_mpris_playlists_get_playlists (MprisPlaylists* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation);
static void mpris_playlists_dbus_interface_method_call (GDBusConnection* connection,
                                                 const gchar* sender,
                                                 const gchar* object_path,
                                                 const gchar* interface_name,
                                                 const gchar* method_name,
                                                 GVariant* parameters,
                                                 GDBusMethodInvocation* invocation,
                                                 gpointer user_data);
static GVariant* mpris_playlists_dbus_interface_get_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GError** error,
                                                       gpointer user_data);
static GVariant* _dbus_mpris_playlists_get_playlist_count (MprisPlaylists* self);
static GVariant* _dbus_mpris_playlists_get_orderings (MprisPlaylists* self);
static GVariant* _dbus_mpris_playlists_get_active_playlist (MprisPlaylists* self);
static gboolean mpris_playlists_dbus_interface_set_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GVariant* value,
                                                      GError** error,
                                                      gpointer user_data);
static void _dbus_mpris_playlists_playlist_changed (GObject* _sender,
                                             GVariant* playlist,
                                             gpointer* _data);
static void _mpris_playlists_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo * const _mpris_root_dbus_arg_info_quit_in[] = {NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_quit_out[] = {NULL};
static const GDBusMethodInfo _mpris_root_dbus_method_info_quit = {-1, "Quit", (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_quit_in), (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_quit_out), NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_raise_in[] = {NULL};
static const GDBusArgInfo * const _mpris_root_dbus_arg_info_raise_out[] = {NULL};
static const GDBusMethodInfo _mpris_root_dbus_method_info_raise = {-1, "Raise", (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_raise_in), (GDBusArgInfo **) (&_mpris_root_dbus_arg_info_raise_out), NULL};
static const GDBusMethodInfo * const _mpris_root_dbus_method_info[] = {&_mpris_root_dbus_method_info_quit, &_mpris_root_dbus_method_info_raise, NULL};
static const GDBusSignalInfo * const _mpris_root_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_can_quit = {-1, "CanQuit", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_can_raise = {-1, "CanRaise", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_has_track_list = {-1, "HasTrackList", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_desktop_entry = {-1, "DesktopEntry", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_identity = {-1, "Identity", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_supported_uri_schemes = {-1, "SupportedUriSchemes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_root_dbus_property_info_supported_mime_types = {-1, "SupportedMimeTypes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _mpris_root_dbus_property_info[] = {&_mpris_root_dbus_property_info_can_quit, &_mpris_root_dbus_property_info_can_raise, &_mpris_root_dbus_property_info_has_track_list, &_mpris_root_dbus_property_info_desktop_entry, &_mpris_root_dbus_property_info_identity, &_mpris_root_dbus_property_info_supported_uri_schemes, &_mpris_root_dbus_property_info_supported_mime_types, NULL};
static const GDBusInterfaceInfo _mpris_root_dbus_interface_info = {-1, "org.mpris.MediaPlayer2", (GDBusMethodInfo **) (&_mpris_root_dbus_method_info), (GDBusSignalInfo **) (&_mpris_root_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_root_dbus_property_info), NULL};
static const GDBusInterfaceVTable _mpris_root_dbus_interface_vtable = {mpris_root_dbus_interface_method_call, mpris_root_dbus_interface_get_property, mpris_root_dbus_interface_set_property};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_next_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_next_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_next = {-1, "Next", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_next_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_next_out), NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_previous_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_previous_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_previous = {-1, "Previous", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_previous_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_previous_out), NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_pause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_pause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_pause = {-1, "Pause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_pause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_pause_out), NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_play_pause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_play_pause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_play_pause = {-1, "PlayPause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_play_pause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_play_pause_out), NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_stop_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_stop_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_stop = {-1, "Stop", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_stop_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_stop_out), NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_play_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_play_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_play = {-1, "Play", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_play_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_play_out), NULL};
static const GDBusArgInfo _mpris_player_dbus_arg_info_seek_offset = {-1, "offset", "x", NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_seek_in[] = {&_mpris_player_dbus_arg_info_seek_offset, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_seek_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_seek = {-1, "Seek", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_seek_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_seek_out), NULL};
static const GDBusArgInfo _mpris_player_dbus_arg_info_set_position_dobj = {-1, "dobj", "s", NULL};
static const GDBusArgInfo _mpris_player_dbus_arg_info_set_position_position = {-1, "position", "x", NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_set_position_in[] = {&_mpris_player_dbus_arg_info_set_position_dobj, &_mpris_player_dbus_arg_info_set_position_position, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_set_position_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_set_position = {-1, "SetPosition", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_set_position_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_set_position_out), NULL};
static const GDBusArgInfo _mpris_player_dbus_arg_info_open_uri_uri = {-1, "uri", "s", NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_open_uri_in[] = {&_mpris_player_dbus_arg_info_open_uri_uri, NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_open_uri_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_open_uri = {-1, "OpenUri", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_open_uri_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_open_uri_out), NULL};
static const GDBusMethodInfo * const _mpris_player_dbus_method_info[] = {&_mpris_player_dbus_method_info_next, &_mpris_player_dbus_method_info_previous, &_mpris_player_dbus_method_info_pause, &_mpris_player_dbus_method_info_play_pause, &_mpris_player_dbus_method_info_stop, &_mpris_player_dbus_method_info_play, &_mpris_player_dbus_method_info_seek, &_mpris_player_dbus_method_info_set_position, &_mpris_player_dbus_method_info_open_uri, NULL};
static const GDBusArgInfo _mpris_player_dbus_arg_info_seeked_position = {-1, "position", "x", NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_seeked[] = {&_mpris_player_dbus_arg_info_seeked_position, NULL};
static const GDBusSignalInfo _mpris_player_dbus_signal_info_seeked = {-1, "Seeked", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_seeked), NULL};
static const GDBusSignalInfo * const _mpris_player_dbus_signal_info[] = {&_mpris_player_dbus_signal_info_seeked, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_playback_status = {-1, "PlaybackStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_loop_status = {-1, "LoopStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_rate = {-1, "Rate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_shuffle = {-1, "Shuffle", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_metadata = {-1, "Metadata", "a{sv}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_volume = {-1, "Volume", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_position = {-1, "Position", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_can_go_next = {-1, "CanGoNext", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_can_go_previous = {-1, "CanGoPrevious", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_can_play = {-1, "CanPlay", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_can_pause = {-1, "CanPause", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_can_seek = {-1, "CanSeek", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_can_control = {-1, "CanControl", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _mpris_player_dbus_property_info[] = {&_mpris_player_dbus_property_info_playback_status, &_mpris_player_dbus_property_info_loop_status, &_mpris_player_dbus_property_info_rate, &_mpris_player_dbus_property_info_shuffle, &_mpris_player_dbus_property_info_metadata, &_mpris_player_dbus_property_info_volume, &_mpris_player_dbus_property_info_position, &_mpris_player_dbus_property_info_can_go_next, &_mpris_player_dbus_property_info_can_go_previous, &_mpris_player_dbus_property_info_can_play, &_mpris_player_dbus_property_info_can_pause, &_mpris_player_dbus_property_info_can_seek, &_mpris_player_dbus_property_info_can_control, NULL};
static const GDBusInterfaceInfo _mpris_player_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Player", (GDBusMethodInfo **) (&_mpris_player_dbus_method_info), (GDBusSignalInfo **) (&_mpris_player_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_player_dbus_property_info), NULL};
static const GDBusInterfaceVTable _mpris_player_dbus_interface_vtable = {mpris_player_dbus_interface_method_call, mpris_player_dbus_interface_get_property, mpris_player_dbus_interface_set_property};
static const GDBusArgInfo _mpris_playlists_dbus_arg_info_activate_playlist_path = {-1, "path", "o", NULL};
static const GDBusArgInfo * const _mpris_playlists_dbus_arg_info_activate_playlist_in[] = {&_mpris_playlists_dbus_arg_info_activate_playlist_path, NULL};
static const GDBusArgInfo * const _mpris_playlists_dbus_arg_info_activate_playlist_out[] = {NULL};
static const GDBusMethodInfo _mpris_playlists_dbus_method_info_activate_playlist = {-1, "ActivatePlaylist", (GDBusArgInfo **) (&_mpris_playlists_dbus_arg_info_activate_playlist_in), (GDBusArgInfo **) (&_mpris_playlists_dbus_arg_info_activate_playlist_out), NULL};
static const GDBusArgInfo _mpris_playlists_dbus_arg_info_get_playlists_index = {-1, "index", "u", NULL};
static const GDBusArgInfo _mpris_playlists_dbus_arg_info_get_playlists_maxcount = {-1, "maxcount", "u", NULL};
static const GDBusArgInfo _mpris_playlists_dbus_arg_info_get_playlists_playlist_ordering = {-1, "playlist_ordering", "s", NULL};
static const GDBusArgInfo _mpris_playlists_dbus_arg_info_get_playlists_reversed = {-1, "reversed", "b", NULL};
static const GDBusArgInfo _mpris_playlists_dbus_arg_info_get_playlists_result = {-1, "result", "a(oss)", NULL};
static const GDBusArgInfo * const _mpris_playlists_dbus_arg_info_get_playlists_in[] = {&_mpris_playlists_dbus_arg_info_get_playlists_index, &_mpris_playlists_dbus_arg_info_get_playlists_maxcount, &_mpris_playlists_dbus_arg_info_get_playlists_playlist_ordering, &_mpris_playlists_dbus_arg_info_get_playlists_reversed, NULL};
static const GDBusArgInfo * const _mpris_playlists_dbus_arg_info_get_playlists_out[] = {&_mpris_playlists_dbus_arg_info_get_playlists_result, NULL};
static const GDBusMethodInfo _mpris_playlists_dbus_method_info_get_playlists = {-1, "GetPlaylists", (GDBusArgInfo **) (&_mpris_playlists_dbus_arg_info_get_playlists_in), (GDBusArgInfo **) (&_mpris_playlists_dbus_arg_info_get_playlists_out), NULL};
static const GDBusMethodInfo * const _mpris_playlists_dbus_method_info[] = {&_mpris_playlists_dbus_method_info_activate_playlist, &_mpris_playlists_dbus_method_info_get_playlists, NULL};
static const GDBusArgInfo _mpris_playlists_dbus_arg_info_playlist_changed_playlist = {-1, "playlist", "v", NULL};
static const GDBusArgInfo * const _mpris_playlists_dbus_arg_info_playlist_changed[] = {&_mpris_playlists_dbus_arg_info_playlist_changed_playlist, NULL};
static const GDBusSignalInfo _mpris_playlists_dbus_signal_info_playlist_changed = {-1, "PlaylistChanged", (GDBusArgInfo **) (&_mpris_playlists_dbus_arg_info_playlist_changed), NULL};
static const GDBusSignalInfo * const _mpris_playlists_dbus_signal_info[] = {&_mpris_playlists_dbus_signal_info_playlist_changed, NULL};
static const GDBusPropertyInfo _mpris_playlists_dbus_property_info_playlist_count = {-1, "PlaylistCount", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_playlists_dbus_property_info_orderings = {-1, "Orderings", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _mpris_playlists_dbus_property_info_active_playlist = {-1, "ActivePlaylist", "(b(oss))", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _mpris_playlists_dbus_property_info[] = {&_mpris_playlists_dbus_property_info_playlist_count, &_mpris_playlists_dbus_property_info_orderings, &_mpris_playlists_dbus_property_info_active_playlist, NULL};
static const GDBusInterfaceInfo _mpris_playlists_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Playlists", (GDBusMethodInfo **) (&_mpris_playlists_dbus_method_info), (GDBusSignalInfo **) (&_mpris_playlists_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_playlists_dbus_property_info), NULL};
static const GDBusInterfaceVTable _mpris_playlists_dbus_interface_vtable = {mpris_playlists_dbus_interface_method_call, mpris_playlists_dbus_interface_get_property, mpris_playlists_dbus_interface_set_property};

static void
_music_mpris_on_bus_acquired_gbus_acquired_callback (GDBusConnection* connection,
                                                     const gchar* name,
                                                     gpointer self)
{
	music_mpris_on_bus_acquired (connection, name);
}

void
music_mpris_initialize (void)
{
	guint owner_id = 0U;
	owner_id = g_bus_own_name_with_closures (G_BUS_TYPE_SESSION, "org.mpris.MediaPlayer2.io.elementary.music", G_BUS_NAME_OWNER_FLAGS_NONE, (GClosure*) ((_music_mpris_on_bus_acquired_gbus_acquired_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _music_mpris_on_bus_acquired_gbus_acquired_callback, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	if (owner_id == ((guint) 0)) {
		g_warning ("MPRIS.vala:37: Could not initialize MPRIS session.\n");
	}
}

void
music_mpris_on_bus_acquired (GDBusConnection* connection,
                             const gchar* name)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (connection != NULL);
	g_return_if_fail (name != NULL);
	{
		MprisRoot* _tmp0_;
		MprisRoot* _tmp1_;
		MprisPlayer* _tmp2_;
		MprisPlayer* _tmp3_;
		_tmp0_ = mpris_root_new ();
		_tmp1_ = _tmp0_;
		mpris_root_register_object (_tmp1_, connection, "/org/mpris/MediaPlayer2", &_inner_error0_);
		_g_object_unref0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp2_ = mpris_player_new (connection);
		_tmp3_ = _tmp2_;
		mpris_player_register_object (_tmp3_, connection, "/org/mpris/MediaPlayer2", &_inner_error0_);
		_g_object_unref0 (_tmp3_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("MPRIS.vala:48: could not create MPRIS player: %s\n", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
mpris_root_quit (MprisRoot* self,
                 GError** error)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	gtk_widget_destroy ((GtkWidget*) _tmp1_);
}

void
mpris_root_raise (MprisRoot* self,
                  GError** error)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	gtk_window_present ((GtkWindow*) _tmp1_);
}

MprisRoot*
mpris_root_construct (GType object_type)
{
	MprisRoot * self = NULL;
	self = (MprisRoot*) g_object_new (object_type, NULL);
	return self;
}

MprisRoot*
mpris_root_new (void)
{
	return mpris_root_construct (TYPE_MPRIS_ROOT);
}

gboolean
mpris_root_get_can_quit (MprisRoot* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
mpris_root_get_can_raise (MprisRoot* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
mpris_root_get_has_track_list (MprisRoot* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = FALSE;
	return result;
}

gchar*
mpris_root_get_desktop_entry (MprisRoot* self)
{
	gchar* result;
	GApplication* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_application_get_default ();
	_tmp1_ = g_application_get_application_id ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	return result;
}

gchar*
mpris_root_get_identity (MprisRoot* self)
{
	gchar* result;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (BUILD_EXEC_NAME);
	result = _tmp0_;
	return result;
}

gchar**
mpris_root_get_supported_uri_schemes (MprisRoot* self,
                                      gint* result_length1)
{
	gchar** result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("http");
	_tmp1_ = g_strdup ("file");
	_tmp2_ = g_strdup ("https");
	_tmp3_ = g_strdup ("ftp");
	_tmp4_ = g_new0 (gchar*, 4 + 1);
	_tmp4_[0] = _tmp0_;
	_tmp4_[1] = _tmp1_;
	_tmp4_[2] = _tmp2_;
	_tmp4_[3] = _tmp3_;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = 4;
	if (result_length1) {
		*result_length1 = _tmp5__length1;
	}
	result = _tmp5_;
	return result;
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

gchar**
mpris_root_get_supported_mime_types (MprisRoot* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = _vala_array_dup1 (MUSIC_MEDIA_CONTENT_TYPES, G_N_ELEMENTS (MUSIC_MEDIA_CONTENT_TYPES));
	_tmp0__length1 = G_N_ELEMENTS (MUSIC_MEDIA_CONTENT_TYPES);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static void
mpris_root_class_init (MprisRootClass * klass,
                       gpointer klass_data)
{
	mpris_root_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_mpris_root_get_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_CAN_QUIT_PROPERTY, mpris_root_properties[MPRIS_ROOT_CAN_QUIT_PROPERTY] = g_param_spec_boolean ("can-quit", "can-quit", "can-quit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_CAN_RAISE_PROPERTY, mpris_root_properties[MPRIS_ROOT_CAN_RAISE_PROPERTY] = g_param_spec_boolean ("can-raise", "can-raise", "can-raise", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_HAS_TRACK_LIST_PROPERTY, mpris_root_properties[MPRIS_ROOT_HAS_TRACK_LIST_PROPERTY] = g_param_spec_boolean ("has-track-list", "has-track-list", "has-track-list", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_DESKTOP_ENTRY_PROPERTY, mpris_root_properties[MPRIS_ROOT_DESKTOP_ENTRY_PROPERTY] = g_param_spec_string ("desktop-entry", "desktop-entry", "desktop-entry", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_IDENTITY_PROPERTY, mpris_root_properties[MPRIS_ROOT_IDENTITY_PROPERTY] = g_param_spec_string ("identity", "identity", "identity", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_SUPPORTED_URI_SCHEMES_PROPERTY, mpris_root_properties[MPRIS_ROOT_SUPPORTED_URI_SCHEMES_PROPERTY] = g_param_spec_boxed ("supported-uri-schemes", "supported-uri-schemes", "supported-uri-schemes", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_ROOT_SUPPORTED_MIME_TYPES_PROPERTY, mpris_root_properties[MPRIS_ROOT_SUPPORTED_MIME_TYPES_PROPERTY] = g_param_spec_boxed ("supported-mime-types", "supported-mime-types", "supported-mime-types", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
mpris_root_instance_init (MprisRoot * self,
                          gpointer klass)
{
}

static GType
mpris_root_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MprisRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisRoot), 0, (GInstanceInitFunc) mpris_root_instance_init, NULL };
	GType mpris_root_type_id;
	mpris_root_type_id = g_type_register_static (G_TYPE_OBJECT, "MprisRoot", &g_define_type_info, 0);
	g_type_set_qdata (mpris_root_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_root_register_object);
	return mpris_root_type_id;
}

GType
mpris_root_get_type (void)
{
	static volatile gsize mpris_root_type_id__once = 0;
	if (g_once_init_enter (&mpris_root_type_id__once)) {
		GType mpris_root_type_id;
		mpris_root_type_id = mpris_root_get_type_once ();
		g_once_init_leave (&mpris_root_type_id__once, mpris_root_type_id);
	}
	return mpris_root_type_id__once;
}

static void
_vala_mpris_root_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	MprisRoot * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MPRIS_ROOT, MprisRoot);
	switch (property_id) {
		case MPRIS_ROOT_CAN_QUIT_PROPERTY:
		g_value_set_boolean (value, mpris_root_get_can_quit (self));
		break;
		case MPRIS_ROOT_CAN_RAISE_PROPERTY:
		g_value_set_boolean (value, mpris_root_get_can_raise (self));
		break;
		case MPRIS_ROOT_HAS_TRACK_LIST_PROPERTY:
		g_value_set_boolean (value, mpris_root_get_has_track_list (self));
		break;
		case MPRIS_ROOT_DESKTOP_ENTRY_PROPERTY:
		g_value_take_string (value, mpris_root_get_desktop_entry (self));
		break;
		case MPRIS_ROOT_IDENTITY_PROPERTY:
		g_value_take_string (value, mpris_root_get_identity (self));
		break;
		case MPRIS_ROOT_SUPPORTED_URI_SCHEMES_PROPERTY:
		{
			int length;
			g_value_take_boxed (value, mpris_root_get_supported_uri_schemes (self, &length));
		}
		break;
		case MPRIS_ROOT_SUPPORTED_MIME_TYPES_PROPERTY:
		{
			int length;
			g_value_take_boxed (value, mpris_root_get_supported_mime_types (self, &length));
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_dbus_mpris_root_quit (MprisRoot* self,
                       GVariant* _parameters_,
                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mpris_root_quit (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mpris_root_raise (MprisRoot* self,
                        GVariant* _parameters_,
                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mpris_root_raise (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
mpris_root_dbus_interface_method_call (GDBusConnection* connection,
                                       const gchar* sender,
                                       const gchar* object_path,
                                       const gchar* interface_name,
                                       const gchar* method_name,
                                       GVariant* parameters,
                                       GDBusMethodInvocation* invocation,
                                       gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Quit") == 0) {
		_dbus_mpris_root_quit (object, parameters, invocation);
	} else if (strcmp (method_name, "Raise") == 0) {
		_dbus_mpris_root_raise (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_mpris_root_get_can_quit (MprisRoot* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_can_quit (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_root_get_can_raise (MprisRoot* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_can_raise (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_root_get_has_track_list (MprisRoot* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_root_get_has_track_list (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_root_get_desktop_entry (MprisRoot* self)
{
	gchar* result;
	GVariant* _reply;
	result = mpris_root_get_desktop_entry (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_mpris_root_get_identity (MprisRoot* self)
{
	gchar* result;
	GVariant* _reply;
	result = mpris_root_get_identity (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_mpris_root_get_supported_uri_schemes (MprisRoot* self)
{
	gchar** result;
	gint result_length1 = 0;
	GVariant* _reply;
	gchar** _tmp9_;
	GVariantBuilder _tmp10_;
	gint _tmp11_;
	result = mpris_root_get_supported_uri_schemes (self, &result_length1);
	_tmp9_ = result;
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("as"));
	for (_tmp11_ = 0; _tmp11_ < result_length1; _tmp11_++) {
		g_variant_builder_add_value (&_tmp10_, g_variant_new_string (*_tmp9_));
		_tmp9_++;
	}
	_reply = g_variant_builder_end (&_tmp10_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}

static GVariant*
_dbus_mpris_root_get_supported_mime_types (MprisRoot* self)
{
	gchar** result;
	gint result_length1 = 0;
	GVariant* _reply;
	gchar** _tmp12_;
	GVariantBuilder _tmp13_;
	gint _tmp14_;
	result = mpris_root_get_supported_mime_types (self, &result_length1);
	_tmp12_ = result;
	g_variant_builder_init (&_tmp13_, G_VARIANT_TYPE ("as"));
	for (_tmp14_ = 0; _tmp14_ < result_length1; _tmp14_++) {
		g_variant_builder_add_value (&_tmp13_, g_variant_new_string (*_tmp12_));
		_tmp12_++;
	}
	_reply = g_variant_builder_end (&_tmp13_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}

static GVariant*
mpris_root_dbus_interface_get_property (GDBusConnection* connection,
                                        const gchar* sender,
                                        const gchar* object_path,
                                        const gchar* interface_name,
                                        const gchar* property_name,
                                        GError** error,
                                        gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "CanQuit") == 0) {
		return _dbus_mpris_root_get_can_quit (object);
	} else if (strcmp (property_name, "CanRaise") == 0) {
		return _dbus_mpris_root_get_can_raise (object);
	} else if (strcmp (property_name, "HasTrackList") == 0) {
		return _dbus_mpris_root_get_has_track_list (object);
	} else if (strcmp (property_name, "DesktopEntry") == 0) {
		return _dbus_mpris_root_get_desktop_entry (object);
	} else if (strcmp (property_name, "Identity") == 0) {
		return _dbus_mpris_root_get_identity (object);
	} else if (strcmp (property_name, "SupportedUriSchemes") == 0) {
		return _dbus_mpris_root_get_supported_uri_schemes (object);
	} else if (strcmp (property_name, "SupportedMimeTypes") == 0) {
		return _dbus_mpris_root_get_supported_mime_types (object);
	}
	return NULL;
}

static gboolean
mpris_root_dbus_interface_set_property (GDBusConnection* connection,
                                        const gchar* sender,
                                        const gchar* object_path,
                                        const gchar* interface_name,
                                        const gchar* property_name,
                                        GVariant* value,
                                        GError** error,
                                        gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
mpris_root_register_object (gpointer object,
                            GDBusConnection* connection,
                            const gchar* path,
                            GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_root_dbus_interface_info), &_mpris_root_dbus_interface_vtable, data, _mpris_root_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_mpris_root_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
mpris_player_get_instance_private (MprisPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, MprisPlayer_private_offset);
}

static GType
mpris_player_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{MPRIS_PLAYER_DIRECTION_NEXT, "MPRIS_PLAYER_DIRECTION_NEXT", "next"}, {MPRIS_PLAYER_DIRECTION_PREVIOUS, "MPRIS_PLAYER_DIRECTION_PREVIOUS", "previous"}, {MPRIS_PLAYER_DIRECTION_STOP, "MPRIS_PLAYER_DIRECTION_STOP", "stop"}, {0, NULL, NULL}};
	GType mpris_player_direction_type_id;
	mpris_player_direction_type_id = g_enum_register_static ("MprisPlayerDirection", values);
	return mpris_player_direction_type_id;
}

static GType
mpris_player_direction_get_type (void)
{
	static volatile gsize mpris_player_direction_type_id__once = 0;
	if (g_once_init_enter (&mpris_player_direction_type_id__once)) {
		GType mpris_player_direction_type_id;
		mpris_player_direction_type_id = mpris_player_direction_get_type_once ();
		g_once_init_leave (&mpris_player_direction_type_id__once, mpris_player_direction_type_id);
	}
	return mpris_player_direction_type_id__once;
}

MprisPlayer*
mpris_player_construct (GType object_type,
                        GDBusConnection* conn)
{
	MprisPlayer * self = NULL;
	g_return_val_if_fail (conn != NULL, NULL);
	self = (MprisPlayer*) g_object_new (object_type, "conn", conn, NULL);
	return self;
}

MprisPlayer*
mpris_player_new (GDBusConnection* conn)
{
	return mpris_player_construct (TYPE_MPRIS_PLAYER, conn);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
mpris_player_refresh_current_media (MprisPlayer* self)
{
	MusicMedia* current_media = NULL;
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	MusicMedia* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	current_media = _tmp4_;
	_tmp5_ = current_media;
	if (_tmp5_ != NULL) {
		MusicMedia* _tmp6_;
		_tmp6_ = current_media;
		mpris_player_on_media_played (self, _tmp6_);
	}
	_g_object_unref0 (current_media);
}

static void
mpris_player_playing_changed (MprisPlayer* self)
{
	g_return_if_fail (self != NULL);
	mpris_player_trigger_metadata_update (self);
}

static GVariant*
_variant_new6 (gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new7 (GHashTable* value)
{
	GVariantBuilder _tmp6_;
	GHashTableIter _tmp7_;
	gpointer _tmp8_;
	gpointer _tmp9_;
	g_hash_table_iter_init (&_tmp7_, value);
	g_variant_builder_init (&_tmp6_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp7_, &_tmp8_, &_tmp9_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp8_;
		_value = (GVariant*) _tmp9_;
		g_variant_builder_add (&_tmp6_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp6_));
}

static gboolean
__lambda177_ (MprisPlayer* self)
{
	GVariant* variant = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GHashTable* _tmp5_;
	GVariant* _tmp10_;
	gboolean result;
	_tmp0_ = mpris_player_get_playback_status (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = _variant_new6 (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	variant = _tmp4_;
	mpris_player_queue_property_for_notification (self, "PlaybackStatus", variant);
	_tmp5_ = self->priv->_metadata;
	_tmp10_ = _variant_new7 (_tmp5_);
	mpris_player_queue_property_for_notification (self, "Metadata", _tmp10_);
	_g_variant_unref0 (_tmp10_);
	self->priv->update_metadata_source = (guint) 0;
	result = FALSE;
	_g_variant_unref0 (variant);
	return result;
}

static gboolean
___lambda177__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda177_ ((MprisPlayer*) self);
	return result;
}

static void
mpris_player_trigger_metadata_update (MprisPlayer* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->update_metadata_source != ((guint) 0)) {
		g_source_remove (self->priv->update_metadata_source);
	}
	self->priv->update_metadata_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, ___lambda177__gsource_func, g_object_ref (self), g_object_unref);
}

static void
mpris_player_on_media_played (MprisPlayer* self,
                              MusicMedia* s)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	if (s == _tmp3_) {
		mpris_player_update_metadata (self, s);
	}
}

static void
mpris_player_update_metadata (MprisPlayer* self,
                              MusicMedia* s)
{
	g_return_if_fail (self != NULL);
	if (s == NULL) {
		GHashTable* _tmp0_;
		_tmp0_ = self->priv->_metadata;
		g_hash_table_remove_all (_tmp0_);
	} else {
		mpris_player_set_media_metadata (self, s);
	}
	mpris_player_trigger_metadata_update (self);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_g_variant_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}

static GVariant*
_variant_new8 (char* value)
{
	return g_variant_ref_sink (g_variant_new_object_path (value));
}

static GVariant*
_variant_new9 (guint64 value)
{
	return g_variant_ref_sink (g_variant_new_uint64 (value));
}

static GVariant*
_variant_new10 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new11 (gint value)
{
	return g_variant_ref_sink (g_variant_new_int32 (value));
}

static GVariant*
_variant_new12 (gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new13 (gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new14 (gchar** value,
                gint value_length1)
{
	gchar** _tmp46_;
	GVariantBuilder _tmp47_;
	gint _tmp48_;
	_tmp46_ = value;
	g_variant_builder_init (&_tmp47_, G_VARIANT_TYPE ("as"));
	for (_tmp48_ = 0; _tmp48_ < value_length1; _tmp48_++) {
		g_variant_builder_add_value (&_tmp47_, g_variant_new_string (*_tmp46_));
		_tmp46_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp47_));
}

static GVariant*
_variant_new15 (gchar** value,
                gint value_length1)
{
	gchar** _tmp57_;
	GVariantBuilder _tmp58_;
	gint _tmp59_;
	_tmp57_ = value;
	g_variant_builder_init (&_tmp58_, G_VARIANT_TYPE ("as"));
	for (_tmp59_ = 0; _tmp59_ < value_length1; _tmp59_++) {
		g_variant_builder_add_value (&_tmp58_, g_variant_new_string (*_tmp57_));
		_tmp57_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp58_));
}

static GVariant*
_variant_new16 (gchar** value,
                gint value_length1)
{
	gchar** _tmp68_;
	GVariantBuilder _tmp69_;
	gint _tmp70_;
	_tmp68_ = value;
	g_variant_builder_init (&_tmp69_, G_VARIANT_TYPE ("as"));
	for (_tmp70_ = 0; _tmp70_ < value_length1; _tmp70_++) {
		g_variant_builder_add_value (&_tmp69_, g_variant_new_string (*_tmp68_));
		_tmp68_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp69_));
}

static GVariant*
_variant_new17 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new18 (gchar** value,
                gint value_length1)
{
	gchar** _tmp84_;
	GVariantBuilder _tmp85_;
	gint _tmp86_;
	_tmp84_ = value;
	g_variant_builder_init (&_tmp85_, G_VARIANT_TYPE ("as"));
	for (_tmp86_ = 0; _tmp86_ < value_length1; _tmp86_++) {
		g_variant_builder_add_value (&_tmp85_, g_variant_new_string (*_tmp84_));
		_tmp84_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp85_));
}

static GVariant*
_variant_new19 (gchar** value,
                gint value_length1)
{
	gchar** _tmp95_;
	GVariantBuilder _tmp96_;
	gint _tmp97_;
	_tmp95_ = value;
	g_variant_builder_init (&_tmp96_, G_VARIANT_TYPE ("as"));
	for (_tmp97_ = 0; _tmp97_ < value_length1; _tmp97_++) {
		g_variant_builder_add_value (&_tmp96_, g_variant_new_string (*_tmp95_));
		_tmp95_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp96_));
}

static GVariant*
_variant_new20 (gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new21 (gint value)
{
	return g_variant_ref_sink (g_variant_new_int32 (value));
}

static GVariant*
_variant_new22 (gint value)
{
	return g_variant_ref_sink (g_variant_new_int32 (value));
}

static GVariant*
_variant_new23 (gint value)
{
	return g_variant_ref_sink (g_variant_new_int32 (value));
}

static void
mpris_player_set_media_metadata (MprisPlayer* self,
                                 MusicMedia* s)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	GVariant* _tmp5_;
	GHashTable* _tmp6_;
	gchar* _tmp7_;
	MusicPlaybackManager* _tmp8_;
	MusicPlaybackManager* _tmp9_;
	MusicPlayback* _tmp10_;
	GVariant* _tmp11_;
	GFile* art_file = NULL;
	MusicAlbum* _tmp12_;
	MusicAlbum* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_ = NULL;
	GFile* _tmp16_;
	GHashTable* _tmp21_;
	gchar* _tmp22_;
	GVariant* _tmp23_;
	GHashTable* _tmp24_;
	gchar* _tmp25_;
	guint _tmp26_;
	guint _tmp27_;
	GVariant* _tmp28_;
	GHashTable* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GVariant* _tmp33_;
	GHashTable* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	GVariant* _tmp38_;
	GHashTable* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gint _tmp43_ = 0;
	gchar** _tmp44_;
	gchar** _tmp45_;
	gint _tmp45__length1;
	GVariant* _tmp49_;
	GHashTable* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gint _tmp54_ = 0;
	gchar** _tmp55_;
	gchar** _tmp56_;
	gint _tmp56__length1;
	GVariant* _tmp60_;
	GHashTable* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gint _tmp65_ = 0;
	gchar** _tmp66_;
	gchar** _tmp67_;
	gint _tmp67__length1;
	GVariant* _tmp71_;
	GHashTable* _tmp72_;
	gchar* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	GVariant* _tmp76_;
	GHashTable* _tmp77_;
	gchar* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	gint _tmp81_ = 0;
	gchar** _tmp82_;
	gchar** _tmp83_;
	gint _tmp83__length1;
	GVariant* _tmp87_;
	GHashTable* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gint _tmp92_ = 0;
	gchar** _tmp93_;
	gchar** _tmp94_;
	gint _tmp94__length1;
	GVariant* _tmp98_;
	GHashTable* _tmp99_;
	gchar* _tmp100_;
	gchar* _tmp101_;
	gchar* _tmp102_;
	gchar* _tmp103_;
	GVariant* _tmp104_;
	GHashTable* _tmp105_;
	gchar* _tmp106_;
	guint _tmp107_;
	guint _tmp108_;
	GVariant* _tmp109_;
	GHashTable* _tmp110_;
	gchar* _tmp111_;
	guint _tmp112_;
	guint _tmp113_;
	GVariant* _tmp114_;
	GHashTable* _tmp115_;
	gchar* _tmp116_;
	guint _tmp117_;
	guint _tmp118_;
	GVariant* _tmp119_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (s != NULL);
	_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_variant_unref0_);
	_g_hash_table_unref0 (self->priv->_metadata);
	self->priv->_metadata = _tmp0_;
	_tmp1_ = self->priv->_metadata;
	_tmp2_ = g_strdup ("mpris:trackid");
	_tmp3_ = mpris_player_get_track_id (self, s);
	_tmp4_ = _tmp3_;
	_tmp5_ = _variant_new8 (_tmp4_);
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp5_);
	_g_free0 (_tmp4_);
	_tmp6_ = self->priv->_metadata;
	_tmp7_ = g_strdup ("mpris:length");
	_tmp8_ = music_app_get_player ();
	_tmp9_ = _tmp8_;
	_tmp10_ = _tmp9_->player;
	_tmp11_ = _variant_new9 (music_playback_get_duration (_tmp10_) / MUSIC_TIME_UTILS_MILI_INV);
	g_hash_table_insert (_tmp6_, _tmp7_, _tmp11_);
	_tmp12_ = music_media_get_album_info (s);
	_tmp13_ = _tmp12_;
	_tmp14_ = music_album_get_cached_cover_file (_tmp13_);
	art_file = _tmp14_;
	_tmp16_ = art_file;
	if (_tmp16_ != NULL) {
		GFile* _tmp17_;
		gchar* _tmp18_;
		_tmp17_ = art_file;
		_tmp18_ = g_file_get_uri (_tmp17_);
		_g_free0 (_tmp15_);
		_tmp15_ = _tmp18_;
	} else {
		const gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp19_ = self->priv->default_image_url;
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (_tmp15_);
		_tmp15_ = _tmp20_;
	}
	_tmp21_ = self->priv->_metadata;
	_tmp22_ = g_strdup ("mpris:artUrl");
	_tmp23_ = _variant_new10 (_tmp15_);
	g_hash_table_insert (_tmp21_, _tmp22_, _tmp23_);
	_tmp24_ = self->priv->_metadata;
	_tmp25_ = g_strdup ("xesam:trackNumber");
	_tmp26_ = music_media_get_track (s);
	_tmp27_ = _tmp26_;
	_tmp28_ = _variant_new11 ((gint) _tmp27_);
	g_hash_table_insert (_tmp24_, _tmp25_, _tmp28_);
	_tmp29_ = self->priv->_metadata;
	_tmp30_ = g_strdup ("xesam:title");
	_tmp31_ = music_media_get_display_title (s);
	_tmp32_ = _tmp31_;
	_tmp33_ = _variant_new12 (_tmp32_);
	g_hash_table_insert (_tmp29_, _tmp30_, _tmp33_);
	_g_free0 (_tmp32_);
	_tmp34_ = self->priv->_metadata;
	_tmp35_ = g_strdup ("xesam:album");
	_tmp36_ = music_media_get_display_album (s);
	_tmp37_ = _tmp36_;
	_tmp38_ = _variant_new13 (_tmp37_);
	g_hash_table_insert (_tmp34_, _tmp35_, _tmp38_);
	_g_free0 (_tmp37_);
	_tmp39_ = self->priv->_metadata;
	_tmp40_ = g_strdup ("xesam:artist");
	_tmp41_ = music_media_get_display_artist (s);
	_tmp42_ = _tmp41_;
	_tmp44_ = mpris_player_get_simple_string_array (_tmp42_, &_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp45__length1 = _tmp43_;
	_tmp49_ = _variant_new14 (_tmp45_, _tmp43_);
	g_hash_table_insert (_tmp39_, _tmp40_, _tmp49_);
	_tmp45_ = (_vala_array_free (_tmp45_, _tmp45__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp42_);
	_tmp50_ = self->priv->_metadata;
	_tmp51_ = g_strdup ("xesam:albumArtist");
	_tmp52_ = music_media_get_display_album_artist (s, TRUE);
	_tmp53_ = _tmp52_;
	_tmp55_ = mpris_player_get_simple_string_array (_tmp53_, &_tmp54_);
	_tmp56_ = _tmp55_;
	_tmp56__length1 = _tmp54_;
	_tmp60_ = _variant_new15 (_tmp56_, _tmp54_);
	g_hash_table_insert (_tmp50_, _tmp51_, _tmp60_);
	_tmp56_ = (_vala_array_free (_tmp56_, _tmp56__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp53_);
	_tmp61_ = self->priv->_metadata;
	_tmp62_ = g_strdup ("xesam:genre");
	_tmp63_ = music_media_get_display_genre (s);
	_tmp64_ = _tmp63_;
	_tmp66_ = mpris_player_get_simple_string_array (_tmp64_, &_tmp65_);
	_tmp67_ = _tmp66_;
	_tmp67__length1 = _tmp65_;
	_tmp71_ = _variant_new16 (_tmp67_, _tmp65_);
	g_hash_table_insert (_tmp61_, _tmp62_, _tmp71_);
	_tmp67_ = (_vala_array_free (_tmp67_, _tmp67__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp64_);
	_tmp72_ = self->priv->_metadata;
	_tmp73_ = g_strdup ("xesam:asText");
	_tmp74_ = music_media_get_lyrics (s);
	_tmp75_ = _tmp74_;
	_tmp76_ = _variant_new17 (_tmp75_);
	g_hash_table_insert (_tmp72_, _tmp73_, _tmp76_);
	_tmp77_ = self->priv->_metadata;
	_tmp78_ = g_strdup ("xesam:comment");
	_tmp79_ = music_media_get_comment (s);
	_tmp80_ = _tmp79_;
	_tmp82_ = mpris_player_get_simple_string_array (_tmp80_, &_tmp81_);
	_tmp83_ = _tmp82_;
	_tmp83__length1 = _tmp81_;
	_tmp87_ = _variant_new18 (_tmp83_, _tmp81_);
	g_hash_table_insert (_tmp77_, _tmp78_, _tmp87_);
	_tmp83_ = (_vala_array_free (_tmp83_, _tmp83__length1, (GDestroyNotify) g_free), NULL);
	_tmp88_ = self->priv->_metadata;
	_tmp89_ = g_strdup ("xesam:composer");
	_tmp90_ = music_media_get_display_composer (s);
	_tmp91_ = _tmp90_;
	_tmp93_ = mpris_player_get_simple_string_array (_tmp91_, &_tmp92_);
	_tmp94_ = _tmp93_;
	_tmp94__length1 = _tmp92_;
	_tmp98_ = _variant_new19 (_tmp94_, _tmp92_);
	g_hash_table_insert (_tmp88_, _tmp89_, _tmp98_);
	_tmp94_ = (_vala_array_free (_tmp94_, _tmp94__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp91_);
	_tmp99_ = self->priv->_metadata;
	_tmp100_ = g_strdup ("xesam:url");
	_tmp101_ = music_media_get_uri (s);
	_tmp102_ = _tmp101_;
	_tmp103_ = _tmp102_;
	_tmp104_ = _variant_new20 (_tmp103_);
	g_hash_table_insert (_tmp99_, _tmp100_, _tmp104_);
	_g_free0 (_tmp103_);
	_tmp105_ = self->priv->_metadata;
	_tmp106_ = g_strdup ("xesam:discNumber");
	_tmp107_ = music_media_get_album_number (s);
	_tmp108_ = _tmp107_;
	_tmp109_ = _variant_new21 ((gint) _tmp108_);
	g_hash_table_insert (_tmp105_, _tmp106_, _tmp109_);
	_tmp110_ = self->priv->_metadata;
	_tmp111_ = g_strdup ("xesam:userRating");
	_tmp112_ = music_media_get_rating (s);
	_tmp113_ = _tmp112_;
	_tmp114_ = _variant_new22 ((gint) _tmp113_);
	g_hash_table_insert (_tmp110_, _tmp111_, _tmp114_);
	_tmp115_ = self->priv->_metadata;
	_tmp116_ = g_strdup ("xesam:useCount");
	_tmp117_ = music_media_get_play_count (s);
	_tmp118_ = _tmp117_;
	_tmp119_ = _variant_new23 ((gint) _tmp118_);
	g_hash_table_insert (_tmp115_, _tmp116_, _tmp119_);
	_g_free0 (_tmp15_);
	_g_object_unref0 (art_file);
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar**
mpris_player_get_simple_string_array (const gchar* text,
                                      gint* result_length1)
{
	gchar** array = NULL;
	gchar** _tmp2_;
	gint array_length1;
	gint _array_size_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** result;
	if (text == NULL) {
		gchar** _tmp0_;
		gchar** _tmp1_;
		gint _tmp1__length1;
		_tmp0_ = g_new0 (gchar*, 0 + 1);
		_tmp1_ = _tmp0_;
		_tmp1__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp1__length1;
		}
		result = _tmp1_;
		return result;
	}
	_tmp2_ = g_new0 (gchar*, 0 + 1);
	array = _tmp2_;
	array_length1 = 0;
	_array_size_ = array_length1;
	_tmp3_ = g_strdup (text);
	_vala_array_add3 (&array, &array_length1, &_array_size_, _tmp3_);
	_tmp4_ = array;
	_tmp4__length1 = array_length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}

static char*
mpris_player_get_track_id (MprisPlayer* self,
                           MusicMedia* m)
{
	gint64 _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	char* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (m != NULL, NULL);
	_tmp0_ = music_media_get_rowid (m);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("/io/elementary/music/Track/%lld", _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	return result;
}

static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}

static gboolean
mpris_player_send_property_change (MprisPlayer* self)
{
	GHashTable* _tmp0_;
	GVariantBuilder* builder = NULL;
	const GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* invalidated_builder = NULL;
	GVariantType* _tmp3_;
	GVariantType* _tmp4_;
	GVariantBuilder* _tmp5_;
	GVariantBuilder* _tmp6_;
	GHashTable* _tmp7_;
	GList* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->changed_properties;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = G_VARIANT_TYPE_ARRAY;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	builder = _tmp2_;
	_tmp3_ = g_variant_type_new ("as");
	_tmp4_ = _tmp3_;
	_tmp5_ = g_variant_builder_new (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_variant_type_free0 (_tmp4_);
	invalidated_builder = _tmp6_;
	_tmp7_ = self->priv->changed_properties;
	_tmp8_ = g_hash_table_get_keys (_tmp7_);
	{
		GList* name_collection = NULL;
		GList* name_it = NULL;
		name_collection = _tmp8_;
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
			gchar* _tmp9_;
			gchar* name = NULL;
			_tmp9_ = g_strdup ((const gchar*) name_it->data);
			name = _tmp9_;
			{
				GVariant* variant = NULL;
				GHashTable* _tmp10_;
				const gchar* _tmp11_;
				gconstpointer _tmp12_;
				GVariant* _tmp13_;
				GVariantBuilder* _tmp14_;
				const gchar* _tmp15_;
				GVariant* _tmp16_;
				_tmp10_ = self->priv->changed_properties;
				_tmp11_ = name;
				_tmp12_ = g_hash_table_lookup (_tmp10_, _tmp11_);
				_tmp13_ = _g_variant_ref0 ((GVariant*) _tmp12_);
				variant = _tmp13_;
				_tmp14_ = builder;
				_tmp15_ = name;
				_tmp16_ = variant;
				g_variant_builder_add (_tmp14_, "{sv}", _tmp15_, _tmp16_, NULL);
				_g_variant_unref0 (variant);
				_g_free0 (name);
			}
		}
		(name_collection == NULL) ? NULL : (name_collection = (g_list_free (name_collection), NULL));
	}
	_g_hash_table_unref0 (self->priv->changed_properties);
	self->priv->changed_properties = NULL;
	{
		GDBusConnection* _tmp17_;
		GVariantBuilder* _tmp18_;
		GVariantBuilder* _tmp19_;
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		_tmp17_ = self->priv->_conn;
		_tmp18_ = builder;
		_tmp19_ = invalidated_builder;
		_tmp20_ = g_variant_new ("(sa{sv}as)", MPRIS_PLAYER_INTERFACE_NAME, _tmp18_, _tmp19_, NULL);
		g_variant_ref_sink (_tmp20_);
		_tmp21_ = _tmp20_;
		g_dbus_connection_emit_signal (_tmp17_, NULL, "/org/mpris/MediaPlayer2", "org.freedesktop.DBus.Properties", "PropertiesChanged", _tmp21_, &_inner_error0_);
		_g_variant_unref0 (_tmp21_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp22_;
		const gchar* _tmp23_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->message;
		g_print ("Could not send MPRIS property change: %s\n", _tmp23_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp24_ = FALSE;
		_g_variant_builder_unref0 (invalidated_builder);
		_g_variant_builder_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp24_;
	}
	self->priv->send_property_source = (guint) 0;
	result = FALSE;
	_g_variant_builder_unref0 (invalidated_builder);
	_g_variant_builder_unref0 (builder);
	return result;
}

static gboolean
_mpris_player_send_property_change_gsource_func (gpointer self)
{
	gboolean result;
	result = mpris_player_send_property_change ((MprisPlayer*) self);
	return result;
}

static void
mpris_player_queue_property_for_notification (MprisPlayer* self,
                                              const gchar* property,
                                              GVariant* val)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	GVariant* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (property != NULL);
	g_return_if_fail (val != NULL);
	_tmp0_ = self->priv->changed_properties;
	if (_tmp0_ == NULL) {
		GHashFunc _tmp1_;
		GEqualFunc _tmp2_;
		GHashTable* _tmp3_;
		_tmp1_ = g_str_hash;
		_tmp2_ = g_str_equal;
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_variant_unref0_);
		_g_hash_table_unref0 (self->priv->changed_properties);
		self->priv->changed_properties = _tmp3_;
	}
	_tmp4_ = self->priv->changed_properties;
	_tmp5_ = g_strdup (property);
	_tmp6_ = _g_variant_ref0 (val);
	g_hash_table_insert (_tmp4_, _tmp5_, _tmp6_);
	if (self->priv->send_property_source == ((guint) 0)) {
		self->priv->send_property_source = g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _mpris_player_send_property_change_gsource_func, g_object_ref (self), g_object_unref);
	}
}

void
mpris_player_next (MprisPlayer* self,
                   GError** error)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	music_library_window_play_next_media (_tmp1_, TRUE);
}

void
mpris_player_previous (MprisPlayer* self,
                       GError** error)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	music_library_window_play_previous_media (_tmp1_, TRUE);
}

void
mpris_player_pause (MprisPlayer* self,
                    GError** error)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_playing (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		MusicPlaybackManager* _tmp4_;
		MusicPlaybackManager* _tmp5_;
		_tmp4_ = music_app_get_player ();
		_tmp5_ = _tmp4_;
		music_playback_manager_pause_playback (_tmp5_);
	}
}

void
mpris_player_play_pause (MprisPlayer* self,
                         GError** error)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	music_library_window_play_media (_tmp1_, TRUE);
}

void
mpris_player_stop (MprisPlayer* self,
                   GError** error)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_playing (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		MusicPlaybackManager* _tmp4_;
		MusicPlaybackManager* _tmp5_;
		_tmp4_ = music_app_get_player ();
		_tmp5_ = _tmp4_;
		music_playback_manager_stop_playback (_tmp5_);
	}
}

void
mpris_player_play (MprisPlayer* self,
                   GError** error)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_playing (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		MusicPlaybackManager* _tmp4_;
		MusicPlaybackManager* _tmp5_;
		_tmp4_ = music_app_get_player ();
		_tmp5_ = _tmp4_;
		music_playback_manager_start_playback (_tmp5_);
	}
}

void
mpris_player_seek (MprisPlayer* self,
                   gint64 offset,
                   GError** error)
{
	gint64 position = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	MusicPlaybackManager* _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicPlayback* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = mpris_player_get_position (self);
	_tmp1_ = _tmp0_;
	position = _tmp1_ + offset;
	if (position < ((gint64) 0)) {
		position = (gint64) 0;
	}
	_tmp2_ = music_app_get_player ();
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_->player;
	if (((guint64) position) < (music_playback_get_duration (_tmp4_) / MUSIC_TIME_UTILS_MILI_INV)) {
		mpris_player_set_position (self, "", position, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			return;
		}
		g_signal_emit (self, mpris_player_signals[MPRIS_PLAYER_SEEKED_SIGNAL], 0, position);
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp5_ = mpris_player_get_can_go_next (self);
		_tmp6_ = _tmp5_;
		if (_tmp6_) {
			mpris_player_next (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				return;
			}
		}
	}
}

void
mpris_player_set_position (MprisPlayer* self,
                           const gchar* dobj,
                           gint64 position,
                           GError** error)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlayback* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dobj != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_->player;
	music_playback_set_position (_tmp2_, position * ((gint64) MUSIC_TIME_UTILS_MILI_INV));
}

void
mpris_player_open_uri (MprisPlayer* self,
                       const gchar* uri,
                       GError** error)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (uri != NULL);
}

GDBusConnection*
mpris_player_get_conn (MprisPlayer* self)
{
	GDBusConnection* result;
	GDBusConnection* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_conn;
	result = _tmp0_;
	return result;
}

void
mpris_player_set_conn (MprisPlayer* self,
                       GDBusConnection* value)
{
	GDBusConnection* old_value;
	g_return_if_fail (self != NULL);
	old_value = mpris_player_get_conn (self);
	if (old_value != value) {
		self->priv->_conn = value;
		g_object_notify_by_pspec ((GObject *) self, mpris_player_properties[MPRIS_PLAYER_CONN_PROPERTY]);
	}
}

gchar*
mpris_player_get_playback_status (MprisPlayer* self)
{
	gchar* result;
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_playing (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("Playing");
		result = _tmp4_;
		return result;
	} else {
		gboolean _tmp5_ = FALSE;
		MusicPlaybackManager* _tmp6_;
		MusicPlaybackManager* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp6_ = music_app_get_player ();
		_tmp7_ = _tmp6_;
		_tmp8_ = music_playback_manager_get_playing (_tmp7_);
		_tmp9_ = _tmp8_;
		if (!_tmp9_) {
			MusicPlaybackManager* _tmp10_;
			MusicPlaybackManager* _tmp11_;
			MusicMedia* _tmp12_;
			MusicMedia* _tmp13_;
			_tmp10_ = music_app_get_player ();
			_tmp11_ = _tmp10_;
			_tmp12_ = music_playback_manager_get_current_media (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp5_ = _tmp13_ == NULL;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			gchar* _tmp14_;
			_tmp14_ = g_strdup ("Stopped");
			result = _tmp14_;
			return result;
		} else {
			MusicPlaybackManager* _tmp15_;
			MusicPlaybackManager* _tmp16_;
			gboolean _tmp17_;
			gboolean _tmp18_;
			_tmp15_ = music_app_get_player ();
			_tmp16_ = _tmp15_;
			_tmp17_ = music_playback_manager_get_playing (_tmp16_);
			_tmp18_ = _tmp17_;
			if (!_tmp18_) {
				gchar* _tmp19_;
				_tmp19_ = g_strdup ("Paused");
				result = _tmp19_;
				return result;
			} else {
				gchar* _tmp20_;
				_tmp20_ = g_strdup ("Stopped");
				result = _tmp20_;
				return result;
			}
		}
	}
}

gchar*
mpris_player_get_loop_status (MprisPlayer* self)
{
	gchar* result;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_app_get_settings ();
	_tmp1_ = _tmp0_;
	switch (g_settings_get_enum (_tmp1_, "repeat-mode")) {
		case MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_OFF:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("None");
			result = _tmp2_;
			return result;
		}
		case MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("Track");
			result = _tmp3_;
			return result;
		}
		default:
		case MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALBUM:
		case MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ARTIST:
		case MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Playlist");
			result = _tmp4_;
			return result;
		}
	}
}

static GVariant*
_variant_new24 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

void
mpris_player_set_loop_status (MprisPlayer* self,
                              const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	GVariant* variant = NULL;
	GVariant* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("None")))) {
		switch (0) {
			default:
			{
				MusicPlaybackManager* _tmp3_;
				MusicPlaybackManager* _tmp4_;
				_tmp3_ = music_app_get_player ();
				_tmp4_ = _tmp3_;
				music_playback_manager_set_repeat_mode (_tmp4_, MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_OFF);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Track")))) {
		switch (0) {
			default:
			{
				MusicPlaybackManager* _tmp5_;
				MusicPlaybackManager* _tmp6_;
				_tmp5_ = music_app_get_player ();
				_tmp6_ = _tmp5_;
				music_playback_manager_set_repeat_mode (_tmp6_, MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_MEDIA);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Playlist")))) {
		switch (0) {
			default:
			{
				MusicPlaybackManager* _tmp7_;
				MusicPlaybackManager* _tmp8_;
				_tmp7_ = music_app_get_player ();
				_tmp8_ = _tmp7_;
				music_playback_manager_set_repeat_mode (_tmp8_, MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				MusicPlaybackManager* _tmp9_;
				MusicPlaybackManager* _tmp10_;
				_tmp9_ = music_app_get_player ();
				_tmp10_ = _tmp9_;
				music_playback_manager_set_repeat_mode (_tmp10_, MUSIC_PLAYBACK_MANAGER_REPEAT_MODE_ALL);
				break;
			}
		}
	}
	_tmp11_ = _variant_new24 (value);
	variant = _tmp11_;
	mpris_player_queue_property_for_notification (self, "LoopStatus", variant);
	_g_variant_unref0 (variant);
	g_object_notify_by_pspec ((GObject *) self, mpris_player_properties[MPRIS_PLAYER_LOOP_STATUS_PROPERTY]);
}

gdouble
mpris_player_get_rate (MprisPlayer* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = 1.0;
	return result;
}

void
mpris_player_set_rate (MprisPlayer* self,
                       gdouble value)
{
	g_return_if_fail (self != NULL);
	g_object_notify_by_pspec ((GObject *) self, mpris_player_properties[MPRIS_PLAYER_RATE_PROPERTY]);
}

gboolean
mpris_player_get_shuffle (MprisPlayer* self)
{
	gboolean result;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = music_app_get_settings ();
	_tmp1_ = _tmp0_;
	result = g_settings_get_enum (_tmp1_, "shuffle-mode") == ((gint) MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL);
	return result;
}

static GVariant*
_variant_new25 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

void
mpris_player_set_shuffle (MprisPlayer* self,
                          gboolean value)
{
	GVariant* variant = NULL;
	GVariant* _tmp4_;
	g_return_if_fail (self != NULL);
	if (value) {
		MusicPlaybackManager* _tmp0_;
		MusicPlaybackManager* _tmp1_;
		_tmp0_ = music_app_get_player ();
		_tmp1_ = _tmp0_;
		music_playback_manager_set_shuffle_mode (_tmp1_, MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_ALL);
	} else {
		MusicPlaybackManager* _tmp2_;
		MusicPlaybackManager* _tmp3_;
		_tmp2_ = music_app_get_player ();
		_tmp3_ = _tmp2_;
		music_playback_manager_set_shuffle_mode (_tmp3_, MUSIC_PLAYBACK_MANAGER_SHUFFLE_MODE_OFF);
	}
	_tmp4_ = _variant_new25 (value);
	variant = _tmp4_;
	mpris_player_queue_property_for_notification (self, "Shuffle", variant);
	_g_variant_unref0 (variant);
	g_object_notify_by_pspec ((GObject *) self, mpris_player_properties[MPRIS_PLAYER_SHUFFLE_PROPERTY]);
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

GHashTable*
mpris_player_get_metadata (MprisPlayer* self)
{
	GHashTable* result;
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicMedia* _tmp2_;
	MusicMedia* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	mpris_player_update_metadata (self, _tmp3_);
	_tmp4_ = self->priv->_metadata;
	_tmp5_ = _g_hash_table_ref0 (_tmp4_);
	result = _tmp5_;
	return result;
}

gdouble
mpris_player_get_volume (MprisPlayer* self)
{
	gdouble result;
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playback_manager_get_volume (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_;
	return result;
}

void
mpris_player_set_volume (MprisPlayer* self,
                         gdouble value)
{
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	music_playback_manager_set_volume (_tmp1_, value);
	g_object_notify_by_pspec ((GObject *) self, mpris_player_properties[MPRIS_PLAYER_VOLUME_PROPERTY]);
}

gint64
mpris_player_get_position (MprisPlayer* self)
{
	gint64 result;
	MusicPlaybackManager* _tmp0_;
	MusicPlaybackManager* _tmp1_;
	MusicPlayback* _tmp2_;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = music_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_->player;
	result = music_playback_get_position (_tmp2_) / ((gint64) MUSIC_TIME_UTILS_MILI_INV);
	return result;
}

gboolean
mpris_player_get_can_go_next (MprisPlayer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
mpris_player_get_can_go_previous (MprisPlayer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
mpris_player_get_can_play (MprisPlayer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
mpris_player_get_can_pause (MprisPlayer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
mpris_player_get_can_seek (MprisPlayer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}

gboolean
mpris_player_get_can_control (MprisPlayer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}

static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}

static void
_mpris_player_on_media_played_music_playback_manager_media_played (MusicPlaybackManager* _sender,
                                                                   MusicMedia* played_media,
                                                                   gpointer self)
{
	mpris_player_on_media_played ((MprisPlayer*) self, played_media);
}

static void
_mpris_player___lambda178_ (MprisPlayer* self)
{
	mpris_player_update_metadata (self, NULL);
}

static void
__mpris_player___lambda178__music_playback_manager_playback_stopped (MusicPlaybackManager* _sender,
                                                                     gint64 was_playing,
                                                                     gpointer self)
{
	_mpris_player___lambda178_ ((MprisPlayer*) self);
}

static void
_mpris_player_refresh_current_media_music_library_media_updated (MusicLibrary* _sender,
                                                                 GeeCollection* medias,
                                                                 gpointer self)
{
	mpris_player_refresh_current_media ((MprisPlayer*) self);
}

static void
_mpris_player_playing_changed_music_library_window_play_pause_changed (MusicLibraryWindow* _sender,
                                                                       gpointer self)
{
	mpris_player_playing_changed ((MprisPlayer*) self);
}

static GObject *
mpris_player_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MprisPlayer * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	MusicPlaybackManager* _tmp3_;
	MusicPlaybackManager* _tmp4_;
	MusicPlaybackManager* _tmp5_;
	MusicPlaybackManager* _tmp6_;
	MusicLibrariesManager* _tmp7_;
	MusicLibrary* _tmp8_;
	MusicLibraryWindow* _tmp9_;
	MusicLibraryWindow* _tmp10_;
	GFile* default_image = NULL;
	MusicIcon* _tmp11_;
	MusicIcon* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_ = NULL;
	GFile* _tmp16_;
	gchar* _tmp20_;
	parent_class = G_OBJECT_CLASS (mpris_player_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MPRIS_PLAYER, MprisPlayer);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_variant_unref0_);
	_g_hash_table_unref0 (self->priv->_metadata);
	self->priv->_metadata = _tmp2_;
	_tmp3_ = music_app_get_player ();
	_tmp4_ = _tmp3_;
	g_signal_connect_object (_tmp4_, "media-played", (GCallback) _mpris_player_on_media_played_music_playback_manager_media_played, self, G_CONNECT_AFTER);
	_tmp5_ = music_app_get_player ();
	_tmp6_ = _tmp5_;
	g_signal_connect_object (_tmp6_, "playback-stopped", (GCallback) __mpris_player___lambda178__music_playback_manager_playback_stopped, self, G_CONNECT_AFTER);
	_tmp7_ = music_libraries_manager;
	_tmp8_ = _tmp7_->local_library;
	g_signal_connect_object (_tmp8_, "media-updated", (GCallback) _mpris_player_refresh_current_media_music_library_media_updated, self, G_CONNECT_AFTER);
	_tmp9_ = music_app_get_main_window ();
	_tmp10_ = _tmp9_;
	g_signal_connect_object (_tmp10_, "play-pause-changed", (GCallback) _mpris_player_playing_changed_music_library_window_play_pause_changed, self, G_CONNECT_AFTER);
	_tmp11_ = music_icon_new ("albumart_2");
	_tmp12_ = _tmp11_;
	_tmp13_ = music_icon_get_file (_tmp12_, 16);
	_tmp14_ = _tmp13_;
	_g_object_unref0 (_tmp12_);
	default_image = _tmp14_;
	_tmp16_ = default_image;
	if (_tmp16_ != NULL) {
		GFile* _tmp17_;
		gchar* _tmp18_;
		_tmp17_ = default_image;
		_tmp18_ = g_file_get_uri (_tmp17_);
		_g_free0 (_tmp15_);
		_tmp15_ = _tmp18_;
	} else {
		gchar* _tmp19_;
		_tmp19_ = g_strdup ("");
		_g_free0 (_tmp15_);
		_tmp15_ = _tmp19_;
	}
	_tmp20_ = g_strdup (_tmp15_);
	_g_free0 (self->priv->default_image_url);
	self->priv->default_image_url = _tmp20_;
	mpris_player_refresh_current_media (self);
	_g_free0 (_tmp15_);
	_g_object_unref0 (default_image);
	return obj;
}

static void
mpris_player_class_init (MprisPlayerClass * klass,
                         gpointer klass_data)
{
	mpris_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MprisPlayer_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_mpris_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mpris_player_set_property;
	G_OBJECT_CLASS (klass)->constructor = mpris_player_constructor;
	G_OBJECT_CLASS (klass)->finalize = mpris_player_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CONN_PROPERTY, mpris_player_properties[MPRIS_PLAYER_CONN_PROPERTY] = g_param_spec_object ("conn", "conn", "conn", g_dbus_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_PLAYBACK_STATUS_PROPERTY, mpris_player_properties[MPRIS_PLAYER_PLAYBACK_STATUS_PROPERTY] = g_param_spec_string ("playback-status", "playback-status", "playback-status", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_LOOP_STATUS_PROPERTY, mpris_player_properties[MPRIS_PLAYER_LOOP_STATUS_PROPERTY] = g_param_spec_string ("loop-status", "loop-status", "loop-status", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_RATE_PROPERTY, mpris_player_properties[MPRIS_PLAYER_RATE_PROPERTY] = g_param_spec_double ("rate", "rate", "rate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_SHUFFLE_PROPERTY, mpris_player_properties[MPRIS_PLAYER_SHUFFLE_PROPERTY] = g_param_spec_boolean ("shuffle", "shuffle", "shuffle", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_METADATA_PROPERTY, mpris_player_properties[MPRIS_PLAYER_METADATA_PROPERTY] = g_param_spec_boxed ("metadata", "metadata", "metadata", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_VOLUME_PROPERTY, mpris_player_properties[MPRIS_PLAYER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_POSITION_PROPERTY, mpris_player_properties[MPRIS_PLAYER_POSITION_PROPERTY] = g_param_spec_int64 ("position", "position", "position", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY, mpris_player_properties[MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY] = g_param_spec_boolean ("can-go-next", "can-go-next", "can-go-next", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY, mpris_player_properties[MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY] = g_param_spec_boolean ("can-go-previous", "can-go-previous", "can-go-previous", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_PLAY_PROPERTY, mpris_player_properties[MPRIS_PLAYER_CAN_PLAY_PROPERTY] = g_param_spec_boolean ("can-play", "can-play", "can-play", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_PAUSE_PROPERTY, mpris_player_properties[MPRIS_PLAYER_CAN_PAUSE_PROPERTY] = g_param_spec_boolean ("can-pause", "can-pause", "can-pause", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_SEEK_PROPERTY, mpris_player_properties[MPRIS_PLAYER_CAN_SEEK_PROPERTY] = g_param_spec_boolean ("can-seek", "can-seek", "can-seek", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYER_CAN_CONTROL_PROPERTY, mpris_player_properties[MPRIS_PLAYER_CAN_CONTROL_PROPERTY] = g_param_spec_boolean ("can-control", "can-control", "can-control", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	mpris_player_signals[MPRIS_PLAYER_SEEKED_SIGNAL] = g_signal_new ("seeked", TYPE_MPRIS_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
}

static void
mpris_player_instance_init (MprisPlayer * self,
                            gpointer klass)
{
	self->priv = mpris_player_get_instance_private (self);
	self->priv->send_property_source = (guint) 0;
	self->priv->update_metadata_source = (guint) 0;
	self->priv->changed_properties = NULL;
}

static void
mpris_player_finalize (GObject * obj)
{
	MprisPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MPRIS_PLAYER, MprisPlayer);
	_g_hash_table_unref0 (self->priv->changed_properties);
	_g_hash_table_unref0 (self->priv->_metadata);
	_g_free0 (self->priv->default_image_url);
	G_OBJECT_CLASS (mpris_player_parent_class)->finalize (obj);
}

static GType
mpris_player_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MprisPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisPlayer), 0, (GInstanceInitFunc) mpris_player_instance_init, NULL };
	GType mpris_player_type_id;
	mpris_player_type_id = g_type_register_static (G_TYPE_OBJECT, "MprisPlayer", &g_define_type_info, 0);
	g_type_set_qdata (mpris_player_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_player_register_object);
	MprisPlayer_private_offset = g_type_add_instance_private (mpris_player_type_id, sizeof (MprisPlayerPrivate));
	return mpris_player_type_id;
}

GType
mpris_player_get_type (void)
{
	static volatile gsize mpris_player_type_id__once = 0;
	if (g_once_init_enter (&mpris_player_type_id__once)) {
		GType mpris_player_type_id;
		mpris_player_type_id = mpris_player_get_type_once ();
		g_once_init_leave (&mpris_player_type_id__once, mpris_player_type_id);
	}
	return mpris_player_type_id__once;
}

static void
_vala_mpris_player_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	MprisPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MPRIS_PLAYER, MprisPlayer);
	switch (property_id) {
		case MPRIS_PLAYER_CONN_PROPERTY:
		g_value_set_object (value, mpris_player_get_conn (self));
		break;
		case MPRIS_PLAYER_PLAYBACK_STATUS_PROPERTY:
		g_value_take_string (value, mpris_player_get_playback_status (self));
		break;
		case MPRIS_PLAYER_LOOP_STATUS_PROPERTY:
		g_value_take_string (value, mpris_player_get_loop_status (self));
		break;
		case MPRIS_PLAYER_RATE_PROPERTY:
		g_value_set_double (value, mpris_player_get_rate (self));
		break;
		case MPRIS_PLAYER_SHUFFLE_PROPERTY:
		g_value_set_boolean (value, mpris_player_get_shuffle (self));
		break;
		case MPRIS_PLAYER_METADATA_PROPERTY:
		g_value_take_boxed (value, mpris_player_get_metadata (self));
		break;
		case MPRIS_PLAYER_VOLUME_PROPERTY:
		g_value_set_double (value, mpris_player_get_volume (self));
		break;
		case MPRIS_PLAYER_POSITION_PROPERTY:
		g_value_set_int64 (value, mpris_player_get_position (self));
		break;
		case MPRIS_PLAYER_CAN_GO_NEXT_PROPERTY:
		g_value_set_boolean (value, mpris_player_get_can_go_next (self));
		break;
		case MPRIS_PLAYER_CAN_GO_PREVIOUS_PROPERTY:
		g_value_set_boolean (value, mpris_player_get_can_go_previous (self));
		break;
		case MPRIS_PLAYER_CAN_PLAY_PROPERTY:
		g_value_set_boolean (value, mpris_player_get_can_play (self));
		break;
		case MPRIS_PLAYER_CAN_PAUSE_PROPERTY:
		g_value_set_boolean (value, mpris_player_get_can_pause (self));
		break;
		case MPRIS_PLAYER_CAN_SEEK_PROPERTY:
		g_value_set_boolean (value, mpris_player_get_can_seek (self));
		break;
		case MPRIS_PLAYER_CAN_CONTROL_PROPERTY:
		g_value_set_boolean (value, mpris_player_get_can_control (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_mpris_player_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	MprisPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MPRIS_PLAYER, MprisPlayer);
	switch (property_id) {
		case MPRIS_PLAYER_CONN_PROPERTY:
		mpris_player_set_conn (self, g_value_get_object (value));
		break;
		case MPRIS_PLAYER_LOOP_STATUS_PROPERTY:
		mpris_player_set_loop_status (self, g_value_get_string (value));
		break;
		case MPRIS_PLAYER_RATE_PROPERTY:
		mpris_player_set_rate (self, g_value_get_double (value));
		break;
		case MPRIS_PLAYER_SHUFFLE_PROPERTY:
		mpris_player_set_shuffle (self, g_value_get_boolean (value));
		break;
		case MPRIS_PLAYER_VOLUME_PROPERTY:
		mpris_player_set_volume (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_dbus_mpris_player_next (MprisPlayer* self,
                         GVariant* _parameters_,
                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mpris_player_next (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mpris_player_previous (MprisPlayer* self,
                             GVariant* _parameters_,
                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mpris_player_previous (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mpris_player_pause (MprisPlayer* self,
                          GVariant* _parameters_,
                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mpris_player_pause (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mpris_player_play_pause (MprisPlayer* self,
                               GVariant* _parameters_,
                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mpris_player_play_pause (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mpris_player_stop (MprisPlayer* self,
                         GVariant* _parameters_,
                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mpris_player_stop (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mpris_player_play (MprisPlayer* self,
                         GVariant* _parameters_,
                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mpris_player_play (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mpris_player_seek (MprisPlayer* self,
                         GVariant* _parameters_,
                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint64 offset = 0LL;
	GVariant* _tmp15_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	offset = g_variant_get_int64 (_tmp15_);
	g_variant_unref (_tmp15_);
	mpris_player_seek (self, offset, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mpris_player_set_position (MprisPlayer* self,
                                 GVariant* _parameters_,
                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* dobj = NULL;
	GVariant* _tmp16_;
	gint64 position = 0LL;
	GVariant* _tmp17_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp16_ = g_variant_iter_next_value (&_arguments_iter);
	dobj = g_variant_dup_string (_tmp16_, NULL);
	g_variant_unref (_tmp16_);
	_tmp17_ = g_variant_iter_next_value (&_arguments_iter);
	position = g_variant_get_int64 (_tmp17_);
	g_variant_unref (_tmp17_);
	mpris_player_set_position (self, dobj, position, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (dobj);
	;
}

static void
_dbus_mpris_player_open_uri (MprisPlayer* self,
                             GVariant* _parameters_,
                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp18_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp18_, NULL);
	g_variant_unref (_tmp18_);
	mpris_player_open_uri (self, uri, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (uri);
	;
}

static void
mpris_player_dbus_interface_method_call (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* method_name,
                                         GVariant* parameters,
                                         GDBusMethodInvocation* invocation,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Next") == 0) {
		_dbus_mpris_player_next (object, parameters, invocation);
	} else if (strcmp (method_name, "Previous") == 0) {
		_dbus_mpris_player_previous (object, parameters, invocation);
	} else if (strcmp (method_name, "Pause") == 0) {
		_dbus_mpris_player_pause (object, parameters, invocation);
	} else if (strcmp (method_name, "PlayPause") == 0) {
		_dbus_mpris_player_play_pause (object, parameters, invocation);
	} else if (strcmp (method_name, "Stop") == 0) {
		_dbus_mpris_player_stop (object, parameters, invocation);
	} else if (strcmp (method_name, "Play") == 0) {
		_dbus_mpris_player_play (object, parameters, invocation);
	} else if (strcmp (method_name, "Seek") == 0) {
		_dbus_mpris_player_seek (object, parameters, invocation);
	} else if (strcmp (method_name, "SetPosition") == 0) {
		_dbus_mpris_player_set_position (object, parameters, invocation);
	} else if (strcmp (method_name, "OpenUri") == 0) {
		_dbus_mpris_player_open_uri (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_mpris_player_get_playback_status (MprisPlayer* self)
{
	gchar* result;
	GVariant* _reply;
	result = mpris_player_get_playback_status (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_loop_status (MprisPlayer* self)
{
	gchar* result;
	GVariant* _reply;
	result = mpris_player_get_loop_status (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_rate (MprisPlayer* self)
{
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_shuffle (MprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_shuffle (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_metadata (MprisPlayer* self)
{
	GHashTable* result;
	GVariant* _reply;
	GVariantBuilder _tmp19_;
	GHashTableIter _tmp20_;
	gpointer _tmp21_;
	gpointer _tmp22_;
	result = mpris_player_get_metadata (self);
	g_hash_table_iter_init (&_tmp20_, result);
	g_variant_builder_init (&_tmp19_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp20_, &_tmp21_, &_tmp22_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp21_;
		_value = (GVariant*) _tmp22_;
		g_variant_builder_add (&_tmp19_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	_reply = g_variant_builder_end (&_tmp19_);
	_g_hash_table_unref0 (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_volume (MprisPlayer* self)
{
	gdouble result;
	GVariant* _reply;
	result = mpris_player_get_volume (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_position (MprisPlayer* self)
{
	gint64 result;
	GVariant* _reply;
	result = mpris_player_get_position (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_can_go_next (MprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_can_go_next (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_can_go_previous (MprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_can_go_previous (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_can_play (MprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_can_play (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_can_pause (MprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_can_pause (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_can_seek (MprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_can_seek (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_mpris_player_get_can_control (MprisPlayer* self)
{
	gboolean result;
	GVariant* _reply;
	result = mpris_player_get_can_control (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
mpris_player_dbus_interface_get_property (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* property_name,
                                          GError** error,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		return _dbus_mpris_player_get_playback_status (object);
	} else if (strcmp (property_name, "LoopStatus") == 0) {
		return _dbus_mpris_player_get_loop_status (object);
	} else if (strcmp (property_name, "Rate") == 0) {
		return _dbus_mpris_player_get_rate (object);
	} else if (strcmp (property_name, "Shuffle") == 0) {
		return _dbus_mpris_player_get_shuffle (object);
	} else if (strcmp (property_name, "Metadata") == 0) {
		return _dbus_mpris_player_get_metadata (object);
	} else if (strcmp (property_name, "Volume") == 0) {
		return _dbus_mpris_player_get_volume (object);
	} else if (strcmp (property_name, "Position") == 0) {
		return _dbus_mpris_player_get_position (object);
	} else if (strcmp (property_name, "CanGoNext") == 0) {
		return _dbus_mpris_player_get_can_go_next (object);
	} else if (strcmp (property_name, "CanGoPrevious") == 0) {
		return _dbus_mpris_player_get_can_go_previous (object);
	} else if (strcmp (property_name, "CanPlay") == 0) {
		return _dbus_mpris_player_get_can_play (object);
	} else if (strcmp (property_name, "CanPause") == 0) {
		return _dbus_mpris_player_get_can_pause (object);
	} else if (strcmp (property_name, "CanSeek") == 0) {
		return _dbus_mpris_player_get_can_seek (object);
	} else if (strcmp (property_name, "CanControl") == 0) {
		return _dbus_mpris_player_get_can_control (object);
	}
	return NULL;
}

static void
_dbus_mpris_player_set_loop_status (MprisPlayer* self,
                                    GVariant* _value)
{
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	mpris_player_set_loop_status (self, value);
	_g_free0 (value);
}

static void
_dbus_mpris_player_set_rate (MprisPlayer* self,
                             GVariant* _value)
{
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	mpris_player_set_rate (self, value);
}

static void
_dbus_mpris_player_set_shuffle (MprisPlayer* self,
                                GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	mpris_player_set_shuffle (self, value);
}

static void
_dbus_mpris_player_set_volume (MprisPlayer* self,
                               GVariant* _value)
{
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	mpris_player_set_volume (self, value);
}

static gboolean
mpris_player_dbus_interface_set_property (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* property_name,
                                          GVariant* value,
                                          GError** error,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "LoopStatus") == 0) {
		_dbus_mpris_player_set_loop_status (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Rate") == 0) {
		_dbus_mpris_player_set_rate (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Shuffle") == 0) {
		_dbus_mpris_player_set_shuffle (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Volume") == 0) {
		_dbus_mpris_player_set_volume (object, value);
		return TRUE;
	}
	return FALSE;
}

static void
_dbus_mpris_player_seeked (GObject* _sender,
                           gint64 position,
                           gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int64 (position));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.mpris.MediaPlayer2.Player", "Seeked", _arguments, NULL);
}

guint
mpris_player_register_object (gpointer object,
                              GDBusConnection* connection,
                              const gchar* path,
                              GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_player_dbus_interface_info), &_mpris_player_dbus_interface_vtable, data, _mpris_player_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "seeked", (GCallback) _dbus_mpris_player_seeked, data);
	return result;
}

static void
_mpris_player_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_mpris_player_seeked, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
mpris_playlists_get_instance_private (MprisPlaylists* self)
{
	return G_STRUCT_MEMBER_P (self, MprisPlaylists_private_offset);
}

MprisPlaylists*
mpris_playlists_construct (GType object_type,
                           GDBusConnection* conn)
{
	MprisPlaylists * self = NULL;
	g_return_val_if_fail (conn != NULL, NULL);
	self = (MprisPlaylists*) g_object_new (object_type, "conn", conn, NULL);
	return self;
}

MprisPlaylists*
mpris_playlists_new (GDBusConnection* conn)
{
	return mpris_playlists_construct (TYPE_MPRIS_PLAYLISTS, conn);
}

static GVariant*
_variant_new26 (guint value)
{
	return g_variant_ref_sink (g_variant_new_uint32 (value));
}

static void
mpris_playlists_playlist_added (MprisPlaylists* self,
                                MusicPlaylist* p)
{
	GVariant* variant = NULL;
	guint _tmp0_;
	guint _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = mpris_playlists_get_playlist_count (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _variant_new26 (_tmp1_);
	variant = _tmp2_;
	mpris_playlists_queue_property_for_notification (self, "PlaylistCount", variant);
	_g_variant_unref0 (variant);
}

static GVariant*
_variant_new27 (guint value)
{
	return g_variant_ref_sink (g_variant_new_uint32 (value));
}

static void
mpris_playlists_playlist_removed (MprisPlaylists* self,
                                  MusicPlaylist* p)
{
	GVariant* variant = NULL;
	guint _tmp0_;
	guint _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = mpris_playlists_get_playlist_count (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _variant_new27 (_tmp1_);
	variant = _tmp2_;
	mpris_playlists_queue_property_for_notification (self, "PlaylistCount", variant);
	_g_variant_unref0 (variant);
}

static gboolean
_mpris_playlists_send_property_change_gsource_func (gpointer self)
{
	gboolean result;
	result = mpris_playlists_send_property_change ((MprisPlaylists*) self);
	return result;
}

static void
mpris_playlists_queue_property_for_notification (MprisPlaylists* self,
                                                 const gchar* property,
                                                 GVariant* val)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	GVariant* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (property != NULL);
	g_return_if_fail (val != NULL);
	_tmp0_ = self->priv->changed_properties;
	if (_tmp0_ == NULL) {
		GHashFunc _tmp1_;
		GEqualFunc _tmp2_;
		GHashTable* _tmp3_;
		_tmp1_ = g_str_hash;
		_tmp2_ = g_str_equal;
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_variant_unref0_);
		_g_hash_table_unref0 (self->priv->changed_properties);
		self->priv->changed_properties = _tmp3_;
	}
	_tmp4_ = self->priv->changed_properties;
	_tmp5_ = g_strdup (property);
	_tmp6_ = _g_variant_ref0 (val);
	g_hash_table_insert (_tmp4_, _tmp5_, _tmp6_);
	if (self->priv->send_property_source == ((guint) 0)) {
		self->priv->send_property_source = g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _mpris_playlists_send_property_change_gsource_func, g_object_ref (self), g_object_unref);
	}
}

static gboolean
mpris_playlists_send_property_change (MprisPlaylists* self)
{
	GHashTable* _tmp0_;
	GVariantBuilder* builder = NULL;
	const GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* invalidated_builder = NULL;
	GVariantType* _tmp3_;
	GVariantType* _tmp4_;
	GVariantBuilder* _tmp5_;
	GVariantBuilder* _tmp6_;
	GHashTable* _tmp7_;
	GList* _tmp8_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->changed_properties;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = G_VARIANT_TYPE_ARRAY;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	builder = _tmp2_;
	_tmp3_ = g_variant_type_new ("as");
	_tmp4_ = _tmp3_;
	_tmp5_ = g_variant_builder_new (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_variant_type_free0 (_tmp4_);
	invalidated_builder = _tmp6_;
	_tmp7_ = self->priv->changed_properties;
	_tmp8_ = g_hash_table_get_keys (_tmp7_);
	{
		GList* name_collection = NULL;
		GList* name_it = NULL;
		name_collection = _tmp8_;
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
			gchar* _tmp9_;
			gchar* name = NULL;
			_tmp9_ = g_strdup ((const gchar*) name_it->data);
			name = _tmp9_;
			{
				GVariant* variant = NULL;
				GHashTable* _tmp10_;
				const gchar* _tmp11_;
				gconstpointer _tmp12_;
				GVariant* _tmp13_;
				GVariantBuilder* _tmp14_;
				const gchar* _tmp15_;
				GVariant* _tmp16_;
				_tmp10_ = self->priv->changed_properties;
				_tmp11_ = name;
				_tmp12_ = g_hash_table_lookup (_tmp10_, _tmp11_);
				_tmp13_ = _g_variant_ref0 ((GVariant*) _tmp12_);
				variant = _tmp13_;
				_tmp14_ = builder;
				_tmp15_ = name;
				_tmp16_ = variant;
				g_variant_builder_add (_tmp14_, "{sv}", _tmp15_, _tmp16_, NULL);
				_g_variant_unref0 (variant);
				_g_free0 (name);
			}
		}
		(name_collection == NULL) ? NULL : (name_collection = (g_list_free (name_collection), NULL));
	}
	_g_hash_table_unref0 (self->priv->changed_properties);
	self->priv->changed_properties = NULL;
	{
		GDBusConnection* _tmp17_;
		GVariantBuilder* _tmp18_;
		GVariantBuilder* _tmp19_;
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		_tmp17_ = self->priv->_conn;
		_tmp18_ = builder;
		_tmp19_ = invalidated_builder;
		_tmp20_ = g_variant_new ("(sa{sv}as)", MPRIS_PLAYLISTS_INTERFACE_NAME, _tmp18_, _tmp19_, NULL);
		g_variant_ref_sink (_tmp20_);
		_tmp21_ = _tmp20_;
		g_dbus_connection_emit_signal (_tmp17_, NULL, "/org/mpris/MediaPlayer2", "org.freedesktop.DBus.Properties", "PropertiesChanged", _tmp21_, &_inner_error0_);
		_g_variant_unref0 (_tmp21_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		g_message ("MPRIS.vala:539: Sent properties changed signal\n");
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp22_;
		const gchar* _tmp23_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->message;
		g_print ("Could not send MPRIS property change: %s\n", _tmp23_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp24_ = FALSE;
		_g_variant_builder_unref0 (invalidated_builder);
		_g_variant_builder_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp24_;
	}
	self->priv->send_property_source = (guint) 0;
	result = FALSE;
	_g_variant_builder_unref0 (invalidated_builder);
	_g_variant_builder_unref0 (builder);
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

void
mpris_playlists_activate_playlist (MprisPlaylists* self,
                                   const char* path,
                                   GError** error)
{
	gchar* playlist_id = NULL;
	gchar* _tmp0_;
	MusicPlaylist* p = NULL;
	MusicLibrariesManager* _tmp1_;
	MusicLibrary* _tmp2_;
	const gchar* _tmp3_;
	MusicStaticPlaylist* _tmp4_;
	MusicPlaylist* _tmp5_;
	MusicPlaylist* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = string_replace ((const gchar*) path, "/io/elementary/music/Playlists/", "");
	playlist_id = _tmp0_;
	_tmp1_ = music_libraries_manager;
	_tmp2_ = _tmp1_->local_library;
	_tmp3_ = playlist_id;
	_tmp4_ = music_library_playlist_from_id (_tmp2_, (gint64) atoi (_tmp3_));
	p = (MusicPlaylist*) _tmp4_;
	_tmp5_ = p;
	if (_tmp5_ == NULL) {
		g_warning ("MPRIS.vala:554: Selected playlist had invalid path %s and could not be" \
" found", (const gchar*) path);
		_g_object_unref0 (p);
		_g_free0 (playlist_id);
		return;
	}
	_tmp6_ = p;
	g_signal_emit_by_name (_tmp6_, "request-play");
	_g_object_unref0 (p);
	_g_free0 (playlist_id);
}

MprisPlaylistsMprisPlaylist**
mpris_playlists_get_playlists (MprisPlaylists* self,
                               guint index,
                               guint maxcount,
                               const gchar* playlist_ordering,
                               gboolean reversed,
                               gint* result_length1,
                               GError** error)
{
	GeeLinkedList* playlists = NULL;
	GeeLinkedList* _tmp0_;
	gint i = 0;
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp14_;
	GeeLinkedList* _tmp42_;
	gint _tmp43_ = 0;
	gpointer* _tmp44_;
	MprisPlaylistsMprisPlaylist** _tmp45_;
	gint _tmp45__length1;
	MprisPlaylistsMprisPlaylist** result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (playlist_ordering != NULL, NULL);
	g_debug ("MPRIS.vala:561: Get Playlist called with index %u and maxcount %u\n", index, maxcount);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	playlists = _tmp0_;
	{
		GeeIterator* _p_it = NULL;
		MusicLibrariesManager* _tmp1_;
		MusicLibrary* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
		_tmp1_ = music_libraries_manager;
		_tmp2_ = _tmp1_->local_library;
		_tmp3_ = music_library_get_playlists (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp4_);
		_p_it = _tmp6_;
		while (TRUE) {
			GeeIterator* _tmp7_;
			MusicStaticPlaylist* p = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			_tmp7_ = _p_it;
			if (!gee_iterator_next (_tmp7_)) {
				break;
			}
			_tmp8_ = _p_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			p = (MusicStaticPlaylist*) _tmp9_;
			if (reversed) {
				GeeLinkedList* _tmp10_;
				MusicStaticPlaylist* _tmp11_;
				_tmp10_ = playlists;
				_tmp11_ = p;
				gee_deque_offer_tail ((GeeDeque*) _tmp10_, (MusicPlaylist*) _tmp11_);
			} else {
				GeeLinkedList* _tmp12_;
				MusicStaticPlaylist* _tmp13_;
				_tmp12_ = playlists;
				_tmp13_ = p;
				gee_deque_offer_head ((GeeDeque*) _tmp12_, (MusicPlaylist*) _tmp13_);
			}
			_g_object_unref0 (p);
		}
		_g_object_unref0 (_p_it);
	}
	i = 0;
	_tmp14_ = gee_linked_list_new (MPRIS_PLAYLISTS_TYPE_MPRIS_PLAYLIST, (GBoxedCopyFunc) mpris_playlists_mpris_playlist_dup, (GDestroyNotify) mpris_playlists_mpris_playlist_free, NULL, NULL, NULL);
	rv = _tmp14_;
	{
		GeeLinkedList* _p_list = NULL;
		GeeLinkedList* _tmp15_;
		gint _p_size = 0;
		GeeLinkedList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _p_index = 0;
		_tmp15_ = playlists;
		_p_list = _tmp15_;
		_tmp16_ = _p_list;
		_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
		_tmp18_ = _tmp17_;
		_p_size = _tmp18_;
		_p_index = -1;
		while (TRUE) {
			gint _tmp19_;
			gint _tmp20_;
			MusicPlaylist* p = NULL;
			GeeLinkedList* _tmp21_;
			gpointer _tmp22_;
			char* path = NULL;
			MusicPlaylist* _tmp23_;
			gint64 _tmp24_;
			gint64 _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			char* _tmp28_;
			char* _tmp29_;
			MprisPlaylistsMprisPlaylist to_add = {0};
			const char* _tmp30_;
			char* _tmp31_;
			MusicPlaylist* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			gchar* _tmp35_;
			GeeLinkedList* _tmp36_;
			MprisPlaylistsMprisPlaylist _tmp37_;
			const char* _tmp38_;
			MusicPlaylist* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			_p_index = _p_index + 1;
			_tmp19_ = _p_index;
			_tmp20_ = _p_size;
			if (!(_tmp19_ < _tmp20_)) {
				break;
			}
			_tmp21_ = _p_list;
			_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp21_, _p_index);
			p = (MusicPlaylist*) _tmp22_;
			_tmp23_ = p;
			_tmp24_ = music_playlist_get_rowid (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_strdup_printf (MPRIS_PLAYLISTS_PLAYLIST_ID, _tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_strdup (_tmp27_);
			_tmp29_ = _tmp28_;
			_g_free0 (_tmp27_);
			path = _tmp29_;
			memset (&to_add, 0, sizeof (MprisPlaylistsMprisPlaylist));
			_tmp30_ = path;
			_tmp31_ = g_strdup (_tmp30_);
			_g_free0 (to_add.id);
			to_add.id = _tmp31_;
			_tmp32_ = p;
			_tmp33_ = music_playlist_get_name (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = g_strdup (_tmp34_);
			_g_free0 (to_add.name);
			to_add.name = _tmp35_;
			_tmp36_ = rv;
			_tmp37_ = to_add;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, &_tmp37_);
			_tmp38_ = path;
			_tmp39_ = p;
			_tmp40_ = music_playlist_get_name (_tmp39_);
			_tmp41_ = _tmp40_;
			g_debug ("MPRIS.vala:582: Added playlist %s %s\n", (const gchar*) _tmp38_, _tmp41_);
			if (((guint) i) >= maxcount) {
				mpris_playlists_mpris_playlist_destroy (&to_add);
				_g_free0 (path);
				_g_object_unref0 (p);
				break;
			}
			mpris_playlists_mpris_playlist_destroy (&to_add);
			_g_free0 (path);
			_g_object_unref0 (p);
		}
	}
	_tmp42_ = rv;
	_tmp44_ = gee_collection_to_array ((GeeCollection*) _tmp42_, &_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp45__length1 = _tmp43_;
	if (result_length1) {
		*result_length1 = _tmp45__length1;
	}
	result = _tmp45_;
	_g_object_unref0 (rv);
	_g_object_unref0 (playlists);
	return result;
}

GDBusConnection*
mpris_playlists_get_conn (MprisPlaylists* self)
{
	GDBusConnection* result;
	GDBusConnection* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_conn;
	result = _tmp0_;
	return result;
}

void
mpris_playlists_set_conn (MprisPlaylists* self,
                          GDBusConnection* value)
{
	GDBusConnection* old_value;
	g_return_if_fail (self != NULL);
	old_value = mpris_playlists_get_conn (self);
	if (old_value != value) {
		self->priv->_conn = value;
		g_object_notify_by_pspec ((GObject *) self, mpris_playlists_properties[MPRIS_PLAYLISTS_CONN_PROPERTY]);
	}
}

guint
mpris_playlists_get_playlist_count (MprisPlaylists* self)
{
	guint result;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	MusicLibrariesManager* _tmp6_;
	MusicLibrary* _tmp7_;
	GeeCollection* _tmp8_;
	GeeCollection* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	guint _tmp12_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	_tmp2_ = music_library_get_playlists (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_get_size (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = music_libraries_manager;
	_tmp7_ = _tmp6_->local_library;
	_tmp8_ = music_library_get_smart_playlists (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = gee_collection_get_size (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = (guint) (_tmp5_ + _tmp11_);
	_g_object_unref0 (_tmp9_);
	_g_object_unref0 (_tmp3_);
	result = _tmp12_;
	return result;
}

gchar**
mpris_playlists_get_orderings (MprisPlaylists* self,
                               gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = mpris_playlists_all_orderings;
	_tmp0__length1 = mpris_playlists_all_orderings_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

void
mpris_playlists_get_active_playlist (MprisPlaylists* self,
                                     MprisPlaylistsMaybePlaylist * result)
{
	MusicPlaylist* p = NULL;
	MprisPlaylistsMaybePlaylist active_playlist = {0};
	MusicPlaylist* _tmp0_;
	g_return_if_fail (self != NULL);
	p = NULL;
	memset (&active_playlist, 0, sizeof (MprisPlaylistsMaybePlaylist));
	_tmp0_ = p;
	if (_tmp0_ == NULL) {
		MprisPlaylistsMprisPlaylist mpris_p = {0};
		gchar* _tmp1_;
		gchar* _tmp2_;
		char* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		MprisPlaylistsMprisPlaylist _tmp6_;
		MprisPlaylistsMprisPlaylist _tmp7_;
		MprisPlaylistsMprisPlaylist _tmp8_ = {0};
		active_playlist.valid = TRUE;
		memset (&mpris_p, 0, sizeof (MprisPlaylistsMprisPlaylist));
		_tmp1_ = g_strdup_printf (MPRIS_PLAYLISTS_PLAYLIST_ID, 0);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (mpris_p.id);
		mpris_p.id = _tmp3_;
		_g_free0 (_tmp2_);
		_tmp4_ = g_strdup (_ ("Playlists"));
		_g_free0 (mpris_p.name);
		mpris_p.name = _tmp4_;
		_tmp5_ = g_strdup ("");
		_g_free0 (mpris_p.icon);
		mpris_p.icon = _tmp5_;
		_tmp6_ = mpris_p;
		_tmp7_ = _tmp6_;
		mpris_playlists_mpris_playlist_copy (&_tmp7_, &_tmp8_);
		mpris_playlists_mpris_playlist_destroy (&active_playlist.playlist);
		active_playlist.playlist = _tmp8_;
		mpris_playlists_mpris_playlist_destroy (&mpris_p);
	} else {
		MprisPlaylistsMprisPlaylist mpris_p = {0};
		MusicPlaylist* _tmp9_;
		gint64 _tmp10_;
		gint64 _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		char* _tmp14_;
		MusicPlaylist* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		MprisPlaylistsMprisPlaylist _tmp19_;
		MprisPlaylistsMprisPlaylist _tmp20_;
		MprisPlaylistsMprisPlaylist _tmp21_ = {0};
		active_playlist.valid = TRUE;
		memset (&mpris_p, 0, sizeof (MprisPlaylistsMprisPlaylist));
		_tmp9_ = p;
		_tmp10_ = music_playlist_get_rowid (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strdup_printf (MPRIS_PLAYLISTS_PLAYLIST_ID, _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (mpris_p.id);
		mpris_p.id = _tmp14_;
		_g_free0 (_tmp13_);
		_tmp15_ = p;
		_tmp16_ = music_playlist_get_name (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strdup (_tmp17_);
		_g_free0 (mpris_p.name);
		mpris_p.name = _tmp18_;
		_tmp19_ = mpris_p;
		_tmp20_ = _tmp19_;
		mpris_playlists_mpris_playlist_copy (&_tmp20_, &_tmp21_);
		mpris_playlists_mpris_playlist_destroy (&active_playlist.playlist);
		active_playlist.playlist = _tmp21_;
		mpris_playlists_mpris_playlist_destroy (&mpris_p);
	}
	*result = active_playlist;
	_g_object_unref0 (p);
	return;
}

void
mpris_playlists_mpris_playlist_copy (const MprisPlaylistsMprisPlaylist* self,
                                     MprisPlaylistsMprisPlaylist* dest)
{
	const char* _tmp0_;
	char* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	_tmp0_ = (*self).id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).id);
	(*dest).id = _tmp1_;
	_tmp2_ = (*self).name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp3_;
	_tmp4_ = (*self).icon;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).icon);
	(*dest).icon = _tmp5_;
}

void
mpris_playlists_mpris_playlist_destroy (MprisPlaylistsMprisPlaylist* self)
{
	_g_free0 ((*self).id);
	_g_free0 ((*self).name);
	_g_free0 ((*self).icon);
}

MprisPlaylistsMprisPlaylist*
mpris_playlists_mpris_playlist_dup (const MprisPlaylistsMprisPlaylist* self)
{
	MprisPlaylistsMprisPlaylist* dup;
	dup = g_new0 (MprisPlaylistsMprisPlaylist, 1);
	mpris_playlists_mpris_playlist_copy (self, dup);
	return dup;
}

void
mpris_playlists_mpris_playlist_free (MprisPlaylistsMprisPlaylist* self)
{
	mpris_playlists_mpris_playlist_destroy (self);
	g_free (self);
}

static GType
mpris_playlists_mpris_playlist_get_type_once (void)
{
	GType mpris_playlists_mpris_playlist_type_id;
	mpris_playlists_mpris_playlist_type_id = g_boxed_type_register_static ("MprisPlaylistsMprisPlaylist", (GBoxedCopyFunc) mpris_playlists_mpris_playlist_dup, (GBoxedFreeFunc) mpris_playlists_mpris_playlist_free);
	return mpris_playlists_mpris_playlist_type_id;
}

GType
mpris_playlists_mpris_playlist_get_type (void)
{
	static volatile gsize mpris_playlists_mpris_playlist_type_id__once = 0;
	if (g_once_init_enter (&mpris_playlists_mpris_playlist_type_id__once)) {
		GType mpris_playlists_mpris_playlist_type_id;
		mpris_playlists_mpris_playlist_type_id = mpris_playlists_mpris_playlist_get_type_once ();
		g_once_init_leave (&mpris_playlists_mpris_playlist_type_id__once, mpris_playlists_mpris_playlist_type_id);
	}
	return mpris_playlists_mpris_playlist_type_id__once;
}

void
mpris_playlists_maybe_playlist_copy (const MprisPlaylistsMaybePlaylist* self,
                                     MprisPlaylistsMaybePlaylist* dest)
{
	MprisPlaylistsMprisPlaylist _tmp0_;
	MprisPlaylistsMprisPlaylist _tmp1_;
	MprisPlaylistsMprisPlaylist _tmp2_ = {0};
	(*dest).valid = (*self).valid;
	_tmp0_ = (*self).playlist;
	_tmp1_ = _tmp0_;
	mpris_playlists_mpris_playlist_copy (&_tmp1_, &_tmp2_);
	mpris_playlists_mpris_playlist_destroy (&(*dest).playlist);
	(*dest).playlist = _tmp2_;
}

void
mpris_playlists_maybe_playlist_destroy (MprisPlaylistsMaybePlaylist* self)
{
	mpris_playlists_mpris_playlist_destroy (&(*self).playlist);
}

MprisPlaylistsMaybePlaylist*
mpris_playlists_maybe_playlist_dup (const MprisPlaylistsMaybePlaylist* self)
{
	MprisPlaylistsMaybePlaylist* dup;
	dup = g_new0 (MprisPlaylistsMaybePlaylist, 1);
	mpris_playlists_maybe_playlist_copy (self, dup);
	return dup;
}

void
mpris_playlists_maybe_playlist_free (MprisPlaylistsMaybePlaylist* self)
{
	mpris_playlists_maybe_playlist_destroy (self);
	g_free (self);
}

static GType
mpris_playlists_maybe_playlist_get_type_once (void)
{
	GType mpris_playlists_maybe_playlist_type_id;
	mpris_playlists_maybe_playlist_type_id = g_boxed_type_register_static ("MprisPlaylistsMaybePlaylist", (GBoxedCopyFunc) mpris_playlists_maybe_playlist_dup, (GBoxedFreeFunc) mpris_playlists_maybe_playlist_free);
	return mpris_playlists_maybe_playlist_type_id;
}

GType
mpris_playlists_maybe_playlist_get_type (void)
{
	static volatile gsize mpris_playlists_maybe_playlist_type_id__once = 0;
	if (g_once_init_enter (&mpris_playlists_maybe_playlist_type_id__once)) {
		GType mpris_playlists_maybe_playlist_type_id;
		mpris_playlists_maybe_playlist_type_id = mpris_playlists_maybe_playlist_get_type_once ();
		g_once_init_leave (&mpris_playlists_maybe_playlist_type_id__once, mpris_playlists_maybe_playlist_type_id);
	}
	return mpris_playlists_maybe_playlist_type_id__once;
}

static void
_mpris_playlists_playlist_added_music_library_playlist_added (MusicLibrary* _sender,
                                                              MusicStaticPlaylist* playlist,
                                                              gpointer self)
{
	mpris_playlists_playlist_added ((MprisPlaylists*) self, playlist);
}

static void
_mpris_playlists_playlist_removed_music_library_playlist_removed (MusicLibrary* _sender,
                                                                  MusicStaticPlaylist* playlist,
                                                                  gpointer self)
{
	mpris_playlists_playlist_removed ((MprisPlaylists*) self, playlist);
}

static GObject *
mpris_playlists_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MprisPlaylists * self;
	MusicLibrariesManager* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrariesManager* _tmp2_;
	MusicLibrary* _tmp3_;
	parent_class = G_OBJECT_CLASS (mpris_playlists_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MPRIS_PLAYLISTS, MprisPlaylists);
	_tmp0_ = music_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	g_signal_connect_object (_tmp1_, "playlist-added", (GCallback) _mpris_playlists_playlist_added_music_library_playlist_added, self, 0);
	_tmp2_ = music_libraries_manager;
	_tmp3_ = _tmp2_->local_library;
	g_signal_connect_object (_tmp3_, "playlist-removed", (GCallback) _mpris_playlists_playlist_removed_music_library_playlist_removed, self, 0);
	return obj;
}

static void
mpris_playlists_class_init (MprisPlaylistsClass * klass,
                            gpointer klass_data)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	mpris_playlists_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MprisPlaylists_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_mpris_playlists_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mpris_playlists_set_property;
	G_OBJECT_CLASS (klass)->constructor = mpris_playlists_constructor;
	G_OBJECT_CLASS (klass)->finalize = mpris_playlists_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYLISTS_CONN_PROPERTY, mpris_playlists_properties[MPRIS_PLAYLISTS_CONN_PROPERTY] = g_param_spec_object ("conn", "conn", "conn", g_dbus_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYLISTS_PLAYLIST_COUNT_PROPERTY, mpris_playlists_properties[MPRIS_PLAYLISTS_PLAYLIST_COUNT_PROPERTY] = g_param_spec_uint ("playlist-count", "playlist-count", "playlist-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYLISTS_ORDERINGS_PROPERTY, mpris_playlists_properties[MPRIS_PLAYLISTS_ORDERINGS_PROPERTY] = g_param_spec_boxed ("orderings", "orderings", "orderings", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MPRIS_PLAYLISTS_ACTIVE_PLAYLIST_PROPERTY, mpris_playlists_properties[MPRIS_PLAYLISTS_ACTIVE_PLAYLIST_PROPERTY] = g_param_spec_boxed ("active-playlist", "active-playlist", "active-playlist", MPRIS_PLAYLISTS_TYPE_MAYBE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	mpris_playlists_signals[MPRIS_PLAYLISTS_PLAYLIST_CHANGED_SIGNAL] = g_signal_new ("playlist-changed", TYPE_MPRIS_PLAYLISTS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VARIANT, G_TYPE_NONE, 1, G_TYPE_VARIANT);
	_tmp0_ = g_strdup ("UserDefined");
	_tmp1_ = g_new0 (gchar*, 1 + 1);
	_tmp1_[0] = _tmp0_;
	mpris_playlists_all_orderings = _tmp1_;
	mpris_playlists_all_orderings_length1 = 1;
}

static void
mpris_playlists_instance_init (MprisPlaylists * self,
                               gpointer klass)
{
	self->priv = mpris_playlists_get_instance_private (self);
	self->priv->send_property_source = (guint) 0;
	self->priv->changed_properties = NULL;
}

static void
mpris_playlists_finalize (GObject * obj)
{
	MprisPlaylists * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MPRIS_PLAYLISTS, MprisPlaylists);
	_g_hash_table_unref0 (self->priv->changed_properties);
	G_OBJECT_CLASS (mpris_playlists_parent_class)->finalize (obj);
}

static GType
mpris_playlists_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MprisPlaylistsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_playlists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisPlaylists), 0, (GInstanceInitFunc) mpris_playlists_instance_init, NULL };
	GType mpris_playlists_type_id;
	mpris_playlists_type_id = g_type_register_static (G_TYPE_OBJECT, "MprisPlaylists", &g_define_type_info, 0);
	g_type_set_qdata (mpris_playlists_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_playlists_register_object);
	MprisPlaylists_private_offset = g_type_add_instance_private (mpris_playlists_type_id, sizeof (MprisPlaylistsPrivate));
	return mpris_playlists_type_id;
}

GType
mpris_playlists_get_type (void)
{
	static volatile gsize mpris_playlists_type_id__once = 0;
	if (g_once_init_enter (&mpris_playlists_type_id__once)) {
		GType mpris_playlists_type_id;
		mpris_playlists_type_id = mpris_playlists_get_type_once ();
		g_once_init_leave (&mpris_playlists_type_id__once, mpris_playlists_type_id);
	}
	return mpris_playlists_type_id__once;
}

static void
_vala_mpris_playlists_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	MprisPlaylists * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MPRIS_PLAYLISTS, MprisPlaylists);
	switch (property_id) {
		case MPRIS_PLAYLISTS_CONN_PROPERTY:
		g_value_set_object (value, mpris_playlists_get_conn (self));
		break;
		case MPRIS_PLAYLISTS_PLAYLIST_COUNT_PROPERTY:
		g_value_set_uint (value, mpris_playlists_get_playlist_count (self));
		break;
		case MPRIS_PLAYLISTS_ORDERINGS_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, mpris_playlists_get_orderings (self, &length));
		}
		break;
		case MPRIS_PLAYLISTS_ACTIVE_PLAYLIST_PROPERTY:
		{
			MprisPlaylistsMaybePlaylist boxed;
			mpris_playlists_get_active_playlist (self, &boxed);
			g_value_set_boxed (value, &boxed);
			mpris_playlists_maybe_playlist_destroy (&boxed);
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_mpris_playlists_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	MprisPlaylists * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MPRIS_PLAYLISTS, MprisPlaylists);
	switch (property_id) {
		case MPRIS_PLAYLISTS_CONN_PROPERTY:
		mpris_playlists_set_conn (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_dbus_mpris_playlists_activate_playlist (MprisPlaylists* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* path = NULL;
	GVariant* _tmp23_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp23_ = g_variant_iter_next_value (&_arguments_iter);
	path = g_variant_dup_string (_tmp23_, NULL);
	g_variant_unref (_tmp23_);
	mpris_playlists_activate_playlist (self, path, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (path);
	;
}

static void
_dbus_mpris_playlists_get_playlists (MprisPlaylists* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint index = 0U;
	GVariant* _tmp24_;
	guint maxcount = 0U;
	GVariant* _tmp25_;
	gchar* playlist_ordering = NULL;
	GVariant* _tmp26_;
	gboolean reversed = FALSE;
	GVariant* _tmp27_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	MprisPlaylistsMprisPlaylist** result;
	gint result_length1 = 0;
	MprisPlaylistsMprisPlaylist** _tmp28_;
	GVariantBuilder _tmp29_;
	gint _tmp30_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp24_ = g_variant_iter_next_value (&_arguments_iter);
	index = g_variant_get_uint32 (_tmp24_);
	g_variant_unref (_tmp24_);
	_tmp25_ = g_variant_iter_next_value (&_arguments_iter);
	maxcount = g_variant_get_uint32 (_tmp25_);
	g_variant_unref (_tmp25_);
	_tmp26_ = g_variant_iter_next_value (&_arguments_iter);
	playlist_ordering = g_variant_dup_string (_tmp26_, NULL);
	g_variant_unref (_tmp26_);
	_tmp27_ = g_variant_iter_next_value (&_arguments_iter);
	reversed = g_variant_get_boolean (_tmp27_);
	g_variant_unref (_tmp27_);
	result = mpris_playlists_get_playlists (self, index, maxcount, playlist_ordering, reversed, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp28_ = result;
	g_variant_builder_init (&_tmp29_, G_VARIANT_TYPE ("a(oss)"));
	for (_tmp30_ = 0; _tmp30_ < result_length1; _tmp30_++) {
		GVariantBuilder _tmp31_;
		g_variant_builder_init (&_tmp31_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp31_, g_variant_new_object_path ((*(*_tmp28_)).id));
		g_variant_builder_add_value (&_tmp31_, g_variant_new_string ((*(*_tmp28_)).name));
		g_variant_builder_add_value (&_tmp31_, g_variant_new_string ((*(*_tmp28_)).icon));
		g_variant_builder_add_value (&_tmp29_, g_variant_builder_end (&_tmp31_));
		_tmp28_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp29_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) mpris_playlists_mpris_playlist_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (playlist_ordering);
	;
}

static void
mpris_playlists_dbus_interface_method_call (GDBusConnection* connection,
                                            const gchar* sender,
                                            const gchar* object_path,
                                            const gchar* interface_name,
                                            const gchar* method_name,
                                            GVariant* parameters,
                                            GDBusMethodInvocation* invocation,
                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "ActivatePlaylist") == 0) {
		_dbus_mpris_playlists_activate_playlist (object, parameters, invocation);
	} else if (strcmp (method_name, "GetPlaylists") == 0) {
		_dbus_mpris_playlists_get_playlists (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_mpris_playlists_get_playlist_count (MprisPlaylists* self)
{
	guint result;
	GVariant* _reply;
	result = mpris_playlists_get_playlist_count (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}

static GVariant*
_dbus_mpris_playlists_get_orderings (MprisPlaylists* self)
{
	gchar** result;
	gint result_length1 = 0;
	GVariant* _reply;
	gchar** _tmp32_;
	GVariantBuilder _tmp33_;
	gint _tmp34_;
	result = mpris_playlists_get_orderings (self, &result_length1);
	_tmp32_ = result;
	g_variant_builder_init (&_tmp33_, G_VARIANT_TYPE ("as"));
	for (_tmp34_ = 0; _tmp34_ < result_length1; _tmp34_++) {
		g_variant_builder_add_value (&_tmp33_, g_variant_new_string (*_tmp32_));
		_tmp32_++;
	}
	_reply = g_variant_builder_end (&_tmp33_);
	return _reply;
}

static GVariant*
_dbus_mpris_playlists_get_active_playlist (MprisPlaylists* self)
{
	MprisPlaylistsMaybePlaylist result = {0};
	GVariant* _reply;
	GVariantBuilder _tmp35_;
	GVariantBuilder _tmp36_;
	mpris_playlists_get_active_playlist (self, &result);
	g_variant_builder_init (&_tmp35_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp35_, g_variant_new_boolean (result.valid));
	g_variant_builder_init (&_tmp36_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp36_, g_variant_new_object_path (result.playlist.id));
	g_variant_builder_add_value (&_tmp36_, g_variant_new_string (result.playlist.name));
	g_variant_builder_add_value (&_tmp36_, g_variant_new_string (result.playlist.icon));
	g_variant_builder_add_value (&_tmp35_, g_variant_builder_end (&_tmp36_));
	_reply = g_variant_builder_end (&_tmp35_);
	mpris_playlists_maybe_playlist_destroy (&result);
	return _reply;
}

static GVariant*
mpris_playlists_dbus_interface_get_property (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* property_name,
                                             GError** error,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaylistCount") == 0) {
		return _dbus_mpris_playlists_get_playlist_count (object);
	} else if (strcmp (property_name, "Orderings") == 0) {
		return _dbus_mpris_playlists_get_orderings (object);
	} else if (strcmp (property_name, "ActivePlaylist") == 0) {
		return _dbus_mpris_playlists_get_active_playlist (object);
	}
	return NULL;
}

static gboolean
mpris_playlists_dbus_interface_set_property (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* property_name,
                                             GVariant* value,
                                             GError** error,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_mpris_playlists_playlist_changed (GObject* _sender,
                                        GVariant* playlist,
                                        gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_variant (playlist));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.mpris.MediaPlayer2.Playlists", "PlaylistChanged", _arguments, NULL);
}

guint
mpris_playlists_register_object (gpointer object,
                                 GDBusConnection* connection,
                                 const gchar* path,
                                 GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_playlists_dbus_interface_info), &_mpris_playlists_dbus_interface_vtable, data, _mpris_playlists_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "playlist-changed", (GCallback) _dbus_mpris_playlists_playlist_changed, data);
	return result;
}

static void
_mpris_playlists_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_mpris_playlists_playlist_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

